/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////////////////////////
// Client.cpp: implementation of the cClient class.
//

#include "Client.h"

#include "wolfpack.h"
#include "SndPkg.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "client.cpp"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cClient::cClient(int so)
{
	if (so < 0 || so > MAXCLIENT)
	{
		char tmp[50];
		sprintf(tmp,"Bad socket # <%d>",so);
		LogCritical(tmp);
	}
	else
		socket=so;
}

cClient::~cClient(){;}

UOXSOCKET	cClient::GetSocket()	{return socket;}
P_CHAR		cClient::getPlayer()	{return MAKE_CHAR_REF(currchar(socket));}
bool		cClient::IsDragging()	{return (DRAGGED[socket]>0);}
void		cClient::SetDragging()	{DRAGGED[socket]=1;}
void		cClient::ResetDragging(){DRAGGED[socket]=0;}
void		cClient::SysMsg(char* text)	{sysmessage(socket,text);}


/////////////
// name:	AllPlayersIterator
// purpose:	intended to replace the now/perm loops
// history:	by Duke, 06.10.2002
//
P_CHAR AllPlayersIterator::First()
{
	pos = 0;
	return _GetData();
}
P_CHAR AllPlayersIterator::Next()
{
	pos++;
	return _GetData();
}
P_CHAR AllPlayersIterator::_GetData()
{
	if (pos < now)
	{
		if (perm[pos])
			return GetData();
		else
			return Next();
	}
	else
		return NULL;
}
P_CHAR AllPlayersIterator::GetData()
{ 
	return MAKE_CHAR_REF(currchar(pos));
}

P_CHAR AllPlayersInRangeIterator::_GetData()
{
	P_CHAR pc = AllPlayersIterator::_GetData();
	if (!pc) return NULL;
	if (inrange1p(Center,pc))
		return GetData();
	else
		return Next();
}

