/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////
// Name:	SndPkg.cpp
// Purpose: functions that send packages to the Client
// History:	cut from wolfpack.cpp by Duke, 25.10.00
// Remarks:	not necessarily ALL those functions
//
#include "SndPkg.h"

#include "mapS.h"
#include "basics.h"
#include "Client.h"
#include "combat.h"		// just for CalcDef()
#include "guilds.h"
#include "house.h"
#include "itemid.h"
#include "oem.h"
#include "magic.h"
#include "npcinfo.h"
#include "regions.h"
#include "skills.h"
#include "sregions.h"
#include "utilsys.h"
#include "weight.h"
#include "network.h"
#include "accounts.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "SndPkg.cpp"

#include "assert.h"

CArray<MAXLAYERS, int>layers("layers");

/////////////
// name:	PosToPtr*
// purpose: store coordinates to packets
// history:	by Duke, 30.08.03
//
void PosToPtrXY(const cCoord& pos, unsigned char* p)
{
	ShortToCharPtr(pos.x, p);
	ShortToCharPtr(pos.y, p+2);
}

void PosToPtrXYZ(const cCoord& pos, unsigned char* p)
{
	PosToPtrXY(pos, p);
	*(p+4) = pos.z;
}

void SndToAllInRange(P_CHAR Person,unsigned char *pkg, int len)//send to all inrange sockets, including the current socket
{
	P_CHAR pc;
	AllPlayersInRangeIterator api(Person);
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		unsigned char packetnum=pkg[0];
		unsigned char offs;
		int m=Network->PacketLen(api.getSocket(), packetnum);
		if (m==0) offs=3; else offs=1;		
		XStartPkt(packetnum, len);
		XAddPkt(&pkg[0+offs], len-offs);
		XFinishPkt(api.getSocket());
	}
}

void SndWornItemsToAllInRange(P_CHAR Person)
{
	// send update to all inrange sockets
	P_CHAR pc;
	AllPlayersInRangeIterator api(Person);
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		wornitems(api.getSocket(), Person);
	} 
}

void SndToAllInRangeExept(P_CHAR Person,unsigned char *pkg, int len)//send to all inrange sockets, NOT including the current socket
{
	P_CHAR pc;
	AllPlayersInRangeIterator api(Person);
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (!pc->isSameAs(Person))
		{
		  unsigned char packetnum=pkg[0];
		  unsigned char offs;
		  int m=Network->PacketLen(api.getSocket(), packetnum);
		  if (m==0) offs=3; else offs=1;		
		  XStartPkt(packetnum, len);
		  XAddPkt(&pkg[0+offs], len-offs);
		  XFinishPkt(api.getSocket());		 
		}
	}
}

//keep the target highlighted so that we know who we're attacking =)
//26/10/99//new packet
void SndAttackOK(UOXSOCKET s, int serial)
{
	unsigned char attackok[6]="\xAA\x00\x00\x00\x00";//AntiChrist! 26/10/99
	LongToCharPtr(serial,attackok+1);
	XStartPkt(0xAA,5);
	XAddPkt(&attackok[0+1], 5-1);
	XFinishPkt(s);
}

void SndWorld(UOXSOCKET s, int map)
{
	if (AllMaps->isValidMap(map))
	{	
	  unsigned char world[7]      ="\xBF\x00\x06\x00\x08\x00";
	  world[5]=map;
	  XStartPkt(0xBF, 6);
	  XAddPkt(&world[0+3], 6-3);
	  XFinishPkt(s);
	}
	else
	{
	   sysmessage(s,"map you want to travel to not installed, plz contact shard admin");
	}
}

void SndSeason(UOXSOCKET s)
{
	unsigned char setseason[4]  ="\xBC\x00\x01";
	setseason[1] = timeLight.season;

	XStartPkt(0xBC, 3);
	XAddPkt(&setseason[0+1], 3-1);
	XFinishPkt(s);
}

void SndNewMap(UOXSOCKET s, int map)
{
	SndWorld(s, map);
	AllMaps->SendMapDifPacket(s); // it's strange but we need to resend the # of difs of ALL maps for ONE map change, typical OSI
	SndSeason(s);
}

void SndDyevat(UOXSOCKET s, int serial, short id)
{
	static unsigned char dyevat[10]="\x95\x40\x01\x02\x03\x00\x00\x0F\xAB";
	LongToCharPtr(serial,(dyevat+1));
	ShortToCharPtr(id,dyevat+7);

	XStartPkt(0x95, 9);
	XAddPkt(&dyevat[0+1], 9-1);
	XFinishPkt(s);
}

void SndUpdscroll(UOXSOCKET s, short txtlen, char* txt)
{
	unsigned char updscroll[10]={0,};
	ShortToCharPtr(txtlen+10,&updscroll[1]);
	updscroll[3]=2;
	ShortToCharPtr(txtlen,&updscroll[8]);

	int l=txtlen+10;
	XStartPkt(0xA6, l);
	XAddPkt(&updscroll[0+3], 10-3);
	XAddPkt((unsigned char*)&txt[0], txtlen);
	XFinishPkt(s);
}


void SndRemoveNpc(UOXSOCKET s, P_CHAR creature, bool distancecheck)
{
	unsigned char removeobject[5];
	removeobject[0]=0x1d;
	if (creature==NULL) return;
	
	if (distancecheck)
	{	
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		if (!inrange1p (Player, creature)) return;
	}

	int serial = creature->serial;
	LongToCharPtr(serial,&removeobject[1]);
	XStartPkt(0x1d, 5);
	XAddPkt(&removeobject[0+1], 5-1);
	XFinishPkt(s);
}

void SndRemoveNpcToAll(P_CHAR creature, bool distancecheck)
{	
    if (creature==NULL) return;	

	unsigned char removeobject[5];
	removeobject[0]=0x1d;
	int serial = creature->serial;
	LongToCharPtr(serial,&removeobject[1]);

	if (distancecheck) 
	{
		SndToAllInRange(creature, &removeobject[0], 5);
	} 
	else
	{
		AllPlayersIterator api;
		P_CHAR pc;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			XStartPkt(0x1d, 5);		  
			XAddPkt(&removeobject[0+1], 5-1);
			XFinishPkt(api.getSocket());
		}
	}
}

void SndRemoveItemToAll(P_ITEM item, bool distancecheck)
{
    if (item==NULL) return;

	unsigned char removeobject[5];
	removeobject[0]=0x1d;

   	int serial = item->serial;
	LongToCharPtr(serial,&removeobject[1]);

	AllPlayersIterator api;
	P_CHAR pc;
	int dist;
	
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{	
	    if (distancecheck) dist = itemdistDeluxe(pc, item); // advanced distance calculation VERY important here
		else dist=1;
        
	    if ((dist<=(VISRANGE+2)) && (dist!=~0) ) 
		{

			XStartPkt(0x1d, 5);
			XAddPkt(&removeobject[0+1], 5-1);
			XFinishPkt(api.getSocket());
		}
	}

}

void SndRemoveItem(UOXSOCKET s, PC_ITEM item, bool distancecheck)
{
	if (item==NULL) return;

	if (distancecheck)
	{	
	   int dist;
	   P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	   dist = itemdistDeluxe(Player, item); // advanced distance calculation VERY important here
	   if ( (dist>=VISRANGE+2) && (dist!=~0) ) return;
	}

	unsigned char removeobject[5];
	LongToCharPtr(item->serial,&removeobject[1]);

	XStartPkt(0x1D,5);
	XAddPkt(&removeobject[0+1], 5-1);
	XFinishPkt(s);
}


void SndShopgumpopen(UOXSOCKET s, int serial)
{
	unsigned char shopgumpopen[8]="\x24\x00\x00\x00\x01\x00\x30";
	LongToCharPtr(serial,shopgumpopen+1);
	XStartPkt(0x24, 7);
	XAddPkt(&shopgumpopen[0+1], 7-1);
	XFinishPkt(s);
}

void SndClearTrade(UOXSOCKET s, int serial)
{
	unsigned char clearmsg[8];

	LongToCharPtr(serial,&clearmsg[3]);
	clearmsg[7]=0x00;

	XStartPkt(0x3B, 8);
	XAddPkt(&clearmsg[0+3], 8-3);
	XFinishPkt(s);
}


void SndSound(UOXSOCKET s, const cCoord& pos, short sound)
{
	unsigned char sfx[12]={0,};

	sfx[0] =0x54;
	sfx[1] = 1;
	ShortToCharPtr(sound,&sfx[2]);
	PosToPtrXY(pos,&sfx[6]);

	XStartPkt(0x54, 12);
	XAddPkt(&sfx[0+1], 12-1);
	XFinishPkt(s);
}

void soundeffect(int s, unsigned char a, unsigned char b) // Play sound effect for player
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	soundeffect2(Player, (a<<8)+b);
}

void soundeffect(P_CHAR pc, short sound)
{
	soundeffect2(pc, sound);
}

void soundeffect2(P_CHAR pc, short sound)
{
	if (!pc) return;

	unsigned char sfx[12]={0,};
	sfx[0] =0x54;
	sfx[1] =1;
	ShortToCharPtr(sound, &sfx[2]);
	PosToPtrXY(pc->pos, &sfx[6]);

	SndToAllInRange(pc, &sfx[0], 12);
}

void soundeffect3(PC_ITEM pi, short sound)
{
	unsigned char sfx[12]={0,};	

	sfx[1] = 1;
	ShortToCharPtr(sound,&sfx[2]);
	PosToPtrXY(pi->pos,&sfx[6]);

	unsigned int j;
	for (j=0;j<now;j++)
	{
		if (perm[j])
		{
			if (inrange2(j,pi) )
			{
				XStartPkt(0x54, 12); 
				XAddPkt(&sfx[0+1], 12-1);
				XFinishPkt(j);
			}
		}
	}
}

void soundeffect5(UOXSOCKET s, P_CHAR Player, short sound)
{
	if (!Player) return;
	SndSound(s, Player->pos, sound);
}

void SndAction(P_CHAR pc, int x)	// character does a certain action
{
	unsigned char doact[14]={0,};

	LongToCharPtr(pc->serial, &doact[1]);
	ShortToCharPtr(x, &doact[5]);

	doact[0]=0x6e;
	doact[8]=5;
	doact[10]=1;
	doact[13]=1;

	SndToAllInRange(pc, &doact[0], 14); 
}


/*
// s: player socket, I: send bolt if it rains or not ?

void weather(int s, char bolt) // Send new weather to player
{
	char wdry[5]="\x65\x00\x00\x00";
	char wrain[5]="\x65\x01\x46\x00";
	char wsnow[5]="\x65\x02\x46\xEC";

	int i=calcCharFromSer(Player->serial),n;

	for (int j=0;j<now;j++)
	{
		if (noweather[currchar[j]] && wtype!=0)
		{
			Xsend(s,wdry,4);
			return;
		}
	}
	// send wdry to non moving(!) players if it rains or snows and they are inside buildings

	if (wtype==0) Xsend(s, wdry, 4);

	if (wtype==1)
	{
		if (bolt)
		{
			n=1;
			for (int a=0;a<n;a++) // reduce if too laggy (client only lag though)
			{
				if (rand()%2)
				{
					soundeffect2(i, 0x00, 0x28);
					bolteffect(i);
				}
				else
				{
					soundeffect2(i, 0x00, 0x29);
					bolteffect(i);
				}
			}
		}

	raindroptime=uiCurrentTime+MY_CLOCKS_PER_SEC*(6+rand()%24);
	Xsend(s, wrain, 4);
	}
		if (wtype==2)
		{
			if (rand()%2)
			{
				soundeffect2(i, 0x00, 0x14);
			}
			else
			{
				soundeffect2(i, 0x00, 0x15);
			}
			Xsend(s, wsnow, 4);
		}
}
*/
void sysbroadcast(const char *txt, int dontsendtothatsocket) // System broadcast in bold text
{
	int tl;
	unsigned int i;
	unsigned char talk[14];

	unsigned int sl=strlen(txt)+1;
	tl=44+sl;

	talk[3]=1;
	talk[4]=1;
	talk[5]=1;
	talk[6]=1;
	talk[7]=1;
	talk[8]=1;
	talk[9]=1;

	unsigned short color=0x127;
	unsigned short font=0;

	ShortToCharPtr(color, &talk[10]);
	ShortToCharPtr(font, &talk[12]);

	char bc[30]={0,};	
	strcpy(bc,"Broadcast");
	sprintf(temp2,"BROADCAST: %s", txt);

	for (i=0;i<now;i++)
	{
		if (perm[i] && i!=(unsigned)dontsendtothatsocket)
		{
			if (clientDimension[i]==3) 
			{			
				sysmessage(i, color, temp2); // 3d clients don't have that fat font type 0, just use an ordinary sysmessage

				// note: it's VERY important that talk[] is LOCAL here.
				// because sysmessage uses GLOBAL talk array, previous calculations would be destroyed
				// in particular packet length which is fatal.
				// same goes for temp2 in sprintf above.
				// because sysbroadcast is usually called via GLOBAL var temp, sprintf(temp...) would be fatal
				// --> Global vars are EVIL !!!

			}
			else
			{
				LogAssert(strlen(txt) > 0);	//Duke: yes it happens, but doesn't produce the invalid packet length error
				LogAssert((strlen(txt)+1)==sl);
				XStartPkt(0x1C, tl);
				XAddPkt((unsigned char*)&talk[0+3], 14-3);
				XAddPkt((unsigned char*)&bc[0], 30);
				XAddPkt((unsigned char*)&txt[0], sl);
				LogAssert((strlen(txt)+1)==sl);
			
				XFinishPkt(i);
			}
		}
	}	
}

void sysmessage(UOXSOCKET s, char *txt) // System message (In lower left corner)
{	
	if (s<=-1) return;
	if ( s>=MAXCLIENT)
		LogCriticalVar("Socket/Index confusion @ Xsend <%s>\n",txt);

	unsigned char talk[14]={0,};

	int sl=strlen(txt)+1;
	int tl = 44 + sl;

	/*talk[1]=tl>>8;
	talk[2]=tl%256;*/

	talk[3]=1;
	talk[4]=1;
	talk[5]=1;
	talk[6]=1;
	talk[7]=1;
	talk[8]=1;
	talk[9]=0x0;

	talk[10]=0x00;	//Color1  - Previous default was 0x0040
	talk[11]=0x00;  //Color2

	talk[12]=0;     
	talk[13]=3;

	// problem1: 3d clietns crash if color set to 0 since 3.0.6g 
	// workaround: set it to non 0 if 3d client
	// but a mean pitfall remaining: there are a couple sysmessages BEFORE client dimension is known
	// hence 3d clients are recognized as 2d clients for those sysmessages
	// it's important that those sysmessages are called with color != 0 ...
	// it've tagged them with "UNKOWNDIMENSION sysmessages" in comment
	if ( clientDimension[s]==3 && talk[10]==0 && talk[11]==0) { talk[10]=0; talk[11]=0x40; }

	XStartPkt(0x1C,tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt(&zeros[0], 30);
	XAddPkt((unsigned char*)&txt[0], sl);
	XFinishPkt(s);
}


void sysmessage(UOXSOCKET s, unsigned short color, char *txt) // System message (In lower left corner)
{
	if (s<=-1) return;

	unsigned char talk[14];
	
	int sl=strlen( txt ) + 1;

	int tl = 44 + sl;

	talk[3]=1;
	talk[4]=1;
	talk[5]=1;
	talk[6]=1;
	talk[7]=1;
	talk[8]=1;
	talk[9]=0;
	talk[10]=color>>8;
	talk[11]=color%256;			 
	talk[12]=0;
	talk[13]=3;

	if ( clientDimension[s]==3 && color==0) { talk[10]=0; talk[11]=0x40; }

	unsigned char zeros[30]={0,};
	XStartPkt(0x1C, tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt(&zeros[0],30);
	XAddPkt((unsigned char*)&txt[0], sl);
	XFinishPkt(s);
}

void itemmessage(UOXSOCKET s, P_ITEM pi, char *txt, unsigned short color) 
{// The message when an item is clicked (new interface, Duke)
	if (!pi) return;

	if ((pi->isType(ITY_Container) && color == 0x0000)||
		(pi->isType(ITY_SpellBook) && color == 0x0000)||
		(pi->id()==0x1BF2 && color == 0x0000))
		color = 0x03B2;

	int tl=44+strlen(txt)+1;

	unsigned char talk[14];

	LongToCharPtr(pi->serial,&talk[3]);
	talk[7]=1;
	talk[8]=1;
	talk[9]=6; // Mode: "You see"
	ShortToCharPtr(color,&talk[10]);
	talk[12]=0;
	talk[13]=3;

	if ( clientDimension[s]==3 && color==0) { talk[10]=0; talk[11]=0x40; }

	XStartPkt(0x1C,tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt((unsigned char*)&pi->name[0], 30);
	XAddPkt((unsigned char*)&txt[0], strlen(txt)+1);
	XFinishPkt(s);
}

void wearIt(const UOXSOCKET s, const P_ITEM pi)
{
	unsigned char wearitem[15];

	LongToCharPtr(pi->serial,&wearitem[1]);
	ShortToCharPtr(pi->id(),&wearitem[5]);

	// invisible horse stuff, neds special treatment for 3d clients
	if (pi->id()==0x3ecf && pi->layer==0x19 && clientDimension[s]==3) wearitem[6]=0xbd;

	wearitem[8]=pi->layer;
	LongToCharPtr(pi->contserial,&wearitem[9]);
	ShortToCharPtr(pi->color(),&wearitem[13]);
	
	XStartPkt(0x2e, 15);
	XAddPkt(&wearitem[0+1], 15-1);
	XFinishPkt(s);
}

void backpack(UOXSOCKET s, P_ITEM pCont) // Send Backpack (with items)
{
	unsigned char bpopen[8]="\x24\x40\x0B\x00\x1A\x00\x3C";
	unsigned char   cont[6]="\x3C\x00\x05\x00\x00";
	if (!pCont)	return;

	int count=0;
	int ci=0,loopexit=0;
	P_ITEM pj;
	while ( ((pj=pCont->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		count++;
	}

	cont[3]=count>>8;
	cont[4]=count%256;
	count=(count*19)+5;

	LongToCharPtr(pCont->serial, &bpopen[1]);
	bpopen[5]=0x00;

	switch(pCont->id())
	{
	case 0x0E75:						// Backpack
	case 0x0E79: bpopen[6]=0x3C; break;	// Box/Pouch
	case 0x0E76: bpopen[6]=0x3D; break;	// Leather Bag
	case 0x0E77:						// Barrel
	case 0x0E7A:						// Square Basket
	case 0x0E7F: bpopen[6]=0x3E; break;	// Keg
	case 0x0E7C: bpopen[6]=0x4A; break;	// Silver Chest
	case 0x0E7D: bpopen[6]=0x43; break;	// Wooden Box
	case 0x0E3D:						// Large Wooden Crate
	case 0x0E3C:						// Large Wooden Crate
	case 0x0E3F:						// Small Wooden Crate
	case 0x0E3E:						// Small Wooden Crate
	case 0x0E7E: bpopen[6]=0x44; break;	// Wooden Crate
	case 0x0E80: bpopen[6]=0x4B; break;	// Brass Box
	case 0x0E40:						// Metal & Gold Chest
	case 0x0E41: bpopen[6]=0x42; break;	// Metal & Gold Chest
	case 0x0E43:						// Wooden & Gold chest
	case 0x0E42: bpopen[6]=0x49; break; // Wooden & Gold Chest
		
	case 0x0990: bpopen[6]=0x41; break; // Round Basket
	case 0x09B2: bpopen[6]=0x3C; break; // Backpack 2
	case 0x09AA: bpopen[6]=0x43; break; // Wooden Box
	case 0x09A8: bpopen[6]=0x40; break; // Metal Box
	case 0x09AB: bpopen[6]=0x4A; break; // Metal/Silver Chest
	case 0x09A9: bpopen[6]=0x44; break; // Small Wooden Crate
					
	case 0x2006: bpopen[6]=0x09; break; // Coffin

	case 0x0A97:						// Bookcase
	case 0x0A98:						// Bookcase
	case 0x0A99:						// Bookcase
	case 0x0A9a:						// Bookcase
	case 0x0A9b:						// Bookcase
	case 0x0A9c:						// Bookcase
	case 0x0A9d:						// Bookcase
	case 0x0A9e: bpopen[6]=0x4d; break; // Bookcase

	case 0x0A4d:						// Fancy Armoire
	case 0x0A51:						// Fancy Armoire
	case 0x0A4c:						// Fancy Armoire
	case 0x0A50: bpopen[6]=0x4e; break; // Fancy Armoire

	case 0x0A4f:						// Wooden Armoire
	case 0x0A53:						// Wooden Armoire
	case 0x0A4e:						// Wooden Armoire
	case 0x0A52: bpopen[6]=0x4f; break; // Wooden Armoire

	case 0x0A30:						// chest of drawers (fancy)
	case 0x0A38: bpopen[6]=0x48; break; // chest of drawers (fancy)

	case 0x0A2c:						// chest of drawers (wood)
	case 0x0A34:						// chest of drawers (wood)
	case 0x0A3c:						// Dresser
	case 0x0A3d:						// Dresser
	case 0x0A44:						// Dresser
	case 0x0A35: bpopen[6]=0x51; break; // Dresser
		
	case 0x0Ab2: if (pCont->morex==1) bpopen[6]=0x4a;	// xab2 is a rug. Secret chest ???
		break;
		
	case 0x2AF8: bpopen[6]=0x44; break;	// shoppack
	case 0x3E65:						// ship's hold
	case 0x3E93:						// ship's hold
	case 0x3EAE:						// ship's hold
	case 0x3EB9: bpopen[6]=0x4C; break;	// ship's hold
		
	default:	 bpopen[6]=0x47;
	}

	XStartPkt(0x24, 7);
	XAddPkt(&bpopen[0+1], 7-1);
	XFinishPkt(s);

	XStartPkt(0x3C, count);
	XAddPkt(&cont[0+3], 5-3);

	unsigned char bpitem[19]={0,};
	ci=0;
	loopexit=0;
	P_ITEM pi;
	while ( ((pi=pCont->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		//fix location of items if they mess up. (needs tweaked for container types)
		if (pi->pos.x>150) pi->pos.x=150;
		if (pi->pos.y>140) pi->pos.y=140;
		//end fix
		LongToCharPtr(pi->serial, &bpitem[0]);
		ShortToCharPtr(pi->id(),&bpitem[4]);
		ShortToCharPtr(pi->amount,&bpitem[7]);
		PosToPtrXY(pi->pos,&bpitem[9]); 
		LongToCharPtr(pCont->serial, &bpitem[13]);
		ShortToCharPtr(pi->color(),&bpitem[17]);
		pi->decaytimer.reset();//HoneyJar // reseting the decaytimer in the backpack
		XAddPkt(&bpitem[0], 19);
	}

	XFinishPkt(s);
}

void backpack2(int s, PC_ITEM Corpse) // Send corpse stuff
{
	if (!Corpse) return;
	int count=0;
	unsigned char bpopen2[6]="\x3C\x00\x05\x00\x00";
	unsigned char display1[8]="\x89\x00\x0D\x40\x01\x02\x03";
	unsigned char display2[6]="\x01\x40\x01\x02\x03";

	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Corpse->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->layer!=0)
		{
			count++;
		}
	}

	int count2=(count*5)+7; // 5 bytes per object, 7 for this header

	/*
	display1[1]=count2>>8;
	display1[2]=count2%256;
	*/

	LongToCharPtr(Corpse->serial, &display1[3]);

	XStartPkt(0x89, count2);
	XAddPkt(&display1[0+3], 7-3);

	ci=0;
	loopexit=0;
	while ( ((pi=Corpse->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->layer!=0)
		{
			display2[0]=pi->layer;
			LongToCharPtr(pi->serial, &display2[1]);
			XAddPkt(&display2[0], 5);
		}
	}

	XFinishPkt(s);

	bpopen2[3]=count>>8;
	bpopen2[4]=count%256;
	count2=(count*19)+5;
	/*
	bpopen2[1]=count2>>8;
	bpopen2[2]=count2%256;*/

	XStartPkt(0x3c, count2);
	XAddPkt(&bpopen2[0+3], 5-3);

	ci=0;
	loopexit=0;
	unsigned char bpitem[19]={0,};
	while ( ((pi=Corpse->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->layer!=0)
		{
			LongToCharPtr(pi->serial,	&bpitem[0]);
			ShortToCharPtr(pi->id(),	&bpitem[4]);
			bpitem[7]=pi->amount>>8;
			bpitem[8]=pi->amount%256;
			PosToPtrXY(pi->pos,&bpitem[9]); 
			LongToCharPtr(Corpse->serial, &bpitem[13]);
			ShortToCharPtr(pi->color(),&bpitem[17]);
			
			pi->decaytimer.reset();// reseting the decaytimer in the backpack	//moroallan

			XAddPkt(&bpitem[0], 19);
		}
	}

	XFinishPkt(s);
}

void sendbpitem(UOXSOCKET s, PC_ITEM pi) // Update single item in backpack
{
	if (!pi) return;

	unsigned char bpitem[19]={0,};
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	LongToCharPtr(pi->serial, &bpitem[0]);
	//AntiChrist - world light sources stuff
	//if player is a gm, this item
	//is shown like a candle (so that he can move it),
	//....if not, the item is a normal
	//invisible light source!
	if (Player->isGM() && pi->id()==0x1647)
	{///let's show the lightsource like a candle
		bpitem[4]=0x0A;
		bpitem[5]=0x0F;
	} else
	{//else like a normal item
		ShortToCharPtr(pi->id(),&bpitem[4]);
	}
	ShortToCharPtr(pi->amount,&bpitem[7]);
	PosToPtrXY(pi->pos,&bpitem[9]); 
	LongToCharPtr(pi->contserial,&bpitem[13]);
	if (Player->isGM() && pi->id()==0x1647)
	{///let's show the lightsource like a blue item
		bpitem[17]=0;
		bpitem[18]='\xC6';
	} else
	{//else like a normal item
		ShortToCharPtr(pi->color(),&bpitem[17]);
	}

//	pi->decaytime=0; // HoneyJar, array range is 0-19 ! //reseting the decaytimer in the backpack
//	Horror ! modifiing pi 'just to be sure' :(
//	Have to come back to this when decay is reorganized.
//	for now a little workaround. Not clean either :( (Duke,4.1.2004)
	if (pi->decaytimer.IsRunning())
		pi->unconst()->decaytimer.reset();

	// we need to find the topmost container that the item is in
	// be it a character or another container.

	//int c = -1;

	P_CHAR pc=NULL;
	PC_ITEM pio=GetOutmostCont(pi);
	if (!pio)
	{
		char ttt[512];
		sprintf(ttt,"item <%i> id <%x> has a bad contserial <%i>",pi->serial,pi->id(),pi->contserial);
		//LogCritical(ttt);
	}
	else
		pc=FindWearerOf(pio);

	if ((pc && inrange1p(Player,pc)) || // if item is in a character's
		//pack (or subcontainer) and player is in range
		(!pc && inrange2(s,pio)))	// or item is in container on ground and container is in range
	{
		XStartPkt(0x25, 20);
		XAddPkt(&bpitem[0], 20-1); // note: not [0+1] is correct !!!
		XFinishPkt(s);
	}
	Weight->NewCalc(Player);	// Ison 2-20-99
}

void tileeffect(const cCoord& pos, char eff1, char eff2, char speed, char loop)
{//AntiChrist
	unsigned char effect[28];
	memset(effect,0,28);

	effect[0]=0x70; // Effect message
	effect[1]=0x02; // Stay at x, y, z effect
	//[2] to [9] are	not applicable here.
	effect[10]=eff1;// Object id of the effect
	effect[11]=eff2;
	PosToPtrXYZ(pos,&effect[12]); 
	//[17] to [21] are not applicable here.
	effect[22]=speed;
	effect[23]=loop; // 0 is really long.	1 is the shortest.
	//[24] to [25] are not applicable here.
	effect[26]=1; // LB possible client crashfix
	effect[27]=0;

	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (inVisRange(pos, pc->pos))
		{
			XStartPkt(0x70, 28);
			XAddPkt(&effect[0+1], 28-1);
			XFinishPkt(api.getSocket());
		}
	}
}

void senditem(UOXSOCKET s, PC_ITEM pi) // Send items (on ground)
{
	unsigned char itmput[21]="\x1A\x00\x13\x40\x01\x02\x03\x20\x42\x00\x32\x06\x06\x06\x4A\x0A\x00\x00\x00";
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if ( pi->visible>=1 && !Player->isGM() )
		return;

	// meaning of the item's attribute visible
	// Visible 0 -> visible to everyone
	// Visible 1 -> only visible to owner and gm's (for owners normal for gm's grayish/hidden color)
	// visible 2 -> only visble to gm's (greyish/hidden color)

	if ( pi->visible>=2 && !Player->isGM() ) return; // workaround for missing gm-check client side for visibity since client 1.26.2

	if (!pi->isInWorld())
	{
		int pack=1;
		if (pi->IsWorn())
		{
			P_CHAR pc = FindWearerOf(pi);
			if (pc)
				pack=0;
		}
		if (pack)
		{
			if (!pi->isMulti()) // LB client crashfix, dont show multis in BP
								// we should better move it out of pack, but thats
								// only a first bannaid
			{
				sendbpitem(s,pi);
				return;
			}
		}
	}

	if (pi->isInWorld() && inrange2(s,pi) )
	{
		LongToCharPtr(pi->serial,&itmput[3]);
		itmput[3] |= 0x80;							// Enable Piles

		//if player is a gm, this item
		//is shown like a candle (so that he can move it),
		//....if not, the item is a normal invisible light source!
		if (Player->isGM() && pi->id()==0x1647)
			ShortToCharPtr(0x0A0F,itmput+7);	//let's show the lightsource like a candle
		else
			ShortToCharPtr(pi->id(),itmput+7);	//else like a normal item
	
		itmput[9]=pi->amount>>8;
		itmput[10]=pi->amount%256;
		itmput[11]=pi->pos.x>>8;
		itmput[12]=pi->pos.x%256;
		itmput[13]=(pi->pos.y>>8)+0xC0; // Enable Dye and Move
		itmput[14]=pi->pos.y%256;
		itmput[15]=pi->pos.z;

		if (Player->isGM() && pi->id()==0x1647)
		{///let's show the lightsource like a blue item
			itmput[16]=0;
			itmput[17]=0xC6;
		} else
		{
			ShortToCharPtr(pi->color(),&itmput[16]);
		}

		itmput[18]=0;

		int dontsendcandidate=0;
		if (pi->visible==1)
		{
			if (!Player->Owns(pi))
			{
				dontsendcandidate=1;
				itmput[18]|=0x80;
			}
		}

		if (dontsendcandidate && !Player->isGM()) return; // LB 9-12-99, client 1.26.2 visibility correction

		if (pi->visible==2)
		{
			itmput[18]|=0x80;
		}


		if (pi->isAllwaysMovable()) itmput[18] |= 0x20;
		if (Player->CanMoveAll()) itmput[18] |= 0x20;
		if (pi->isOwnerMovable() && Player->Owns(pi))
			itmput[18] |= 0x20;
		if (Player->DoesViewHouseIcons())
		{
			if (pi->id()>=0x4000 && pi->id()<=0x40FF) // LB, 25-dec-1999 litle bugfix for treasure multis, ( == changed to >=)
			{
				itmput[7]=0x14;
				itmput[8]=0xF0;
			}
		}

		int dir=0;
		if (pi->dir)
		{
			dir=1;
			itmput[19]=itmput[18];
			itmput[18]=itmput[17];
			itmput[17]=itmput[16];
			itmput[16]=itmput[15];
			itmput[15]=pi->dir;
			itmput[2]=0x14;
			itmput[11]|=0x80;
		}

		int l=19+dir;
		itmput[2]=l;

		XStartPkt(0x1A, l);
		XAddPkt(&itmput[0+3], l-3);
		XFinishPkt(s);

		if (IsCorpse(pi->id()))
		{
			backpack2(s, pi);
		}
	}
}

// sends item in differnt color and position than it actually is
// used for LSd potions now, LB 5'th nov 1999
void senditem_lsd(UOXSOCKET s, PC_ITEM pi,unsigned short color, int x, int y, signed char z)
{
	if (!pi) return;
	unsigned char itmput[20]="\x1A\x00\x13\x40\x01\x02\x03\x20\x42\x00\x32\x06\x06\x06\x4A\x0A\x00\x00\x00";
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if ( pi->visible>=1 && !Player->isGM() ) return; // workaround for missing gm-check client side for visibity since client 1.26.2
	// for lsd we dont need extra work for type 1 as in send_item

	if (pi->isInWorld())
	{
		LongToCharPtr(pi->serial,	&itmput[3]);
		itmput[3] |= 0x80;							// Enable Piles
		ShortToCharPtr(pi->id(),	&itmput[7]);
		ShortToCharPtr(pi->amount,	&itmput[9]);
		ShortToCharPtr(x,			&itmput[11]);
		itmput[13]=(y>>8)+0xC0; // Enable Dye and Move
		itmput[14]=y%256;
		itmput[15]=z;
		ShortToCharPtr(color,		&itmput[16]);
		itmput[18]=0;

		if (pi->visible==1)
		{
			if (!Player->Owns(pi))
			{
				itmput[18]|=0x80;
			}
		}
		if (pi->visible==2)
		{
			itmput[18]|=0x80;
		}

		if (pi->visible==3)
		{
			if (Player->id() == 0x03DB || !Player->isGM())
				itmput[18]|=0x80;
		}

		if (pi->isAllwaysMovable()) itmput[18] |= 0x20;
		if (Player->CanMoveAll()) itmput[18] |= 0x20;
		if (pi->isOwnerMovable() && Player->Owns(pi))
			itmput[18] |= 0x20;
		if (Player->DoesViewHouseIcons())
		{
			if (pi->id()>=0x4000 && pi->id()<=0x40FF)
			{
				itmput[7]='\x14';
				itmput[8]='\xF0';
			}
		}
		if (pi->dir)
		{
			itmput[19]=itmput[18];
			itmput[18]=itmput[17];
			itmput[17]=itmput[16];
			itmput[16]=itmput[15];
			itmput[15]=pi->dir;
			itmput[2]=20;
			itmput[11]|=0x80;

			XStartPkt(0x1A,20);
			XAddPkt(&itmput[0+3], 20-3);
			XFinishPkt(s);

		} else
		{
			itmput[2]=19;
			XStartPkt(0x1A,19);
			XAddPkt(&itmput[0+3], 19-3);
			XFinishPkt(s);		
		}

		if (IsCorpse(pi->id()) )
		{
			backpack2(s, pi);
		}
	}

}



// LB 3-JULY 2000
void sendperson_lsd(UOXSOCKET s, P_CHAR pc, unsigned short color)
{
	if (s==-1) return;
	if (!pc) return;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int j, k,b,cc1=0,cc2=0;
	unsigned char oc[1024];

	int sendit;
	if (Player->isGM()) sendit=1; else // gm ? -> yes, send everything :)
	{ // no, -> dont show hidden & logged out chars
		if (pc->isHidden() && !pc->isSameAs(Player)) sendit=0; else sendit=1; // dont show hidden persons, even lsd'ed
		if ( (!pc->npc) && !pc->InGame()) sendit=0;
	}

	if (!pc->InGame() && !pc->npc && !Player->isGM()) 
	{
		sendit=0;
		SndRemoveNpc(s,pc);
	}

	if (!sendit) return;

	oc[0]=0x78; // Message type 78
	LongToCharPtr(pc->serial,&oc[3]); // Character serial number
	ShortToCharPtr(pc->id(), &oc[7]); // Character art id
	PosToPtrXYZ(pc->pos,	&oc[9]); 
	oc[14]=pc->dir; // Character direction
	ShortToCharPtr(pc->skin, &oc[15]);	// Character skin color
	oc[17]=0; // Character flags
	k=19;

	oc[18]=3;

	if (rand()%3==0) oc[18]=rand()%6;


	color = RandomNum(0, 0x03E9);
	color += RandomNum(0, 8);
	color %= 0x03E9;
	if (color < 0x0002 || color > 0x03E9)
		color = 0x03E9;
	if (color & 0xC000)
	{
		color = 0x1000;
		color |= RandomNum(0, 255);
	}
	ShortToCharPtr(color, &oc[15]);

	for (j=0;j<MAXLAYERS;j++) layers[j] = 0;

	int ci=0,loopexit=0;
	P_ITEM pi_j;
	while ( ((pi_j=pc->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if ( layers[pi_j->layer] == 0 )
		{
			LongToCharPtr(pi_j->serial,oc+k+0);
			ShortToCharPtr(pi_j->id(),oc+k+4);
			oc[k+6]=pi_j->layer;
			k=k+7;
			if /*(pi_j->color1!=0 || pi_j->color2!=0)*/ (1==1)
			{
				oc[k-3]=oc[k-3]|0x80;
				
				if ( rand()%9<7 ) // send fake colors, 2/3 base color
				{
					ShortToCharPtr(color,&oc[k+0]);
				}
				else // 1/3 new color
				{
					color=rand()%0x3e9;
					color+=rand()%8;
					color=color%0x03E9;
					if (color<0x0002 || color>0x03E9)
					{
						color=0x03E9;
					}
					b=((color&0x4000)>>14)+((color&0x8000)>>15);
					if (b)
					{
						color=0x100+rand()%255;
					}
					ShortToCharPtr(color,&oc[k+0]);
				}
				k=k+2;
			}
			layers[pi_j->layer] = 1;
		}
	}

	oc[k+0]=0;// Not well understood. It's a serial number. I set this to my serial number,
	oc[k+1]=0;// and all of my messages went to my paperdoll gump instead of my character's
	oc[k+2]=0;// head, when I was a character with serial number 0 0 0 1.
	oc[k+3]=0;
	k=k+4;

	oc[1]=k>>8;
	oc[2]=k%256;


	// without 0x1d client doesnt show 0x77 changes
	SndRemoveNpc(s, pc);

	unsigned char goxyz[19];
	if (pc->isSameAs(Player))
	{
		//goxyz[0]=0x20;

		LongToCharPtr(pc->serial,&goxyz[1]);
		ShortToCharPtr(pc->id(),&goxyz[5]);

		goxyz[8]=cc1;
		goxyz[9]=cc2;
	
		goxyz[10]=0;
		PosToPtrXY(pc->pos,&goxyz[11]); 
		goxyz[17]=pc->dir|0x80;
		goxyz[18]=pc->pos.z;

		XStartPkt(0x20,19);
		XAddPkt(&goxyz[0+1], 19-1);
		XFinishPkt(s);

		walksequence[s]=-1;
	}



	XStartPkt(0x78, k);
	XAddPkt(&oc[0+3], k-3);
	XFinishPkt(s);

	unsigned char extmove[17];
	// extmove[0]=0x77;

	LongToCharPtr(pc->serial,   &extmove[1]);
	ShortToCharPtr(pc->id(),	&extmove[5]);
	PosToPtrXYZ(pc->pos,&extmove[7]); 
	extmove[12]=pc->dir|0x80;

	extmove[13]=cc1;
	extmove[14]=cc2;

	extmove[15]=0;
	extmove[16]=3;

	XStartPkt(0x77, 17);
	XAddPkt(&extmove[0+1],17-1);
	XFinishPkt(s);
}

void SndCharDeleteError(UOXSOCKET s)
{
	unsigned char delete_error[2] = {0x85, 0x03};
	XStartPkt(0x85, 2);
	XAddPkt(&delete_error[0+1], 2-1);
	XFinishPkt(s);
}

void chardel (UOXSOCKET s) // Deletion of character
{
	if (acctno[s]!=-1)
	{
		unsigned int j=0;
		P_CHAR pc, ToKill=NULL;
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
		{
			if (pc->account==acctno[s])
			{			
				if (j==buffer[s][0x22]) ToKill=pc;
				j++;
			}
		}

		if (!ToKill) return;	// error, char to delete not found !!
	

		if (SrvParms->checkcharage)
		{
			if (ToKill->creationday+7 >= getPlatformDay())
			{
				SndCharDeleteError(s); 		
				return;
			}
		}

		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			if (pc->isSameAs(ToKill))	// must be a 'delayed logout' or stuck connection (Duke)
			{
				//SndCharDeleteError(s); // character too old confusing if it aint. sending account already in use instead	
				unsigned char value=1;
				XStartPkt(0x82,2);
		        XAddPkt(&value, 2-1);
		        XFinishPkt(s);

				return;
			}
		}

		////// now the deletion is ok !!! ///////////

	    Accounts->RemovePlayerFromAccountShadow(ToKill); // Account/player-list housekeeping

		if (SrvParms->char_log)
		{
			char logtxt[555];
			sprintf(logtxt, "%s (%i) was deleted from account %i\n", ToKill->name, ToKill->serial, ToKill->account);
			savelog(logtxt, "characters.log");
		}

		Npcs->DeleteChar(ToKill);

		if (j>=5) j=5;	
		if (j<=0) return;
		
		unsigned char relogin[304];
		memset(&relogin[0],0,304);
		if (j>=1) relogin[3]=j--; else { j=0; relogin[3]=j; }
		
		int tlen=304;
			
		j=0;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
		{
			if ( pc->account==acctno[s])
			{				
				strcpy( (char*)&relogin[4+j*60], pc->name);				
				j++;
			}
		}

		XStartPkt(0x86,tlen);
		XAddPkt(&relogin[0+3], tlen-3);
		XFinishPkt(s);
	}
}

void teleport(P_CHAR pc, const cCoord& old_pos, char noOnlinecheck) // Teleports character to its current set coordinates
{
	if (!pc) return;
	UOXSOCKET k = pc->calcSocket();	

	unsigned char goxyz[19];
	if (k!=-1)	// If a player, move them to the appropriate XYZ
	{
		LongToCharPtr(pc->serial, &goxyz[1]);
		ShortToCharPtr(pc->id(), &goxyz[5]);
		ShortToCharPtr(pc->skin, &goxyz[8]);

		goxyz[10] = 0x00;
		if (pc->Poisoned()) goxyz[10] |= 0x04; 
		if (pc->isHidden()) goxyz[10] |= 0x80;

		PosToPtrXY(pc->pos,&goxyz[11]); 
		goxyz[17]=pc->dir|0x80;
		goxyz[18]=pc->dispz;


		XStartPkt(0x20, 19);
		XAddPkt(&goxyz[0+1], 19-1);
		XFinishPkt(k);

		Weight->NewCalc(pc);	// Ison 2-20-99
		statwindow(k, pc);	// Ison 2-20-99
		walksequence[k]=-1;
	}

	cCoord cl = pc->pos;
	pc->pos = old_pos;	

	unsigned int i;
	for (i=0;i<now;i++) // Send the removal of the old position to all players.
	{		
		if (perm[i])
		{		            
			SndRemoveNpc(i, pc);		    
		}		
	}

	pc->pos=cl;

	for (i=0;i<now;i++) // Send the update to all players.
	{		
		if (perm[i])
		{		            		    
			if (inrange1pl(pc, currchar(i)))
			{			  
				impowncreate(i, pc, 1);
			}
		}		
	}
	
	// that's what teleported npc/players will see
	if (k!=-1)
	{
		cChar* pc2;
		int loopexit=0;

		RegGrid3x3Iterator4Chars rg3ic(pc->pos);
		while((pc2 = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			if ( pc2->npc || ( pc2->InGame() || pc->isGM() || noOnlinecheck)
				&& !pc->isSameAs(pc2) && inrange1p(pc, pc2))
			{
				impowncreate(k, pc2, 1);
			}
		}

		PC_ITEM pi;
		loopexit=0;
		RegGrid3x3Iterator4Items rg3ii(pc->pos);
		while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			if (inVisRange(pc->pos, pi->pos))
			{
				senditem(k, pi);
			}
		}
		if (perm[k]  || noOnlinecheck ) dolight(k);
	}

	checkregion(pc);
}


/////////////////////
// Name:	updatechar
// Purpose: resend the character
// History:	by Duke, 6.1.02
// Remarks:	1. this function assumes that the position of the char has NOT changed
//			2. it does NOT send the remove packet (which would cause blinking)
//			3. the setcharflag() does not really belong here, but taking it out is risky :-/
//

void updatechar(cChar* pc)
{
	setcharflag(pc);//AntiChrist - bugfix for highlight color not being updated
	
	P_CHAR Watcher;
	AllPlayersInRangeIterator api(pc);
	unsigned char goxyz[19];
	for (Watcher = api.First(); Watcher != NULL; Watcher = api.Next())
	{
		int s = api.getSocket();
		if (Watcher->isSameAs(pc))		// this is only sent to the updated player
		{
			LongToCharPtr( pc->serial,	&goxyz[1]);
			ShortToCharPtr(pc->id(),	&goxyz[5]);
			ShortToCharPtr(pc->skin,	&goxyz[8]);
			goxyz[10]=0x00;
			if (pc->Poisoned()) goxyz[10] |= 0x04;
			if (pc->isHidden()) goxyz[10] |= 0x80;
			PosToPtrXY(pc->pos,&goxyz[11]);
			goxyz[17]=pc->dir|0x80;		// not sure if the running bit should be set
			goxyz[18]=pc->pos.z;

			XStartPkt(0x20,19);
			XAddPkt(&goxyz[0+1], 19-1);
			XFinishPkt(s);
			
			walksequence[s]=-1;			// if pos didn't change, we could probably omit that
		}

		impowncreate(s, pc, 0);			
	}
}

void target(UOXSOCKET s, int a1, char *txt) // Send targetting cursor to client
{
	unsigned char tarcrs[20]="\x6C\x01\x40\x01\x02\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";

	targetok[s]=1;
	tarcrs[2]=(unsigned char) (a1>>24);
	tarcrs[3]=(unsigned char) (a1>>16);
	tarcrs[4]=(unsigned char) (a1>>8);
	tarcrs[5]=(unsigned char) (a1%256);
	sysmessage(s, txt);

	XStartPkt(0x6c, 19);
	XAddPkt(&tarcrs[0+1], 19-1);
	XFinishPkt(s);
}

void skillwindow(int s, P_CHAR Player) // Opens the skills list, updated for client 1.26.2b by LB
{
	int i;
	unsigned char skillstart[5]="\x3A\x01\x5d\x00"; // hack for that 3 new skills+1.26.2 client, LB 4'th dec 1999
	unsigned char skillmid[8] = "\x00\x00\x00\x00\x00\x00\x00"; // changed for 1.26.2 clients [size 7 insted of 4]
	unsigned char skillend[3]="\x00\x00";

	if (!Player) return;

	int sk=SkillManager->getAllSkillsValue();
	short len = 7*sk+6;

	XStartPkt(0x3a, len);
	XAddPkt(&skillstart[0+3], 4-3); // type: 0 -> full list without skill caps
	
	for (i=0;i<sk;i++)
	{
		SkillManager->updateSkillLevel(Player,i);
		skillmid[1]=i+1;
		ShortToCharPtr(Player->Skill(i), &skillmid[2]);
		ShortToCharPtr(Player->getRealSkill(i), &skillmid[4]);
		char x=Player->lockSkill[i];
		if (x!=0 && x!=1 && x!=2) x=0;
		skillmid[6]=x; // leave it unlocked, regardless

		XAddPkt(&skillmid[0], 7);
	}

	XAddPkt(&skillend[0], 2);
	XFinishPkt(s);
}


void updatestats( P_CHAR pc, char x )
{
	if (!pc) return;
	int a = 0, b = 0;
	unsigned char updater[10]="\xA1\x01\x02\x03\x04\x01\x03\x01\x02";
	
	switch (x)
	{
	case 0:
		a=pc->effStr();
		b=pc->Hp();
		break;
	case 1:
		a=pc->effInt();
		b=pc->Mana();
		break;
	case 2:
		a=pc->effDex();
		b=pc->Stm();
		break;
	}
	
	updater[0]=0xA1+x;
	LongToCharPtr(pc->serial,&updater[1]);
	ShortToCharPtr(a,&updater[5]);
	ShortToCharPtr(b,&updater[7]);
	if (x == 0)  //Send to all, only if it's Health change
	{
		SndToAllInRange(pc, updater, 9);
	}
	else
	{
		UOXSOCKET s = pc->calcSocket();
		if (s != -1)
		{
			XStartPkt(0xA1+x, 9);
			XAddPkt(&updater[0+1], 9-1);
			XFinishPkt(s);
		}
	}
}

void statwindow(int s, P_CHAR pc, unsigned char modus) // Opens the status window
{	
	if (modus!=0 && modus!=1 && modus!=4) modus=1;

	unsigned char statstring[88]={0,};
	bool ghost;
	
	if (s<0 || s>=MAXCLIENT || !pc) return; // lb, fixes a few (too few) -1 crashes ...

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if (pc->id()==0x0192 || pc->id()==0x0193) ghost = true; else ghost = false;

	LongToCharPtr(pc->serial,&statstring[3]);
	strncpy((char*)&statstring[7],pc->name, 30); // can not be more than 30

	if (!ghost)
	{
		ShortToCharPtr(pc->Hp(), &statstring[37]);	
	} 
	else
	{
		statstring[37] = statstring[38] = 0;
	}

	//Changed, so ghosts can see their maximum hit points.

	ShortToCharPtr(pc->effStr(), &statstring[39]);	

	// name change flag
	if ((Player->isGM() || Player->Owns(pc)) && !Player->isSameAs(pc))
	{
		statstring[41]=0xFF;
	} 
	else if (Player->Owns(pc) &&  !Player->isSameAs(pc)) //Morrolan - from Banter
	{
		statstring[41]=0xFF;
	}
	else
	{
		statstring[41]=0x00;
	}

	if (ghost) statstring[41]=0x00;

	if (modus==0) // modus 0 -> only health bar for other mobiles. 
                  // note: it also works to send all data (=modus 1/4) in that case.
                  // that's how it is currently done (always all data). 
				  // Anyway, I've added the possibility to use this optimization the protocol offers (LB)
	{
		statstring[42]=0;
		XStartPkt(0x11, 43);
	    XAddPkt(&statstring[0+3], 43-3);
	    XFinishPkt(s);
		return;
	}

	// sex
	if (pc->id()==0x0191) statstring[43]=1;
	else if (pc->id()==0x0193) statstring[43]=1;
	else statstring[43]=0;

	//Changed so ghosts can see their str, dex and int, their char haven't lose those attributes.
	ShortToCharPtr(pc->effStr(), &statstring[44]);
	ShortToCharPtr(pc->effDex(), &statstring[46]);
	ShortToCharPtr(pc->effInt(), &statstring[48]);

	if (!ghost)
	{
		ShortToCharPtr(pc->Stm(),&statstring[50]);
		ShortToCharPtr(pc->Mana(),&statstring[54]);
	}
	else
	{
		// Sets to 0 stamina and mana
		int l=0;
		LongToCharPtr(l, &statstring[50]);
	}

	// ghosts will see their mana as 0/x, ie 0/100
	// This will show red bars when status are displayed as percentages (little status window)

	ShortToCharPtr(pc->effDex(),&statstring[52]);
	ShortToCharPtr(pc->effInt(),&statstring[56]);
	
	int gold = pc->CountGold();
	LongToCharPtr(gold,&statstring[58]);
	
	short x=Combat->CalcDef(pc,0);
	ShortToCharPtr(x,&statstring[62]);

	x = pc->weight;
	ShortToCharPtr(x,&statstring[64]);
	
	// modus 1: old complete status data.
	if (modus==1 || !SrvParms->AOS_Mode)
	{
	   statstring[42]=1;
	   XStartPkt(0x11, 66);
	   XAddPkt(&statstring[0+3], 66-3);
	   XFinishPkt(s);
	   return;
	} 
	
	// modus 4: new AOS status data (modus 1 data+additional AOS data) [note: server has to be in AOS mode, otherwise not send]
	if (modus==4)
	{
	   statstring[42]=4;
	
	   short statcap=225;
	   char maxpets=5;
	   char currpets=0;	 
	   short fireresist=0;
	   short coldresist=0;
	   short poisonresist=0;	   
	   short energyresist=0;
	   short luck=0;
	   short damagemax=0;
	   short damagemin=0;
	   int tithing=pc->GetTithingPoints();
	 
	   statstring[68]=maxpets;
	   statstring[69]=currpets;	   
	   ShortToCharPtr(statcap,      &statstring[66]);
	   ShortToCharPtr(fireresist,   &statstring[70]);	   
	   ShortToCharPtr(coldresist,   &statstring[72]);
	   ShortToCharPtr(poisonresist, &statstring[74]);	   
	   ShortToCharPtr(energyresist, &statstring[76]);
	   ShortToCharPtr(luck,         &statstring[78]);	   
	   ShortToCharPtr(damagemax,    &statstring[80]);
	   ShortToCharPtr(damagemin,    &statstring[82]);	   
	   LongToCharPtr(tithing,       &statstring[84]);

	   XStartPkt(0x11, 88);
	   XAddPkt(&statstring[0+3], 88-3);
	   XFinishPkt(s);
	   return;
	}	
}

void updates(UOXSOCKET s) // Update Window
{
	Script* Scp = findSection(misc_script,"MOTD");
	if (!Scp) return;

	int x=0,y=0;
	int loopexit=0;
	while (Scp->NextLineInSection() && (++loopexit < MAXLOOPS) )
	{
		x++;
		y+=strlen(script1)+1;	// we will add one space later
	}
	Scp->Close();

	Scp = findSection(misc_script,"MOTD");
	if (!Scp) return;

	unsigned char updscroll[10]={0,};
	ShortToCharPtr(y+10,&updscroll[1]);
	updscroll[3]=2;
	ShortToCharPtr(y,&updscroll[8]);

	XStartPkt(0xA6, y+10);
	XAddPkt(&updscroll[0+3], 10-3);

	int j;
	for (j=0;j<x;j++)
	{
		char temp[512];
		Scp->NextLine();
		sprintf(temp, "%s ", script1);
		XAddPkt((unsigned char*)&temp[0], strlen(temp));
	}

	XFinishPkt(s);
	Scp->Close();
}


void deny(UOXSOCKET k, P_CHAR pc, int sequence)
{
	if (!pc) return;
	unsigned char walkdeny[9]="\x21\x00\x01\x02\x01\x02\x00\x01";

	walkdeny[1]=sequence;
	PosToPtrXY(pc->pos,&walkdeny[2]); 
	walkdeny[6]=pc->dir;
	walkdeny[7]=pc->dispz;

	XStartPkt(0x21, 8);
	XAddPkt(&walkdeny[0+1], 8-1);
	XFinishPkt(k);

	walksequence[k]=-1;
	
	static int fw1=0;

	if (SrvParms->antifastwalk)
	{
	  unsigned char addkey[9]={0xbf,0x0,0x9,0x0,0x2,0x0,0x0,0x0,0x0};
	  LongToCharPtr(0x77777700+(fw1), addkey+5);
	  XStartPkt(0xBF, 9);
	  XAddPkt(&addkey[0+3], 9-3);
	  XFinishPkt(k);
	  fw1++;
	}
}

void weblaunch(int s, char *txt) // Direct client to a web page
{
	int l;	

	sysmessage(s, "Launching your web browser. Please wait...");
	l=strlen(txt)+4;	
	
	XStartPkt(0xA5, l);	
	XAddPkt((unsigned char*)&txt[0], strlen(txt)+1); // note: [0+3] wrong here (though dyn-sized)
	XFinishPkt(s);
}

void broadcast(int s, P_CHAR Player) // GM Broadcast (Done if a GM yells something)
{
	if (!Player) return;
	int i,tl;
	unsigned char nonuni[512];
	
	if (Player->unicode)
	{
		for (i=13;i<(buffer[s][1]<<8)+buffer[s][2];i=i+2)
		{
			nonuni[(i-13)/2]=buffer[s][i];
		}
	}
	unsigned char talk[14];
	
	if (!Player->unicode)
	{
		tl=44+strlen((char*)&buffer[s][8])+1;		
		
		LongToCharPtr(Player->serial,&talk[3]);
		ShortToCharPtr(Player->id(),&talk[7]);
		talk[9]=1;
		talk[10]=buffer[s][4];
		talk[11]=buffer[s][5];
		talk[12]=buffer[s][6];
		talk[13]=Player->fonttype;
		
		P_CHAR pc;
		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			XStartPkt(0x1c, tl);
			XAddPkt(&talk[0+3], 14-3);
			
			XAddPkt((unsigned char*)&Player->name[0], 30);
			XAddPkt(&buffer[s][8], strlen((char*)&buffer[s][8])+1);
			XFinishPkt(api.getSocket());
		}
	}
	else
	{
		tl=44+strlen((char*)&nonuni[0])+1;
		
		LongToCharPtr(Player->serial,&talk[3]);
		ShortToCharPtr(Player->id(),&talk[7]);
		talk[9]=1;
		talk[10]=buffer[s][4];
		talk[11]=buffer[s][5];
		talk[12]=buffer[s][6];
		talk[13]=Player->fonttype;
		
		P_CHAR pc;
		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			XStartPkt(0x1c, tl);
			XAddPkt(&talk[0+3], 14-3);
			XAddPkt((unsigned char*)&Player->name[0], 30);
			XAddPkt(&nonuni[0], strlen((char*)&nonuni[0])+1);
			XFinishPkt(api.getSocket());
		}
	}
}

void itemtalk(int s, P_ITEM pi, char *txt) // Item "speech"
{
	if (s<=-1) return;
	if (!pi) return;

	int tl=44+strlen(txt)+1;

	unsigned char talk[14];

	LongToCharPtr(pi->serial,&talk[3]);
	ShortToCharPtr(pi->id(),&talk[7]);
	talk[9]=0; // Type
	talk[10]=0x04;
	talk[11]=0x81;
	talk[12]=0;
	talk[13]=3;

	XStartPkt(0x1c, tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt((unsigned char*)&pi->name[0], 30);
	XAddPkt((unsigned char*)&txt[0], strlen(txt)+1);
	XFinishPkt(s);
}


// player: if used to send some "fake" speech above players head, set to true
// actually with this flag it just doesnt set the speech color according to AI, so it looks real.
// if not given, it's set to false

void npctalk(int s, P_CHAR pc_npc, char *txt, char antispam, bool player) // NPC speech
{
	if (!pc_npc || s==-1) return;
	//P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	char machwas;
	if (antispam)
	{
		if (pc_npc->antispamtimer<uiCurrentTime)
		{
			pc_npc->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*10;
			machwas=1;
		} else machwas=0;
	} else machwas=1;

	if (machwas)
	{
		if (!player)
		{
		  pc_npc->saycolor = 0x0481;
		  if (pc_npc->isAiMonster()) //bad npcs speech (red)..Ripper
			pc_npc->saycolor = 0x0026;
		  else if (pc_npc->npc && !pc_npc->tamed && !pc_npc->guarded && !pc_npc->war)
			pc_npc->saycolor = 0x005b;
		}

		unsigned char talk[14];

		int tl=44+strlen(txt)+1;
		
		LongToCharPtr(pc_npc->serial,&talk[3]);
		ShortToCharPtr(pc_npc->id(),&talk[7]);
		talk[9]=0; // Type
		ShortToCharPtr(pc_npc->saycolor, &talk[10]);
		talk[12]=0;
		talk[13]=3;

		XStartPkt(0x1C, tl);
		XAddPkt(&talk[0+3], 14-3);

		XAddPkt((unsigned char*)&pc_npc->name[0], 30);
		XAddPkt((unsigned char*)&txt[0], strlen(txt)+1);	
		XFinishPkt(s);
	}
}

void npctalkall(cChar* pc, char *txt,char antispam) // NPC speech to all in range.
{
	if (!pc) return;

	bool machwas = false;

	if (antispam)
	{
		if (pc->antispamtimer<uiCurrentTime)
		{
			pc->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*10;
			machwas=true;
		} else machwas=false;
	} else machwas=true;

	if (machwas)
	{
		P_CHAR pc_l;
		AllPlayersInRangeIterator api(pc);
		for (pc_l = api.First(); pc_l != NULL; pc_l = api.Next())
		{
			npctalk(api.getSocket(), pc, txt,0);
		}
	}
}

void npctalk_runic(int s, P_CHAR pc, char *txt,char antispam) // NPC speech
{
	int tl;
	char machwas;

	if (!pc || s==-1) return; //lb

	if (antispam)
	{
		if (pc->antispamtimer<uiCurrentTime)
		{
			pc->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*10;
			machwas=1;
		} else machwas=0;
	} else machwas=1;

	if (machwas)
	{	
		tl=44+strlen(txt)+1;

		unsigned char talk[14];

		LongToCharPtr(pc->serial,&talk[3]);
		ShortToCharPtr(pc->id(),&talk[7]);
		talk[9]=0;

		// color here

		talk[10]=0;
		talk[11]=1; // black

		// big problems with contrast/readability, plz find out a better one, LB !

		talk[12]=0;
		talk[13]=8;			

		XStartPkt(0x1C, tl);
		XAddPkt(&talk[0+3], 14-3);
		XAddPkt((unsigned char*)&pc->name[0], 30);
		XAddPkt((unsigned char*)&txt[0], strlen(txt)+1);
		XFinishPkt(s);
	}
}

void npcemote(UOXSOCKET s, P_CHAR pc, char *txt, char antispam) // NPC speech
{
	int tl;
	char machwas;

	if (s==-1 || !pc) return;

	//P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if (antispam)
	{
		if (pc->antispamtimer<uiCurrentTime)
		{
			pc->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*10;
			machwas=1;
		} else machwas=0;
	} else machwas=1;

	if (machwas)
	{
		tl=44+strlen(txt)+1;

		unsigned char talk[14];


		LongToCharPtr(pc->serial,&talk[3]);
		ShortToCharPtr(pc->id(),&talk[7]);
		talk[9]=2; // Type
		pc->emotecolor=0x0026;
		ShortToCharPtr(0x0026,&talk[10]);
		talk[12]=0;
		talk[13]=3;

		XStartPkt(0x1C, tl);
		XAddPkt(&talk[0+3], 14-3);
		XAddPkt((unsigned char*)&pc->name[0], 30);
		XAddPkt((unsigned char*)&txt[0], strlen(txt)+1);
		XFinishPkt(s);
	}
}

// Last touch: LB 8'th April 2001 for particleSystem

// if UO_3DonlyEffect is true, sta has to be valid and contain particleSystem data (if not, crash)
// for particleSystem data layout see staticeffectUO3d and updated packetDoku
// for old 2d staticeffect stuff , the new (3d client) pararamters UO_3Donlyeffect, sta and skip_old are defaulted in such a way that they behave like they did before
// simply dont set them in that case
// the last parameter is for particlesystem optimization only (dangerous). don't use unless you know 101% what you are doing.

void staticeffect(P_CHAR pc, short eff, unsigned char speed, unsigned char loop,
				  bool UO3DonlyEffekt, stat_st *sta, bool skip_old)
{
	if (!pc) return;

	int a0,a1,a2,a3,a4;
	unsigned char effect[29];
	unsigned int j;
	P_CHAR Player = pc;
	
	if (!skip_old)
	{
		memset(&effect[0], 0, 29);	
		effect[0]=0x70; // Effect message
		effect[1]=0x03; // Static effect
		LongToCharPtr(Player->serial,&effect[2]);
		//[6] to [9] are the target ser, not applicable here.
		ShortToCharPtr(eff,&effect[10]);	// Object id of the effect
		PosToPtrXYZ(Player->pos,&effect[12]); 
		//[17] to [21] are the target's position, not applicable here.
		effect[22]=speed;
		effect[23]=loop; // 0 is really long. 1 is the shortest.
		effect[24]=0; // This value is unknown
		effect[25]=0; // This value is unknown
		effect[26]=1; // CLient side crashfix
		effect[27]=0; // This value is used for moving effects that explode on impact.
	}
	
	if (!UO3DonlyEffekt) // no UO3D effect ? lets send old effect to all clients
	{
		SndToAllInRange(Player, effect, 28);
		return;
	} 
	else
	{
		// UO3D effect -> let's check which client can see it
	   for (j=0;j<now;j++)
	   {
		   if (perm[j])
		   {
		     if (inrange1pl(Player,currchar(j)))
			 {
			 if (clientDimension[j]==2 && !skip_old) // 2D client, send old style'd 
			 {
				 XStartPkt(0x70, 28);
				 XAddPkt(&effect[0+1], 28-1);
				 XFinishPkt(j);

			 } else if (clientDimension[j]==3) // 3d client, send 3d-Particles	
			 {

				staticeffectUO3D(Player, sta);

				// allow to fire up to 4 layers at same time (like on OSI servers)
				a0 = sta->effect[10];

				a1 = ( ( a0 & 0x000000ff )       );
				a2 = ( ( a0 & 0x0000ff00 ) >> 8  );
				a3 = ( ( a0 & 0x00ff0000 ) >> 16 );
				a4 = ( ( a0 & 0xff000000 ) >> 24 );

				if (a1!=0xff) { particleSystem[46] = a1; XStartPkt(0xC7, 49); XAddPkt(&particleSystem[0+1], 49-1); XFinishPkt(j); } 					
				if (a2!=0xff) { particleSystem[46] = a2; XStartPkt(0xC7, 49); XAddPkt(&particleSystem[0+1], 49-1); XFinishPkt(j); }				
				if (a3!=0xff) { particleSystem[46] = a3; XStartPkt(0xC7, 49); XAddPkt(&particleSystem[0+1], 49-1); XFinishPkt(j); }
			    if (a4!=0xff) { particleSystem[46] = a4; XStartPkt(0xC7, 49); XAddPkt(&particleSystem[0+1], 49-1); XFinishPkt(j); }

				//sprintf(temp, "a0: %x a1: %x a2: %x a3: %x a4: %x \n",a0,a1,a2,a3,a4);
				//ConOut(temp);
			 }
			 else if (clientDimension[j] != 2 && clientDimension[j] !=3 ) { sprintf(temp, "Invalid Client Dimension: %i\n",clientDimension[j]); LogError(temp); } // attention: a simple else is wrong !
		 } // end inrange
		} // end perm
	  } // end for
	} // end UO:3D effect

	// remark: if a UO:3D effect is send and ALL clients are UO:3D ones, the pre-calculation of the 2-d packet
	// is redundant. but we can never know, and probably it will take years till the 2d cliet dies.
	// I think it's too infrequnet to consider this as optimization.
}


void movingeffect(P_CHAR pc_source, P_CHAR pc_dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode, bool UO3DonlyEffekt, move_st *str, bool skip_old )
{
	unsigned char effect[29];
	unsigned int j;

	if (pc_source==NULL || pc_dest==NULL) return;

	if (!skip_old)
	{
		effect[0]=0x70; // Effect message
		effect[1]=0x00; // Moving effect
		LongToCharPtr(pc_source->serial,&effect[2]);
		LongToCharPtr(pc_dest->serial,&effect[6]);
		effect[10]=eff1;// Object id of the effect
		effect[11]=eff2;
		PosToPtrXYZ(pc_source->pos,&effect[12]); 
		PosToPtrXYZ(pc_dest->pos,&effect[17]); 
		effect[22]=speed;
		effect[23]=loop; // 0 is really long. 1 is the shortest.
		effect[24]=0; // This value is unknown
		effect[25]=0; // This value is unknown
		effect[26]=0; //1; // LB, potential crashfix
		effect[27]=explode; // This value is used for moving effects that explode on impact.
	}
	
	
	if (!UO3DonlyEffekt) // no UO3D effect ? lets send old effect to all clients
	{
		for (j=0;j<now;j++)
		{
			if (perm[j])
			{
				if (inrange1pl(pc_source,currchar(j)) && inrange1pl(pc_dest,currchar(j)))
				{
					XStartPkt(0x70, 28);
					XAddPkt(&effect[0+1], 28-1);
					XFinishPkt(j);
				}
			}
		}
		return;
	} 
	else
	{
		// UO3D effect -> let's check which client can see it
		for (j=0;j<now;j++)
		{
			if (perm[j])
			{
				if ( inrange1pl(pc_source,currchar(j)) && inrange1pl(pc_dest,currchar(j)) )
				{
					if (clientDimension[j]==2 && !skip_old) // 2D client, send old style'd 
					{
						XStartPkt(0x70, 28);
						XAddPkt(&effect[0+1], 28-1);
						XFinishPkt(j);
						
					} else if (clientDimension[j]==3) // 3d client, send 3d-Particles	
					{
						
						movingeffectUO3D(pc_source, pc_dest, str);			
						XStartPkt(0xC7, 49);
						XAddPkt(&particleSystem[0+1], 49-1);
						XFinishPkt(j);
					}
					else if (clientDimension[j] != 2 && clientDimension[j] !=3 ) { sprintf(temp, "Invalid Client Dimension: %i\n",clientDimension[j]); LogError(temp); }
				}
			}
		}		
	}
}

void bolteffect(P_CHAR Player, bool UO3DonlyEffekt, bool skip_old )
{
	if (!Player) return;
	unsigned char effect[29];
	unsigned int  j;

	if (!skip_old)
	{
		memset(&effect[0], 0, 29);	
		effect[0]=0x70; // Effect message
		effect[1]=0x01; // Bolt effect
		LongToCharPtr(Player->serial,&effect[2]);
		//[6] to [11] are not applicable here.
		PosToPtrXYZ(Player->pos,&effect[12]); 
		//[17] to [27] are not applicable here.
		effect[26]=1; // LB possible client crashfix
		effect[27]=0;
	}
	
	if (!UO3DonlyEffekt) // no UO3D effect ? lets send old effect to all clients
	{
		SndToAllInRange(Player, effect, 28);
	} 
	else
	{
		// UO3D effect -> let's check which client can see it
		for (j=0;j<now;j++)
		{
			if (perm[j])
			{
				if (inrange1pl(Player,currchar(j)))
				{
					if (clientDimension[j]==2 && !skip_old) // 2D client, send old style'd 
					{
						XStartPkt(0x70, 28);
						XAddPkt(&effect[0+1], 28-1);
						XFinishPkt(j);
						
					} else if (clientDimension[j]==3) // 3d client, send 3d-Particles	
					{
						bolteffectUO3D(Player);			
						XStartPkt(0xC7, 49);
						XAddPkt(&particleSystem[0+1], 49-1);
						XFinishPkt(j);
					}
					else if (clientDimension[j] != 2 && clientDimension[j] !=3 ) { sprintf(temp, "Invalid Client Dimension: %i\n",clientDimension[j]); LogError(temp); }
				}
			}
		}
	}
}


// staticeffect2 is for effects on items
void staticeffect2(P_ITEM pi, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode, bool UO3DonlyEffekt,  stat_st *str, bool skip_old )
{
	unsigned char effect[29];
	unsigned int j;
	
	if (!skip_old)
	{
		memset(&effect[0], 0, 29);
		effect[0]=0x70; // Effect message
		effect[1]=0x02; // Static effect
		LongToCharPtr(pi->serial, &effect[2]);
		LongToCharPtr(pi->serial, &effect[6]);
		//[6] to [9] are the target ser, not applicable here.
		effect[10]=eff1;// Object id of the effect
		effect[11]=eff2;
		PosToPtrXYZ(pi->pos,&effect[12]); 
		PosToPtrXYZ(pi->pos,&effect[17]); 
		effect[22]=speed;
		effect[23]=loop; // 0 is really long. 1 is the shortest.
		effect[24]=0; // This value is unknown
		effect[25]=0; // This value is unknown
		effect[26]=1; // LB, client side crashfix
		effect[27]=explode; // This value is used for moving effects that explode on impact.
	}
	
	if (!UO3DonlyEffekt) // no UO3D effect ? lets send old effect to all clients
	{
		for (j=0;j<now;j++)
		{
			if (perm[j])
			{
				if (inrange2(j,pi))
				{
					XStartPkt(0x70, 28);
					XAddPkt(&effect[0+1], 28-1);
					XFinishPkt(j);
				}
			}
		}
		return;
	} 
	else
	{
		// UO3D effect -> let's check which client can see it
		for (j=0;j<now;j++)
		{
			if (perm[j])
			{
			  if (inrange2(j,pi))
			  {
				if (clientDimension[j]==2 && !skip_old) // 2D client, send old style'd 
				{
				  XStartPkt(0x70, 28);
				  XAddPkt(&effect[0+1], 28-1);
				  XFinishPkt(j);
				}
				else if (clientDimension[j]==3) // 3d client, send 3d-Particles	
				{
					itemeffectUO3D(pi, str);			

					XStartPkt(0xC7, 49);
					XAddPkt(&particleSystem[0+1], 49-1);
					XFinishPkt(j);
				}
				else if (clientDimension[j] != 2 && clientDimension[j] !=3 )
				{ sprintf(temp, "Invalid Client Dimension: %i\n",clientDimension[j]); LogError(temp); }
			  }
			}
		}
	}
}


void bolteffect2(P_CHAR Player,char a1,char a2)	// experimenatal, lb
{
	if (!Player) return;
	unsigned char effect[29] = {0,};
	int x2,x,y2,y;

	if (Player==NULL) return;

	effect[0]=0x70; // Effect message
	effect[1]=0x00; // effect from source to dest
	LongToCharPtr(Player->serial,&effect[2]);

	effect[10]=a1;
	effect[11]=a2;

	y=rand()%36;
	x=rand()%36;

	if (rand()%2==0) x=x*-1;
	if (rand()%2==0) y=y*-1;
	x2=Player->pos.x+x;
	y2=Player->pos.y+y;
	if (x2<0) x2=0;
	if (y2<0) y2=0;
	if (x2>6144) x2=6144;
	if (y2>4096) y2=4096;

	// ConOut("bolt: %i %i %i %i %i %i\n",x2,y2,Player->pos.x,Player->pos.y,x,y);

	PosToPtrXY(Player->pos,&effect[12]);	// source coordinates
	effect[16]=0;

	effect[17]=x2>>8;	//target coordiantes
	effect[18]=x2%256;
	effect[19]=y2>>8;
	effect[20]=y2%256;
	effect[21]=127;

	//[22] to [27] are not applicable here.

	effect[26]=1; // client crash bugfix
	effect[27]=0;

	SndToAllInRange(Player, effect, 28);
}

//	- Movingeffect3 is used to send an object from a char
//    to another object (like purple potions)
void movingeffect3(P_CHAR pc_source, const cCoord& epos, short effid, unsigned char speed, unsigned char loop, unsigned char explode)
{
	unsigned char effect[29];

	if (pc_source==NULL) return;

	memset (&effect, 0, 29);
	effect[0]=0x70; // Effect message
	effect[1]=0x00; // Moving effect
	LongToCharPtr(pc_source->serial,&effect[2]);
	effect[6]=0;
	effect[7]=0;
	effect[8]=0;
	effect[9]=0;
	LongToCharPtr(effid,&effect[10]);
	PosToPtrXYZ(pc_source->pos,&effect[12]); 
	PosToPtrXYZ(epos,&effect[17]); 
	effect[22]=speed;
	effect[23]=loop; // 0 is really long.  1 is the shortest.
	effect[24]=0; // This value is unknown
	effect[25]=0; // This value is unknown
	effect[26]=0; // This value is unknown
	effect[27]=explode; // This value is used for moving effects that explode on impact.

	SndToAllInRange(pc_source, effect, 28);
}

// staticeffect3 is for effects on items
void staticeffect3(const cCoord& pos, unsigned char eff1, unsigned char eff2, char speed, char loop, char explode)
{
	unsigned char effect[29];
	memset (&effect, 0, 29);

	effect[0]=0x70; // Effect message
	effect[1]=0x02; // Static effect
	//[6] to [9] are the target ser, not applicable here.
	effect[10]=eff1;// Object id of the effect
	effect[11]=eff2;
	PosToPtrXYZ(pos,&effect[12]); 
	PosToPtrXYZ(pos,&effect[17]); 
	effect[22]=speed;
	effect[23]=loop; // 0 is really long.  1 is the shortest.
	effect[24]=0; // This value is unknown
	effect[25]=0; // This value is unknown
	effect[26]=1; // LB changed to 1
	effect[27]=explode; // This value is used for moving effects that explode on impact.

	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (inVisRange(pos, pc->pos))
		{
			XStartPkt(0x70, 28);
			XAddPkt(&effect[0+1], 28-1);
			XFinishPkt(api.getSocket());
		}
	}
}

void movingeffect3(P_CHAR pc_source, P_CHAR pc_dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode,unsigned char unk1,unsigned char unk2,unsigned char ajust,unsigned char type)
{
	//0x0f 0x42 = arrow 0x1b 0xfe=bolt
	unsigned char effect[29];
	unsigned int j;

	if (!pc_source || !pc_dest) return;

	effect[0]=0x70; // Effect message
	effect[1]=type; // Moving effect
	LongToCharPtr(pc_source->serial,&effect[2]);
	LongToCharPtr(pc_dest->serial,&effect[6]);
	effect[10]=eff1;// Object id of the effect
	effect[11]=eff2;
	PosToPtrXYZ(pc_source->pos,&effect[12]); 
	PosToPtrXYZ(pc_dest->pos,&effect[17]); 
	effect[22]=speed;
	effect[23]=loop; // 0 is really long. 1 is the shortest.
	effect[24]=unk1; // This value is unknown
	effect[25]=unk2; // This value is unknown
	effect[26]=ajust; // LB, potential crashfix
	effect[27]=explode; // This value is used for moving effects that explode on impact.
	for (j=0;j<now;j++)
	{
		if (perm[j])
		{
			if (inrange1pl(pc_source,currchar(j)) && inrange1pl(pc_dest,currchar(j)))
			{
				XStartPkt(0x70, 28);
				XAddPkt(&effect[0+1], 28-1);
				XFinishPkt(j);
			}
		}
	}
}



//	- Movingeffect2 is used to send an object from a char
//	to another object (like purple potions)
void movingeffect2(P_CHAR pc_source, const P_ITEM pi, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode)
{
	//0x0f 0x42 = arrow 0x1b 0xfe=bolt
	unsigned char effect[29];
	unsigned int j;

	if (!pi) return;
	if (!pc_source) return;

	effect[0]=0x70; // Effect message
	effect[1]=0x00; // Moving effect
	LongToCharPtr(pc_source->serial,&effect[2]);
	LongToCharPtr(pi->serial, &effect[6]);
	effect[10]=eff1;// Object id of the effect
	effect[11]=eff2;
	PosToPtrXYZ(pc_source->pos,&effect[12]); 
	PosToPtrXYZ(pi->pos,&effect[17]); 
	effect[22]=speed;
	effect[23]=loop; // 0 is really long. 1 is the shortest.
	effect[24]=0; // This value is unknown
	effect[25]=0; // This value is unknown
	effect[26]=0; //1; // LB potential crashfix
	effect[27]=explode; // This value is used for moving effects that explode on impact.
	for (j=0;j<now;j++)
	{	// - If in range of source person or destination position and online send effect
		if (perm[j])
		{
			if (inrange1pl(pc_source,currchar(j)) || inrange2(j,pi))
			{
				XStartPkt(0x70, 28);
				XAddPkt(&effect[0+1], 28-1);
				XFinishPkt(j);
			}
		}
	}
}


///////////////////////////////////////////////////////////
/// input: region #, 
/// -1 = calc global world cycling.
/// if region has no cycling, calcs global world cycling
///////////////////////////////////////////////////////////

unsigned char calcLightCycling(int reg)
{
	unsigned char c='\xFF';
	int i=-1;
	int darklevel, brightlevel, curlevel;

	if (reg <0 || reg>255)
	{
		darklevel   = timeLight.worlddarklevel;
		brightlevel = timeLight.worldbrightlevel;
		curlevel    = timeLight.worldcurlevel;
	} else	
	{
		darklevel   = region[reg].darklevel;
		brightlevel = region[reg].brightlevel;
		curlevel    = region[reg].curlight;
	}

	if ((timeLight.hour<=3 && (!timeLight.ampm)) || (timeLight.hour>=10 && timeLight.ampm)) i=darklevel;
	if ((timeLight.hour>=10&& (!timeLight.ampm)) || (timeLight.hour<=3 && timeLight.ampm))  i=brightlevel;
	if (i==-1)
	{
		i=(((60*(timeLight.hour-4))+timeLight.minute) * (darklevel-brightlevel)) / 360;
		if (timeLight.ampm)
		{
			i=i+brightlevel;
		} else {
			i=darklevel-i;
		}
	}

	if (wtype) i += 2;
	if (timeLight.moon1+timeLight.moon2<4) i++;
	if (timeLight.moon1+timeLight.moon2<10) i++;
	c=i;

	return c;
}

void dolight(UOXSOCKET s)
{
	if ((s==-1)||(!perm[s])) return;

	unsigned char light[3]="\x4F\x00";
	int reg;
	char glob;
	int fixed,dungeon,bright,dark;

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	// first check if player is under temp-light-change effect (255==no effect)
	// if so, no need to do further calculations.
	// just send effect value and quit
	if (Player->fixedlight!=255)
	{
		light[1]=Player->fixedlight;
		if (light[1]-Player->lastlightvalue!=0) //only send if light actually changes
		{
		   XStartPkt(0x4F, 2);
		   XAddPkt(&light[0+1], 2-1);
		   XFinishPkt(s);
		   Player->lastlightvalue=light[1];		
		}
		return;
	}

	/// now check region and region light values
	/// if region invalid or region light vlaues not defined, use global light values
	reg = Player->region;
	glob=0;
	if (reg<0 || reg >255) glob=1;
	else if ( region[reg].darklevel == -2 || region[reg].brightlevel == -2 )  glob=1; else glob=0;

	if (glob)
	{
		fixed   = timeLight.worldfixedlevel;
        dark    = timeLight.worlddarklevel;
		bright  = timeLight.worldbrightlevel;
		dungeon = timeLight.dungeonlightlevel;

	}
	else
	{
		fixed   =  region[reg].fixedlight;
		dark    =  region[reg].darklevel;
		bright  =  region[reg].brightlevel;
		dungeon =  region[reg].dungeonlevel;
	}

	/// finally we've got all lightvalues.

	/// now check if we are in a dungeon.
	/// if so, send dungeonlight and quit

	if (indungeon(Player))
	{
		light[1]=dungeon;
		if (light[1]-Player->lastlightvalue!=0) //only send if light actually changes
		{
		   XStartPkt(0x4F, 2);
		   XAddPkt(&light[0+1], 2-1);
		   XFinishPkt(s);
		   Player->lastlightvalue=light[1];
		}
		return;	
	}

	//// finally check if we have fixedlight or cyclinglight.
	
	if (fixed!=255)
	{
		light[1]=fixed;
        
		if (glob) 
		{			
			timeLight.worldcurlevel=fixed;
		}
		else 
		{			
			region[reg].curlight=fixed;
		}
		
	}
	else
	{
		int l;
		if (glob)
		{
			l = calcLightCycling(-1);		
			timeLight.worldcurlevel=l;
			light[1]=l;		
		}
		else
		{
			l = calcLightCycling(reg);		 
			region[reg].curlight=l;
			light[1]=l;
		}			
	}
	
	if (light[1]-Player->lastlightvalue!=0) //only send if light actually changes 
	{
	    XStartPkt(0x4F, 2);
	    XAddPkt(&light[0+1], 2-1);
		XFinishPkt(s);
		Player->lastlightvalue=light[1];
	}
}

void updateskillPacket(int s, int skillnum) // updated for client 1.26.2b by LB
{
	unsigned char update[11];
	char x;
	
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	
	update[0] = 0x3A; // Skill Update Message
	update[3] = '\xFF'; // single list

	if (skillnum>ALLSKILLSMAX || skillnum<0) return;
	
	update[4] = 0x00;
	update[5] = (char)skillnum;

	ShortToCharPtr(Player->Skill(skillnum), &update[6]);
	ShortToCharPtr(Player->getRealSkill(skillnum), &update[8]);
	x = Player->lockSkill[skillnum];
	if (x != 0 && x != 1 && x != 2) x = 0;
	update[10] = x;
		
	XStartPkt(0x3A, 11);
	XAddPkt(&update[0+3], 11-3);
	XFinishPkt(s);
}

void deathaction(P_CHAR pc, P_ITEM Corpse) // Character does a certain action
{
	if (!pc || !Corpse) return;
	unsigned char deathact[14]="\xAF\x01\x02\x03\x04\x01\x02\x00\x05\x00\x00\x00\x00";

	LongToCharPtr(pc->serial,&deathact[1]);
	LongToCharPtr(Corpse->serial,&deathact[5]);
	
	SndToAllInRangeExept(pc,deathact,13);
}

void deathmenu(int s) // Character sees death menu
{
	unsigned char testact[3]="\x2C\x00";

	XStartPkt(0x2C, 2);
	XAddPkt(&testact[0+1], 2-1);
	XFinishPkt(s);
}

// impowncreate without online checks, fixed grey look
// only use[d] for insta-loggout for gm's ...

void sendgrey(UOXSOCKET s, P_CHAR pc)
{
	if (s==-1) return;
	if (!pc) return;
	int j, k;
	unsigned char oc[1024];

	if (pc->stablemaster_serial>0) return; // dont **show** stabled pets

	oc[0]=0x78; // Message type 78

	LongToCharPtr(pc->serial,&oc[3]);
	ShortToCharPtr(pc->id(), &oc[7]);	// Character art id
	PosToPtrXYZ(pc->pos,&oc[9]);		// Character position
	oc[14]=pc->dir; // Character direction
	ShortToCharPtr(pc->skin, &oc[15]); // Character skin color
	oc[17]=0x80; // show GREY
	oc[18]=3;
	k=19;

	for (j=0;j<MAXLAYERS;j++) layers[j] = 0;

	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=pc->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if ( layers[pi->layer] == 0 )
		{
			LongToCharPtr(pi->serial,oc+k+0);
			ShortToCharPtr(pi->id(),oc+k+4);
			oc[k+6]=pi->layer;
			k=k+7;
			if (pi->color()!=0)
			{
				oc[k-3] |= 0x80;
				ShortToCharPtr(pi->color(),oc+k);
				k=k+2;
			}
			layers[pi->layer] = 1;
		}
	}
	
	oc[k+0]=0;// Not well understood. It's a serial number. I set this to my serial number,
	oc[k+1]=0;// and all of my messages went to my paperdoll gump instead of my character's
	oc[k+2]=0;// head, when I was a character with serial number 0 0 0 1.
	oc[k+3]=0;
	k=k+4;

	// unimportant remark: its a packet "terminator" !!! LB

	oc[1]=k>>8;
	oc[2]=k%256;

	XStartPkt(0x78,k);
	XAddPkt(&oc[0+3], k-3);
	XFinishPkt(s);
}


void impowncreate(UOXSOCKET s, P_CHAR pc, int z) //socket, player to send
{
	int j, k;
	unsigned char oc[1024];

	if (!pc) return;
	if (s==-1) return; //lb
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if (pc->stablemaster_serial>0) return; // dont **show** stabled pets
	if (pc->isHidden()
		&& !Player->isSameAs(pc)
		&& (Player->GetViewingDepth()<1))	//note: only gms can have viewingdepth>0
		return;
	if (	(!pc->InGame() && !pc->npc && (Player->GetViewingDepth()<2)) ||
			(pc->isDummy() && (Player->GetViewingDepth()<3))	)
	{
		SndRemoveNpc(s, pc);
		return;
	}
	// hidden chars can only be seen "grey" by themselves or by gm's
	// other wise they are invisible=dont send the packet

	oc[0]=0x78; // Message type 78

	LongToCharPtr(pc->serial, &oc[3]);	// Character serial number
	ShortToCharPtr(pc->id(), &oc[7]);	// Character art id
	PosToPtrXY(pc->pos, &oc[9]);		// Character x/y position
	if (z) oc[13]=pc->dispz; // Character z position
	else oc[13]=pc->pos.z;
	oc[14]=pc->dir; // Character direction
	ShortToCharPtr(pc->skin, &oc[15]); // Character skin color
	oc[17]=0; // Character flags
	if (pc->isHidden() || !(pc->InGame()||pc->npc)) oc[17] |= 0x80; // Show hidden state correctly
	if (pc->Poisoned()) oc[17] |= 0x04; //AntiChrist -- thnx to SpaceDog
	
	k=19;
	int guild=Guilds->Compare(Player,pc);
	if (guild==1)//Same guild (Green)
		oc[18]=2;
	else if (guild==2) // Enemy guild.. set to orange
		oc[18]=5;
	else
	{
		switch(pc->flag)
		{//1=blue 2=green 5=orange 6=Red 7=Transparent(Like skin 66 77a)
		case 0x01: oc[18]=6; break;// If a bad, show as red.
		case 0x04: oc[18]=1; break;// If a good, show as blue.
		case 0x08: oc[18]=2; break;// green (guilds)
		case 0x10: oc[18]=5; break;// orange (guilds)
		default:   oc[18]=3; break;// grey (Can be pretty much any number.. I like 3 :-)
		}
	}
	
	for (j=0;j<MAXLAYERS;j++) layers[j] = 0;

	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=pc->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if ( layers[pi->layer] == 0 )
		{
			LongToCharPtr(pi->serial,oc+k+0);
			ShortToCharPtr(pi->id(),oc+k+4);
			oc[k+6]=pi->layer;			
			
			// invisible horse stuff, needs special treatment for 3d clients, LB
			if (pi->id()==0x3ecf && pi->layer==0x19 && clientDimension[s]==3) oc[k+5]=0xbd;
			
			k=k+7;
			if (pi->color()!=0)
			{
				oc[k-3] |= 0x80;
				ShortToCharPtr(pi->color(),oc+k);
				k=k+2;
			}
			layers[pi->layer] = 1;
		}
		else
		{
#ifdef DEBUG
			ConOut("Double layer (%i) on Item (%i) on Char (%i)\n", pi->layer , j , i);
			sprintf(temp, "Double layer (%i) on Item (%2x %2x %2x %2x) on Char (%2x %2x %2x %2x)\n",
				pi->layer, pi->ser1, pi->ser2, pi->ser3, pi->ser4,
				pc->ser1, pc->ser2, pc->ser3, pc->ser4);
			sysbroadcast(temp);
#endif
		}
	}

	oc[k+0]=0;// Not well understood. It's a serial number. I set this to my serial number,
	oc[k+1]=0;// and all of my messages went to my paperdoll gump instead of my character's
	oc[k+2]=0;// head, when I was a character with serial number 0 0 0 1.
	oc[k+3]=0;
	k=k+4;

	// unimportant remark: its a packet "terminator" !!! LB

	oc[1]=k>>8;
	oc[2]=k%256;

	XStartPkt(0x78,k);
	XAddPkt(&oc[0+3], k-3);
	XFinishPkt(s);
}

void senddummyshopinfo(int s, P_CHAR Vendor, P_ITEM pi)
{
	unsigned char m1[1024];
	unsigned char m2[1024];
	unsigned char itemname[256];
	memset(m1, 0, 1024);
	memset(m2, 0, 1024);
	memset(itemname, 0, 256);
	int m1t,m2t,k, slen;

	strcpy((char*)itemname,"I'm out of regular wares");

	m1[0]=0x3C; // Container content message
	m1[1]=0;
	m1[2]=0;// Size of message
	m1[3]=0;//  Count of items
	m1[4]=1;// Count of items

	m2[0]=0x74;// Buy window details message
	m2[1]=0;// Size of message
	m2[2]=0;// Size of message
	LongToCharPtr(pi->serial,m2+3); //container serial number
	m2[7]=1; // Count of items;

	m1t=5;
	m2t=8;

	LongToCharPtr(0,m1+m1t+0);    //dummy Item serial number
	ShortToCharPtr(0,m1+m1t+4);   //dummy ID
	m1[m1t+6]=0;			        
		
	ShortToCharPtr(0,m1+m1t+7); 
	ShortToCharPtr(m1t,m1+m1t+9);   
	ShortToCharPtr(m1t,m1+m1t+11);   
	LongToCharPtr(pi->serial,m1+m1t+13);   // container serial
	ShortToCharPtr(0,m1+m1t+17);

	LongToCharPtr(0,m2+m2t+0); 		  // item value

	slen=strlen((char*)itemname)+1;

	m2[m2t+4]=slen;

	for(k=0;k<slen;k++)
	{
		m2[m2t+5+k]=itemname[k];          // item name
	}

	m2t=m2t+slen+5;	
	m1t=m1t+19;

	ShortToCharPtr(m1t,m1+1); 
	ShortToCharPtr(m2t,m2+1); 

	XStartPkt(0x3c, m1t);
	XAddPkt(&m1[0+3], m1t-3);
	XFinishPkt(s);

	XStartPkt(0x74, m2t);
	XAddPkt(&m2[0+3], m2t-3);	
	XFinishPkt(s);

}


bool sendshopinfo(int s, P_CHAR Vendor, P_ITEM pi)
{
	unsigned char m1[6096];
	unsigned char m2[6096];
	char itemname[256];
	char cFoundItems=0;
	memset(m1,0,6096);
	memset(m2,0,6096);
	memset(itemname,0,256);
	int k, m1t, m2t, value;
	unsigned char slen;
               
	m1[0]=0x3C; // Container content message
	m1[1]=0;// Size of message
	m1[2]=0;// Size of message
	m1[3]=0;//  Count of items
	m1[4]=0;// Count of items
	m2[0]=0x74;// Buy window details message
	m2[1]=0;// Size of message
	m2[2]=0;// Size of message
	LongToCharPtr(pi->serial,m2+3); //container serial number
	m2[7]=0; // Count of items;
	m1t=5;
	m2t=8;

	int ci=0,loopexit=0;
	P_ITEM pj;
	while ( ((pj=pi->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (m2[7]==255) break;	// 255 items max per shop container
		if (pj->amount>0)		// don't count items with 0 amount 
								// (0x1a container items should never be deleted, hence they get a 0 if item out of stock 
		{
			if (m2t>6000 || m1t>6000) break;
					
			LongToCharPtr(pj->serial,m1+m1t+0);    //Item serial number
			ShortToCharPtr(pj->id(),m1+m1t+4);     //ID

			//m1[m1t+6]=0;			               // Always zero (but already 0'ed out)
		
			ShortToCharPtr(pj->amount,m1+m1t+7);   // amount

			ShortToCharPtr(m1t,m1+m1t+9);   
			ShortToCharPtr(m1t,m1+m1t+11);   

			/// note, that's actually kind of a client bug resp. oddity
			/// normally, those two are for x/y of item
			/// but client sorts the items in 0x3c's by x/y after 0x74 being send, not like it had been added
            /// it does NOT sort 0x74. so we get a mismatch of ID+description if we add real x/y's
			/// to get them synched (both lists in same order) we need to add dummy x/y's that have same order like being added
			/// eg m1t, itemcount would work as well. just has to be monotonic increasing with itemcount		

			LongToCharPtr(pi->serial,m1+m1t+13);   // container serial
			ShortToCharPtr(pj->color(),m1+m1t+17); // Item color

			m1[4]++; // Increase item count.
			m1t=m1t+19;

			value=pj->calcBuyPrice(Vendor->region);

	        LongToCharPtr(value,m2+m2t+0); 		  // item value
			slen=m2[m2t+4]=pj->getName(itemname); // Item name length		
			
			for(k=0;k<slen;k++)
			{
				m2[m2t+5+k]=itemname[k];          // item name
			}
			
			m2[7]++;
			m2t=m2t+slen+5;		
			cFoundItems=1; //we found items so send message			
		}
	}
   
	if (cFoundItems==1)
	{
		ShortToCharPtr(m1t,m1+1); 
	    ShortToCharPtr(m2t,m2+1); 

		XStartPkt(0x3c, m1t);
	    XAddPkt(&m1[0+3], m1t-3);
	    XFinishPkt(s);

	    XStartPkt(0x74, m2t);
	    XAddPkt(&m2[0+3], m2t-3);	
	    XFinishPkt(s);

		return true;
	}

	return false;
}

void SearchItemToSell(P_CHAR Vendor, P_ITEM ShopItem, P_ITEM Pack, unsigned char* m1, int* m1t)
{
	char ciname[256]; // By Magius(CHE)
	char cinam2[256]; // By Magius(CHE)
	char itemname[256];

	int value;

	int ci2 = 0, loopexit2 = 0;
	P_ITEM PackItem;	// items that the Player has
	while ( ((PackItem=Pack->Search(&ci2)) != NULL) && (++loopexit2 < MAXLOOPS) )
	{
		if (PackItem->isType(ITY_Container))
		{
			int ci = 0;
			if (PackItem->Search(&ci) != NULL)// pack is not empty
			{
				if (SrvParms->sellfromsubpacks) SearchItemToSell(Vendor, ShopItem, PackItem, m1, m1t);
				continue;
			}
		}
		sprintf(ciname,"'%s'",PackItem->name); // Added by Magius(CHE)
		sprintf(cinam2,"'%s'",ShopItem->name); // Added by Magius(CHE)
		strupr(ciname); // Added by Magius(CHE)
		strupr(cinam2); // Added by Magius(CHE)
		
		if (PackItem->id()==ShopItem->id()  &&
			PackItem->isType(ShopItem->type) && (m1[8]<60) &&
			((SrvParms->sellbyname==0)||(SrvParms->sellbyname==1 && (!strcmp(ciname,cinam2))))) // If the names are the same! --- Magius(CHE)
		{

			if (*m1t>=4000) break;				

			LongToCharPtr( PackItem->serial,	m1+(*m1t)+0);
			ShortToCharPtr(PackItem->id(),		m1+(*m1t)+4);
			ShortToCharPtr(PackItem->color(),	m1+(*m1t)+6);
			ShortToCharPtr(PackItem->amount,	m1+(*m1t)+8);
			value=ShopItem->calcSellPrice(Vendor->region,PackItem);			

			ShortToCharPtr(value, m1+(*m1t)+10);

			m1[(*m1t)+12]=0;// Unknown... 2nd length byte for string?
			m1[(*m1t)+13]=PackItem->getName(itemname);

			(*m1t)+=14;

			for(int z=0;z<m1[(*m1t)-1];z++)
			{
				m1[(*m1t)+z]=itemname[z];
			}
			(*m1t)=(*m1t)+m1[(*m1t)-1];
			m1[8]++;
		}
	}
}

int sellstuff(int s, P_CHAR pc)
{
	if (!pc) return 0;

	int m1t;
	unsigned char m1[4096];

	cItem* BuyList = pc->GetItemOnLayer(0x1C);
	if (BuyList == NULL)
		return 0;

	P_CHAR Player = MAKE_CHARREF_LRV(currchar(s),0);
	cItem* Pack = Player->getBackpack();
	if (!Pack)
		return 0;

	m1[0]=0x9E; // Header
	m1[1]=0; // Size
	m1[2]=0; // Size
	LongToCharPtr(pc->serial,m1+3);
	m1[7]=0; // Num items
	m1[8]=0; // Num items
	m1t=9;

	int ci=0,loopexit=0;
	P_ITEM ShopItem;	// items that the vendor would like to buy
	while ( ((ShopItem=BuyList->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		SearchItemToSell(pc, ShopItem, Pack, m1, &m1t);

	ShortToCharPtr(m1t,	m1+1);

	if (m1[8]>0)
	{
		XStartPkt(0x9E, m1t);
		XAddPkt(&m1[0+3], m1t-3);
		XFinishPkt(s);
	}
	else
	{
		npctalkall(pc, "Thou doth posses nothing of interest to me.",0);
	}

	return 1;
}

void playmidi(int s, char num1, char num2)
{
	unsigned char msg[3];
	msg[0]=0x6D;
	msg[1]=num1;
	msg[2]=num2;

	XStartPkt(0x6D, 3);
	XAddPkt(&msg[0+1], 3-1);
	XFinishPkt(s);
}

void sendtradestatus(P_ITEM Trade1, P_ITEM Trade2)
{
	if (!Trade1 || !Trade2) return;

	P_CHAR Player1 = FindWearerOf(Trade1);
	P_CHAR Player2 = FindWearerOf(Trade2);
	if (!Player1 || !Player2) return;

	int s1 = Player1->calcSocket();
	int s2 = Player2->calcSocket();
	if (s1 == -1 || s2 == -1) return; 

	unsigned char msg[30];
	msg[0]=0x6F;//Header
	msg[3]=0x02;//State
	LongToCharPtr(Trade1->serial,msg+4);
	msg[8]=0;
	msg[9]=0;
	msg[10]=0;
	msg[11]=Trade1->morez%256;
	msg[12]=0;
	msg[13]=0;
	msg[14]=0;
	msg[15]=Trade2->morez%256;
	msg[16]=0; // No name in this message

	XStartPkt(0x6F, 17);
	XAddPkt(&msg[0+3], 17-3);
	XFinishPkt(s1);

	LongToCharPtr(Trade2->serial,msg+4);
	msg[11]=Trade2->morez%256;
	msg[15]=Trade1->morez%256;

	XStartPkt(0x6F, 17);
	XAddPkt(&msg[0+3], 17-3);
	XFinishPkt(s2);
}

void endtrade(P_ITEM Cont1)
{
	if (!Cont1) return;
	P_ITEM Cont2 = FindItemBySerial(Cont1->getMoreB1_4());
	if (!Cont2) return;

	P_CHAR Player1 = FindWearerOf(Cont1);
	P_CHAR Player2 = FindWearerOf(Cont2);
	if (!Player1 || !Player2) return;

	P_ITEM Pack1 = Packitem(Player1);
	P_ITEM Pack2 = Packitem(Player2);
	if (!Pack1 || !Pack2) return;

	int s1 = Player1->calcSocket();
	int s2 = Player2->calcSocket();

	unsigned char msg[30];
	msg[0]=0x6F;//Header Byte
	msg[1]=0x00;//Size
	msg[2]=0x11;//Size
	msg[3]=0x01;//State byte
	msg[8]=0;
	msg[9]=0;
	msg[10]=0;
	msg[11]=0;
	msg[12]=0;
	msg[13]=0;
	msg[14]=0;
	msg[15]=0;
	msg[16]=0;

	LongToCharPtr(Cont1->serial,msg+4);
	if (s1 > -1)	// player may have been disconnected (Duke)
	{
		XStartPkt(0x6F, 17);
		XAddPkt(&msg[0+3], 17-3);
		XFinishPkt(s1);
	}
	
	LongToCharPtr(Cont2->serial,msg+4);
	if (s2 > -1)	// player may have been disconnected (Duke)
	{
		XStartPkt(0x6F, 17);
		XAddPkt(&msg[0+3], 17-3);
		XFinishPkt(s2);
	}
	
	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Cont1->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		pi->SetContSerial(Pack1->serial);
		if (pi->glow>0)
		{
			Player1->removeHalo(pi);
			Player1->addHalo(pi);
		}
		pi->SetRandPosInCont(Pack1);
		if (s1!=-1) pi->refresh();
		
	}
	
	ci=0,loopexit=0;
	while ( ((pi=Cont2->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		pi->SetContSerial(Pack2->serial);
		if (pi->glow>0)
		{
			Player2->removeHalo(pi);
			Player2->addHalo(pi);
		}
		pi->SetRandPosInCont(Pack2);
		if (s2!=-1)
			pi->refresh();
	}
	
	Items->DeleItem(Cont1);
	Items->DeleItem(Cont2);
}

void tellmessage(int i, int s, char *txt)
{
	int tl;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	sprintf(temp, "GM tells %s: %s", Player->name, txt);

	tl=44+strlen(temp)+1;

	unsigned char talk[14];

	talk[3]=1;
	talk[4]=1;
	talk[5]=1;
	talk[6]=1;
	talk[7]=1;
	talk[8]=1;
	talk[9]=0;
	talk[10]=0x00; //First Part  \_Yellow
	talk[11]=0x35; //Second Part /
	talk[12]=0;
	talk[13]=3;

	XStartPkt(0x1C, tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt((unsigned char*)&zeros[0], 30);
	XAddPkt((unsigned char*)&temp[0], strlen(temp)+1);
	XFinishPkt(s);

	XStartPkt(0x1C, tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt((unsigned char*)&zeros[0], 30);
	XAddPkt((unsigned char*)&temp[0], strlen(temp)+1);

	XFinishPkt(i);

}



// particleSystem core functions, LB 2-April 2001

// sta_str layout:

// 0..3 already used in 2d-staticeffect
// effect 4  -> tile1
// effect 5  -> tile2
// effect 6  -> speed1
// effect 7  -> speed1
// effect 8  -> effect1
// effect 9  -> effect2
// effect 10 -> reserved, dont use
// effect 11 -> 
// effect 12 -> 


void staticeffectUO3D(P_CHAR pc, stat_st *sta)
{
	if (!pc) return;
	
	// please no optimization of p[...]=0's yet :)
	
	particleSystem[0]=0xc7;
	particleSystem[1]=0x3;

	LongToCharPtr(pc->serial,&particleSystem[2]);
	
	particleSystem[6]=0x0; // always 0 for this type
	particleSystem[7]=0x0;
	particleSystem[8]=0x0;
	particleSystem[9]=0x0;
	
	particleSystem[10]=sta->effect[4]; // tileid1
	particleSystem[11]=sta->effect[5]; // tileid2
	
	PosToPtrXYZ(pc->pos,&particleSystem[12]); 
	PosToPtrXYZ(pc->pos,&particleSystem[17]); 
	
	particleSystem[22]= sta->effect[6]; // unkown1 
	particleSystem[23]= sta->effect[7]; // unkown2
	
	particleSystem[24]=0x0; // only non zero for type 0
	particleSystem[25]=0x0;
	
	particleSystem[26]=0x1;
	particleSystem[27]=0x0;
	
	particleSystem[28]=0x0;
	particleSystem[29]=0x0;
	particleSystem[30]=0x0;
	particleSystem[31]=0x0;
	particleSystem[32]=0x0;
	particleSystem[33]=0x0;
	particleSystem[34]=0x0;
	particleSystem[35]=0x0;
	
	particleSystem[36]=sta->effect[8]; // effekt #
	particleSystem[37]=sta->effect[9];
	
	particleSystem[38]=sta->effect[11];
	particleSystem[39]=sta->effect[12];
	
	particleSystem[40]=0x00;
	particleSystem[41]=0x00;
	
	LongToCharPtr(pc->serial,&particleSystem[42]);
	
	particleSystem[46]=0; // layer, gets set afterwards for multi layering
	
	particleSystem[47]=0x0; // has to be always 0 for all types
	particleSystem[48]=0x0;
	
}

// move_st layout:
// 0..4 already used in 2d-move_effect

// effect 5  -> tile1
// effect 6  -> tile2
// effect 7  -> speed1
// effect 8  -> speed2
// effect 9  -> effect1
// effect 10 -> effect2
// effect 11 -> impact effect1
// effect 12 -> impact effect2
// effect 13 -> unkown1, does nothing, but gets set on OSI shards
// effect 14 -> unkown2
// effect 15 -> adjust  
// effect 16 -> explode on impact

void movingeffectUO3D(P_CHAR source, P_CHAR dest, move_st *sta)
{
	P_CHAR pc_cs=source;
	P_CHAR pc_cd=dest;
	
	if (source==NULL || dest==NULL) return;
	
	particleSystem[0]=0xc7;
	particleSystem[1]=0x0;
	
	LongToCharPtr(pc_cs->serial,&particleSystem[2]);
	LongToCharPtr(pc_cd->serial,&particleSystem[6]);
	
	particleSystem[10]=sta->effect[5]; // tileid1
	particleSystem[11]=sta->effect[6]; // tileid2
	
	PosToPtrXYZ(pc_cs->pos,&particleSystem[12]); 
	PosToPtrXYZ(pc_cd->pos,&particleSystem[17]); 
	
   particleSystem[22]= sta->effect[7]; // speed1 
   particleSystem[23]= sta->effect[8]; // speed2

   particleSystem[24]=0x0; 
   particleSystem[25]=0x0;

   particleSystem[26]=sta->effect[15]; // adjust
   particleSystem[27]=sta->effect[16]; // explode

   particleSystem[28]=0x0;
   particleSystem[29]=0x0;
   particleSystem[30]=0x0;
   particleSystem[31]=0x0;
   particleSystem[32]=0x0;
   particleSystem[33]=0x0;
   particleSystem[34]=0x0;
   particleSystem[35]=0x0;

   particleSystem[36]=sta->effect[9]; //  moving effekt 
   particleSystem[37]=sta->effect[10];
   particleSystem[38]=sta->effect[11]; // effect on explode
   particleSystem[39]=sta->effect[12];

   particleSystem[40]=sta->effect[13]; // ??
   particleSystem[41]=sta->effect[14];

   particleSystem[42]=0x00;
   particleSystem[43]=0x00;
   particleSystem[44]=0x00;
   particleSystem[45]=0x00;
   
   particleSystem[46]=0xff; // layer, has to be 0xff in that modus

   particleSystem[47]=sta->effect[17];
   particleSystem[48]=0x0;

}

// same sta-layout as staticeffectuo3d
void itemeffectUO3D(P_ITEM pi, stat_st *sta)
{
	// please no optimization of p[...]=0's yet :)
	
	particleSystem[0]=0xc7;
	particleSystem[1]=0x2;
	
	if ( !sta->effect[11] ) 
	{
		LongToCharPtr(pi->serial, &particleSystem[2]);
	}
	else
	{
		particleSystem[2]=0x00;
		particleSystem[3]=0x00;
		particleSystem[4]=0x00;
		particleSystem[5]=0x00;
	}
	
	particleSystem[6]=0x0; // always 0 for this type
	particleSystem[7]=0x0;
	particleSystem[8]=0x0;
	particleSystem[9]=0x0;
	
	particleSystem[10]=sta->effect[4]; // tileid1
	particleSystem[11]=sta->effect[5]; // tileid2
	
	PosToPtrXYZ(pi->pos,&particleSystem[12]); 
	PosToPtrXYZ(pi->pos,&particleSystem[17]); 
	
	particleSystem[22]= sta->effect[6]; // unkown1 
	particleSystem[23]= sta->effect[7]; // unkown2
	
	particleSystem[24]=0x0; // only non zero for type 0
	particleSystem[25]=0x0;
	
	particleSystem[26]=0x1;
	particleSystem[27]=0x0;
	
	particleSystem[28]=0x0;
	particleSystem[29]=0x0;
	particleSystem[30]=0x0;
	particleSystem[31]=0x0;
	particleSystem[32]=0x0;
	particleSystem[33]=0x0;
	particleSystem[34]=0x0;
	particleSystem[35]=0x0;
	
	particleSystem[36]=sta->effect[8]; // effekt #
	particleSystem[37]=sta->effect[9];
	
	particleSystem[38]=0; // unknown
	particleSystem[39]=1;
	
	particleSystem[40]=0x00;
	particleSystem[41]=0x00;
	
	LongToCharPtr(pi->serial, &particleSystem[42]);
	
	particleSystem[46]=0xff; 
	
	particleSystem[47]=0x0; 
	particleSystem[48]=0x0;
}

void bolteffectUO3D(P_CHAR pc)
{
	OldMagic->doStaticEffect(pc, 30);
}

void PlayDeathSound( P_CHAR pc )
{ 
	if (pc->xid()==0x0191)
	{
		switch(RandomNum(0, 3)) // AntiChrist - uses all the sound effects
		{
		case 0:		soundeffect2( pc, 0x0150 );	break;// Female Death
		case 1:		soundeffect2( pc, 0x0151 );	break;// Female Death
		case 2:		soundeffect2( pc, 0x0152 );	break;// Female Death
		case 3:		soundeffect2( pc, 0x0153 );	break;// Female Death
		}
	}
	else if (pc->xid()==0x0190)
	{
		switch( RandomNum(0, 3) ) // AntiChrist - uses all the sound effects
		{
		case 0:		soundeffect2( pc, 0x015A );	break;// Male Death
		case 1:		soundeffect2( pc, 0x015B );	break;// Male Death
		case 2:		soundeffect2( pc, 0x015C );	break;// Male Death
		case 3:		soundeffect2( pc, 0x015D );	break;// Male Death
		}
	}
	else
	{
		playmonstersound(pc, SND_DIE);
	}
}

// experimental, new stauts info / AOS, currently only used for titching points display
void sendExtendedStatus(UOXSOCKET s)
{



}


// LB 03-03-2002
void sendNPCPopupMenue(UOXSOCKET s)
{
	assert(SrvParms->npcpopmenues); // should only arrive if clients got npcpopupmenues enabled.
	// what in turn should only happen if npcpopupmenu is enabled serverside
	
	int NpcPopupLen,NpcMenuEntries;
	int extra;
	const char MAXPOPUPENTRIES=10;
	
	extra=0;
	
	P_CHAR pc = FindCharBySerPtr(&buffer[s][5]);						
	if (pc==NULL) return; // no popups for items ...
	
	if (pc->account>0) 	// players are monsters !!! ;)
	{
		if (pc->isMonsterBody() ) return; // no popups for monsters 
		if (pc->isAnimalBody() ) return; // for animals useless too
	}
											
	////////////////////////////////////
	// answer client request, to be moved to npc code after experimental phase closed
    //
	// needs a rewrite too, still very "hackish", quick & dirty code. 
    // LB
							
    unsigned char NpcPopupReply[15+MAXPOPUPENTRIES*8];
	NpcPopupLen=12;

	/// fixpoints
	NpcPopupReply[0]=0xbf;
	NpcPopupReply[3]=0x0;
	NpcPopupReply[4]=0x14;

	NpcPopupReply[5]=0x0; // unknown, constant
	NpcPopupReply[6]=0x1; // unknown, constant

	LongToCharPtr(pc->serial,&NpcPopupReply[7]);
                            
	// number of entries
	if (pc->shop) NpcMenuEntries=3; else NpcMenuEntries=1;

	NpcPopupReply[11]=NpcMenuEntries;

	int a;
	for(a=0; a<NpcMenuEntries; a++)
	{
		if (NpcPopupLen>=(15+MAXPOPUPENTRIES*8))
		{
			LogError("NpcPopupLen index out of bounds !");
			break;
		}
		
		NpcPopupReply[12+a*6+0+extra]=0x00;  // Entry ID (echo'd back by client)
		NpcPopupReply[12+a*6+1+extra]=a;
		
		NpcPopupReply[12+a*6+2+extra]=0x17;  // Text ID, curently open paperdoll
		NpcPopupReply[12+a*6+3+extra]=0xEB;
		
		NpcPopupReply[12+a*6+4+extra]=0x0;  // bitfield.
		NpcPopupReply[12+a*6+5+extra]=0x0;
		
		// |0x0 = enabled
		// |0x1 = greyed
		// |0x20 unknown, but 2 more bytes follwing
		
		switch(a)
		{
		case 0:	   
			NpcPopupReply[12+a*6+5+extra]=0x20;
			break;
			
		case 1:	   
			NpcPopupReply[12+a*6+3+extra]=0xd7;
			break;	   
			
		case 2:	   
			NpcPopupReply[12+a*6+3+extra]=0xd8;
			break;
		}
		
		NpcPopupLen+=6;
		
		if ( NpcPopupReply[12+a*6+5+extra] & 0x20)
		{								   
			NpcPopupReply[12+a*6+6+extra]=0xff;
			NpcPopupReply[12+a*6+7+extra]=0xff;
			
			NpcPopupLen+=2;
			extra+=2;
		}
	}
	
	NpcPopupReply[1]= (NpcPopupLen >> 8);
	NpcPopupReply[2]= (NpcPopupLen %256);


	XStartPkt(0xBF,  NpcPopupLen);
	XAddPkt(&NpcPopupReply[0+3], NpcPopupLen-3);
	XFinishPkt(s);
}


void generateAntiMarcoQueries(unsigned char inputtype, unsigned char exceptiontype, unsigned char querytype)
{
	/// Parameter check
	if (!(inputtype==0||inputtype==1))
	{
	   sprintf(temp,"currently unsupported Anti Macro Input type: %i set in server.scp\n", inputtype);
       LogWarning(temp);
	   return;
	}

	if ( !(exceptiontype==0 || exceptiontype==1))
	{
	   sprintf(temp,"currently unsupported Anti Macro Exception type: %i set in server.scp\n", exceptiontype);
       LogWarning(temp);
	   return;
	}

	if (!(querytype==0 || querytype==1))
	{
	   sprintf(temp,"currently unsupported Anti Macro Query type: %i set in server.scp\n", querytype);
       LogWarning(temp);
	   return;
	}
	
    //////  send it to all players online 
	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		int sock=api.getSocket();
		P_CHAR pc;
		pc=MAKE_CHAR_REF(currchar(sock));
		if (pc==NULL) 
		{
		  LogError("Error in generating AntiMacro stuff 1\n");
		  return;
		}

		if (pc->isGM()) return; // no nag screens for GM's ;)

		bool ok=false;
		switch(exceptiontype) // check for exceptions
		{
		   case 0: ok=true; break; // no exception
		   case 1: 
			    ok=true;            // players in houses dont get macro checks
			   	PC_ITEM House = findHouseAt(pc->pos);
		        if (House) 
				{
			       int f=on_hlist(House, pc->serial);
			       if (f == H_FRIEND || pc->Owns(House) || IsCoOwner(House,pc))
				   {
					   ok=false;
				   }
				}		
			   break;
		}

		if (ok) // only send if exception rules say it's ok to send a query
		{
			std::string querystr; // generate query phrase
			switch(querytype)
			{
			  case 0: 
				  querystr="any word"; 
				  break;

			  case 1: 
				 
				  char num=(rand()%5)+3;
				  char a;
				  char t[17];
				  for (a=0;a<num;a++) 
				  {
					  char x=rand()%25;
					  x=x+65;
					  t[a]=x;					  
				  }
				  t[a]=0;

				  querystr=t;
				  break;
			}

			// remember query time + requested string...
			
			AntiMacro[sock].QueryStartTime=uiCurrentTime;
			AntiMacro[sock].QueryAnswerTime=0; // reset OLD answertime
			AntiMacro[sock].QueryString=querystr;

			unsigned char textRequestPacket[0x15];
			int serial;

			// generate TextRequestPacket (for type 1+0)
			if (inputtype==0 || inputtype==1)
			{
				serial = pc->serial;

				textRequestPacket[0]=0xc2;
				ShortToCharPtr((short)0x15, textRequestPacket+1); // length
				LongToCharPtr(serial, textRequestPacket+3);
				LongToCharPtr((int)0x1, textRequestPacket+7);  //  1: type of request, 1 = anti macro query
				LongToCharPtr((int)0x0, textRequestPacket+11); // 10 0's
				LongToCharPtr((int)0x0, textRequestPacket+15); 
				ShortToCharPtr((short)0x0, textRequestPacket+19);
			}
			
			switch(inputtype) // presentation of query
			{			  
			case 0:  // sysmessage + simple text entry !
				
				sprintf(temp,"Server-request->Please enter:%s within the next minutes", querystr.c_str());
				sysmessage(sock, 0xe6, temp);
				soundeffect5(sock, pc, 0x0029);	
				
				// send textentry request packet
				XStartPkt(0xC2, 0x15);
				XAddPkt(&textRequestPacket[0+3], 0x15-3);
				XFinishPkt(sock);
				break;
				
			case 1: // scroll + simple text entry
				
				sprintf(temp,"Server-request->Please enter:%s within the next minutes", querystr.c_str());
				SndUpdscroll(sock, strlen(temp), temp);				 
				soundeffect5(sock, pc, 0x0029);
				
				// send textentry request packet		
				XStartPkt(0xC2, 0x15);
				XAddPkt(&textRequestPacket[0+3], 0x15-3);
				XFinishPkt(sock);
				break;
				
			}	// end inputtype switch
			
		} // end if ok (to send anti macro request)	   				
		
	} // end allplayer iterator
}

CParticleEffects::CParticleEffects(void):zero_s(0),zero_l(0)
{	
	
	C7[0]=0xC7;

	////////////////////////////////////////////////////////////////
	///               setup spellcasting tables
	////////////////////////////////////////////////////////////////

	/// spell-start effect table

	// classic magery

	MapPre.insert(effPre(1,  preParticleStorage(0x47)));MapPre.insert(effPre(2,  preParticleStorage(0x33)));
	MapPre.insert(effPre(3,  preParticleStorage(0x47)));MapPre.insert(effPre(4,  preParticleStorage(0x65)));
	MapPre.insert(effPre(5,  preParticleStorage(0x51)));MapPre.insert(effPre(6,  preParticleStorage(0x47)));
	MapPre.insert(effPre(7,  preParticleStorage(0x33)));MapPre.insert(effPre(8,  preParticleStorage(0x47)));
	MapPre.insert(effPre(9,  preParticleStorage(0x65)));MapPre.insert(effPre(10, preParticleStorage(0x65)));
	MapPre.insert(effPre(11, preParticleStorage(0x65)));MapPre.insert(effPre(12, preParticleStorage(0x51)));
	MapPre.insert(effPre(13, preParticleStorage(0x29)));MapPre.insert(effPre(14, preParticleStorage(0x29)));
	MapPre.insert(effPre(15, preParticleStorage(0x33)));MapPre.insert(effPre(16, preParticleStorage(0x65)));
	MapPre.insert(effPre(17, preParticleStorage(0x51)));MapPre.insert(effPre(18, preParticleStorage(0x51)));
	MapPre.insert(effPre(19, preParticleStorage(0x29)));MapPre.insert(effPre(20, preParticleStorage(0x5b)));
	MapPre.insert(effPre(21, preParticleStorage(0x47)));MapPre.insert(effPre(22, preParticleStorage(0x47)));
	MapPre.insert(effPre(23, preParticleStorage(0x29)));MapPre.insert(effPre(24, preParticleStorage(0x33)));
	MapPre.insert(effPre(25, preParticleStorage(0x65)));MapPre.insert(effPre(26, preParticleStorage(0x33)));
	MapPre.insert(effPre(27, preParticleStorage(0x47)));MapPre.insert(effPre(28, preParticleStorage(0x51)));
	MapPre.insert(effPre(29, preParticleStorage(0x65)));MapPre.insert(effPre(30, preParticleStorage(0x3d)));
	MapPre.insert(effPre(31, preParticleStorage(0x47)));MapPre.insert(effPre(32, preParticleStorage(0x47)));
	MapPre.insert(effPre(34, preParticleStorage(0x2a)));MapPre.insert(effPre(35, preParticleStorage(0x2a)));
	MapPre.insert(effPre(36, preParticleStorage(0x34)));MapPre.insert(effPre(37, preParticleStorage(0x48)));
	MapPre.insert(effPre(38, preParticleStorage(0x34)));MapPre.insert(effPre(39, preParticleStorage(0x5c)));
	MapPre.insert(effPre(40, preParticleStorage(0x50)));MapPre.insert(effPre(41, preParticleStorage(0x2a)));
	MapPre.insert(effPre(42, preParticleStorage(0x3e)));MapPre.insert(effPre(43, preParticleStorage(0x51)));
	MapPre.insert(effPre(44, preParticleStorage(0x2a)));MapPre.insert(effPre(45, preParticleStorage(0x2a)));
	MapPre.insert(effPre(46, preParticleStorage(0x47)));MapPre.insert(effPre(47, preParticleStorage(0x34)));
	MapPre.insert(effPre(48, preParticleStorage(0x2a)));MapPre.insert(effPre(49, preParticleStorage(0x3e)));
	MapPre.insert(effPre(50, preParticleStorage(0x3e)));MapPre.insert(effPre(51, preParticleStorage(0x52)));
	MapPre.insert(effPre(52, preParticleStorage(0x48)));MapPre.insert(effPre(53, preParticleStorage(0x48)));
	MapPre.insert(effPre(54, preParticleStorage(0x2a)));MapPre.insert(effPre(55, preParticleStorage(0x52)));
	MapPre.insert(effPre(56, preParticleStorage(0x2a)));MapPre.insert(effPre(57, preParticleStorage(0x34)));
	MapPre.insert(effPre(58, preParticleStorage(0x48)));MapPre.insert(effPre(59, preParticleStorage(0x66)));
	MapPre.insert(effPre(60, preParticleStorage(0x32)));MapPre.insert(effPre(61, preParticleStorage(0x5a)));
	MapPre.insert(effPre(62, preParticleStorage(0x3c)));MapPre.insert(effPre(63, preParticleStorage(0x5a)));
	MapPre.insert(effPre(64, preParticleStorage(0x6e)));MapPre.insert(effPre(33, preParticleStorage(0x50, 0x2,0x1)));

	// necro	
	MapPre.insert(effPre(101, preParticleStorage(0x47)));
	MapPre.insert(effPre(102, preParticleStorage(0x47)));
	MapPre.insert(effPre(103, preParticleStorage(0x5b))); 
	int a; for (a=104; a<=116; a++) MapPre.insert(effPre(a, preParticleStorage(0x47)));

	// paladin
	for (a=201; a<=210; a++) MapPre.insert(effPre(a, preParticleStorage(0x2a)));

	//////////////////////////////////////////
	/// static effects table
	//////////////////////////////////////////

	MapSta.insert(effSta(1,  staticParticleStorage(0x00,0x00,0x0a,0x0f,0x13,0x8a,0x0)));
	MapSta.insert(effSta(3,  staticParticleStorage(0x37,0x79,0x0a,0x0f,0x13,0x8c,0x0)));
	MapSta.insert(effSta(4,  staticParticleStorage(0x37,0x6a,0x09,0x20,0x13,0x8d,0x0)));
	MapSta.insert(effSta(7,  staticParticleStorage(0x37,0x6a,0x09,0x20,0x13,0x90,0x3)));
	MapSta.insert(effSta(8,  staticParticleStorage(0x37,0x79,0x0a,0x0f,0x13,0x91,0x0)));
	MapSta.insert(effSta(9,  staticParticleStorage(0x37,0x5a,0x0a,0x0f,0x13,0x92,0x3)));
	MapSta.insert(effSta(10, staticParticleStorage(0x37,0x5a,0x0a,0x0f,0x13,0x93,0x0)));
	MapSta.insert(effSta(11, staticParticleStorage(0x37,0x3a,0x0a,0x0f,0x13,0x94,0x3)));
	MapSta.insert(effSta(12, staticParticleStorage(0x37,0x4a,0x0a,0x0f,0x13,0x95,0x3)));
	MapSta.insert(effSta(15, staticParticleStorage(0x37,0x5a,0x09,0x14,0x13,0x98,0x3)));
	MapSta.insert(effSta(16, staticParticleStorage(0x37,0x5a,0x0a,0x0f,0x13,0x99,0x3)));
	MapSta.insert(effSta(17, staticParticleStorage(0x37,0x3a,0x0a,0x0f,0x13,0x9a,0x2)));
	MapSta.insert(effSta(20, staticParticleStorage(0x37,0x4a,0x0a,0x0f,0x13,0x9d,0x3)));
	MapSta.insert(effSta(22, staticParticleStorage(0x37,0x28,0x0a,0x99,0x13,0x9f,0x0)));
	MapSta.insert(effSta(25, staticParticleStorage(0x37,0x6a,0x0a,0x0f,0x13,0x94,0x3)));
	MapSta.insert(effSta(26, staticParticleStorage(0x37,0x5a,0x09,0x14,0x13,0xa3,0x3)));
	MapSta.insert(effSta(27, staticParticleStorage(0x37,0x4a,0x0a,0x0f,0x13,0xa4,0x3)));
	MapSta.insert(effSta(29, staticParticleStorage(0x37,0x6a,0x09,0x20,0x13,0xa6,0x0)));
	MapSta.insert(effSta(30, staticParticleStorage(0x00,0x00,0x0a,0x05,0x13,0xa7,0x3)));
	MapSta.insert(effSta(31, staticParticleStorage(0x37,0x4a,0x0a,0x0f,0x13,0xa8,0x0)));
	MapSta.insert(effSta(32, staticParticleStorage(0x00,0x00,0x0a,0x05,0x13,0xa9,0x3)));
	MapSta.insert(effSta(33, staticParticleStorage(0x37,0x28,0x0a,0x00,0x13,0xaa,0x0)));
	MapSta.insert(effSta(35, staticParticleStorage(0x37,0x3a,0x0a,0x0f,0x13,0xac,0x0)));
	MapSta.insert(effSta(36, staticParticleStorage(0x37,0x5a,0x0a,0x0f,0x13,0xad,0x3)));
	MapSta.insert(effSta(37, staticParticleStorage(0x00,0x00,0x0a,0x0f,0x07,0xf6,0x0)));
    MapSta.insert(effSta(38, staticParticleStorage(0x37,0x6a,0x06,0x01,0x13,0xaf,0x5)));
	MapSta.insert(effSta(40, staticParticleStorage(0x37,0x28,0x0a,0x0a,0x13,0xb1,0x0)));
	MapSta.insert(effSta(43, staticParticleStorage(0x36,0xbd,0x0a,0x0a,0x13,0xb4,0x0)));
	MapSta.insert(effSta(46, staticParticleStorage(0x37,0x4a,0x0a,0x0f,0x13,0x95,0x3)));
	MapSta.insert(effSta(48, staticParticleStorage(0x37,0x28,0x0a,0x0a,0x13,0xb1,0x0)));
	MapSta.insert(effSta(49, staticParticleStorage(0x00,0x00,0x0a,0x05,0x13,0xa7,0x3)));
	MapSta.insert(effSta(51, staticParticleStorage(0x37,0x09,0x0a,0x1e,0x13,0xbc,0x5)));
	MapSta.insert(effSta(53, staticParticleStorage(0x37,0x4a,0x0a,0x0f,0x13,0xbe,0x0)));
	MapSta.insert(effSta(54, staticParticleStorage(0x37,0x28,0x0a,0x0a,0x13,0x9f,0x0)));
	MapSta.insert(effSta(55, staticParticleStorage(0x00,0x00,0x0a,0x05,0x13,0xc0,0x0)));
	MapSta.insert(effSta(58, staticParticleStorage(0x00,0x00,0x0a,0x05,0x13,0xc3,0x0)));
	MapSta.insert(effSta(59, staticParticleStorage(0x36,0x6a,0x09,0x20,0x25,0x1d,0x3)));
	MapSta.insert(effSta(60, staticParticleStorage(0x00,0x00,0x0a,0x20,0x13,0xc5,0x3)));
	MapSta.insert(effSta(61, staticParticleStorage(0x00,0x00,0x0a,0x20,0x13,0xc6,0x3)));
	MapSta.insert(effSta(62, staticParticleStorage(0x00,0x00,0x0a,0x20,0x13,0xc7,0x3)));
	MapSta.insert(effSta(63, staticParticleStorage(0x00,0x00,0x0a,0x20,0x13,0xc8,0x3)));
	MapSta.insert(effSta(64, staticParticleStorage(0x00,0x00,0x0a,0x20,0x13,0xc9,0x3)));

	MapSta.insert(effSta(355, staticParticleStorage(0x00,0x00,0x0a,0x0f,0x0f,0xcb,0x1))); // fizzle classic
	MapSta.insert(effSta(356, staticParticleStorage(0x00,0x00,0x0a,0x0f,0x0f,0xcb,0x1))); // fizzle necro
	MapSta.insert(effSta(357, staticParticleStorage(0x00,0x00,0x0a,0x0f,0x0f,0xcb,0x1))); // fizzle paladin

	// necro
	MapSta.insert(effSta(102,  staticParticleStorage(0x37, 0x5a, 0x01,0x11,0x26, 0xbf, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x21, 0x7)));
	MapSta.insert(effSta(1020, staticParticleStorage(0x37, 0x28, 0x01,0x0d,0x25, 0x1e, 0xff,0xff,0xff,0xff, 0x0,0x1, 0x0, 0x21, 0x7))); 
	MapSta.insert(effSta(103,  staticParticleStorage(0x37, 0x3a, 0x01,0x0f,0x26, 0xb9, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x43, 0x7)));
	MapSta.insert(effSta(104,  staticParticleStorage(0x37, 0x79, 0x01,0x0f,0x26, 0xb1, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x20, 0x2)));
	MapSta.insert(effSta(1040, staticParticleStorage(0x37, 0xb9, 0x01,0x04,0x25, 0x1e, 0xff,0xff,0xff,0xff, 0x0,0x1, 0x0, 0x20, 0x5)));
	MapSta.insert(effSta(105,  staticParticleStorage(0x37, 0x28, 0x01,0x0d,0x26, 0xb8, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x4, 0x7e, 0x7)));
	MapSta.insert(effSta(1050, staticParticleStorage(0x37, 0x79, 0x01,0x0f,0x25, 0x1e, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x43, 0x7)));
	MapSta.insert(effSta(106,  staticParticleStorage(0x37, 0x28, 0x01,0x0d,0x26, 0xbe, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x5c, 0x3)));
	MapSta.insert(effSta(107,  staticParticleStorage(0x37, 0x09, 0x01,0x1e,0x26, 0xb0, 0x5, 0xff,0xff,0xff, 0x0,0x1, 0x4, 0x54, 0x6)));
	MapSta.insert(effSta(108,  staticParticleStorage(0x37, 0x3a, 0x01,0x11,0x26, 0xaf, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x0f, 0x4)));
	MapSta.insert(effSta(109,  staticParticleStorage(0x37, 0xc4, 0x01,0x08,0x26, 0xbc, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x27, 0x3)));
	MapSta.insert(effSta(1090, staticParticleStorage(0x37, 0xc4, 0x01,0x08,0x25, 0x1e, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x27, 0x4)));
	MapSta.insert(effSta(111,  staticParticleStorage(0x36, 0xc8, 0x01,0x09,0x26, 0xb7, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x43, 0x5)));
	MapSta.insert(effSta(1110, staticParticleStorage(0x37, 0x4a, 0x01,0x11,0x25, 0x1e, 0xff,0xff,0xff,0xff, 0x0,0x1, 0x4, 0x54, 0x4)));
	MapSta.insert(effSta(112,  staticParticleStorage(0x37, 0x28, 0x01,0x0a,0x26, 0xb6, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x0,  0x0)));
	MapSta.insert(effSta(114,  staticParticleStorage(0x37, 0x3a, 0x01,0x0f,0x26, 0xb5, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x0,  0x0)));
	MapSta.insert(effSta(1140, staticParticleStorage(0x00, 0x00, 0x00,0x00,0x13, 0xa7, 0x3, 0xff,0xff,0xff, 0x0,0x0, 0x0, 0x0,  0x0)));
	MapSta.insert(effSta(116,  staticParticleStorage(0x37, 0x4a, 0x01,0x0f,0x26, 0xae, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x4, 0x54, 0x4)));

	// pala
	MapSta.insert(effSta(201,  staticParticleStorage (0x37, 0x3a, 0x01,0x0f,0x13, 0x94, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x3, 0x2)));
	MapSta.insert(effSta(2222, staticParticleStorage (0x37, 0x09, 0x01,0x1e,0x26, 0xce, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x0, 0x7)));
	MapSta.insert(effSta(202,  staticParticleStorage (0x37, 0x6a, 0x01,0x3e,0x26, 0xc3, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x3, 0x3)));
	MapSta.insert(effSta(2020, staticParticleStorage (0x37, 0x79, 0x01,0x2e,0x25, 0x1e, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x5, 0x3)));
	MapSta.insert(effSta(203,  staticParticleStorage (0x37, 0x79, 0x01,0x1e,0x26, 0xec, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x3, 0x3)));
	MapSta.insert(effSta(204,  staticParticleStorage (0x37, 0xc4, 0x01,0x19,0x26, 0xc2, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0xe, 0x3)));
	MapSta.insert(effSta(205,  staticParticleStorage (0x37, 0x6a, 0x01,0x1f,0x26, 0xe9, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x4, 0x88, 0x0)));
	MapSta.insert(effSta(2050, staticParticleStorage (0x37, 0xc4, 0x01,0x1f,0x25, 0x1e, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x2b, 0x2)));
	MapSta.insert(effSta(206,  staticParticleStorage (0x37, 0x5a, 0x01,0x1e,0x26, 0xee, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x21, 0x2)));
	MapSta.insert(effSta(2060, staticParticleStorage (0x37, 0xb9, 0x01,0x1e,0x25, 0x1e, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x2b, 0x3)));
	MapSta.insert(effSta(208,  staticParticleStorage (0x37, 0x09, 0x01,0x1e,0x26, 0xed, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x5,  0x7)));
	MapSta.insert(effSta(2080, staticParticleStorage (0x37, 0x6a, 0x01,0x1e,0x25, 0x1e, 0x3, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x5,  0x3)));
	MapSta.insert(effSta(2333, staticParticleStorage (0x37, 0x5a, 0x01,0x0f,0x13, 0x8d, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0x5,  0x3)));
	MapSta.insert(effSta(209,  staticParticleStorage (0x37, 0x09, 0x01,0x1e,0x26, 0xeb, 0x0, 0xff,0xff,0xff, 0x0,0x1, 0x0, 0xd,  0x3)));
	
	///////////////////////////////////////
	/// move effects table
	////////////////////////////////////////
	
	MapMov.insert(effMov(5,  moveParticleStorage(0x36,0xe4,0x07,0x0,0x0b,0xbe,0x0f,0xa6,0x0,0x0,0x0,0x0,0x0)));
	MapMov.insert(effMov(18, moveParticleStorage(0x36,0xd4,0x07,0x0,0x0b,0xcb,0x0f,0xb3,0x01,0x60,0x0,0x01,0x0)));
	MapMov.insert(effMov(42, moveParticleStorage(0x37,0x9f,0x07,0x0,0x0b,0xe3,0x0f,0xcb,0x02,0x11,0x0,0x01,0x0)));
	MapMov.insert(effMov(55, moveParticleStorage(0x36,0xd4,0x0a,0x7,0x25,0x1d,0x0,0x1,0x0,0x0,0x0,0x1,0x1)));

	//MapMov.insert(effMov(201, moveParticleStorage(0x37,0x4b,0x01,0x0, 0x25,0x1d, 0x0, 0x1, 0x0, 0x0, 0x0,0x0,0x1, 0x0, 0x3f, 0x2, 0x1, 0x0  )));

	/////////////////////////////////////
	/// after spellcasting tables
	//////////////////////////////////////

	MapAfter.insert(effAfter(6,  afterParticleStorage(0x37, 0x6a, 0x09, 0x20, 0x13, 0x8f, 0x00, 0x03)));
	MapAfter.insert(effAfter(37, afterParticleStorage(0x37, 0x4a, 0x0a, 0x0f, 0x13, 0xae, 0x00, 0x00)));
	MapAfter.insert(effAfter(38, afterParticleStorage(0x00, 0x00, 0x0a, 0x05, 0x13, 0xaf, 0x00, 0x05, 0xff, 0xff, 0x27,0x0f)));

	// to add: necro
	// to add: paladin

	/////////////////////////////////////
	// item effect table
	/////////////////////////////////////

	MapItem.insert(effItem(13, itemParticleStorage(0x6a, 0x09, 0x0a, 0x96, 0x00)));
	MapItem.insert(effItem(14, itemParticleStorage(0x6a, 0x09, 0x20, 0x8f, 0x03)));
	MapItem.insert(effItem(19, itemParticleStorage(0x6a, 0x09, 0x20, 0x9c, 0x02)));
	MapItem.insert(effItem(23, itemParticleStorage(0x6a, 0x09, 0x20, 0xa0, 0x03)));
	MapItem.insert(effItem(24, itemParticleStorage(0x6a, 0x09, 0x20, 0xa1, 0x03)));
	MapItem.insert(effItem(28, itemParticleStorage(0x6a, 0x0f, 0x0a, 0xa5, 0x00)));
    MapItem.insert(effItem(39, itemParticleStorage(0x6a, 0x09, 0x0a, 0xb0, 0x00)));
	MapItem.insert(effItem(44, itemParticleStorage(0x6a, 0x0a, 0x0f, 0xb5, 0x03)));
	MapItem.insert(effItem(45, itemParticleStorage(0x79, 0x0a, 0x0f, 0xb6, 0x03)));
	MapItem.insert(effItem(47, itemParticleStorage(0x6a, 0x09, 0x0a, 0xb8, 0x03)));
	MapItem.insert(effItem(50, itemParticleStorage(0x6a, 0x09, 0x0a, 0xbb, 0x00)));
	MapItem.insert(effItem(22, itemParticleStorage(0x28, 0x0a, 0x00, 0xe7, 0x02, 0xff, 0xff, 0x37, 0x07)));
	MapItem.insert(effItem(32, itemParticleStorage(0x00, 0x00, 0x00, 0xa9, 0x03, 0xff, 0xff, 0x0, 0x13)));
	MapItem.insert(effItem(59, itemParticleStorage(0x00, 0x00, 0x00, 0xc4, 0x03, 0xff, 0xff, 0x0, 0x13)));

	// necro
	MapItem.insert(effItem(101, itemParticleStorage(0x89, 0x01, 0x28, 0xb3, 0x00, 0xff,0xff, 0xff, 0x37, 0x26)));

	//paladin (none)
}

void CParticleEffects::addInvisibleItem(P_CHAR pc, int spellNum, cCoord& c)
{

}

void CParticleEffects::staticeffectUO3D(P_CHAR pc, int spellNum, int caller)
{
	if (!pc) return;
	
	switch(caller)
	{
	   case CALLER_PREPARTICLES:   
		 
		 itPre = MapPre.find(spellNum);
		 if (itPre == MapPre.end() )
		 {
			LogErrorVar("No Preparticle-table entry in Spell#%i\n",spellNum);
			return;
		 }
		 
		 C7[10]=itPre->second.getByte(0); // tileid1		 		
	     C7[11]=itPre->second.getByte(1); // tileid2
		 C7[22]=itPre->second.getByte(2); // unkown1 
	     C7[23]=itPre->second.getByte(3); // unkown2		 	
	     C7[36]=itPre->second.getByte(4); // effekt #
	     C7[37]=itPre->second.getByte(5);		 
		 break;

	   case CALLER_AFTERPARTICLES:
		 		    
		 itAfter = MapAfter.find(spellNum);
		 if (itAfter == MapAfter.end() )
		 {
			LogErrorVar("No afterparticle-table entry in Spell#%i\n",spellNum);
			return;
		 }
		 		 
		 C7[10]=itAfter->second.getByte(0); // tileid1		 		
	     C7[11]=itAfter->second.getByte(1); // tileid2
		 C7[22]=itAfter->second.getByte(2); // unkown1 
	     C7[23]=itAfter->second.getByte(3); // unkown2		 	
	     C7[36]=itAfter->second.getByte(4); // effekt #
	     C7[37]=itAfter->second.getByte(5);	
	     C7[38]=itAfter->second.getByte(10);
	     C7[39]=itAfter->second.getByte(11);
		 break;

	   case CALLER_STATICPARTICLES: 
		 
		 itSta = MapSta.find(spellNum);
		 if (itSta == MapSta.end() )
		 {	
			LogErrorVar("No staticparticle-table entry in Spell#%i\n",spellNum);
			return;
		 }		 

		 C7[10]=itSta->second.getByte(4); // tileid1
		 C7[11]=itSta->second.getByte(5); // tileid2
		 C7[22]=itSta->second.getByte(6); // unkown1
		 C7[23]=itSta->second.getByte(7); // unknown2
		 C7[36]=itSta->second.getByte(8); // effect #
		 C7[37]=itSta->second.getByte(9); 
		 C7[38]=itSta->second.getByte(14); 
		 C7[39]=itSta->second.getByte(15);
		 C7[30]=itSta->second.getByte(0);
		 C7[31]=itSta->second.getByte(1);
		 C7[35]=itSta->second.getByte(2);

		 break;

	   default: 
		 LogError("Unkonwn caller in stateffectUO3d\n");
		 return;		 
	}
	
	C7[1]=0x3;

	LongToCharPtr(pc->serial, &C7[2]);
	LongToCharPtr(zero_l, &C7[6]);  // always 0 for this type
			
	PosToPtrXYZ(pc->pos, &C7[12]);
	PosToPtrXYZ(pc->pos, &C7[17]);
		
    ShortToCharPtr(zero_s, &C7[24]);
		
	C7[26]=0x1;
	C7[27]=0x0;
	
	LongToCharPtr(zero_l, &C7[28]);
	LongToCharPtr(zero_l, &C7[32]);
	
	ShortToCharPtr(zero_s, &C7[40]);	
	LongToCharPtr(pc->serial, &C7[42]);
		
	C7[46]=0; // layer, gets set afterwards for multi layering
	
	ShortToCharPtr(zero_s, &C7[47]);	
		
}

void CParticleEffects::movingeffectUO3D(P_CHAR source, P_CHAR dest, int spellNum)
{	
   if (source==NULL || dest==NULL) return;

   itMov = MapMov.find(spellNum);
   if (itMov == MapMov.end() )
   {	
	 LogErrorVar("No movparticle-table entry in Spell#%i\n",spellNum);
	 return;
   }		 

   char subtype=itMov->second.getByte(3);

   C7[1]=0x0;

   if (subtype==0)
   {
     LongToCharPtr(source->serial, &C7[2]);
     LongToCharPtr(dest->serial,   &C7[6]);
   } 
   else
   {
	 LongToCharPtr(zero_l, &C7[2]);
	 LongToCharPtr(zero_l, &C7[6]);
   }

   C7[10]=itMov->second.getByte(5); // tileid1
   C7[11]=itMov->second.getByte(6); // tileid2
  
   if (subtype==0)
	   PosToPtrXYZ(source->pos, &C7[12]);
   else
	   PosToPtrXYZ(dest->pos, &C7[12]);
   
   PosToPtrXY(dest->pos, &C7[17]);
   if (subtype==0) C7[21]=dest->pos.z; else C7[21]=dest->pos.z+0x32;
      
   C7[22]=itMov->second.getByte(7); // speed1
   C7[23]=itMov->second.getByte(8); // speed2

   ShortToCharPtr(zero_s, &C7[24]);
  
   C7[26]=itMov->second.getByte(15); // adjust
   C7[27]=itMov->second.getByte(16); // explode

   LongToCharPtr(zero_l,  &C7[28]);
   LongToCharPtr(zero_l,  &C7[32]);
 
   C7[36]=itMov->second.getByte(9); // moving effect
   C7[37]=itMov->second.getByte(10);
   C7[38]=itMov->second.getByte(11); // effect on explode
   C7[39]=itMov->second.getByte(12); 
   C7[40]=itMov->second.getByte(13); // ??
   C7[41]=itMov->second.getByte(14); 
  
   if (subtype==0) LongToCharPtr(zero_l,  &C7[42]);
   else
   {
	  LongToCharPtr(dest->serial,  &C7[42]);

   }
 
   if (subtype==0) C7[46]=0xff; else C7[46]=itMov->second.getByte(4);

   C7[47]=itMov->second.getByte(17);
   C7[48]=0x0;

   C7[30]=itMov->second.getByte(0);
   C7[31]=itMov->second.getByte(1);
   C7[35]=itMov->second.getByte(2);

}

void CParticleEffects::itemeffectUO3D(P_ITEM pi, int spellNum)
{
	if (!pi) return;

   itItem = MapItem.find(spellNum);
   if (itItem == MapItem.end() )
   {	
	  LogErrorVar("No itemparticle-table entry in Spell#%i\n",spellNum);
	  return;
   }
	
   C7[1]=0x2;
	
   if ( !itItem->second.getByte(10) ) LongToCharPtr(pi->serial, &C7[2]); else LongToCharPtr(zero_l, &C7[2]);
		
	LongToCharPtr(zero_l, &C7[6]); // always 0 for this type
	
	C7[10]=itItem->second.getByte(0); // tileid1
	C7[11]=itItem->second.getByte(1); // tileid2
	
	PosToPtrXYZ(pi->pos, &C7[12]);
	PosToPtrXYZ(pi->pos, &C7[17]);
	
	C7[22]= itItem->second.getByte(2); // unkown1 
	C7[23]= itItem->second.getByte(3); // unkown2

	ShortToCharPtr(zero_s, &C7[24]);
		
	C7[26]=0x1;
	C7[27]=0x0;

    LongToCharPtr(zero_l, &C7[28]);	
    LongToCharPtr(zero_l, &C7[32]);
	
	C7[36]=itItem->second.getByte(4); // effekt #
	C7[37]=itItem->second.getByte(5);
	
	C7[38]=0; // unknown
	C7[39]=1;
	
	ShortToCharPtr(zero_s, &C7[40]);	
	LongToCharPtr(pi->serial, &C7[42]);
	
	C7[46]=0xff; 	
	ShortToCharPtr(zero_s, &C7[47]);	

}

void CParticleEffects::SpellCastingStart(int spellNum, P_CHAR Player, UOXSOCKET s) 
{ 
	if (clientDimension[s]==3) // 2d client does nothing(!) with those, so it's a waste of bandwidth
	{
	  this->staticeffectUO3D(Player, spellNum, CALLER_PREPARTICLES);	
	  this->sendParticleMultiLayer(s, spellNum, CALLER_PREPARTICLES);
	}
}

void CParticleEffects::SpellCastingDestination(int spellNum,  P_CHAR Player, P_CHAR DestMobile, P_ITEM DestItty, UOXSOCKET s) 
{
	SCD(spellNum, Player, DestMobile, DestItty, s);

	if (spellNum>100) // some necro+paladin spells emmit multiple diffeernt packets per phase (encoded as dummy spell spellnummer*10, = 1010, 1020, 1030 etc)
	{
	  spellNum*=10;
	  SCD(spellNum, Player, DestMobile, DestItty, s);
	}
}

int CParticleEffects::StaEffectOnBoth(int spellNum) // list of spells that have their effect applied to target and caster
{
	switch(spellNum)
	{
	   case 102: return 102;
	   case 201: return 2222;
	   case 208: return 2333;
	   default: return 0;
	}
}

void CParticleEffects::SCD(int spellNum,  P_CHAR Player, P_CHAR DestMobile, P_ITEM DestItty, UOXSOCKET s) // SpellCastingDestination implentation
{  
   itItem = MapItem.find(spellNum);
   if (itItem != MapItem.end() )
   {	
	 if (DestItty!=NULL)
	 {
	   this->itemeffectUO3D(DestItty, spellNum);
	   this->sendParticleSingleLayer(s);
	 }
   }

   itSta = MapSta.find(spellNum);
   if (itSta != MapSta.end() )
	{
		if (DestMobile!=NULL)
		{
		  this->staticeffectUO3D(DestMobile, spellNum, CALLER_STATICPARTICLES);	
		  this->sendParticleSingleLayer(s);
		}


		int sn=StaEffectOnBoth(spellNum);
		if (sn)
		{
		   if (Player!=NULL)
		   {
		     this->staticeffectUO3D(Player, sn, CALLER_STATICPARTICLES);	
		     this->sendParticleSingleLayer(s);
		   }
		}
	}

    itMov = MapMov.find(spellNum);
    if (itMov != MapMov.end() )
	{		
	   if (DestMobile!=NULL && Player!=NULL)
	   {		  
	     this->movingeffectUO3D(Player, DestMobile, spellNum);
         this->sendParticleSingleLayer(s);
	   }
	}
}


void CParticleEffects::SpellCastingAfter(int spellNum, P_CHAR DestMobile, UOXSOCKET s) 
{ 
   itAfter = MapAfter.find(spellNum);
   if (itAfter != MapAfter.end() )   
   {
	 if (DestMobile!=NULL)
	 {
	   this->staticeffectUO3D(DestMobile, spellNum, CALLER_AFTERPARTICLES);	
	   this->sendParticleMultiLayer(s, spellNum, CALLER_AFTERPARTICLES);
	 }
   }	
}

void CParticleEffects::sendParticleMultiLayer(UOXSOCKET s, int spellNum, int caller)
{
   int one,two,three,four;
   switch(caller)
   {
	  case CALLER_PREPARTICLES:   

	  itPre = MapPre.find(spellNum);
      if (itPre == MapPre.end() ) return;
	  one=itPre->second.getByte(6);
	  two=itPre->second.getByte(7);
	  three=itPre->second.getByte(8);
	  four=itPre->second.getByte(9);    
	  break;

	  case CALLER_AFTERPARTICLES:

	  itAfter = MapAfter.find(spellNum);
      if (itAfter == MapAfter.end() ) return;
	  one=itAfter->second.getByte(6);
	  two=itAfter->second.getByte(7);
	  three=itAfter->second.getByte(8);
	  four=itAfter->second.getByte(9);    
	  break;

	  case CALLER_STATICPARTICLES: 

	  itSta = MapSta.find(spellNum);
      if (itSta == MapSta.end() ) return;	  
	  one=itSta->second.getByte(10);
	  two=itSta->second.getByte(11);
	  three=itSta->second.getByte(12);
	  four=itSta->second.getByte(13);
	  break;

	  default: return;
   }

   P_CHAR Person = MAKE_CHARREF_LR(currchar(s));
   if (one!=0xff)   { C7[46]=one;   SndToAllInRange(Person, &C7[0], 49); }   
   if (two!=0xff)   { C7[46]=two;   SndToAllInRange(Person, &C7[0], 49); }   
   if (three!=0xff) { C7[46]=three; SndToAllInRange(Person, &C7[0], 49); }
   if (four!=0xff)  { C7[46]=four;  SndToAllInRange(Person, &C7[0], 49); }
}


void SendPermActSinglePlayer(UOXSOCKET s, P_CHAR pc, unsigned short id, unsigned short rep, unsigned char speed, unsigned char direction)
{
  if (pc==NULL) return;
  unsigned char Animation[14];
  int serial=pc->serial;

  direction=direction%8; // 0..7

  Animation[0]=0x6e;
  LongToCharPtr(serial, &Animation[1]);
  ShortToCharPtr(id, &Animation[5]);
  Animation[7]=0x0; // unknown
  Animation[8]=direction;
  ShortToCharPtr(rep, &Animation[9]);
  Animation[11]=0x0; // forwards
  Animation[12]=0x1; // activate repetations
  Animation[13]=0xff-speed;

  XStartPkt(0x6e, 14);
  XAddPkt(&Animation[0+1], 14-1);
  XFinishPkt(s);

}

