/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

////////////////////////
// SndPkg.h: interface for SndPkg.cpp
//

#if !defined(__SNDPKG_H__)
#define __SNDPKG_H__

#include "platform.h"	// Platform specifics

#include "typedefs.h"	// UOXSOCKET and others
#include "CArray.h"
#include "network.h"

struct move_st
{
	int effect[18];
};

struct stat_st
{
	int effect[17];
};

void PosToPtrXY(const cCoord& pos, unsigned char* p);
void PosToPtrXYZ(const cCoord& pos, unsigned char* p);

void SndToAllInRange(P_CHAR pc, unsigned char* pkg, int len);
void SndToAllInRangeExept(P_CHAR pc, unsigned char* pkg, int len);
void SndWornItemsToAllInRange(P_CHAR Person);
void SndAttackOK(UOXSOCKET s, int serial);
void SndDyevat(UOXSOCKET s, int serial, short id);
void SndWorld(UOXSOCKET s, int map);
void SndSeason(UOXSOCKET s);
void SndNewMap(UOXSOCKET s, int map);
void SndUpdscroll(UOXSOCKET s, short txtlen, char* txt);

void SndRemoveNpc(UOXSOCKET s, P_CHAR creature, bool distancecheck=true);
void SndRemoveItem(UOXSOCKET s, PC_ITEM item, bool distancecheck=true);
void SndRemoveNpcToAll(P_CHAR creature, bool distancecheck=true);
void SndRemoveItemToAll(P_ITEM item, bool distancecheck=true);

void SndShopgumpopen(UOXSOCKET s, int serial);
void SndClearTrade(UOXSOCKET s, int serial);

void SndSound(UOXSOCKET s, const cCoord& pos, short sound);
void soundeffect(int s, unsigned char a, unsigned char b); // Play sound effect for player
void soundeffect(P_CHAR pc, short sound);
void soundeffect2(P_CHAR pc, short sound);
void soundeffect3(PC_ITEM pi, short sound);
void soundeffect5(UOXSOCKET s, P_CHAR Player, short sound);
void SndAction(P_CHAR pc, int x);	// character does a certain action
void sysbroadcast(const char *txt, int dont=-69); // System broadcast in bold text
void sysmessage(UOXSOCKET s, char *txt); // System message (In lower left corner);
void sysmessage(UOXSOCKET s, unsigned short color, char *txt);
void itemmessage(UOXSOCKET s, P_ITEM pi, char *txt, unsigned short color=0x0000);
void wearIt(const UOXSOCKET s, const P_ITEM pi);
void backpack(UOXSOCKET s, P_ITEM Cont); // Send Container (with items);
void backpack2(int s, PC_ITEM Corpse); // Send corpse stuff
void sendbpitem(UOXSOCKET s, PC_ITEM pi); // Update single item in backpack
void tileeffect(const cCoord& pos, char eff1, char eff2, char speed, char loop);
void senditem(UOXSOCKET s, PC_ITEM pi); // Send items (on ground);
void senditem_lsd(UOXSOCKET s, PC_ITEM pi,unsigned short color, int x, int y, signed char z);
void sendperson_lsd(UOXSOCKET s, P_CHAR pc, unsigned short color);
void chardel (UOXSOCKET s); // Deletion of character
void teleport(P_CHAR pc,   const cCoord& old_pos, char noOnlinecheck=0); // Teleports character to its current set coordinates
void updatechar(cChar* pc); // If character status has been changed (eg.Polymorph);, resend him
void target(UOXSOCKET s, int a1, char *txt); // Send targetting cursor to client
void skillwindow(int s, P_CHAR Player); // Opens the skills list, updated for client 1.26.2b by LB
void updatestats(P_CHAR pc, char x);
void statwindow(int s, P_CHAR pc, unsigned char modus=1);	// Opens the status window
void updates(UOXSOCKET s); // Update Window
void tips(int s, int i); // Tip of the day window
void deny(UOXSOCKET k, P_CHAR pc, int sequence);
void weblaunch(int s, char *txt); // Direct client to a web page
void broadcast(int s, P_CHAR Player); // GM Broadcast (Done if a GM yells something);
void itemtalk(int s, P_ITEM pi, char *txt); // Item "speech"
void npctalk(int s, cChar* pNpc, char *txt,char antispam, bool player=false); // NPC speech
void npctalkall(P_CHAR pc, char *txt,char antispam); // NPC speech to all in range.
void npctalk_runic(int s, P_CHAR pc, char *txt,char antispam); // NPC speech
void npcemote(UOXSOCKET s, P_CHAR pc, char *txt, char antispam); // NPC speech


void staticeffect (P_CHAR pc, short eff, unsigned char speed, unsigned char loop, bool UO3DonlyEffekt=false, stat_st *str=NULL, bool skip_old=false );
void movingeffect(P_CHAR source, P_CHAR dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode, bool UO3DonlyEffekt=false, move_st *str=NULL, bool skip_old=false);
void bolteffect(P_CHAR Player, bool UO3DonlyEffekt=false, bool skip_old=false);
void staticeffect2(P_ITEM pi, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode, bool UO3DonlyEffekt=false, stat_st *str=NULL, bool skip_old=false);

void staticeffect3(const cCoord& pos, unsigned char eff1, unsigned char eff2, char speed, char loop, char explode);
void movingeffect3(P_CHAR source, const cCoord& effpos, short effid, unsigned char speed, unsigned char loop, unsigned char explode);
void movingeffect3(P_CHAR pc_source, P_CHAR pc_dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode,unsigned char unk1,unsigned char unk2,unsigned char ajust,unsigned char type);
void bolteffect2(P_CHAR Player,char a1,char a2);	// experimenatal, lb
void movingeffect2(P_CHAR source, const P_ITEM dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode);

void staticeffectUO3D(P_CHAR pc, stat_st *sta);
void movingeffectUO3D(P_CHAR source, P_CHAR dest, move_st *sta);
void bolteffectUO3D(P_CHAR pc);
void itemeffectUO3D(P_ITEM pi, stat_st *sta);

void dolight(int s);
void senddummyshopinfo(int s, P_CHAR Vendor, P_ITEM pi);
void updateskillPacket(int s, int skillnum); // updated for client 1.26.2b by LB
void deathaction(P_CHAR pc, P_ITEM Corpse); // Character does a certain action
void deathmenu(int s); // Character sees death menu
void impowncreate(int s, P_CHAR pc, int z); //socket, player to send
void sendgrey(UOXSOCKET s, P_CHAR pc);
bool sendshopinfo(int s, P_CHAR Vendor, P_ITEM pi);
int sellstuff(int s, P_CHAR pc);
void playmidi(int s, char num1, char num2);
void sendtradestatus(P_ITEM Trade1, P_ITEM Trade2);
void endtrade(P_ITEM Cont1);
void tellmessage(int s, int s2, char *txt);
void PlayDeathSound( P_CHAR pc );
void sendNPCPopupMenue(UOXSOCKET s);
void generateAntiMarcoQueries(unsigned char inputtype, unsigned char exceptiontype,unsigned char querytype);
void SendPermActSinglePlayer(UOXSOCKET s, P_CHAR pc, unsigned short id, unsigned short rep, unsigned char speed, unsigned char direction);



///////////////////////////////////////////////////
///
/// handles particle effects and normal effects
/// technically speaking encapsulates 0xc0 and 0xC7 
//  packet functionity
/// additionaly it provides an easy interface
//  in magery-effects (basicly just give it spell #)
//  (LB)
///
///////////////////////////////////////////////////

/*

  will replace

  sndpkg.cpp: movingeffect 1-3, staticeffect 1-3, bolteffect1-3, 
              itemeffectuo3d, staticeffectuo3d, movingeffectuo3d

  magic.cpp: itemParticles, afterParticles,preParticles, 
             invisble itemparticles, getstatEffects, 
			 getmoveEffects, getitemEffects 

*/



class preParticleStorage
{
    public:

	preParticleStorage::preParticleStorage(unsigned char ef, unsigned char l1=0x01, unsigned char l2=0x02, unsigned char l3=0xff, unsigned char l4=0xff, unsigned char c1=0x0, unsigned char c2=0x0, unsigned char c3=0xa, unsigned char c4=0x5, unsigned char c5=0x23): eff(ef), layer1(l1), layer2(l2), layer3(l3), layer4(l4), co1(c1), co2(c2),co3(c3),co4(c4),co5(c5) { ; }

	inline unsigned char getByte(unsigned char pos)
	{
		switch (pos)
		{
		   case 0: return co1;
		   case 1: return co2;
		   case 2: return co3;
		   case 3: return co4;
		   case 4: return co5;
		   case 5: return eff;
		   case 6: return layer1;
		   case 7: return layer2;
		   case 8: return layer3;
		   case 9: return layer4;
		   default: return 0;
		}

	}

    private:
	  const char eff;
	  const char layer1;const char layer2;const char layer3;const char layer4;
	  const char co1;const char co2;const char co3;const char co4;const char co5;
};

class staticParticleStorage
{
    public:

	staticParticleStorage::staticParticleStorage(unsigned char b4, unsigned char b5, unsigned char b6, unsigned char b7, unsigned char b8, unsigned char b9, unsigned char l1, unsigned char c2=0xff, unsigned char c3=0xff, unsigned char c4=0xff, unsigned char c5=0x0, unsigned char c6=0x1, unsigned char c7=0x0, unsigned char c8=0x0, unsigned char c9=0x0, unsigned char c10=0x0): by4(b4), by5(b5), by6(b6), by7(b7),by8(b8),by9(b9),layer1(l1), co2(c2),co3(c3),co4(c4),co5(c5),co6(c6),co7(c7),co8(c8),co9(c9),co10(c10)  { ; }

	inline unsigned char getByte(unsigned char pos)
	{
		switch (pos)
		{

		   case 0: return co7;
		   case 1: return co8;
		   case 2: return co9;
		   case 3: return co10;

		   case 4: return by4;
		   case 5: return by5;
		   case 6: return by6;
		   case 7: return by7;
		   case 8: return by8;
		   case 9: return by9;

		   case 10: return co2;
		   case 11: return co3;
		   case 12: return co4;
		   case 13: return layer1;

		   case 14: return co5;
		   case 15: return co6;

		   default: return 0;
		}
	}

    private:
	  const char by4;const char by5;const char by6;const char by7;const char by8;
	  const char by9;const char layer1;	  
	  const char co2;const char co3;const char co4;const char co5;const char co6;
	  const char co7;const char co8;const char co9; const char co10;
};

class moveParticleStorage
{
    public:

	moveParticleStorage::moveParticleStorage(unsigned char b6, unsigned char b7, unsigned char b8, unsigned char b9, unsigned char b10, unsigned char b11, unsigned char b12, unsigned char b13, unsigned char b14, unsigned char b15, unsigned char b16, unsigned char b17, unsigned char b18, unsigned char b19=0x0, unsigned char b20=0x0, unsigned char b21=0x0, unsigned char b22=0x0, unsigned char b23=0x0): by6(b6), by7(b7),by8(b8),by9(b9),by10(b10),by11(b11),by12(b12),by13(b13),by14(b14),by15(b15),by16(b16),by17(b17),by18(b18),by19(b19),by20(b20),by21(b21),by22(b22),by23(b23)  { ; }

	inline unsigned char getByte(unsigned char pos)
	{
		switch (pos)
		{
		   case 0: return by19;
		   case 1: return by20;
		   case 2: return by21;		 
		   case 3: return by22;
		   case 4: return by23;
		   case 5: return by6;
		   case 6: return by7;
		   case 7: return by8;
		   case 8: return by9;
		   case 9: return by10;
		   case 10: return by11;
		   case 11: return by12;
		   case 12: return by13;
		   case 13: return by14;
		   case 14: return by15;
		   case 15: return by16;
		   case 16: return by17;
		   case 17: return by18;
		   default: return 0;
		}
	}

    private:	  
	  const char by6;const char by7;const char by8;
	  const char by9;const char by10;const char by11;const char by12;
	  const char by13;const char by14;const char by15;const char by16;
	  const char by17;const char by18;const char by19; const char by20; 
	  const char by21; const char by22; const char by23;	  	  	 
};

class afterParticleStorage
{
    public:

	afterParticleStorage::afterParticleStorage(unsigned char b1, unsigned char b2, unsigned char b3, unsigned char b4, unsigned char b5, unsigned char b6, unsigned char l1, unsigned char l2, unsigned char l3=0xff, unsigned char l4=0xff, unsigned char c1=0x0, unsigned char c2=0x1): by1(b1), by2(b2), by3(b3), by4(b4), by5(b5), by6(b6),layer1(l1),layer2(l2),layer3(c1), layer4(c2),co1(c1),co2(c2)  { ; }

	inline unsigned char getByte(unsigned char pos)
	{
		switch (pos)
		{
		   case 0: return by1;
		   case 1: return by2;
		   case 2: return by3;
		   case 3: return by4;
		   case 4: return by5;
		   case 5: return by6;
		   case 6: return layer1;
		   case 7: return layer2;
		   case 8: return layer3;
		   case 9: return layer4;
		   case 10: return co1;
		   case 11: return co2;		 
		   default: return 0;
		}
	}

    private:
	  const char by1;const char by2;const char by3;const char by4;
	  const char by5;const char by6;
	  const char layer1;const char layer2;const char layer3;const char layer4;	  
	  const char co1;const char co2;
};

class itemParticleStorage
{
    public:

	itemParticleStorage::itemParticleStorage(unsigned char b1, unsigned char b2, unsigned char b3, unsigned char b4, unsigned char l1, unsigned char l2=0x0, unsigned char l3=0xff, unsigned char l4=0xff, unsigned char c1=0x37, unsigned char c2=0x13): by1(b1), by2(b2), by3(b3), by4(b4), layer1(l1), layer2(l2), layer3(l3), layer4(l4),co1(c1),co2(c2)  { ; }

	inline unsigned char getByte(unsigned char pos)
	{
		switch (pos)
		{
		   case 0: return co1;
		   case 1: return by1;
		   case 2: return by2;
		   case 3: return by3;
		   case 4: return co2;
		   case 5: return by4;
		   case 6: return layer1;
		   case 7: return layer2;
		   case 8: return layer3;
		   case 9: return layer4;		  
		   default: return 0;
		}
	}

    private:
	  const char by1;const char by2;const char by3;const char by4;	  
	  const char layer1;const char layer2;const char layer3;const char layer4;
	  const char co1;const char co2;
};


class CParticleEffects
{
	enum caller 
	{
		CALLER_PREPARTICLES=0,
		CALLER_AFTERPARTICLES=1,
		CALLER_STATICPARTICLES=2,
	};

    public:

	   CParticleEffects(void) ;

	   /// particle effect (Magery related effects) stuff ///

	   void SpellCastingStart(int spellNum, P_CHAR Player, UOXSOCKET s);
	   void SpellCastingDestination(int spellNum, P_CHAR Player, P_CHAR DestMobile, P_ITEM DestItty, UOXSOCKET s);
	   void SpellCastingAfter(int spellNum, P_CHAR DestMobile, UOXSOCKET s);
	   void SpellFizzles(int spellNum, P_CHAR Player);	  

    private:	 
	   
	   /// pre calculated effect tables (only magery)

	  typedef map<int,preParticleStorage> mapPre;      typedef pair<int, preParticleStorage> effPre;
	  typedef map<int, staticParticleStorage> mapSta;  typedef pair<int, staticParticleStorage> effSta;
	  typedef map<int, moveParticleStorage> mapMov;    typedef pair<int, moveParticleStorage> effMov;
	  typedef map<int, afterParticleStorage> mapAfter; typedef pair<int, afterParticleStorage> effAfter;
	  typedef map<int, itemParticleStorage> mapItem;   typedef pair<int, itemParticleStorage> effItem;

	  mapPre MapPre;     mapPre::iterator itPre;
	  mapSta MapSta;     mapSta::iterator itSta;
	  mapMov MapMov;     mapMov::iterator itMov;
	  mapAfter MapAfter; mapAfter::iterator itAfter;
	  mapItem MapItem;   mapItem::iterator itItem;

	  CArray<49, unsigned char>C7;
	  
	  const short zero_s;
	  const int   zero_l;

	  ///////// helpers for magery effects //////////

	  void addInvisibleItem(P_CHAR pc, int spellNum, cCoord& c); 
	  void staticeffectUO3D(P_CHAR pc, int spellNum, int caller);
      void movingeffectUO3D(P_CHAR source, P_CHAR dest, int spellNum);      
      void itemeffectUO3D(P_ITEM pi, int spellNum);

	  void SCD(int spellNum, P_CHAR Player, P_CHAR DestMobile, P_ITEM DestItty, UOXSOCKET s);
	  int StaEffectOnBoth(int sNum);
	  void sendParticleMultiLayer(UOXSOCKET s, int spellNum, int caller); 
	  inline void sendParticleSingleLayer(UOXSOCKET s) {  P_CHAR Person = MAKE_CHARREF_LR(currchar(s)); SndToAllInRange(Person, &C7[0], 49);  }
};

class CEff
{
   public:
  /*
	void staticeffect(P_CHAR pc, short eff, unsigned char speed, unsigned char loop);
    void movingeffect(P_CHAR source, P_CHAR dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode, move_st *str=NULL);
    void bolteffect(P_CHAR Player);
  */

   private:	   
  /*
	void staticeffect2(P_ITEM pi, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode, stat_st *str=NULL);
    void staticeffect3(cCoord &c, unsigned char eff1, unsigned char eff2, char speed, char loop, char explode);
    void movingeffect3(P_CHAR source, cCoord &c, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode);
    void movingeffect3(P_CHAR pc_source, P_CHAR pc_dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode,unsigned char unk1,unsigned char unk2,unsigned char ajust,unsigned char type);
    void bolteffect2(P_CHAR Player,unsigned char a1,unsigned char a2);
    void movingeffect2(P_CHAR source, const P_ITEM dest, unsigned char eff1, unsigned char eff2, unsigned char speed, unsigned char loop, unsigned char explode);
  */

};

#endif
