/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __SRVPARMS_H__
#define __SRVPARMS_H__

#include "platform.h"
#include <string>
using namespace std;

class cKeyWord;
class cSection;
class cParmScript;

#define NPCSPEED .3	// was .2  5 steps every second

#define MAXTRACKINGTARGETS 20   // maximum number of trackable targets
#define TRACKINGRANGE 10        // tracking range is at least TRACKINGRANGE, additional distance is calculated by Skill,INT
#define TRACKINGTIMER 30        // tracking last at least TRACKINGTIMER seconds, additional time is calculated by Skill,INT, & DEX
#define TRACKINGDISPLAYTIME 30  // tracking will display above the character every TRACKINGDISPLAYTIME seconds

#define ECLIPSETIMER .5

struct ServerList_st
{
	UI16 uiIndex;
	string sServer;
	string AliasServer;
	UI08 uiFull;
	UI08 uiTime;
	string sIP;
	string AliasIP;
	UI16 uiPort;
};

struct timeLight_st
{
	int day; 
	int hour;
	int minute;
	int ampm; 
    int secondsperuominute; //Number of seconds for a WOLFPACK minute.
    unsigned int uotickcount;
    int moon1update;
    int moon2update;
	int fixedInlorPotionTime;
	int varInlorPotionTime;
	int fixedInlorSpellTime;
	int varInlorSpellTime;
	unsigned char season;
    unsigned char moon1;
    unsigned char moon2;
    unsigned char dungeonlightlevel;
    unsigned char worldfixedlevel;
    unsigned char worldcurlevel;
    unsigned char worldbrightlevel; //used to be 0x05
    unsigned char worlddarklevel; //used to be 0x1a - too dark
};

struct repsys_st
{
	long int		murderdecay;
	int				maxkills;
	int				crimtime;
};

struct resource_st
{
	unsigned int		logs;
	unsigned int	logtime;
	unsigned int	lograte;// AntiChrist
	unsigned int		logarea;
	int					logtrigger;// AntiChrist
	int					logstamina;// AntiChrist
	unsigned int		ore;
	unsigned int	oretime;
	unsigned int	orerate;// AntiChrist
	unsigned int		orearea;
	int					miningtrigger;// AntiChrist
	int					miningstamina;// AntiChrist
};

struct tracking_st
{
	unsigned int baserange;
	unsigned int maxtargets;
	unsigned int basetimer;
	unsigned int redisplaytime;
};

class cSrvParms
{
public:
	unsigned char IDLESERVERCHATTER;
	unsigned char packetstats;

	unsigned char antimacro_on;
	unsigned char antimacro_inputtype;
	unsigned short antimacro_queryfrequency;
	unsigned char antimacro_exceptions;
	unsigned char antimacro_querytype;

	char AOS_Mode;
	char newmagictest;
	unsigned int packetsendstyle; // LB .. defines the way packets are send
	unsigned char npcpopmenues;
	unsigned char antifastwalk;
	unsigned char antiinjection;
	unsigned long int CryptKey1;
	unsigned long int CryptKey2;

	unsigned char alwaysrelogin;
	unsigned int eclipsemode;
	unsigned int eclipsetimer;	
	unsigned int checkcharage;
	unsigned int poisontimer;
	unsigned int joinmsg;
	unsigned int partmsg;
	unsigned int decaytimer;
	unsigned int startgold;
	unsigned int saveinterval;
	unsigned int defaultpriv1;
	unsigned int defaultpriv2;


 //taken from 6904t2(5/10/99) - AntiChrist
	unsigned int playercorpsedecaymultiplier;
	unsigned int lootdecayswithcorpse;

	unsigned int invisibiliytimer;
	unsigned int hungerrate;
	unsigned char defaultfood; // determines what players can eat
	unsigned int skilldelay;
	unsigned int snoopdelay;
	unsigned int objectdelay;
	unsigned int bandagedelay;					// in seconds, on top of objectdelay
	unsigned int bandageincombat;				// 0=no, 1=yes; can use bandages while healer and/or patient are in combat ?
	unsigned int bandagecanres;					// 0=no, 1=yes; can resurrect with bandages
	unsigned int inactivitytimeout;				// seconds of inactivity until player will be disconnected (duke)
			// LB: if no packet received from client in that time period, disconnection ! (except idle packet)
			// thats necessary, cauz in case of client/OS crashes or IP changes on the fly players didnt get disconnected

	unsigned int hitpointrate;
	unsigned int staminarate;
	unsigned int manarate;
	unsigned int skilladvancemodifier;
	unsigned int statsadvancemodifier;
	unsigned int gatetimer;
	unsigned int minecheck;
	unsigned int showdeathanim;
	unsigned int combathitmessage;
	unsigned int monsters_vs_animals;
	unsigned int animals_attack_chance;
	unsigned int animals_guarded;
	unsigned int npc_base_fleeat;
	unsigned int npc_base_reattackat;
	unsigned int tamed_disappear; // Ripper
	unsigned int houseintown; // Ripper
	unsigned int shoprestock; // Ripper 
	unsigned char guardsactive;
	unsigned char bg_sounds;
	unsigned char commandPrefix; //Ripper	
	unsigned char mul_autodetect;

	int  playerpositionsrefresh;
	char playerpositionsfile[300];
	int  playerposfilebackupratio;

	char archivepath[300];
	char logging_path[300];
	char htmlfilepath[300];
	char mulpath[300];
	char completemulpath[300];
	char bookpath[300];
	int backup_save_ratio; // LB, each X'th save-intervall a backup is done if a path is given ...

	unsigned int maxabsorbtion; // Magius(CHE) --- Maximum Armour of the single pieces of armour (for player)!
	unsigned int maxnohabsorbtion; // Magius(CHE) --- Maximum Armour of the total armour (for NPC)!
	unsigned int npcdamage; // Magius(CHE) --- DAmage divided by this number if the attacked is an NPC!

	unsigned int sellbyname;	// Values= 0(Disabled) or 1(Enabled) - The NPC Vendors buy from you if your item has the same name of his item! --- Magius(CHE)
	int sellfromsubpacks;		// Players can sell from subpacks? (Thrawn)
	unsigned int sellmaxitem;	// Set maximum amount of items that one player can sell at one time (5 is standard OSI) --- Magius(CHE)
	unsigned int trade_system;	// Magius(CHE)
	unsigned int rank_system;	// Rank system to make various types of a single item based on the creator's skill! - Magius(CHE)
	int CheckBank;				// Vendors check bank for gold above this amount - Ripper
	int VendorGreet;			// shop keepers greet - Ripper

	unsigned int skilllevel;// Magius(CHE)
	unsigned int hungerdamage;
	unsigned int hungerdamagerate;
	int armoraffectmana; // Should armor slow mana regen ?
		
	char announceworldsaves;
		
	unsigned char auto_a_create; //Create accounts when people log in with unknown name/password
	unsigned int  auto_a_reload; //Auto reload accounts if file was touched, this stores the time interval in minutes.
		  
	unsigned int rogue;
	signed int maxstealthsteps;//AntiChrist - max number of steps allowed with stealth skill at 100.0
	unsigned int runningstaminasteps;//AntiChrist - max number of steps allowed with stealth skill at 100.0
	unsigned short int quittime;//Instalog
	int html;//HTML
	float boatspeed;

	unsigned int savespawns;

	float stablingfee;

	int attackstamina;	// AntiChrist (6) - for ATTACKSTAMINA

	unsigned int skillcap;//LB skill cap
	unsigned int statcap;//AntiChrist stat cap

	char specialbanktrigger[50]; //special bank trigger - AntiChrist
	int usespecialbank; //special bank - AntiChrist

//	int cutscrollreq;//AntiChrist - cut skill requirements for scrolls

	int persecute;//AntiChrist - persecute thing

	char errors_to_console; // LB
	char gm_log;
	char speech_log;
	char pvp_log;
	char server_log;
	int char_log;
	char logmode;

	unsigned long int housedecay_secs;
	unsigned int ra_port;
	bool EnableRA;

	unsigned char showCVCS; // Show client verification stuff at login ? (blackwind) 
	unsigned int default_jail_time; // Default jail time (86400) 
	unsigned int attack_distance; // Attack distance bugfix (blackwind) 


	float goldweight;//AntiChrist - configurable gold weight
	char msgboardpath[256];   // Dupois - Added April 4, 1999 for msgboard.cpp - path to store BB* files (ie C:\POSTS\)
	int  msgpostaccess;       // Dupois - Added April 4, 1999 for msgboard.cpp - who gets to post messages (0=GM only, 1 = everyone)
	int  msgpostremove;       // Dupois - Added April 4, 1999 for msgboard.cpp - who gets to remove post messages (0=GM only, 1 = everyone)
	int  msgretention;        // Dupois - Added April 4, 1999 for msgboard.cpp - how long to keep posts before deleting them automatically (in days - default 30)
	int  escortactive;        // Dupois - Added April 4, 1999 for escort quests - are escort quests created
	int  escortinitexpire;    // Dupois - Added April 4, 1999 for escort quests - time to expire after spawning NPC in secs(0=never)
	int  escortactiveexpire;  // Dupois - Added April 4, 1999 for escort quests - time to expire after quest has been accepted by player in secs(0=never)
	int  escortdoneexpire;    // Dupois - Added April 4, 1999 for escort quests - time to expire after quest has been completed by player in secs(0=never)
	int  bountysactive;       // Dupois - Added July 18, 2000 for bounty quests - whether bounties are active (1-default) or inactive (0)
	int  bountysexpire;       // Dupois - Added July 18, 2000 for bounty quests - number of days when an unclaimed bounty expires and is deleted (0=never-default)

	int engraving;			// engraving of items enabled/disabled? (Thrawn)
	int smeltableitems;		// smelting  of items enabled/disabled? (Thrawn)
	int defaultgmview;		// the default viewingdepth for gms (Thrawn)

	unsigned int BankboxLimit;		// bankbox limit - Ripper
	unsigned int StrongboxLimit;	// strongbox limit - Ripper
	unsigned int SecurecontLimit;	// secure & lockdowns limit - Ripper
	unsigned int ContainerLimit;	// All containers without a set limit - Ripper
	unsigned int ContainerWeight;	// All containers without a set weight - Ripper
	unsigned int BoatHoldWeight;	// weight limit of a boat's hold (Duke)

	int thehardway;					// cut new playerchar's stats, skills and/or items (Duke)

	void Init();
	void Load();
	void Save();
protected:
	cParmScript* ParmScript;
	cSection* SectionIT;
	cKeyWord* Key1;			// handler for chars_log; don't worry, just an intermediate prototype for better script handling (Duke, 8.10.03)
	void LoadLogging();
	void LoadScript(char *fn);
	void loadserver();
};

struct begging_st
{
	int timer;
	unsigned int range;
	char text[3][256];
};

struct fishing_st
{
	unsigned int basetime;
	unsigned int randomtime;
	unsigned int loot_probability;
};

struct spiritspeak_st
{
	unsigned int spiritspeaktimer;
};

struct speed_st 
{
	int antinpcaggregation;
	int idlesleep;
	int maxsocketwait;
	int loopsleep;
	float itemtime;
	unsigned int srtime;
	float npctime;
	float npcaitime;
//	unsigned int checkmem;
};


#endif
