/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////
// Name:	Timing.cpp
// Purpose: functions that handle the timer controlled stuff
// History:	cut from wolfpack.cpp by Duke, 26.10.00
// Remarks:	not necessarily ALL those functions
//

#include "Timing.h"
#include "Client.h"

#include "accounts.h"
#include "boats.h"
#include "combat.h"
#include "house.h"
#include "html.h"
#include "magic.h"
#include "magic_new.h"
#include "msgboard.h"
#include "network.h"
#include "npcinfo.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"
#include "sregions.h"
#include "TmpEff.h"
#include "Trade.h"
#include "worldmain.h"
#include "walking.h"
#include "Timing.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "Timing.cpp"

//////////////////////
// Name:	cPerfTimers
// Purpose: a set of timers used to control performance 
// History:	by Duke, 26.9.2002
// Remarks:	not a final version, just some preliminary stuff ;)
//

cPerfTimers::cPerfTimers()
{
	for (int i=0;i<PTM_max;i++) 
	{
		timers[i].setMilliSecs(1);	// init to nonzero so they are not considered 'not running'
	}
}

void cPerfTimers::setSecs(enum ePerfTimers tmr,int val)		    {	timers[tmr].setSecs(val);	advance();}
void cPerfTimers::setMilliSecs(enum ePerfTimers tmr,int val)    {	timers[tmr].setMilliSecs(val);	advance();}
bool cPerfTimers::hasExpired(void)								{	return 	master.hasExpired();}
bool cPerfTimers::hasExpired(enum ePerfTimers tmr)			    {	return 	timers[tmr].hasExpired();}

void cPerfTimers::advance(enum ePerfTimers tmr) { ; }

void cPerfTimers::advance()
{
	unsigned int next = ~0;
	for (int i=0;i<PTM_max;i++)
	{
		unsigned int v = timers[i].getValue();
		if (v < next)
			next = v;
	}
	master.setValue(next);
}


void checktimers() // Check shutdown timers
{
	unsigned int tclock=uiCurrentTime;
	if (lclock>tclock) overflow=1;
	else overflow=0;
	if (endtime)
	{
		if (endtime<=tclock) keeprun=0;
	}
	lclock=tclock;
}

void do_lsd(UOXSOCKET s)
{
	if (rand()%15==0)
	{
		int color=0,ctr=0,b,xx,yy,di,icnt=0;
		signed char zz;
		P_CHAR Player = MAKE_CHAR_REF(currchar(s));

		PC_ITEM pi;
		int loopexit=0;
		RegGrid3x3Iterator4Items rg3ii(Player->pos);
		while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			color=pi->color(); // fetch item's color and covert to 16 bit
			if (rand()%44==0) color+=pi->pos.x-pi->pos.y; else
				color+=Player->pos.x+Player->pos.y;
			color+=rand()%3; // add random "noise"
			ctr++;
			// lots of color consistancy checks
			color=color%0x03E9;
			if (color<0x0002 || color>0x03E9)
			{
				color=0x03E9;
			}
			b=((color&0x4000)>>14)+((color&0x8000)>>15);
			if (b)
			{
				color=0x100+rand()%255;
			}
			
			if (rand()%10==0) zz=pi->pos.z+rand()%33; else zz=pi->pos.z;
			if (rand()%10==0) xx=pi->pos.x+rand()%3; else xx=pi->pos.x;
			if (rand()%10==0) yy=pi->pos.y+rand()%3; else yy=pi->pos.y;
			di = Player->dist(pi);
			if (di<13) if (rand()%7==0)
			{
				icnt++;
				if (icnt%10==0 || icnt<10) 
					senditem_lsd(s, pi,color,xx,yy,zz); // attempt to cut packet-bombing by this thing
			}
			
		}

		cChar* pc;
		loopexit=0;
		RegGrid3x3Iterator4Chars rg3ic(Player->pos);
		while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			di = Player->dist(pc);
			if (di<10) if (rand()%10==0)
			{
				icnt++;
				if (icnt%10==0 || icnt<10) 
					sendperson_lsd(s, pc,color); // attempt to cut packet-bombing by this thing
			}
		}

		if (rand()%33==0)
		{
			if (rand()%10>3) soundeffect5(s, pc, 0x00F8); // lsd sound :)
			else
			{
				int snd=rand()%19;
				if (snd>9) soundeffect5(s, pc, 0x0100+snd-10);
				else soundeffect5(s, pc, 246+snd);
			}	
		}
	}
}

void genericCheck(P_CHAR pc, unsigned int currenttime)// Char mapRegions
{
	if (pc == NULL)
		return;
	
	if (!pc->dead)
	{
		if (pc->Hp() > pc->effStr())
		{
			pc->fullHp();
			updatestats(pc, 0);
		}
		if (pc->Stm() > pc->effDex())
		{
			pc->fullStm();
			updatestats(pc, 2);
		}
		if (pc->Mana() > pc->effInt())
		{
			pc->fullMana();
			updatestats(pc, 1);
		}
		if (pc->regen <= currenttime || overflow)
		{
			int limit = pc->effStr();
			unsigned int interval = SrvParms->hitpointrate*MY_CLOCKS_PER_SEC;

			if (pc->Hunger()>3 || SrvParms->hungerrate == 0)	// won't regenerate if hungry
			{
				int loopexit=0;
				while ((pc->regen <= currenttime && pc->Hp() < limit) && (++loopexit<MAXLOOPS))
				{
					int inc=1;
					if (pc->Skill(HEALING) > 500)
						inc=2;
					else if (pc->Skill(HEALING) > 800)
						inc=3;
					pc->regen += interval;
					pc->increaseHp(inc);
				}
			}
			pc->regen = currenttime + interval;
		}
		if (pc->regen2 <= currenttime || overflow)
		{
			int limit = pc->effDex();
			unsigned int interval = SrvParms->staminarate*MY_CLOCKS_PER_SEC;

			if (pc->Stm() < limit)
			{
				int loopexit=0;
				while ( (pc->regen2 <= currenttime && pc->Stm() < limit) && (++loopexit<MAXLOOPS) )
				{
					pc->regen2 += interval;
					pc->stm++;
				}
				updatestats(pc, 2);
			}
			pc->regen2 = currenttime + interval;
		}

		// regen mana rewritten to conform to OSI, save cpu and save bandwidth (Duke, 7.3.2002)
		if (pc->regen3 <= currenttime || overflow)
		{
			unsigned int interval = SrvParms->manarate*MY_CLOCKS_PER_SEC;	// milliseconds for worst case ie. full plate & stupid
			int limit = pc->effInt();
			if (pc->Mana() < limit)
			{
				int ac = Skills->GetAntiMagicalArmorDefence(pc);
				int acBon = ((30 - min(30,ac))*100)/30;							// armour class bonus in %
				if (!SrvParms->armoraffectmana)
					acBon = 100;
				int persBon = min(static_cast<int>(pc->effInt()), pc->Skill(MEDITATION)/10);	// personal bonus in %
				interval -= (((interval*6)/7) * min(persBon,acBon)) / 100;

				int loopexit=0;
				while ((pc->regen3 <= currenttime && pc->Mana() < limit) && (++loopexit<MAXLOOPS))
				{
					pc->regen3 += interval;
					pc->mn += pc->med ? 2 : 1;		// double speed/amount if meditating
				}

				updatestats(pc, 1);
				if (pc->med && pc->Mana() >= pc->effInt())	// right now a little prob if med (1 surplus mana); will be solved with mana class
				{
					sysmessage(pc->calcSocket(), "You are at peace.");
					pc->med = 0;
				}
			}
			pc->regen3 = currenttime + interval;
		}

		if ((pc->hidden == 2) && ((pc->invistimeout <= currenttime) || (overflow)) && (!pc->IsPermaHidden()))
		{// only if not permanently hidden - AntiChrist
			pc->hidden = 0;
			pc->stealth=-1;
			updatechar(pc);
		}
	}
	if (pc->Hp() <= 0 && !pc->dead)
		deathstuff(pc);
}

void PoisonMsg(P_CHAR pc)
{
	char t[120];
	if (pc->poisontxt.hasExpired())
	{
		pc->poisontxt.setSecs(10);
		switch (pc->Poisoned())
		{
		case 1:	sprintf(t,"* %s looks a bit nauseous *", pc->name);				break;
		case 2:	sprintf(t,"* %s looks disoriented and nauseous! *",pc->name);	break;
		case 3:	sprintf(t,"* %s is in severe pain! *", pc->name);				break;
		case 4:	sprintf(t,"* %s looks extremely weak and is wrecked in pain! *", pc->name);	break;
		}
		pc->emotecolor=0x0026;
		npcemoteall(pc,t,1);
	}
}

void PoisonEffect(P_CHAR pc, int secs, int div, int mini)
{
	if (!div) return;	// prevent divide by zero
	pc->poisondamagetime.setSecs(secs);
	PoisonMsg(pc);
	pc->reduceHp(max(pc->Hp()/div, mini));
}

void checkHunger(P_CHAR pc, unsigned int currenttime)
{
	static unsigned int hungerdamagetimer=0; // For hunger damage

	if (!pc->npc) // check player
	{
		UOXSOCKET s = pc->calcSocket();

		short color = 0x40;

		// note: dont set color to 0, this can lead to client crashes on login
		// because on login, if the player is hungry, and the 3d/2d ID packet isnt send yet, 3d clietns are recog. as 2d clients
		// and the generic 3d client crash if speech with color 0 can't apply.
		// an alternative fix would be delaying hunger time to like 10 secs aftr login.
		// then 3 clients  are regcog as 3d clients, and no need to set color !=0.

		if (SrvParms->hungerrate>1 && (pc->hungertime<=currenttime || overflow))
		{
			if (!pc->isGMorCounselor() && pc->Hunger()) //Morrolan GMs and Counselors don't get hungry
				pc->chgHunger(-1);

			switch(pc->Hunger())
			{
			case 6: break; //Morrolan
			case 5: sysmessage(s, color, "You are slightly peckish");					break;	// Sayro's request
	//		case 5: sysmessage(s, color, "You are still stuffed from your last meal");	break;	// OSI ?
			case 4:	sysmessage(s,color, "You are not very hungry but could eat more");	break;
			case 3:	sysmessage(s,color, "You are feeling fairly hungry");				break;
			case 2:	sysmessage(s,color, "You are extremely hungry");					break;
			case 1:	sysmessage(s,color, "You are very weak from starvation");			break;
			case 0:
				if (!pc->isCounselor())
					sysmessage(s, color, "You must eat very soon or you will die!");
				break;
			}
			pc->hungertime = currenttime+(SrvParms->hungerrate*MY_CLOCKS_PER_SEC); // Bookmark
		}
		if (((hungerdamagetimer<=currenttime)||(overflow))&&(SrvParms->hungerdamage>0)) // Damage them if they are very hungry
		{
			hungerdamagetimer=currenttime+(SrvParms->hungerdamagerate*MY_CLOCKS_PER_SEC); /** set new hungertime **/
			if (pc->Hp() > 0 && pc->Hunger()<2 && !pc->isCounselor() && !pc->dead)
			{
				sysmessage(s,color, "You are starving !");
				pc->reduceHp(SrvParms->hungerdamage);
				if (pc->Hp()<=0)
				{
					sysmessage(s, color, "You have died of starvation");
				}
			}
		}
	}
	else //hunger code for npcs
	{
		char t[120];
		if (SrvParms->hungerrate>1 && (pc->hungertime<=currenttime || overflow))
		{
			t[0] = '\0';

			if (pc->stablemaster_serial > 0)	// for stabled pets
			{
				if (pc->Hunger() < 6)
					pc->chgHunger(1);			// feed them
			}
			else
			{
				if (pc->Hunger())
					pc->chgHunger(-1);
			}

			if (pc->tamed && !pc->isAiVendor())
			{//if tamed let's display his hungry status
				switch(pc->Hunger())
				{
				case 6:
				case 5:	break;
				case 4:	sprintf(t,"* %s looks a little hungry *",pc->name);			break;
				case 3:	sprintf(t,"* %s looks fairly hungry *",pc->name);			break;
				case 2:	sprintf(t,"* %s looks extremely hungry *",pc->name);		break;
				case 1:	sprintf(t,"* %s looks weak from starvation *",pc->name);	break;
				case 0:
					//maximum hunger - untame code - AntiChrist
					//pet release code here
					if (pc->tamed)
					{
						if (pc->doppelgaenger_serial==-3) // added by Thrawn: unmount if mounted
						{
							P_CHAR Petowner = FindCharBySerial(pc->GetOwnSerial());
							int s = Petowner->calcSocket();
							unmounthorse(s);
						}
						pc->ResetFollowTarget();
						pc->npcWander=2;
						if (pc->ownserial!=-1) 
							pc->SetOwnSerial(-1);
						sprintf(temp, "* %s appears to have decided that it is better off without a master *", pc->name);
						npctalkall(pc,temp,0);
						soundeffect2(pc, 0x01FE);
						if (SrvParms->tamed_disappear)
						{
							Npcs->DeleteChar(pc);
						}
					}
					sprintf(t,"* %s must eat very soon or he will die! *",pc->name);
					break;
				}

				if ( (strlen(t)) && (!pc->hidden) )
				{//display message ( if there's one // and if the animal is not hidden
					pc->emotecolor=0x0026;
					npcemoteall(pc,t,1);
				}
			}//if tamed
			pc->hungertime=currenttime+(SrvParms->hungerrate*MY_CLOCKS_PER_SEC); // Bookmark
		}//if hungerrate>1
	}
}


void checkPoison(P_CHAR pc)
{
	UOXSOCKET s = pc->calcSocket();
	// new math + poison wear off timer added by lord binary !
	if ( pc->Poisoned() && !pc->isInvul() && !pc->isDummy() )
	{
		if ( pc->poisondamagetime.hasExpired())
		{
			if (!pc->poisonwearofftime.hasExpired()) // lb, makes poison wear off pc's
			{
				switch (pc->Poisoned())
				{
				case 1:	PoisonEffect(pc, 15, 40, 3);	break;	// lesser, 1 of 40 hp every 15 sec, minimum 3
				case 2:	PoisonEffect(pc, 10, 32, 5);	break;	// regular
				case 3:	PoisonEffect(pc, 10, 16, 7);	break;	// greater
				case 4:	PoisonEffect(pc,  5,  8, 6);	break;	// deadly
				default:
					LogErrorVar("Fallout of switch <%d>",pc->Poisoned());
					pc->ResetPoisoned();
					return;
				}
				if ( (s!=-1) && (pc->Hp()<1) )
				{
					sysmessage(s, "The poison has killed you.");
				}
			}
		} // end if poison-wear off-timer
	} // end if poison-damage timer

	if ( pc->Poisoned() && pc->poisonwearofftime.hasExpired() )
	{
		pc->PoisonWearOff(-1);
		if (s!=-1) sysmessage(s, "The poison has worn off.");
	}
}

void checkNPC(P_CHAR pc, cPerfTimers *ptmr, unsigned int currenttime)//Char mapRegions
{
	if (pc == NULL)	return;
	if (pc->stablemaster_serial!=0) return;
	if (pc->isDummy()) return; // don't touch temporary data-store-dummy NPC for doppelgaengers (or NPC's being transfered) //but check ridden animals (Thrawn)

	if (ptmr->hasExpired(PTM_npcai))
		Npcs->CheckAI(currenttime, pc);//Lag fix

	if (ptmr->hasExpired(PTM_npcwalk))
		npcMovement2(currenttime, pc);//Lag fix

	setcharflag(pc);
	if (!pc->dead)
	{
		if (!pc->HasSwingTarget())
			Combat->DoCombat(pc,currenttime);
		else
			if (pc->timeout<=currenttime)
				Combat->CombatHitCheckLoS(pc,currenttime);
	}
	
	if (ptmr->hasExpired(PTM_fieldeffect))
		OldMagic->CheckFieldEffects4(currenttime, pc);//Lag fix
	
	//	restockNPC(pc,currenttime);
	
	if ((pc->disabled>0)&&((pc->disabled<=currenttime)||(overflow)))
	{
		pc->disabled=0;
	}
	if (pc->summontimer<=currenttime||(overflow))
	{
		if (pc->summontimer>0)
		{
			// Dupois - Added Dec 20, 1999
			// QUEST expire check - after an Escort quest is created a timer is set
			// so that the NPC will be deleted and removed from the game if it hangs around
			// too long without every having its quest accepted by a player so we have to remove
			// its posting from the message board before icing the NPC
			// Only need to remove the post if the NPC does not have a follow target set
			if ( (pc->questType==ESCORTQUEST) && !pc->IsFollowing() )
			{
				MsgBoardQuestEscortRemovePost(pc);
				MsgBoardQuestEscortDelete(pc);
				return;
			}
			// Dupois - End
			
			soundeffect2(pc, 0x01FE);
			pc->dead=true;
			Npcs->DeleteChar(pc);
			return;
		}
	}
	
//	if ((pc->fleeat==0)) pc->fleeat=SrvParms->npc_base_fleeat;
//	if ((pc->reattackat==0)) pc->reattackat=SrvParms->npc_base_reattackat;

	if (pc->npcWander!=5 &&	pc->Hp() < (pc->effStr()*pc->fleeat)/100)
	{
		pc->oldnpcWander = pc->npcWander;
		pc->npcWander=5;
		pc->setNextMoveTime();
	}

	if (pc->npcWander==5 &&	pc->Hp() > (pc->effStr()*pc->reattackat)/100)
	{
		pc->npcWander = pc->oldnpcWander;
		pc->setNextMoveTime();

		pc->oldnpcWander=0; // so it won't save this at the wsc file
	}
	// end of flee code

	checkPoison(pc);
	checkHunger(pc,currenttime);
}

void checkPC(P_CHAR pc, cPerfTimers *ptmr, unsigned int currenttime)
{
	UOXSOCKET s = pc->calcSocket();	//Only calc socket once!

	if (ptmr->hasExpired(PTM_fieldeffect))
		OldMagic->CheckFieldEffects4(currenttime, pc);//Lag fix

	if (!pc->dead)
	{
		if (!pc->HasSwingTarget())
			Combat->DoCombat(pc,currenttime);
		else
		{
			if (pc->timeout<=currenttime)
				Combat->CombatHitCheckLoS(pc,currenttime);
		}
		pc->checkCraftAI(s);
	}

	
	if (SrvParms->antimacro_on) // check anti maco stuff timers iff enabled in server.scp
	{
		if (!pc->npc && pc->InGame())
		{	
		  // Check if Anti macro Queries got answered in time

		}	
	}

	if (pc->smoketimer>currenttime)
	{
		if (pc->smokedisplaytimer<=currenttime)
		{
			pc->smokedisplaytimer=currenttime+5*MY_CLOCKS_PER_SEC;
			staticeffect(pc, 0x3735, 0, 30);
			soundeffect2(pc, 0x002B);
			switch( RandomNum(0, 6) )
			{
			case 0:	npcemote(s, pc, "*Drags in deep*",1 );	break;
			case 1:	npcemote(s, pc, "*Coughs*",1 );			break;
			case 2:	npcemote(s, pc, "*Retches*",1 );			break;
			case 3:	npcemote(s, pc, "*Hacking cough*",1 );	break;
			case 4:	npcemote(s, pc, "*Sighs in contentment*",1 ); break;
			case 5:	npcemote(s, pc, "*Puff puff*",1 );		break;
			case 6:	npcemote(s, pc, "Wheeeee!!! Xuri's smoking!",1 ); break;
			default:	break;
			}
		}
	}

	if (LSD[s]) do_lsd(s); //LB's LSD potion-stuff

	if (!pc->npc && pc->InGame() && pc->squelched==2)
	{
		if (pc->mutetime!=-1)
		{
			if (pc->mutetime<=(int)currenttime||overflow)
			{
				pc->squelched=0;
				pc->mutetime=-1;
				sysmessage(s, "You are no longer squelched!");
			}
		}
	}

	if (!pc->npc && pc->InGame())
	{
		if ( pc->crimflag > 0 && ( (unsigned)pc->crimflag <= currenttime || overflow ) &&  pc->isCriminal() )//AntiChrist
		{
			sysmessage(s,"You are no longer a criminal.");
			pc->crimflag=-1;
			pc->setInnocent();
		}
		if (pc->murderrate<currenttime)//AntiChrist
		{
			if (pc->kills>0)
				pc->kills--;
			if (((signed)pc->kills==repsys.maxkills)&&(repsys.maxkills>0))
				sysmessage(s, "You are no longer a murderer.");
			pc->murderrate=(repsys.murderdecay*MY_CLOCKS_PER_SEC)+currenttime;//AntiChrist
		}
		setcharflag(pc);//AntiChrist
	}

	if (!pc->npc && pc->IsCasting())//PC casting a spell
	{
		pc->nextact--;
		if (pc->spelltime<=currenttime||overflow)//Spell is complete target it.
		{
			Magic->AfterSpellDelay(pc);
		}
		else if (pc->nextact<=0)//redo the spell action
		{
			pc->nextact=75;
			if (!pc->onhorse) impaction(s, pc->spellaction); // no animation, when player is on horse
		}
	}

	if (SrvParms->bg_sounds>=1)
	{
		if (SrvParms->bg_sounds>10) SrvParms->bg_sounds=10;
		int timer=SrvParms->bg_sounds*100;
		if (timer==0) timer=1;
		if ( pc->InGame() && !pc->npc && !pc->dead && ((rand()%(timer))==(timer/2))) bgsound(pc); //lb, bgsound uses array positions not sockets !
	}
	if ( pc->spiritspeaktimer.hasExpired())
		pc->spiritspeaktimer.reset();

	
	// Blackwinds Jail stuff.
	if (pc->cell>0)
	{
		if (pc->jailtimer.hasExpired())
		{
			sysmessage(s,"Your jail time is over!");
			
			if (pc != NULL)
			{
				if (pc->cell==0)
				{			
					sysmessage(s,"You're not in jail already ? Please report to GM");
					pc->jailtimer.reset();
					sprintf(temp,"%i cause bug in jail system.",pc->account);
					savelog(temp,"server.log");
				}
				else
				{
					jails[pc->cell].occupied = false;
					pc->teleTo(jails[pc->cell].oldpos);
					pc->cell=0;
					pc->jailtimer.reset();
					pc->SetPriv2(0);
					
					sprintf(temp,"%s is auto-released from jail \n",pc->name);
					savelog(temp,"server.log");
					
					sysmessage(s, "You are released.");
				}
			}
		}
	}
	
	// LB, changed to seconds instead of crappy #of checks, 21/9/99
	if (!pc->trackingtimer.hasExpired() && pc->InGame())
	{
		if (pc->trackingdisplaytimer.hasExpired())
		{
			pc->trackingdisplaytimer.setSecs(tracking_data.redisplaytime);
			Skills->Track(pc);
		}
	}
	else
	{
		P_CHAR Track = FindCharBySerial(pc->trackingtarget);
		if (Track)
		{
			pc->trackingtimer.reset();
			unsigned char arrow[7] = {0xBA, 0,};
			arrow[0]='\xBA';
			arrow[1]=0;
			ShortToCharPtr(Track->pos.x-1,&arrow[2]);
			ShortToCharPtr(Track->pos.y  ,&arrow[4]);
			
			XStartPkt(0xBA,6);
			XAddPkt(&arrow[0+1],6-1);
			XFinishPkt(s);
		}
	}

	checkHunger(pc,currenttime);
	checkPoison(pc);

	if ( pc->onhorse )
	{
		P_ITEM pHorse = pc->GetItemOnLayer(0x19);
		if (!pHorse)
		{
			pc->onhorse = false;	// turn it off, we aren't on one because there's no item!
			return;
		}
		else
		{
			// Thrawn: checking ridden npc
			P_CHAR Pet = FindCharBySerial(pHorse->morex);
			if (Pet != NULL)
			{
				checkPoison(Pet);
				checkHunger(Pet,currenttime);
			}
			if (pHorse->decaytimer.hasExpired())
			{
				pc->onhorse = false;
				Items->DeleItem( pHorse );
			}
		}
	}
}

void checkCharIfPlayerIsNear(P_CHAR pc, bool Near, cPerfTimers *ptmr)
{
	//AntiChrist
	//so we can use two different speeds
	//for checking tamed and non-tamed npcs!
	//players WANT to have faster tamed npcs....
	if (pc->npc)
	{
		genericCheck(pc,uiCurrentTime); // lb, lagfix
		if (Near)
			checkNPC(pc,ptmr,uiCurrentTime);
	}
	else
		if (Accounts->GetInWorld(pc->account) == pc->GetIndex() && pc->logout>0 &&
			((unsigned)pc->logout<=uiCurrentTime || (overflow)))
		{										
			pc->SetOffline();
			pc->logout=-1;
			updatechar(pc);
		}
}

void checkItemIfPlayerIsNear(PC_ITEM pi)
{
	Items->RespawnItem(uiCurrentTime, pi->unconst());
	if (pi->isType(ITY_Gate1) || pi->isType(ITY_Gate2))
	{
		if (pi->gatetime<=uiCurrentTime) // LB !!!
		{		
			Items->DeleItem(pi->unconst()); 
		}
	}
	Items->DecayItem(uiCurrentTime, pi->unconst());
}

void checkBoatIfPlayerIsNear(P_ITEM pi)
{
}

void checkAntiMacroReplies(void)
{
    //#define DEBUG_IT
	
	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{	
		// check if reply overdue
		bool ok=true;
		bool n_answer;
		int sock = api.getSocket();
		
#ifdef DEBUG_IT
		printf("AM-check!\n");
#endif
		
		if (AntiMacro[sock].QueryStartTime!=0) // only check if there had been already a query
		{
			unsigned long int diff;
			
			if (AntiMacro[sock].QueryAnswerTime==0) // no answer, 
			{
				diff = uiCurrentTime-AntiMacro[sock].QueryStartTime;
				n_answer=true;
				
#ifdef DEBUG_IT
				printf("no answer\n");
#endif			  
			}
			else
			{ 
				n_answer=false;
				diff = AntiMacro[sock].QueryAnswerTime-AntiMacro[sock].QueryStartTime;
				
#ifdef DEBUG_IT
				printf("already answered\n");
#endif			   		       
			}
			
			diff/=MY_CLOCKS_PER_SEC;
			
			// note a tricky part of this: because of unsignedness -1 values give very huge values.
			// that's ok here, they need to set ok false, which is automatically/implicitly done.
			// shouldnt happen anyway.
			
			if (diff>=(60*3)) // no answer or too late ???
			{
				ok=false;
			}
			else // in time
			{
				ok=true;
				
				if (n_answer==false) // only check if answer ok if answer given
				{
					switch(SrvParms->antimacro_querytype)
					{
					case 0: 
						break; // no reply checking
						
					case 1: 
						int len_qs, len_as,requ_matches,a,matches,max;
						
						len_qs=AntiMacro[sock].QueryString.length();
						len_as=AntiMacro[sock].QueryReplString.length();
						matches=0;
						
						switch(len_qs) // how many correct matches do we need (from server-query-string = 3-8 chars) ?
						{
						case 3: requ_matches=2; break;
						case 4: requ_matches=2; break;
						case 5: requ_matches=3; break;
						case 6: requ_matches=3; break;
						case 7: requ_matches=4; break;
						case 8: requ_matches=5; break;
						default: requ_matches=100; break;
						}
						
						if (len_as<len_qs) max=len_as; // we can only check minimum from len_querystring and reply					  									 
						else if (len_as>len_qs) max=len_qs;					  			
						else max=len_as;					 					  
						
						for (a=0; a<max;a++)
						{
							if (AntiMacro[sock].QueryString[a]==AntiMacro[sock].QueryReplString[a]) matches++;
						}
						
						ok = matches>=requ_matches;
						
						//printf("AS:%i QS:%i requ:%i m:%i\n",len_as, len_qs, requ_matches, matches);
						
						//if (!(AntiMacro[sock].QueryString==AntiMacro[sock].QueryReplString)) ok=false; // check for exact reply
						break;
					}
				}
			}
			
#ifdef DEBUG_IT		    
			printf("diff ok:%i t:%i\n",ok, diff);
#endif
			
			if (!ok)
			{
				if (n_answer==true) sprintf(temp,"Disconected player %s reason: NO Anti Macro Query answer was given at all\n",pc->name);
				else                sprintf(temp,"Disconected player %s reason: too many errors in Anti Macro reply\n",pc->name);
				
				LogMessageF('X', -1, "Macroers.txt", temp);
				
				Network->Disconnect(sock);		
				
				return; // disconnects in a allplayeriterator is dangerous, better not, wait for next victims in next check
			}
		}
	}
}

void checkauto() // Check automatic/timer controlled stuff (Like fighting and regeneration)
{
	
	#define ANTIMACROQUERYUNIT 5 //minutes
    #define ANTIMACROREPLYUNIT 1 //minutes

	unsigned int i,currenttime=uiCurrentTime; //\/ getclock only once
	static unsigned int checkspawnregions=0;
	static unsigned int checkitemstime=0;
	static cPerfTimers Timers, *ptmr=&Timers;
	static unsigned int nextdecaytime=0;
	static unsigned int lighttime=0;
	static unsigned int htmltime=0;
	static unsigned int housedecaytimer=0;
	static unsigned int checklogouttimer=0;
	static unsigned int nextAntiMacroQueryCheck=uiCurrentTime+MY_CLOCKS_PER_SEC*60*ANTIMACROQUERYUNIT*SrvParms->antimacro_queryfrequency;
	static unsigned int nextAntiMacroReplyCheck=uiCurrentTime+MY_CLOCKS_PER_SEC*60*ANTIMACROREPLYUNIT;
	static unsigned int nextPlayerpositionfileCheck=uiCurrentTime+MY_CLOCKS_PER_SEC*SrvParms->playerpositionsrefresh;

	if (checklogouttimer < currenttime)
	{
		char lo,l,lo2;
		lo  = Network->CheckDelayedLogoutTime(); // logout players if logout timer ok	
		l   = Network->CheckDualLogins();        // kick dual logins. (can happen if alwaysrelogin set to 1)
		lo2 = Network->CheckStuckConnections();  // kick connections (client or non clients) that didn't send any data for > 90 secs. (client side ping comes at 60 sec itnervals)
		checklogouttimer = currenttime+13*MY_CLOCKS_PER_SEC;
	}

	if (housedecaytimer<=currenttime)
	{
		//////////////////////
		///// check_houses
		/////////////////////
		if (SrvParms->housedecay_secs!=(unsigned)-1)
			check_house_decay();

		////////////////////
		// check stabling
		///////////////////

		unsigned int ci;
		int serial; //,serhash;
		unsigned long int diff;	

		P_CHAR pc;
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
		{
			if (pc->npc_type ==1)
			{
				serial = pc->serial;
				vector<SERIAL> pets = stablesp.getData(serial);
				for (ci = 0; ci < pets.size();ci++)
				{
					P_CHAR pc_pet = FindCharBySerial(pets[ci]);
					if (pc_pet != NULL)
					{
						diff = (getNormalizedTime() - pc_pet->timeused_last) / MY_CLOCKS_PER_SEC;
						pc_pet->time_unused+=diff;
					}
				}
			}
		}

		housedecaytimer=uiCurrentTime+MY_CLOCKS_PER_SEC*60*11; // check only each 11 minutes
	}

	// if antimacro on, issue all x-minutes an anti-amcro query for all online players, x specified in server.scp
	if (nextAntiMacroQueryCheck<=currenttime && SrvParms->antimacro_on) 
	{
		generateAntiMarcoQueries(SrvParms->antimacro_inputtype, SrvParms->antimacro_exceptions, SrvParms->antimacro_querytype);		
		nextAntiMacroQueryCheck=uiCurrentTime+MY_CLOCKS_PER_SEC*60*ANTIMACROQUERYUNIT*SrvParms->antimacro_queryfrequency;	
	}

	// if antimacro on, issue all x-minutes an anti-amcro query for all online players, x specified in server.scp
	if (nextAntiMacroReplyCheck<=currenttime && SrvParms->antimacro_on) 
	{		
		checkAntiMacroReplies();
		nextAntiMacroReplyCheck=uiCurrentTime+MY_CLOCKS_PER_SEC*60*ANTIMACROREPLYUNIT;	
	}

	if (nextPlayerpositionfileCheck<=currenttime && SrvParms->playerpositionsrefresh>0)
	{
		makePlayerPosFile();
		nextPlayerpositionfileCheck=uiCurrentTime+MY_CLOCKS_PER_SEC*SrvParms->playerpositionsrefresh;
	}

	if (checkspawnregions<=currenttime && speed.srtime != (unsigned) -1)//Regionspawns
	{
		if (!DoTimedSpawn())	
			checkspawnregions=uiCurrentTime+speed.srtime*MY_CLOCKS_PER_SEC;
	}

	if (SrvParms->html>0 && (htmltime<=currenttime || overflow))
	{
		updatehtml();
		htmltime=currenttime+(SrvParms->html*MY_CLOCKS_PER_SEC);
	}

	if (SrvParms->saveinterval != 0)
	{
		cwmWorldState->CheckSaving();

		// Dupois - Added Dec 20, 1999
		//			After an automatic world save occurs, lets check to see if
		//			anyone is online (clients connected). If nobody is connected
		//			Lets do some maintenance on the bulletin boards.
	/*		if ( !now )
		{
				clConsole.send("LoneWolf: No players currently online. Starting bulletin board maintenance.\n" );
				savelog( "Bulletin Board Maintenance routine running (AUTO)\n", "server.log" );
			MsgBoardMaintenance();
		}
		*/
	}

	//Time functions
	if (timeLight.uotickcount<=currenttime||(overflow))
	{
		if (timeLight.minute < 59) {timeLight.minute++;}
		else
		{
			timeLight.minute=0;
			if (timeLight.hour < 12) timeLight.hour++;
			else
			{
				timeLight.hour = 1;
				timeLight.ampm = !timeLight.ampm;
				if (!timeLight.ampm) timeLight.day++;
			}
		}
		timeLight.uotickcount=currenttime+timeLight.secondsperuominute*MY_CLOCKS_PER_SEC;
		if (timeLight.minute%8==0)
			timeLight.moon1=(timeLight.moon1+1)%8;
		if (timeLight.minute%3==0)
			timeLight.moon2=(timeLight.moon2+1)%8;
	}

	if (lighttime<=currenttime || (overflow))
	{
		for (i=0;i<now;i++) if (perm[i]) dolight(i); // bandwidth fix, LB
		lighttime=currenttime+30*MY_CLOCKS_PER_SEC;
	}

	static unsigned int itemlooptime = 0;
    if (itemlooptime <=currenttime || (overflow))
	{
		itemlooptime = currenttime+5*MY_CLOCKS_PER_SEC;
		PC_ITEM pi;
		AllItemsIterator aii;
		for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++) // Ripper...so spawners get set to nodecay.
		{
			// lets make sure they are spawners.
			if ((pi->type>=61 && pi->type<=65) || pi->isType(ITY_NpcAreaSpawner) || pi->isType(ITY_QuestSpawn))
			{
				pi->unconst()->decayOff();	// set to nodecay
			}
		}
	}

	for(i=0;i<now;i++)
	{
		P_CHAR Player_i = MAKE_CHAR_REF(currchar(i));
		if (Player_i->InGame())
		{
		if (Player_i->account==acctno[i])
		{
			genericCheck(Player_i,currenttime);
			checkPC(Player_i,ptmr,currenttime);

			cChar* pc;
			int loopexit=0;
			RegGrid3x3Iterator4Chars rg3ic(Player_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				if (ptmr->hasExpired(PTM_npcwalk) ||
					ptmr->hasExpired(PTM_npcai) ||
					ptmr->hasExpired(PTM_fieldeffect) || overflow)
				{
					bool Near=false;
					if (Player_i->dist(pc)<=24) //Morrolan tweak from 30 to 24 tiles
						Near=true;
					checkCharIfPlayerIsNear(pc,Near,ptmr);
				}
			}

			PC_ITEM pi;
			loopexit=0;
			RegGrid3x3Iterator4Items rg3ii(Player_i->pos);
			while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				if (checkitemstime<=currenttime||(overflow))
				{
					checkItemIfPlayerIsNear(pi);
					if (pi->isType(ITY_88) && pi->morey<25 )
					{
						if (Player_i->dist(pi)<=pi->morey)
						{
							if (RandomNum(1,100)<=(signed)pi->morez)
								SndSound(i, pi->pos, pi->morex);
						}
					}
				}
				else //Boats
				{
					if (pi->isType(ITY_Boat) && pi->type2!=0		// type2==0 means not moving
						&& (pi->gatetime<=currenttime||overflow))
					{
						P_ITEM Boat = pi->unconst();
						if (Boat->type2&1)		// covers 1 (forward) and 3(slow forward)
							Boats->Move(i, Boat->dir, Boat);
						else 
						{
							int dir = Boat->dir+4;
							if (dir>7) dir-=8; // LB, BUGKILLING !!!
							Boats->Move(i, dir, Boat);
						}
						int slow = 1;	// multiplied with boatspeed
						if (Boat->type2 > 2) slow=2;	// doubles the time between moves
						Boat->gatetime=(unsigned int)(currenttime + (double)(SrvParms->boatspeed*slow*MY_CLOCKS_PER_SEC));
					}	
				}
			}
		}
		}
	}//for i<now

#if 0
	// Duke: experimental code to do ALLWAYS do those checks that are only done when a player is near
	if (ptmr->hasExpired(PTM_npcwalk) || overflow)
	{
		P_CHAR pc;
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
		{
			if (ptmr->hasExpired(PTM_npcwalk) || overflow)
			{
				checkCharIfPlayerIsNear(pc,true,ptmr);
			}
		}
	}
	
	P_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		checkItemIfPlayerIsNear(pi);
	}
#endif

	AllTmpEff->Check();

	if (ptmr->hasExpired(PTM_npcwalk))			ptmr->setMilliSecs(PTM_npcwalk,(unsigned int)((double)(speed.npctime*1000)));
	if (ptmr->hasExpired(PTM_npcai))			ptmr->setMilliSecs(PTM_npcai,(unsigned int)((double)(speed.npcaitime*1000)));
	if (ptmr->hasExpired(PTM_fieldeffect))		ptmr->setMilliSecs(PTM_fieldeffect,500);

	if (checkitemstime<=currenttime) checkitemstime=(unsigned int)((double)(speed.itemtime*MY_CLOCKS_PER_SEC+currenttime)); //lb
	if (SrvParms->shoprestock==1 && shoprestocktime<=currenttime)
	{
		shoprestocktime=currenttime+(shoprestockrate*60*MY_CLOCKS_PER_SEC);
		restock(0);
	}
	if (nextdecaytime <= currenttime)
		nextdecaytime = currenttime + (15*MY_CLOCKS_PER_SEC); // lb ...
	if (SrvParms->auto_a_reload > 0 && Accounts->lasttimecheck + (SrvParms->auto_a_reload*60*MY_CLOCKS_PER_SEC) <= currenttime)
		Accounts->CheckAccountFile();

	// Do Eclipse stuff.. /blackwind 
	if (SrvParms->eclipsetimer>0) 
	{ 
		if (SrvParms->eclipsetimer <= uiCurrentTime) 
		{ 
			SrvParms->eclipsetimer = (unsigned int)((double) uiCurrentTime +(ECLIPSETIMER*MY_CLOCKS_PER_SEC)); 
			if (SrvParms->eclipsemode)
				timeLight.worldfixedlevel--;
			else 
				timeLight.worldfixedlevel++; 
			setabovelight(timeLight.worldfixedlevel,-1); 
			if ((timeLight.worldfixedlevel>20) ||(timeLight.worldfixedlevel < 1))
			{ 
				SrvParms->eclipsetimer = 0; 
				SrvParms->eclipsemode=!SrvParms->eclipsemode; 
			} 
		} 
	} // end eclipse / blackwind..
}
