/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// TmpEff.h: interface for the TmpEff class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__TMPEFF_H__)
#define __TMPEFF_H__ 

#include "platform.h"
#include "typedefs.h"


enum eTmpEffTypes
{
	TEF_None=0,
	TEF_Paralyze=1,
	TEF_NightSight=2,
	TEF_Clumsy=3,
	TEF_FeebleMind=4,
	TEF_Weaken=5,
	TEF_Agility=6,
	TEF_Cunning=7,
	TEF_Strength=8,
	TEF_Grinding=9,
	TEF_Mortar=10,
	TEF_Bless=11,
	TEF_Curse=12,
	TEF_Door=13,
	TEF_TDummy=14,
	TEF_ReactiveArmor=15,
	TEF_ExplMsg=16,
	TEF_Explode=17,
	TEF_Polymorph=18,
	TEF_Incognito=19,
	TEF_LSD=20,
	TEF_Protection=21,
	TEF_HideGM=33,
	TEF_UnHideGM=34,
	TEF_HealMsg=35,
	TEF_Sheep=36,
	TEF_Plant=37,
	TEF_Mill=38,
	TEF_Taming=39,
	TEF_FencingPara=44,
	TEF_Concussion=45,
	TEF_Camping=46,
	TEF_Doppelgaenger=47
};

class cTmpEff  
{
protected:
	int sourSer;
	int destSer;
public:
	unsigned int expiretime;
	unsigned char num;
	unsigned char more1;
	unsigned char more2;
	unsigned char more3;
	unsigned char dispellable;

public:
	cTmpEff() {;}
	virtual ~cTmpEff() {;}
	void Init(int number);
	void setExpiretime_s(int seconds);
	void setDest(int ser);
	int  getDest();
	void setSour(int ser);
	int  getSour();
	virtual void On(P_CHAR pc);
	virtual void Off(P_CHAR pc);
	void Reverse();
	virtual void Expire();
	virtual void Prolong(int seconds);
};

class cAllTmpEff  
{
private:
	cTmpEff **teffects;
	unsigned int teffectcount; // No temp effects to start with

public:
	cAllTmpEff();
//	virtual ~cAllTmpEff();
	bool Alloc(int count);
	bool ReAlloc(int newcount);
	void On();
	void Off();
	void ExpireOnDeath(P_CHAR pc);
	void Check();
	bool Add(P_CHAR pcSource, P_CHAR pcDest, int num, unsigned char more1, unsigned char more2, unsigned char more3, short dur);
	bool Add(P_CHAR pcSource, P_ITEM piDest, int num, unsigned char more1, unsigned char more2, unsigned char more3);
	void Insert(cTmpEff* pTE);
	void Remove(int i);
};

unsigned char tempeffect(P_CHAR Source,P_CHAR Dest, eTmpEffTypes num, unsigned char more1=0, unsigned char more2=0, unsigned char more3=0, short dur=-1);
unsigned char tempeffect(P_CHAR pcBoth,				eTmpEffTypes num, unsigned char more1, unsigned char more2, unsigned char more3, short dur=-1);
unsigned char tempeffect(P_CHAR Source,P_ITEM Dest, eTmpEffTypes num, unsigned char more1=0, unsigned char more2=0, unsigned char more3=0);
unsigned char tempeffect(P_ITEM piDest,				eTmpEffTypes num, unsigned char more1=0, unsigned char more2=0, unsigned char more3=0);

#endif

 
