/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////
// Name:	Trade.cpp
// Purpose: functions that are related to trade
// History:	cut from wolfpack.cpp by Duke, 26.10.00
// Remarks:	not necessarily ALL those functions
//

#include "Trade.h"

#include "Client.h"
#include "commands.h"
#include "itemid.h"
#include "SndPkg.h"
#include "weight.h"
#include "LwMisc.h"
#include "network.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "Trade.cpp"

void buyaction(P_CLIENT ps)
{
	int s = ps->GetSocket();
	int clear=0, i, j;
	P_ITEM buyit[512];
	int amount[512];
	int layer[512];
	int goldtotal=0;
	int soldout=0;
	int tmpvalue=0; // Fixed for adv trade system -- Magius(CHE) 
	P_CHAR Player = ps->getPlayer();
	if (!Player) return;

	P_ITEM Pack=Player->getBackpack();
	if (!Pack) return; //LB no player-pack - no buy action possible - and no crash too ;-)

	P_CHAR Vendor = FindCharBySerPtr(&buffer[s][3]);
	if (!Vendor) return;

	int itemtotal=(((256*(buffer[s][1]))+buffer[s][2])-8)/7;
	if (itemtotal>256) return; //LB

	for(i=0;i<itemtotal;i++)
	{
		unsigned char *p = &buffer[s][8+(7*i)];
		layer[i]=*p;
		buyit[i]=FindItemBySerial(LongFromCharPtr(p+1));
		amount[i]=ShortFromCharPtr(p+5);

		P_ITEM iBuyitem = buyit[i];
		if (iBuyitem!=NULL)
		{
			iBuyitem->rank=10;
			tmpvalue=iBuyitem->calcBuyPrice(Vendor->region);	// Fixed for adv trade system -- Magius(CHE) 
			goldtotal=goldtotal+(amount[i]*tmpvalue);
		}
	}

	if (Player->canAfford(goldtotal) || Player->isGM())
	{
		for (i=0;i<itemtotal;i++)
		{
			P_ITEM iBuyitem = buyit[i];
			if (iBuyitem!=NULL)
			{
				if (iBuyitem->amount<amount[i])
				{
					soldout=1;
				}
			}
		}
		if (soldout)
		{
			npctalk(s, Vendor, "Alas, I no longer have all those goods in stock. Let me know if there is something else thou wouldst buy.",0);
			clear=1;
		}
		else
		{
			if (Player->isGM())
			{
				sprintf(temp, "Here you are, %s. Someone as special as thee will receive my wares for free of course.", Player->name);
			}
			else
			{
				if (Player->useBankToPay(goldtotal))
				{
					sprintf(temp, "Here you are, %s. %d gold coin%s will be deducted from your bank account.  I thank thee for thy business.",
					Player->name, goldtotal, (goldtotal==1) ? "" : "s");
				    goldsfx(s, goldtotal);
				}
			    else
				{
				    sprintf(temp, "Here you are, %s.  That will be %d gold coin%s.  I thank thee for thy business.",
					Player->name, goldtotal, (goldtotal==1) ? "" : "s");
				    goldsfx(s, goldtotal);	// Dupois, SFX for gold movement. Added Oct 08, 1998
				}
			}
			npctalkall(Vendor, temp,0);
			Vendor->DoAction(0x20);		// bow (Duke, 17.3.2001)

			clear=1;
			if (!Player->isGM())
				Player->pay(goldtotal);

			for (i=0;i<itemtotal;i++)
			{
				P_ITEM pi = buyit[i];
				if (pi != NULL)
				{
					if (pi->amount>amount[i])	// they didn't buy all of these items
					{
						if (pi->pileable)
						{
							Commands->DupeItem(ps, pi, amount[i]);
						}
						else
						{
							for (j=0;j<amount[i];j++)
							{
								Commands->DupeItem(ps, pi, 1);
							}
						}
						pi->amount-=amount[i];
						pi->restock+=amount[i];
					}
					else
					{
						switch(layer[i])
						{
						case 0x1A:	// from the restock-container
							if (pi->pileable)
							{
								Commands->DupeItem(ps, pi, amount[i]);
							}
							else
							{
								for (j=0;j<amount[i];j++)
								{
									Commands->DupeItem(ps, pi, 1);
								}
							}
							pi->amount-=amount[i];
							pi->restock+=amount[i];
							break;
						case 0x1B:	// from the no-restock-container
							if (pi->pileable)
							{
								pi->SetContSerial(Pack->serial);
								pi->refresh();
							}
							else
							{
								for (j=0;j<amount[i]-1;j++)
								{
									Commands->DupeItem(ps, pi, 1);
								}
								pi->SetContSerial(Pack->serial);
								pi->amount=1;
								pi->refresh();
							}
							break;
						default:
							LogError("Fallout of switch");
						}

					}

					if (validhair(pi->id())) //if they bought hair (thrawn)
					{
						DeleteItemOnLayer(Player, 0x0b);
						if (pi->color() < 0x044E || pi->color() > 0x04AD) pi->setColor(0x044E);
						Player->Wear(pi,0x0B); //"hair" layer
						pi->refresh();

						// send update to all inrange sockets
						SndWornItemsToAllInRange(Player);
					} 
					else if (validbeard(pi->id()) && Player->id()==0x0190) // or beard (and player is male)
					{
						DeleteItemOnLayer(Player, 0x10);
						if (pi->color() < 0x044E || pi->color() > 0x04AD) pi->setColor(0x044E);
						Player->Wear(pi,0x10); //"beard" layer
						pi->refresh();

						// send update to all inrange sockets
						SndWornItemsToAllInRange(Player);
					}
				}
			}
		}
	}
	else
	{
		npctalkall(Vendor, "Alas, thou dost not possess sufficient gold for this purchase!",0);
	}

	if (clear)
	{
		SndClearTrade(s,Vendor->serial);
	}
	Weight->NewCalc(Player);	// Ison 2-20-99
	statwindow(s, Player);
}

void restockNPC(P_CHAR pc, bool full)
{
	cItem* Stock = pc->GetItemOnLayer(0x1A);	// the vendor's sell container
	if (Stock)
	{
		int ci=0,loopexit=0;
		P_ITEM pi;
		while ( ((pi=Stock->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (full)	// restock to max
			{
				pi->amount += pi->restock;
				pi->restock = 0;
			}
			else
			{
				if (pi->restock)
				{
					int tmp=min(pi->restock, (pi->restock/2)+1);
					pi->amount += tmp;
					pi->restock -= tmp;
				}
			}
			// MAgius(CHE): All items in shopkeeper need a new randomvaluerate.
			if (SrvParms->trade_system==1)
				StoreItemRandomValue(pi,pc->region);
		}
	}
}

void restock(bool full)
{
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc = aci.GetData()) != aci.End(); aci++)
	{
		if (pc->shop)
			restockNPC(pc,full);
	}
}

#if 0
void restock(int s)
{
	P_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		// Dupois - added this check to only restock items that ... well ... have a restock value >0
		// Added Oct 25, 1998
		if (pi->restock && isItemSerial(pi->contserial))
		{
			P_ITEM ci = FindItemBySerial(pi->contserial);
			if (ci != NULL)
			{
				if ((ci->layer==0x1A))
				{
					if (s)
					{
						pi->amount += pi->restock;
						pi->restock = 0;
					}
					else
					{
						if (pi->restock > 0)
						{
							int a = min(pi->restock, (pi->restock/2)+1);
							pi->amount+=a;
							pi->restock-=a;
						}
					}
				}
			}
		}
		// MAgius(CHE): All items in shopkeeper need a new randomvaluerate.
		if (SrvParms->trade_system==1) StoreItemRandomValue(pi,-1);// Magius(CHE) (2)
	}
}
#endif

// this is a q&d fix for 'sell price higher than buy price' bug (Duke, 30.3.2001)
static bool items_match(P_ITEM pi1, P_ITEM pi2)
{
	if (pi1->id()==pi2->id() &&
		pi1->isType(pi2->type) &&
		!(pi1->id()==0x14F0 && (pi1->morex!=pi2->morex)) &&			// house deeds only differ by morex
		!(IsShield(pi1->id()) && strcmp(pi1->name2,pi2->name2)) &&	// magic shields only differ by name2
		!(IsMetalArmour(pi1->id()) && pi1->color()!=pi2->color()) )	// color checking for armour
		return true;
	return false;
}
 
void sellaction(P_CLIENT ps)
{
	int s = ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	int i, amt, value=0, totgold=0;
	P_ITEM iNpa=NULL,iNpb=NULL,iNpc=NULL;
	int serial = LongFromCharPtr(&buffer[s][3]);

	if (buffer[s][8]!=0)
	{
		P_CHAR Vendor = FindCharBySerial(serial);
		if (!Vendor) return;

		int ci=0,loopexit=0;
		P_ITEM pi;
		while ( ((pi=Vendor->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (pi->layer==0x1A)      iNpa=pi; // Buy Restock container
			else if (pi->layer==0x1B) iNpb=pi;	// Buy no restock container
			else if (pi->layer==0x1C) iNpc=pi;	// Sell container
		}

		// Pre Calculate Total Amount of selling items to STOPS if the items if greater than SELLMAXITEM - Magius(CHE)
		unsigned int maxsell=0;
		i=buffer[s][8];
		if (i>256) return;
		for (i=0;i<buffer[s][8];i++)
		{
			amt=ShortFromCharPtr(&buffer[s][9+(6*i)+4]);
			maxsell+=amt;
		}
		if (maxsell>SrvParms->sellmaxitem)
		{
			char tmpmsg[256];
			sprintf(tmpmsg,"Sorry %s but i can buy only %i items at time!",Player->name,SrvParms->sellmaxitem);
			npctalkall(Vendor, tmpmsg,0);
			return;
		}

		for (i=0;i<buffer[s][8];i++)
		{
			P_ITEM pSell=FindItemBySerPtr(&buffer[s][9+(6*i)]);	// the item to sell
			if (!pSell) continue;
			amt=ShortFromCharPtr(&buffer[s][9+(6*i)+4]);
			
			// player may have taken items out of his bp while the sell menu was up ;-)
			if (pSell->amount<amt)
			{
				npctalkall(Vendor, "Cheating scum! Leave now, before I call the guards!",0);
				return;
			}

			// Search the buy restock Container
			P_ITEM iJoin = NULL;
			ci=0,loopexit=0;
			P_ITEM pi;

			if (iNpa!=NULL)
			{
				while ( ((pi=iNpa->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
				{
					if (items_match(pi,pSell))
						iJoin = pi;
				}
			}

			// Search the sell Container to determine the price
			ci=0,loopexit=0;
			if (iNpc!=NULL)
			{
				while ( ((pi=iNpc->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
				{
					if (items_match(pi,pSell))
					{
						value=pi->calcSellPrice(Vendor->region,pSell);
						break;	// let's take the first match
					}
				}
				totgold+=(amt*value);	// add to the bill
			}

			if (iJoin!=NULL)	// The item goes to the container with restockable items
			{
				iJoin->amount+=amt;
				iJoin->restock-=amt;
				pSell->ReduceAmount(amt);
			}
			else
			{
				if (iNpb!=NULL)
				{
					pSell->SetContSerial(iNpb->serial);
					SndRemoveItemToAll(pSell);
					if (pSell->amount!=amt)
						Commands->DupeItem(ps, pSell, pSell->amount-amt);
				}
			}
		}
		addgold(s, Player, totgold);
		goldsfx(s, totgold);	// Dupois, SFX for gold movement	// Added Oct 08, 1998
	}

	SndClearTrade(s,serial);
}

P_ITEM tradestart(UOXSOCKET s, P_CHAR pc)
{
	if (!pc) return NULL;
	unsigned char msg[90];
	P_CHAR Player = MAKE_CHARREF_LRV(currchar(s),NULL);

	P_ITEM Pack1 = Packitem(Player);
	P_ITEM Pack2 = Packitem(pc);
	int s2=pc->calcSocket();

	if (!Pack1)
	{
		sysmessage(s,"Time to buy a backpack!");
		sprintf(temp,"%s doesnt have a backpack!",Player->name);
		sysmessage(s2,temp);
		return 0;
	}

	if (!Pack2)
	{
		sysmessage(s2,"Time to buy a backpack!");
		sprintf(temp,"%s doesnt have a backpack!",pc->name);
		sysmessage(s,temp);
		return 0;
	}

	P_ITEM TrWin1=Items->SpawnItem(Player,1,"#",0,0x1E5E,0,0);
	if (!TrWin1) return 0;//AntiChrist to preview crashes
	TrWin1->pos.x=26;
	TrWin1->pos.y=0;
	TrWin1->pos.z=0;
	TrWin1->setType(ITY_Container);
	TrWin1->dye=0;
	Player->Wear(TrWin1,0);
	sendbpitem(s, TrWin1);
	if (s2!=-1) sendbpitem(s2, TrWin1);

	P_ITEM TrWin2=Items->SpawnItem(pc,1,"#",0,0x1E5E,0,0);
	if (!TrWin2) return 0;//AntiChrist to preview crashes
	TrWin2->pos.x=26;
	TrWin2->pos.y=0;
	TrWin2->pos.z=0;
	TrWin2->setType(ITY_Container);
	TrWin2->dye=0;
	pc->Wear(TrWin2,0);
	sendbpitem(s, TrWin2);
	if (s2!=-1) sendbpitem(s2, TrWin2);

	TrWin2->setMoreB1_4(TrWin1->serial);
	TrWin1->setMoreB1_4(TrWin2->serial);
	TrWin2->morez=0;
	TrWin1->morez=0;

	msg[0]=0x6F; // Header Byte
	msg[3]=0; // Initiate
	LongToCharPtr(pc->serial,msg+4);
	LongToCharPtr(TrWin1->serial,msg+8);
	LongToCharPtr(TrWin2->serial,msg+12);
	msg[16]=1;
	strcpy((char*)&(msg[17]),pc->name);

	XStartPkt(0x6F, 47);
	XAddPkt(&msg[0+3], 47-3);
	XFinishPkt(s);

	if (s2 >= 0)
	{
		msg[0]=0x6F; // Header Byte
		msg[1]=0; // Size	
		LongToCharPtr(Player->serial,msg+4);
		LongToCharPtr(TrWin2->serial,msg+8);
		LongToCharPtr(TrWin1->serial,msg+12);
		msg[16]=1;
		strcpy((char*)&(msg[17]),Player->name);

		XStartPkt(0x6F, 47);
	    XAddPkt(&msg[0+3], 47-3);
	    XFinishPkt(s2);	
	}
	return TrWin1;
}

void clearalltrades()
{
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->isType(ITY_Container) && pi->pos.x==26 && pi->pos.y==0 && pi->pos.z==0 &&
			pi->id()==0x1E5E)
		{
			P_CHAR pc=FindWearerOf(pi);
			P_ITEM Pack=Packitem(pc);
			if (Pack)
			{
				int ci=0,loopexit=0;
				P_ITEM pj;
				while ( ((pj=pi->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
				{
					pj->SetContSerial(Pack->serial);
				}
			}
			Items->DeleItem(pi->unconst());
			Console.send("Trade cleared\n");
		}
	}
}

void trademsg(int s)
{
	P_ITEM Cont1,Cont2;
	Cont1 = FindItemBySerPtr(&buffer[s][4]);

	switch(buffer[s][3])
	{
	case 0://Start trade - Never happens, sent out by the server only.
		break;
	case 2://Change check marks. Possibly conclude trade
		if (!Cont1) return;

		Cont2 = FindItemBySerial(Cont1->getMoreB1_4());
		if (!Cont2) return;
		
		Cont1->morez=buffer[s][11];
		sendtradestatus(Cont1, Cont2);
		if (Cont1->morez && Cont2->morez)
		{
			dotrade(Cont1, Cont2);
			endtrade(Cont1);
		}
		break;
	case 1://Cancel trade. Send each person cancel messages, move items.
		endtrade(Cont1);
		break;
	default:
		LogError("Fallout of switch");
	}
}

void dotrade(P_ITEM Trade1, P_ITEM Trade2)
{
	if (!Trade1 || !Trade2) return;

	P_CHAR Player1 = FindWearerOf(Trade1);
	P_CHAR Player2 = FindWearerOf(Trade2);
	if (!Player1 || !Player2) return;

	if (Trade1->morez==0 || Trade2->morez==0)
	{//not checked - give items to previous owners - AntiChrist
		P_CHAR Pt;
		Pt=Player1;
		Player1=Player2;
		Player2=Pt;
	}

	P_ITEM Pack1 = Packitem(Player1);
	P_ITEM Pack2 = Packitem(Player2);
	if (!Pack1 || !Pack2) return;

	int s1 = Player1->calcSocket();
	int s2 = Player2->calcSocket();


	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Trade1->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		pi->SetContSerial(Pack2->serial);
		if (pi->glow>0)
		{
			Player1->removeHalo(pi);
			Player2->addHalo(pi);
		}
		pi->SetRandPosInCont(Pack2);
		if (s1!=-1)
			pi->refresh();
		if (s2!=-1) sendbpitem(s2, pi);
		pi->refresh();
	}
	ci=0;loopexit=0;
	while ( ((pi=Trade2->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		pi->SetContSerial(Pack1->serial);
		if (pi->glow>0)
		{
			Player2->removeHalo(pi);
			Player1->addHalo(pi);
		}
		pi->SetRandPosInCont(Pack1);
		if (s2!=-1)
			pi->refresh();
		if (s1!=-1) sendbpitem(s1, pi);
		pi->refresh();
	}
}

