/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __ACCOUNTS_H__
#define __ACCOUNTS_H__


// Authenticate return codes

#define LOGIN_NOT_FOUND -3
#define BAD_PASSWORD -4
#define ACCOUNT_BANNED -5
#define ACCOUNT_WIPE -6

enum online_status {ON,OFF,DELAYED};

#include "platform.h"
#include "defines.h"
#include "netsys.h"	// for SOCKET

#include <string>
#include <map>
#include <vector>
#include <list>
#include <fstream>
#include <sys/stat.h>

#include "typedefs.h"

using namespace std;

struct account_st
{
	unsigned int number;
	string name;
	string pass;
	bool ban;
	bool remoteadmin;
	int lastused;
};

struct player_struct
{
   int serial;
   online_status stat;
};

class account_playerlist
{
   public:	
    void init()                                    { players.clear(); playerselected=-1;}
	account_playerlist::account_playerlist(void )  { this->init();   }
	account_playerlist::~account_playerlist(void ) { players.clear();}	

	int getplayeronline(void)
	{
		return 0;
	}

	int getplayerunderdelayedlogout(void)
	{
		return 0;
	}

	void addPlayerInitialy(player_struct &p) { players.push_back(p); } // only call this one once(!) at server start when the list of players per account is created

	void FirstPlayerListIter(player_struct& ps, bool &end) 
	{ 
	  litty=players.begin(); 
	  if (players.size()>0) 
	  { 
		end=false; 
		ps=*litty;
	  }
	  else end=true; 	  	  
	}

	void NextPlayerListIter(player_struct& ps, bool &end) 
	{ 
		++litty; 
		if (litty!=players.end()) 
		{
		  end=false;
		  ps=*litty;
		}
		else end=true;
	}

	void EraseCurrentIteratedPlayer(void) { players.erase(litty); } // erase player that is in current First/next iteration

   private:
	  list<player_struct> players;  // serial+status
	  int playerselected;	        // remember which of the max 5 players logged in last. (serial)
	  list<player_struct>::iterator litty;

};

class connectionAccountSt
{
  public:
	  int account;
	  const SOCKET TheSock;
	  bool firstpacket;
	  bool gameserver;
	  connectionAccountSt::connectionAccountSt(SOCKET Sck):account(-1), TheSock(Sck),firstpacket(false), gameserver(false)  { ; }
	  bool operator== (const connectionAccountSt& elem) const { return elem.TheSock == TheSock; }
	  bool operator!= (const connectionAccountSt& elem) const { return elem.TheSock != TheSock; } // gcc 2.95's stl seriously needs == AND(!!!) != for find algorithm

};

class cAccount
{
private:

	map<string, account_st> acctlist;
	map<int, string> acctnumbers_sp;

	// to be removed/changed
	struct acctman_st
	{
		bool online;
		CHARACTER character;
	};
	// to be removed changed
	map<int, acctman_st> acctman; // to be removed

	map<int, account_playerlist* > acctplayer;

	int lastusedacctnum;
	unsigned int unsavedaccounts;
	unsigned int saveratio;

	void LoadAccount ( int acctnumb );

public:
	unsigned int lasttimecheck;

	cAccount( void );
	~cAccount( void );
	void SetSaveRatio ( int );

	void InitPlayerAccountShadow(void); // to add
	void RemovePlayerFromAccountShadow(P_CHAR Player);
	void AddPlayerToAccountShadow(P_CHAR Player);

	// to be removed/changed
	CHARACTER GetInWorld( int );
	void SetOnline( int, P_CHAR Player );
	void SetOffline( int acctnum );
	bool IsOnline( int );
	////

	void LoadAccounts( void );
	void SaveAccounts( void );
	void CheckAccountFile(void);
	int Count();
	bool RemoteAdmin(int acctnum);
	signed int Authenticate(string username, string password);
	unsigned int CreateAccount(string username, string password);
	bool ChangePassword(unsigned int number, string password);
	void SetLastUsed(unsigned int number, int day);
	void AddGift(int gift_scp_num);
	void RemoveAccount(int acctnum);
	bool CheckExistence(char* username); //Thrawn
	P_CHAR GetCurrentPlayer(int acct);

};


#endif // __ACCOUNTS_H__

