/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "admin.h"

#include <fstream>
#include "basics.h"
#include "mapS.h"
#include "mapstuff.h"

using namespace std ;

#include "wolfpack.h"
#include "debug.h"
#undef DBGFILE
#define DBGFILE "admin.cpp"

cAdmin::cAdmin()
{
	;
}

bool cAdmin::loadstart_helper(const char* sect, unsigned char num)
{
	if (num>=MAXSTART) return false;

   	if (!i_scripts[startlocs_scp]->find(sect)) return false;

	int entries=0;
	int loopexit=0;
	do
	{
		read1();
		if ( strcmp(script1, "}") )
		{
			if (entries<=4)
			{
				strcpy(start[num][entries], script1);			  
			}
			entries++;			
		}
	}
	while ( (strcmp(script1, "}")) && (++loopexit < MAXLOOPS) );

	if (entries!=5) return false;

	return true;
}

bool cAdmin::loadStartlocations()
{
	openscript("startlocs.scp");

	//int loopexit=0;
	//int entries=0;
	bool ok ;

	ok = loadstart_helper("STARTLOCATION_YEW", 0);
	if (!ok) { closescript();  return false; }

	ok = loadstart_helper("STARTLOCATION_MINOC", 1);
	if (!ok) { closescript();  return false; }

	ok = loadstart_helper("STARTLOCATION_BRITAIN", 2);
	if (!ok) { closescript();  return false; }

	ok = loadstart_helper("STARTLOCATION_MOONGLOW", 3);
	if (!ok) { closescript(); return false; }

	ok = loadstart_helper("STARTLOCATION_TRINSIC", 4);
	if (!ok) { closescript(); return false; }

	ok = loadstart_helper("STARTLOCATION_MAGICINA", 5);
	if (!ok) { closescript(); return false; }

	ok = loadstart_helper("STARTLOCATION_JHOLM", 6);
	if (!ok) { closescript(); return false; }

	ok = loadstart_helper("STARTLOCATION_SKARA_BRAE", 7);
	if (!ok) { closescript(); return false; }

	ok = loadstart_helper("STARTLOCATION_VESPER", 8);
	if (!ok) { closescript(); return false; }

	//for (int a=0; a<MAXSTART; a++) printf("%s %s %s %s %s\n",start[a][0], start[a][1], start[a][2], start[a][3], start[a][4]);

	
	int a,x,y;
	
	int Mapnum=0; // needs correct map of course if multiple maps get implemented
    int mWidth  = AllMaps->GetMapWidth(Mapnum);
	int mHeight = AllMaps->GetMapHeight(Mapnum);
	
    for (a=0; a<MAXSTART; a++)
	{	
		x = makenum2(start[a][2]);
		y = makenum2(start[a][3]); 		
		
		if ( (x / 8) >= mWidth || (y / 8) >= mHeight )
		{ 
			strcpy(start[a][2], "666");
			LogWarning("A Startlocation has invalid Coords, correcting, plz check startlocation.scp");
		}
	}
	
    closescript();
    return true;
}

// LB's autodetect muls stuff
bool cAdmin::setMulnames()
{
	char *muldir=NULL;
	
	char slash='/'; // linux slash
#ifndef __unix__ 
	slash = '\\'; // windows slash
#endif
	
	char *UO2d_path = new char[300], *UO3d_path = new char[300];
	
	if (SrvParms->mul_autodetect)
	{
#ifndef __unix__ 
		
		HKEY tempKey;
		
		DWORD pathLength1 = 300, pathLength2 = 300;
		char strTarget[300];
		char t1,t2;
		bool uo3d, t2a;     
		char *t3d_registry = "Software\\Origin Worlds Online\\Ultima Online Third Dawn\\1.0";
		char *t2a_registry = "Software\\Origin Worlds Online\\Ultima Online\\1.0";
		char *strValue     = "ExePath";
		
		t2a=0;
		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, t2a_registry, 0, KEY_READ, &tempKey) != ERROR_SUCCESS) t1=0; else t1=1;
		if (t1) if (RegQueryValueEx(tempKey, strValue, 0, 0, (LPBYTE)strTarget, &pathLength1) != ERROR_SUCCESS) t2a=0; else t2a=1 ;	
		RegCloseKey(tempKey);
		strcpy(UO2d_path, strTarget);
		int len = strlen(UO2d_path); 
		if (len<11 || len>299) len=20;
		UO2d_path[len-11]=0; // assuming client.exe name never changes, cutting of \client.exe
		
		uo3d=0;
		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, t3d_registry, 0, KEY_READ, &tempKey) != ERROR_SUCCESS) t2=0; else t2=1;
		if (t2) if (RegQueryValueEx(tempKey, strValue, 0, 0, (LPBYTE)strTarget, &pathLength2) != ERROR_SUCCESS) uo3d=0; else uo3d=1 ;	
		RegCloseKey(tempKey);
		strcpy(UO3d_path, strTarget);
		len = strlen(UO3d_path); 
		if (len<9 || len>299) len=20;
		UO3d_path[len-9]=0; // cutting of \uotd.exe
		
		
		if (t2a) muldir = UO2d_path;        // t2a only or t2a+3d installed -> pick t2a dir for muls
		else if (uo3d) muldir = UO3d_path;  // only 3d installed, well, pick 3d client dir   
		else 
		{
			LogWarning("mul autodetection failed, no UO installation found. Set path to mul files manually\n"); 
			muldir = SrvParms->mulpath;
		}	   
		
#else
		muldir = SrvParms->mulpath;
		LogWarning("mul autodetection doesn't work under Linux\n");
#endif
	}
	
	else
	{
		muldir = SrvParms->mulpath;
	}
	
	bool slash_at_end = (muldir[strlen(muldir)-1]==slash);
	
	if (!slash_at_end) 
	{ 
		int l=strlen(muldir)-1;
		muldir[l+1]=slash;
		muldir[l+2]=0;
	}
	
	strcpy(SrvParms->completemulpath, muldir);
	
	if (UO2d_path!=NULL) delete [] UO2d_path;
	if (UO3d_path!=NULL) delete [] UO3d_path;		
	
	
    return true;
}

bool cAdmin::resolveClientRelayAdress()
{
		     
	// name resovling of server-address, LB 7-JULY 2000

	unsigned long ip;		
	sockaddr_in m_sin;
	hostent *hpe;
		
    m_sin.sin_family = AF_INET;   	 
	ip = inet_addr(serv.sIP.c_str());

	Console.send("\n");
		
	if (ip == INADDR_NONE) // adresse-name instead of ip adress given ! trnslate to ip string
	{
		Console.send("client relay host: %s\n", serv.sIP.c_str());
		hpe = gethostbyname(serv.sIP.c_str());
			
		if (hpe == NULL)  
		{ 				  
              #if	defined(__unix__)
				// We should be able to use the xti error functions, cant find them so...
				// sprintf(temp,"warning: %d resolving name: %s\n", t_srerror(t_errno),name) ;
				sprintf(temp, "warning: Error resolving name: %s : %s\n", serv.sIP.c_str(), hstrerror(h_errno));
              #else 
				sprintf(temp, "warning: %d resolving name: %s\n", WSAGetLastError(), serv.sIP.c_str());
              #endif	   
				LogWarning(temp);
				LogWarning("switching to localhost\n");				
				//Console.send(temp);
				//Console.send("switching to localhost\n");
				serv.sIP = "127.0.0.1";
		}
		else
		{
				memcpy((char*)&(m_sin.sin_addr), hpe->h_addr, hpe->h_length);
				
				serv.sIP = sock_ntop ( m_sin );
		} // end else resolvable
	}

	Console.send("client relay IP: %s\n", serv.sIP.c_str());	
	Console.send("gameserver port: %i\n\n", serv.uiPort);
	
	// end name resovling

  return true;
}


