/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

 //Boats->cpp by Zippy Started on 7/12/99

// Mapregion stuff + boat-blocking corrected/touched by LB 7/24/99

#include "boats.h"

#include <iostream>
#include <cmath>
#include <assert.h>
using namespace std ;

#include "house.h"
#include "mapstuff.h"
#include "regions.h"
#include "SndPkg.h"
#include "multi.h"
#include "mapS.h"
#include "tiledata.h"
#include "walking.h"
#include "network.h"

#include "wolfpack.h"

//For iSizeShipOffsets->
#define PORT_PLANK 0
#define STARB_PLANK 1
#define HOLD 2
#define TILLER 3

//For iShipItems->
#define PORT_P_C 0//Port Plank Closed
#define PORT_P_O 1//Port Planl Opened
#define STAR_P_C 2//Starboard Plank Closed
#define STAR_P_O 3//Starb Plank Open
#define TILLERID 5//Tiller
#define HOLDID 4//Hold


#undef DBGFILE
#define DBGFILE "boats.cpp" 

#define X 0
#define Y 1

//============================================================================================
//UooS Item translations - You guys are the men! :o)

//[4]=direction of ship
//[4]=Which Item (PT Plank, SB Plank, Hatch, TMan)
//[2]=Coord (x,y) offsets
signed short int iSmallShipOffsets[4][4][2];

//  P1    P2   Hold  Tiller
signed short int iMediumShipOffsets[4][4][2];
// X  Y  X  Y  X  Y  X  Y
signed short int iLargeShipOffsets[4][4][2];
// X  Y  X  Y  X  Y  X  Y

//Ship Items
//[4] = direction
//[6] = Which Item (PT Plank Up,PT Plank Down, SB Plank Up, SB Plank Down, Hatch, TMan)
unsigned char cShipItems[4][6]=
{ 
	{(unsigned char)0xB1,(unsigned char)0xD5,(unsigned char)0xB2,(unsigned char)0xD4,(unsigned char)0xAE,(unsigned char)0x4E },
	{(unsigned char)0x8A,(unsigned char)0x89,(unsigned char)0x85,(unsigned char)0x84,(unsigned char)0x65,(unsigned char)0x53 },
	{(unsigned char)0xB2,(unsigned char)0xD4,(unsigned char)0xB1,(unsigned char)0xD5,(unsigned char)0xB9,(unsigned char)0x4B },
	{(unsigned char)0x85,(unsigned char)0x84,(unsigned char)0x8A,(unsigned char)0x89,(unsigned char)0x93,(unsigned char)0x50 },
};
//============================================================================================


static void sendinrange(P_ITEM pi)//Send this item to all online people in range
{//(Decided this was better than writing 1000 for loops to send an item.
	for (unsigned int a=0;a<now;a++)
	{
		if (perm[a])
		{
			if (iteminrange(a,pi,VISRANGE))
				senditem(a,pi);
		}
	}
}


bool cBoat::inmulti(const cCoord& pos, PC_ITEM iMulti)//see if they are in the multi at these chords (Z is NOT checked right now)
{
	if (!iMulti) return false;
	int LoopExit=0;
	singleMultiPart mult;

	assert(iMulti->id()>=0x4000);

	Multi->multiIteratorStart(iMulti->id()-0x4000);

	while (Multi->multiIteratorNext(mult) && ++LoopExit<MAXLOOPS)
	{
		if (iMulti->pos.x+mult.x == pos.x && iMulti->pos.y+mult.y == pos.y)
		{
			if (mult.visibility)
			{
				return true;
			}
			else
			{
				if (iMulti->isType(ITY_Boat))	// the hatch on a boat is not 'visible',
				{								// so let's search the dynamic items there
					PC_ITEM pi;
					int loopexit=0;
					RegGrid3x3Iterator4Items rg3ii(pos);
					while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
					{
						if (pi->pos.IsSameXY(pos))
							return true;
					}
				}
			}
		}
	}
	return false;
}

PC_ITEM findMulti(const cCoord& pos)
{
	int lastdist=30;	

	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->isMulti())
		{
			int ret = pos.distance(pi->pos);
			if (ret<=lastdist)
			{
				lastdist=ret;
				if (Boats->inmulti(pos, pi))
					return pi;
			}
		}
	}
	return NULL;
}

cBoat::cBoat()//Constructor
{
  /*
  //[4]=direction of ship
  //[4]=Which Item (PT Plank, SB Plank, Hatch, TMan)
  //[2]=Coord (x,y) offsets 
  */

  iSmallShipOffsets[0][0][0]=-2;
  iSmallShipOffsets[0][0][1]=0;
  iSmallShipOffsets[0][1][0]=2;
  iSmallShipOffsets[0][1][1]=0;
  iSmallShipOffsets[0][2][0]=0;
  iSmallShipOffsets[0][2][1]=-4;
  iSmallShipOffsets[0][3][0]=1;
  iSmallShipOffsets[0][3][1]=4;

  iSmallShipOffsets[1][0][0]=0;
  iSmallShipOffsets[1][0][1]=-2;
  iSmallShipOffsets[1][1][0]=0;
  iSmallShipOffsets[1][1][1]=2;
  iSmallShipOffsets[1][2][0]=4;
  iSmallShipOffsets[1][2][1]=0;
  iSmallShipOffsets[1][3][0]=-4;
  iSmallShipOffsets[1][3][1]=0;

  iSmallShipOffsets[2][0][0]=2;
  iSmallShipOffsets[2][0][1]=0;
  iSmallShipOffsets[2][1][0]=-2;
  iSmallShipOffsets[2][1][1]=0;
  iSmallShipOffsets[2][2][0]=0;
  iSmallShipOffsets[2][2][1]=4;
  iSmallShipOffsets[2][3][0]=0;
  iSmallShipOffsets[2][3][1]=-4;

  iSmallShipOffsets[3][0][0]=0;
  iSmallShipOffsets[3][0][1]=2;
  iSmallShipOffsets[3][1][0]=0;
  iSmallShipOffsets[3][1][1]=-2;
  iSmallShipOffsets[3][2][0]=-4;
  iSmallShipOffsets[3][2][1]=0;
  iSmallShipOffsets[3][3][0]=4;
  iSmallShipOffsets[3][3][1]=0;

  ///////////////////////////////////

  iMediumShipOffsets[0][0][0]=-2;
  iMediumShipOffsets[0][0][1]=0;
  iMediumShipOffsets[0][1][0]=2;
  iMediumShipOffsets[0][1][1]=0;
  iMediumShipOffsets[0][2][0]=0;
  iMediumShipOffsets[0][2][1]=-4;
  iMediumShipOffsets[0][3][0]=1;
  iMediumShipOffsets[0][3][1]=5;

  iMediumShipOffsets[1][0][0]=0;
  iMediumShipOffsets[1][0][1]=-2;
  iMediumShipOffsets[1][1][0]=0;
  iMediumShipOffsets[1][1][1]=2;
  iMediumShipOffsets[1][2][0]=4;
  iMediumShipOffsets[1][2][1]=0;
  iMediumShipOffsets[1][3][0]=-5;
  iMediumShipOffsets[1][3][1]=0;

  iMediumShipOffsets[2][0][0]=2;
  iMediumShipOffsets[2][0][1]=0;
  iMediumShipOffsets[2][1][0]=-2;
  iMediumShipOffsets[2][1][1]=0;
  iMediumShipOffsets[2][2][0]=0;
  iMediumShipOffsets[2][2][1]=4;
  iMediumShipOffsets[2][3][0]=0;
  iMediumShipOffsets[2][3][1]=-5;

  iMediumShipOffsets[3][0][0]=0;
  iMediumShipOffsets[3][0][1]=2;
  iMediumShipOffsets[3][1][0]=0;
  iMediumShipOffsets[3][1][1]=-2;
  iMediumShipOffsets[3][2][0]=-4;
  iMediumShipOffsets[3][2][1]=0;
  iMediumShipOffsets[3][3][0]=5;
  iMediumShipOffsets[3][3][1]=0;

  ///////////////////////////////////

  iLargeShipOffsets[0][0][0]=-2;
  iLargeShipOffsets[0][0][1]=-1;
  iLargeShipOffsets[0][1][0]=2;
  iLargeShipOffsets[0][1][1]=-1;
  iLargeShipOffsets[0][2][0]=0;
  iLargeShipOffsets[0][2][1]=-5;
  iLargeShipOffsets[0][3][0]=1;
  iLargeShipOffsets[0][3][1]=5;

  iLargeShipOffsets[1][0][0]=1;
  iLargeShipOffsets[1][0][1]=-2;
  iLargeShipOffsets[1][1][0]=1;
  iLargeShipOffsets[1][1][1]=2;
  iLargeShipOffsets[1][2][0]=5;
  iLargeShipOffsets[1][2][1]=0;
  iLargeShipOffsets[1][3][0]=-5;
  iLargeShipOffsets[1][3][1]=0;

  iLargeShipOffsets[2][0][0]=2;
  iLargeShipOffsets[2][0][1]=1;
  iLargeShipOffsets[2][1][0]=-2;
  iLargeShipOffsets[2][1][1]=1;
  iLargeShipOffsets[2][2][0]=0;
  iLargeShipOffsets[2][2][1]=5;
  iLargeShipOffsets[2][3][0]=0;
  iLargeShipOffsets[2][3][1]=-5;

  iLargeShipOffsets[3][0][0]=-1;
  iLargeShipOffsets[3][0][1]=2;
  iLargeShipOffsets[3][1][0]=-1;
  iLargeShipOffsets[3][1][1]=-2;
  iLargeShipOffsets[3][2][0]=-5;
  iLargeShipOffsets[3][2][1]=0;
  iLargeShipOffsets[3][3][0]=5;
  iLargeShipOffsets[3][3][1]=0;
 
  return;
}

cBoat::~cBoat()//Destructor
{
}

void cBoat::PlankStuff(UOXSOCKET s, P_CHAR Player, P_ITEM Plank)//If the plank is opened, double click Will send them here
{
	if (!Plank) return;

	P_ITEM Boat = FindItemBySerial(Plank->getMore1_4());
	if (!Boat) return;

	if (Boat->serial != Player->multis)	//They aren't on this boat, so make them enter
	{
		cCoord DeckPos = Boat->pos;
		DeckPos.Add(1,1,2);

		int ci=0,loopexit=0;
		P_CHAR Pet;
		while ( ((Pet=SearchOwnedPets(Player->serial,&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (Pet->npc && inrange1p(Player, Pet))
			{
				Pet->teleTo(DeckPos);
				Pet->SetMultiSerial(Boat->serial);	//Put all their Pets/Hirlings on the boat too
			}
		}
        OpenPlank(Plank); //lb

		Player->teleTo(DeckPos);
        Player->SetMultiSerial(Boat->serial);

		sysmessage(s,"you entered a boat");
	}
	else
	{
		if (Boat->type2)	// is the boat moving ?
			sysmessage(s,"You reconsider and do not jump overboard");
		else
			LeaveBoat(s,Player,Plank);//They are on a boat, get off
	}
}


void cBoat::LeaveBoat(UOXSOCKET s, P_CHAR Player, P_ITEM Plank)//Get off a boat (dbl clicked an open plank while on the boat.
{
	if (!Plank) return;

	int x,x2=Plank->pos.x;
	int y,y2=Plank->pos.y;
	signed char z=Plank->pos.z,mz,sz,typ;

	PC_ITEM Boat = GetBoat(s);
	if (!Boat) return;
	
	for(x=x2-2;x<x2+3;x++)
	{
		for(y=y2-2;y<y2+3;y++)
		{
			cCoord chkPos(x,y,z,Boat->pos.map);
			sz = Map->StaticTop(chkPos,z); // MapElevation() doesnt work cauz we are in a multi !!
			mz = Map->MapElevation(chkPos);
			if (sz == illegal_z) 
				typ=0;
			else 
				typ=1;
			
			if ((typ==0 && mz!=5) || (typ==1 && sz!=-5))// everthing the blocks a boat is ok to leave the boat ... LB
			{
				cCoord newPos(x,y, typ ? sz : mz, Boat->pos.map);
				int ci=0,loopexit=0;
				P_CHAR Pet;
				while ( ((Pet=SearchOwnedPets(Player->serial,&ci)) != NULL) && (++loopexit < MAXLOOPS) )
				{
					if (Pet->npc && inrange1p(Player, Pet))
					{
						Pet->teleTo(newPos);//make all their Pets/Hirlings leave the boat too
						Pet->SetMultiSerial(-1);
					}
				}
				
		        Player->SetMultiSerial(-1);
				Player->teleTo(newPos); 
				
				sysmessage(s,"You left the boat.");			
				return;
			}
		}//for y
	}//for x
	sysmessage(s,"You cannot get off here!");
}

void cBoat::OpenPlank(P_ITEM Plank)//Open, or close the plank (called from keytarget() )
{
	if (Plank==NULL) return;
	switch (Plank->id())
	{
		//Open Plank->
	case 0x3EE9: Plank->setId(0x3E84); break;
	case 0x3EB1: Plank->setId(0x3ED5); break;
	case 0x3EB2: Plank->setId(0x3ED4); break;
	case 0x3E8A: Plank->setId(0x3E89); break;
	case 0x3E85: Plank->setId(0x3E84); break;
		//Close Plank->
	case 0x3E84: Plank->setId(0x3EE9); break;
	case 0x3ED5: Plank->setId(0x3EB1); break;
	case 0x3ED4: Plank->setId(0x3EB2); break;
	case 0x3E89: Plank->setId(0x3E8A); break;
	default:
		sprintf(temp,"WARNING: Invalid plank ID called! Plank '%s' [%x]\n",Plank->name,Plank->id());
		LogWarning( temp );
		break;
	}
	Plank->refresh();
}

bool cBoat::Build(UOXSOCKET s, P_CHAR Player, P_ITEM Boat, char id2, int scpno)//Build a boat! (Do stuff NESSICARY for boats, called from buildhouse() )
{
	if (!Boat || !Player) 
	{
		sysmessage(s, "There was an error creating that boat.");
		return false;
	}
	
	int nid2=id2;
	const tileData *tile;
	cellData map;
	const landData *land;

	if (id2!=0x00 && id2!=0x04 && id2!=0x08 && id2!=0x0C && id2!=0x10 && id2!=0x14)//Valid boat ids (must start pointing north!)
	{
		sysmessage(s, "The deed is broken, please contact a Game Master.");
		return false;
	}
	//Start checking for a valid possition:

	AllMaps->SeekMap(Boat->pos, map);

	switch(map.TID)
	{
	//water tiles:
	case 0x00A8:
	case 0x00A9:
	case 0x00AA:
	case 0x00Ab:
	case 0x0136:
	case 0x0137:
	case 0x3FF0:
	case 0x3FF1:
	case 0x3FF2:
	case 0x2FF3:
		break;
	//Lava tiles:
	case 0x01F4:
	case 0x01F5:
	case 0x01F6:
	case 0x01F7:
		break;
	default:
		tile = TileData->SeekTile(ShortFromCharPtr(&(buffer[s][0x11])));
		if (!(strstr((char *) tile->name, "water") || strstr((char *) tile->name, "lava")))
		{
			land = TileData->SeekLand(map.TID);	
			if (!(TileData->isWet(land->flags)))//not a "wet" tile
			{
				sysmessage(s, "You cannot place your boat there.");
				return false;
			}
		}
	}
	
	// Okay we found a good  place....

	Boat->more1=id2;//Set min ID
	Boat->more2=nid2+3;//set MAX id
	Boat->setType(ITY_Boat);
	Boat->pos.z=-5;//Z in water
	strcpy(Boat->name,"a mast");//Name is something other than "%s's house"
	
	P_ITEM Tiller=Items->SpawnItem(Player,1,"a tiller man",0,0x3E4E,0,0);
	if ( !Tiller ) return false;
	Tiller->setMore1_4(Boat->serial);//Lock this item!
	Tiller->pos=Boat->pos;
	Tiller->decayOff();
	Tiller->SetMultiSerial(Boat->serial);

	P_ITEM RightPlank=Items->SpawnItem(Player,1,"#",0,0x3EB2,0,0);//Plank2 is on the RIGHT side of the boat
	if ( !RightPlank ) return false;
	RightPlank->setType(ITY_Boat);
	RightPlank->type2=3;
	RightPlank->setMore1_4(Boat->serial);//Lock this item!
	RightPlank->pos=Boat->pos;
	RightPlank->decayOff();
	RightPlank->SetMultiSerial(Boat->serial);

	P_ITEM LeftPlank=Items->SpawnItem(Player,1,"#",0,0x3EB1,0,0);//Plank1 is on the LEFT side of the boat
	if ( !LeftPlank ) return false;
	LeftPlank->setType(ITY_Boat);//Boat type
	LeftPlank->type2=3;//Plank sub type
	LeftPlank->setMore1_4(Boat->serial);//Lock this item!
	LeftPlank->pos=Boat->pos;
	LeftPlank->decayOff();
	LeftPlank->SetMultiSerial(Boat->serial);

	P_ITEM Hold=Items->SpawnItem(Player,1,"#",0,0x3EAE,0,0);
	if ( !Hold ) return false;
	Hold->setMore1_4(Boat->serial);//Lock this too :-)
	Hold->setType(ITY_Container);
	Hold->pos=Boat->pos;
	Hold->decayOff();
	Hold->SetMultiSerial(Boat->serial);
	
	Boat->setMoreB1_4(Tiller->serial);//Tiller ser stored in boat's Moreb
	Boat->morex=LeftPlank->serial;//Store the other stuff anywhere it will fit :-)
	Boat->morey=RightPlank->serial;
	Boat->morez=Hold->serial;
	Boat->setMore3_4(scpno);	// remember the script number for drydocking
	
	switch(id2)//Give everything the right XY for it size boat
	{
	case 0x00:
	case 0x04:
		Tiller->pos.Add(1,4);
		RightPlank->pos.Add(2);
		LeftPlank->pos.Add(-2);
		Hold->pos.Add(0,-4);
		break;
	case 0x08:
	case 0x0C:
		Tiller->pos.Add(1,5);
		RightPlank->pos.Add(2);
		LeftPlank->pos.Add(-2);
		Hold->pos.Add(0,-4);
		break;
	case 0x10:
	case 0x14:
		Tiller->pos.Add(1,5);
		RightPlank->pos.Add(2,-1);
		LeftPlank->pos.Add(-2,-1);
		Hold->pos.Add(0,-5);
		break;
	}
	mapRegions->Add(Tiller);//Make sure everything is in da regions!
	mapRegions->Add(LeftPlank);
	mapRegions->Add(RightPlank);
	mapRegions->Add(Hold);
	mapRegions->Add(Boat);
	
	//their x pos is set by BuildHouse(), so just fix their Z...
	Player->pos.z = Player->dispz = Boat->pos.z+3;//Char Z, try and keep it right.
	Player->SetMultiSerial(Boat->serial);
	Boat->refresh();
	return true;
}

PC_ITEM cBoat::GetBoat(UOXSOCKET s)//get the closest boat to the player and check to make sure they are on it
{	
	P_CHAR Player=MAKE_CHARREF_LRV(currchar(s),NULL);

    if (Player->multis>0) return FindItemBySerial( Player->multis );
    else if (Player->multis==-1) return NULL;
	else return findBoatAt(Player->pos);
}

/////////////
// name:	IsFreeWater
// purpose:	check if a boat(-part) could move onto this tile
// history:	by Duke, 11.10.03
//
static bool IsFreeWater2(short x, short y, signed char z)
{
	cellData map;
	cCoord c(x,y,0,0); // Note needs change when multiple maps supported
	AllMaps->SeekMap(c, map);	
	const landData *land = TileData->SeekLand(map.TID);
	bool TileIsWet=false, Obstacle=false, MapIsWet = TileData->isWet(land->flags);

	int loopexit=0;
	cellData stat;
	AllMaps->mapStaticIteratorStart(c);
	while ( (AllMaps->mapStaticIteratorNext(stat)) && (++loopexit < MAXLOOPS) )
	{			
		const tileData *tile = TileData->SeekTile(stat.TID);
		if (z==-5 && stat.z < -50)	// I found brick arches in a depth of -88 z near the coastline (eg. x=3522 y=2901) (Duke)
			continue;				// as we don't have submarines, skip them
		if (TileData->isWet(tile->flags))
			TileIsWet = true;
		else
			Obstacle = true;
		if (MapIsWet && Obstacle)		// ANY other static on the sea will block
			return false;
	}
	if ((MapIsWet || TileIsWet) && !Obstacle) return true;	// found something to swim on

	return false;
}

/////////////
// name:	IsFreeWater
// purpose:	check if a boat(-part) could move onto this tile
// history:	cut from cBoat::Block() by Duke, 29.9.03
//

// DO NOT DELETE, just avoiding compilition of currently(!) unused code

/*
static bool IsFreeWater(short x, short y, signed char z)
{
	int sz=Map->StaticTop(x,y,z);
	if (sz==illegal_z)	// map-tile
	{
		cellData map;
		cCoord c(x,y,0,0); // Note needs change when multiple maps supported
		AllMaps->SeekMap(c, map);	
		const landData *land = TileData->SeekLand(map.TID);
		if (!TileData->isWet(land->flags)) return false;
	} 
	else	// static-tile
	{ // go through all statics of a given x,y...
		cCoord c(x,y,0,0); // NOTE: needs to be changed when implenting muliple maps
		
		int loopexit=0;
		cellData stat;
		AllMaps->mapStaticIteratorStart(c);
		while ( (AllMaps->mapStaticIteratorNext(stat)) && (++loopexit < MAXLOOPS) )
		{			
			const tileData *tile = TileData->SeekTile(stat.TID);
			int zt=stat.z+tile->height;
			
			//for this part...: Bridges can be shown not valid,
			//so we will keep setting false until we hit a valid point,
			//when we hit a valid place, we'll stop, leave block as it was, 
			//if all points are invalid, block is true and we exit as normal.

			if (!(TileData->isWet(tile->flags)) && zt<=70)// every static tile with z>70 (mast height?) doesnt block, no matter what water-bit is has
				return false;
			else if (strcmp((char*)tile->name, "water"))
				return false;
		}
	}
	return true;
}
*/

enum eBoatTypes
{
	SmallBoat=1, MediumBoat, LargeBoat, InvalidBoat
};

static eBoatTypes BoatType(short id)
{
	switch (id&0xFFFC)	// ignore the bits for other dirs than north
	{
	case 0x4000:
	case 0x4004:	return SmallBoat;
	case 0x4008:
	case 0x400C:	return MediumBoat;
	case 0x4010:
	case 0x4014:	return LargeBoat;
	default:		return InvalidBoat;
	}
}

/*
static int LengthOfShip(eBoatTypes size)
{
	switch (size)
	{
	case SmallBoat:	return 10;
	case MediumBoat:return 11;
	case LargeBoat:	return 12;
	default:		return 222;
	}
}
*/

static int FrontOffset(eBoatTypes size)
{
	switch (size)
	{
	case SmallBoat:	return 5;
	case MediumBoat:return 5;
	case LargeBoat:	return 6;
	default:		return 44;
	}
}
static int RearOffset(eBoatTypes size)
{
	switch (size)
	{
	case SmallBoat:	return 4;
	case MediumBoat:return 5;
	case LargeBoat:	return 5;
	default:		return 33;
	}
}
// turns a vector by +90 degrees, ie. (-2,4) becomes (4,2)
static void RotateRight(short &x, short &y)
{
	short t = x;
	x=y; y=t;	// swap x and y
	y *= -1;
}

////////////
// name:	IsMovingBlocked
// purpose:	Check to see if the boat is blocked in front of, behind, or next to it (Depending on direction)
// history:	by Duke, 30.9.03
// remark:	this is 'work in progress'.
//
bool cBoat::IsMovingBlocked(P_ITEM Boat, int dir)
{
	int relDir = ((dir+8)-Boat->dir)&0x07;	// 1. calc relative dir of movement ie. forward,right,...
	eBoatTypes BoatSize = BoatType(Boat->id());

	short x1,y1,x2,y2;
	switch (relDir)	// 2. get the line of tiles to check for a ship pointing north
	{
	case 0:	x1=-2; x2=+2; y1=FrontOffset(BoatSize)+1;	y2=FrontOffset(BoatSize)+1;		break;	// forward
	case 2:	x1=+3; x2=+3; y1=FrontOffset(BoatSize)+1;	y2=-(RearOffset(BoatSize)+1);	break;	// sideways right
	case 4:	x1=-2; x2=+2; y1=-(RearOffset(BoatSize)+1);	y2=-(RearOffset(BoatSize)+1);	break;	// backward
	case 6:	x1=-3; x2=-3; y1=FrontOffset(BoatSize)+1;	y2=-(RearOffset(BoatSize)+1);	break;	// sideways left
	}

	// 3. now turn that line corresponding to the dir the boat actually is pointing to
	// fall-through is intentional; to turn west, we need to rotate three times
	switch (Boat->dir)
	{
	case 6:	RotateRight(x1,y1);	RotateRight(x2,y2);	// west
	case 4:	RotateRight(x1,y1);	RotateRight(x2,y2);	// south
	case 2:	RotateRight(x1,y1);	RotateRight(x2,y2);	// east
	}

	// 4. adjust the line to current boat position
	// (on the UO map, y runs a bit differently than in a mathematical coord system ;) (Duke)
	x1 += Boat->pos.x;
	y1 = Boat->pos.y + (-1*y1);
	x2 += Boat->pos.x;
	y2 = Boat->pos.y + (-1*y2);

	// 5. check the tiles on that line

	bool Xline = false;
	int length = abs(y1-y2);
	if (y1==y2)
	{
		Xline = true;
		length = abs(x1-x2);
	}

	short x=min(x1,x2);
	short y=min(y1,y2);

	int MapNum=0; // get world # , needs to be changed if multi map support gets in
	int max_x = AllMaps->GetMapWidth(MapNum) * 8;
	int max_y = AllMaps->GetMapHeight(MapNum) * 8;
	if (x < 1 || x+length > max_x || y < 1 || y+length > max_y)
		return true;	// parts of the line would be outside the map

	int i;
	for (i=0;i<=length;i++)
	{
		if (Xline)
		{
			if (!IsFreeWater2(x+i,y,Boat->pos.z)) return true;
		}
		else
		{
			if (!IsFreeWater2(x,y+i,Boat->pos.z)) return true;
		}
	}
	return false;
}

////////////
// name:	IsTurningBlocked
// purpose:	Check if the boat is blocked to turn left or right (Depending on direction)
// history:	by Duke, 10.10.03
// remark:	this is 'work in progress'.
//
bool cBoat::IsTurningBlocked(P_ITEM Boat, int turningright)
{
	eBoatTypes BoatSize = BoatType(Boat->id());

	// determine the bounding rectangle for both old and new position for a ship pointing north
	short x1=0,y1=0,x2=0,y2=0;	// lower left, upper right corner
	y1=-RearOffset(BoatSize);
	y2=+FrontOffset(BoatSize);
	if (turningright)
	{
		x1=-RearOffset(BoatSize);
		x2=+FrontOffset(BoatSize);
	}
	else
	{
		x1=-FrontOffset(BoatSize);
		x2=+RearOffset(BoatSize);
	}

	// now turn that line corresponding to the dir the boat actually is pointing to
	// fall-through is intentional; to turn east, we need to rotate three times
	switch (Boat->dir)
	{
	case 6:	RotateRight(x1,y1);	RotateRight(x2,y2);	// east
	case 4:	RotateRight(x1,y1);	RotateRight(x2,y2);	// south
	case 2:	RotateRight(x1,y1);	RotateRight(x2,y2);	// west
	}

	short x = Boat->pos.x+min(x1,x2);	// get the lower left corner after rotation
	short y = Boat->pos.y+min(y1,y2);
	short Xlength = abs(x1-x2);
	short Ylength = abs(y1-y2);

	int MapNum=0; // get world # , needs to be changed if multi map support gets in
	int max_x = AllMaps->GetMapWidth(MapNum) * 8;
	int max_y = AllMaps->GetMapHeight(MapNum) * 8;
	if (x < 1 || x+Xlength > max_x || y < 1 || y+Ylength > max_y)
		return true;	// parts of the rectangle would be outside the map

	int i,j;
	for (i=0;i<=Xlength;i++)
	{
		for (j=0;j<=Ylength;j++)
		{
			if (!IsFreeWater2(x+i,y+j,Boat->pos.z))
				return true;
		}
	}
	return false;
}

void cBoat::Move(UOXSOCKET s, int dir, P_ITEM Boat)
{//Move the boat and all it's items 1 square
	int tx=0,ty=0;
	unsigned int a;
	
	if (!Boat) return;

	P_ITEM Tiller = FindItemBySerial( Boat->getMoreB1_4() );
	if (!Tiller) return;
	
	GetXYfromDir(dir, &tx, &ty);

	if ((Boat->pos.x+tx<=200 && Boat->pos.y+ty<=200) || // 'permuda triangle'
		(Boat->pos.x+tx<=10 || Boat->pos.x+tx>=6000 || Boat->pos.y+ty<=10 || Boat->pos.y+ty>=4085))
	{
		Boat->type2=0;
		itemtalk(s,Tiller,"Arr, Sir, we've hit rough waters!");
		return;
	}
	if (IsMovingBlocked(Boat,dir))
	{
		Boat->type2=0;
		itemtalk(s, Tiller, "Arr, somethings in the way!");
		return;
	}

	Boat->MoveTo(Boat->pos, tx, ty);
	Boat->refresh();

	//Move all the special items and items on deck...
	vector<SERIAL> vecEntries = imultisp.getData(Boat->serial);
	for (a = 0; a < vecEntries.size(); a++)
	{
		P_ITEM pi = FindItemBySerial(vecEntries[a]);
		if (pi != NULL)
		{
			pi->MoveTo(pi->pos, tx, ty);
			sendinrange(pi);
		}
	}
	// ...and the passengers
	vecEntries.clear();
	vecEntries = cmultisp.getData(Boat->serial);
	for (a = 0; a < vecEntries.size(); a++)
	{
		P_CHAR pc_c = FindCharBySerial(vecEntries[a]);
		if (pc_c != NULL)
		{
			cCoord newPos(pc_c->pos);
			newPos.Add(tx,ty);
			pc_c->teleTo(newPos, false);
		}
	}
}

static void TurnPos(const cCoord& BoatPos, cCoord& StuffPos, int dir)	//Turn an item/pc that was on the boat when the boat was turned.
{
	int dx = StuffPos.x-BoatPos.x;//get their distance x
	int dy = StuffPos.y-BoatPos.y;//and distance Y
	
	StuffPos.x=BoatPos.x;
	StuffPos.y=BoatPos.y;
	
	if (dir)//turning right
	{
		StuffPos.Add(dy*-1,dx);
	}
	else
	{//turning left
		StuffPos.Add(dy,dx*-1);
	}
}

void cBoat::TurnStuff(P_ITEM Boat, P_ITEM pi, int dir)//Turn an item that was on the boat when the boat was turned.
{
	mapRegions->Remove(pi);
	TurnPos(Boat->pos, pi->pos, dir);
	mapRegions->Add(pi);
	sendinrange(pi);
}

void cBoat::TurnStuff(P_ITEM Boat, P_CHAR pc, int dir)//Turn a char that was on the boat when the boat was turned.
{
	cCoord old_pos=pc->pos;
	mapRegions->Remove(pc);
	TurnPos(Boat->pos, pc->pos, dir);
	mapRegions->Add(pc);
	teleport(pc, old_pos);
}

void cBoat::Turn(P_ITEM Boat, int turn)//Turn the boat item, and send all the people/items on the boat to turnboatstuff()
{
	if (!Boat) return;

	int id2=Boat->id2;
	int oldid2=Boat->id2;
	int olddir = Boat->dir;
	int dir;
	unsigned int a;
	
	//Of course we need the boat items!
	P_ITEM Tiller = FindItemBySerial(Boat->getMoreB1_4());
	if (!Tiller) return;
	P_ITEM LeftPlank = FindItemBySerial( Boat->morex );
	if (!LeftPlank) return;
	P_ITEM RightPlank = FindItemBySerial( Boat->morey );
	if (!RightPlank) return;
	P_ITEM Hold = FindItemBySerial( Boat->morez );
	if (!Hold) return;

	if (turn)//Right
	{
		Boat->dir+=2;
		id2++;
	}
	else
	{//Left
		Boat->dir-=2;
		id2--;
	}
	if (Boat->dir>7) Boat->dir-=4;//Make sure we dont have any DIR errors
	//if (Boat->dir<0) Boat->dir+=4;
	if (id2<Boat->more1) id2+=4;//make sure we don't have any id errors either
	if (id2>Boat->more2) id2-=4;//Now you know what the min/max id is for :-)
	
	Boat->id2=id2;//set the id

	if (Boat->id2==Boat->more1) Boat->dir=0;//extra DIR error checking
	if (Boat->id2==Boat->more2) Boat->dir=6;


//	if ( Block( Boat, 0, 0, Boat->dir ) )
	if (IsTurningBlocked(Boat,turn))
	{
		Boat->dir = olddir;
		Boat->id2 = oldid2;		

		for (a=0;a<now;a++)
		{
			if (perm[a])
			{
				if (iteminrange(a,Tiller,BUILDRANGE))
				{
					itemtalk( a, Tiller, "Arr, something's in the way!" );
				}
			}
		}
		return;
	}
	Boat->id2=id2;//set the id
	
	if (Boat->id2==Boat->more1) Boat->dir=0;//extra DIR error checking
	if (Boat->id2==Boat->more2) Boat->dir=6;    
		
		    
	vector<SERIAL> vecEntries = imultisp.getData(Boat->serial);
    for (a = 0; a < vecEntries.size(); a++)
	{
		P_ITEM pi = FindItemBySerial(vecEntries[a]);
		if (pi != NULL)
			TurnStuff(Boat,pi,turn);
	}

	vecEntries.clear();
	vecEntries = cmultisp.getData(Boat->serial);
	for (a = 0; a < vecEntries.size(); a++)
	{
		P_CHAR pc = FindCharBySerial(vecEntries[a]);
		if (pc != NULL)
			TurnStuff(Boat,pc,turn);
	}
	
	//Set the DIR for use in the Offsets/IDs array
	dir=(Boat->dir&0x0F)/2;

	//set it's Z to 0,0 inside the boat


	LeftPlank->id2=cShipItems[dir][PORT_P_C];//change the ID
	RightPlank->id2=cShipItems[dir][STAR_P_C];
	Tiller->id2=cShipItems[dir][TILLERID];
	Hold->id2=cShipItems[dir][HOLDID];

	// Hold and planks are already moved in turstuff()
	// now only the tillerman needs special treatment because he is 1 off in the norther position of the boat !!!
	// Duke, 31.10.2003
	switch(Boat->more1)//Now set what size boat it is and move the special items
	{
	case 0x00:
	case 0x04:
		Tiller->MoveTo(Boat->pos.x + iSmallShipOffsets[dir][TILLER][X], Boat->pos.y + iSmallShipOffsets[dir][TILLER][Y], Tiller->pos.z);
		break;

	case 0x08:
	case 0x0C:
		Tiller->MoveTo(Boat->pos.x + iMediumShipOffsets[dir][TILLER][X], Boat->pos.y + iMediumShipOffsets[dir][TILLER][Y], Tiller->pos.z);
		break;

	case 0x10:
	case 0x14:
		Tiller->MoveTo(Boat->pos.x + iLargeShipOffsets[dir][TILLER][X], Boat->pos.y + iLargeShipOffsets[dir][TILLER][Y], Tiller->pos.z);
		break;

	default:
		LogWarningVar("Turnboatstuff() more1 error! more1 = %c not found!",Boat->more1); 
	}

	sendinrange(LeftPlank);
	sendinrange(RightPlank);
	sendinrange(Hold);
	sendinrange(Tiller);
	Boat->refresh();
}

/////////////
// name:	speech
// pupose:	handle boat commands speech
// history:	by unknown
//			redesigned to separate parsing and actions (Duke, 15.9.03)
// remarks:	msg must already be capitalized
// returns:	0 = not a recognized cmd
//			1 = handled
//
char cBoat::Speech(UOXSOCKET s, P_CHAR Player, char *msg)//See if they said a command. 
{
	enum eBoatCmd
	{
		None=0,OneForward,SlowForward,Forward,OneBackward,SlowBackward,Backward,
		OneLeft,OneRight,Stop,Port,Starboard,ComeAbout
	};
	if (s<0 || s>=MAXCLIENT) return 0;

	PC_ITEM BoatC = GetBoat(s);
	if (!BoatC) return 0;//if they aren't on a boat, then we don't care what they said

	eBoatCmd Cmd=None;

	P_ITEM Tiller = FindItemBySerial(BoatC->getMoreB1_4());
	if (!Tiller) return 0;

	if (!inVisRange(Player->pos,Tiller->pos)) return 0;

	if (strstr(msg,"UNFURL SAIL") || strstr(msg,"RAISE ANCHOR"))
	{
		Cmd=Forward;
	}
	else if (strstr(msg,"ONE") || strstr(msg,"DRIFT"))
	{
		if (strstr(msg,"LEFT"))			Cmd=OneLeft;
		else if (strstr(msg,"RIGHT"))	Cmd=OneRight;
		else if (strstr(msg,"FORWARD"))	Cmd=OneForward;
		else if (strstr(msg,"BACK"))	Cmd=OneBackward;
	} 
	else if (strstr(msg,"SLOW"))
	{
		if (strstr(msg,"FORWARD"))		Cmd=SlowForward;
		else if (strstr(msg,"BACK"))	Cmd=SlowBackward;
	} 
	else if (strstr(msg,"FORWARD"))		Cmd=Forward;
	else if (strstr(msg,"BACK"))		Cmd=Backward;
	else if (strstr(msg,"STARBOARD"))	Cmd=Starboard;
	else if (strstr(msg,"PORT"))		Cmd=Port;
	else if (strstr(msg,"COME ABOUT"))	Cmd=ComeAbout;
	else if (strstr(msg,"STOP") || strstr(msg,"FURL SAIL"))
	{
		Cmd=Stop;
	}
	else if (strstr(msg,"TURN"))
	{
		if (strstr(msg,"RIGHT"))		Cmd=Starboard;
		else if (strstr(msg, "LEFT"))	Cmd=Port;
		else if (strstr(msg,"AROUND"))	Cmd=ComeAbout;
	}
	else if (strstr(msg,"SET NAME")==msg)	// must be the *first* words in msg
	{
		sprintf(Tiller->name,"a ship named %-.45s",msg+8);
		return 1;
	}

	if (Cmd == None)
		return 0;

	P_ITEM Boat = BoatC->unconst();
	int dir=Boat->dir&0x0F;
	int tx,ty;
	switch (Cmd)
	{
	case Forward:
		Boat->type2=1;	//Moving
		// fall-through
	case OneForward:
		Move(s,dir,Boat);
		break;
	case SlowForward:
		Boat->type2=3;	//Moving slowly forward
		Move(s,dir,Boat);
		break;
	case Backward:
		Boat->type2=2;	//Moving backward
		// fall-through
	case OneBackward:
		if (dir>=4) dir-=4; 
		else dir+=4;
		Move(s,dir,Boat);		
		break;
	case SlowBackward:
		Boat->type2=4;	//Moving slowly backward
		if (dir>=4) dir-=4; 
		else dir+=4;
		Move(s,dir,Boat);		
		break;
	case OneLeft:
		dir-=2;
		if (dir<0) dir+=8;			
		Move(s,dir,Boat);
		break;
	case OneRight:
		dir+=2;
		if (dir>=8) dir-=8;
		Move(s,dir,Boat);
		break;
	case Stop:
		Boat->type2=0;	//Moving is type2 1 and 2, so stop is 0 :-)
		break;
	case Port:
		dir+=2; if (dir>7) dir-=8;
		tx=0,ty=0;
		GetXYfromDir(dir, &tx, &ty);
//		if (!Block(Boat,tx,ty,dir))
		if (!IsTurningBlocked(Boat,0))
		{
			Turn(Boat,0);
		}
		else 
		{ 
			Boat->type2=0;
			itemtalk(s,Tiller,"Arr,somethings in the way"); 
			return 1;
		}
		break;
	case Starboard:
		dir-=2; if (dir<0) dir+=8;
		tx=0,ty=0;
		GetXYfromDir(dir, &tx, &ty);
//		if (!Block(Boat,tx,ty,dir))
		if (!IsTurningBlocked(Boat,1))
		{
			Turn(Boat,1);
		}
		else
		{ 
			Boat->type2=0;
			itemtalk(s,Tiller,"Arr,somethings in the way"); 
			return 1;
		}
		break;
	case ComeAbout:
		Turn(Boat,1);
		Turn(Boat,1);
		break;

	default:
		break;
	}

	if (Cmd!=None)
	{
		itemtalk(s, Tiller, "Aye, sir.");
		return 1;
	}
	return 0;
}

void cBoat::Drydock(UOXSOCKET s, P_CHAR Player, P_ITEM Tiller)
{
	if (!Player || !Tiller) return;

	P_ITEM Boat = FindItemBySerial(Tiller->multis);
	if (!Boat) return;

	if (!Player->hasKeyFor(Boat))
	{
		sysmessage(s,"You don't have the key for that boat");
		return;
	}

	P_CHAR pc;
	int loopexit=0;
	RegGrid3x3Iterator4Chars rg3ic(Boat->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pc->multis == Boat->serial)
		{
			sysmessage(s,"There are characters on the boat");
			return;
		}
	}

	PC_ITEM LeftPlank=NULL,RightPlank=NULL,Hold=NULL;
	PC_ITEM pi;
	loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(Boat->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->multis == Boat->serial)
		{
			if (pi->serial == Boat->getMoreB1_4())	continue;
			else if ((unsigned)pi->serial == Boat->morex)		LeftPlank = pi;
			else if ((unsigned)pi->serial == Boat->morey)		RightPlank = pi;
			else if ((unsigned)pi->serial == Boat->morez)		Hold = pi;
			else
			{
				sysmessage(s,"There are items on the boat's deck");
				return;
			}
		}
	}
	if (!Tiller || !LeftPlank || !RightPlank || !Hold)
	{
		LogError("didn't find all boat parts");
		return;	// we should have found all boat parts in the process above
	}
	
	if (Hold->CountItems())
	{
		sysmessage(s,"There are items on the boat's hold");
		return;
	}

	// maybe add checks for weight and container limits here

	P_ITEM BoatModel = Items->SpawnItem(Player,1,"#",0,0x14F4,0,1);
	if (!BoatModel) return;
	BoatModel->setType(ITY_BoatModel);
	BoatModel->newbieOn();
	BoatModel->decayOff();
	BoatModel->setMore3_4(Boat->getMore3_4());		// the section # in house.scp

	killkeys(Boat);
	Items->DeleItem(Tiller);
	Items->DeleItem(LeftPlank->unconst());
	Items->DeleItem(RightPlank->unconst());
	Items->DeleItem(Hold->unconst());
	Items->DeleItem(Boat->unconst());
}

/////////////////////
// Name:	Boat Crafting
// purpose:	Let them craft boats tile by tile
//			The ship plan is turned into the 'anchorpoint', the (ship-)Yard
//			Tiles are added along the lines of the .mul files
//			Once the last tiles has been added, all the dynamic tiles are removed
//			and the Yard is turned into a ship deed.
// history:	by Duke, 26.12.2003
// remark:	morex holds the serial of the yard
//			the morex of the *yard* holds the boat's section in house.scp
//			morey has the current # of parts already built
//			morez contains the id of the boat being built
//
bool cBoat::GetNextPart(short boatid, int builtsofar, singleMultiPart& mult)
{
	assert(boatid>=0x4000);
	int LoopExit=0;
	Multi->multiIteratorStart(boatid-0x4000);
	while (Multi->multiIteratorNext(mult) && ++LoopExit<MAXLOOPS)
	{
		if (LoopExit > builtsofar)
			return true;
	}
	return false;
}

void cBoat::ShowNextPart(UOXSOCKET s, P_ITEM pi)
{
	P_ITEM Yard = NULL;
	if (pi->isType(ITY_ShipYard))
		Yard = pi;
	else
		Yard = FindItemBySerial(pi->morex);
	if (!Yard) return;


	short boatid = Yard->morez;
	singleMultiPart partinfo;
	if (!GetNextPart(boatid, Yard->morey, partinfo))
		sysmessage(s,"There are no more parts missing.");
	else
		sysmessage(s,"The next part requires 20 logs and carpentry skill.");
}

void cBoat::PlaceShipYard(UOXSOCKET s, P_CHAR Player, cCoord& Tpos)
{
	P_ITEM pi = Player->getDclickedItem();
	if (!pi) return;
	if (!pi->isType(ITY_ShipPlan)) return;
	pi->setType(ITY_ShipYard);
	pi->setNotMovable();
//	pi->visible=2;			// only GMs can see it	
//	pi->SetOwnSerial(Player->serial);
	pi->SetContSerial(-1);
	pi->MoveTo2(Tpos);
}

void cBoat::AddShipPart(UOXSOCKET s, P_CHAR Player, P_ITEM pi)
{
	P_ITEM Yard = NULL;
	if (pi->isType(ITY_ShipYard))
		Yard = pi;
	else
		Yard = FindItemBySerial(pi->morex);
	if (!Yard) return;


	short boatid = Yard->morez;
	singleMultiPart partinfo;
	if (!GetNextPart(boatid, Yard->morey, partinfo))
		EndShipCrafting(s,Player,Yard);
	else
	{
		if (Player->CountItems(0x1BE0) < 20)
		{
			sysmessage(s,"You don't have enough logs.");
			return;
		}
		if (!Player->checkSkill(CARPENTRY))
		{
			Player->deleteItems(5,0x1BE0);
			sysmessage(s,"You failed to add a part");
			return;
		}

		P_ITEM Part = Items->SpawnItem(Player,1,"#",0,partinfo.tile,0,0);
		if (!Part) return;
		Player->deleteItems(20,0x1BE0);
		cCoord PartPos = Yard->pos;
		PartPos.Add(partinfo.x,partinfo.y,partinfo.z);
		Part->setType(ITY_ShipPart);
		Part->decayOff();
		Part->setNotMovable();
		Part->MoveTo2(PartPos);
		Part->morex = Yard->serial;
		sysmessage(s,"You add a part to the ship");
		Yard->morey++;
	}
}

void cBoat::EndShipCrafting(UOXSOCKET s, P_CHAR Player, P_ITEM Yard)
{
	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(Yard->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->morex == Yard->serial)
			Items->DeleItem(pi->unconst());
	}

	char* p = strstr(Yard->name,"plan");
	if (p) strncpy(p,"deed",4);
	Yard->setMovability(1);
	Yard->setId(0x14F0);
	Yard->setType(ITY_None);
	Yard->value=20000;
	Yard->newbieOn();
	Yard->refresh();
}


