/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__BOATS_H__)
#define __BOATS_H__

// Platform specifics
#include "platform.h"
#include "typedefs.h"

class cCoord;		// used-in-the-interface
struct singleMultiPart;

class cBoat 
{
private:
	void LeaveBoat(int s, P_CHAR Player, P_ITEM Plank);		
	bool Block(P_ITEM Boat, short int, short int,int);
	bool IsMovingBlocked(P_ITEM Boat, int dir);
	bool IsTurningBlocked(P_ITEM Boat, int right);
	void TurnStuff(P_ITEM Boat, P_ITEM pi, int dir);
	void TurnStuff(P_ITEM Boat, P_CHAR pc, int dir);
	bool GetNextPart(short boatid, int builtsofar, singleMultiPart& mult);
	void EndShipCrafting(UOXSOCKET s, P_CHAR Player, P_ITEM Yard);
	
public:
	cBoat();
	PC_ITEM GetBoat(int);
	virtual ~cBoat();
	char Speech(UOXSOCKET s, P_CHAR Player, char* msg);
	void OpenPlank(P_ITEM Plank);
	void PlankStuff(UOXSOCKET s, P_CHAR Player, P_ITEM Plank);
	bool Build(int s, P_CHAR Player, P_ITEM Boat, char id2, int scpno);
	void Move(int, int, P_ITEM Boat);
	void Turn(P_ITEM Boat, int);
	bool inmulti(const cCoord& pos, PC_ITEM iMulti);
	void Drydock(UOXSOCKET s, P_CHAR Player, P_ITEM Tiller);
	void ShowNextPart(UOXSOCKET s, P_ITEM pi);
	void PlaceShipYard(UOXSOCKET s, P_CHAR Player, cCoord& Tpos);
	void AddShipPart(UOXSOCKET s, P_CHAR Player, P_ITEM pi);
};

PC_ITEM findMulti(const cCoord& pos);

#endif

