/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// Books class by Lord Binary 7'th December 1999
// Implements writable books

// V0.9 5'th dec, initial version
// V1.0 7'th dec 1999, "wrapped" everything in a class, added customable number of max-pages
// V1.1 12-dec-1999 -> nasty bug fixed (item# used as "key" instead of serial#) and a few very small bugfixes

#include "books.h"

#include <iostream>
#include <vector> 

using namespace std ;

#include "wolfpack.h"
#include "network.h"
#include "debug.h"
#undef DBGFILE
#define DBGFILE "books.cpp"

const int linesperpage = 8 ;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cBooks::cBooks()//Constructor
{
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cBooks::~cBooks()//Destructor
{

}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

bool cBooks::useD4(UOXSOCKET s) 
{
	return (ClientVersion->supportsNewBookPacket(clientData[s].clientVersion)) ;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
std::string cBooks::makeBookName(P_ITEM pBook)
{
	std::string directory = (*SrvParms).bookpath ;
	std::string slash ;
#if defined(__unix__)
	slash = "/" ;
#else
	slash = "\\" ;
#endif
	char serial[9] ;
	memset(serial,0,9) ;
	sprintf(serial,"%08x",(*pBook).serial) ;

	if (directory.length() != 0 )
	{
		if (directory.substr(directory.length()-1,directory.length()-1) != slash)
		{
			directory += slash ;
		}
	}
	directory +=serial ;
	directory +=".bok" ;
	return directory ;

}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::writeTitleAuthor(std::fstream& file, std::string value, int seek)
{
	char temp[256] ;
	memset(temp,0,256) ;
	size_t length= value.length() ;
	if (length > 255)
		length = 255 ;

    strncpy(temp,value.c_str(),length) ;
	file.seekp(seek) ;
	file.write(temp,256) ;

}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
std::string cBooks::readTitleAuthor(std::fstream& file,int seek)
{
	file.seekg(seek) ;
	char temp[256] ;
	file.read(temp,256) ;
	return std::string(temp) ;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
std::string cBooks::title(std::fstream& file)
{

	return readTitleAuthor(file,6) ;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::title(std::fstream& file, std::string value)
{
	writeTitleAuthor(file, value, 6) ;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
std::string cBooks::author(std::fstream& file)
{
	return readTitleAuthor(file,266) ;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::author(std::fstream& file, std::string value)
{
	writeTitleAuthor(file, value, 266) ;

}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
short cBooks::pagecount(std::fstream& file)
{
	short rvalue=0 ;

	if (file.is_open())
	{
		file.seekg(4) ;
		file.read((char*)&rvalue,2) ;
	}
	else
		Console.send("Error pagecount\n") ;
	return rvalue ;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::pagecount(std::fstream& file, short value)
{
	file.seekp(4) ;
	file.write((char*)&value,2) ;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool cBooks::oldBokFormat(std::fstream& file)
{
	bool rvalue = false ;

	file.seekg(0) ;
	int value ;
	file.read((char*)&value,4) ;
	if (value != 1)
		rvalue = true ;
	return rvalue ;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
std::string cBooks::line(std::fstream& file, int pagenum, int linenum)
{
	char temp[256] ;
	file.seekg(518 + ((10*256)* pagenum) + (256 * linenum)) ;
	file.read(temp,256) ;
	return (std::string(temp)) ;

}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::line(std::fstream& file, int pagenum, int linenum, std::string value)
{
	char temp[256] ;
	memset(temp,0,256) ;
	file.seekp(518 + ((10*256)* pagenum) + (256 * linenum)) ;
	size_t length = value.length() ;
	if (length > 255)
		length = 255 ;
	strncpy(temp,value.c_str(),length) ;
	file.write(temp,256) ;
}


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::convertBok(P_ITEM pBook,std::fstream& file)
{
	if (file.is_open())
	{
		char temp[256] ;
		short numpages ;
		std::string tline ;
		std::string bokfile = makeBookName(pBook) ;
		std::string tempbok =  bokfile + ".temp" ;
		std::fstream tempfile ;
		file.seekg(94) ;
		file.read(temp,4) ;
		temp[4] = 0 ;
		numpages = str2num(temp) ;
		makeBookFile(tempbok,numpages) ;
		tempfile.open(tempbok.c_str(), ios::in|ios_base::out|ios_base::binary) ;
		// Get the title
		file.seekg(0) ;
		memset(temp,0,256) ;
		file.read(temp,61) ;
		tline = temp ;
		title(tempfile,tline) ;
		memset(temp,0,256) ;
		file.seekg(62) ;
		file.read(temp,31) ;

		author(tempfile,std::string(temp)) ;
		memset(temp,0,256) ;

		for (int j=0; j < numpages ; ++j)
		{
			file.seekg(100 + (((linesperpage*34)+1) * j)) ;
			for(int jj=0; jj < linesperpage;++jj)
			{
				file.read(temp,34) ;
				temp[33]=0 ;
				std::string tline = temp ;
				line(tempfile,j,jj,tline) ;
				memset(temp,0,34) ;
			}
		}
		file.close() ;
		tempfile.close() ;
	
		remove(bokfile.c_str()) ;
		rename(tempbok.c_str(),bokfile.c_str()) ;
	}
	else
		Console.send("Convert error, file not open\n") ;
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void cBooks::makeBookFile(std::string filename,short numpages)
{
	const int version = 1 ;
	
	char temp[260] ;
	std::fstream file ;
	file.open(filename.c_str(), ios_base::binary | ios_base::out) ;
	if (file.is_open())
	{
		file.write((char*)&version,4) ;
		file.write((char*)&numpages,2) ;
		memset(temp,0,260) ;

		file.write(temp,256) ;   // title 
		file.write(temp,256) ;   // author  ;
		for (int index = 0 ; index < numpages; ++index)
		{
			for (int jj=0 ; jj < 10 ; ++jj)
			{
				file.write(temp,256) ;
			}
		}
		file.close() ;
	}
	else
	{
	
		Console.send("Error creating file\n");
		Console.send(filename.c_str()) ;
		Console.send("\n");
	}
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::prepareFile(P_ITEM pBook)
{
	std::fstream file ;
	std::string name = makeBookName(pBook) ;
	int numpages = pBook->morey ;
	if (numpages < 1 || numpages > 255)
	{
		numpages = 32 ;
	}
	file.open(name.c_str(),ios_base::in | ios_base::binary) ;
	if (!file.is_open())
	{
		file.close() ;
		makeBookFile(name,numpages) ;
	}
	else
	{
		if (oldBokFormat(file))
		{
			convertBok(pBook,file) ;

		}
		file.close() ;
	}

}


// opens old (readonly) books == old, bugfixed readbook function
void cBooks::openbook_scp(UOXSOCKET s, P_ITEM pBook)
{
	unsigned char bookopen[10]="\x93\x40\x01\x02\x03\x00\x00\x00\x02"; //LB 7'th dec 1999, making it client 1.26 complaint
	unsigned char booktitle[61]="\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
	unsigned char bookauthor[31]="\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
	int loopexit=0;
	
	openscript("misc.scp");
	sprintf(temp, "BOOK %i",pBook->getMore1_4());
	if (!i_scripts[misc_script]->find(temp))
	{
		closescript();
		return;
	}

	LongToCharPtr(pBook->serial,&bookopen[1]);
	do
	{
		read2();
	}
	while ( (strcmp(script1, "PAGES")) && (++loopexit < MAXLOOPS) );
	bookopen[8] = (char) str2num(script2); // LB, bugfixing old code

	loopexit=0;
	do
	{
		read2();
	}
	while ( (strcmp(script1, "TITLE")) && (++loopexit < MAXLOOPS) );

	strcpy((char*)booktitle, script2);

	loopexit=0;
	do
	{
		read2();
	}
	while ( (strcmp(script1, "AUTHOR")) && (++loopexit < MAXLOOPS) );

	strcpy((char*)bookauthor, script2);

	XStartPkt(0x93, 0x63);
	XAddPkt(&bookopen[0+1], 9-1);
	XAddPkt(&booktitle[0], 60);
	XAddPkt(&bookauthor[0],30);
	XFinishPkt(s);

	closescript();
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// opens bok books
// writeable 1 -> open new books in writable mode
//           0 -> open new books in readonly mode
void cBooks::openbook(UOXSOCKET s, P_ITEM pBook, char writeable)
{
	unsigned char ttmp[512];
	std::fstream file ;
	int packetlength =99;
	prepareFile(pBook) ;
	std::string name = makeBookName(pBook) ;
	file.open(name.c_str(),ios_base::in | ios_base::binary );

	unsigned char tempserial[4] ;
	unsigned char tempshort[2] ;
	LongToCharPtr(pBook->serial, tempserial) ;

	if (file.is_open())
	{
		short numpages = pagecount(file) ;
	
		std::string Title = title(file) ;
		int titlelen = Title.length() + 1 ;
		std::string Author = author(file) ;
		int authorlen = Author.length() + 1 ;
		int j, jj ;
		if (useD4(s))
		{
			packetlength = 15 + titlelen + authorlen ;
			XStartPkt(0xd4,packetlength) ;
			
			XAddPkt((unsigned char*)tempserial,4) ;
			XAddPkt((unsigned char*)&writeable,1) ;
			XAddPkt((unsigned char*)&writeable,1) ;
			
			ShortToCharPtr(numpages,tempshort) ;
			XAddPkt((unsigned char*)tempshort,2) ;
			
			ShortToCharPtr(titlelen,tempshort) ;
			XAddPkt((unsigned char*)tempshort,2) ;
			
			strncpy((char*)ttmp, Title.c_str(), 512);
			XAddPkt(ttmp,titlelen) ;
			
			ShortToCharPtr(authorlen,tempshort) ;
			XAddPkt((unsigned char*)tempshort,2) ;
			
			strncpy((char*)ttmp, Author.c_str(), 512);
			XAddPkt(ttmp,authorlen) ;
			
		}
		else
		{
			XStartPkt(0x93,packetlength) ;
			XAddPkt((unsigned char*)tempserial,4) ;
			XAddPkt((unsigned char*)&writeable,1) ;
			XAddPkt((unsigned char*)&writeable,1) ;
			
			ShortToCharPtr(numpages,tempshort) ;
			XAddPkt((unsigned char*)tempshort,2) ;
			unsigned char temp[60] ;
			memset(temp,0,60) ;
			if (Title.length() > 59)
			{
				titlelen = 60 ;
			}	
			strncpy((char*)temp,Title.c_str(),titlelen -1) ;
			XAddPkt(temp,60) ;
			memset(temp,0,60) ;
			if (Author.length() > 29)
			{
				authorlen = 30 ;
			}
			strncpy((char*)temp,Author.c_str(),authorlen-1) ;
			XAddPkt(temp,30) ;
		}
		XFinishPkt(s);
	
    //////////////////////////////////////////////////////////////
	// Now we HAVE to send the ENTIRE Book                     / /
	// Cauz in writeable mode the client only sends out packets  /
	// if something  gets changed                                /
	// this also means -> for each bookopening in writeable mode /
	// lots of data has to be send.                              /
	//////////////////////////////////////////////////////////////

		if (writeable) 
		{
			unsigned char ttmp[512];
			
			packetlength = 0 ;
			std::vector< std::vector< std::string > > pages;
	  
			for (j=0;j< numpages;++j)
			{
				std::vector<std::string>  vecstorage ;
				vecstorage.clear() ;
				for (jj=0; jj < linesperpage ; ++jj)
				{
					
					vecstorage.push_back(line(file,j,jj)) ;
					packetlength += vecstorage[jj].length() + 1 ;
				}
				pages.push_back(vecstorage) ;
			}

			packetlength +=9 + numpages*4 ;
			XStartPkt(0x66,packetlength) ;
			XAddPkt((unsigned char*)tempserial,4) ;
			ShortToCharPtr(numpages,tempshort) ;
			XAddPkt((unsigned char*)tempshort,2) ;
			for (j=0;j< numpages;++j)
			{
				int truenum = j+1 ;
				ShortToCharPtr(truenum,tempshort) ;
				XAddPkt((unsigned char*)tempshort,2) ;
				ShortToCharPtr(linesperpage,tempshort) ;
				XAddPkt((unsigned char*)tempshort,2) ;
			
				for (jj=0; jj < linesperpage ; ++jj)
				{
					strncpy((char*)ttmp, pages[j][jj].c_str(), 512);
					XAddPkt(ttmp,pages[j][jj].length() + 1) ;

				}
			}
			XFinishPkt(s) ;
		}
		file.close() ;
	}
	else
		Console.send("Error preparing file\n") ;

}

// sends a page of new readonly book to the client
void cBooks::readbook_readonly(UOXSOCKET s, P_ITEM pBook, int p) 
{	
	int packetlength = 0,j=0 ;
	std::fstream file ;
	std::string bookname = makeBookName(pBook) ;
	file.open(bookname.c_str(),ios::in|ios::binary) ;
	if (file.is_open())
	{
		unsigned char tempserial[4];
		unsigned char ttmp[512];
		unsigned char tmpshort[2];
		std::vector<std::string> page(linesperpage) ;
	
		for (j=0 ; j< linesperpage; ++j)
		{
			page[j]=line(file,p-1,j) ;		
			packetlength += page[j].length() + 1 ;
		}

		packetlength +=9 + 4 ;
		XStartPkt(0x66,packetlength);	
		LongToCharPtr(pBook->serial, tempserial) ;
		XAddPkt(tempserial,4) ;

		short onepage = 1;   // one page
		short pagenum = p; 
		short lpp     = linesperpage;	

		ShortToCharPtr(onepage, tmpshort);
		XAddPkt(tmpshort,2) ;

		ShortToCharPtr(pagenum, tmpshort);
		XAddPkt(tmpshort,2) ;

		ShortToCharPtr(lpp, tmpshort);
		XAddPkt(tmpshort,2) ;
	
		for (j=0;j<linesperpage;++j)
		{
			strncpy((char*)ttmp, page[j].c_str(), 512);
			XAddPkt(ttmp,page[j].length()+1) ;
		}
	
		XFinishPkt(s) ;

	}
}


// old readbook function
void cBooks::readbook_readonly_scp(UOXSOCKET s, P_ITEM pBook, int p)
{
	int x, y, pos, j;
	unsigned char bookpage[14]="\x66\x01\x02\x40\x01\x02\x03\x00\x01\x00\x01\x00\x01";
	int loopexit=0,loopexit2=0;
	
	openscript("misc.scp");
	sprintf(temp, "BOOK %i",pBook->getMore1_4());
	if (!i_scripts[misc_script]->find(temp))
	{
		closescript();
		return;
	}
	x=p;

	do
	{
		loopexit=0;
		do
		{
			read2();
		}
		while ( (strcmp(script1, "PAGE")) && (++loopexit < MAXLOOPS) );
		x--;
	}
	while ( (x>0) && (++loopexit2 < 6666 ));

	closescript();
	openscript("misc.scp");
	sprintf(temp, "PAGE %s", script2);
	if (!i_scripts[misc_script]->find(temp))
	{
		closescript();
		return;
	}
	pos=ftell(scpfile);
	x=-1;
	y=-2;
	loopexit=0;
	do
	{
		read1();
		x++;
		y+=strlen(script1)+1;
	}
	while ( (strcmp(script1, "}")) && (++loopexit < MAXLOOPS) );
	y+=13;
	fseek(scpfile, pos, SEEK_SET);
	bookpage[1]=y>>8;
	bookpage[2]=y%256;
	LongToCharPtr(pBook->serial,&bookpage[3]);
	bookpage[9]=p>>8;
	bookpage[10]=p%256;
	bookpage[11]=x>>8;
	bookpage[12]=x%256;

	XStartPkt(0x66, y);
	XAddPkt(&bookpage[0+3], 13-3);	

	for (j=0;j<x;j++)
	{
		read1();
		XAddPkt((unsigned char*)&script1[0], strlen(script1)+1);
	}
	closescript();

	XFinishPkt(s);
}





void cBooks::delete_bokfile(P_ITEM pBook)
{
	
	std::string name = makeBookName(pBook);
	remove(name.c_str());
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::processBookPacket(UOXSOCKET s)
{
	int size;
	size=ShortFromCharPtr(&buffer[s][1]);
	P_ITEM iIty = FindItemBySerPtr(&buffer[s][3]);
	if (iIty!=NULL)
	{
		P_ITEM pBook=iIty;
		if (pBook->morex!=666 && pBook->morex!=999)
			Books->readbook_readonly_scp(s, pBook, ShortFromCharPtr(&buffer[s][9]));  // call old books read-method
		if (pBook->morex==666) // writeable book -> copy page data send by client to the class-page buffer
		{
			std::fstream file ;
			std::string bookname = makeBookName(pBook) ;
			file.open(bookname.c_str(),ios_base::in | ios_base::out|ios_base::binary) ;
			int pagenum = ShortFromCharPtr(&buffer[s][9]) ;
			int j,jj ;
			char temp[2] ;
			memset(temp,0,2) ;
			if (file.is_open())
			{
				jj = 13 ;
				for (j=0 ; j< linesperpage;++j)
				{
					string newline ;
					while (buffer[s][jj]!=0 && jj < size)
					{
						temp[0] = buffer[s][jj] ;
						newline += temp ;
						++jj ;
					}
					if (newline.length() > 0)
					{
						line(file,pagenum-1,j,newline) ;
					}
					newline="" ;
					++jj ;
					if (jj >=size)
					{
						break;
					}

				}
				file.close() ;
			}
		}
		if (pBook->morex==999)
			this->readbook_readonly(s,pBook,ShortFromCharPtr(&buffer[s][9])); // new books readonly
	}
}

void cBooks::processOldBookHeaderPacket(UOXSOCKET s)
{
	P_ITEM iIty = FindItemBySerPtr(&buffer[s][1]);
	if (iIty!=NULL)
	{
		P_ITEM pBook=iIty;
		if (pBook->morex==666)
		{
			// if title or author changed, we need to save
			std::string name = makeBookName(pBook) ;
			fstream file ;
			file.open(name.c_str(),ios_base::in | ios_base::binary | ios_base::out) ;
			if (file.is_open())
			{
				std::string newtitle = (char*)&(buffer[s][9]) ;
				std::string newauthor = (char*)&(buffer[s][69]) ;
				title(file,newtitle) ;
				author(file,newauthor) ;

				file.close() ;
			}
			else
			{

				Console.send("Error opening book file\n") ;
				Console.send(name.c_str()) ;
				Console.send("\n") ;
			}

		}
	}


}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void cBooks::processBookHeaderPacket(UOXSOCKET s)
{
	P_ITEM iIty = FindItemBySerPtr(&buffer[s][3]);
	if (iIty!=NULL)
	{
		P_ITEM pBook=iIty;
		if (pBook->morex==666)
		{
			// if title or author changed, we need to save
			std::string name = makeBookName(pBook) ;
			fstream file ;
			file.open(name.c_str(),ios_base::binary | ios_base::in |ios_base::out) ;
			if (file.is_open())
			{
				std::string newtitle ;
				std::string newauthor ;
				int index = 13 ;
				char temp[2] ;
				memset(temp,0,2) ;
				while (buffer[s][index] != 0 )
				{
					temp[0] = buffer[s][index] ;
					newtitle += temp ; 
					++index ;
				}
				++index ;
				++index ;
				++index ;

				while (buffer[s][index] != 0 )
				{
					temp[0] = buffer[s][index] ;
					newauthor += temp ; 
					++index ;
				}
				title(file,newtitle) ;
				author(file,newauthor) ;

				file.close() ;
			}

		}
	}


}




std::string cBooks::clickTitle(P_ITEM pBook, bool format) 
{
	string rvalue ;
	int loopexit ;

	if (format)
	{
		std::string name = makeBookName(pBook) ;
		std::string titlename ;
		std::string authorname ;
		fstream file ;
		file.open(name.c_str(),ios_base::binary | ios_base::in) ;


		if (file.is_open())
		{
			if (oldBokFormat(file))
			{
				convertBok(pBook,file) ;
				file.open(name.c_str(),ios_base::in | ios_base::binary );

			}

			titlename = title(file) ;
			authorname = author(file) ;
			if (titlename.length() != 0 )
			{
				rvalue = '"' ;
				rvalue +=titlename + (char)'"' ;
			}
			if (authorname.length() !=0)
			{
				rvalue +=" by " + authorname ;
			}
			file.close() ;
		}
	}
	else
	{
	

		openscript("misc.scp");
		sprintf(temp, "BOOK %i",pBook->getMore1_4());
		if (!i_scripts[misc_script]->find(temp))
		{
			closescript();
		}
		else
		{
			loopexit = 0;
			do
			{
				read2();
			}
			while ( (strcmp(script1, "TITLE")) && (++loopexit < MAXLOOPS) );
			rvalue='"' ;
			rvalue += script2;
			rvalue+='"';

			loopexit=0;
			do
			{
				read2();
			}
			while ( (strcmp(script1, "AUTHOR")) && (++loopexit < MAXLOOPS) );
			string punt ;
			punt  = script2 ;
			if (punt !="")
			{
				rvalue += " by " ;
				rvalue += punt ;

			}

		}
		closescript();
	}
	return rvalue ;
}


