/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/*
 * This code is an attempt to clean up the messy "if/then/else" routines
 * currently in use for GM commands, as well as adding more functionality
 * and more potential for functionality.
 *
 * Current features:
 * - Actual table of commands to execute, what perms are required, dialog
 *   messages for target commands, etc handled by a central system
 *
 * - /SETPRIV3 user-friendliness - /SETPRIV3 <command> works now instead of
 *   all that cumbersome bitmask math (Eg; /SETPRIV3 + SAVE and click on a
 *   char and they get SAVE command perms, /SETPRIV3 - SAVE and click on a
 *   char and their SAVE privs are removed)
 */

#include "cmdtable.h"

#include "accounts.h"
#include "bounty.h"
#include "Client.h"
#include "commands.h"
#include "gumps.h"
#include "magic.h"
#include "mapstuff.h"
#include "msgboard.h"
#include "network.h"
#include "qsf.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"
#include "sregions.h"
#include "targeting.h"
#include "teleport.h"
#include "Trade.h"
#include "worldmain.h"
#include "tiledata.h"
#include "titles.h"
#include "house.h"
#include "mapS.h"
#include "guilds.h"


#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "cmdtable.cpp"

extern void pdump(UOXSOCKET s, char type, FILE* file);

TARGET_S target_use = { 24, "What object will you use?" };
TARGET_S target_jail = { 126, "Select player to jail." };
TARGET_S target_release = { 127, "Select player to release from jail." };
TARGET_S target_istats = { 12, "Select item to inspect." };
TARGET_S target_cstats = { 13, "Select char to inspect." };
TARGET_S target_tele = { 2, "Select teleport target." };
TARGET_S target_xbank = { 107, "Select target to open bank of." };
TARGET_S target_xsbank = { 107, "Select target to open specialbank of." };//AntiChrist
TARGET_S target_remove = { 3, "Select item to remove." };
TARGET_S target_makegm = { 14, "Select character to make a GM." };
TARGET_S target_makecns = {15, "Select character to make a Counselor." };
TARGET_S target_killhair = { 16, "Select character for cutting hair." };
TARGET_S target_killbeard = { 17, "Select character for shaving." };
TARGET_S target_kill = { 20, "Select character to kill." };
TARGET_S target_resurrect = { 21, "Select character to resurrect." };
TARGET_S target_bolt = { 22, "Select character to bolt." };
// This fires a harmless bolt at the user.
TARGET_S target_kick = { 25, "Select character to kick." };
// This disconnects the player targeted from the game. They
// can still log back in.
TARGET_S target_movetobag = { 111, "Select an item to move into your bag." };
TARGET_S target_xgo = { 8, "Select char to teleport." };
TARGET_S target_setmorex = { 63, "Select object to set morex on." };
TARGET_S target_setmorey = { 64, "Select object to set morey on." };
TARGET_S target_setmorez = { 65, "Select object to set morez on." };
TARGET_S target_setmorexyz = { 66, "Select object to set morex, morey, and morez on." };
TARGET_S target_sethexmorexyz = { 66, "Select object to set hex morex, morey, and morez on." };
TARGET_S target_setnpcai = { 106, "Select npc to set AI type on." };
TARGET_S target_settype = { 6, "Select item to edit type." };
TARGET_S target_itrig = { 200, "Select item to trigger." };
TARGET_S target_ctrig = { 201, "Select NPC to trigger." };
TARGET_S target_ttrig = { 202, "Select item to set trigger type." };
TARGET_S target_setid = { 7, "Select item to polymorph." };
TARGET_S target_setmore = { 10, "Select item to edit 'more' value." };
TARGET_S target_setmore2 = { 90, "Select item to edit 'more2' value." };
TARGET_S target_setfont = { 19, "Select character to change font." };
TARGET_S target_npcaction = { 53, "Select npc to make act." };
TARGET_S target_setamount = { 23, "Select item to edit amount." };
TARGET_S target_setamount2 = { 129, "Select item to edit amount." };
TARGET_S target_setmovable = { 28, "Select item to edit mobility." };
TARGET_S target_setvisible = { 61, "Select item to edit visibility." };
TARGET_S target_setdir = { 88, "Select item to edit direction." };
TARGET_S target_setspeech = { 135, "Select NPC to edit speech." };
TARGET_S target_setowner = { 30, "Select NPC or OBJECT to edit owner." };
TARGET_S target_freeze = { 34, "Select player to freeze in place." };
TARGET_S target_unfreeze = { 35, "Select player to unfreeze." };
TARGET_S target_tiledata = { 46, "Select item to inspect." };
TARGET_S target_recall = { 38, "Select rune from which to recall." };
TARGET_S target_mark = { 39, "Select rune to mark." };
TARGET_S target_gate = { 43, "Select rune from which to gate." };
TARGET_S target_heal = { 44, "Select person to heal." };
TARGET_S target_npctarget = { 56, "Select player for the NPC to follow." };
TARGET_S target_tweak = { 62, "Select item or character to tweak." };
//TARGET_S target_sbopen = { 87, "Select spellbook to open as a container." };
TARGET_S target_mana = { 113, "Select person to restore mana to." };
TARGET_S target_stamina = { 114, "Select person to refresh." };
TARGET_S target_makeshop = { 116, "Select the character to add shopkeeper buy containers to." };
TARGET_S target_buy = { 121, "Select the shopkeeper you'd like to buy from." };
TARGET_S target_setvalue = { 122, "Select item to edit value." };
TARGET_S target_setrestock = { 123, "Select item to edit amount to restock." };
TARGET_S target_sell = { 112, "Select the NPC to sell to." };
TARGET_S target_setspattack = { 150, "Select creature to set SPATTACK on." };
TARGET_S target_setspadelay = { 177, "Select creature to set SPADELAY on." };
TARGET_S target_setpoison = { 175, "Select creature to set POISON." };
TARGET_S target_setpoisoned = { 176, "Select creature to set POISONED." };
TARGET_S target_setadvobj = { 178, "Select creature to set ADVOBJ." };
TARGET_S target_setwipe = { 133, "Select item to modify." };
TARGET_S target_fullstats = { 151, "Select creature to restore full stats." };
TARGET_S target_hide = { 131, "Select creature to hide." };
TARGET_S target_unhide = { 132, "Select creature to reveal." };
TARGET_S target_house = { 207, "Select location for house." };
TARGET_S target_split = { 209, "Select creature to make able to split." };
TARGET_S target_splitchance = {210, "Select creature to set it's chance of splitting." };
TARGET_S target_possess = { 212, "Select creature to possess." };
TARGET_S target_telestuff = { 214, "Select player/object to teleport." };
TARGET_S target_killpack = { 18, "Select character to remove pack." };
TARGET_S target_trainer = { 206, "Select character to become a trainer." };
TARGET_S target_showpriv3 = { 226, "Select character to display priviliges." };
TARGET_S target_ban = { 235, "Select character to BAN." };
TARGET_S target_newx = { 251, "Select item to reposition." };
TARGET_S target_newy = { 252, "Select item to reposition." };
TARGET_S target_newz = { 5, "Select item to reposition." };
TARGET_S target_incx = { 253, "Select item to reposition." };
TARGET_S target_incy = { 254, "Select item to reposition." };
TARGET_S target_incz = { 260, "Select item to reposition." };
TARGET_S target_glow = { 255, "Select item to make glowing." };
TARGET_S target_unglow = { 249, "Select item to deactivate glowing." };
TARGET_S target_showskills = { 247, "Select char to see skills" };
TARGET_S target_sethome = { 256, "Set home location for a npc."};
TARGET_S target_setwork = { 257, "Set work location for a npc."};
TARGET_S target_setfood = { 258, "Set food location for a npc."};
TARGET_S target_setrevertswap = { 259, "Select target to revert swap effect."};
TARGET_S target_seti =		{ 261, "Select item to set attributes."};
TARGET_S target_clonenpc = { 262, "Select NPC to clone"};
TARGET_S target_permact = { 263, "Select NPC to do perma-action"};
TARGET_S target_xsay =	{ 264, "Select char to speak your words."};



CMDTABLE_S command_table[] = {
{"SETGMMOVEEFF",0, 21,	CMD_FUNC, (CMD_DEFINE)&command_setGmMoveEff},
{"BOUNTY",		255,0,  CMD_FUNC,   (CMD_DEFINE)&command_bounty},
{"POST",		1,  2,  CMD_FUNC,   (CMD_DEFINE)&command_post},
{"GPOST",		1,  2,  CMD_FUNC,   (CMD_DEFINE)&command_gpost},
{"RPOST",		1,  2,  CMD_FUNC,   (CMD_DEFINE)&command_rpost},
{"LPOST",		1,  2,  CMD_FUNC,   (CMD_DEFINE)&command_lpost},
{"SHOWP",		255,0,	CMD_FUNC,	(CMD_DEFINE)&command_showp},
{"SETPRIV3",	0,	0,	CMD_FUNC,	(CMD_DEFINE)&command_setpriv3},
{"USE",			0,	1,	CMD_TARGET,	(CMD_DEFINE)&target_use},
{"RESEND",		0,	2,	CMD_FUNC,	(CMD_DEFINE)&command_resend},
{"POINT",		0,	3,	CMD_FUNC,	(CMD_DEFINE)&command_teleport},
{"WHERE",		0,	4,	CMD_FUNC,	(CMD_DEFINE)&command_where},
{"ADDU",		0,	5,	CMD_ITEMMENU,	(CMD_DEFINE)1}, // Opens the GM add menu.
{"Q",			0,	6,	CMD_FUNC,	(CMD_DEFINE)&command_q},
{"NEXT",		0,	7,	CMD_FUNC,	(CMD_DEFINE)&command_next},
{"CLEAR",		0,	8,	CMD_FUNC,	(CMD_DEFINE)&command_clear},
{"GOTOCUR",		0,	9,	CMD_FUNC,	(CMD_DEFINE)&command_gotocur},
{"GMTRANSFER",	0,	10,	CMD_FUNC,	(CMD_DEFINE)&command_gmtransfer},
{"JAIL",		0,  27, CMD_FUNC,   (CMD_DEFINE)&command_jail},
{"RELEASE",		0,	12,	CMD_TARGET,	(CMD_DEFINE)&target_release},
{"ISTATS",		0,	13,	CMD_TARGET,	(CMD_DEFINE)&target_istats},
{"CSTATS",		0,	14,	CMD_TARGET,	(CMD_DEFINE)&target_cstats},
{"GOPLACE",		0,	15,	CMD_FUNC,	(CMD_DEFINE)&command_goplace},
{"GOCHAR",		0,	16,	CMD_FUNC,	(CMD_DEFINE)&command_gochar},
{"FIX",			0,	17,	CMD_FUNC,	(CMD_DEFINE)&command_fix},
{"XGOPLACE",	0,	18,	CMD_FUNC,	(CMD_DEFINE)&command_xgoplace},
{"SHOWIDS",		0,	19,	CMD_FUNC,	(CMD_DEFINE)&command_showids},
{"POLY",		0,	20,	CMD_FUNC,	(CMD_DEFINE)&command_poly},
{"SKIN",		0,	21,	CMD_FUNC,	(CMD_DEFINE)&command_skin},
{"ACTION",		0,	22,	CMD_FUNC,	(CMD_DEFINE)&command_action},
{"TELE",		0,	23,	CMD_TARGET,	(CMD_DEFINE)&target_tele},
{"XTELE",		0,	24,	CMD_FUNC,	(CMD_DEFINE)&command_xtele},
{"GO",			0,	25,	CMD_FUNC,	(CMD_DEFINE)&command_go},
{"XGO",			0,	26,	CMD_TARGETXYZ,	(CMD_DEFINE)&target_xgo},
{"SETMOREX",	0,	27,	CMD_TARGETX,	(CMD_DEFINE)&target_setmorex},
{"SETMOREY",	0,	28,	CMD_TARGETX,	(CMD_DEFINE)&target_setmorey},
{"SETMOREZ",	0,	29,	CMD_TARGETX,	(CMD_DEFINE)&target_setmorez},
{"ZEROKILLS",	0,	30,	CMD_FUNC,	(CMD_DEFINE)&command_zerokills},
{"SETMOREXYZ",	0,	31,	CMD_TARGETXYZ,	(CMD_DEFINE)&target_setmorexyz},
{"SETHEXMOREXYZ",1,	0,	CMD_TARGETHXYZ,	(CMD_DEFINE)&target_sethexmorexyz},
{"SETNPCAI",	1,	1,	CMD_TARGETHX,	(CMD_DEFINE)&target_setnpcai},
{"XBANK",		1,	2,	CMD_TARGET,	(CMD_DEFINE)&target_xbank},
{"XSBANK",		1,	2,	CMD_TARGET,	(CMD_DEFINE)&target_xsbank},//AntiChrist
{"TILE",		1,	3,	CMD_FUNC,	(CMD_DEFINE)&command_tile},
{"WIPE",		1,	4,	CMD_FUNC,	(CMD_DEFINE)&command_wipe},
{"IWIPE",		1,	5,	CMD_FUNC,	(CMD_DEFINE)&command_iwipe},
{"ADD",			1,	6,	CMD_FUNC,	(CMD_DEFINE)&command_add},
{"ADDX",		1,	7,	CMD_FUNC,	(CMD_DEFINE)&command_addx},
{"RENAME",		1,	8,	CMD_FUNC,	(CMD_DEFINE)&command_rename},
{"TITLE",		1,	9,	CMD_FUNC,	(CMD_DEFINE)&command_title},
{"SAVE",		1,	10,	CMD_FUNC,	(CMD_DEFINE)&command_save},
{"REMOVE",		1,	11,	CMD_TARGET,	(CMD_DEFINE)&target_remove},
{"TRAINER",		1,	12,	CMD_TARGET,	(CMD_DEFINE)&target_trainer},
{"DYE",			1,	13,	CMD_FUNC,	(CMD_DEFINE)&command_dye},
{"SETTYPE",		1,	15,	CMD_TARGETX,	(CMD_DEFINE)&target_settype},
{"ITRIG",		1,	16,	CMD_TARGETX,	(CMD_DEFINE)&target_itrig},
{"CTRIG",		1,	17,	CMD_TARGETX,	(CMD_DEFINE)&target_ctrig},
{"TTRIG",		1,	18,	CMD_TARGETX,	(CMD_DEFINE)&target_ttrig},
{"WTRIG",		1,	19,	CMD_FUNC,	(CMD_DEFINE)&command_wtrig},
{"SETID",		1,	20,	CMD_TARGETHXY,	(CMD_DEFINE)&target_setid},
{"SETPRIV",		1,	21,	CMD_FUNC,	(CMD_DEFINE)&command_setpriv},
{"NODECAY",		4,	30,	CMD_FUNC,	(CMD_DEFINE)&command_nodecay},
{"SEND",		255,0,	CMD_FUNC,	(CMD_DEFINE)&command_send},
{"SHOWTIME",	1,	23,	CMD_FUNC,	(CMD_DEFINE)&command_showtime},
{"SETTIME",		5,	2,	CMD_FUNC,	(CMD_DEFINE)&command_settime},
{"SETMORE",		1,	24,	CMD_TARGETHID4,	(CMD_DEFINE)&target_setmore},
{"SETMORE2",	1,	24,	CMD_TARGETHID4,	(CMD_DEFINE)&target_setmore2},
{"SHUTDOWN",	1,	25,	CMD_FUNC,	(CMD_DEFINE)&command_shutdown},
{"MAKEGM",		1,	26,	CMD_TARGET,	(CMD_DEFINE)&target_makegm},
{"MAKECNS",		1,	27,	CMD_TARGET,	(CMD_DEFINE)&target_makecns},
{"KILLHAIR",	1,	28,	CMD_TARGET,	(CMD_DEFINE)&target_killhair},
{"KILLBEARD",	1,	29,	CMD_TARGET,	(CMD_DEFINE)&target_killbeard},
{"KILLPACK",	1,	30,	CMD_TARGET,	(CMD_DEFINE)&target_killpack},
{"SETFONT",		1,	31,	CMD_TARGETHID1,	(CMD_DEFINE)&target_setfont},
{"WHOLIST",		2,	0,	CMD_FUNC,	(CMD_DEFINE)&command_wholist},
{"PLAYERLIST",	2,	0,	CMD_FUNC,	(CMD_DEFINE)&command_playerlist},
{"KILL",		2,	1,	CMD_TARGET,	(CMD_DEFINE)&target_kill},
{"RESURRECT",	2,	2,	CMD_TARGET,	(CMD_DEFINE)&target_resurrect},
{"RES",			2,	2,	CMD_TARGET,	(CMD_DEFINE)&target_resurrect},
{"BOLT",		2,	3,	CMD_TARGET4OPT,	(CMD_DEFINE)&target_bolt},
{"SFX",			2,	4,	CMD_FUNC,	(CMD_DEFINE)&command_sfx},
{"NPCACTION",	2,	5,	CMD_TARGETHID1,	(CMD_DEFINE)&target_npcaction},
{"LIGHT",		2,	6,	CMD_FUNC,	(CMD_DEFINE)&command_light},
{"SETAMOUNT",	2,	7,	CMD_TARGETX,	(CMD_DEFINE)&target_setamount},
{"SETAMOUNT2",	2,	8,	CMD_TARGETX,	(CMD_DEFINE)&target_setamount2},
{"DISCONNECT",	2,	9,	CMD_FUNC,	(CMD_DEFINE)&command_disconnect},
{"KICK",		2,	10,	CMD_TARGET,	(CMD_DEFINE)&target_kick},
{"TELL",		2,	11,	CMD_FUNC,	(CMD_DEFINE)&command_tell},
{"DRY",			2,	12,	CMD_FUNC,	(CMD_DEFINE)&command_dry},
{"RAIN",		2,	13,	CMD_FUNC,	(CMD_DEFINE)&command_rain},
{"SNOW",		2,	14,	CMD_FUNC,	(CMD_DEFINE)&command_snow},
{"GMMENU",		2,	15,	CMD_FUNC,	(CMD_DEFINE)&command_gmmenu},
{"ITEMMENU",	2,	16,	CMD_FUNC,	(CMD_DEFINE)&command_itemmenu},
{"ADDITEM",		2,	17,	CMD_FUNC,	(CMD_DEFINE)&command_additem},
{"DUPE",		2,	18,	CMD_FUNC,	(CMD_DEFINE)&command_dupe},
{"MOVETOBAG",	2,	19,	CMD_TARGET,	(CMD_DEFINE)&target_movetobag},
{"COMMAND",		2,	20,	CMD_FUNC,	(CMD_DEFINE)&command_command},
{"GCOLLECT",	2,	21,	CMD_FUNC,	(CMD_DEFINE)&command_gcollect},
{"ALLMOVEON",	2,	22,	CMD_FUNC,	(CMD_DEFINE)&command_allmoveon},
{"ALLMOVEOFF",	2,	23,	CMD_FUNC,	(CMD_DEFINE)&command_allmoveoff},
{"SHOWHS",		2,	24,	CMD_FUNC,	(CMD_DEFINE)&command_showhs},
{"HIDEHS",		2,	25,	CMD_FUNC,	(CMD_DEFINE)&command_hidehs},
{"VIEWDEPTH",	3,	15,	CMD_FUNC,	(CMD_DEFINE)&command_viewdepth},
{"SETMOVABLE",	2,	26,	CMD_TARGETX,	(CMD_DEFINE)&target_setmovable},
{"SET",			2,	27,	CMD_FUNC,	(CMD_DEFINE)&command_set},
{"SETVISIBLE",	2,	28,	CMD_TARGETX,	(CMD_DEFINE)&target_setvisible},
{"SETDIR",		2,	29,	CMD_TARGETX,	(CMD_DEFINE)&target_setdir},
{"SETSPEECH",	2,	30,	CMD_TARGETX,	(CMD_DEFINE)&target_setspeech},
{"SETOWNER",	2,	31,	CMD_TARGETHID4,	(CMD_DEFINE)&target_setowner},
{"ADDNPC",		3,	0,	CMD_FUNC,	(CMD_DEFINE)&command_addnpc},
{"FREEZE",		3,	1,	CMD_TARGET,	(CMD_DEFINE)&target_freeze},
{"UNFREEZE",	3,	2,	CMD_TARGET,	(CMD_DEFINE)&target_unfreeze},
{"READINI",		3,	3,	CMD_FUNC,	(CMD_DEFINE)&command_readini},
{"GUMPMENU",	3,	4,	CMD_FUNC,	(CMD_DEFINE)&command_gumpmenu},
{"TILEDATA",	3,	5,	CMD_TARGET,	(CMD_DEFINE)&target_tiledata},
{"RECALL",		3,	6,	CMD_TARGET,	(CMD_DEFINE)&target_recall},
{"MARK",		3,	7,	CMD_TARGET,	(CMD_DEFINE)&target_mark},
{"GATE",		3,	8,	CMD_TARGET,	(CMD_DEFINE)&target_gate},
{"HEAL",		3,	9,	CMD_TARGET,	(CMD_DEFINE)&target_heal},
{"NPCTARGET",	3,	10,	CMD_TARGET,	(CMD_DEFINE)&target_npctarget},
{"NPCRECT",		3,	12,	CMD_FUNC,	(CMD_DEFINE)&command_npcrect},
{"NPCCIRCLE",	3,	13,	CMD_FUNC,	(CMD_DEFINE)&command_npccircle},
{"NPCWANDER",	3,	14,	CMD_FUNC,	(CMD_DEFINE)&command_npcwander},
{"TWEAK",		3,	15,	CMD_TARGET,	(CMD_DEFINE)&target_tweak},
//{"SBOPEN",		3,	16,	CMD_TARGET,	(CMD_DEFINE)&target_sbopen},
{"SECONDSPERUOMINUTE",3,17,CMD_FUNC,	(CMD_DEFINE)&command_secondsperuominute},
{"BRIGHTLIGHT",	3,	18,	CMD_FUNC,	(CMD_DEFINE)&command_brightlight},
{"DARKLIGHT",	3,	19,	CMD_FUNC,	(CMD_DEFINE)&command_darklight},
{"DUNGEONLIGHT",3,	20,	CMD_FUNC,	(CMD_DEFINE)&command_dungeonlight},
{"TIME",		3,	21,	CMD_FUNC,	(CMD_DEFINE)&command_time},
{"MANA",		3,	22,	CMD_TARGET,	(CMD_DEFINE)&target_mana},
{"STAMINA",		3,	23,	CMD_TARGET,	(CMD_DEFINE)&target_stamina},
{"GMOPEN",		3,	24,	CMD_FUNC,	(CMD_DEFINE)&command_gmopen},
{"MAKESHOP",	3,	25,	CMD_TARGET,	(CMD_DEFINE)&target_makeshop},
{"BUY",			3,	26,	CMD_TARGET,	(CMD_DEFINE)&target_buy},
{"SETVALUE",	3,	27,	CMD_TARGETX,	(CMD_DEFINE)&target_setvalue},
{"SETRESTOCK",	3,	28,	CMD_TARGETX,	(CMD_DEFINE)&target_setrestock},
{"RESTOCK",		3,	29,	CMD_FUNC,	(CMD_DEFINE)&command_restock},
{"RESTOCKALL",	3,	30,	CMD_FUNC,	(CMD_DEFINE)&command_restockall},
{"SETSHOPRESTOCKRATE",3,31,CMD_FUNC,(CMD_DEFINE)&command_setshoprestockrate},
{"WHO",			4,	0,	CMD_FUNC,	(CMD_DEFINE)&command_who},
{"GMS",			4,	1,	CMD_FUNC,	(CMD_DEFINE)&command_gms},
{"SELL",		4,	2,	CMD_TARGET,	(CMD_DEFINE)&target_sell},
{"MIDI",		4,	3,	CMD_FUNC,	(CMD_DEFINE)&command_midi},
{"GUMPOPEN",	4,	4,	CMD_FUNC,	(CMD_DEFINE)&command_gumpopen},
{"RESPAWN",		4,	5,	CMD_FUNC,	(CMD_DEFINE)&command_respawn},
{"REGSPAWNALL",	4,	5,	CMD_FUNC,	(CMD_DEFINE)&command_regspawnall},
{"REGSPAWNMAX",	4,	5,	CMD_FUNC,	(CMD_DEFINE)&command_regspawnmax},
{"REGSPAWN",	4,	5,	CMD_FUNC,	(CMD_DEFINE)&command_regspawn},
{"SETSPATTACK",	4,	6,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_setspattack},
{"SETSPADELAY", 4,	7,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_setspadelay},
{"SETPOISON",	4,	8,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_setpoison},
{"SETPOISONED",	4,	9,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_setpoisoned},
{"SETADVOBJ",	4,	10,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_setadvobj},
{"SETWIPE",		4,	11,	CMD_TARGETID1,	(CMD_DEFINE)&target_setwipe},
{"FULLSTATS",	4,	12,	CMD_TARGET,	(CMD_DEFINE)&target_fullstats},
{"HIDE",		4,	13,	CMD_TARGET,	(CMD_DEFINE)&target_hide},
{"UNHIDE",		4,	14,	CMD_TARGET,	(CMD_DEFINE)&target_unhide},
{"RELOADSERVER",4,	15,	CMD_FUNC,	(CMD_DEFINE)&command_reloadserver},
{"LOADDEFAULTS",4,	16,	CMD_FUNC,	(CMD_DEFINE)&command_loaddefaults},
{"CQ",			4,	17,	CMD_FUNC,	(CMD_DEFINE)&command_cq},
{"WIPENPCS",	4,	18,	CMD_FUNC,	(CMD_DEFINE)&command_wipenpcs},
{"CNEXT",		4,	19,	CMD_FUNC,	(CMD_DEFINE)&command_cnext},
{"CCLEAR",		4,	20,	CMD_FUNC,	(CMD_DEFINE)&command_cclear},
{"MINECHECK",	4,	21,	CMD_FUNC,	(CMD_DEFINE)&command_minecheck},
{"INVUL",		4,	22,	CMD_FUNC,	(CMD_DEFINE)&command_invul},
{"NOINVUL",		4,	23,	CMD_FUNC,	(CMD_DEFINE)&command_noinvul},
{"GUARDSON",	4,	24,	CMD_FUNC,	(CMD_DEFINE)&command_guardson},
{"GUARDSOFF",	4,	25,	CMD_FUNC,	(CMD_DEFINE)&command_guardsoff},
{"HOUSE",		4,	26,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_house},
{"ANNOUNCEON",	4,	27,	CMD_FUNC,	(CMD_DEFINE)&command_announceon},
{"ANNOUNCEOFF",	4,	28,	CMD_FUNC,	(CMD_DEFINE)&command_announceoff},
{"WF",			4,	29,	CMD_FUNC,	(CMD_DEFINE)&command_wf},
{"DECAY",		1,	22,	CMD_FUNC,	(CMD_DEFINE)&command_decay},
{"SPLIT",		4,	31,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_split},
{"SPLITCHANCE",	5,	0,	CMD_TARGETHTMP,	(CMD_DEFINE)&target_splitchance},
{"POSSESS",		5,	1,	CMD_TARGET,	(CMD_DEFINE)&target_possess},
{"KILLALL",		5,	3,	CMD_FUNC,	(CMD_DEFINE)&command_killall},
{"PDUMP",		5,	4,	CMD_FUNC,	(CMD_DEFINE)&command_pdump},
{"RENAME2",		5,	5,	CMD_FUNC,	(CMD_DEFINE)&command_rename2},
{"READSPAWNREGIONS",5,6,CMD_FUNC,	(CMD_DEFINE)&command_readspawnregions},
{"CLEANUP",		5,	7,	CMD_FUNC,	(CMD_DEFINE)&command_cleanup},
{"GY",			5,	8,	CMD_FUNC,	(CMD_DEFINE)&command_gy},
{"TILEW",		5,	9,	CMD_FUNC,	(CMD_DEFINE)&command_tilew},
{"SQUELCH",		5,	10,	CMD_FUNC,	(CMD_DEFINE)&command_squelch},
{"MUTE",		5,	10,	CMD_FUNC,	(CMD_DEFINE)&command_squelch},
{"TELESTUFF",	5,	11,	CMD_TARGET,	(CMD_DEFINE)&target_telestuff},
{"SPAWNKILL",	5,	12,	CMD_FUNC,	(CMD_DEFINE)&command_spawnkill},
{"SHOWPRIV3",	5,	13,	CMD_TARGET,	(CMD_DEFINE)&target_showpriv3},
{"NEWX",		5,	14,	CMD_TARGETX,	(CMD_DEFINE)&target_newx},
{"NEWY",		5,	15,	CMD_TARGETX,	(CMD_DEFINE)&target_newy},
{"NEWZ",		1,	14,	CMD_TARGETX,	(CMD_DEFINE)&target_newz},
{"INCX",		5,	16,	CMD_TARGETX,	(CMD_DEFINE)&target_incx},
{"INCY",		5,	17,	CMD_TARGETX,	(CMD_DEFINE)&target_incy},
{"INCZ",		6,	1,	CMD_TARGETX,	(CMD_DEFINE)&target_incz},

{"WANIM",		5,	18,	CMD_FUNC,	(CMD_DEFINE)&command_wanim},
{"READACCOUNTS",5,	20, CMD_FUNC,	(CMD_DEFINE)&command_readaccounts},
{"LETUSIN",     5,	21, CMD_FUNC,	(CMD_DEFINE)&command_letusin},
{"SERVERSLEEP", 5,	22, CMD_FUNC,	(CMD_DEFINE)&command_serversleep},
{"RELOADCACHEDSCRIPTS",5,23,CMD_FUNC,(CMD_DEFINE)&command_reloadcachedscripts},

{"SETMURDER",	5,	26, CMD_FUNC,	(CMD_DEFINE)&command_setmurder},//taken from 6904t2(5/10/99) - AntiChrist
{"GLOW",		5,	25,	CMD_TARGET, (CMD_DEFINE)&target_glow},
{"UNGLOW",		5,	26,	CMD_TARGET, (CMD_DEFINE)&target_unglow},
//{"SETMENUPRIV", 5,	27,	CMD_FUNC,	(CMD_DEFINE)&command_setmenupriv},
{"SHOWSKILLS",	5,	28,	CMD_TARGETX,(CMD_DEFINE)&target_showskills},
{"TILESCRIPT",	5,	29, CMD_FUNC,	(CMD_DEFINE)&command_tilescript},
{"KILLNPCS",	5,	30, CMD_FUNC,	(CMD_DEFINE)&command_killnpcs},
{"SWAP",		5,	31, CMD_FUNC,	(CMD_DEFINE)&command_swap},
{"REVERTSWAP",	6,	0,	CMD_TARGETX,(CMD_DEFINE)&target_setrevertswap},
{"CLONENPC",	6,	5,	CMD_TARGET4OPT,(CMD_DEFINE)&target_clonenpc},
{"KILLCLONES",	6,	6,	CMD_FUNC,   (CMD_DEFINE)&command_killclones},

{"DELID",		2,	35,	CMD_FUNC,	(CMD_DEFINE)&command_delid},
{"DELTYPE",		2,	36,	CMD_FUNC,	(CMD_DEFINE)&command_deltype},
{"SETSEASON",	2,	13,	CMD_FUNC,	(CMD_DEFINE)&command_setseason},
{"ECLIPSE",     1,  10, CMD_FUNC,   (CMD_DEFINE)&command_eclipse}, 
{"SYSM",        5,  8,  CMD_FUNC,   (CMD_DEFINE)&command_sysm},
{"SETHOME",		0,	14, CMD_TARGETXYZ,	(CMD_DEFINE)&target_sethome},
{"SETWORK",		0,	14, CMD_TARGETXYZ,	(CMD_DEFINE)&target_setwork},
{"SETFOOD",		0,	14, CMD_TARGETXYZ,	(CMD_DEFINE)&target_setfood},	
{"PASSWORD",	5,	19,	CMD_FUNC,		(CMD_DEFINE)&command_password},
{"GIFT",		6,	2,	CMD_FUNC,		(CMD_DEFINE)&command_gift},
{"SETI",		6,	3,	CMD_TARGETSTR,	(CMD_DEFINE)&target_seti},
{"ERASEACCOUNT",6,	4,	CMD_FUNC,		(CMD_DEFINE)&command_eraseaccount},
{"CREATEACCOUNT",6,	4,	CMD_FUNC,		(CMD_DEFINE)&command_createaccount},
{"QSFIMPORT",	6,	7,	CMD_FUNC,		(CMD_DEFINE)&command_qsfimport},
{"QSFEXPORT",	6,	7,	CMD_FUNC,		(CMD_DEFINE)&command_qsfexport},
{"QSFREMOVE",	6,	7,	CMD_FUNC,		(CMD_DEFINE)&command_qsfremove},
{"QSFWHERE",	6,	7,	CMD_FUNC,		(CMD_DEFINE)&command_qsfwhere},
{"MAKEPLAYERPOSFILE", 6,8, CMD_FUNC,	(CMD_DEFINE)&command_makeplayerposfile},
{"DEVTEST",		6,	9,	CMD_FUNC,		(CMD_DEFINE)&command_devtest},
{"PERMACT",		6,	10,	CMD_TARGET4OPT,	(CMD_DEFINE)&target_permact},
{"PRIVHIDE",	6,	11,	CMD_FUNC,		(CMD_DEFINE)&command_privhide},
{"MAPTRAVEL",   6,  12, CMD_FUNC,       (CMD_DEFINE)&command_maptravel}, 
{"CV",          6,  13, CMD_FUNC,       (CMD_DEFINE)&command_clientver},
{"GT",          6,  14, CMD_FUNC,		(CMD_DEFINE)&command_guildtalk},
{"XSAY",		6,	15,	CMD_TARGETSTR,	(CMD_DEFINE)&target_xsay},
{"SETSTATLIMITS",6,	16,	CMD_FUNC,		(CMD_DEFINE)&command_setstatlimits},
{"SHOWSTATLIMITS",6,16,	CMD_FUNC,		(CMD_DEFINE)&command_showstatlimits},
{"SSTATS",		6,	17,	CMD_FUNC,		(CMD_DEFINE)&command_sstats},
{NULL,		0,	0,	0,		NULL}			// Tseramed, cleaner
};

// note: 6,7: last meta gm priv level

static char *ch="abcdefg";

/* Actual commands go below. Define all the dynamic command_ functions as
 * the name of the function in lowercase, a void function, accepting one
 * integer, which is the player # that sent the command.
 * Like this:
 * void command_rain(int s)
 *
 * If you stick comments (double-slash comments) between the function definition
 * and the opening block, they will automatically be used as the
 * HTML documentation for that command. The first line will be used as the
 * short documentation, any subsequent lines will be used as a seperate
 * "more info" page for your command. HTML is allowed, but remember that
 * everything is fit into a template.
 */


void command_clientver(UOXSOCKET s)
{
  char tmp[512];
  sprintf(tmp,"[%s]", clientData[s].clientVersion.c_str());
  sysmessage(s,"you are using client version");
  sysmessage(s, tmp);
  sprintf(tmp,"Nr:[%i] 3D:[%i]", ClientVersion->getClientNr(clientData[s].clientVersion), ClientVersion->get3DNess(clientData[s].clientVersion));
  sysmessage(s,tmp);

  //updates(s);
}

// When player has been murdered and they are 
// a ghost, they can use the bounty command to 
// place a bounty on the murderers head

void command_bounty(UOXSOCKET s)
{
	// Check if boountys are active
	
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	if ( !SrvParms->bountysactive )
	{
		sysmessage(s, "The bounty system is not active.");
		return;
	}
	
	if ( !Player->dead )
	{
		sysmessage(s, "You can only place a bounty while you are a ghost.");
		Player->murdererSer = 0;
		return;
	}
	
	if ( Player->murdererSer == 0 )
	{
		sysmessage(s, "You can only place a bounty once after someone has murdered you.");
		return;
	}
	
	if ( tnum == 2 )
	{
		int nAmount = makenumber(1);
		if ( BountyWithdrawGold( Player, nAmount ) )
		{
			P_CHAR Murderer = FindCharBySerial(Player->murdererSer);
			if ( BountyCreate( Murderer, nAmount ) )
			{
				sprintf( temp, "You have placed a bounty of %d gold coins on %s.", nAmount, Murderer->name );
				sysmessage( s, temp );
			}
			else
				sysmessage( s, "You were not able to place a bounty (System Error)" );
			
			// Set murdererSer to 0 after a bounty has been 
			// placed so it can only be done once
			Player->murdererSer = 0;
		}
		else
			sysmessage( s, "You do not have enough gold to cover the bounty.");
		
	}
	else
		sysmessage(s, "To place a bounty on a murderer, use BOUNTY <amount>");	
}


void command_maptravel(UOXSOCKET s)
{
	int map;
	if (tnum==2)
	{
		map = makenumber(1);
		if (map<0 || map>3) { sysmessage(s,"invalid map"); return; }
		
		P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
		cCoord newPos(Player->pos);
		newPos.map = map;

		SndNewMap(s, map);

		Player->teleTo(newPos);		
		Player->teleTo(newPos); // note this is no typo/bug, we absolutly need to resend all players/items TWICE on maptravel. that's a client odditiy
	}
}

void command_serversleep(UOXSOCKET s)
{
	int seconds;
	unsigned int a;
	
	if (tnum==2)
	{
		seconds = makenumber(1);
		sprintf(temp,"server is going to sleep for %i seconds!",seconds);
		
		sysbroadcast(temp); // broadcast server sleep
		for (a=0; a<now; a++) // make sure all send buffers are flushed (=the messages are really send beffore server sleeps)
		{
			if (perm[a]) PacketSender.FlushBuffers(a);
		}
		
		seconds=seconds*1000; 
		
		Sleep(seconds);
		
		sprintf(temp,"server is back from a %i second break",seconds/1000);
		
		sysbroadcast(temp); 
		for (a=0; a<now; a++) // not absolutely necassairy ..
		{
			if (perm[a]) PacketSender.FlushBuffers(a);
		}
		
	}
	else sysmessage(s,"invalid number of arguments");
	
}

void command_makeplayerposfile(UOXSOCKET s)
{
	makePlayerPosFile();
	sysmessage(s, "Player Posfile succsessfully created!");
}

void command_reloadcachedscripts(UOXSOCKET s)
{
	Titles->Reload();
	loadregions();
	loadspawnregions();
	OldMagic->InitSpells();
	loadmetagm();
	SkillManager->loadskills();
	read_in_teleport(); // hope i've cought all  ...
	Network->LoadHosts_deny();

	sysmessage(s,"Cached scripts reloaded");
}

// Returns the current bulletin board posting mode for the player
void command_post(UOXSOCKET s)
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	strcpy( temp, "You are currently posting " );
	
	switch( Player->postType )
	{
	case LOCALPOST:
		strcat( temp, "a message to a single board [LOCAL]." );
		break;
		
	case REGIONALPOST:
		strcat( temp, "a message to all boards in this area [REGIONAL]." );
		break;
		
	case GLOBALPOST:
		strcat( temp, "a message to all boards in the world [GLOBAL]." );
		break;
		
	default:
		strcat( temp, "an unknown message type. Setting to normal [LOCAL]." );
		Player->postType = LOCALPOST;
	}
	
	sysmessage( s, temp );
}

// Sets the current bulletin board posting mode for the player to GLOBAL
// ALL bulletin boards will see the next message posted to any bulletin board
void command_gpost(UOXSOCKET s)
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	Player->postType = GLOBALPOST;
	sysmessage( s, "Now posting GLOBAL messages." );
}

// Sets the current bulletin board posting mode for the player to REGIONAL
// All bulletin boards in the same region as the board posted to will show the
// next message posted
void command_rpost(UOXSOCKET s)
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	Player->postType = REGIONALPOST;
	sysmessage( s, "Now posting REGIONAL messages." );
}

// Sets the current bulletin board posting mode for the player to LOCAL
// Only this bulletin board will have this post
void command_lpost(UOXSOCKET s)
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	Player->postType = REGIONALPOST;
	sysmessage( s, "Now posting LOCAL messages." );
}

// taken from 6904t2(5/10/99) - AntiChrist
void command_setmurder(UOXSOCKET s)
{
	if ( tnum == 2 )
	{
		addmitem[s]=makenumber(1);
		target(s, 240, "Select the person to set the murder count of: ");
	}
}

/*
void command_setacct(UOXSOCKET s)
{

}

void command_addacct(UOXSOCKET s)
{

}

void command_banacct(UOXSOCKET s)
{

}

void command_unbanacct(UOXSOCKET s)
{

}

void command_removeacct(UOXSOCKET s)
{

}*/


// bug clearing if players get account already in use for no reason.
// that bug should be gone in 11.9 but I got a bit paranoid bout it. LB
void command_letusin(UOXSOCKET s)
{
	int a,x;
	for (a=0,x=0; a<MAXCLIENT; a++) // maxclient instead of now is essential here !
	{
		if ( acctno[a]>=0 )
		{
			Accounts->SetOffline(acctno[a]);
			x++;
		}
	}
	
	sprintf(temp,"command successfull, cleared %i poor souls",x);
	sysmessage(s, temp);
}

void command_readaccounts(UOXSOCKET s)
{
	Accounts->LoadAccounts();
	sysmessage(s,"Accounts reloaded...attention, if you changed existing(!) account numbers you should use the letusin command afterwards ");
}

void command_showp(UOXSOCKET s)
// Displays hex values of your PRIV3 settings.
{
    P_CHAR Player=MAKE_CHARREF_LR(currchar(s));

	int i;
	for (i=0;i<7;i++) 
	{
		sprintf(temp,"priv3%c : %X ", ch[i],Player->priv3[i]);
		sysmessage(s,temp);
	}
}


void command_setpriv3(UOXSOCKET s)
// Alter GM Command Privs
// <P>The Setpriv3 command has 3 different formats:</P>
// <UL>
// <LI><B>One argument</B> - Set priv3 to a template found in the game script.</LI>
// <LI><B>Two arguments</B> - SETPRIV3 [+ or -] COMMAND, example: To allow a user to
// have access to the SAVE command, use <B>SETPRIV3 + SAVE</B>, to take awake a
// user's access to MAKECNS, use <B>SETPRIV3 - MAKECNS</B></LI>
// <LI><B>Six or Seven Arguments</B> - Manually set the entire setpriv3
// structure as a sequence of six or seven eight-digit hexadecimal
// numbers.</LI>
// </UL>
// <P>For more information on Meta-GM permissions, check out
// <A HREF="http://stud4.tuwien.ac.at/%7Ee9425109/uox3_1.htm">
// Lord Binary's UOX Site</A>.</P>
{
	int y, z;
	unsigned int i;
	int loopexit=0;

    P_CHAR Player=MAKE_CHARREF_LR(currchar(s));

	switch(tnum)
	{
	case 7:
	case 8:
		if (SrvParms->gm_log) { sprintf(temp,"%s.log",Player->name); savelog("setpriv3 executed!\n",temp); }
		priv3a[s]=hexnumber(1);
		priv3b[s]=hexnumber(2);
		priv3c[s]=hexnumber(3);
		priv3d[s]=hexnumber(4);
		priv3e[s]=hexnumber(5);
		priv3f[s]=hexnumber(6);
		if (tnum==8) priv3g[s]=hexnumber(7);
		else priv3g[s]=0;
		target(s, 250, "Select player to set command clearance");
		break;
	case 2:
		y=makenumber(1);
		if (SrvParms->gm_log) { sprintf(temp,"%s.log",Player->name); savelog("setpriv3 executed!\n",temp); }
		//AntiChrist-this was metagm[y%255]-
		if (y>255)
		{
			LogError("setpriv3-command: avoiding crash. argument was >255!\n");
			sysmessage(s,"Setpriv3-command argument has to be between 0 and 255.");
			return;
		}
		priv3a[s]=metagm[y][0];
		priv3b[s]=metagm[y][1];
		priv3c[s]=metagm[y][2];
		priv3d[s]=metagm[y][3];
		priv3e[s]=metagm[y][4];
		priv3f[s]=metagm[y][5];
		priv3g[s]=metagm[y][6];
		target(s, 250, "Select player to set command clearance");
		break;
	case 3:	/* new code to allow + COMMAND or - COMMAND 07/24/99 */
		if (!strcmp((char*)comm[1], "+") || !strcmp((char*)comm[1], "-"))
		{
			y=comm[1][0]=='+' ? 1 : 0;
			for (i=0;i<strlen((char*)comm[2]);i++)
			{
				comm[2][i]=toupper(comm[2][i]);
			}
			i=0; z=-1;
			loopexit=0;
			while((command_table[i].cmd_name)&&(z==-1) && (++loopexit < MAXLOOPS))
			{
				if (!strcmp((char*)command_table[i].cmd_name, (char*)comm[2])) z=i;
				i++;
			}
			if (z==-1)
			{
				sysmessage(s, "That command doesn't exist.");
			} else if (command_table[z].cmd_priv_m==255)
			{
				sysmessage(s, "No special permissions are neccessary to use that command.");
			} else
			{
				addx[s]=z;
				addy[s]=y;
				sprintf(temp, "Select player to alter %s command access.", command_table[z].cmd_name);
				target(s, 225, temp);
			}
		} else {
			sysmessage(s, "2-Argument Usage: /SETPRIV3 +/- COMMAND");
		}
		break;
	default:
		sysmessage(s, "This command takes 1, 2, 6, or 7 arguments.");
		break;
	}
}

void command_resend(UOXSOCKET s)
// Resends server data to client.
{
	all_items(s);
	LogMessage("ALERT: all_items() called in command_resend().\nThis function could cause a lot of lag!\n");
	P_CHAR pc=MAKE_CHARREF_LR(currchar(s));
	teleport(pc, pc->pos);
}

void command_teleport(UOXSOCKET s)
{
	P_CHAR pc=MAKE_CHARREF_LR(currchar(s));
	teleport(pc, pc->pos); 
}

void command_where(UOXSOCKET s)
// Prints your current coordinates+region.
// added region-name too, LB
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));

	if (strlen(region[Player->region].name)>0)
		sprintf(temp, "You are at: %s",region[Player->region].name); 
	else
		strcpy(temp,"You are at: unknown area");
	sysmessage(s,temp);

	sprintf(temp, "%i %i (%i)",Player->pos.x,Player->pos.y,Player->pos.z); 
	sysmessage(s,temp);
}

void command_q(UOXSOCKET s)
// Shows the GM or Counsellor queue.
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));

	if (!Player->isGM()) //They are not a GM
	{
		Commands->ShowGMQue(s, 0);
	}
	else
	{
		Commands->ShowGMQue(s, 1); // They are a GM
	}
}


void command_next(UOXSOCKET s)
// For Counselors or GM's, goes to next call in queue.
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	if (!Player->isGM()) //They are not a GM
	{
		Commands->NextCall(s, 0);
	}
	else
	{
		Commands->NextCall(s, 1); // They are a GM
	}
}

void command_clear(UOXSOCKET s)
// For Counselor's and GM's, removes current call from queue.
{
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s));
	
	if (!Player->isGM()) //They are not a GM
	{
		donewithcall(s, 0);
	}
	else
	{
		donewithcall(s, 1); // They are a GM
	}
}

void command_goplace(UOXSOCKET s) 
// (d) Teleports you to a location from the LOCATIONS.SCP file. 
{ 
	P_CHAR Player=MAKE_CHARREF_LR(currchar(s)); 
	
	if (tnum==2) 
	{ 
		Commands->MakePlace(s, makenumber(1)); 
		if (addx[s]!=0) 
		{ 
			////////////////////////////////// 
			// Adding the gmmove effects..Aldur 
			doGmMoveEff(s); 
			cCoord newPos(addx[s],addy[s],addz[s],DEFAULT_MAP);
			Player->teleTo(newPos); 
			doGmMoveEff(s); 
		} 
	} 
}

void command_gochar(UOXSOCKET s) 
// (h h h h) Teleports you to another character. 
{ 
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s)); 
	P_CHAR pc; 
	
	if (tnum == 5) 
	{ 
		int serial = calcserial(hexnumber(1), hexnumber(2), hexnumber(3), hexnumber(4));
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++) 
		{ 
			if (pc->serial == serial) 
			{ 
				doGmMoveEff(s);		// Adding the gmmove effects ..Aldur
				Player->teleTo(pc->pos); 
				doGmMoveEff(s); 
				break;
			} 
		} 
	} 
	else if (tnum == 2) 
	{ 
		UOXSOCKET si = makenumber(1);
		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			if (si == api.getSocket()) 
			{ 
				doGmMoveEff(s);		// Adding the gmmove effects ...Aldur
				Player->teleTo(pc->pos);
				doGmMoveEff(s);
				break;
			} 
		} 
	} 
}

void command_fix(UOXSOCKET s)
// Try to compensate for messed up Z coordinates. Use this if you find yourself half-embedded in the ground.
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	
	if (tnum == 2)
	{
		if (validtelepos(s)==-1)
		{
			Player->dispz = Player->pos.z = makenumber(1);
		}
		else
		{
			Player->dispz = Player->pos.z = validtelepos(s);
		}

		teleport(Player, Player->pos); // only x/y used for old coords, we changed only z, so can use new for old coords param
	}
}

void command_xgoplace(UOXSOCKET s)
// (d) Send another character to a location in your LOCATIONS.SCP file.
{
	if (tnum==2)
	{
		Commands->MakePlace(s, makenumber(1));
		if (addx[s]!=0)
		{
			target(s, 8, "Select char to teleport.");
		}
	}
}

void command_showids(UOXSOCKET s)
// Display the serial number of every item on your screen.
{
	cChar* Player = MAKE_CHARREF_LR(currchar(s));

	cChar* pc;
	int loopexit=0;
	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (inrange1p(Player, pc)) 
			Titles->ShowCname(s, Player, pc, 1);
	}
}

void command_poly(UOXSOCKET s)
// (h h) Polymorph yourself into any other creature.
{
	if (tnum==3)
	{
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		int k=(hexnumber(1)<<8)+hexnumber(2);
		if (k>=0x000 && k<=0x3e1) // lord binary, body-values >0x3e crash the client
			
		{ 
			Player->setXid(k); // allow only non crashing ones
			Player->setId(k);
			
			unsigned short color = Player->skin; // transparency for mosnters allowed, not for players, 
			// if polymorphing from monster to player we have to switch from transparent to semi-transparent
			// or we have that sit-down-client crash
			if ((color&0x4000) && (k >=0x0190 && k<=0x03e1))
			{
				if (color!=0x8000)
				{
					Player->skin = Player->xskin = 0xF000;
				}
			}
		}
		updatechar(Player);
	}
}

void command_skin(UOXSOCKET s)
// (h h) Change the hue of your skin.
{
	if (tnum == 3)
	{
		int k, b, body;
		
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

		body = Player->id();
		k = (hexnumber(1) << 8) + hexnumber(2);
		b = k&0x4000; 
		if (b == 16384 &&(body >=0x0190 && body <= 0x03e1))
			k = 0xf000; 
		
		if (k != 0x8000)
		{	
			Player->skin = Player->xskin = k;
			updatechar(Player);
		}
	}
}

void command_action(UOXSOCKET s)
// (h) Preform an animated action sequence.
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (tnum==2) Player->DoAction(hexnumber(1));
}

void command_setseason(UOXSOCKET s)
// Sets the season globally
// Season change packet structure:
// BYTE 0xBC	(Season change command)
// BYTE season	(0 spring, 1 summer, 2 fall, 3 winter, 4 dead, 5 unknown (rotating?))
// BYTE unknown	If 0, cannot change from undead, so 1 is the default
{
	if (tnum==2)
	{
		timeLight.season = hexnumber(1);
		P_CHAR pc;
		AllPlayersIterator api;
		for (pc = api.First(); pc != NULL; pc = api.Next())
		{
			SndSeason(api.getSocket());
			sysmessage(s, "Season set");
		}
	}
	else
		sysmessage(s, "Setseason takes one argument.");	
}

void command_xtele(UOXSOCKET s)
// (d / h h h h / nothing) Teleport a player to your position.
// <UL><LI>If you specify nothing (/XTELE), you click on the player to teleport in.</LI>
// <LI>If you specify a serial number (/XTELE .. .. .. ..), you teleport that player to you.</LI>
// <LI>If you specify a single number (/XTELE ..), you teleport the player logged in
// under that slot to you.</LI>
// </UL>
{
	if (tnum==5 || tnum==2)
	{
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		Targ->XTeleport(s, Player, tnum);
	}
	else
	{
		target(s, 136, "Select char to teleport to your position.");
	}
}

void command_go(UOXSOCKET s) 
// (d d d [d]) Go to the specified X/Y/Z[/map] coordinates 
{ 
	if (tnum==4 || tnum == 5) 
	{ 
		int x=makenumber(1);int y=makenumber(2);int z=makenumber(3); // LB 
		if (x<6144 && y<4096 && z>-127 && z<128) 
		{
			P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
			int nmap = (tnum==5) ? makenumber(4) : Player->pos.map;
			cCoord newPos(x,y,z,nmap);

			bool travel = (nmap == Player->pos.map) ? false : true;	// do we change maps ??

			doGmMoveEff(s); 	// Adding the gmmove effects ..Aldur
			if (travel) { SndNewMap(s,nmap); Player->teleTo(newPos);} // note: two teleto's in case of map change absoultly necassairy, no bug !!! (client oddity on map-switch)
			Player->teleTo(newPos);			
			doGmMoveEff(s);
		} 
	} 
}

void command_setstatlimits(UOXSOCKET s) 
// (d d d [d]) Go to the specified X/Y/Z[/map] coordinates 
{ 
	if (tnum!=4) return;

	int x=makenumber(1);
	int y=makenumber(2);
	int z=makenumber(3);

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if ((x == 0) && (y == 0) && (z == 0))
	{ // remove individual limits
		Player->setStrLimit(x);
		Player->setDexLimit(y);
		Player->setIntLimit(z);
		return;
	}

	if (x<1) x=1;
	if (y<1) y=1;
	if (z<1) z=1;

	if (x	  >SrvParms->statcap) x=SrvParms->statcap-2;
	if (x+y	  >SrvParms->statcap) y=SrvParms->statcap-x-1;
	if (x+y+z >SrvParms->statcap) z=SrvParms->statcap-y-x;

	char msg[128];


	Player->setStrLimit(x);
	Player->setStr(x);
	sprintf(msg,"Strength limited to %d",Player->getStrLimit());
	sysmessage(s,0x127,msg);

	Player->setDexLimit(y);
	Player->setDex(y);
	sprintf(msg,"Dexerty limited to %d",Player->getDexLimit());
	sysmessage(s,0x127,msg);

	Player->setIntLimit(z);
	Player->setInt(z);
	sprintf(msg,"Intelligence limited to %d",Player->getIntLimit());
	sysmessage(s,0x127,msg);


}

void command_showstatlimits(UOXSOCKET s) 
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	char msg[128];

	sysmessage(s,0x127,"Your statlimits are set to:");
	sprintf(msg,"Strength: %d",Player->getStrLimit());
	sysmessage(s,0x127,msg);
	sprintf(msg,"Dexerty: %d",Player->getDexLimit());
	sysmessage(s,0x127,msg);
	sprintf(msg,"Intelligence: %d",Player->getIntLimit());
	sysmessage(s,0x127,msg);
	sprintf(msg,"Sum of all stats is limited to: %d",SrvParms->statcap);
	sysmessage(s,0x127,msg);

}

void command_zerokills(UOXSOCKET s)
// Sets all PK counters to 0.
{
	sysmessage(s,"Zeroing all player kills...");
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
	{
		pc->kills=0;
		setcharflag(pc);//AntiChrist
	}		
	sysmessage(s, "All player kills are now 0.");
}

void command_tile(UOXSOCKET s)
// (h h) Tiles the item specified over a square area.
// To find the hexidecimal ID code for an item to tile,
// either create the item with /add or find it in the
// world, and get /ISTATS on the object to get it's ID
// code.
{
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		clickx[s]=-1;
		clicky[s]=-1;
		target(s,198,"Select first corner of bounding box.");  // 198 didn't seem taken...
	}
}

void command_tilescript(UOXSOCKET s)
// (D) Tiles the item specified over a square area.
// tilenumer D (dec) is taken from itemscript
{
	if (tnum==2)
	{
		addx2[s]=makenumber(1);						
		clickx[s]=-1;
		clicky[s]=-1;
		target(s,299,"Select first corner of bounding box for tilescript.");
	}
}

void command_killnpcs(UOXSOCKET s)
{
	if (tnum==1)
	{			
		clickx[s]=-1;
		clicky[s]=-1;
		target(s,300,"Select first corner of bounding box for killnpcs.");
	}
}

void command_swap(UOXSOCKET s)
{
	if (tnum==2)
	{			
		clickx[s]=-1; // damn multipurpose global array. stroring serials here, hence it has to be int
		// clickx,y IS int, so no prob. but for x,y only short required. 
		// DONT change it short cauze used here
		
		addx2[s]=makenumber(1);	
		target(s,301,"Select target creature");
	}
	else 
		sysmessage(s, "you haven't selected a swap duration");
}



void command_wipe(UOXSOCKET s)
// (d d d d / nothing) Deletes ALL NPC's and items inside a specified square.
// <UL><LI>With no arguments, /WIPE will ask you to click in opposing corners of
// the square.</LI>
// <LI>You may also specify coordinates - X1, Y1, X2, Y2.</LI>
// </UL>
{
	addid1[s]=0; // addid1[s]==0 is used to denote a true wipe
	if (tnum==1)
	{
		clickx[s]=-1;
		clicky[s]=-1;
		target(s,199,"Select first corner of wiping box.");  // 199 didn't seem taken...
	}
	else if (tnum==2)
	{
		mstring dummy = Commands->params[1];
		dummy.lower();
		if (!strcmp("all", dummy.c_str()))
		{
			// Really should warn that this will wipe ALL objects...
			Commands->Wipe(s);
		}
	}
	else if (tnum==5)
	{ // Wipe according to world coordinates
		cRectangle rect(makenumber(1),makenumber(2),makenumber(3),makenumber(4));
		Commands->PartialWipe(s,rect,false);
	}
}

void command_killclones(UOXSOCKET s)
{	
	int cnt=0;
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc = aci.GetData()) != aci.End(); aci++)
	{
		if ( pc->npc && pc->account<0 )
		{			  			   
			if (pc->isclone)
			{
				cnt++;						
				Npcs->DeleteChar(pc);
			}
			
		}
	}

	sprintf(temp,"All Britannian clones killed (%i)", cnt);
	sysmessage(s,temp);
}

void command_iwipe(UOXSOCKET s)
// (d d d d / nothing) Deletes ALL NPC's and items NOT inside a specified square.
// <UL><LI>With no arguments, /IWIPE will ask you to click in opposing corners of
// the square.</LI>
// <LI>You may also specify coordinates - X1, Y1, X2, Y2.</LI>
// </UL>
{
	addid1[s]=1;  // addid1[s]==1 is used to denote the INVERSE wipe
	if (tnum==1)
	{
		clickx[s]=-1;
		clicky[s]=-1;
		target(s,199,"Select first corner of inverse wiping box.");  // 199 didn't seem taken...
	}
	else if (tnum==2)
	{
		mstring dummy = Commands->params[1];
		dummy.lower();
		if (!strcmp("all", dummy.c_str()))
		{
			sysmessage(s,"Well aren't you the funny one!");
		}
	}
	else if (tnum==5)
	{ // Wipe according to world coordinates
		cRectangle rect(makenumber(1),makenumber(2),makenumber(3),makenumber(4));
		Commands->PartialWipe(s,rect,true);
	}
}

void command_add(UOXSOCKET s)
// (h h) Adds a new item, or opens the GM menu if no hex codes are specified.
{
	if (tnum==2 || tnum>3)//AntiChrist
	{
		sysmessage(s,"Syntax error. Usage: /add <id1> <id2>");
		return;
	} 
	else if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		if (addid1[s]<0x40) target(s, 0, "Select location for item.");		
	}
	else if (tnum==1)
	{
	  //itemmenu(s, 1);
	  CAddMenu *Grr = new CAddMenu(1, -1);
	  Grr->showAddGump(s);
	  delete Grr;
	}	

}

void command_addx(UOXSOCKET s)
// (h h) Adds a new item to your current location.
{
	if (tnum==3)
	{
		addid1[s] = (unsigned char) hexnumber(1);
		addid2[s] = (unsigned char) hexnumber(2);
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		Commands->AddHere(s, Player->pos.z);
	}
	if (tnum==4)
	{
		addid1[s] = (unsigned char) hexnumber(1);
		addid2[s] = (unsigned char) hexnumber(2);
		Commands->AddHere(s, makenumber(3));
	}
}

void command_rename(UOXSOCKET s)
// (text) Renames any dynamic item in the game.
{
	if (tnum>1)
	{
		addx[s]=0;	// addx[s] = 1 will set name2
		strcpy(xtext[s], Commands->GetAllParams().c_str());
		target(s, 1, "Select item or character to rename.");
	}
}

void command_rename2(UOXSOCKET s)
// (text) Rename an item or character.
{
	if (tnum>1)
	{
		addx[s]=1;
		strcpy(xtext[s], Commands->GetAllParams().c_str());
		target(s,  1, "Select item or character to rename.");
	} 
	return;
}

void command_title(UOXSOCKET s)
// (text) Changes the title of any player or NPC.
{
	if (tnum>1)
	{
		strcpy(xtext[s], Commands->GetAllParams().c_str());
		target(s, 47, "Select character to change the title of.");
	}
}


void command_save(UOXSOCKET s)
// Saves the current world data into ITEMS.WSC and CHARS.WSC.
{
	sysmessage(s, "Initialising World Data save...");
	cwmWorldState->savenewworld(1);
	sysmessage(s, "World has been saved successfully!");
}

void command_dye(UOXSOCKET s)
// (h h/nothing) Dyes an item a specific color, or brings up a dyeing menu if no color is specified.
{
	dyeall[s]=1;
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
	}
	else
	{
		addid1[s]=255;
		addid2[s]=255;
	}
	target(s,  4, "Select item to dye.");
}

void command_wtrig(UOXSOCKET s)
// (word) Sets the trigger word on an NPC.
{
	if (tnum>1)
	{
		strcpy(xtext[s], &tbuffer[7]);
		target(s,  203, "Select the NPC to set trigger word on.");
	}
}

void command_setpriv(UOXSOCKET s)
// (Chars/NPCs: h h, Objects: h) Sets priviliges on a Character or object.
{
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		target(s,  9, "Select char to edit priv.");
	}
	if (tnum==2)
	{
		addid1[s]=3;
		addid2[s]=hexnumber(1);
		target(s,  89, "Select object to edit priv.");
	}
}

void command_nodecay(UOXSOCKET s)
// Prevents an object from ever decaying.
{
	addid1[s]=0; 
	target(s, 89, "Select object to make permenant.");
}

void command_send(UOXSOCKET s)
// Debugging command
{
	int i;
	if (tnum<=2) return;
	temp[0]=hexnumber(1);
	temp[1]=hexnumber(2);
	if (temp[0]!=0x69) return; // kindersicherung / magic number ;)	

	switch(temp[1])		
	{
	   case 1: // raw data via console (0x69 0x1 raw data)
		   for (i=3;i<tnum;i++) temp[i-3]=hexnumber(i);
		   sysmessage(s,"Mode1: Raw data send to client");
		   //Xsend(s, temp, tnum-3); // need rewrite for new packet send stuff, currently no need for it and time		   		  
		   break;

	   case 2: // raw data via dump file (0x69 0x2 filename)

		   char t[512];
		   char *buff, *buff2;
		   buff= new char[128*1024]; // 128kb dump file max
		   buff2=new char[128*1024];

		   makestring(3, t, false); // get dump file

		   FILE *f;
		   f = fopen(t,"rb");
		   if (f==NULL) 
		   {
			   delete[] buff;
			   delete[] buff2;
			   return;
		   }

		   int so = fread(buff, sizeof(char), 127*1024, f);
		   fclose(f);
		   if (so<=0) return;
		   buff[so]=0;

		   // tokenize string
           char *token;
		   char seps[]   = " ";
		   char *r;
           token = strtok( buff, seps );
		   int x=0;

           while( token != NULL )
		   {     
              int i=-1;
			  r = strstr(token, ":");
			  if (r==NULL) sscanf(token, "%x", &i);
			  if (i!=-1) 
			  {
				  //Xsend(s, &i, 1);
				  buff2[x++]=i;				 
			  }

              token = strtok( NULL, seps );
		   }
			  
		   int a;
		   printf("\n");
		   for (a=0; a<x; a++)
		   {
			   printf("%02x ", buff2[a]);
			   if (((a+1)%20)==0) printf("\n");
		   }
		   printf("\n");
		      		
		   delete[] buff2;
		   delete[] buff;	
		  
		   break;

	}
}

void command_showtime(UOXSOCKET s)
// Displays the current UO time.
{
	if (timeLight.ampm || (!timeLight.ampm && timeLight.hour==12))
		sprintf(temp, "%s %2.2d %s %2.2d %s", "LoneWolf: Time: ", timeLight.hour, ":", timeLight.minute, "PM");
	else
		sprintf(temp, "%s %2.2d %s %2.2d %s", "LoneWolf: Time: ", timeLight.hour, ":", timeLight.minute, "AM");
	sysmessage(s,temp);
}

void command_settime(UOXSOCKET s)
// (d d) Sets the current UO time in hours and minutes.
{
	int newhours, newminutes;
	if (tnum==3)
	{
		newhours = makenumber(1);
		newminutes = makenumber(2);
		if ((newhours < 25) && (newhours > 0) && (newminutes > -1) && (newminutes <60))
		{
			if (newhours > 12)
			{
				timeLight.ampm=1;
				timeLight.hour=newhours-12;
			}
			else
			{
				timeLight.ampm=0;
				timeLight.hour=newhours;
			}
			timeLight.minute=newminutes;
		}
	}
}

void command_shutdown(UOXSOCKET s)
// (d) Shuts down the server. Argument is how many minutes until shutdown.
{
	if (tnum==2)
	{
		endtime=uiCurrentTime+(MY_CLOCKS_PER_SEC*makenumber(1));
		if (makenumber(1)==0)
		{
			endtime=0;
			sysbroadcast("Shutdown has been interrupted.");
		}
		else endmessage(0);
	}
}

void command_wholist(UOXSOCKET s)
// Same as playerlist but has offline players...Ripper
{
	char x[256];
	int f;
	makestring(1,x);
	if (tnum!=2) x[0]=0;
	if (tnum==3) f=makenumber(2); else f=-1;
	whomenu(s, 4, x,f);
}

void command_playerlist(UOXSOCKET s)
{ // Brings up an interactive listing of online users.
	char x[256];
	makestring(1,x);
	if (tnum!=2) x[0]=0;
	playermenu(s, 4, x);
}


void command_sfx(UOXSOCKET s)
// (h h) Plays the specified sound effect.
{
	if (tnum==3)
	{
		soundeffect(s, hexnumber(1), hexnumber(2));
	}
}

void command_light(UOXSOCKET s)
// (h) Sets the light level. 0=brightest, 15=darkest, -1=enable day/night cycles.
{
	if (tnum==2)
	{
		timeLight.worldfixedlevel=hexnumber(1);
		if (timeLight.worldfixedlevel!=255) setabovelight(timeLight.worldfixedlevel,-1);
		else setabovelight(timeLight.worldcurlevel,-1);
		sprintf(temp, "lightlevel: %i set globally\n", timeLight.worldfixedlevel);
		sysmessage(s, temp);
	}
	
	if (tnum==3)
	{
		unsigned char level=hexnumber(1);
		int reg=hexnumber(2);
		
		if (reg<0 || reg>255)
		{
			sysmessage(s,"invalid region");
			return;
		}
		
		sprintf(temp, "lightlevel: %i set for region: %s\n", level, region[reg].name);
		sysmessage(s, temp);
		
		region[reg].fixedlight=level;
		
		if (level!=255) setabovelight(level,reg);
		else setabovelight(region[reg].curlight,reg);
	}
}

void command_disconnect(UOXSOCKET s)
// (d) Disconnects the user logged in under the specified slot.
{
	if (tnum==2) Network->Disconnect(makenumber(1));
}

void command_tell(UOXSOCKET s)
// (d text) Sends an anonymous message to the user logged in under the specified slot.
{
	if (tnum>2) 
	{ 
		mstring dummy = Commands->GetAllParams();
		int m = makenumber(1);
		if (m<0) sysbroadcast(dummy.c_str()); else
		tellmessage(s, makenumber(1), (char*) dummy.c_str());
	}
}

void command_dry(UOXSOCKET s)
// Set weather to dry (no rain or snow).
{
   sysmessage(s,"Being Worked On!\n");
/*	int i;
	wtype=0;
	for (i=0;i<now;i++) if (perm[i]) weather(i,0);*/
}

void command_rain(UOXSOCKET s)
// Sets the weather condition to rain.
{
   sysmessage(s,"Being Worked On!\n");
/*		int i;
		if (wtype==2)
		{
		   wtype=0;
		   for (i=0;i<now;i++) if (perm[i]) weather(i,0);
		}
		wtype=1;
		for (i=0;i<now;i++) if (perm[i]) weather(i,0); */

}

void command_snow(UOXSOCKET s)
// Sets the weather condition to snow.
{
   sysmessage(s,"Being Worked On!\n");
/*	int i;
	if (wtype==1)
	{
		wtype=0;
		for (i=0;i<now;i++) if (perm[i]) weather(i,0);
	}
	wtype=2;
	for (i=0;i<now;i++) if (perm[i]) weather(i,0);*/
}

void command_gmmenu(UOXSOCKET s)
// (d) Opens the specified GM Menu.
{
	if (tnum==2) gmmenu(s, makenumber(1));
}

void command_itemmenu(UOXSOCKET s)
// (d) Opens the specified Item Menu from ITEMS.SCP.
{
	if (tnum==2) itemmenu(s, makenumber(1));
}

void command_additem(UOXSOCKET s)
// (d) Adds the specified item from ITEMS.SCP.
{
//	if (tnum<2 || tnum>3) return;
	if (tnum==2)
	{
		addmitem[s] = makenumber(1); // Anthracks' fix
		sprintf(temp, "Select location for item. [Number: %i]", addmitem[s]);
		target(s,  26, temp);
	}
}

void command_dupe(UOXSOCKET s)
// (d / nothing) Duplicates an item. If a parameter is specified, it's how many copies to make.
{
	if (tnum==2)
		addid1[s]=makenumber(1);
	else
		addid1[s]=1;

	target(s,  110, "Select an item to dupe.");
}


void command_command(UOXSOCKET s)
// Executes a trigger scripting command.
{
	int i;
	if (tnum>1)
	{
		i=0;
		script1[0]=0;
		script2[0]=0;
		strcpy(script1, Commands->params[1].c_str());
		if (Commands->params.size() > 2)
			strcpy(script2, Commands->params[2].c_str());

		if (!strcmp("ADDITEM", script1))	// bughunting, Duke, 5.6.2003
			LogAssert(itemmake[s].maxskill!=0);

		scriptcommand(s, script1, script2);
	}
}

void command_gcollect(UOXSOCKET s)
// Runs garbage collection routines.
{
	gcollect();
	sysmessage(s,"command succesfull");
}

void command_allmoveon(UOXSOCKET s)
// Enables GM ability to pick up all objects.
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	Player->AllowMoveAll();
	// teleport(currchar(s), Player->pos); // why do we need a teleport here ?
	sysmessage(s, "ALLMOVE enabled."); // Crackerjack 07/25/99
}

void command_allmoveoff(UOXSOCKET s)
// Disables GM ability to pick up all objects.
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	Player->DisallowMoveAll();
	//teleport(currchar(s), Player->pos);  // why do we need a teleport here ?
	sysmessage(s, "ALLMOVE disabled."); // Crackerjack 07/25/99
}

void command_showhs(UOXSOCKET s)
// Makes houses appear as deeds. (The walls disappear and there's a deed on the ground in their place.)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	Player->MakeShowHouseIcons();

	PC_ITEM pi;
	int loopexit = 0;
	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (ishouse(pi)) SndRemoveItem(s,pi);
	}

	teleport(Player,Player->pos);
	sysmessage(s, "House icons visible. (Houses invisible)");
}

void command_hidehs(UOXSOCKET s)
// Makes houses appear as houses (opposite of /SHOWHS).
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	Player->MakeNoShowHouseIcons();
	teleport(Player, Player->pos);
	sysmessage(s, "House icons hidden. (Houses visible)");
}

void command_viewdepth(UOXSOCKET s)
// change the viewingdepth
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if (tnum==2)
	{
		short depth = makenumber(1);
		Player->SetViewingDepth(depth);

		P_CHAR pc;
		int loopexit=0;
		RegGrid3x3Iterator4Chars rg3ic(Player->pos);
		while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			if (!Player->isSameAs(pc) && inrange1p(Player, pc))
				impowncreate(s, pc, 1);
		}
	}
	else sysmessage(s, "Syntax: viewdepth <num>");
}

void command_set(UOXSOCKET s)
// (text, d) Set STR/DEX/INT/Skills on yourself arguments are skill & amount.
{
	int i;
	if (tnum==3)
	{
		i=0;
		script1[0]=0;
		strcpy(script1, Commands->params[1].c_str());
		strupr(script1);
		addx[s]=-1;
		
		for (i=0;i<SKILLS;i++)
		{
			if (!strcmp(SkillManager->getSkillName(i), script1)) 
			{ /*clConsole.send("%s\n",skillname[i]);*/
				if (SrvParms->AOS_Mode) addx[s]=i;
				else
				{
					if (i!=NECROMANCY && i!=CHIVALRY && i!=FOCUS) addx[s]=i;

				}
			}
			if (!strcmp(script1, "ALLSKILLS")) { addx[s]=ALL; }
		}
		if (addx[s]!=-1)
		{
			addy[s]=makenumber(2);
			target(s,  36, "Select character to modify.");
		}
	}
}

void command_addnpc(UOXSOCKET s)
// (d or h h) Add the specified NPC from NPC.SCP or by hex ID code.
{
	if (tnum==3)
	{
		addid1[s]=hexnumber(1);
		addid2[s]=hexnumber(2);
		target(s,  33, "Select location for the NPC.");
	}
	else if (tnum==2)
	{
		addmitem[s]=makenumber(1);
		target(s,  27, "Select location for the NPC.");
	}
}

void command_readini(UOXSOCKET s)
// Re-loads the WOLFPACK.INI file.
{
	//Admin->ReadIni();
	sysmessage(s, "command obsolete, no more ini file, plz remind devs to take it out completely");
}

void command_gumpmenu(UOXSOCKET s)
// (d) Opens the specified GUMP menu.
{
	if (tnum==2)
	{
		Gumps->Menu(s, makenumber(1));
	}
}

void command_npcrect(UOXSOCKET s)
// (d d d d) Set bounding box for a NPC with a NPCWANDER of 3.
{
	if (tnum==5)
	{
		addx[s]=makenumber(1); // bugfix, LB, old npcshape worked only if its only excuted by ONE player at the same time
		addy[s]=makenumber(2);
		addx2[s]=makenumber(3);
		addy2[s]=makenumber(4);
		target(s,  67, "Select the NPC to set the bounding rectangle for."); // lb bugfix, was 58 ...
	}
}

void command_npccircle(UOXSOCKET s)
// (d d d) Set bounding circle for a NPC with a NPCWANDER of 2.
{
	if (tnum==4)
	{
		addx[s]=makenumber(1);
		addy[s]=makenumber(2);
		addx2[s]=makenumber(3);
		target(s,  59, "Select the NPC to set the bounding circle for.");
	}
}

void command_npcwander(UOXSOCKET s)
// (d) Sets the type of wandering a NPC does.
// <UL><LI>0 = NPC Does not move.</LI>
// <LI>1 = NPC Follows specified target. (See
// <A HREF="npctarget.html">/NPCTARGET</A>)</LI>
// <LI>2 = NPC Wanders Freely.</LI>
// <LI>3 = NPC stays in box specified by <A HREF="npcrect.html">NPCRECT</A>.</LI>
// <LI>4 = NPC stays in circle specified by <A HREF="npccircle.html">NPCCIRCLE</A>.</LI></UL>
{
	if (tnum==2)
	{
		addx[s]=makenumber(1);
		target(s,  60, "Select the NPC to set the wander method for.");
	}
}

void command_secondsperuominute(UOXSOCKET s)
// (d) Sets the number of real-world seconds that pass for each UO minute.
{
	if (tnum==2)
	{
		timeLight.secondsperuominute=makenumber(1);
		sysmessage(s, "Seconds per UO minute set.");
	}
}

void command_brightlight(UOXSOCKET s)
// (h) Sets default daylight level.
{
	if (tnum==2)
	{
		timeLight.worldbrightlevel=hexnumber(1);
		sysmessage(s, "World bright light level set.");
	}
}

void command_darklight(UOXSOCKET s)
// (h) Sets default nighttime light level.
{
	if (tnum==2)
	{
		timeLight.worlddarklevel=hexnumber(1);
		sysmessage(s, "World dark light level set.");
	}
}

void command_dungeonlight(UOXSOCKET s)
// (h) Sets default dungeon light level.
{
	if (tnum==2)
	{
		timeLight.dungeonlightlevel=min(hexnumber(1), 27);
		sysmessage(s, "Dungeon light level set.");
	}
}

void command_gmopen(UOXSOCKET s)
// (h / nothing) Opens specified layer on player/NPC, or player's pack if no layer specified.
// <P>Useful hex codes for this command are:</P>
// <TABLE BORDER=1>
// <TR><TD><B>15</B></TD><TD>Backpack</TD></TR>
// <TR><TD><B>1A</B></TD><TD>NPC Buy Restock container</TD></TR>
// <TR><TD><B>1B</B></TD><TD>NPC Buy no restock container</TD></TR>
// <TR><TD><B>1C</B></TD><TD>NPC Sell container</TD></TR>
// <TR><TD><B>1D</B></TD><TD>Bank Box</TD></TR>
// </TABLE>
{
	if (tnum==2) addmitem[s]=hexnumber(1);
	else addmitem[s]=0x15;
	target(s,  115, "Select the character to open the container on.");
}

void command_restock(UOXSOCKET s)
// Forces a manual vendor restock.
{
	restock(0);
	sysmessage(s, "Manual shop restock has occurred.");
}

void command_restockall(UOXSOCKET s)
// Forces a manual vendor restock to maximum values.
{
	restock(1);
	sysmessage(s, "Restocking all shops to their maximums");
}

void command_setshoprestockrate(UOXSOCKET s)
// (d) Sets the universe's shop restock rate.
{
	if (tnum==2)
	{
		shoprestockrate=makenumber(1);
		sysmessage(s, "NPC shop restock rate changed.");
	}
	else
		sysmessage(s, "Invalid number of parameters.");
}

void command_midi(UOXSOCKET s)
// (d d) Plays the specified MIDI file.
{
	if (tnum==3) playmidi(s, makenumber(1), makenumber(2));
	return;
}

void command_gumpopen(UOXSOCKET s)
// (h h) Opens the specified GUMP menu.
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (tnum==3) Gumps->Open(s, Player->serial, hexnumber(1), hexnumber(2));
}

void command_respawn(UOXSOCKET s)
// Forces a respawn.
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	
	sprintf(temp,"Respawn command called by %s.\n", Player->name);//AntiChrist
	sysbroadcast("World is now respawning, expect some lag!");
	LogMessage(temp);
	Respawn->Start();
}

void command_regspawnmax(UOXSOCKET s)
// (d) Spawns in all regions up to the specified maximum number of NPCs/Items.
{
	if (tnum==2)
	{
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		sprintf(temp,"MAX Region Respawn command called by %s.\n", Player->name);//AntiChrist
		LogMessage(temp);
		Commands->RegSpawnMax(s, makenumber(1));
	}
}

void command_regspawn(UOXSOCKET s)
// (d d) Preforms a region spawn. First argument is region, second argument is max # of items/NPCs to spawn in that region.
{
	if (tnum==3)
	{
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		sprintf(temp,"Specific Region Respawn command called by %s.\n", Player->name);//AntiChrist
		LogMessage(temp);
		Commands->RegSpawnNum(s, makenumber(1), makenumber(2));
		sysmessage(s, "Region has been spawned!");
	}
}

void command_reloadserver(UOXSOCKET s)
// Reloads the SERVER.SCP file.
{
	SrvParms->Load();
	sysmessage(s,"Server.scp reloaded.");
}

void command_loaddefaults(UOXSOCKET s)
// Loads the server defaults.
{
	SrvParms->Init();
	sysmessage(s, "Defaults Server Settings have been loaded!");
}

void command_cq(UOXSOCKET s)
// Display the counselor queue.
{
	Commands->ShowGMQue(s, 0); // Show the Counselor queue, not GM queue   
}

void command_cnext(UOXSOCKET s)
// Attend to the next call in the counselor queue.
{
	Commands->NextCall(s, 0); // Show the Counselor queue, not GM queue   
}

void command_cclear(UOXSOCKET s)
// Remove the current call from the counselor queue.
{
	donewithcall(s, 0); // Show the Counselor queue, not GM queue   
}

void command_minecheck(UOXSOCKET s)
// (d) Set the server mine check interval in minutes.
{
	if (tnum==2)
		SrvParms->minecheck=makenumber(1);
}

void command_invul(UOXSOCKET s)
// Makes the targeted character immortal.
{
	addx[s]=1;
	target(s,179,"Select creature to make invulnerable.");
}

void command_noinvul(UOXSOCKET s)
// Makes the targeted character mortal.
{
	addx[s]=0;
	target(s,179,"Select creature to make mortal again.");
}

void command_guardson(UOXSOCKET s)
// Activates town guards.
{
	SrvParms->guardsactive=1;
	sysbroadcast("Guards have been reactivated.");
}

void command_guardsoff(UOXSOCKET s)
// Deactivates town guards.
{
	SrvParms->guardsactive=0;
	sysbroadcast("Warning: Guards have been deactivated globally.");
}

void command_announceon(UOXSOCKET s)
// Enable announcement of world saves.
{
	SrvParms->announceworldsaves=1;
	cwmWorldState->announce(SrvParms->announceworldsaves);
	sysbroadcast("WorldStat Saves will be displayed.");
}

void command_announceoff(UOXSOCKET s)
// Disable announcement of world saves.
{
	SrvParms->announceworldsaves = 0;
	cwmWorldState->announce( SrvParms->announceworldsaves );
	sysbroadcast("WorldStat Saves will not be displayed.");
}

void command_wf(UOXSOCKET s)
// Make the specified item worldforge compatible.
{
	if (tnum==2)
	{
		addid1[s]=255;
		target(s,  6, "Select item to make WorldForge compatible.");
	}
}

void command_decay(UOXSOCKET s)
// Enables decay on an object.
{
	addid1[s]=1;
	target(s,  89, "Select object to decay.");
}

void command_killall(UOXSOCKET s)
// (d text) Kills all of a specified item.
{
	if (tnum>2)
	{
		mstring dummy = Commands->GetAllParams();
		dummy = dummy.substr(dummy.find_first_not_of(" "));
		if (makenumber(1)<10)
			Commands->KillAll(s, makenumber(1), dummy.c_str());
		else if (makenumber(1)<100)
			Commands->KillAll(s, makenumber(1), dummy.c_str());
		else
			Commands->KillAll(s, makenumber(1), dummy.c_str());
	}
	return;
}

void command_pdump(UOXSOCKET s)
// Display some performance information.
{
	sysmessage(s, "Performance Dump:");
	pdump(s, 1, NULL);
	
	return;
}

void command_readspawnregions(UOXSOCKET s)
// Re-read the SPAWN.SCP file.
{
	loadspawnregions();
	sysmessage(s,"Spawnregions reloaded.");
	return;
}

void command_gy(UOXSOCKET s)
// (text) GM Yell - Announce a message to all online GMs.
{
	if (now==1)
	{
		sysmessage(s,"There are no other users connected.");
		return;
	}
	
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	sprintf(xtext[s], "(GM ONLY): %s", Commands->GetAllParams().c_str());//AntiChrist bugfix - cms_offset+4, not +7
	short tl=44+strlen(&xtext[s][0])+1;

	unsigned char talk[14];
	
	LongToCharPtr(Player->serial, &talk[3]);
	ShortToCharPtr(Player->id(), &talk[7]);
	talk[9]=1;
	talk[10]=buffer[s][4];
	talk[11]=buffer[s][5];
	talk[12]=buffer[s][6];
	talk[13]=Player->fonttype;
			 
	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (pc->isGM())
		{
			UOXSOCKET si = api.getSocket();

			XStartPkt(0x1c,tl);
			XAddPkt(&talk[0+3], 14-3);
			XAddPkt((unsigned char*)&Player->name[0], 30);
			XAddPkt((unsigned char*)&xtext[s][0], strlen(&xtext[s][0])+1);   
			XFinishPkt(si);
		}
	}
}

void command_tilew(UOXSOCKET s)
// (h h d d d d d) id id x1 x2 y1 y2 z - Tile an object using specified id & coordinates.
// <UL><LI>The first two numbers are hexidecimal, and are the ID codes for
// the item to tile.</LI>
// <LI>The second pair of numbers is the decimal coordinates of the upper
// left hand corner of the box being tiled. To get this value, go to the
// upper left hand corner and type /WHERE.</LI>
// <LI>The third pair of numbers is the lower right hand corner of the
// box being tiled.</LI>
// <LI>The final number is the Z-Axis of the box being tiled.</LI></UL>
{
	if (tnum==8)
	{
		addid1[s] = static_cast<unsigned char>(hexnumber(1));//id1
		addid2[s] = static_cast<unsigned char>(hexnumber(2));//id2
		int pile=0;
		const tileData* tile;
		short id = (addid1[s]<<8)+addid2[s];
		tile = TileData->SeekTile(id);
		if (TileData->isStackable(tile->flags)) pile=1;
		for (int x=makenumber(3);x<=makenumber(4);x++)
		{
			for (int y=makenumber(5);y<=makenumber(6);y++)
			{
				P_ITEM pi_a = Items->SpawnItem(currchar(s), 1, "#", pile, id, 0, 0);
				if (pi_a != NULL) //AntiChrist - to preview crashes
				{
					pi_a->decayOff();	//Make them not decay
					pi_a->pos.x=x;
					pi_a->pos.y=y;
					pi_a->pos.z = static_cast<signed char>(makenumber(7));
					mapRegions->Add(pi_a); // lord Binary
					pi_a->refresh();//AntiChrist
				}
			}
		}
		addid1[s]=0; // lb, i was so free and placed it here so that we dont have y-1 rows of 0-id items ... hope that was not intentinal ..
		addid2[s]=0;
	}  
	else { sysmessage(s, "Format: /tilew ID1 ID2 X1 X2 Y1 Y2 Z"); }
	return;
}

void command_squelch(UOXSOCKET s)
// (d / nothing) Squelchs specified player. (Makes them unnable to speak.)
{
	if (tnum==2)
    {
		if (makenumber(1)!=0 || makenumber(1)!=-1)
        {
            addid1[s]=makenumber(1);
        }
    }
    target(s,223,"Select character to squelch.");
    return;
}

void command_spawnkill(UOXSOCKET s)
// (d) Kills spawns from the specified spawn region in SPAWN.SCP.
{
	if (tnum==2)
	{
		Commands->KillSpawn(s, makenumber(1));
		sysmessage(s, "Spawn killed!");
	}
	return;
}


void command_wanim(UOXSOCKET s)
// (d d) Changes server lighting animation.
{
   if (tnum==3)
   {
	   w_anim[0]=(signed char) hexnumber(1);
	   w_anim[1]=(signed char) hexnumber(2);

	   //P_CHAR Player =  MAKE_CHARREF_LR(currchar(s));

	   sysmessage(s,"new GLOBAL bolt animation set!");
   }
}

void command_gotocur(UOXSOCKET s)
// Goes to the current call in the GM/Counsellor Queue
{
	Commands->GotoCur(s);
}

void command_gmtransfer(UOXSOCKET s)
// Escalate a Counsellor Page into the GM Queue
{
	Commands->GMtransfer(s);
}

void command_who(UOXSOCKET s)
// Displays a list of users currently online.
{
	if (now==1)
	{
		sysmessage(s,"There are no other users connected.");
		return;
	}

	int j=0;
	unsigned int i;
	sysmessage(s,"Current Users in the World:");
	for (i=0;i<now;i++)
	{
		if (perm[i]) //Keeps NPC's from appearing on the list
		{
			P_CHAR pc = MAKE_CHAR_REF(currchar(i));
			//if (!pc) continue;
			if (!pc)
			{
				char tt[444];
				sprintf(tt,"Invalid char index detected !! now=%i, i=%i, index=%i",now,i,currchar(i));
				LogError(tt);
				continue;
			}
			j++;
			char serstr[20];
			LongToHexChunks(pc->serial,serstr);
			sprintf(temp, "%i) %s %s", (j-1), pc->name, serstr);
			sysmessage(s, temp);
		}
	}
	sprintf(temp,"Total Users Online: %d\n", j);
	sysmessage(s,temp);
	sysmessage(s,"End of userlist");
}

void command_gms(UOXSOCKET s)
{
	int j=0;
	sysmessage(s,"Current GMs and Counselors in the world:");

	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (pc->isCounselor()) //Keeps NPC's from appearing on the list
		{
			j++;
			sysmessage(s, pc->name);
		}
	}
	sprintf(temp, "Total Staff Online: %d\n", j);
	sysmessage(s, temp);
	sysmessage(s,"End of stafflist");
}

void command_regspawnall(UOXSOCKET s)
{
//	sysmessage(s, "Command is disabled. Use respawn instead.");	//might cause allocation problems (Duke)
//	return;

	sysbroadcast("ALL Regions Spawning to MAX, this will cause some lag.");
	
	int spawned=AllSpawnMax();

	sprintf(temp, "Done. %d total NPCs/items spawned in %d regions.", spawned, NumberOfSpawnRegions());
	sysmessage(s, temp);
}

void command_wipenpcs(UOXSOCKET s)
{
	int deleted = 0;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
	{
        if (pc->npc && !pc->isAiVendor() && !pc->tamed) // Ripper
		{			
					
			Npcs->DeleteChar(pc);
			deleted++;
		}
	}
	
	if (SrvParms->gm_log) 
	{ 
		char temp2[1024];
		sprintf(temp,"%s.log",Player->name); 
		sprintf(temp2,"npc wipe done, %i npcs deleted\n",deleted); 
		savelog(temp2,temp); 
	}

	gcollect();

	sprintf(temp,"All NPC's have been wiped (%i).", deleted);
	sysmessage(s, temp);

}

void command_cleanup(UOXSOCKET s)
{
	int corpses=0;
	char temp[100];
	
	sysmessage(s,"Cleaning corpses and closing gates...");
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->corpse==1 || pi->isType(ITY_Gate1) || pi->isType(ITY_Gate2))
		{
			Items->DeleItem(pi->unconst());
			corpses++;
		}
	}
	gcollect();
	sysmessage(s, "Done.");
	sprintf(temp, "%i corpses or gates have been cleaned.",corpses);
	sysmessage(s, temp);
}

/* new commands go just above this line. :-) */

void command_delid( UOXSOCKET s )
{
	if (tnum != 3)
	{
		sysmessage( s, "Syntax Error. Usage: /delid <id1> <id2>" );
		return;
	}

	short id = (hexnumber(1)<<8)+hexnumber(2);
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->id() == id)
			Items->DeleItem( pi->unconst() );
	}
}

void command_deltype( UOXSOCKET s )
{
	if (tnum != 2)
	{
		sysmessage( s, "Syntax Error. Usage: /deltype <type>" );
		return;
	}

	unsigned int type = makenumber( 1 );
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if ( pi->isType(type) )
			Items->DeleItem( pi->unconst() );
	}
}

// blackwind system message 
void command_sysm(UOXSOCKET s) 
{ 
	if (now == 1)
	{ 
		sysmessage(s, "There are no other users connected."); 
		return; 
	}	
	strcpy(xtext[s], Commands->GetAllParams().c_str()); 
	sysbroadcast(xtext[s]); 
} 

void command_eclipse(UOXSOCKET s) 
{ 
	SrvParms->eclipsetimer = (unsigned int)((double) uiCurrentTime +(ECLIPSETIMER*MY_CLOCKS_PER_SEC));
	sysmessage(s, "Eclipse ! Earth fades !! "); 
}

void command_jail(UOXSOCKET s) 
// (d) Jails the target with given secs. 
{ 
	if (tnum == 2) 
	{ 
		addmitem[s] = makenumber(1); // We temporary use addmitem for jail secs. 
		sprintf(temp, "Select Character to jail. [Jailtime: %i secs]", addmitem[s]); 
		target(s,  126, temp); 
	} 
	else 
	{ 
		addmitem[s] = SrvParms->default_jail_time; 
		sprintf(temp, "Select Character to jail. [Jailtime:Server default of %i secs]", addmitem[s]); 
		target(s,  126, temp); 
	} 
	return; 
} 

// handler for the movement effect 
// Aldur
// 
void command_setGmMoveEff(UOXSOCKET s) 
// (h) set your movement effect. 
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s)); 
	if (tnum == 2)
		Player->gmMoveEff = makenumber(1);
	return; 
}

void command_password(UOXSOCKET s)
// (text) Changes the account password
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s)); 
	if ( tnum > 1 )
	{
		char pwd[200] = {0,};
		strncpy(pwd, &tbuffer[Commands->cmd_offset+9], 198);
		if (!isalpha(pwd[0]) && !isdigit(pwd[0]))
		{
			sysmessage(s, "Passwords must start with a letter or a number\n");
			return;
		}
		if (Accounts->ChangePassword(Player->account, pwd)) 
		{
			sprintf(temp,"Password changed to %s", &tbuffer[Commands->cmd_offset+9]);
			sysmessage(s, temp);
		}
		else 
		{
			sysmessage(s, "Some Error occured while changing password!");
		}
	}
	else 
		sysmessage(s, "You must digit 'PASSWORD <newpassword>");

	return;
}

void command_gift(UOXSOCKET s) 
// (d) script # of item to distribute. 
{
	if (tnum != 3)	return;	// wrong number of arguments

	int sin = makenumber(1);
	script1[0]=0;
	strcpy(script1, Commands->params[2].c_str());
	strupr(script1);
	int who = 0;
	if (!strcmp("ONLINE",script1)) who = 1;
	if (!strcmp("ACCOUNT",script1)) who = 2;
	if (!strcmp("PLAYER",script1)) who = 3;
	if (!who)
	{
		sysmessage(s, "Syntax: gift <item#> ONLINE or ACCOUNT or PLAYER");
		return;
	}

	P_CHAR pc;
	switch (who)
	{
	case 1:	// to all online players
		{
			AllPlayersIterator api;
			for (pc = api.First(); pc != NULL; pc = api.Next())
			{
				pc->AddGift(sin);
			}
		}
		break;
	case 2:	// to the first char on each account
		Accounts->AddGift(sin);
		break;
	case 3:	// to every player char
		AllCharsIterator aci;
		for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
		{
			if (pc->npc) continue;
			pc->AddGift(sin);
		}
		break;
	}
}

void command_eraseaccount(UOXSOCKET s) 
// (d) account # to delete 
{
	if (tnum != 2)	// wrong number of arguments
	{
		sysmessage(s, "Syntax: eraseaccount <account#>");
		return;
	}

	int noc = 0;
	int acc = makenumber(1);
	P_CHAR pc;
	AllCharsIterator aci;
	for (aci.Begin(); (pc=aci.GetData()) != NULL; aci++)
	{
		if (pc->npc) continue;
		if (pc->account == acc)
		{
			Npcs->DeleteChar(pc);
			noc++;
		}
	}
	Accounts->RemoveAccount(acc);
	sprintf(temp,"Erased %i characters",noc);
	sysmessage(s, temp);
}

void command_createaccount(UOXSOCKET s) 
{
	if (tnum != 3)	// wrong number of arguments
	{
		sysmessage(s, "Syntax: createaccount <account> <password>");
		return;
	}

	char acct[256];
	char pass[256];

	if ( (makestring(1,acct,false)) && (makestring(2,pass,false)) )
	{
		if (Accounts->CheckExistence(acct))
		{
			sysmessage(s, "Error: account already exists");
			return;
		}

		Accounts->CreateAccount(acct,pass);
		sprintf(temp,"Account '%s' with pass '%s' created",acct,pass);
		sysmessage(s, temp);
	}
	else sysmessage(s, "Error: account could not be created");
}

void command_qsfimport(UOXSOCKET s) 
{
	if (tnum != 2)	// wrong number of arguments
	{
		sysmessage(s, "Syntax: qsfimport <filename>");
		return;
	}
	char fn[300];
	strcpy(fn, Commands->params[1].c_str());
	qsfLoad(fn, 0);
}

void command_qsfexport(UOXSOCKET s) 
{
	if (tnum != 2)	// wrong number of arguments
	{
		sysmessage(s, "Syntax: qsfexport <filename>");
		return;
	}
	char fn[300];
	strcpy(fn, Commands->params[1].c_str());
	qsfExport(fn);
}

void command_qsfremove(UOXSOCKET s) 
{
	if (tnum != 2)	// wrong number of arguments
	{
		sysmessage(s, "Syntax: qsfremove <filename>");
		return;
	}
	char fn[300];
	strcpy(fn, Commands->params[1].c_str());
	qsfRemove(fn, 0);
}

void command_qsfwhere(UOXSOCKET s) 
{
	if (tnum != 1)	// wrong number of arguments
	{
		sysmessage(s, "Syntax: qsfwhere");
		return;
	}
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s)); 
	char msg[300];
	sprintf(msg,"QSF-block is %4.4X",qsfWhere(Player->pos));
	sysmessage(s,msg);
}

void command_devtest(UOXSOCKET s)
{
	target(s,  58, "Select target for devtest"); 
}

void command_privhide(UOXSOCKET s)
{
	P_CHAR pc = MAKE_CHARREF_LR(currchar(s));
	if (!pc->PrivHide())
	{
		pc->PrivHideOn();
		sysmessage(s, "PrivHide toggled to ON");
	}
	else
	{
		pc->PrivHideOff();
		sysmessage(s, "PrivHide toggled to OFF");
	}
}


void command_guildtalk(UOXSOCKET s)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (!Player) return;
	
	if (Player->guildnumber==0) 
	{
		sysmessage(s, "you are in no guild");
		sysmessage(s, "hence using the GUILD talk command is rather pointless");
		return;
	}
	
	int l=Commands->GetAllParams().size();
	if (l<=0) 
	{
		sysmessage(s,"silence can not be broadcasted");
		return;
	} 
	else if (l>300) 
	{
		sysmessage(s,"too much data to broadcast");
		return;
	}
	
	AllPlayersIterator api;
	
	P_CHAR pc; 
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (!Player->isSameAs(pc))
		{
			int g = Guilds->Compare(Player, pc);
			if (g==2) // if same guild
			{
				char data[512];
				UOXSOCKET si=api.getSocket();
				
				sprintf(data, "GUILDTALK from %s", Player->name);
				sysmessage(si, 3, data);
				
				strcpy(data, Commands->GetAllParams().c_str());
				sysmessage(si, 5, data);
			}
		}
	}
}

void command_sstats(UOXSOCKET s)
{
	int totalitems=0;
	int totalgold=0;
	int modified=0;
	
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->id()==0x0EED) totalgold += pi->amount;
		if (pi->HasChanged()) modified++;
		totalitems++;
	}
	char msg[100];
	sprintf(msg,"Total gold: %i",totalgold);
	sysmessage(s,msg);
	sprintf(msg,"Modified items: %i/%i",modified,totalitems);
	sysmessage(s,msg);
}

