/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//
#include "combat.h"

#include "itemid.h"
#include "guilds.h"
#include "LoS.h"
#include "magic.h"
#include "npcinfo.h"
#include "skills.h"
#include "TmpEff.h"
#include "trigger.h"
#include "SndPkg.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "combat.cpp"
#define SWINGAT (unsigned int)1.75 * MY_CLOCKS_PER_SEC // changed from signed to unsigned, LB

void cCombat::ItemCastSpell(UOXSOCKET s, P_CHAR Target, P_ITEM pi)//S=Socket c=Char # Target i=Item //Itemid
{
	if (!pi) return;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	unsigned short int spellnum=((pi->morex*8)-8)+pi->morey;
	unsigned short int tempmana=Player->mn;//Save their mana so we can give it back.
	unsigned short int tempmage=Player->Skill(MAGERY);//Easier than writing new functions for all these spells

	if (!pi->isType(ITY_CastingItem)) return;
	
	if ((int)pi->morez<=0) return; //morez it UI, so first convtert to int, then check for negative value (Thrawn)
	
//	Player->Skill(MAGERY) = RandomNum(600, 1000);//For damage
//#pragma note("Why are we gambling with his skill?")
	
	switch(spellnum)
	{
	case 1: OldMagic->ClumsySpell(Player,Target);			break;
	case 3: OldMagic->FeebleMindSpell(Player,Target);		break;
	case 5:	OldMagic->MagicArrow(Player,Target);			break;
	case 8: OldMagic->WeakenSpell(Player,Target);			break;
	case 18: OldMagic->FireballSpell(Player,Target);		break;
	case 22: OldMagic->HarmSpell(Player,Target);			break;
	case 27: OldMagic->CurseSpell(Player,Target);			break;
	case 30: OldMagic->NPCLightningTarget(Player,Target);	break;
	case 37: OldMagic->MindBlastSpell(Player,Target);		break;
	case 38: OldMagic->ParalyzeSpell(Player,Target);		break;
	case 42: OldMagic->NPCEBoltTarget(Player,Target);		break;
	case 43: OldMagic->ExplosionSpell(Player,Target);		break;
	case 51: OldMagic->NPCFlameStrikeTarget(Player,Target);break;
	default:
		staticeffect(Player, 0x3735, 0, 30);
		soundeffect2(Player, 0x005C);
		break;
	}
	Player->mn+=tempmana;
	Player->skill[MAGERY]=tempmage;
	if (Player->effInt()<Player->mn) Player->mn=Player->effInt();//Shouldn't happen, but just in case;
	
	pi->morez--;
	if (pi->morez==0)//JUST lost it's charge....
		sysmessage(s, "This item is out of charges.");
}

bool CheckPoisoning(UOXSOCKET sa, UOXSOCKET sd, P_CHAR Attacker, P_CHAR Defender)
{
	if (Attacker->Poison() && Defender->Poisoned()<Attacker->Poison())
	{
		if (rand()%3==0)
		{
			Defender->PoisonStart(sd,Attacker->Poison());
			if (sd != -1) 
				sysmessage(sd,"You have been poisoned!");//AntiChrist 
			if (sa != -1) 
				impowncreate(sa,Defender,1); //Duke, sends the green bar to attacker too 
			return true;
		}
	}
	return false;
}

// This checks LineOfSight before calling CombatHit (Duke, 10.7.2001)
void cCombat::CombatHitCheckLoS(P_CHAR Attacker, unsigned int currenttime)
{
	P_CHAR Defender = Attacker->GetSwingTarget();
	if (!Defender) return;
	UOXSOCKET s1=Attacker->calcSocket();

	unsigned short los=line_of_sight(s1,Attacker->pos, Defender->pos,	LOS_STD_BLOCKERS);

	CombatHit(Attacker,Defender,currenttime,los);
}

static short calcHitLocation(int damage)
{
	int x=rand()%100;// determine area of body hit
	int loc = 1;
	if (x<=44) loc=1; // body
	else if (x<=58) loc=2; // arms
	else if (x<=72) loc=3; // head
	else if (x<=86) loc=4; // legs
	else if (x<=93) loc=5; // neck
	else loc=6; // hands
	return loc;
}

static char* calcHitMessage(int damage,int loc)
{
	static char *p = new char[256];
	
	switch (loc)
	{
	case 1:      // body
		switch (rand()%3)
		{
		case 0:
			//later take into account dir facing attacker during battle
			if (damage < 10) strcpy(p,"hits you in your Chest!");
			if (damage >=10) strcpy(p,"lands a terrible blow to your Chest!");
			break;
		case 1:
			if (damage < 10) strcpy(p,"lands a blow to your Stomach!");
			if (damage >=10) strcpy(p,"knocks the wind out of you!");
			break;
		case 2:
			if (damage < 10) strcpy(p,"hits you in your Ribs!");
			if (damage >=10) strcpy(p,"broken your Rib?!");
			break;
		}
		break;
		
	case 2:      // arms
		if (damage > 1)
		{
			switch (rand()%2)
			{
			case 0:	strcpy(p,"hits you in Left Arm!");		break;
			case 1:	strcpy(p,"hits you in Right Arm!");		break;
			}
		}
		break;
		
	case 3:      // head
		switch (rand()%3)
		{
		case 0:
			if (damage < 10) strcpy(p,"hits you you straight in the Face!");
			if (damage >=10) strcpy(p,"lands a stunning blow to your Head!");
			break;
		case 1:
			if (damage < 10) strcpy(p,"hits you to your Head!"); //kolours - (09/19/98)
			if (damage >=10) strcpy(p,"smashed a blow across your Face!");
			break;
		case 2:
			if (damage < 10) strcpy(p,"hits you you square in the Jaw!");
			if (damage >=10) strcpy(p,"lands a terrible hit to your Temple!");
			break;
		}
		break;
		
	case 4:      // legs
		switch (rand()%3)
		{
		case 0:	strcpy(p,"hits you in Left Thigh!");	break;
		case 1:	strcpy(p,"hits you in Right Thigh!");	break;
		case 2:	strcpy(p,"hits you in Groin!");			break;
		}
		break;
		
	case 5:      // neck
		strcpy(p,"hits you to your Throat!");
		break;

	case 6:      // hands
		if (damage > 1)
		{
			switch (rand()%2)
			{
			case 0: strcpy(p,"hits you in Left Hand!");		break;
			case 1: strcpy(p,"hits you in Right Hand!");	break;
			}
			break;
		}
	}
	return p;
}

// CombatHit now expects that LineOfSight has been checked before (Duke, 10.7.2001)
void cCombat::CombatHit(P_CHAR Attacker, P_CHAR Defender, unsigned int currenttime, short los)
{
	if (!Defender || !Attacker) return;
	
	UOXSOCKET s1=Attacker->calcSocket(), s2=Defender->calcSocket();
	unsigned short fightskill=Skills->GetCombatSkill(Attacker), bowtype=Attacker->getBowType(),splitnum,splitcount;
	unsigned int basedamage;
	int damage; // removed from unsigne by Magius(CHE)
	int x;
	char hit;

	int maxabs, maxnohabs, tmpj;	// Magius(CHE) - For armour absorbtion system


	P_ITEM Weapon=Attacker->getWeapon();// get the weapon item only once

	if (Weapon!=NULL)
	{
		if (!(rand()%50)	// a 2 percent chance (Duke, 07.11.2000)
			&& !Weapon->isType(ITY_SpellBook))	// but not for spellbooks (Duke, 09/10/00)
		{
			Weapon->hp--; //Take off a hit point
			if (Weapon->hp<=0)
			{
				sysmessage(s1,"Your weapon has been destroyed");
				if ((Weapon->trigon==1) && (Weapon->layer>0))// -Frazurbluu- Trigger Type 2 is my new trigger type *-
				{
					triggerwitem(s1, Weapon, 1); // trigger is fired when item destroyed
				}				
				Items->DeleItem(Weapon);
				Weapon=NULL;
				Attacker->SetPoison(0); //fix for players poisoning without weapon
			}
		}
	}


	Attacker->ResetSwingTarget();

	if ((Attacker->dist(Defender)>1 && fightskill!=ARCHERY) || !los) return;
	if (Defender->npc && Defender->isInvul()) return; // ripper
	if (Defender->isDummy()) return; // dont damage dummy npcs

// Lagfix for 'turning towards Opponent' (Sayro, 15.8.03)
// Now only lag in close, but still unable to run around mob and outmanouvre like old times. 
// Added check to see if player was running. Less lag, but now it refused to turn if I had run the last few tiles, stopped, and let npc come to me. As long as last steps were run, it wouldn't turn. 
// Added check to inactive client. Now it worked perfect.
// Turns only players, when they strike, and when they are not busy doing something else.
	if (!Attacker->npc && (!Attacker->running || Attacker->clientidletime)) 
	{ 
		int newdir = chardir(Attacker,Defender);
		if (newdir != Attacker->dir)	// check to see if dir is already correct 
		{
			Attacker->dir = newdir;		// turn to opponent
			updatechar(Attacker);
		}
	}

	hit=Attacker->checkSkill(fightskill);  // increase fighting skill for attacker and defender
	if (!hit)
	{
		if (!Attacker->npc)
			doMissedSoundEffect(Attacker);
		if (fightskill==ARCHERY && los)
		{
			if (rand()%3-1)//-1 0 or 1
			{
				short id=0x1BFB;	// bolts
				if (bowtype==1)
					id=0x0F3F;		// arrows

				P_ITEM pAmmo=Items->SpawnItem(Defender,1,"#",1,id,0,0);
				if (pAmmo)
				{
					pAmmo->MoveTo2(Defender->pos);
				}
			}
		}
		return;
	}

	if (Defender->isInvul())
		return;
	
	if (Defender->xid()==0x191) soundeffect2(Defender,0x014B);
	if (Defender->xid()==0x190) soundeffect2(Defender,0x0156);
	playmonstersound(Defender, SND_DEFEND);
	//AntiChrist -- for poisoned weapons
	if (CheckPoisoning(s1, s2, Attacker, Defender))	// attacker poisons defender
	{
		if (Weapon)		// if we actually poisoned the defender using a weapon
		{
			if (rand()%(6-Weapon->Poisoned())==0)	// the higher the poison strength, the higher the chance to reduce it
			{
				Weapon->poisoned--;
				Attacker->poison--;
				if (Weapon->Poisoned() <= 0)
					Weapon->poisoned = 0;
			}
		}
	}
	if (fightskill!=ARCHERY)	// only for melee (Duke,21.4.01)
		CheckPoisoning(s2, s1, Defender, Attacker); // and vice versa
	
	if (Defender->effDex()>0) Defender->Unfreeze();
	
	if (fightskill!=WRESTLING && los)
		Combat->ItemSpell(Attacker, Defender);
	
	if (fightskill!=WRESTLING || Attacker->npc==1)
		basedamage=Combat->CalcAtt(Attacker);
	else
	{
		if (Attacker->Skill(WRESTLING)/100 > 0) 
			basedamage=rand()%(Attacker->Skill(WRESTLING)/100);
		else
			basedamage=rand()%2;
	}
	
	if (!Attacker->npc && fightskill!=WRESTLING)
	{ 
		if (Weapon!=NULL)
		{
			if (Weapon->racehate != 0 && Defender->getRace() != 0)//-Fraz- Racehating combat
			{
				if (Weapon->racehate==Defender->getRace())
				{
					basedamage *=2;
					if (!Defender->npc)
					{
						sysmessage(s2,"You sceam in agony from being hit by the accursed metal!");
						if (Defender->xid()==0x191) soundeffect2(Defender,0x0152);
						else if (Defender->xid()==0x190) soundeffect2(Defender,0x0157);
					}// can add a possible effect below here for npc's being hit
				}
			}
		}
	}
	
	Attacker->checkSkill(TACTICS);
	damage=(int)(basedamage*((Attacker->Skill(TACTICS)+500.0)/1000.0)); // Add Tactical bonus
	damage=damage+(int)((basedamage*(Attacker->effStr()/500.0))); // Add Strength bonus
	
	//Adds a BONUS DAMAGE for ANATOMY
	//Anatomy=100 -> Bonus +20% Damage - AntiChrist (11/10/99)
	if (Attacker->checkSkill(ANATOMY))
	{
		float multiplier=(((Attacker->Skill(ANATOMY)*20)/1000.0f)/100.0f)+1;
		damage=(int)  (damage * multiplier);
	}
	//Adds a BONUS DEFENCE for TACTICS
	//Tactics=100 -> Bonus -20% Damage - AntiChrist (11/10/99)
	float multiplier=1-(((Defender->Skill(TACTICS)*20)/1000.0f)/100.0f);
	damage=(int)  (damage * multiplier);
	P_ITEM pShield=Defender->getShield();
	if (pShield)
	{
		if (Defender->checkSkill(PARRYING))// chance to block with shield
		{
			if (pShield->def!=0) damage-=rand()%(pShield->def);// damage absorbed by shield
			if (rand()%2) pShield->hp--; //Take off a hit pointt
			if (pShield->hp<=0)
			{
				sysmessage(s2,"Your shield has been destroyed");
				if ((pShield->trigon==1) && (pShield->layer >0))// -Frazurbluu- Trigger Type 2 is my new trigger type *-
				{
					triggerwitem(s2, pShield, 1); // trigger is fired when item destroyed
				}	
				Items->DeleItem(pShield);
				pShield=NULL;
			}
		}
	}
	// Armor destruction and sped up by hitting with maces should go in here somewhere 
	// According to lacation of body hit Id imagine -Frazurbluu- **NEEDS ADDED**
	x = calcHitLocation(damage);
	if (SrvParms->combathitmessage && !Defender->npc && s2!=-1)
	{
		sprintf(temp2,"%s %s",Attacker->name, calcHitMessage(damage,x));
		sysmessage(s2, temp2); //kolours -- hit display
	}
	x = CalcDef(Defender,x);
	
	// Magius(CHE) - For armour absorbtion system
	maxabs = 20; //
	// there are monsters with DEF >20, this makes them undefeatable
	maxnohabs=100;
	if (SrvParms->maxabsorbtion>0) maxabs = SrvParms->maxabsorbtion;
	else
	{
		Console.send("SERVER.SCP:ComabatHit() Error in MAX_ABSORBTION. Reset to Default (20).\n");
		SrvParms->maxabsorbtion=maxabs;
	}
	if (SrvParms->maxnohabsorbtion>0) maxnohabs=SrvParms->maxnohabsorbtion;
	else
	{
		Console.send("SERVER.SCP:ComabatHit() Error in MAX_NON_HUMAN_ABSORBTION. Reset to Deafult (100).\n");
		SrvParms->maxnohabsorbtion=maxnohabs;
	}
	if (!isTrueHuman(Defender)) maxabs=maxnohabs;
	tmpj=(int) (damage*x)/maxabs; // Absorbtion by Magius(CHE)
	damage -= tmpj;
	if (damage<0) damage=0;
	if (Defender->npc==0) damage /= SrvParms->npcdamage; // Rate damage against other players
	// End Armour Absorbtion by Magius(CHE) (See alse reactive armour spell damage)
	
	if (!Attacker->npc)//Zippy
		ItemCastSpell(s1,Defender,Weapon);
	
	//AntiChrist - 26/10/99
	//when hitten and damage >1, defender fails if casting a spell!
	if (damage>1 && !Defender->npc)//only if damage>1 and against a player
	{
		if (Defender->IsCasting() && Defender->GetCastingSpellType()==0 )
		{//if casting a normal spell (scroll: no concentration loosen)
			Defender->disturbCasting(s2);
		}
	}
	
	if (damage>0)
	{
		if (Defender->ra) // For reactive armor spell
		{
			// -Frazurbluu- RA may need a rewrite to be more OSI standard here
			// Its said 80% deflected 10% to attacker / 10% defender gotta check special effects
			int damage1;
			damage1=(int)( damage*(Defender->Skill(MAGERY)/2000.0));
			Defender->reduceHp(damage-damage1);
			if (Defender->npc) damage1 *= SrvParms->npcdamage; // by Magius(CHE)
			Attacker->reduceHp(damage1);  // Remove damage from attacker
			staticeffect(Defender, 0x374A, 0, 15);//RA effect - AntiChrist (9/99)
		}
		else 
		{
			if (Weapon!=NULL)
			{
				if (!Defender->npc && Attacker->Skill(ANATOMY)/4 > rand()%1000)
				{
					if (fightskill==MACEFIGHTING && IsSpecialMace(Weapon->id()))// Stamina Loss -Fraz-
					{ 
						Defender->reduceStm(3+(rand()%3));
						damage *= 2;	// double damage !!
						sysmessage(s1,"You delivered a stunning blow");
					}
					if (fightskill==FENCING && IsFencing2H(Weapon->id()))// Paralyzing -Fraz-
					{
						tempeffect(Attacker, Defender, TEF_FencingPara, 0, 0, 0);
						sysmessage(s1,"You delivered a paralyzing blow");
					}
					if (fightskill==SWORDSMANSHIP && IsAxe(Weapon->id()))// Concussion Hit -Fraz-
					{ 
						tempeffect(Attacker, Defender, TEF_Concussion, 0, 0, 0);
						sysmessage(s1,"You delivered a concussion blow");
					}
				}
			}
			else
				Defender->reduceStm(rand()%3);
			
			Defender->reduceHp(damage); // Remove damage from defender only apply special hits to non-npc's
		}
		// blood shred by blackwind
		if (damage>10)
		{
			short id=0x122c;	
			if (damage>20) id=0x122b;
			if (damage>30) id=0x122e;
			if (damage>40) id=0x122d;
			if (damage>50) id=0x122a;
			P_ITEM Blood=Items->SpawnItem(Defender,1,"#",0,id,0,0);
			if (Blood)
			{
				Blood->setNotMovable(); //Moveable by GM
				Blood->decaytimer.setSecs(SrvParms->decaytimer/2);
				Blood->MoveTo2(Defender->pos);
			}
		}
		
		/////////  For Splitting NPCs ///  McCleod
		if (Defender->split>0 && Defender->Hp()>=1)
		{
			if (rand()%100<=Defender->splitchnc)
			{
				if (Defender->split==1) splitnum=1;
				else splitnum=rand()%Defender->split+1;
				
				for (splitcount=0;splitcount<splitnum;splitcount++)
					Npcs->Split(Defender);
			}
		}
		////////      End of spliting NPCs
	}
	//if (!Attacker->npc)
	if ((fightskill==ARCHERY && los) || fightskill!=ARCHERY)
		doSoundEffect(Attacker, fightskill, Weapon);
	
	updatestats(Defender, 0);
	if (Defender->id() >= 0x0190)
	{
		if (!Defender->onhorse) Defender->DoAction(0x14);
	}
}

static int numbitsset( int number )
{
	int bitsset = 0;

	int z=0;
	while( number && z<128)
	{
		if ( number & 0x1 ) bitsset++;
		number >>= 1;
		z++;
	}
	return bitsset;
}

static int whichbit( int number, int bit )
{
	int i, setbits = 0, whichbit = 0, intsize = sizeof(int) * 8;

	for( i=0;i<intsize;i++ )
	{
		if ( number & 0x1 ) setbits++;

		if ( setbits == bit )
		{
			whichbit = i+1;
			break;
		}
		number >>= 1;
	}

	return whichbit;
}

// The SPATTACK setting in npc.scp determines which spells an npc can cast.
// It's a hexadecimal number (represented in decimal :/ in the script).
// each bit represents one spell.
// 0x0001 (   1) MagicArrow
// 0x0002 (   2) Harm
// 0x0004 (   4) Clumsy									
// 0x0008 (   8) FeebleMind
// 0x0010 (  16) Weaken
// 0x0020 (  32) Fireball
// 0x0040 (  64) Curse
// 0x0080 ( 128) Lightning
// 0x0100 ( 256) Paralyze
// 0x0200 ( 512) MindBlast
// 0x0400 (1024) EBolt
// 0x0800 (2048) Explosion
// 0x1000 (4096) FlameStrike
// 0x2000 (8192) Fireball /w 10 mana
// 0x4000 (16384) Fireball /w 20 mana
// 0x8000 (32768) Fireball /w 20 mana
// To create your favourite spell setting, simply add the dec numbers of the spells you want
// or subtract the number of an unwanted spell from the current setting of SPATTACK
//
static void NpcSpellAttack(P_CHAR Attacker, P_CHAR Defender, unsigned int currenttime, int los)
{
	if (Attacker->spatimer<=currenttime)
	{
		int spattacks = numbitsset( Attacker->spattack );

		if (!Defender->dead && Attacker->dist(Defender)<SrvParms->attack_distance && spattacks > 0 )
		{
			if (los)
			{
				Attacker->DoAction(6);																	
				int spattackbit=rand()%(spattacks) + 1;
				switch(whichbit(Attacker->spattack, spattackbit))
				{
				case 1:	if (Attacker->mn>=4)	OldMagic->MagicArrow(Attacker,Defender);			break; 
				case 2:	if (Attacker->mn>=6)	OldMagic->HarmSpell(Attacker,Defender);				break;
				case 3:	if (Attacker->mn>=4)	OldMagic->ClumsySpell(Attacker,Defender);			break;
				case 4:	if (Attacker->mn>=4)	OldMagic->FeebleMindSpell(Attacker,Defender);		break;
				case 5:	if (Attacker->mn>=4)	OldMagic->WeakenSpell(Attacker,Defender);			break;
				case 6:	if (Attacker->mn>=9)	OldMagic->FireballSpell(Attacker,Defender);			break;
				case 7:	if (Attacker->mn>=11)	OldMagic->CurseSpell(Attacker,Defender);			break;
				case 8:	if (Attacker->mn>=11)	OldMagic->NPCLightningTarget(Attacker,Defender);	break;
				case 9:	if (Attacker->mn>=14)	OldMagic->ParalyzeSpell(Attacker,Defender);			break;
				case 10:if (Attacker->mn>=14)	OldMagic->MindBlastSpell(Attacker,Defender);		break;
				case 11:if (Attacker->mn>=20)	OldMagic->NPCEBoltTarget(Attacker,Defender);		break;
				case 12:if (Attacker->mn>=20)	OldMagic->ExplosionSpell(Attacker,Defender);		break;
				case 13:if (Attacker->mn>=40)	OldMagic->NPCFlameStrikeTarget(Attacker,Defender);	break;
				case 14:						OldMagic->PFireballTarget(Attacker, Defender, 10);	break;
				case 15:						OldMagic->PFireballTarget(Attacker, Defender, 20);	break;
				case 16:						OldMagic->PFireballTarget(Attacker, Defender, 40);	break;
				}
			}			
		}
		Attacker->spatimer=currenttime+(Attacker->spadelay*MY_CLOCKS_PER_SEC); //LB bugkilling
	}
}				

// Formulas take from OSI's combat formulas
// attack speed should be determined here.
// attack speed = 15000 / ((DEX+100) * weapon speed)
static void SetWeaponTimeout(P_CHAR Attacker, P_ITEM Weapon)
{
	int x,j;
	
	if (Weapon) 
	{ 
		if (Weapon->spd==0) Weapon->spd=35;
		x = (15000*MY_CLOCKS_PER_SEC) / ((Attacker->effDex()+100) * Weapon->spd); //Calculate combat delay
	}
	else 
	{
		if (Attacker->Skill(WRESTLING)>200) j = 35;
		else if (Attacker->Skill(WRESTLING)>400) j = 40;
		else if (Attacker->Skill(WRESTLING)>600) j = 45;
		else if (Attacker->Skill(WRESTLING)>800) j = 50;
		else j = 30;
		x = (15000*MY_CLOCKS_PER_SEC) / ((Attacker->effDex()+100) * j);
	}
	Attacker->timeout=uiCurrentTime+x;
}


void cCombat::DoCombatAnimations(P_CHAR Attacker, P_CHAR Defender, int fightskill, int bowtype, int los)
{
	short id = Attacker->id();
	int aa;

	///
	/// monsters / animals have their fighting anims somewhere completely different haven humans/npcs !!!
	///
	/// furthermore anim# have differnt meanings depending on being animals/monsters/npcs/human
	if (Attacker->isAnimalBody() || Attacker->isMonsterBody() && !Attacker->InGame())
	{
	  if (id<2048 && id >-1)
	  {
		aa=4+(rand()%3);
		if (NpcInfo_antiBlink(id)) // anti blink bit set ?
		{
			aa=5;
			if (id==5) // eagles need special treatment
			{
				switch (RandomNum(0, 2))
				{
				case 0: aa=0x1;  break;
				case 1: aa=0x14; break;
				case 2: aa=0x1;  break;
				}
			}
		}	
		if (aa==4 && Attacker->isAnimalBody()) aa=7; // 25% of animls dont have anim 4. it's a stupid one anyway, so I dropped it completely
    	Attacker->DoAction(aa);
	  }
	}
	
	playmonstersound(Attacker, SND_ATTACK);

	if (Attacker->isNpcBody() || Attacker->isHuman() || Attacker->InGame())
	{
	  if (Attacker->onhorse)
	  {
		CombatOnHorse(Attacker);	// determines weapon in hand and runs animation kolours (09/19/98)
	  }
	  else
	  {	
		CombatOnFoot(Attacker);	// determines weapon in hand and runs animation kolours (09/19/98)
	  }
	}

	if (fightskill==ARCHERY)
	{
		if (los)
		{
			if (bowtype==1)
			{
				Attacker->deleteItems(1, 0x0F3F);
				movingeffect3(Attacker, Defender, 0x0F, 0x42, 0x08, 0x00, 0x00,0,0,0,0);
			}
			else
			{
				Attacker->deleteItems(1, 0x1BFB);
				movingeffect3(Attacker, Defender, 0x1B, 0xFE, 0x08, 0x00, 0x00,0,0,0,0);
			}
		}
	}
}

void cCombat::DoCombat(P_CHAR Attacker, unsigned int currenttime)
{
	P_CHAR Defender = Attacker->GetTarget();
	if (!Defender
		|| (!Defender->npc && !Defender->InGame() || Defender->isHidden())
		&& Attacker->war)
	{
		Attacker->war=0; // LB
		Attacker->timeout=0;
		Attacker->setAttacker(NULL);
		Attacker->resetAttackFirst();
		return;
	}

	if (!(Attacker->npc || Attacker->InGame()) || !Defender) return;

	if ((Defender->npc && !Defender->isAiVendor()) || (Defender->InGame() && !Defender->dead) ) // ripper
	{
		if (Attacker->dist(Defender) > SrvParms->attack_distance)
		{
			if (Attacker->isAiTeleGuard() && Attacker->inGuardedArea()) // changed from 0x40 to 4, LB
			{
				Attacker->teleTo(Defender->pos);
				soundeffect2(Attacker, 0x01FE); // crashfix, LB
				staticeffect(Attacker, 0x372A, 0x09, 0x06);
				npctalkall(Attacker,"Halt, scoundrel!",1);
			}
			else 
			{ // else -> npcaityes != 4
				Attacker->ResetTarget();
				Attacker->timeout=0;
				P_CHAR Opponent = Attacker->getAttacker();
				if (Opponent)
				{
					Opponent->resetAttackFirst();
					Opponent->setAttacker(NULL);
				}
				Attacker->setAttacker(NULL);
				Attacker->resetAttackFirst();
				if (Attacker->npc && !Attacker->isAiVendor() && !Attacker->dead && Attacker->war)
					npcToggleCombat(Attacker); // ripper
			}
		}
		else
		{
			P_ITEM Weapon=Attacker->getWeapon();
			int bowtype=0;
			int x;
			if (!Attacker->HasTarget())
			{
				npcsimpleattacktarget(Attacker,Defender);
				x=(((100-Attacker->effDex())*MY_CLOCKS_PER_SEC)/25)+(1*MY_CLOCKS_PER_SEC); //Yet another attempt.
				Attacker->timeout=currenttime+x;
				return;
			}
			if (Combat->TimerOk(Attacker))
			{
				int los = line_of_sight(-1, Attacker->pos, Defender->pos, LOS_STD_BLOCKERS);
				UOXSOCKET s1 = Attacker->calcSocket();
				int fightskill=Skills->GetCombatSkill(Attacker);
				x=0;
				if (los)
				{
					if (fightskill==ARCHERY)
					{
						int arrowsquant;
						bowtype=Attacker->getBowType();
						if (bowtype==1) arrowsquant=Attacker->CountItems(0x0F3F);
						else arrowsquant=Attacker->CountItems(0x1BFB);
						if (arrowsquant>0)
							x=1;
						else
							sysmessage(s1, "You are out of ammunitions!");
					}
					else
					{
						if ( Attacker->dist(Defender)<2 )
							x=1;
					}
				}
				if (x)
				{
					// - Do stamina maths - AntiChrist (6) -
					if (abs(SrvParms->attackstamina)>0 && !Attacker->isGM())
					{
						if ((SrvParms->attackstamina<0)&&(Attacker->Stm()<abs(SrvParms->attackstamina)))
						{
							sysmessage(s1,"You are too tired to attack.");
							SetWeaponTimeout(Attacker, Weapon);
							return;
						}
						Attacker->reduceStm(-1 * SrvParms->attackstamina);	// *-1 because attackstamina is given as a negative value
						// --------ATTACK STAMINA END ------
					}
					
					DoCombatAnimations( Attacker, Defender, fightskill, bowtype, los);

					if ((Attacker->dist(Defender)<2 || fightskill==ARCHERY) && !Attacker->isAiTeleGuard())
                    {
						if (los)
						{
							npcsimpleattacktarget(Attacker,Defender);
						}
					}
					if (Attacker->timeout2 > uiCurrentTime) return; //check shotclock memory-BackStab
					if (fightskill==ARCHERY)
						Combat->CombatHit(Attacker,Defender,currenttime,los);
					else
						Attacker->SetSwingTarget(Defender);
				}

				SetWeaponTimeout(Attacker, Weapon);
				Attacker->timeout2=Attacker->timeout; // set shotclock memory-BackStab
				if (!Defender->isInvul() && !Defender->isDummy())
				{
					NpcSpellAttack(Attacker,Defender,currenttime,los);
				}
				if (fightskill!=ARCHERY)
				{
					Combat->CombatHit(Attacker,Defender,currenttime,los); // LB !!!
					//return; // Ripper	???? (Duke)
				}
			}
		}
		if (Defender->Hp()<1)//Highlight //Repsys
		{
			//murder count \/
			
			if (!Attacker->npc && !Defender->npc)//Player vs Player
			{
				if (Defender->isInnocent() && Guilds->Compare(Attacker,Defender)==0 )
				{
					Attacker->kills++;
					sprintf(temp, "You have killed %i innocent people.", Attacker->kills);
					sysmessage(Attacker->calcSocket(),temp);
					//Console.send("DEBUG %s's kills are now -> %i\n",Attacker->name,Attacker->kills);
					if (Attacker->kills==(unsigned)repsys.maxkills+1)
						sysmessage(Attacker->calcSocket(),"You are now a murderer!");
				}
			}
			npcToggleCombat(Attacker);
			return; // LB
		}
	}
}

int cCombat::CalcAtt(P_CHAR pc) // Calculate total attack powerer
{
	if (!pc) return 0;
	int total = 0;
	
	if (pc->npc==1) 
	{
		//Compatibility for use with older scripts
		if ((pc->lodamage==0)&&(pc->hidamage==0)) return(pc->att);
		
		//Code for new script commands
		if (pc->lodamage==pc->hidamage) //Avoids divide by zero error
		{
			return(pc->lodamage);
		}
		if (!(pc->hidamage<=2))
		{
			int j=pc->hidamage-pc->lodamage; 
			if (j!=0) total=(rand()%(j))+pc->lodamage; else total=pc->lodamage;
		}
		
		if (total<1) total=1;
		return(total);
	}
	
	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=pc->SearchHands(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->lodamage == pi->hidamage) total+=pi->lodamage;
		else if ((pi->lodamage>0)&&(pi->hidamage>0))
		{
			if (pi->hidamage-pi->lodamage!=0) total+=(rand()%(pi->hidamage-pi->lodamage))+(pi->lodamage); 
			else total+=pi->lodamage;
		}
		else if ((pi->lodamage==0)&&(pi->hidamage==0)) total+=pi->att;
	}
	if (total<1) total=1;
	return total;
}

int cCombat::CalcDef(P_CHAR pc,int x) // Calculate total defense power 
{ 
	P_ITEM pj=NULL; 
	P_ITEM pShield = pc->getShield(); 
	unsigned int total=pc->def; 
	if (x==0) // -Fraz- added parrying skill bonuses
	{ 
		if (pShield) 
			total+=1+(((pc->Skill(PARRYING)/10) * pShield->def) / 200); // -Fraz- These values may need tweaked to OSI
	} 
	if (pc->Skill(PARRYING)>=1000) 
		total+=5; // gm parry bonus. 
	if (isTrueHuman(pc)) // Added by Magius(CHE) 
	{ 
		int ci=0,loopexit=0; 
		P_ITEM pi; 
		while ( ((pi=pc->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{ 
			if (pi->layer>1 && pi->layer<25) 
			{ 
				//blackwinds new stuff 
				int armordef=0; 
				if (pi->def>0) 
				{ 
					float armorhpperc=((float)pi->hp/((float)pi->maxhp/100)); 
					armordef=(int)(((float)pi->def/100)*armorhpperc); 
				} 

				if (x==0) 
					total+=pi->def; 
				else 
				{ 
					switch (pi->layer) 
					{ 
					case 5: 
					case 13: 
					case 17: 
					case 20: 
					case 22: 
						if (x==1 && pi->def>total) 
						{ 
							total=pi->def; 
							pj=pi; 
						} 
						break; 
					case 19: 
						if (x==2 && pi->def>total) 
						{ 
							total=pi->def; 
							pj=pi; 
						} 
						break; 
					case 6: 
						if (x==3 && pi->def>total) 
						{ 
							total=pi->def; 
							pj=pi; 
						} 
						break; 
					case 3: 
					case 4: 
					case 12: 
					case 23: 
					case 24: 
						if (x==4 && pi->def>total) 
						{ 
							total=pi->def; 
							pj=pi; 
						} 
						break; 
					case 10: 
						if (x==5 && pi->def>total) 
						{ 
							total=pi->def; 
							pj=pi; 
						} 
						break; 
					case 7: 
						if (x==6 && pi->def>total) 
						{ 
							total=pi->def; 
							pj=pi; 
						} 
						break; 
					default: 
						break; 
					} 
				} 
			} 
		} 
	} else pj=NULL; 

	UOXSOCKET k=pc->calcSocket(); 
	if (pj && k!=-1) 
	{ 
		//AntiChrist - don't damage hairs, beard and backpack 
		//important! this sometimes cause backpack destroy! 
		// 
		if (pj->layer!=0x0B && pj->layer!=0x10 && pj->layer!=0x15) // bugfix lB,was 0x15, 0x15,0x15 !! 
		{ 
			if ((rand()%2)==0) 
				pj->hp--; //Take off a hit point 
			if (pj->hp<=0) 
			{ 
				sprintf(temp,"Your %s has been destroyed", pj->getName().c_str());
				pc->removeItemBonus(pj);	// remove BONUS STATS given by equipped special items
				//-Frazurbluu-  need to have tactics bonus removed also
				if ((pj->trigon==1) && (pj->layer >0))// -Frazurbluu- Trigger Type 2 is my new trigger type *-
				{
					triggerwitem(k, pj, 1); // trigger is fired when item destroyed
				}
				sysmessage(k,temp);
				Items->DeleItem(pj);		 
			}
			statwindow(k,pc);
		}
	}
	if (total < 2) total = 2;
	return total;
}

int cCombat::TimerOk(P_CHAR pc)
{
	if (!pc) return 0;
	int d=0;
	//---BackStab-- Tab-Machinegun stopper- meet both timeout requirements---------- 
    if (( pc->timeout < uiCurrentTime )&&(pc->timeout2 < uiCurrentTime)) d=1;
	if (overflow) d=1;
	return d;
}

//play animation for weapon in hand during combat on a horse //kolours - modularized (09/20/98)
void cCombat::CombatOnHorse(P_CHAR pc)
{
	if (!pc) return;
	P_ITEM Weapon=pc->getWeapon();

	// tweak for better fight animations if on Lama, ostards, kirin, seahorse, or ridgeback
	// LB (04-02-2002)
	

	P_ITEM pHorseItem=pc->GetItemOnLayer(0x19);	

	int base;
	int sock = pc->calcSocket();

	if (sock >=0) 
	{
		if (clientDimension[0]==2) base = 0x17;
		else
		{
			switch(pHorseItem->id() & 0x00FF)
			{
			case 0xab: // llamas
			case 0xa6:
				base=0x2b;
				break;
				
			case 0xa3:  // ostards 
			case 0xa4:
			case 0xa5:
			case 0xac:
				base=0x35;
				break;
				
			case 0xad: // kirin
				base=0x3f;
				break;
				
			case 0xb3: // sea horse
				base=0x49;
				break;
				
			case 0xb8: //ridgeback
				base=0x53;
				break;
				
			default:
				base = 0x17; // default (horse) base animation
				break;
			} // end of 3d client only switch (2d doesn't have those special anims)
		} 
	} else base = 0x17;

	if (Weapon)
	{
		short id = Weapon->id();

		if (IsBow(id))
		{
			pc->DoAction(base+4);
			return;
		}
		if (IsCrossbow(id) || IsHeavyCrossbow(id))
		{
			pc->DoAction(base+5);
			return;
		}

		if (  IsSword(id) || IsMaceType(id) ||
			(id ==0x0FB4 || id ==0x0FB5) || // sledge hammer
			IsFencing1H(id) )
		{
			pc->DoAction(base+3);
			return;
		}
		if ( IsAxe(id) || IsFencing2H(id) )
		{
			pc->DoAction(base+6); //2Handed
			return;
		}
	} // end of !=-1
	else
	{
		pc->DoAction(base+3); //fist fighting
		return;
	}
}

//play animation for weapon in hand for combat on foot //kolours - (09/20/98)
void cCombat::CombatOnFoot(P_CHAR pc)
{
	if (!pc) return;
	P_ITEM Weapon=pc->getWeapon();
	int m = rand()%4; //randomize the animation sequence

	if (Weapon)
	{
		short id = Weapon->id();

		if (IsBow(id))
		{
			pc->DoAction(0x12); //bow
			return;
		}
		if (IsCrossbow(id) || IsHeavyCrossbow(id))
		{
			pc->DoAction(0x13); //crossbow - regular
			return;
		}
		if (IsSword(id))
		{
			switch (m) //swords
			{
			case 0:		pc->DoAction(0x0D);	return; //side swing
			case 1:		pc->DoAction(0x0A);	return; //poke
			default:	pc->DoAction(0x09);	return; //top-down swing
			}
		}
		if (IsMace1H(id))
		{
			switch (m) //maces
			{
			case 0:		pc->DoAction(0x0D);	return;	//side swing
			default:	pc->DoAction(0x09);	return; //top-down swing
			}
		}
		if (IsMace2H(id) || IsAxe(id))
		{
			switch (m)
			{
			case 0:		pc->DoAction(0x0D);	return; //2H top-down
			case 1:		pc->DoAction(0x0C);	return; //2H swing
			default:	pc->DoAction(0x0D);	return; //2H top-down
			}
		}
		if (IsFencing1H(id))	// one handed fencing
		{
			switch (m) //fencing
			{
			case 0:		pc->DoAction(0x09);	return; //top-down
			case 1:		pc->DoAction(0x0D);	return; //side-swipe
			default:	pc->DoAction(0x0A);	return; //default: poke
			}
		}
		if (IsFencing2H(id))	//pitchfork & spear
		{
			switch (m) //pitchfork
			{
			case 0:		pc->DoAction(0x0D);	return; //top-down
			default:	pc->DoAction(0x0E);	return; //default: 2-handed poke
			}
		}
	} // end of !=-1
	else
	{
		switch (m) //fist fighting
		{
		case 0:		pc->DoAction(0x0A);	return; //fist straight-punch
		case 1:		pc->DoAction(0x09);	return; //fist top-down
		default:	pc->DoAction(0x1F);	return; //default: //fist over-head
		}
	}
}


void cCombat::ItemSpell(cChar* Attacker, cChar* Defender)
{
	if (Attacker->npc)			// npcs can't use casting weapons right now (Duke)
		return;
	//currentSpellType[calcSocketFromChar(Attacker)]=2;
	// followed Pokey's advice and disabled it because none of the called spell functions actually
	// uses 'currentSpellType'. That should fix the 'precasted spells require no mana'-bug.
	// However, once we have a final design for magic....(Duke, 6.5.2002)

	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Attacker->SearchHands(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (!pi->isType(ITY_SpellBook))
		{
			if (pi->offspell && (pi->att||pi->hidamage) && pi->isType(ITY_CastingItem))
			{				
				if ((int)pi->morez<=0) return; //morez it UI, so first convtert to int, then check for negative value (Thrawn)
				switch(pi->offspell)
				{
				case 1:	OldMagic->ClumsySpell(Attacker,Defender, false);		break;
				case 2:	OldMagic->FeebleMindSpell(Attacker,Defender, false);	break;
				case 3:	OldMagic->MagicArrow(Attacker,Defender, false);		break;
				case 4:	OldMagic->WeakenSpell(Attacker,Defender, false);		break;
				case 5:	OldMagic->HarmSpell(Attacker,Defender, false);			break;
				case 6:	OldMagic->FireballSpell(Attacker,Defender, false);		break;
				case 8:	OldMagic->CurseSpell(Attacker,Defender, false);		break;
				case 9:	OldMagic->LightningSpellItem(Attacker,Defender);		break;
				case 11:OldMagic->MindBlastSpell(Attacker,Defender, false);	break;
				case 12:OldMagic->ParalyzeSpell(Attacker,Defender, false);		break;
				case 14:OldMagic->ExplosionSpell(Attacker,Defender, false);	break;
				case 15:OldMagic->FlameStrikeSpellItem(Attacker,Defender);		break;
				default:
					LogErrorVar("invalid offspell value %i",pi->offspell);
				}
				pi->morez--;
				if (pi->morez <= 0)
				{
					pi->morez = 0;
					pi->setType(pi->type2);
					pi->morex = 0;
					pi->morey = 0;
					pi->offspell = 0;
				}
			}
			return;
		}
    }
}

//AntiChrist - do the sound effect ( only if HITTEN! )
void cCombat::doSoundEffect(P_CHAR pc, int fightskill, P_ITEM Weapon)
{
	bool heavy=false;
	int a=rand()%4;

	//check if a heavy weapon
	if (Weapon==NULL) return;

	if (IsAxe(Weapon->id()))
		heavy=true;

	if (heavy)
	{
		if (a==0 || a==1) soundeffect2(pc, 0x0236);
		else soundeffect2(pc, 0x0237);
		return;
	}		

	switch(fightskill)
	{
	case ARCHERY:
		soundeffect2(pc, 0x0234);
		break;
	case FENCING:
	case SWORDSMANSHIP:
		if (a==0 || a==1) soundeffect2(pc, 0x023B);
		else soundeffect2(pc, 0x023C);
		break;
	case MACEFIGHTING:
		if (a==0 || a==1) soundeffect2(pc, 0x0232);
		else if (a==2) soundeffect2(pc, 0x0139);
		else soundeffect2(pc, 0x0233);
		break;
	case WRESTLING:
		if (a==0) soundeffect2(pc, 0x0135);
		else if (a==1) soundeffect2(pc, 0x0137);
		else if (a==2) soundeffect2(pc, 0x013D);
		else soundeffect2(pc, 0x013B);
		break;
	default:
		soundeffect2(pc, 0x013D);
	}
}


//AntiChrist - do the "MISSED" sound effect
void cCombat::doMissedSoundEffect(P_CHAR pc)
{
	int a=rand()%3;

	if (a==0) soundeffect2(pc, 0x0238);
	else if (a==1) soundeffect2(pc, 0x0239);
	else soundeffect2(pc, 0x023A);
}
