/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__COORD_H__)
#define __COORD_H__


#include "platform.h"	// Platform specifics

class cRectangle;		// avoid inclusion of rectangle.h

#define DEFAULT_MAP 0	// only to mark places where we explicitely do not support multi-maps yet

class cCoord
{
public:

	cCoord(void);
	cCoord(const cCoord& clCoord) ;
	cCoord(UI16, UI16, SI08, UI08 uiMap = 0);
	// Operators
	cCoord& operator= (const cCoord& clCoord) ;
	bool operator==(const cCoord&) const;
	cCoord operator+(const cCoord& src) const;

	UI32 distance(const cCoord &src) const;
	bool IsSameXY(const cCoord &other) const;
	bool IsSameXY(short ox, short oy) const;
	bool IsIn(const cRectangle& rect) const;
	void Add(short dx, short dy=0, short dz=0);

public:

	UI16 	x;
	UI16 	y;
	SI08 	z;
	UI08    map;
};

#endif
