/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "dbl_single_click.h"

#include "boats.h"
#include "books.h"
#include "guilds.h"
#include "gumps.h"
#include "itemid.h"
#include "house.h"
#include "LoS.h"
#include "magic.h"
#include "magic_new.h"
#include "msgboard.h"
#include "skills.h"
#include "TmpEff.h"
#include "trigger.h"
#include "SndPkg.h"
#include "utilsys.h"
#include "weight.h"
#include "Partysystem.h"
#include "assert.h"
#include "titles.h"
#include "network.h"
#include "regions.h"
#include "spells.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "dbl_single_click.cpp"


//////////////////
// name:	slotmachine
// history:	by Ripper, 5.12.2000
// purpose:	takes 5gp to spin it and gives random wins
//
static void slotmachine(UOXSOCKET s, P_CHAR Player, P_ITEM Slot)
{
	if (Player->dead)		// no ghosts playing :)
	{
		sysmessage(s,"ghosts cant do that!");
		return;
	}
	if (Player->dist(Slot)>3)	// within 3 to play.
	{
		sysmessage(s,"you need to be closer to play!");
		return;
	}
	if (Player->CountGold() < 5)	// check his gold to see if less than 5gp.
	{
		sysmessage(s,"you dont have enough gold to play!");
		return;
	}
	Player->deleteItems(5,0x0EED);	// if 5gp or more lets delete 5gp.
	int spin=RandomNum( 0,100);	// now lets spin to win :)
	switch(spin)
	{
	case 0: Items->SpawnItemBackpack2(s,SNI_3185);
		sysmessage(s,"Single bars, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 1: Items->SpawnItemBackpack2(s,SNI_3186);
		sysmessage(s,"Double bars, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 2: Items->SpawnItemBackpack2(s,SNI_3187);
		sysmessage(s,"Triple bars, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 3: Items->SpawnItemBackpack2(s,SNI_2003);
		sysmessage(s,"Any three 7`s, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 4: Items->SpawnItemBackpack2(s,SNI_2004);
		sysmessage(s,"Three blue 7`s, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 5: Items->SpawnItemBackpack2(s,SNI_2005);
		sysmessage(s,"Three white 7`s, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 6: Items->SpawnItemBackpack2(s,SNI_2006);
		sysmessage(s,"Three red 7`s, you are a winner!!");soundeffect(Player, 0x0038); break;
	case 7: Items->SpawnItemBackpack2(s,SNI_2007);
		sysmessage(s,"Jackpot, you are a winner!!");soundeffect(Player, 0x0038); break;
	default : itemmessage(s,Slot,"Sorry,not a winner,please insert coins."); break;
	}
	soundeffect(Player, 0x0057);	// my stupid spin sound hehe.
}

////////////////////
// Author : LB
// purpose: converting x,y coords to sextant coords
// input : x,y coords of object 
// output: sextant: sextant cords as string (char *)
// memory for output string sextant has to be reserved by callee !
// if not -> crash (has to be >=36 bytes !)
// thanks goes to Balxan / UOAM for the basic alogithm
// could be optimized a lot, but the freuqency of being called is probably very low
/////////////////////

void getSextantCords(const cCoord& pos, bool t2a, char *sextant)
{
   double Tx, Ty, Dx, Dy, Cx, Cy, Wx, Wy, Mx, My, Hx, Hy;
   signed int xH, xM, yH, yM;
   char xHs[20], yHs[20], xMs[20], yMs[20];

   if (t2a) // for t2a the center is in the middle
   {
	   Cy = 3112.0;
	   Cx = 5936.0;
   } else 
   {
	  // center, LB's throne *g*
      Cx = 1323.0;
      Cy = 1624.0;
   }

   //  map dimensions
   Wx = 5120.0;
   Wy = 4096.0;

   // convert input ints to float;
   Tx = (double) pos.x;
   Ty = (double) pos.y;

   // main calculation
   Dx = ( (Tx - Cx) * 360.0 ) / Wx;
   Dy = ( (Ty - Cy) * 360.0 ) / Wy;

   ////// now let's get minutes, hours & directions from it
   Hx = (signed int) Dx; // get hours (cut off digits after comma, no idea if there's a cleaner/better way)
   
   Mx = Dx - Hx; // get minutes
   Mx = Mx * 60;

   Hy = (signed int) Dy;
   My = Dy - Hy;
   My = My * 60;

   // convert the results to ints;
   xH = (signed int) Hx;
   xM = (signed int) Mx;
   yH = (signed int) Hy;
   yM = (signed int) My;

   // now compose result string

   numtostr(abs(xH),xHs);
   numtostr(abs(xM),xMs);
   numtostr(abs(yH),yHs);
   numtostr(abs(yM),yMs);

   strcpy(sextant, xHs);
   strcat(sextant,"o ");
   strcat(sextant, xMs);
   strcat(sextant,"' "); 
   if (xH>=0) strcat(sextant,"E"); else strcat(sextant,"W");

   strcat(sextant, "  ");
   strcat(sextant, yHs);
   strcat(sextant,"o ");
   strcat(sextant, yMs);
   strcat(sextant,"' "); 
   if (yH>=0) strcat(sextant,"S"); else strcat(sextant,"N");

}

/// decodes potion keg message parts (when single clicking keg)
/// mess: type of potion, mess2: amount of potions inside, empty: keg empty or not ?
void GenPotionKegMessage(P_ITEM keg, P_CHAR clicker, char* mess, char* mess2, char &empty, char &own)
{
	int potiontype,potionsubtype, potionamount, ownerserial;
	mess[0]=0;mess2[0]=0;

	int t = keg->getType();
	assert(t==ITY_POTIONKEG || t==ITY_POTIONKEG_PROTECTED);
	if (t!=ITY_POTIONKEG && t!=ITY_POTIONKEG_PROTECTED)
	{
		LogWarning("GenPotionKegMessaged called for non keg item");
		return;
	}

	ownerserial   = keg->morex;
	potiontype    = keg->morey;
	potionsubtype = keg->morez;
	potionamount  = keg->getMore1_4();

	empty=0;
	if (potionamount==0)
	{
        empty=1;	
		return;
	}

	P_CHAR pc = FindCharBySerial(ownerserial); 


	////////// decode potion type ////////////////////

	own=1;
	if (pc==NULL) // not clicked by owner ... only show color of potion
	{
      own=0;
	  int a=rand()%100;
	  if (a<=((100-(clicker->Skill(TASTEID)/10))-10)) potiontype=(rand()%8)+1; // tastid skill determines probability of correct color decoding

	  switch(potiontype)
	  {
		  case POTION_AGILITY:     strcpy(mess, "blue"); break;
		  case POTION_CURE:        strcpy(mess, "orange");break;
		  case POTION_EXPLOSION:   strcpy(mess, "purple lammaish");break;
		  case POTION_HEAL:        strcpy(mess, "yellow");break;
		  case POTION_NIGHTSIGHT:  strcpy(mess, "black");break;
		  case POTION_POISON:      strcpy(mess, "green");break;
		  case POTION_REFRESH:     strcpy(mess, "red");break;
		  case POTION_STRENGTH:    strcpy(mess, "white");break;
		  case POTION_MANA:        strcpy(mess, "reddish");break;
		  case POTION_LSD:         strcpy(mess, "rainbow colors");break;
		  case POTION_ALC:         strcpy(mess, "brownish");break;
		  default:                 strcpy(mess, "unkown color");break;
	  }
	}
    else // if owner, show all infos
	{
	  switch(potiontype)
	  {
	   case POTION_AGILITY:
		 switch(potionsubtype)
		 {
		   case 1:  strcpy(mess,"Agility"); break;
		   case 2:  strcpy(mess,"Greater Agility");break;
		   default: strcpy(mess,"Agility of unknown strength");break;
		 }
		 break;

	   case POTION_CURE:
		 switch(potionsubtype)
		 {
		   case 1:strcpy(mess,"Lesser Cure");break;
		   case 2:strcpy(mess,"Cure");break;
		   case 3:strcpy(mess,"Greater Cure");break;
		   default:strcpy(mess,"Cure of unknown strength");break;
		 }
		 break;

	   case POTION_EXPLOSION:
		 switch(potionsubtype)
		 {
		   case 1:strcpy(mess,"Lesser Explosion");break;
		   case 2:strcpy(mess,"Explosion");break;
		   case 3:strcpy(mess,"Greater Explosion");break;
		   default:strcpy(mess,"Explosion of unknown strength");break;
		 }
		 break;

	   case POTION_HEAL:
		 switch(potionsubtype)
		 {
		    case 1:strcpy(mess,"Lesser Heal");break;
			case 2:strcpy(mess,"Heal");break;
			case 3:strcpy(mess,"Greater Heal");break;
		    default:strcpy(mess,"Heal of unknown strength");break;
		 }
		 break;

	   case POTION_NIGHTSIGHT:strcpy(mess, "Nighsight");break;

	   case POTION_POISON:
		 switch(potionsubtype)
		 {
		    case 1:strcpy(mess,"Lesser Poison");break;
			case 2:strcpy(mess,"Poison");break;
			case 3:strcpy(mess,"Greater Poison");break;
			case 4:strcpy(mess,"Deadly Poison");break;
		    default:strcpy(mess,"Poison of unknown strength");break;
		 }
		 break;

	   case POTION_REFRESH:
		 switch(potionsubtype)
		 {
		    case 1:strcpy(mess,"Lesser Refresh");break;
			case 2:strcpy(mess,"Refresh");break;
		    default:strcpy(mess,"Refresh of unknown strength");break;
		 }
		 break;

	   case POTION_STRENGTH:
		 switch(potionsubtype)
		 {
		    case 1:strcpy(mess,"Lesser Strength");break;
			case 2:strcpy(mess,"Strength");break;
		    default:strcpy(mess,"Strength of unknown strength");break;
		 }
		 break;

	   case POTION_MANA:
		 switch(potionsubtype)
		 {
		    case 1:strcpy(mess,"Lesser Mana");break;
			case 2:strcpy(mess,"Mana");break;
		    default:strcpy(mess,"Mana of unknown strength");break;
		 }
		 break;

	   case POTION_LSD:strcpy(mess,"LSD");break;

	   case POTION_ALC:
		 switch(potionsubtype)
		 {
		    case 1:strcpy(mess,"Beer");break;
			case 2:strcpy(mess,"Wine");break;
		    default:strcpy(mess,"Alc of unknown strength");break;
		 }
		 break;

		 default: strcpy(mess,"unknown potion");break;
	  }
	 }

	/////////////////////////////
	// deocde quantity
	/////////////////////////////

	if (potionamount >=1 && potionamount <=4)        strcpy(mess2, "nearly empty");
    else if (potionamount >=5 && potionamount <=19)  strcpy(mess2, "not very full");
	else if (potionamount >=20 && potionamount <=29) strcpy(mess2, "about one quarter full");
	else if (potionamount >=30 && potionamount <=39) strcpy(mess2, "about one third full");
	else if (potionamount >=40 && potionamount <=46) strcpy(mess2, "almost half full");	
	else if (potionamount >=47 && potionamount <=53) strcpy(mess2, "approximately half full");	
	else if (potionamount >=54 && potionamount <=69) strcpy(mess2, "more than half full");
	else if (potionamount >=70 && potionamount <=79) strcpy(mess2, "three quaters full");	
	else if (potionamount >=80 && potionamount <=95) strcpy(mess2, "very full");	
	else if (potionamount >=96 && potionamount <=99) strcpy(mess2, "almost to the top of the keg");
	else if (potionamount == 100)                    strcpy(mess2, "completely full");	
	else                                             strcpy(mess2, "full to unkown height"); 
	
	
}


void PotionKegRetrival(UOXSOCKET s, P_CHAR Player, P_ITEM keg, int type)
{
	int kegownerserial, kegpotiontype, kegpotionsubtype, kegpotionamount;

	kegownerserial   = keg->morex;
	kegpotiontype    = keg->morey;
	kegpotionsubtype = keg->morez;
	kegpotionamount  = keg->getMore1_4();

	if (kegpotionamount==0) return; // nothing to retreive
	
	if (type) // owner protected -> check ownership before access is granted
	{			
		if (Player->serial!=kegownerserial) 
		{
		    if (s!=-1) sysmessage(s, "you are not the owner of this keg");
			return;
		}
	}

	// find empty bottle
		
	P_ITEM Pack=Player->getBackpack();
	int ci=0;
	P_ITEM EmptyBottle=ContainerSearchFor(Pack->serial,&ci,0x0f0e,-1);
	if (EmptyBottle==NULL) // no bottle found
	{
		if (s!=-1) sysmessage(s, "no empty bottle in backpack");
		return;
	}


	/////// fill bottle //////////////////////////////////

	short id=0;
	switch (kegpotiontype)
	{
		case POTION_AGILITY:	id=0x0F08; break;
		case POTION_CURE:		id=0x0F07; break;
		case POTION_EXPLOSION:	id=0x0F0D; break;
		case POTION_HEAL:		id=0x0F0C; break;
		case POTION_NIGHTSIGHT:	id=0x0f06; break;
		case POTION_POISON:		id=0x0F0A; break;
		case POTION_REFRESH:	id=0x0F0B; break;
		case POTION_STRENGTH:	id=0x0F09; break;
		case POTION_MANA:		id=0x0F08; break;
		case POTION_LSD:		id=0x1841; break;
		case POTION_ALC:		id=0x0F0E; break;
		default:				id=0x0F0E; break;
	}

	P_ITEM Potion = Items->SpawnItem(Player,1,"#",0, id,0,1);
	if (!Potion) return;

	EmptyBottle->ReduceAmount(1);
	Potion->setType(ITY_Potion);
	Potion->morey=kegpotiontype;
	Potion->morez=kegpotionsubtype;

	char x[128];
	char y[128];
	char empty, own;
	GenPotionKegMessage(keg, Player, x, y, empty, own);	
	if (own) strcat(x, " potion"); else strcat(x, " liquid");
	strncpy(Potion->name, x, 50);

	Potion->weight+=10;
	Potion->refresh();

	//////////////////// remove 1 potion from keg /////////

	keg->weight-=80;
	keg->setMore1_4(kegpotionamount-1);
	if (s!=-1) soundeffect(Player, 0x0030);

}

void usehairdye(UOXSOCKET s, P_ITEM Dye)	// x is the hair dye bottle object number
{
	int ci=0,loopexit=0;
	P_ITEM pi;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	while ( ((pi=Player->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->layer==0x10 || pi->layer==0x0B)//beard(0x10) and hair
		{
			pi->setColor(Dye->color());	//Now change the color to the hair dye bottle color!
			pi->refresh();
		}
	}
	Items->DeleItem(Dye);	//Now delete the hair dye bottle!
}

void usepotion(P_CHAR Player, P_ITEM pi)//Reprogrammed by AntiChrist
{
	int x;

	int s=Player->calcSocket();

	//blackwinds fix for potion delay 
	// disabled for now, because both objectdelay AND skilldelay are set, so you can't do anything (Duke)
	// delay should only be for another healing potion, but a good solution will need the new timers :(
#if 0
    if ((Player->skilldelay<=uiCurrentTime) || Player->isGM())
	{
       if (Player->skill[ALCHEMY]==1000)
		   Player->skilldelay=uiCurrentTime + (MY_CLOCKS_PER_SEC*9);
	   else 
          Player->skilldelay=uiCurrentTime + (MY_CLOCKS_PER_SEC*14);
#endif

	switch(pi->morey)
	{
	case POTION_AGILITY: // Agility Potion
		staticeffect(Player, 0x373a, 0, 15);
		switch(pi->morez)
		{
		case 1:
			tempeffect(Player, TEF_Agility, 5+RandomNum(1,10), 0, 0, 120);	// duration 2 minutes Duke, 31.10.2000
			sysmessage(s, "You feel more agile!");
			break;
		case 2:
			tempeffect(Player, TEF_Agility, 10+RandomNum(1,20), 0, 0, 120);
			sysmessage(s, "You feel much more agile!");
			break;
		default:
			LogErrorVar("Fallout of switch in usepotion() 1, value %i",pi->morez);
			return;
		}
		soundeffect2(Player, 0x01E7);
		if (s!=-1) updatestats(Player, 2);
		break;

	case POTION_CURE: // Cure Potion
		if (Player->Poisoned()<1)
			sysmessage(s,"The potion had no effect.");
		else
		{
			x=RandomNum(1,100);
			if ((unsigned)Player->Poisoned() < pi->morez) Player->ResetPoisoned();	// potion is stronger than poison: 100% chance
			if ((unsigned)Player->Poisoned() == pi->morez && x<81) Player->ResetPoisoned();	// potion as strong as poison: 80% chance
			switch (pi->morez)
			{
			case 1:
				if (Player->Poisoned()==2 && x<41) Player->ResetPoisoned();
				if (Player->Poisoned()==3 && x<21) Player->ResetPoisoned();
				if (Player->Poisoned()==4 && x< 6) Player->ResetPoisoned();
				break;
			case 2:
				if (Player->Poisoned()==3 && x<41) Player->ResetPoisoned();
				if (Player->Poisoned()==4 && x<21) Player->ResetPoisoned();
				break;
			case 3:
				if (Player->Poisoned()==4 && x<61) Player->ResetPoisoned();
				break;
			default:
				LogErrorVar("Fallout of switch in usepotion() 2, value %i",pi->morez);
				return;
			}
			if (Player->Poisoned())
				sysmessage(s,"The potion was not able to cure this poison.");
			else
			{
				staticeffect(Player, 0x373A, 0, 15);
				soundeffect2(Player, 0x01E0); //cure sound - SpaceDog
				sysmessage(s,"The poison was cured.");
			}
		}
		impowncreate(s, Player,1); //Lb, makes the green bar blue or the blue bar blue !
		break;

	case POTION_EXPLOSION: // Explosion Potion
		if (Player->inGuardedArea()) // Ripper 11-14-99
		{
			sysmessage(s," You cant use that in town!");
			return;
		}
		setAddid1_4(s,pi->serial);
		sysmessage(s, "Now would be a good time to throw it!");
		tempeffect(Player, TEF_ExplMsg, 0, 1, 3);
		tempeffect(Player, TEF_ExplMsg, 0, 2, 2);
		tempeffect(Player, TEF_ExplMsg, 0, 3, 1);
		tempeffect(Player, pi, TEF_Explode, 0, 4, 0);
		target(s,207,"*throw*");
		return; // lb bugfix, break is wronh here because it would delete bottle

	case POTION_HEAL: // Heal Potion
		switch(pi->morez)
		{
		case 1:
			Player->increaseHp( 5+RandomNum(1,5)+Player->Skill(HEALING)/100);
			sysmessage(s, "You feel better!");
			break;
		case 2:
			Player->increaseHp(15+RandomNum(1,10)+Player->Skill(HEALING)/50);
			sysmessage(s, "You feel more healthy!");
			break;
		case 3:
			Player->increaseHp(20+RandomNum(1,20)+Player->Skill(HEALING)/40);
			sysmessage(s, "You feel much more healthy!");
			break;
		default:
			LogErrorVar("Fallout of switch in usepotion() 4, value %i",pi->morez);
			return;
		}
		staticeffect(Player, 0x376A, 0x09, 0x06); // Sparkle effect
		soundeffect2(Player, 0x01F2); //Healing Sound - SpaceDog
		break;
	case POTION_NIGHTSIGHT: // Night Sight Potion

		staticeffect(Player, 0x376A, 0x09, 0x06);			

		int fix;
		fix = timeLight.fixedInlorPotionTime*60;
		int var;
		float k,l,m;
		k = (float) (timeLight.varInlorPotionTime*60);
		l = (float) pi->getMoreB1_4(); // get magery of CREATOR (alchemist)
		l = l / 1000.0;			
		m = k * l;
		var = (int)m; // oki dokey, you can write all that cruft into a single line, but got somewhat shizo about badly working conversion

		tempeffect(Player, TEF_NightSight, 0, 0, 0, var+fix); // should last for var+fix
		soundeffect2(Player, 0x01E3);
		break;
	case POTION_POISON: // Poison Potion
		if (pi->morez>4) pi->morez=4;
		if ((unsigned)Player->Poisoned() < pi->morez)
		{
			Player->PoisonStart(s,pi->morez);
			soundeffect2(Player, 0x0246); //poison sound - SpaceDog
			sysmessage(s, "You poisoned yourself! *sigh*"); //message -SpaceDog
		}
		break;
	case POTION_REFRESH: // Refresh Potion
		switch(pi->morez)
		{
		case 1:
			Player->increaseStm(20+RandomNum(1,10));
			sysmessage(s, "You feel more energetic!");
			break;
		case 2:
			Player->increaseStm(40+RandomNum(1,30));
			sysmessage(s, "You feel much more energetic!");
			break;
		default:
			LogErrorVar("Fallout of switch in usepotion() 7, value %i",pi->morez);
			return;
		}
		staticeffect(Player, 0x376A, 0x09, 0x06); // Sparkle effect
		soundeffect2(Player, 0x01F2); //Healing Sound
		break;
	case POTION_STRENGTH: // Strength Potion
		staticeffect(Player, 0x373A, 0, 15);
		switch(pi->morez)
		{
		case 1:
			tempeffect(Player, TEF_Strength, 5+RandomNum(1,10), 0, 0, 120);	// duration 2 minutes Duke, 31.10.2000
			sysmessage(s, "You feel more strong!");
			break;
		case 2:
			tempeffect(Player, TEF_Strength, 10+RandomNum(1,20), 0, 0, 120);
			sysmessage(s, "You feel much more strong!");
			break;
		default:
			LogErrorVar("Fallout of switch in usepotion() 8, value %i",pi->morez);
			return;
		}
		soundeffect2(Player, 0x01EE);
		break;

	case POTION_MANA: // Mana Potion
		switch(pi->morez)
		{
		case 1:
			Player->mn=min(Player->mn+10+pi->morex/100, (unsigned)Player->effInt());
			break;
		case 2:
			Player->mn=min(Player->mn+20+pi->morex/50, (unsigned)Player->effInt());
			break;
		default:
			LogErrorVar("Fallout of switch in usepotion() 9, value %i",pi->morez);
			return;
		}
		if (s!=-1) updatestats(Player, 1);
		staticeffect(Player, 0x376A, 0x09, 0x06); // Sparkle effect
		soundeffect2(Player, 0x01E7); //agility sound - SpaceDog
		break;

	case POTION_LSD: //LB's LSD potion, 5'th november 1999
		if (pi->id()!=0x1841) return; // only works with a special flask
		if (s==-1) return;
		if (LSD[s]==1)
		{
			sysmessage(s,"no,no,no,cant you get enough ?");
			return;
		}
		tempeffect(Player, TEF_LSD, 60+RandomNum(1,120), 0, 0); // trigger effect
		staticeffect(Player, 0x376A, 0x09, 0x06); // Sparkle effect
		soundeffect5(s, Player, 0x00F8); // lsd sound :)
		break;

	case POTION_SHRINK: //shrink potions by Thrawn
		sysmessage(s,"You can't shrink yourself!");
		return;

	default:
		LogErrorVar("Fallout of switch in usepotion() morey= %i",pi->morey);
		return;
	}
	soundeffect2(Player, 0x0030);
	if (Player->isHuman() && Player->onhorse==0) Player->DoAction(0x22);

	//empty bottle after drinking
	if (pi->morey!=3)	// not for explosion potions ;)
	{
		P_ITEM Bottle = Items->SpawnItem(Player,1,"#",1,0x0F0E,0,1);
		if (pi->morey==10)
		{
			Bottle->morey=10;
			Bottle->setId(0x183d); // empty Lsd potions
			Bottle->refresh();
		}
	}
	pi->ReduceAmount(1);

#if 0
	}
     else sysmessage(s, "You must wait a few seconds before you drink another potion");
#endif
}

void doubleclick(int s) // Completely redone by Morrolan 07.20.99
{
	P_ITEM iP,iK,iC;
	int w = 0;
	//	unsigned char map1[20] = "\x90\x40\x01\x02\x03\x13\x9D\x00\x00\x00\x00\x13\xFF\x0F\xA0\x01\x90\x01\x90";
	unsigned char map1[20] = "\x90\x40\x01\x02\x03\x13\x9D\x00\x00\x00\x00\x13\xFF\x0F\xFF\x01\x90\x01\x90";
	// By Polygon: Lower map border is 4095, not 4000, no more needed with new system anyway ;)
	unsigned char map2[12] = "\x56\x40\x01\x02\x03\x05\x00\x00\x00\x00\x00";
	// By Polygon: This one is needed to show the location on treasure maps
	unsigned char map3[12] = "\x56\x40\x01\x02\x03\x01\x00\x00\x00\x00\x00";
	
	//LogAssert(buffer[s][1]&0x80);
	int serial = LongFromCharPtr(&buffer[s][1]) & 0x7FFFFFFF;
	
	if (isCharSerial(serial))
	{
		dbl_click_character(s, serial);
		return;
	}

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	
	if (!Player->objectdelay.hasExpired() && !Player->isGM())
	{
		sysmessage(s, "You must wait to perform another action.");
		return;
	}
	else
		Player->objectdelay.setSecs(SrvParms->objectdelay);
	
	P_ITEM pi = FindItemBySerial(serial);
	if (!pi) return;

	Player->dclickedserial = serial;

	if (pi->isInWorld() && !Player->isGM() )
	{
		short pz = Player->pos.z;	// expand to short to avoid problems near +/- 127
		if ((Player->dist(pi) > 2 || pi->pos.z > pz+20 || pi->pos.z < pz-10)
			&& (pi->id() != 0x100A && pi->id() != 0x100B)	// not an archery butte
			&& !IsTillerman(pi->id())		// drydocking
			&& !IsPlank(pi->id()) )			// entering boats
		{
			sysmessage(s, "That is too far away.");
			return;
		}
#if 0
		if (!line_of_sight(s,Player, pi, WALLS_CHIMNEYS+DOORS+FLOORS_FLAT_ROOFING))
		{
			sysmessage(s, "You can't see that well enough.");
			return;
		}
#endif
	}
	
	if (isItemSerial(pi->contserial) && !pi->isType(ITY_Container) && !pi->isInWorld())
	{// Cant use stuff that isn't in your pack.
		P_CHAR PO = GetPackOwner(FindItemBySerial(pi->contserial));
		if (PO)
			if (!PO->isSameAs(Player))
				return;
	}
	else if (pi->IsWorn())	// on a character.
	{
		P_CHAR Wearer = FindWearerOf(pi);
		if (Wearer)
			if (!Wearer->isSameAs(Player) && pi->layer != 15 && !pi->isType(ITY_Container))
				return;
	}
	
	// Begin Items/Guildstones Section 

	// Criminal for looting an innocent corpse & unhidden if not owner..Ripper
	if (pi->corpse==1)
	{
		if (Player->isHiddenBySkill() && !Player->Owns(pi) && !Player->isGM())
		{
			Player->hidden=0;
			updatechar(Player);
		}

		if (!Player->Owns(pi) && !Player->isGM() && Player->isInnocent())
		{
			P_CHAR CorpseOwner = FindCharBySerial(pi->ownserial);
			bool Innocent = true;
			if (CorpseOwner)
			{
				if (Guilds->Compare(Player, CorpseOwner))
				{
					Innocent = false;
				}
				if (CorpseOwner->PartyCanLoot())
				{
					if (PartySystem->AreInSameParty(Player, CorpseOwner))
					{
						Innocent = false;
					}
				}
			}

			if (pi->more2==1 && (Innocent))
			{
				criminal(Player);
			}
		}
	}
	
	if (pi->isLockedDown() && pi->secureIt == 1)
	{
		if (!(Player->Owns(pi) || IsCoOwner(pi,Player) || Player->isGM()))
		{
			sysmessage(s, "That is a secured chest!");
			return;
		}
	}
	
	if (Player->dead &&					// if you are dead and
		!(pi->isType(ITY_Ankh) || pi->isType(ITY_Teleporter)))		// it's not an ankh nor teleporting object, FORGET IT!
	{
		sysmessage(s, "You may not do that as a ghost.");
		return;
	}
	else if (!Player->isGM() && pi->layer != 0 && !Player->Wears(pi))
	{// can't use other people's things!
		if (!(pi->layer == 0x15  && SrvParms->rogue == 1)) // bugfix for snooping not working, LB
		{
			sysmessage(s, "You cannot use items equipped by other players.");
			return;
		}
	}
	// Begin checking objects that we force an object delay for (std objects)
	// taken from 6904t2(5/10/99) - AntiChrist
	else if (s >= 0)
	{
		// start trigger stuff
		if (pi->trigger > 0)
		{
			if (pi->trigtype == 0)
			{
				if (pi->disabled <= uiCurrentTime) // changed by Magius(CHE) 
				{
					triggerwitem(s, pi, 1); // if players uses trigger
				} 
				else 
				{
					if (pi->TrigInf && pi->TrigInf->disabledmsg[0]) 
						sysmessage(s, pi->TrigInf->disabledmsg); // Added by Magius(CHE) 
					else 
						sysmessage(s, "That doesnt seem to work right now.");
				}
			}
			else 
			{
				sysmessage(s, "You are not close enough to use that.");
			}
			return;
		}
		
		// check this on trigger in the event that the .trigger property is not set on the item
		// trigger code.  Check to see if item is envokable by id
		
		else if ( checkenvoke( pi->id() ) )
		{
			target(s,  24, "What will you use this on?");
			return;
		}
		// end trigger stuff
		// BEGIN Check items by type 
	}	
	switch (pi->type)
	{
	case ITY_Ankh:		// Check for 'resurrect item type' this is the ONLY type one can use if dead.
		if (Player->dead)
		{
			Gumps->Menu(s,7,pi);
		} 
		else 
			sysmessage(s, "You are already living!");
		return;
		
	case ITY_Boat:
		if (pi->type2 == 3)
		{
			if (iteminrange(Player, pi, 5))
			{
				if (IsOpenPlank(pi->id()))
					Boats->PlankStuff(s, Player, pi);
				else 
					sysmessage(s, "That is locked.");
			}
			else 
				sysmessage(s, "You can't reach that!");
			return;
		}
		break;
		
	case ITY_Container: // normal containers
	case ITY_SpawnChest:
		if (pi->moreb1)
			OldMagic->MagicTrap(Player, pi); // added by AntiChrist
		// only 1 and 63 can be trapped, so pleaz leave it here :) - Anti
	case ITY_65: // nodecay item spawner..Ripper
	case ITY_66: // decaying item spawner..Ripper
		Player->objectdelay.reset();	// no delay for opening containers

		if ((pi->isInWorld() && iteminrange(Player, pi, 2)) ||  // Backpack in world - free access to everyone
			Player->Wears(pi))	// primary pack
		{
			backpack(s, pi);
			return;
		}
		if (isItemSerial(pi->contserial))
		{
			PC_ITEM pio = GetOutmostCont(pi);
			if (!pio) return;		// this should *not* happen, but it does ! Watch the logfiles (Duke)
			if (Player->Wears(pio) ||	// sub-pack
				(pio->isInWorld() && iteminrange(Player, pio, 2)))	// in world and in range
			{
				backpack(s, pi);
				return;
			}
		}
		P_CHAR pco;
		pco = GetPackOwner(pi);
		
		if ((npcinrange(Player, pco, 2)) || (iteminrange(Player, pi, 2)))
		{	
			if (pco == NULL)// reorganized by AntiChrist to avoid crashes
				backpack(s, pi);
			else if (Player->serial == pco->serial || Player->isGMorCounselor() || pco->isAiVendor())
				backpack(s, pi);
			else if (pco->ownserial == Player->serial) backpack(s,pi); // no snooping if looking in your packimal's packs
			else
				Skills->Snooping(Player, pi);
		}
		else
			sysmessage(s, "You are too far away!");
		return;
	case ITY_2: // Order gates?
		{
		PC_ITEM pj;
		AllItemsIterator aii;
		for (aii.Begin(); (pj = aii.GetData()) != aii.End(); aii++)
		{
			if (pj->isType(ITY_3))
			{
				if (pj->morez == 1)
				{
					P_ITEM pj2 = pj->unconst();
					pj2->morez = 2;
					pj2->pos.z += 17;
					pj2->refresh();
					w = 1;
				}
				else if (pj->morez == 2)
				{
					P_ITEM pj2 = pj->unconst();
					pj2->morez = 1;
					pj2->pos.z -= 17;
					pj2->refresh();
					w = 0;
				}
			}
		}
		}
		return;// order gates
	case ITY_4: // Chaos gates?
		{
		PC_ITEM pj;
		AllItemsIterator aii;
		for (aii.Begin(); (pj = aii.GetData()) != aii.End(); aii++)
		{
			if (pj->isType(ITY_5))
			{
				if (pj->morez == 3)
				{
					P_ITEM pj2 = pj->unconst();
					pj2->morez = 4;
					pj2->pos.z += 17;							
					pj2->refresh();
					w = 1;
				}
				else if (pj->morez == 4)
				{
					P_ITEM pj2 = pj->unconst();
					pj2->morez = 3;
					pj2->pos.z -= 17;							
					pj2->refresh();
					w = 0;
				}
			}
		}
		}
		//						if (w==1) sysmessage(s, "Chaos Gate opened.");
		//						else sysmessage(s, "Chaos Gate closed.");
		return;// chaos gates
	case ITY_6: // teleport item (ring?)
		target(s,  2, "Select teleport target.");
		return;// case 6
	case ITY_Key:
		setAddid1_4(s,pi->getMore1_4());
		if (pi->more1 == 255)
			addid1[s] = 255;
		target(s,  11, "Select item to use the key on.");
		return;

	case ITY_LockedContainer:	// locked item spawner
	case ITY_LockedSpawnChest:	//Morrolan traps?
		// Added traps effects by AntiChrist
		Player->objectdelay.reset();
		if (pi->moreb1)
			OldMagic->MagicTrap(Player, pi);
		sysmessage(s, "This item is locked.");
		return;
		
	case ITY_SpellBook:
		Player->objectdelay.reset();
		iK=Player->getBackpack();
		if (iK)
		{
			if (!iK->ContainsSub(pi) && !(Player->Wears(pi) && pi->layer == 1))
			{
				sysmessage(s, "To open the spellbook, it needs to be equipped or in your backpack");
				return;
			}
		}
		else
		{
			if (!(Player->Wears(pi) && pi->layer == 1))
			{
				sysmessage(s, "To open the spellbook, it needs to be equipped or in your backpack");
				return;
			}
		}

		Magic->OpenSpellBook(Player,pi,SBT_REGULAR);
		return;
	case ITY_NecroBook:
		Player->objectdelay.reset();
		iK=Player->getBackpack();
		if (iK)
		{
			if (!iK->ContainsSub(pi) && !(Player->Wears(pi) && pi->layer == 1))
			{
				sysmessage(s, "To open the spellbook, it needs to be equipped or in your backpack");
				return;
			}
		}
		else
		{
			if (!(Player->Wears(pi) && pi->layer == 1))
			{
				sysmessage(s, "To open the spellbook, it needs to be equipped or in your backpack");
				return;
			}
		}

		Magic->OpenSpellBook(Player,pi,SBT_NECRO);
		return;
	case ITY_PaladinBook:
		Player->objectdelay.reset();
		iK=Player->getBackpack();
		if (iK)
		{
			if (!iK->ContainsSub(pi) && !(Player->Wears(pi) && pi->layer == 1))
			{
				sysmessage(s, "To open the spellbook, it needs to be equipped or in your backpack");
				return;
			}
		}
		else
		{
			if (!(Player->Wears(pi) && pi->layer == 1))
			{
				sysmessage(s, "To open the spellbook, it needs to be equipped or in your backpack");
				return;
			}
		}

		Magic->OpenSpellBook(Player,pi,SBT_PALADIN);
		return;

	// modified by AntiChrist for use with newSelectSpell2Cast
	// rewritten (Duke 18.3.2001)
	// Attempting to fix many problems -moved here- 7/2001 -Frazurbluu-
	// SWEET, since I have the inBACKPACK working I should make a trigger function detailing object location for firing -Fraz-
	//rewritten by Thrawn, due to the whole magery rewrite
	case ITY_RegularSpellScroll:
	case ITY_NecroSpellScroll:
	case ITY_PaladinSpellScroll:
//	case ITY_CurstomSpellScroll:
		if (pi->isLockedDown()) return; //can't cast from locked down scrolls

		P_ITEM Pack;
		Pack = Player->getBackpack(); // get players backpack
		if (!Pack) return;

		if (!Pack->ContainsSub(pi)) // scroll in backpack?
		{
			sysmessage(s, "The scroll must be in your backpack to envoke its magic.");
			return;
		}

		int spn;
		spn = pi->getMore1_4();// get spell

		Magic->BeginCasting(Player,spn,STY_SCROLL);
//		if (OldMagic->newSelectSpell2Cast(s, Player, spn))		// check cast !
			pi->ReduceAmount(1);								// remove scroll if successful
		return;

	case ITY_Map:
		//		By Polygon:		Assign areas and map size before sending
		LongToCharPtr(pi->serial, &map1[1]);
		LongToCharPtr(pi->serial, &map2[1]);
		ShortToCharPtr(pi->getMore1_2(), &map1[7]);		// Assign topleft x
		ShortToCharPtr(pi->getMore3_4(), &map1[9]);		// Assign topleft y
		ShortToCharPtr(pi->getMoreB1_2(), &map1[11]);	// Assign lowright x
		ShortToCharPtr(pi->getMoreB3_4(), &map1[13]);	// Assign lowright y
		int width, height;		// Tempoary storage for w and h;
		width = 134 + (134 * pi->morez);	// Calculate new w and h
		height = 134 + (134 * pi->morez);
		ShortToCharPtr(width, &map1[15]);
		ShortToCharPtr(height, &map1[17]);
//		END OF: By Polygon
		
		XStartPkt(0x90, 19);
		XAddPkt(&map1[0+1],19-1);
		XFinishPkt(s);


		XStartPkt(0x56, 11);
		XAddPkt(&map2[0+1], 11-1);
		XFinishPkt(s);

		return;// maps
	case ITY_Book: // book (not spellbooks)
		Player->objectdelay.reset();
		if (pi->morex != 666 && pi->morex != 999)
			Books->openbook_scp(s, pi); 
		else if (pi->morex == 666)
			Books->openbook(s, pi, 1);
		else 
			Books->openbook(s, pi, 0);
		return;// book
		
	case ITY_Door: // door(unlocked)
		Player->objectdelay.reset();
		dooruse(s, pi);
		return; // doors
	case ITY_LockedDoor:
		iP = Player->getBackpack();
		if (iP!=NULL) // LB
		{
			PC_ITEM pj;
			AllItemsIterator aii;
			for (aii.Begin(); (pj = aii.GetData()) != aii.End(); aii++)
			{
				if (pj->isType(ITY_Key))
				{
					if ( pj->getMore1_4() == pi->getMore1_4() &&
						iP->Contains(pj))
					{
						sysmessage(s, "You quickly unlock, use, and then relock the door.");
						Player->objectdelay.reset();
						dooruse(s, pi);
						return;
					}
				}
			}
		}
		sysmessage(s, "This door is locked.");
		return;
	case ITY_Food: // For eating food
		Player->objectdelay.reset();
		if (pi->isLockedDown())
			return; // Ripper..cant eat locked down food :)
		
		if (!Player->CanEat(pi) || (pi->id()==0x0f36))	// new food system: see if player can eat the item
														// there is no type for hay, prevent eating it by checking the id
		{
			sysmessage(s, "You can't eat this!");
			return;
		}

		if (Player->Hunger() >= 6)
		{
			sysmessage(s, "You are simply too full to eat any more!");
			return;
		}
		else
		{
			switch (RandomNum(0, 2))
			{
			case 0: soundeffect2(Player, 0x003A);		break;
			case 1: soundeffect2(Player, 0x003B);		break;
			case 2: soundeffect2(Player, 0x003C);		break;
			}
			
			switch (Player->Hunger())
			{
			case 0:  sysmessage(s, "You eat the food, but are still extremely hungry.");	break;
			case 1:  sysmessage(s, "You eat the food, but are still extremely hungry.");	break;
			case 2:  sysmessage(s, "After eating the food, you feel much less hungry.");	break;
			case 3:  sysmessage(s, "You eat the food, and begin to feel more satiated.");	break;
			case 4:  sysmessage(s, "You feel quite full after consuming the food.");		break;
			case 5:  sysmessage(s, "You are nearly stuffed, but manage to eat the food.");	break;
			case 6:  sysmessage(s, "You are simply too full to eat any more!");				break;
			default: sysmessage(s, "You are simply too full to eat any more!");				break;
			}
			
			if (pi->Poisoned() && Player->Poisoned() < pi->Poisoned()) 
			{
				sysmessage(s, "You have been poisoned!");
				soundeffect2(Player, 0x0246); // poison sound - SpaceDog
				Player->PoisonStart(s,pi->Poisoned());
			}
			
			pi->ReduceAmount(1);	// Remove a food item
			Player->chgHunger(1);
		}
		return;
	case ITY_CastingItem: // -Fraz- Modified and tuned up, Wands must now be equipped or in pack
		iK = Player->getBackpack();
		if (iK!=NULL)
		{
			if (iK->Contains(pi) || Player->Wears(pi) && pi->layer == 1)
			{
				if ((int)pi->morez > 0) //morez is UI, so first convtert to int, then check for negative value (Thrawn)
				{
					if (Magic->BeginCasting(Player,(8*(pi->morex - 1)) + pi->morey,STY_ITEM))
					{
						pi->morez--;
						if (pi->morez == 0)
						{
							pi->setType(pi->type2);
							pi->morex = 0;
							pi->morey = 0;
							pi->offspell = 0;
						}
					}

/*					currentSpellType[s] = 2;
					if (OldMagic->newSelectSpell2Cast(s, Player, )
					{ 
					}
*/
				}
			}
			else
				sysmessage(s, "If you wish to use this, it must be equipped or in your backpack.");
		}
		return;

	case ITY_18: // crystal ball?
		switch (RandomNum(0, 9))
		{
		case 0: itemmessage(s,pi, "Seek out the mystic llama herder.");									break;
		case 1: itemmessage(s,pi, "Wherever you go, there you are.");									break;
		case 2: itemmessage(s,pi, "Quick! Lord Binary is giving away gold at the castle!");				break;
		case 3: itemmessage(s,pi, "Ripper is watching you every move.");								break;
		case 4: itemmessage(s,pi, "The message appears to be too cloudy to make anything out of it.");	break;
		case 5: itemmessage(s,pi, "You have just lost five strength.. not!")			;				break;
		case 6: itemmessage(s,pi, "You're really playing a game you know");								break;
		case 7: itemmessage(s,pi, "You will be successful in all you do.");								break;
		case 8: itemmessage(s,pi, "You are a person of culture.");										break;
		case 9: itemmessage(s,pi, "Give me a break! How much good fortune do you expect!");				break;
		}
		soundeffect(Player, 0x01EC);
		return;
		
		case ITY_Potion:
			usepotion(Player, pi);
			return; // case 19 (potions)					
			
		case ITY_Rune:
			if (pi->morex == 0 && pi->morey == 0 && pi->morez == 0)
			{
				sysmessage(s, "That rune is not yet marked!");
			}
			else
			{
				P_ITEM pack = Player->getBackpack();
				if (pack->ContainsSub(pi))
				{
					Player->setInput(4,pi);
					sysmessage(s, "Enter new rune name.");
				}
				else sysmessage(s, "The rune needs to be in your backpack!");
			}
			return;

		case ITY_FireworksWand:
			srand(uiCurrentTime);
			if (pi->morex <= 0)
			{
				sysmessage(s,  "That is out of charges.");
				return;
			}
			pi->morex--;
			sprintf(temp, "Your wand now has %i charges left", pi->morex);
			sysmessage(s, (char*) temp);
			
			int wi;
			for (wi = 0; wi <(rand()%4 + 1); wi++)
			{
				cCoord effPos(Player->pos);
				effPos.Add((rand()%11 - 5), (rand()%11 - 5), 10);
				movingeffect3(Player, effPos, 0x36E4, 17, 0, rand()%2);
				switch (RandomNum(0, 4))
				{
				case 0:	staticeffect3(effPos, 0x37, 0x3A, 0x09, 0, 0);	break;
				case 1:	staticeffect3(effPos, 0x37, 0x4A, 0x09, 0, 0);	break;
				case 2:	staticeffect3(effPos, 0x37, 0x5A, 0x09, 0, 0);	break;
				case 3:	staticeffect3(effPos, 0x37, 0x6A, 0x09, 0, 0);	break;
				case 4: staticeffect3(effPos, 0x37, 0x7A, 0x09, 0, 0);	break;
				}
			}
			return;
			
		case ITY_SmokeObj: // let's smoke! :)
			Player->smoketimer = pi->morex*MY_CLOCKS_PER_SEC + getNormalizedTime();
			Items->DeleItem(pi);
			return;
		case ITY_RenameDeed: // rename deed! -- eagle 1/29/00
			Player->setInput(5,pi);
			sysmessage(s, "Enter your new name.");
			Items->DeleItem(pi);
			return;
			
// Dclicking an item of type 100 seems to try save the morex-z values and set vivisility to 2.
// Or restore the morex-z and visibility to their old values.
// It seems the coder attempted to create an 'gates on/off'-item.
// But the code is buggy and will screw the morex-z on restore (moreb1-3 are only char !)
//
// I guess I'll better disable it...(Duke, 20.9.03)

/*		case ITY_100:  // type 100?  this ain't in the docs... - Morrolan
			{
			P_ITEM pj;
			AllItemsIterator aii;
			for (aii.Begin(); (pj = aii.GetData()) != aii.End(); aii++)
			{
				if ( (pj->moreb1 == pi->morex && pj->moreb2 == pi->morey && pj->moreb3 == pi->morez)
					|| (pj->morex == pi->morex && pj->morey == pi->morey && pj->morez == pi->morez)
					&& (!pj->isSameAs(pi) && pi->morex != 0  && pi->morey != 0  && pi->morez != 0))
				{ 
					if ((pj->morex == 0) &&(pj->morey == 0) &&(pj->morez == 0))
					{ 
						pj->morex = pj->moreb1;
						pj->morey = pj->moreb2;
						pj->morez = pj->moreb3;
						pj->visible = 0;								
						pj->refresh();
					} 
					else 
					{
						pj->moreb1 = pj->morex;
						pj->moreb2 = pj->morey;
						pj->moreb3 = pj->morez;
						pj->morex = 0;
						pj->morey = 0;
						pj->morez = 0;
						pj->visible = 2;							
						pj->refresh();
					}
				}
			}
			}
			return; */
		case ITY_101: //??
			Player->setId(pi->morex); 
			updatechar(Player);
			pi->setType(ITY_102);
			return;
		case ITY_102: //??
			Player->setId(Player->xid());
			updatechar(Player);
			pi->setType(ITY_101);
			return;
		case ITY_103: // Army enlistment
			enlist(s, pi->morex);
			Items->DeleItem(pi);
			return; // case 103 (army enlistment object)
		case ITY_Teleporter: // Teleport object
			{
			cCoord newPos(pi->morex,pi->morey,pi->morez,DEFAULT_MAP);
			Player->teleTo(newPos);
			return; // case 104 (teleport object (again?))
			}
		case ITY_Drink:  // For drinking
			soundeffect2(Player, 0x0030+(rand()%2));
			pi->ReduceAmount(1);	// Remove a drink
			sysmessage(s, "Gulp !");
			return;
			
		case ITY_TownHouse:
			deedTownHouse(s,pi);
			return;
			
		case ITY_TownHouseDeed:
			target(s, 78, "Select a location in your new home!");
			return;
			
		case ITY_GuildStone:
			if ( pi->id() == 0x14F0  ||  pi->id() == 0x1869 )	// Check for Deed/Teleporter + Guild Type
			{
				Guilds->StonePlacement(s,Player,pi);
				return;
			}
			else if (pi->id() == 0x0ED5)	// Check for Guildstone + Guild Type
			{
				Guilds->Menu(s, 1);
				return;
			}
			else 
				Console.send("Unhandled guild item type named: %s with ID of: %X", pi->name, pi->id());
			return;
			// End of guild stuff
		case ITY_Sign: // Open a gumpmenu - Crackerjack 8/9/99
			if (!(Player->Owns(pi) || IsCoOwner(pi,Player) || Player->isGM()))
			{
				sysmessage(s, "You can not use that.");
				return;
			}
			setAddid1_4(s,pi->serial);
			Gumps->Menu(s, pi->morex, pi);
			return;	

		case ITY_NPCITEM: // handles transfer of NPC's via pack
			
			P_CHAR Npc;
			if (pi->morey==1)
			{
				Npc = FindCharBySerial(pi->morex); // find npc, remember, it's still there, just invisible
				if (Npc==NULL) return;
				
				Npc->doppelgaenger_serial=0; // undo invisibility etc
				Npc->makeVulnerable();	          
				Npc->MoveToOneOff(Player->pos);
				Npc->unhide(); // also resends npc
				
				pi->morey=0; // set deed back to empty
				pi->setId(pi->morez); 			   
				pi->refresh();
			}
			else
			{
				target(s, 302, "select NPC to put into deed");
			}
			return;
			
		case ITY_SHRUNKNPC:
			Npc = FindCharBySerial(pi->morex);
			if (!Npc) return;
			
			Npc->doppelgaenger_serial=0;
			Npc->SetOwnSerial(Player->serial);
			Npc->MoveToOneOff(Player->pos);

			Npc->hungertime += uiCurrentTime; // readd the current time and let it hunger again (Thrawn)

			updatechar(Npc);
			
			pi->ReduceAmount(1);
			return;
			
		case ITY_POTIONKEG_PROTECTED: // Potion keg retrival
		case ITY_POTIONKEG:
			int t;
			t = pi->isType(ITY_POTIONKEG_PROTECTED);			   
			PotionKegRetrival(s, Player, pi, t);
			return;
			
		case ITY_VendorDeed:			// PlayerVendors deed
		case ITY_VendorDeedWithoutHouse:
			{	
				if (pi->isLockedDown())
				{
					sysmessage(s, "That item is locked down.");
					return; 
				} // added by ripper, bugfixed by LB

				char withouthouse=1;

				if  (pi->isType(ITY_VendorDeed)) // only check for house for normal vendor deed type (217)
				{
				  int los = 0;
				  PC_ITEM House = findHouseAt(Player->pos); // boats are also multis zippy, btw !!!		
				  if (House)
				  {
					if (Player->hasKeyFor(House))
						los = 1;
				  }
				
				  if (!House || !los)
				  {
					sysmessage(s, "You must be close to a house and have a key in your pack to place that.");
					return;
				  }

				  withouthouse=0;
				}

				P_CHAR Vendor = Npcs->AddNPC(-1, SNC_PlayerVendor, Player->pos);
				if (!Vendor) 
				{
					LogError("npc-script couldnt find vendor !");
					return;
				}
				Vendor->setAi(17);
				Vendor->makeInvulnerable();
				Vendor->hidden = 0;
				Vendor->stealth=-1;
				Vendor->dir = Player->dir;
				Vendor->npcWander = 0;
				Vendor->setInnocent();
				Vendor->SetOwnSerial(Player->serial);
				Vendor->tamed = false;
				Vendor->SetPriv4(withouthouse); // memorize vendor type in case it gets deeded
				Items->DeleItem(pi);
				updatechar(Vendor);
				sprintf(temp, "Hello sir! My name is %s and i will be working for you.", Vendor->name);
				npctalk(s, Vendor, temp, 0);
				
				return;
			}
		case ITY_EmptyMap:
			sysmessage(s, "...just an empty map"); 
			return;
		// By Polygon: Clicked on a tattered treasure map, call decipher-function
		case ITY_TatteredMap:
			Skills->Decipher(pi, s);
			return;
/*
	By Polygon:
	Clicked on a deciphered treasure map
	Show a map-gump with the treasure location in it
*/
		case ITY_DecipheredMap:	// Deciphered treasure map
			LongToCharPtr(pi->serial, &map1[1]);
			LongToCharPtr(pi->serial, &map2[1]);
			ShortToCharPtr(pi->getMore1_2(), &map1[7]);		// Assign topleft x
			ShortToCharPtr(pi->getMore3_4(), &map1[9]);		// Assign topleft y
			ShortToCharPtr(pi->getMoreB1_2(), &map1[11]);	// Assign lowright x
			ShortToCharPtr(pi->getMoreB3_4(), &map1[13]);	// Assign lowright y
			map1[15] = 0x01;			// Let width and height be 256
			map1[16] = 0x00;
			map1[17] = 0x01;
			map1[18] = 0x00;

			XStartPkt(0x90, 19);
			XAddPkt(&map1[0+1],19-1);
			XFinishPkt(s);
		
			XStartPkt(0x56, 11);
			XAddPkt(&map2[0+1],11-1);
			XFinishPkt(s);

			// Generate message to add a map point
			LongToCharPtr(pi->serial, &map3[1]);
			int posx, posy;			// tempoary storage for map point
			int tlx, tly, lrx, lry;	// tempoary storage for map extends
			tlx = pi->getMore1_2();	// topleft x
			tly = pi->getMore3_4();	// topleft y
			lrx = pi->getMoreB1_2();
			lry = pi->getMoreB3_4();
			if ((lrx - tlx)==0 || (lry - tly)==0)
			{
				LogWarning("Bad script on treasure map");
				return;
			}
			posx = (256 * (pi->morex - tlx)) / (lrx - tlx);	// Generate location for point
			posy = (256 * (pi->morey - tly)) / (lry - tly);
			map3[7] = posx>>8;	// Store the point position
			map3[8] = posx%256;
			map3[9] = posy>>8;
			map3[10] = posy%256;
			
		
			XStartPkt(0x56, 11);
			XAddPkt(&map3[0+1],11-1);
			XFinishPkt(s);		
			return;

// END OF: By Polygon
		case ITY_JailBall: // Blackwinds JAIL BALL 
            if (Player->jailtimer.getRemainingSecs()>0) 
			{ 
	             sprintf(temp, "You have %i seconds left in the jail", Player->jailtimer.getRemainingSecs()); 
	             itemmessage(s,pi, temp); 
			} 
            else 
			{ 
	             sysmessage(s, "Crystall ball shatters.."); 
	             pi->ReduceAmount(1); 
			}
            return;
		case ITY_ReputationBall: // Blackwinds Reputation ball 
			soundeffect(Player, 0x01EC); // Play sound effect for player 
			
			sprintf(temp,"Your karma is %i",Player->karma);
			sysmessage(s,temp); 
			sprintf(temp,"Your fame is %i",Player->fame);
			sysmessage(s,temp); 
			sprintf(temp,"Your Kill count is %i ",Player->kills);
			sysmessage(s,temp); 
			sprintf(temp,"You died %i times.",Player->deaths);
			sysmessage(s,temp);
			staticeffect(Player, 0x372A, 0x09, 0x06 );
			sysmessage(s,"*The crystal ball seems to have vanished*");
			pi->ReduceAmount(1); 
			return; 
		case ITY_BankDeed:
			iK = Player->GetBankBox();
			if (!iK) return;
			if (iK->Contains(pi))
			{
				P_ITEM Gold = Items->SpawnGoldInBank(Player,pi->morex);
				Gold->refresh();
				soundeffect(Player, 0x0037);
				Items->DeleItem(pi);
			}
			else
			{
				sysmessage(s, "Check must be in the bank box to be used!");
			}
			return;
		case ITY_IDwand: // Fraz'z ID wand
			{
				iK = Player->getBackpack();
				if (iK!=NULL)
				if (iK->Contains(pi) || Player->Wears(pi) && pi->layer == 1)
				{
					if (pi->morex <= 0)
					{
						sysmessage(s,  "That is out of charges.");
						return;
					}
					pi->morex--;
					sprintf(temp, "Your wand now has %i charges left", pi->morex);
					sysmessage(s, (char*) temp);
					target(s,  75, "What do you wish to identify?");
				}
				else
				{
					sysmessage(s, "If you wish to use this, it must be equipped or in your backpack.");
				}
				return;
			}
		case ITY_RuneBook:
			runebookg[s]=serial;
			Gumps->RuneBook(s,7,pi);
			return;
		case ITY_BoatModel:
			addx[s] = pi->getMore3_4();
			buildHousePass1(s, pi->getMore3_4());
			return;
		case ITY_ShipPlan:
			target(s,83,"Select where to craft your ship");
			return;
		case ITY_ShipYard:
		case ITY_ShipPart:
			Boats->ShowNextPart(s,pi);
			return;
		default:						
			break; // case (itype!) 
		}// switch (itype)
		// END Check items by type
		
		// Begin checking objects by ID
		if (!pi->isLockedDown())
		{
			if (IsGrowingPlant(pi->id()))
			{
				sysmessage(s, "This plant still needs to grow.");
				return;
			}
			if (IsRipeCotton(pi->id()))
			{
				Player->DoAction(Player->onhorse ? 0x1D : 0x0D);
				soundeffect(Player, 0x013E);
				P_ITEM Cotton = Items->SpawnItem(Player, 1, "#", 1, 0x0DF9, 0, 1);
				if (!Cotton) return;
				sysmessage(s, "You reach down and pick some cotton.");
				tempeffect(pi, TEF_Plant,1);	// reduce it to seed/sapling and let it grow
				return;
			}
			if (IsRipeWheat(pi->id()))
			{
				Player->DoAction(Player->onhorse ? 0x1D : 0x0D);
				soundeffect(Player, 0x013E);
				P_ITEM Wheat = Items->SpawnItem(Player, 1, "#", 1, 0x1EBD, 0, 1);
				if (!Wheat)	return;
				sysmessage(s, "You reach down and pick some wheat.");
				tempeffect(pi, TEF_Plant,1);	// reduce it to seed/sapling and let it grow
				return;
			}
			if (IsEmptyMill(pi->id()))
			{
				if (Player->CountItems(0x1EBD) < 4)
				{
					sysmessage(s, "You need at least 4 sheaves of wheat.");
					return;
				}
				Player->deleteItems(4,0x1EBD);
				int dir = 1;
				if (pi->id()==0x192C)
					dir=2;
				tempeffect(pi, TEF_Mill,dir,1);	// start to operate the mill
				return;
			}
			if (IsFinishedMill(pi->id()))
			{
				P_ITEM Sack = Items->SpawnItem(Player, 1, "#", 1, 0x1039, 0, 1);
				if (!Sack)	return;
				sysmessage(s, "You reach down and put the flour into a sack.");
				if (pi->id()==0x1923)
					pi->setId(0x1922);
				else
					pi->setId(0x192E);
				pi->refresh();
				return;
			}
			if (IsSword(pi->id()) || IsDagger(pi->id()) || IsKryss(pi->id()))
			{
				target(s, 86, "What would you like to use that on ?");
				return;
			}
			if (IsAxe(pi->id()))
			{
				target(s,  76, "What would you like to use that on ?");
				return;
			}
			if (IsForge(pi->id()))
			{
				if (!iteminrange(Player, pi, 3))
					sysmessage(s, "Must be closer to use this!");
				else
					target(s,  237, "What item would you like to Smelt?");
				return;
			}
			if (IsTillerman(pi->id()))
			{
				if (!iteminrange(Player, pi, 8))
					sysmessage(s, "Must be closer to use this!");
				else
					Boats->Drydock(s,Player,pi);
				return;
			}
			switch (pi->id())
			{	
				case 0x0FA9:// dye
					dyeall[s] = 0;
					target(s,  31, "Which dye vat will you use this on?");
					return;// dye
				case 0x0FAF:
				case 0x0FB0: // Anvils
					if (!iteminrange(Player, pi, 3))
					{
						sysmessage(s, "Must be closer to use this!");
						return;
					}
					target(s,  236, "Select item to be repaired.");
					return;
				case 0x0FAB:// dye vat
					addid1[s] = pi->color()>>8;
					addid2[s] = pi->color();
					target(s,  32, "Select the clothing to use this on.");
					return;// dye vat
				case 0x14F0:// houses
					if (!pi->isType(ITY_103) && !pi->isType(ITY_GuildStone))
					{  // experimental house code
						addx[s] = pi->morex;
						buildHousePass1(s, pi->morex);
						// target(s,0,1,0,207,"Select Location for house.");
					}
					return;// house deeds
				case 0x100A:
				case 0x100B:// archery butte
					Skills->AButte(s, pi);
					return;// archery butte
				case 0x0E9C:
					if (Player->checkSkill(MUSICIANSHIP))
						soundeffect2(Player, 0x0038);
					else 
						soundeffect2(Player, 0x0039);
					return;
				case 0x0E9D:
				case 0x0E9E:
					if (Player->checkSkill(MUSICIANSHIP))
						soundeffect2(Player, 0x0052);
					else 
						soundeffect2(Player, 0x0053);
					return;
				case 0x0EB1:
				case 0x0EB2:
					if (Player->checkSkill(MUSICIANSHIP))
						soundeffect2(Player, 0x0045);
					else 
						soundeffect2(Player, 0x0046);
					return;
				case 0x0EB3:
				case 0x0EB4:
					if (Player->checkSkill(MUSICIANSHIP))
						soundeffect2(Player, 0x004C);
					else 
						soundeffect2(Player, 0x004D);
					return;
				case 0x102A:// Hammer
				case 0x102B:
				case 0x0FBB:// tongs
				case 0x0FBC:
				case 0x13E3:// smith's hammers
				case 0x13E4:
				case 0x0FB4:// sledge hammers
				case 0x0FB5:
					if (!Player->ToolWearOut(s, pi))
						target(s,  50, "Select material to use.");
					return; // Smithy
					
				case 0x1026:// Chisels
				case 0x1027:
				case 0x1028:// Dove Tail Saw
				case 0x1029:
				case 0x102C:// Moulding Planes
				case 0x102D:
				case 0x102E:// Nails
				case 0x102F:
				case 0x1030:// Jointing plane
				case 0x1031:
				case 0x1032:// Smoothing plane
				case 0x1033:
				case 0x1034:// Saw
				case 0x1035:
					if (!Player->ToolWearOut(s, pi))
						target(s,  134, "Select material to use.");
					return; // carpentry
					
				case 0x0E85:// pickaxes
				case 0x0E86:
				case 0x0F39:// shovels
				case 0x0F3A:
					if (!Player->ToolWearOut(s, pi))
					{
						target(s,  51, "Where do you want to dig?");
					}
					return; // mining
				case 0x0E24: // empty vial
					iP = Player->getBackpack();
					if (iP)
					{
						if (iP->Contains(pi))
							target(s,  186, "What do you want to fill the vial with?");
						else 
							sysmessage(s, "The vial is not in your pack");
					}
					return;
				case 0x0DF9: 
					target(s,  166, "Select spinning wheel to spin cotton.");
					return;
				case 0x0FA0:
				case 0x0FA1: // thread to Bolt
				case 0x0E1D:
				case 0x0E1F:
				case 0x0E1E:  // yarn to cloth
					target(s,  165, "Select loom to make your cloth");
					return;
				case 0x14ED: // Build cannon
					target(s, 171, "Build this Monster!");
					Items->DeleItem(pi);
					return;
				case 0x1BD1:
				case 0x1BD2:
				case 0x1BD3:
				case 0x1BD4:
				case 0x1BD5:
				case 0x1BD6:	// make shafts
					itemmake[s].Mat1id = pi->id();
					target(s, 172, "What would you like to use this with?"); 
					return;
				case 0x0E73: // cannon ball
					target(s, 170, "Select cannon to load."); 
					Items->DeleItem(pi);
					return;
				case 0x0FF8:
				case 0x0FF9: // pitcher of water to flour
					target(s, 173, "Select flour to pour this on.");  
					return;
				case 0x09C0:
				case 0x09C1: // sausages to dough
					target(s, 174, "Select dough to put this on.");  
					return;
				case 0x0DF8: // wool to yarn 
					target(s, 164, "Select your spin wheel to spin wool.");      
					return;
				case 0x0F9D: // sewing kit for tailoring
					if (!Player->ToolWearOut(s, pi))
						target(s, 167, "Select material to use.");
					return;
				case 0x19B7:
				case 0x19B9:
				case 0x19BA:
				case 0x19B8: // smelt ore
//					Player->setDclickedItem(pi);
					target(s, 52, "Select forge to smelt ore on.");// smelting  for all ore changed by Myth 11/12/98
					return;
				case 0x1E5E:
				case 0x1E5F: // Message board opening
					MsgBoardEvent(s);
					return;
				case 0x0A58: // Closed Bedroll
					if (!pi->isInWorld())
					{
						sysmessage(s, "This must be placed on the ground to use.");
						return;
					}
					if (!iteminrange(Player, pi, 1))
					{
						sysmessage(s, "Get closer.");
						return;
					}
					pi->setId(0x0A55); // Open Bedroll
					pi->refresh();
					return;
				case 0x0A55: // Open Bedroll
					if (!pi->isInWorld())
					{
						sysmessage(s, "This must be placed on the ground to use.");
						return;
					}
					if (!iteminrange(Player, pi, 1))
					{
						sysmessage(s, "Get closer.");
						return;
					}
					if (Player->checkSkill(CAMPING, 0, 500))
					{
						PC_ITEM pj;
						int loopexit=0;
						RegGrid3x3Iterator4Items rg3ii(Player->pos);
						while ((pj = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if (pj->isType(ITY_Campfire) && Player->dist(pj) < 3)
							{
								if (pj->more1 != 1)
								{
									sysmessage(s,"Your camp is not secure yet.");
								}
								else
								{
								    Gumps->Menu(s,6,pi);
								}
							}
							else
							{
								pi->setId(0x0A58); // Closed Bedroll
						        pi->refresh();
							}
						}	 
					}
					return;
				case 0x0DE1:
				case 0x0DE2: // camping
					if (Player->checkSkill(CAMPING, 0, 500))
					{
						P_ITEM pFire = Items->SpawnItem(Player, 1, "#", 0, 0x0DE3, 0, 0);
						if (pFire)
						{
							pFire->setType(ITY_Campfire);
							pFire->dir = 2;
							pFire->decayOn();
							pFire->startDecay();
							if (pi->isInWorld())
								pFire->MoveTo2(pi->pos);
							else
								pFire->MoveTo2(Player->pos);

							pi->ReduceAmount(1);
							tempeffect(Player,TEF_Camping,0,0,0);
						}
					}
					else
					{
						sysmessage(s, "You fail to light a fire.");
					}
					return; // camping
				case 0x1508: // magic statue?
					if (Player->checkSkill(ITEMID, 0, 10))
					{
						pi->setId(0x1509);
						pi->setType(ITY_Campfire);
						pi->refresh();
					}
					else
					{
						sysmessage(s, "You failed to use this statue.");
					}
					return;
				case 0x1509:
					if (Player->checkSkill(ITEMID, 0, 10))
					{
						pi->setId(0x1508);
						pi->setType(ITY_Campfire);
						pi->refresh();
					}
					else
					{
						sysmessage(s, "You failed to use this statue.");
					}
					return;
				case 0x1230:
				case 0x1246: // guillotines?
					if (Player->checkSkill(ITEMID, 0, 10))
					{
						pi->setId(0x1245);
						pi->setType(ITY_Campfire);	// ?????
						pi->refresh();
					}
					else
					{
						sysmessage(s, "You failed to use this.");
					}  
					return;
				case 0x1245: // Guillotine stop animation
					if (Player->checkSkill(ITEMID, 0, 10))
					{
						pi->setId(0x1230);
						pi->setType(ITY_Campfire);	// ???
						pi->refresh();
					}
					else
					{
						sysmessage(s, "You failed to use this.");
					}
					return;
				case 0x1039:  // closed flour sack
							  /*
							  if (Skills->CheckSkill(currchar(s), ITEMID, 0, 10))
							  {
							  pi->id1 = 0x10;
							  pi->id2 = 0x3A;
							  pi->type = 45;						
							  RefreshItem(x);// AntiChrist
							  }
							  else
							  {
							  sysmessage(s, "You failed to use this.");
							  }
					*/
					return;
				case 0x103A: // open flour sack
							 /*
							 if (Skills->CheckSkill(currchar(s), ITEMID, 0, 10))
							 {
							 pi->id1 = 0x10;
							 pi->id2 = 0x39;
							 pi->type = 45;						
							 RefreshItem(x);// AntiChrist
							 }
							 else
							 {
							 sysmessage(s, "You failed to use this.");
							 }
					*/
					return;
				case 0x0DBF:
				case 0x0DC0:// fishing
					target(s, 45, "Fish where?");
					return;
				case 0x104B:
				case 0x104C:
				case 0x1086: // Clock and bracelet
					telltime(s);
					return;
				case 0x0E9B: // Mortar for Alchemy
					setAddid1_4(s,pi->serial);
					if (pi->isType(ITY_filledMortar))
					{
						target(s, 109, "Where is an empty bottle for your potion?");
					}
					else
					{
						target(s, 108, "What do you wish to grind with your mortar and pestle?");
					}
					return; // alchemy
				case 0x0F9E:
				case 0x0F9F: // scissors
					if (!Player->ToolWearOut(s, pi))
						target(s, 128, "What cloth should I use these scissors on?");
					return;
				case 0x0E21: // healing
					target(s, 130, "Who will you use the bandages on?");
					return;
				case 0x1057:
				case 0x1058: // sextants
					// dont know how if thats an accourate way to find out t2a-ness
					bool t2a;
					t2a = (Player->pos.x >= 5121);					    
					
					getSextantCords(Player->pos, t2a, temp2);
					sprintf(temp, "You are at: %s", temp2);
					sysmessage(s, temp);
					return;
				case 0x0E27:
				case 0x0EFF:   // Hair Dye
					Gumps->Menu(s,9,pi);
					return;
				case 0x14FB:
				case 0x14FC:
				case 0x14FD:
				case 0x14FE: // lockpicks
					target(s, 162, "What lock would you like to pick?");
					return;
				case 0x097A: // Raw Fish steaks
					target(s, 49, "What would you like to cook this on?");
					return;
				case 0x09b9: // Raw Bird
					target(s, 54, "What would you like to cook this on?");
					return;
				case 0x1609: // Raw Lamb
					target(s, 55, "What would you like to cook this on?");
					return;
				case 0x09F1: // Raw Ribs
					target(s, 68, "What would you like to cook this on?");
					return;
				case 0x1607: // Raw Chicken Legs
					target(s, 69, "What would you like to cook this on?");
					return;
				case 0x105B:
				case 0x105C:
				case 0x1053:
				case 0x1054: // tinker axle
					setAddid1_4(s,pi->serial);
					target(s, 183, "Select part to combine that with.");
					return;
				case 0x1051:
				case 0x1052:
				case 0x1055:
				case 0x1056:
				case 0x105D:
				case 0x105E:
					setAddid1_4(s,pi->serial);
					target(s, 184, "Select part to combine it with.");
					return;
				case 0x104F:
				case 0x1050:
				case 0x104D:
				case 0x104E:// tinker clock
					setAddid1_4(s,pi->serial);
					target(s, 185, "Select part to combine with");
					return;
				case 0x1059:
				case 0x105A:// tinker sextant
					if (Player->checkSkill(TINKERING, 500))
					{
						sysmessage(s, "You create the sextant.");
						iC = Items->SpawnItem(s, Player, 1, "a sextant", 0, 0x1057, 0, 1, 1);
						if (iC!=NULL)
							iC->decayOn();
						pi->ReduceAmount(1);
					}
					else 
						sysmessage(s, "you fail to create the sextant.");
					return;
				case 0x1070:
				case 0x1074: // training dummies
					if (iteminrange(Player, pi, 1))
						Skills->TDummy(s);
					else 
						sysmessage(s, "You need to be closer to use that.");
					return;
				case 0x1071:
				case 0x1073:
				case 0x1075:
				case 0x1077:// swinging training dummy
					sysmessage(s, "You must wait for it to stop swinging !");
					return;
				case 0x1EA8: 
					slotmachine(s, Player, pi);
					return; // Ripper
				case 0x1EBA: // tool kit / ship crafting (Duke, 26.12.2003)
					target(s, 84, "Select item to work on.");
					return;
				case 0x1EBC: // tinker's tools
					if (!Player->ToolWearOut(s, pi))
						target(s, 180, "Select material to use.");
					return;
				default:
					//	Console.send("Unhandled item id for item: %s with id: %X.",pi->name, itemids); //check for unused items - Morrolan
					break;
			}// switch (itemids)
		}
		// END Check items by ID
		sysmessage(s, "You can't think of a way to use that item.");
}


void singleclick(UOXSOCKET s, int serial)
{	
	int amt = 0, wgt;
	char itemname[100];
	char temps2[100];
	
	temp[0] = temp2[0] = itemname[0] = 0;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	// Begin chars/npcs section
	
	if (isCharSerial(serial))
	{
		P_CHAR pc = FindCharBySerial(serial);
		if (pc)		
		{
			Titles->ShowCname(s, Player, pc, 0);
			return;
		}
	}
	// End chars/npcs section
	
	P_ITEM pi = FindItemBySerial(serial);
	if (pi == NULL)
	{
		Console.send("singleclick() couldn't find item serial: %d\n", serial);
		return;
	}
	
	pi->getName(itemname);

	if (pi->isType(ITY_SpellBook))
	{
		int spellcount=Magic->CountSpells(pi);
		sprintf(temp, "[%i spells]", spellcount);
		itemmessage(s,pi, temp, 0x0481);
	}
	if (pi->isType(ITY_BankDeed))
	{
		sprintf(temp,"value: %i",pi->morex);
		itemmessage(s,pi,temp,0x0481);
	}
	// Don't understand why these aren't if/else if/else, but  whatever
	if (pi->isType(ITY_Book)) 
	{
		string clicktitle ;
		if (pi->morex ==666 || pi->morex ==999)
		{
			clicktitle = (*Books).clickTitle(pi,true) ;
		}
		else
		{
			clicktitle = (*Books).clickTitle(pi,false) ;
		}
		
		if (clicktitle=="")
		{
			clicktitle = itemname ;
		}
		
		sprintf(temp,clicktitle.c_str()) ;
		itemmessage(s,pi,temp) ;
		return;
	}
		
	if (Player->canSeeSerials())
	{
		if (pi->amount > 1)
			sprintf(temp, "%s [%x]: %i", itemname, pi->serial, pi->amount);
		else
			sprintf(temp, "%s [%x]", itemname, pi->serial);
		itemmessage(s,pi, temp);
		return;
	}
	
	// Click in a Player Vendor item, show description, price and return
	if (!pi->isInWorld() && isItemSerial(pi->contserial))
	{
		P_CHAR Vendor = GetPackOwner(FindItemBySerial(pi->contserial));
		if (Vendor)
		{
			if (Vendor->isAiVendor())
			{
				if (strlen(pi->creator)>0 && pi->madewith>0)
					sprintf(temps2, "%s %s by %s", pi->desc, SkillManager->getMadeWord(pi->madewith - 1), pi->creator); 
				else
					strcpy(temps2, pi->desc); // LB bugfix
				
				sprintf(temp, "%s at %igp", temps2, pi->value); // Changed by Magius(CHE)				
				itemmessage(s,pi, temp);
				return;
			}
		}
	}
	
	// From now on, we will build the message into temp, and let itemname with just the name info
	// Add amount info.
	if (!pi->pileable || pi->amount == 1)
		strncpy(temp, itemname, 100);
	else 
		if (itemname[strlen(itemname) - 1] != 's') // avoid iron ingotss : x
			sprintf(temp, "%ss : %i", itemname, pi->amount);
		else
			sprintf(temp, "%s : %i", itemname, pi->amount);
		
	// Add creator's mark (if any)			
	if (strlen(pi->creator) > 0 && pi->madewith > 0)
		sprintf(temp, "%s %s by %s", temp, SkillManager->getMadeWord(pi->madewith - 1), pi->creator);
	
	if (pi->isType(ITY_CastingItem)) // Fraz
	{
		if (!strcmp(pi->name2,pi->name))
		{
			sprintf(temp, "%s %i charge", temp, pi->morez);
			if (pi->morez != 1)
				strcat(temp, "s");
		}
	}
	else if (pi->isType(ITY_IDwand) || pi->isType(ITY_FireworksWand))
	{
		if (!strcmp(pi->name2,pi->name))
		{
			sprintf(temp, "%s %i charge", temp, pi->morex);
			if (pi->morex != 1)
				strcat(temp, "s");
		}
	} 	
	else if (pi->isType(ITY_POTIONKEG) || pi->isType(ITY_POTIONKEG_PROTECTED))	
	{
	  char x[128],y[128];	 
	  char empty=0, own=1;

	  GenPotionKegMessage(pi, Player, x, y, empty, own);	 
	  if (empty)   strncpy(temp, "An empty keg",256);
	  else 
	  {
		  if (own) sprintf(temp,"A %s keg of %s potion",y,x); 
		  else     sprintf(temp,"A %s keg of %s liquid",y,x);	
	  }
	}

	// Corpse highlighting...Ripper
	if (pi->corpse==1)
	{
		if (pi->more2==1)
		    itemmessage(s,pi,"[Innocent]",0x005A);
		else if (pi->more2==2)
			itemmessage(s,pi,"[Criminal]",0x03B2);
		else if (pi->more2==3)
			itemmessage(s,pi,"[Murderer]",0x0026);
	}  // end highlighting

	// Let's handle secure/locked down stuff.
	if (pi->isLockedDown() && !pi->isType(ITY_Door) && !pi->isType(ITY_Sign))
	{
		if (pi->secureIt !=1)
			itemmessage(s,pi, "[locked down]", 0x0481);
		if (pi->secureIt == 1 && pi->isLockedDown())
			itemmessage(s,pi, "[locked down & secure]", 0x0481);				
	}
	
	itemmessage(s,pi, temp);
	
	// Send the item/weight as the last line in case of containers
	if (pi->isContainerType()) 
	{
		wgt = (int) Weight->LockeddownWeight(pi, &amt); // get stones and item #, LB	
		if (amt>0)
		{
			sprintf(temps2, "[%i items, %i stones]", amt, wgt);
			itemmessage(s,pi, temps2);
		}
		else
			itemmessage(s,pi,"[0 items, 0 stones]");
	}
}

bool IsMount(short id)
{
	return ((id>=0x0072 && id<=0x007A)||
			(id==0x0084)||(id==0x0090)||
			(id==0x00AA)||(id==0x00AB)||
			(id>=0x00B1 && id<=0x00B3)||
			(id==0x00BB)||(id==0x00BC)||
			(id==0x00BE)||(id==0x00C8)||
			(id==0x00CC)||(id==0x00D2)||
			(id>=0x00DA && id==0x00DC)||
			(id==0x00E2)||(id==0x00E4)||
			(id>=0x0317 && id<=0x031A)||
			(id==0x031F)	);
}

//Handles Double clicks over PC/NPCs

void dbl_click_character(UOXSOCKET s, SERIAL target_serial)
{
	unsigned char pdoll[256]="\x88\x00\x05\xA8\x90\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
	int keyboard=buffer[s][1]&0x80;
	
	P_CHAR target = FindCharBySerial( target_serial );
	if (!target)
		return;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

    if (target->npc && IsMount(target->id()))
	{//if mount
		if (target->doppelgaenger_serial==-3) return; // avoiding unintendedly changes to the dumy npc by dclick
		if (Player->dist(target)<2 || Player->isGM())
		{
			//AntiChrist - cannot ride animals under polymorph effect
			//if (Player->id1!=Player->orgid1 || Player->id2!=Player->orgid2) {
			if (Player->polymorph)
			{
				sysmessage(s, "You cannot ride anything under polymorph effect.");
				return;
			}
			if (Player->dead)
			{
				sysmessage(s,"You are dead and cannot do that.");
				return;
			}
			if (target->war)
				sysmessage(s,"Your pet is in battle right now!");
			else
				mounthorse(s, target);
		}
		else sysmessage(s, "You need to get closer.");
		return; 
	}//if mount
	else if (target->npc && (target->id1!=0x01 || target->id2<0x90 || target->id2>0x93))
	{//if monster
		if (target->isPackAnimal())
		{//if packhorse or packlhama added by JustMichael 8/31/99
			if (Player->Owns(target) || Player->isGM())	// let GMs snoop pack animals by Uber 05-25-2002
			{
				P_ITEM Pack = Packitem(target);
				if (Pack!=NULL)
				{
					backpack(s,Pack);
				}
				else
				{
					Console.send("Pack animal %i has no backpack!\n",target->serial);
				}
			}
			else
			{
				sysmessage(s, "That is not your beast of burden!");
			}
			return;
		}
		else
		{
			sysmessage(s, "You cannot open monsters paperdolls.");
		}
		return; 
	}//if monster
	else
	{//char
		if (target->isAiVendor())//PlayerVendors
		{
			npctalk(s,target,"Take a look at my goods.",0);
			P_ITEM Pack = Packitem(target);
			if (Pack) backpack(s, Pack); // rippers bugfix for vendor bags not opening !!!
			return;
		}
		if (Player->isSameAs(target))//dbl-click self
		{
			if ((!keyboard)&&(unmounthorse(s)==0)) return; //on horse
			//if not on horse, treat ourselves as any other char
		}
		LongToCharPtr(target->serial,&pdoll[1]);
		
		strcpy(temp,Titles->GetTitle(target));
		temp[60]=0;

		strcpy((char*)&pdoll[5], temp);


		XStartPkt(0x88, 66);
		XAddPkt(&pdoll[0+1],66-1);
		XFinishPkt(s);

		return;
	}//char
}

