/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// dragdrop.cpp: implementation of dragging and dropping
// cut from wolfpack.cpp by Duke, 23.9.2000
//////////////////////////////////////////////////////////////////////

#include "dragdrop.h"

#include "basics.h"
#include "boats.h"
#include "bounty.h"
#include "Client.h"
#include "commands.h"
#include "guilds.h"
#include "house.h"
#include "itemid.h"
#include "magic.h"
#include "magic_new.h"
#include "spells.h"
#include "mapstuff.h"
#include "regions.h"
#include "speech.h"
#include "Trade.h"
#include "trigger.h"
#include "SndPkg.h"
#include "weight.h"
#include "tiledata.h"
#include "Partysystem.h"
#include "assert.h"
#include "sregions.h"
#include "wolfpack.h"
#include "network.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "dragdrop.cpp"

//#include "dragdrop.h"

typedef struct _PKGx08
{
//0x08 Packet
//Drop Item(s) (14 bytes) 
//* BYTE cmd 
//* BYTE[4] item id 
	long Iserial;
//* BYTE[2] xLoc 
	short TxLoc;
//* BYTE[2] yLoc 
	short TyLoc;
//* BYTE zLoc 
	signed char TzLoc;
//* BYTE[4] Move Into (FF FF FF FF if normal world) 
	long Tserial;

	cCoord Tpos;
} PKGx08;

// moved here from cWeight by Duke, 12.5.2001 (not sure what this is good for ...:((
// if the item is neither equipped nor in primary backpack return true
static bool CheckWhereItem( P_ITEM Pack, P_ITEM pi, P_CHAR Player)
{
	if (!pi) return false;
	if (!Player) return false;

	if ( Pack->Contains(pi) || Player->Wears(pi))			
		return false;

	return true;
}

void UpdateStatusWindow(UOXSOCKET s, P_ITEM pi)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	P_ITEM Pack = Packitem(Player);
	if (!Pack) return;
	if (CheckWhereItem(Pack, pi, Player))
		statwindow(s,Player);
}

static void SndBounce(UOXSOCKET s, short dragdrop)
{
	static unsigned char bounce[3]="\x27\x00";
	bounce[1]=dragdrop;	// 0 to reject drag, 5 for rejectdrop
	
	XStartPkt(0x27,2);
	XAddPkt(&bounce[0+1],2-1);
	XFinishPkt(s);
}

static void SndRejectDrag(UOXSOCKET s)	{SndBounce(s,0);}
static void SndRejectDrop(UOXSOCKET s)	{SndBounce(s,5);}

// Name:	item_bounce3
// Purpose:	holds some statements that were COPIED some 50 times
// Remarks:	temporary functions to revamp the 30 occurences of the 'bouncing bugfix'
// History:	init Duke, 10.8.2000

static void item_bounce3(const UOXSOCKET s, const P_ITEM pi)
{
	pi->SetContSerial(pi->oldcontserial);

	if (pi->oldcontserial == -1)
		pi->MoveTo(pi->oldpos);
	else
		pi->pos=pi->oldpos;
	
	pi->layer=pi->oldlayer;
	pi->flags.isBeeingDragged=false;
	P_CHAR Player = MAKE_CHAR_REF(currchar(s));
	if (Player)
		Player->WeightAtCursor = 0;
	P_CHAR pc = FindCharBySerial(pi->oldcontserial);

	if (pi->layer > 0 && pc != NULL)
	{
		pc->addItemBonus(pi);
	}
	pi->refresh(); // there are some update problems without refreshing (thrawn)

}

static void item_bounce4(const UOXSOCKET s, const P_ITEM pi)
{
	item_bounce3(s,pi);
	if (pi->isMulti())
		senditem(s, pi);
}

/*
static void item_bounce5(const UOXSOCKET s, const P_ITEM pi)
{
	item_bounce3(s,pi);
	if (pi->isInWorld())
	{
		if (pi->isMulti())
			senditem(s, pi);
	}
	else
		senditem(s, pi);
}
*/

static void item_bounce6(const P_CLIENT ps, const P_ITEM pi)
{
	UOXSOCKET s=ps->GetSocket();
	SndRejectDrop(s);
	if (ps->IsDragging())
	{
		ps->ResetDragging();
		item_bounce4(s,pi);
	}
}

///
/// return value: 2 -> not successfull, 1: ok
///
int PotionKegFilling(int type, P_CHAR Player, P_ITEM keg, P_ITEM bottle)
{
	int bottlepotiontype, bottlepotionsubtype, kegownerserial, kegpotiontype, kegpotionsubtype, kegpotionamount;
   
	assert (keg->isType(ITY_POTIONKEG) || keg->isType(ITY_POTIONKEG_PROTECTED));

	int t = bottle->isType(ITY_Potion); // only potions are allowed to be dragged into keg
	if (!t) return 2;

	bottlepotiontype    = bottle->morey;
	bottlepotionsubtype = bottle->morez;

	if (bottlepotiontype>=POTION_LAST || bottlepotiontype<=0) // only known potions allowed
	{
		return 2;
	}

	kegownerserial   = keg->morex;
	kegpotiontype    = keg->morey;
	kegpotionsubtype = keg->morez;
	kegpotionamount  = keg->getMore1_4();

	int toadd = bottle->amount;


	if (kegpotionamount<0 || kegpotionamount>=100 || toadd<0 || toadd>=100 || (toadd+kegpotionamount)<0 || (toadd+kegpotionamount)>=100) // illegal amount
	{
		return 2;
	}

	int s=Player->calcSocket();

	if (kegpotionamount==0) // empty keg
	{
		if (s!=-1) soundeffect(Player, 0x02D6);
		keg->morex=Player->serial; // set ownership
		keg->morey=bottlepotiontype; // and the (one and only) type of potions that can be filled later on
		keg->morez=bottlepotionsubtype;

        Items->DeleItem(bottle); // delete potion

		keg->setMore1_4(toadd); // keg contains now exacly one potion
		keg->weight+=80*toadd;    // 1 potion = 0.8 stones

		Items->SpawnItem(Player, 1, "#", 1, 0x0f0e, 0, 1); // spawn empty bottle in players bp
		

	} else // filled keg
	{
		if ((bottlepotiontype==kegpotiontype) && (bottlepotionsubtype==kegpotionsubtype)) // potion type match -> ok
		{
		   if (s!=-1) soundeffect(Player, 0x02D6);
		   Items->DeleItem(bottle); // delete potion
		   keg->setMore1_4(kegpotionamount+toadd); // add one potion
		   keg->weight+=80*toadd;    // 1 potion = 0.8 stones weight increase
		   Items->SpawnItem(Player, 1, "#", 1, 0x0f0e, 0, 1); // spawn empty bottle in players bp
		}
		else // trying to fill in wrong potion, a big no-no
		{
			return 2;
		}
	}			

	return 1;
}

// this function SCREAMES for a rewrite !! LB !! (7.1.2000)
// note: 2-Jan-2003 and still screaming ... poor little unheaerd function ...

bool get_item2(P_CLIENT ps, char &corpseitem) // Client grabs an item
{
	corpseitem=0; // !!!
	UOXSOCKET s = ps->GetSocket();
	cChar* Player = ps->getPlayer();
	
	Player->disturbMed(s); // Meditation
	
	if (LSD[s]) 
	{
		sysmessage(s,"huh huuuuh a frazurubluu");
		return false;
	}

	P_ITEM pi = FindItemBySerPtr(&buffer[s][1]);
	if (pi == NULL) return false; // player tried to grab land .. return ;)
    // now it's official that we are trying to grab an item ...
	corpseitem=pi->corpse;

	if (pi->multis > 0 && pi->multis != Player->multis) 
	{
	  // note: multi properties are only set in a very weird way ! 
	  // for houses this check has side effects (in house items suddently getitng unmoveable, only for boats ok
	  // (e.g decayitem)
	  P_ITEM house = FindItemBySerial(pi->multis);
	  if (house!=NULL) // multi neither boat nor house, do not return
	  {
		if (!ishouse(house)) return false;	// must be on the same boat to grab an item on the deck
	  }			
	}	

	if (pi->flags.isBeeingDragged) return false;
	pi->flags.isBeeingDragged=false;

	// note: client has a build in check not to grab items if dist >3
	// but: cheat tools and OSI's arm/disarm macros don't have it. so we need to check server side too
	int dist = itemdistDeluxe(Player, pi); 
	if (dist>3) return false;	
  
	if (!Player->canPickUp(pi)) return false;
	
	//Items is no loger a spawn region item
	DecSpawnCount(pi->spawnregion);
	pi->spawnregion=0;
	
	if (!pi->isInWorld())
	{
		PC_ITEM Cont=GetOutmostCont(pi);
		if (!Cont->isInWorld())
		{
			if (Cont->IsWorn())
			{
				cChar* Npc = FindWearerOf(Cont);  // Find character owning item
				if (!Npc)
				{				
					return false;
				}
				
				if (!Player->isGM() && !Npc->isSameAs(Player) && !Player->Owns(Npc))// Pack aniamls and vendors.
				{					
					return false;
				}

				if (pi->layer>0)
				{
					Npc->removeItemBonus(pi);	// remove BONUS STATS given by equipped special items
				}
				if (pi->trigon==1 && pi->layer && pi->layer != 15 && pi->layer < 19)// -Frazurbluu- Trigger Type 2 is my new trigger type *-
				{
					triggerwitem(s, pi, 1); // trigger is fired
				}	
				
				if (pi->Poisoned())	// AntiChrist -- for poisoned items
				{
					Npc->poison -= pi->Poisoned();
					if (Npc->Poison() < 0)
						Npc->SetPoison(0);
				}
			}
			else  // its an item
			{
				if (Cont->layer == 0 && Cont->id() == 0x1E5E)		// Trade window???
				{
					cItem* Trade2 = FindItemBySerial(Cont->getMoreB1_4());	// the second part of the trade window
					if (!Trade2)
					{					
						return false;
					}
					if (Trade2->morez || Cont->morez)
					{
						Trade2->morez = 0;
						P_ITEM Cont2 = Cont->unconst();
						Cont2->morez = 0;
						sendtradestatus(Trade2, Cont2);
					}
				}
				// Blackwinds Looting is crime implementation
				// changed slightly by Ripper
				if (Cont->corpse && !Player->Owns(Cont)) 
				{ 
					P_CHAR co = FindCharBySerial(Cont->ownserial);				
					if (co && Cont->more2 == 1 && Guilds->Compare(Player, co) == 0) 
					{ 
						if (!(co->PartyCanLoot() && PartySystem->AreInSameParty(Player, co)))
						{
							Player->karma -= 5; 
							criminal(Player);
							sysmessage(s, "You lost some karma!"); 
						}
					
					} 
				}
			}
		}
	}
	
	/////////////////////////////////////
	// from here on we've allowed grabbing the client.
	// do all actions necasairy
	/////////////////////////////////////

	int update = 0;
	UpdateStatusWindow(s, pi);

	ps->SetDragging(); 
	
	pi->oldpos = pi->pos;	// first let's save the position
	pi->oldcontserial = pi->contserial;	// then let's save the container
	pi->oldlayer = pi->layer;	// then the layer
	
	pi->layer = 0;
	if (!pi->isInWorld())
		soundeffect(Player, 0x0057);
	if (pi->amount>1)
	{
		unsigned short amount = ShortFromCharPtr(&buffer[s][5]);
		if (amount>pi->amount)
			amount = pi->amount;
		
		if (amount < pi->amount)	// we'll have to split the pile
		{
			P_ITEM Rest = Items->CloneItem(pi);
			if (Rest==NULL) return false;	// bounce etc
			
			Rest->amount = pi->amount - amount;
			
			Rest->SetContSerial(Rest->contserial);
			Rest->SetOwnSerial(Rest->ownserial);
			Rest->SetSpawnSerial(Rest->spawnserial);
			
			statwindow(s,Player);
			Rest->refresh();
		}
		
		if (pi->id() == 0x0EED) // gold coin
		{
			P_ITEM Pack = Player->getBackpack();
			if (Pack!=NULL) // lb
				if (Pack->Contains(pi))
					update = 1;
		}
		
		pi->amount = amount;
	}
	
#if 0
	int amt = 0, wgt; bool tooheavy=false;
	wgt = (int)Weight->LockeddownWeight(pi, &amt, 0);
	
	P_ITEM bp = Player->getBackpack();							
	if ( !((bp->serial==pi->contserial) && (bp->serial!=-1)) ) // true if item is not inside players' bp
	{
		if (( (Player->weight+wgt) > (Player->st.Real()*WEIGHT_PER_STR)+30)) // LB -> added: drop item if too heavy
		{
			float res=float( (Player->weight+wgt) - ((Player->st*WEIGHT_PER_STR)+30))*2;
			int diff = Player->st.Real();
			diff -= (int)res;
			if (diff<=0 && !Player->isGM() )					   
			{
				tooheavy=true;						 						 
				
				bounce[1] = 0;
				Xsend(s, bounce, 2);
				if (ps->IsDragging()) // only restore item if it got draggged before !!!
				{
					ps->ResetDragging();				
					item_bounce4(s, pi);
				}
				
				sysmessage(s, "you can't pick this up, this is too heavy");					 
				{				 

				  return false;
				}
			}
		}
	}
	
	if (!tooheavy) Player->weight+=wgt;

#endif

	if (pi->multis>0)	// Boats
		imultisp.remove(pi->multis, pi->serial);
	if (!pi->isNotMovable())	// don't decay items set to NOT movable
		pi->startDecay();
	
	int amt2 = 0;
	Player->WeightAtCursor = (short) Weight->LockeddownWeight(pi, &amt2);
	update = 1;					
	
	SndRemoveItemToAll(pi);

	// Tauriel remove item from world mapcells
	mapRegions->Remove(pi); // remove this item from a map cell				
	pi->pos.x = 0;
	pi->pos.y = 0;
	pi->pos.z = 0;
	
	pi->flags.isBeeingDragged=true;
	pi->SetContSerial(-1);
	
	if (update) 
	{
		Weight->NewCalc(ps->getPlayer());
		statwindow(s, Player);
	}
	return true;
}


void get_item(P_CLIENT ps) // Client grabs an item
{
	char corpse;
	if (!get_item2(ps, corpse))
	{		
		if (!corpse) SndRejectDrag(ps->GetSocket()); // corpses crash client if bounce packet send on them
	}
}

void wear_item(P_CLIENT ps) // Item is dropped on paperdoll
{
	unsigned char wearitem[15];
	const tileData *tile;
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	if (!Player) return;

	P_CHAR Target = FindCharBySerPtr(&buffer[s][6]);
	if (!Target) return;
	
	if (Target->dead)  //Exploit fix: Dead ppl can't equip anything.
		return;
	
	P_ITEM pi=FindItemBySerPtr(&buffer[s][1]);
	if (!pi) return;

	if (pi->flags.isBeeingDragged==false) 
	{		
		SndRejectDrop(s);
		if (ps->IsDragging())
		{
			ps->ResetDragging();		
			sysmessage(s, "you can't wear things you haven't grabbed");
		}			
		return;
	}

	pi->flags.isBeeingDragged=false;
	Player->WeightAtCursor = 0;

//	if (clientDimension[s]==3)
//	{
	tile = TileData->SeekTile(pi->id());		
		
	if (tile->quality==0) // quality == layer for wearables !!!
	{
		sysmessage(s,"You can't wear that");
		SndRejectDrop(s);
		if (ps->IsDragging())
		{
			ps->ResetDragging();
			item_bounce4(s,pi);
			UpdateStatusWindow(s,pi);
		}
		return;
	}
//	}

	if (pi->isMulti()) return;	// LB, client crashfix if multi-objects are moved to PD
	
	if (!Player->isGM())		// players cant equip items on other players or npc`s paperdolls.
	{
		if (!Player->isSameAs(Target))
		{
			sysmessage(s, "You cant put items on other players!");
			item_bounce6(ps,pi);
			pi->refresh();
			return;
		}
	}
	
	if (Player->isSameAs(Target) || Player->isGM()) 
	{
		if (Player->isSameAs(Target) && pi->st > Target->effStr())
		{
			sysmessage(s,"You are not strong enough to use that.");
			SndRejectDrop(s);
			if (ps->IsDragging())
			{
				ps->ResetDragging();
				item_bounce4(s,pi);
				UpdateStatusWindow(s,pi);
			}
			return;
		}
		
		if (Player->id()!=0x191 // Ripper...so males cant wear female armor
			&& isFemaleArmour(pi->id()))
		{
			sysmessage(s,"You cant wear female armor!");
			SndRejectDrop(s);
			if (ps->IsDragging())
			{
				ps->ResetDragging();
				item_bounce4(s,pi);				  
				UpdateStatusWindow(s,pi);
			}
			return;
		}
		
//		if (clientDimension[s]==2) Map->SeekTile(pi->id(), &tile);
		if (( (pi->isNotMovable() || (tile->weight==255 && !pi->isAllwaysMovable()) )&&(Player->CanMoveAll()) ) ||
			( (pi->isOwnerMovable() || pi->isLockedDown()) && !Player->Owns(pi)))
		{
			item_bounce6(ps,pi);
			return;
		}
		
		
		// - AntiChrist (4) - checks for new ITEMHAND system
		// - now you can't equip 2 hnd weapons with 1hnd weapons nor shields!!
		int letsbounce=0; // AntiChrist (5) - new ITEMHAND system
		int ci=0,loopexit=0;
		P_ITEM Eq;	// the equipped item
		while ( ((Eq=Player->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (Eq->itmhand==1 && pi->itmhand==1)
			{
				sysmessage(s,"You already have a weapon equipped!");
				letsbounce=1;
			}
			else if (Eq->itmhand==2 && pi->itmhand==1)
			{
				sysmessage(s,"Your hands are both occupied!");
				letsbounce=1;
			}
			else if (Eq->itmhand==1 && pi->itmhand==2)
			{
				sysmessage(s,"You cannot equip a two handed weapon with a weapon equipped!");
				letsbounce=1;
			}
			else if (Eq->itmhand==2 && pi->itmhand==2)
			{
				sysmessage(s,"You cannot equip a two handed weapon with a two handed weapon equipped!");
				letsbounce=1;
			}
			else if (Eq->itmhand==2 && pi->itmhand==3)
			{
				sysmessage(s,"You cannot equip a shield with a two handed weapon equipped!");
				letsbounce=1;
			}
			else if (Eq->itmhand==3 && pi->itmhand==2)
			{
				sysmessage(s,"You cannot equip a two handed weapon while holding any other items!");
				letsbounce=1;
			}
			else if (Eq->layer == tile->quality) // quality == layer in case of wearables
			{
				sysmessage(s, "You already have an armor equipped!");
				letsbounce = 1;
			}

			if (letsbounce)//Let's bounce the item
			{
				SndRejectDrag(s);			
				if (ps->IsDragging())
				{
					ps->ResetDragging();
					item_bounce4(s,pi);
				    UpdateStatusWindow(s,pi);
					itemsfx(s, pi->id());		// antichrist
				}
				return;
			} 
		}
		
		//remove order/chaos shield if not in chaos/order guild
		if (IsChaosOrOrderShield(pi->id()))
		{
			int gType=Guilds->GetType(Player->guildnumber);
			if (!Player->isGM())
			{
				//Yes this if else can be compressed but we dont know if new guild types will be added
				if (gType!=2 && IsChaosShield(pi->id()))
				{
					sysmessage(s, "You can't wear Chaos shields");
					sysmessage(s, "The shield destroys itself");
					Items->DeleItem(pi);
					return;
				}
				else if (gType!=1 && IsOrderShield(pi->id()))
				{
					sysmessage(s, "You can't wear Order shields");
					sysmessage(s, "The shield destroys itself");
					Items->DeleItem(pi);
					return;
				}
			}
		}
		
		//if drop a light unhide character
		if (Player->isHidden() && !Player->IsPermaHidden() && !Player->isGM())
		{
			if (TileData->isLightSourceItem(pi->id()))
			{	
				sysmessage(s,"The light reveal you");
				Player->unhide();
			}
		}
		
		pi->SetContSerial(Target->serial);
		pi->layer=buffer[s][5];

		// AntiChrist - now the STAT BONUS works -
		Target->addItemBonus(pi);
		if (pi->trigtype==2) // -Frazurbluu- Trigger Type 2 is my new trigger type *-
		{
			triggerwitem(s, pi, 1); // trigger is fired
		}	
		// AntiChrist -- for poisoned items
		if (pi->Poisoned())
		{
			if (Player->Poison() < pi->Poisoned())
				Player->SetPoison(pi->Poisoned());
		}
		if (showlayer)	Console.send("Item equipped on layer %i.\n",pi->layer);
		
		SndRemoveItemToAll(pi);
		
		LongToCharPtr(pi->serial,&wearitem[1]);
		ShortToCharPtr(pi->id(),&wearitem[5]);

		wearitem[8]=pi->layer;
		LongToCharPtr(pi->contserial,&wearitem[9]);
		ShortToCharPtr(pi->color(),&wearitem[13]);

		XStartPkt(0x2e, 15);
		XAddPkt(&wearitem[0+1], 15-1);
		XFinishPkt(s);
		
		SndWornItemsToAllInRange(Target);

		UOXSOCKET so = s;
		if (!Player->isSameAs(Target))
			so = Target->calcSocket();
		Weight->NewCalc(Target);
		if (so > -1)
		{
			itemsfx(so, pi->id());	// Dupois - see itemsfx() for details	// Added Oct 09, 1998
			statwindow(so,Target);
		}
		
		if (pi->glow>0)
		{
			Player->removeHalo(pi); // if gm equips on differnt player it needs to be deleted out of the hashteble
			Target->addHalo(pi);
			Target->glowHalo(pi);
		}
    }
}

static int ItemDroppedOnPet(P_CLIENT ps, PKGx08 *pp, P_ITEM pi, P_CHAR Pet)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();

	if ((Player->Owns(Pet) && pi->isType(ITY_Potion))) // by thrawn: feed your animals with potions
	{
		switch(pi->morey)
		{
		case POTION_SHRINK:
			if (Pet->summontimer!=0) // dont allow shrinking summoned npcs
			{
				sysmessage(s,"You can't shrink summoned pets!");
				return 2;
			}
			if (Pet->isPackAnimal()) // attemp to shrink a pack animal?
			{
				int amt1=0;
				P_ITEM Pack = Pet->getBackpack(); // get the animals backpack
				Weight->LockeddownWeight(Pack,&amt1); // count the items in the backpack
				if (amt1>0) // dont allow to shrink the pet when its backpack contains items
				{
					sysmessage(s,"You have to empty the pets backpack before you can shrink it!");
					return 2;
				}
			}
			
			Pet->Shrink();
			return 1;
		}
	}
	else if (Pet->Hunger()<6 && pi->isType(ITY_Food) && Pet->CanEat(pi))//AntiChrist new hunger code for npcs
	{
		soundeffect2(Player, 0x003A+(rand()%3));	//0x3A - 0x3C three different sounds

		if (pi->Poisoned() && Pet->Poisoned() < pi->Poisoned()) 
		{
			soundeffect2(Pet, 0x0246); //poison sound - SpaceDog
			Pet->PoisonStart(s,pi->Poisoned());
		}
		
		pi->getName(temp2);
		sprintf(temp,"* You see %s eating %s *",Pet->name,temp2);
		Pet->emotecolor=0x0026;
		npcemoteall(Pet,temp,1);
		Pet->chgHunger(1);
		return 1;
	}

	sysmessage(s,"It doesn't appear to want the item");
	return 2;
}

static int ItemDroppedOnGuard(P_CLIENT ps, PKGx08 *pp, P_ITEM pi, P_CHAR Guard)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();

	if ( strstr( pi->name, "the head of" ) )
	{
		// This is a head of someone, see if the owner has a bounty on them
		P_CHAR Villain = FindCharBySerial(pi->ownserial);
		if (!Villain) return 0;

		int reward = Villain->questBountyReward;
		if ( reward > 0 )
		{
			// Give the person the bounty assuming that they are not the
			// same person as the reward is for
			if ( !Player->isSameAs(Villain))
			{
				// give them the gold for bringing the villan to justice
				addgold( s, Player, reward );
				goldsfx( s, reward );
				
				sprintf((char*) temp, "Excellent work! You have brought us the head of %s. Here is your reward of %d gold coins.",
					Villain->name, reward );	// Now thank them for their hard work
				npctalk( s, Guard, temp, 0);
				
				BountyDelete( Villain->serial );	// Delete the Bounty from the bulletin board
				
				Player->karma  += 100;				// Adjust their karma back to what it was before the beheading!
			}
			else
				npctalk(s, Guard, "You can not claim that prize scoundrel. You are lucky I don't strike you down where you stand!",0);
			
			Items->DeleItem(pi);
			return 1;
		}
	}
	return 0;	// not handled
}

static int ItemDroppedOnBeggar(P_CLIENT ps, PKGx08 *pp, P_ITEM pi, P_CHAR Beggar)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();

	if (pi->id()!=0x0EED)
	{
		sprintf(temp,"Sorry %s i can only use gold",Player->name);
		npctalk(s,Beggar,temp,0);
		return 2;	// bounce
	}

	sprintf(temp,"Thank you %s for the %i gold!",Player->name,pi->amount);
	npctalk(s,Beggar,temp,0);
	if (pi->amount<=100)
	{
		Player->karma += 10;
		sysmessage(s,"You have gained a little karma!");
	}
	else
	{
		Player->karma += 50;
		sysmessage(s,"You have gained some karma!");
	}
	Items->DeleItem(pi);
	return 1;
}

static int ItemDroppedOnBanker(P_CLIENT ps, PKGx08 *pp, P_ITEM pi, P_CHAR Banker)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	P_ITEM Bankbox = Player->GetBankBox();

    if (pi->id() == 0x0EED)
	{
		sprintf(temp,"%s you have deposited %i gold.",Player->name, pi->amount);
		npctalk(s,Banker,temp,0);
		Bankbox->AddItem(pi);
	    statwindow(s, Player);
		return 1;
	}
	return 2;
}

static int ItemDroppedOnTrainer(P_CLIENT ps, PKGx08 *pp, P_ITEM pi, P_CHAR Trainer)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	
	if ( pi->id() != 0x0EED ) // Did not give gold
	{
		npctalk(s, Trainer, "I am sorry, but I can only accept gold.",0);
		return 2;	// bounce
	}
	
	char sk=Trainer->trainingplayerin;
	npctalk(s, Trainer, "I thank thee for thy payment. That should give thee a good start on thy way. Farewell!",0);
	
	int sum = Player->getSkillSum();
	int delta = Trainer->getTeachingDelta(Player, sk, sum);
	int rc=1;

	if (pi->amount>delta) // Paid too much
	{
		pi->amount-=delta;	// a bit tricky: bounce the *rest* !
		rc = 2;	// bounce
	}
	else
	{
		if (pi->amount < delta)		// Gave less gold
			delta = pi->amount;		// so adjust skillgain
		Items->DeleItem(pi);
	}
	Player->chgRealSkill(sk,delta);
	SkillManager->updateSkillLevel(Player, sk);
	updateskillPacket(s,sk);
	
	Player->trainer=-1;
	Trainer->trainingplayerin='\xFF';
	return rc;
}

static int ItemDroppedOnSelf(P_CLIENT ps, PKGx08 *pp, P_ITEM pi)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	
	if (pi->isMulti()) // crashfix , prevents putting multi-objects in your backback
	{
		sysmessage(s,"Hey, putting houses in your pack crashes your back and client !");
		pi->MoveTo2(Player->pos);
		return 1;
	}
	
	if (pi->glow>0) // glowing items
	{
		Player->addHalo(pi);
		Player->glowHalo(pi);
	}
	
	P_ITEM Pack = Player->getBackpack();
	if (!Pack)	// if player has no pack, put it at its feet
	{ 
		pi->MoveTo2(Player->pos);
	}
	else
	{
		Pack->AddItem(pi); // player has a pack, put it in there
	}
	return 1;
}

///////////////
// return:	0=unhandled, 1=handled, 2=bounce request
static int ItemDroppedOnChar(P_CLIENT ps, PKGx08 *pp, P_ITEM pi)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	P_CHAR pTC=FindCharBySerial(pp->Tserial);	// the targeted character
	if (!pTC) return 2;

	if (pTC->isSameAs(Player)) // dumping stuff to his own backpack !
	{
		return ItemDroppedOnSelf( ps, pp, pi);
	}

	if (pTC->npc)
	{
		if (!pTC->isHuman())						
		{
			return ItemDroppedOnPet( ps, pp, pi, pTC);
		}
		else	// Item dropped on a Human character
		{
			int rc;
			if ( pTC->npc && pTC->isAiTeleGuard() )	// Item dropped on a Guard (possible bounty quest)
			{
				rc=ItemDroppedOnGuard( ps, pp, pi, pTC);
				if (rc) return rc;
			}
			if ( pTC->npcaitype == 5 )
			{
				rc=ItemDroppedOnBeggar( ps, pp, pi, pTC);
				if (rc) return rc;
			}
			if ( pTC->npcaitype == 8 )
			{
				rc=ItemDroppedOnBanker( ps, pp, pi, pTC);
				if (rc) return rc;
			}
			if (Player->trainer == pTC->serial) // if the player is training from this NPC
			{
				rc=ItemDroppedOnTrainer( ps, pp, pi,pTC);	//This crazy training stuff done by Anthracks (fred1117@tiac.net);
				if (rc) return rc;
			}

			npctalk(s, pTC, "Thank thee kindly, but I have done nothing to warrant a gift.",0);
			return 2;	// bounce
		}
	}
	else // dropped on another player
	{
		// By Polygon: Avoid starting the trade if GM drops item on logged on char (crash fix)
		if (Player->isGM() && !pTC->InGame())
		{
			// Drop the item in the players pack instead
			P_ITEM Pack = pTC->getBackpack();
			if (Pack != NULL)	// Valid pack?
			{
				Pack->AddItem(pi);	// Add it
				Weight->NewCalc(pTC);
			}
			else	// No pack, give it back to the GM
			{
				Pack = Player->getBackpack();
				if (Pack)	// Valid pack?
				{
					Pack->AddItem(pi);	// Add it
				}
				else	// Even GM has no pack?
				{
					pi->MoveTo2(Player->pos);	// Drop it to it's feet
				}
			}
		}
		else
		{
			P_ITEM TrWin = tradestart(s, pTC); //trade-stuff
			if (!TrWin) return 2;
			pi->SetContSerial(TrWin->serial);
			pi->pos.x=30;
			pi->pos.y=30;
			pi->pos.z=9;
			SndRemoveItemToAll(pi);
			pi->refresh();
		}
		return 1;
	}
	return 0;
}

bool dump_item(P_CLIENT ps, PKGx08 *pp, P_ITEM pi) // Item is dropped on ground or a character
{
	//UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	if (!Player) return true;

	//Ripper...so order/chaos shields disappear when on ground.
	if (IsChaosOrOrderShield(pi->id()))
	{
		Guilds->RemoveGuildShield(Player,pi);
		return 0;
	}
	
	if (pp->TxLoc != -1)
	{
		pi->MoveTo(pp->Tpos);
		pi->SetContSerial(-1);
		
		if (pi->glow)
		{
			Player->removeHalo(pi);
			Player->glowHalo(pi);
		}		
		SndRemoveItemToAll(pi);
		pi->refresh();

		//Boats !
		if (Player->multis>0) //How can they put an item in a multi if they aren't in one themselves Cut lag by not checking everytime something is put down
		{
			P_ITEM Multi1 = FindItemBySerial( Player->multis );
			if (Multi1)									// so they seem to be in a multi
			{
				PC_ITEM Multi2 = findMulti(pi->pos);		// verify the item is in there too
				if (Multi2)
					pi->SetMultiSerial(Multi2->serial);
			}
		}
	}
	else
	{
		int rc=ItemDroppedOnChar(ps, pp, pi);
		if (rc==2) return 1;	// bounce
	}
	return 0;
}

///////////////
// return:	0=unhandled, 1=handled, 2=bounce request, 3=handled/remove request
int droppedOnSpecialItem(P_CLIENT ps, PKGx08 *pp, P_CHAR Player, P_ITEM Drop, P_ITEM Target)
{	
	cSpell* spell;
	UOXSOCKET s=ps->GetSocket();
	P_ITEM Pack = Player->getBackpack();

	switch (Target->type)
	{
	case ITY_Trashbin:
		Items->DeleItem(Drop);
		sysmessage(s, "As you let go of the item it disappears.");
		return 1;

	case ITY_POTIONKEG:
	case ITY_POTIONKEG_PROTECTED:

		int t,r;
		t = Target->isType(ITY_POTIONKEG_PROTECTED);	
		r = PotionKegFilling(t, Player, Target, Drop);

		return r;

	case ITY_SpellBook:
		if (Drop->isType(ITY_RegularSpellScroll)) // do we have a regular spell scroll
		{
			spell = Magic->GetSpell(Drop->getMore1_4());	// spellnum for scroll is saved in more
		}
		else
		{
			sysmessage(s, "You can't place this in your spellbook!");
			return 2; // bounce
		}

		if (Pack)
		{
			if (!Player->Wears(Target) && !Pack->ContainsSub(Target))
			{
				sysmessage(s, "You cannot place spells in other peoples spellbooks.");
				return 2; // bounce
			}
		}
		else
		{
			if (!Player->Wears(Target)) // no pack and spellbook is not equipped
			{
				sysmessage(s, "You cannot place spells in other peoples spellbooks.");
				return 2; // bounce
			}
		}
		
		if (!spell) // prevent crash when spell not found
		{
			sysmessage(s, "This spell is not implemented, please contact shard admin!");
			return 2;
		}

		if (spell->IsInBook(Target)) // book already contains that spell
		{
			sysmessage(s,"You already have that spell!");
			return 2;	// bounce
		}

		spell->AddToBook(Target);
		Magic->OpenSpellBook(Player,Target,SBT_REGULAR);
		return 3; // handled + remove request

	case ITY_NecroBook:
		if (!Drop->isType(ITY_NecroSpellScroll)) // do we have a regular spell scroll
		{
			sysmessage(s, "You can't place this in your spellbook!");
			return 2; // bounce
		}

		if (Pack)
		{
			if (!Player->Wears(Target) && !Pack->ContainsSub(Target))
			{
				sysmessage(s, "You cannot place spells in other peoples spellbooks.");
				return 2; // bounce
			}
		}
		else
		{
			if (!Player->Wears(Target)) // no pack and spellbook is not equipped
			{
				sysmessage(s, "You cannot place spells in other peoples spellbooks.");
				return 2; // bounce
			}
		}

		spell = Magic->GetSpell(Drop->getMore1_4());	// spellnum for scroll is saved in more

		if (!spell) // prevent crash when spell not found
		{
			sysmessage(s, "This spell is not implemented, please contact shard admin!");
			return 2;
		}

		if (spell->IsInBook(Target)) // book already contains that spell
		{
			sysmessage(s,"You already have that spell!");
			return 2;	// bounce
		}

		spell->AddToBook(Target);
		Magic->OpenSpellBook(Player,Target,SBT_NECRO);
		return 3; // handled + remove request

	case ITY_PaladinBook:
		if (!Drop->isType(ITY_PaladinSpellScroll)) // do we have a regular spell scroll
		{
			sysmessage(s, "You can't place this in your spellbook!");
			return 2; // bounce
		}

		if (Pack)
		{
			if (!Player->Wears(Target) && !Pack->ContainsSub(Target))
			{
				sysmessage(s, "You cannot place spells in other peoples spellbooks.");
				return 2; // bounce
			}
		}
		else
		{
			if (!Player->Wears(Target)) // no pack and spellbook is not equipped
			{
				sysmessage(s, "You cannot place spells in other peoples spellbooks.");
				return 2; // bounce
			}
		}

		spell = Magic->GetSpell(Drop->getMore1_4());	// spellnum for scroll is saved in more

		if (!spell) // prevent crash when spell not found
		{
			sysmessage(s, "This spell is not implemented, please contact shard admin!");
			return 2;
		}

		if (spell->IsInBook(Target)) // book already contains that spell
		{
			sysmessage(s,"You already have that spell!");
			return 2;	// bounce
		}

		spell->AddToBook(Target);
		Magic->OpenSpellBook(Player,Target,SBT_PALADIN);
		return 3; // handled + remove request

	case ITY_RuneBook:
		if (Drop->id()==0x1F4C)			// a recall scroll
		{
			if (Target->morey+Drop->amount <= Target->morez)
			{
				Target->morey+=Drop->amount;
				SndRemoveItemToAll(Drop);
				return 1;
			}
			else
			{
				sysmessage(s,"Rune Book already is at max charges");
				return 2;
			}
		}
		
		if (Drop->type == ITY_Rune)
		{
			if (Drop->morex==0 && Drop->morey==0 && Drop->morez==0)
			{
				sysmessage(s,"That rune is not marked");
				return 2;
			}
			if (Target->CountItems(0x1F14)>16)	// count the runes
			{
				sysmessage(s,"Rune Book Full");
				return 2;
			}
			
			Target->AddItem(Drop,pp->TxLoc,pp->TyLoc);
			sysmessage(s,"Dropped rune into runebook");
			return 1;
		}
		break;

	default:
		break;

	}
	return 0;
}

int pack_item(P_CLIENT ps, PKGx08 *pp, P_ITEM Drop, P_ITEM pCont) // Item is put into container or on another item
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
		
	if (Drop->isMulti()) 
	{ 
		sysmessage(s,"Hey, putting houses in your pack crashes your back and client!");
		return 1;	// LB crashfix that prevents moving multi objcts in BP's
	}

	if (pCont->layer==0 && pCont->id() == 0x1E5E &&
		Player->Wears(pCont))	// Trade window???
	{
		P_ITEM TrW = FindItemBySerial(pCont->getMoreB1_4());
		if (!TrW) return 1;
		
		if (TrW->morez || pCont->morez)
		{
			TrW->morez=0;
			pCont->morez=0;
			sendtradestatus(TrW, pCont);
		}
	}
	
	if (SrvParms->usespecialbank)	//AntiChrist - Special Bank Stuff
	{
		if (pCont->morey==123 && pCont->morex==1 && pCont->isType(ITY_Container))	// morey==123  - gold only bank
		{
			if ( Drop->id() == 0x0EED )//if they're gold ok
			{
				goldsfx(s, 2);
			}
			else
			{//if they're not gold..bounce on ground
				sysmessage(s,"You can only put golds in this bank box!");

				Drop->SetContSerial(-1);
				Drop->MoveTo2(Player->pos);
				return 0;
			}
		}
	}
	
	P_CHAR Receiver = GetPackOwner(pCont);
	if (Receiver)
	{
		if ( (!Receiver->isSameAs(Player) && !Player->isGM()) || (Player->isGM() && Receiver->isAiVendor()) /* gms should be able to test player vendors */ )	// can't drop in other char's bp unless...
		{
			if (!Receiver->npc || !Player->Owns(Receiver))
			{
				sysmessage(s,"This aint your backpack!");				
				return 1;
			}
			if (Receiver->isAiVendor())	// player run vendors
			{
				Player->setInput(1,Drop);
				sysmessage(s, "Set a price for this item.");
			}
			if (Receiver->isPackAnimal())	// packhorses etc.
			{
				P_ITEM PackA = Receiver->getBackpack();
				int count1;
				int w = (int)Weight->LockeddownWeight(PackA, &count1);
				if (Player->WeightAtCursor + w > 1600)
				{
					sysmessage(s,"That would be too heavy for your packhorse!");				
					return 1;
				}
			}
		}
	}

	int rc = droppedOnSpecialItem( ps, pp, Player, Drop, pCont);	// spellbook, runebook, trashbin....

	if (rc == 1) return 0;	// done
	if (rc == 2) return 1;	// rejected
	if (rc == 3) return 2;	// done + remove request
    
	if (!Player->isGMorCounselor() && pCont->isContainerType())
	{
		// Rippers new container limits//
		unsigned int amt=0;	// to count the items in the container
		int ci=0,loopexit=0;
		P_ITEM pi;
		while ( ((pi=pCont->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			amt++;
		}

		if (pCont->isType(ITY_Container))
		{
			if (pCont->morex == 1 && amt >= SrvParms->BankboxLimit)
			{
				sprintf(temp, "Bankboxes have a limit of %i items.", SrvParms->BankboxLimit);
				sysmessage(s, temp);
				return 1;
			}
			else if (pCont->id() == 0x0E80 && amt >= SrvParms->StrongboxLimit)
			{
				sprintf(temp, "Strongboxes have a limit of %i items.", SrvParms->StrongboxLimit);
				sysmessage(s, temp);
				return 1;
			}
			else if (pCont->isLockedDown() && amt >= SrvParms->SecurecontLimit) // Secure/lockdowns & lockdown chests
			{
				sprintf(temp, "Lockeddown containers have a limit of %i items.", SrvParms->SecurecontLimit);
				sysmessage(s, temp);
				return 1;
			}
			else if (amt >= SrvParms->ContainerLimit)	// other simple containers
			{
				sprintf(temp, "This container has a limit of %i items.", SrvParms->ContainerLimit);
				sysmessage(s, temp);
				return 1;
			}
		}
		else
		{
			if (amt >= SrvParms->ContainerLimit)	// ALL other containers
			{
				sprintf(temp, "This container has a limit of %i items.", SrvParms->ContainerLimit);
				sysmessage(s, temp);
				return 1;
			}
		}
		
		int total=0;
		int contwgt = (int) Weight->LockeddownWeight(pCont, &total);
		total=0;	// reset the # of items
		int dropwgt = (int) Weight->LockeddownWeight(Drop, &total);
		if (IsHatch(pCont->id()))
		{
			if (dropwgt + contwgt >= (int)SrvParms->BoatHoldWeight)
			{
				sprintf(temp, "The hold has a weight limit of %i stones.", SrvParms->BoatHoldWeight);
				sysmessage(s, temp);
				return 1;
			}
		}
		else	// all other containers
		{
			if (dropwgt + contwgt >= (int)SrvParms->ContainerWeight)
			{
				sprintf(temp, "This container has a weight limit of %i stones.", SrvParms->ContainerWeight);
				sysmessage(s, temp);
				return 1;
			}
		}
	}
    if (pCont->isContainerType())
		pCont->AddItem(Drop, pp->TxLoc, pp->TyLoc);
	else
	{
		if (!pCont->PileItem(Drop))
		{
			if (!pCont->isInWorld())
				Drop->SetContSerial(pCont->contserial);		// add to the same container as the item we dropped upon

			Drop->MoveTo2(pCont->pos);
		}
	}
	return 0;
}

void drop_item(P_CLIENT ps) // Item is dropped
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();	

	PKGx08 pkgbuf, *pp=&pkgbuf;

	pp->Iserial=LongFromCharPtr(&buffer[s][1]);
	pp->TxLoc=ShortFromCharPtr(&buffer[s][5]);
	pp->TyLoc=ShortFromCharPtr(&buffer[s][7]);
	pp->TzLoc=buffer[s][9];
	pp->Tserial=LongFromCharPtr(&buffer[s][10]);
	pp->Tpos.x = pp->TxLoc;
	pp->Tpos.y = pp->TyLoc;
	pp->Tpos.z = pp->TzLoc;
	pp->Tpos.map = Player->pos.map;

	P_ITEM Drop = FindItemBySerial(pp->Iserial);
	if (!Drop)
	{
		//LogErrorVar("client sent bad itemserial %d",pp->Iserial);
		return;
	}

    //#define debug_dragg
	
	if (clientDimension[s]==3)
	{
	  // UO:3D clients send SOMETIMES two dragg packets for a single dragg action. 
	  // sometimes we HAVE to swallow it, sometimes it has to be interpreted
	  // if UO:3D specific item loss problems are reported, this is probably the code to blame :)
	  // LB (2001)

	  // Note(2003): never breed of 3d clients (late 3.x + 4.x) do NOT do that anymore. (two packets)
	  // but still different behaviour from 2d. this works for all known 3d clients
	  // could be simplified if we move to 4.x clients only
      // plz don't touch unless you really know what you do - eg having lots of drop-packet-logg-files
      // of many 3d-clients

    
	  #ifdef debug_dragg 
	    if (Drop) { printf("lulu\n");sprintf(temp, "%04x %02x %02x %01x %04x i-name: %s EVILDRAG-old: %i\n",pp->Iserial, pp->TxLoc, pp->TyLoc, pp->TzLoc, pp->Tserial, Drop->name, EVILDRAGG[s]); clConsole.send(temp); }
		else { sprintf(temp, "blocked: %04x %02x %02x %01x %04x i-name: invalid item EVILDRAG-old: %i\n",pp->Iserial, pp->TxLoc, pp->TyLoc, pp->TzLoc, pp->Tserial, EVILDRAGG[s]); clConsole.send(temp); }
      #endif

	  if  ( (pp->TxLoc==-1) && (pp->TyLoc==-1) && (pp->Tserial==0)  && (EVILDRAGG[s]==1) ) 
	  { 
		  EVILDRAGG[s]=0; 
          #ifdef debug_dragg
		    clConsole.send("Swallow only\n"); 
          #endif
		  item_bounce6(ps, Drop); 
		  Drop->refresh();
		  return; 
	  }	 // swallow! note: previous evildrag !

	  else if ( (pp->TxLoc==-1) && (pp->TyLoc==-1) && (pp->Tserial==0)  && (EVILDRAGG[s]==0) ) 
	  {
          #ifdef debug_dragg
		    clConsole.send("Bounce & Swallow\n"); 
          #endif

		  item_bounce6(ps, Drop); 
		  Drop->refresh();
		  return; 
	  }
	  else if ( ( (pp->TxLoc!=-1) && (pp->TyLoc!=-1) && ( pp->Tserial!=-1)) || ( (isItemSerial(pp->Iserial)) && (isItemSerial(pp->Tserial)) ) ) EVILDRAGG[s]=1; // calc new evildrag value
	  else EVILDRAGG[s]=0;
	} 

	#ifdef debug_dragg 
	  else
	  {
		 int i = calcItemFromSer( pp->Iserial );
	     if (i!=-1) { sprintf(temp, "blocked: %04x %02x %02x %01x %04x i-name: %s EVILDRAG-old: %i\n",pp->Iserial, pp->TxLoc, pp->TyLoc, pp->TzLoc, pp->Tserial, Drop->name, EVILDRAGG[s]); clConsole.send(temp); }
	  }
    #endif

	if (Drop->flags.isBeeingDragged==false) 
	{		
		SndRejectDrop(s);
		if (ps->IsDragging())
		{
			ps->ResetDragging();		
			sysmessage(s, "you can't drop things you havn't grabbed");
		}			
		return;
	}

	if (!Drop->isInWorld() ||			//testing UOP Blocking Tauriel 1-12-99
		!Player->canPickUp(Drop))
	{
		item_bounce6(ps,Drop);
		SndRemoveItemToAll(Drop);			
		Drop->refresh();
		return;
	}
		
	int rc;
	if ( isItemSerial(pp->Tserial) )
	{
		const P_ITEM pCont=FindItemBySerial(pp->Tserial);
		if (!pCont)
			rc = 1;
		else
		{
			rc=pack_item(ps,pp,Drop,pCont);
			
			if (!rc && Drop->glow>0) // LB's glowing items stuff
			{
				P_CHAR Receiver = GetPackOwner(pCont); 
				Player->removeHalo(Drop); // if gm put glowing object in another pack, handle glowsp correctly !
				if (Receiver) 
				{
					Receiver->addHalo(Drop);
					Receiver->glowHalo(Drop);
				}
			}
		}
	}
	else 
		rc=dump_item(ps,pp,Drop);

	if (rc==1)	// rejected
	{
		item_bounce6(ps,Drop);
		SndRemoveItemToAll(Drop);			
		Drop->refresh();
	}
	else
	{
		Drop->flags.isBeeingDragged=false;
		itemsfx(s, Drop->id());
		Player->WeightAtCursor = 0;
		Weight->NewCalc(ps->getPlayer());
		statwindow(s,Player);
	}

	if (rc==2)
	{
		Items->DeleItem(Drop); // delete item
		SndRemoveItemToAll(Drop);
	}
}

