/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/*
Module : fishing.cpp
Purpose: store all fishing related functions
Created: Ripper...1-31-01
History: None
*/

#include "targeting.h"

#include "Client.h"
#include "itemid.h"
#include "mapstuff.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"
#include "mapS.h"
#include "fishing.h"
#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "fishing.cpp"

bool RandomLootItemNpcBySkill(UOXSOCKET s,P_CHAR Pc,int scp_num,int skill_num,char * section_name )
{
	Script* Scp=i_scripts[scp_num];
	int skill_section=RandomNum(0,(int)(Pc->Skill(skill_num)/10));
	Scp->Open();
	int loopexit=0;
	while(skill_section >= 0 && (++loopexit<MAXLOOPS) )
	{	
		if (Scp->find(section_name,skill_section)) break;
		skill_section--;		
	}
	if (skill_section < 0)
	{
		Scp->Close();
		return true;
	}

	int i=0;
	loopexit=0;
	char* token_temp=NULL;
	char loot_item[256]={0};
	char default_message[256]={0};
	char loot_message[256]={0};
	Scp->NextLineSplitted();
 	while( !Scp->EndSect() && (++loopexit < MAXLOOPS) )
 	{
		if (!Scp->CmpTok1("DEFAULT")) strcpy(default_message,script2);	
		else i++;
		Scp->NextLineSplitted();
	}
	Scp->find(section_name,skill_section);
	bool no_loot=false;
	int k=0;

	loopexit=0;
	if (i>0)
 	{
  		i=(rand()%(i))+1;
		do
		{
			Scp->NextLineSplitted();
			if (Scp->CmpTok1("DEFAULT")) k++;
		}while((k<i) && ++loopexit<MAXLOOPS);
		Scp->Close();
		token_temp=strpbrk(script2," ");
		if (token_temp)
		{
			token_temp[0]=0;
			token_temp++;
			strcpy(loot_message,token_temp);
		}
		strcpy(loot_item,script2);
		if (!Scp->CmpTok1("NPC"))
		{
			if (Pc->inGuardedArea() && SrvParms->guardsactive) no_loot=true;
			else if (Npcs->AddRespawnNPC(s,str2num(loot_item))==NULL) no_loot=true;	
		}	
		else if (!Scp->CmpTok1("ITEM")) 
		{
			if (!(Items->SpawnItemBackpack2(s, str2num(loot_item),1))) no_loot=true;
		}
		else if (!Scp->CmpTok1("ITEMLIST"))
		{
			int rand_item=Items->PickFromItemlist(loot_item); //uses ITEMLIST
			if (!Items->SpawnItemBackpack2(s,rand_item,1))
				 no_loot=true;
		}
		if (!no_loot)
		{
			if (token_temp) sysmessage( s, loot_message);
			else sysmessage( s, default_message);
		}
	}
	return no_loot;
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Author: LB, (2.7.2000)
// Purpose: Finding Items per Item-Id in a x*y rectangle around a player
// Input paramters: player      -> players' index in the chars array. (= calling via currchar[s] )
//                  id1,id2     -> item id to search for
//                  x,y         -> x*y rectangle around the players current x,y location. (current x,y = middle point of the rect) 
//                                 thats the region where the searching takes place
//                                 warning: x and y should be max 10, because mapregions are used.
//
//                  max_returns -> no more than return_max items are returned
//
// Output paramters: number of items found
//                   items_found -> list of found items's serials.
//
// PRE: items_found pointer must have memory allocated for max_return int's. if not it might **crash**           
//      mapregion array has to be correct (no duplicate entries etc). 
//      It usually contains all items in a (10 until 15) * (10 until 15) grid/recantagle. 
//      uncertian about exact number, but I'd say everything below 10 is save. ( -> x,y <= 10)    
//      player must be valid player_index
//       
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    
static int Find_items_around_player(P_CHAR Player, short id, unsigned char x, unsigned char y, int max_returns, int* items_found)
{
	if (!Player) return -1;
	if (max_returns<1) return -1;

	cRectangle rect(Player->pos.x-x, Player->pos.y-y, Player->pos.x+x, Player->pos.y+y);
	int found=0;
	
	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->id() == id) // found the item
		{				
			if (pi->pos.IsIn(rect))
			{
				// remark: case ignored where players' x,y - range x,y < 0
				
				if (found<max_returns) 
				{
					items_found[found] = pi->serial;
					found++;
				} else break;
			}
		}
	}		
	return found;
}

// LB: added fish stacking !!
static void Fish(P_CHAR Player)
{
	if (!Player) return;
	const int max_fish_piles = 1;		// attention: thats per fish *type*, so the efffective limit of piles is *3
	const int max_fish_stacksize = 15;	// attention: rela max size = value+1

	int d,ii,ss,b;
	int idnum;
	int color;

	int fishes_around_player;
	int fish_sers[max_fish_piles];

	int s=Player->calcSocket();

	if (Player->Stm() < 2)
	{
		sysmessage(s, "You are too tired to fish, you need to rest!");
		return;
	}

	if (!Player->checkSkill(FISHING))
	{
		sysmessage(s,"You fish for a while, but fail to catch anything.");
		return;
	}
	Player->reduceStm(2); // lose 2 stamina each cast.

	// New Random fishing up items and monsters...OPIK
	bool normal_fish=true;
	if ((unsigned)RandomNum(0,100) <= fishing_data.loot_probability)
	{
		normal_fish=RandomLootItemNpcBySkill(s,Player,fishing_script,FISHING,"FISHLIST");
	}
	if (normal_fish)
	{
	ii=rand()%3;
	idnum=0xCC+ii;

	///**** exotic fish stuff *****//
	float mv=-0.087087087f*(float)Player->Skill(FISHING)+100.087087087086f; // gm fish -> 1/13 % probability on new spawn(!) to have exotic color, neophyte: 1/92 % probability, linear interpolation in between
	int no_idea_for_variable_name = (int) mv;
	if (no_idea_for_variable_name<=0) no_idea_for_variable_name=1; // prevent modulo crashes	
	if (rand()%no_idea_for_variable_name==0) 
	{ 		
		color=(Player->pos.x+Player->pos.y);
		color+=rand()%10;
		color=color%0x03E9; 
		if (color<0x0002 || color>0x03E9)
		{
			color=0x03E9;
		}
		b=((color&0x4000)>>14)+((color&0x8000)>>15);

		if (b)
		{
			color=0x100+rand()%255;
		}
	} else color=0;

	/**** end of exotic fish stuff stuff */

	fishes_around_player=Find_items_around_player(Player, 0x0900+idnum, 2, 2, max_fish_piles, fish_sers); // lets search for fish in a 2*2 rectangle around the player
	
	P_ITEM pFish;
	if (fishes_around_player<=0) // no fish around -> spawn a new one
	{
		pFish=Items->SpawnItem(Player,1,"#",1,0x0900+idnum,color,0);
		if (!pFish) return;//AntiChrist to prevent crashes
		pFish->setType(ITY_Food);
		pFish->AddFoodType(FOOD_FISH+FOOD_RAW); // set flags for new food system
		pFish->MoveTo2(Player->pos);
		pFish->SetMultiSerial(Player->multis);
	}
	else // fishes around ?
	{
		int min=1234567;
		P_ITEM iC = NULL;
		P_ITEM iMc = NULL;
		for (d=0;d<fishes_around_player;d++) // lets pick the smallest pile form the return list
		{
			iC = FindItemBySerial( fish_sers[d] );
			if (iC)
			{
				ss=iC->amount;
				if (ss<min) { min=ss; iMc=iC; }
			}
		}
		if (!iMc) return;
		if (iMc->amount>max_fish_stacksize) // if smallest fish-stack > max_stacksize spawn a new fish anyway
		{
			if (fishes_around_player>=max_fish_piles)
			{
				sysmessage(s,"you catch a fish, but no place for it left");
				return;
			}
			
			P_ITEM Fish=Items->SpawnItem(Player,1,"#",1,0x0900+idnum,color,0);
			if (!Fish) return;
			Fish->setType(ITY_None);
			Fish->MoveTo2(Player->pos);
			Fish->SetMultiSerial(Player->multis);
		}
		else // if fish stack <=max_ -> just increase stack !!
		{
			if (iC!=NULL)
			{
				iC->amount++;
				iC->refresh();
			}
		}
	} // end else fishes around
	if ((color&0x00FF)>0)
		sysmessage(s,"You pull out an exotic fish!");
	else
	    sysmessage(s,"You pull out a fish!");
	}
}

void cTargets::FishTarget(P_CLIENT ps, short Tx, short Ty, short landid)
{
	P_CHAR Player=ps->getPlayer();
	if (!Player) return;

	cCoord Tpos(Tx,Ty,0,0);  // NOTE: needs to be changed when multiple maps get implemented
	if (!inRange(Player->pos,Tpos,6))	// fixes an exploit with fishing, LB
	{
		ps->SysMsg("You are too far away to reach that");
		return;
	}

	bool ok=false;
	if (IsFishWater(landid))
		ok = true;
	else
	{	// it might be offshore fishing (client returns id=0 for deep sea ) Duke, Thx for the hint goes to Avanoon guys

		cellData map;
		AllMaps->SeekMap(Tpos, map); // search the ground tile where they casted		
		if ( map.TID == 0x00A8 || map.TID == 0x00A9 || map.TID == 0x00AA || map.TID == 0x00AB )
			ok = true;
	}
	if (ok)
	{
		Player->DoAction(0x0B);
		if (fishing_data.randomtime!=0)
			Player->fishingtimer=rand()%fishing_data.randomtime+fishing_data.basetime;
		else
			Player->fishingtimer=fishing_data.basetime;
		
		soundeffect(Player, 0x023F);
		Player->unhide();
		Fish(Player);
	}
	else
		ps->SysMsg("You need to be closer to the water to fish!");
}

