/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "wolfpack.h"
#include "SndPkg.h"
#include "debug.h"
#include "cGumps.h"
#include "gumps.h"
#include "tiledata.h"

#undef  DBGFILE
#define DBGFILE "gumpclasses.cpp"



CTithing::CTithing(void):okButtonId(5),outerleftButtonId(2), leftButtonId(1), rightButtonId(3), outerrightButtonId(4)
{
   DaGump=NULL;
   DaGump = new CGumps<0x0300>(0x00000293, "Tithing Gump");

   DaGump->addGumpDescr("page 0");
   DaGump->addGumpDescr("gumppic 30 30 102");
   DaGump->addGumpDescr("xmfhtmlgumpcolor 95 100 120 100 1060198 0 0 0");
   DaGump->addGumpDescr("text 57 274 0 2");
   DaGump->addGumpDescr("text 87 274 53 3");
   DaGump->addGumpDescr("text 137 274 0 0");
   DaGump->addGumpDescr("text 172 274 53 1");
   DaGump->addGumpDescr("button 105 230 5220 5220 1 0 2");
   DaGump->addGumpDescr("button 113 230 5222 5222 1 0 2");
   DaGump->addGumpDescr("text 108 228 0 5");
   DaGump->addGumpDescr("text 112 228 0 5");
   DaGump->addGumpDescr("button 127 230 5223 5223 1 0 1");
   DaGump->addGumpDescr("text 131 228 0 5");
   DaGump->addGumpDescr("button 147 230 5224 5224 1 0 3");
   DaGump->addGumpDescr("text 153 228 0 4");
   DaGump->addGumpDescr("button 168 230 5220 5220 1 0 4");
   DaGump->addGumpDescr("button 174 230 5222 5222 1 0 4");
   DaGump->addGumpDescr("text 172 228 0 4");
   DaGump->addGumpDescr("text 176 228 0 4");
   DaGump->addGumpDescr("button 217 272 4023 4024 1 0 5");

   DaGump->addGumpText("Tithe:");
   DaGump->addGumpText("0000");
   DaGump->addGumpText("Gold:");
   DaGump->addGumpText("0000");
   DaGump->addGumpText(">");
   DaGump->addGumpText("<");

   DaGump->toRawData(0xa0, 0x28);
}

void CTithing::showTithingGump(UOXSOCKET s)
{
	DaGump->SendGump(s);
}

void CTithing::setGoldandTithing(int gold, int tithing)
{
	char g[100]; char h[100];

	numtostr(gold, g);
	numtostr(tithing,h);

	DaGump->deleteGumpTextComplete();

	DaGump->addGumpText("Tithe:");
    DaGump->addGumpText(g);
    DaGump->addGumpText("Gold:");
    DaGump->addGumpText(h);
    DaGump->addGumpText(">");
    DaGump->addGumpText("<");

	DaGump->toRawDataDynOnly();
}

void CTithing::ButtonHandler(int id, unsigned int gid, UOXSOCKET s)
{
	if (gid!=DaGump->myGumpId()) return; // not my gump ? return

	if (id==okButtonId)
	{
		sysmessage(s,"TithingGumpManager: ok pressed");
	} 
	else if (id==outerleftButtonId)
	{
		sysmessage(s,"TithingGumpManager: << pressed");
	}
	else if (id==leftButtonId)
	{
		sysmessage(s,"TithingGumpManager: < pressed");
	}
	else if (id==rightButtonId)
	{
		sysmessage(s,"TithingGumpManager: > pressed");
	}
	else if (id==outerrightButtonId)
	{
		sysmessage(s,"TithingGumpManager: >> pressed");
	}
}

CTithing::~CTithing(void)
{
  if (DaGump!=NULL) delete DaGump;
}

///////////////////////////////////////////
//
//  LB 13-May 2003
//
//////////////////////////////////////////

CAddMenu::CAddMenu(int imenuNum, int imprev)
{
   TheGump=NULL;
   TheGump = new CGumps<0x1000>(0x00000082, "Add Menu Gump");

   //printf("%04x\n",imenuNum);

   //////////////////////////////////
	//// fetch data from scripts ////
   //////////////////////////////////

   static char text[255][257];
   int id[255],id2[255];
   int number=0,loopexit=0;	
   char sect[512];
   int np=0;

   Script * Scp=i_scripts[items_script];
   sprintf(sect, "ITEMMENU %i", imenuNum);
   Scp=Scp->Select(sect,custom_item_script);
   if (!Scp) return;  

   Scp->NextLine();
   strcpy(text[0], script1);id[0]=0;id2[0]=0;
   Scp->NextLineSplitted();
   while ( !Scp->EndSect() && (++loopexit < MAXLOOPS) )
   {
	  if (number>=255) break;   
	  number++;
	  strcpy(text[number], script2); // get text	  
	  id2[number]=hstr2num(script1); // fetch item id (iff it's an additem entry, otherwise its irrevlevant)	  
	  Scp->NextLineSplitted();
	  id[number]=str2num(script2);	// number of submenu or item to add
	
	  int sn=scriptCommandtoNum(script1);	  
	  id[number]=id[number]&0x0000ffff; // clear high short (low short=number)
	  id[number]|=(sn<<16); // add script command # as high short
	  
	  if ( /*sn==7 || sn==10 || sn==11*/ 1==1) // only collects id's of npc/items !
	  {	 		  
		  if (TileData->isTileOk(id2[number]) && id2[number]!=0 ) np++; else id2[number]=0;
	  }

	  Scp->NextLineSplitted();	 
   }
   number++;
   Scp->Close();

   ///////////////////
   // generate gump //
   ///////////////////

   int maxx=max(340,min(640,160+np*50+100));
   int a,p;
   char tmp[4096];

   TheGump->addGumpDescr("noclose");
   TheGump->addGumpDescr("page 0");
   sprintf(temp,"resizepic 0 0 2600 %i 320", maxx);
   TheGump->addGumpDescr(temp);
   sprintf(temp, "button %i 20 4017 4018 1 0 %i", maxx-80, 123456789); // close button
   TheGump->addGumpDescr(temp);
   TheGump->addGumpDescr("text 40 40 0 0");
   TheGump->addGumpDescr("page 1");
  
   const char maxbuttonsperpage=8;
   bool fullpage, lastpage;
   int b=0, cip=0;p=1;
   for (a=1; a<number;a++)
   {	 
	 sprintf(tmp, "text 80 %i 0 %i", 80+20*b, a); 
     TheGump->addGumpDescr(tmp);
	 sprintf(tmp, "button 50 %i 4005 4006 1 0 %i", 83+20*b, id[a]);
     TheGump->addGumpDescr(tmp); 	 

	 if (id2[a]!=0) 
	 {
		 sprintf(tmp, "tilepic %i 160 %i", 200+50*cip, id2[a]); 
	     TheGump->addGumpDescr(tmp);
		 cip++;
		 if ( (cip%maxbuttonsperpage)==0) cip=0;
	 }
	 
	 if (a==(number-1)) lastpage=true; else lastpage=false;

	 b++;
	 fullpage=false;

	 if ( ((a) % (maxbuttonsperpage)) == 0) // new page
	 {			
		 // add buttom left+right button

		 if (!lastpage) // lastpage aint no next page button
		 {
		   sprintf(tmp,"button %i 275 4005 4006 0 %i", maxx-80, p+1); // goto next page button (right)
		   TheGump->addGumpDescr(tmp);	
		 }		 

		 if ((p-1)>0)
		 {
			sprintf(tmp,"button 50 275 4014 4015 0 %i", p-1); // goto previous page button (left)
		    TheGump->addGumpDescr(tmp);	
		 }
		 else if (p==0) // only one page
		 {
			 if (imprev!=-1) // if there is a link to previous menue add it the left button, if not no left-button.
			 {
				sprintf(tmp,"button 50 275 4014 4015 1 0 %i", imprev); // goto previous page button (left)
		        TheGump->addGumpDescr(tmp);	
			 }
		 }
	
		 // start next page
		 sprintf(tmp,"page %i", p+1);
		 TheGump->addGumpDescr(tmp);			 

		 p++;
		 b=0;
		 cip=0;
		 fullpage=true;
	 }

	 if (lastpage && !fullpage) // add left button the last page (if last page doenst have exactly maxbuttons entries)
	 {
		 if ((p-1)>0)
		 {
			sprintf(tmp,"button 50 275 4014 4015 0 %i", p-1); 
		    TheGump->addGumpDescr(tmp);	
		 }
		 else if (p==0) 
		 {
			 if (imprev!=-1)
			 {
				sprintf(tmp,"button 50 275 4014 4015 1 0 %i", imprev); 
		        TheGump->addGumpDescr(tmp);	
			 }
		 }
	 }

   }
 
   TheGump->addGumpText(text[0]);
   for (a=1;a<number;a++) TheGump->addGumpText(text[a]);

   int centx=(max(0,(640-maxx)))/2;
   TheGump->toRawData(centx, 0x46);
	
}

CAddMenu::~CAddMenu(void)
{

  delete TheGump;

}

void AddMenuButtonHandler(int id1, int id2, UOXSOCKET s)
{
	if (id2!=0x82) return;
	int buttonId=id1;
	int sn, num;

	sn = ((buttonId>>16)&0x0000ffff);
	num = buttonId&0x0000ffff;

	if (sn==1) // new link
	{
	   CAddMenu *Grr = new CAddMenu(num, -1);
	   Grr->showAddGump(s);
	   delete Grr;
	}
	else // anything else (e.g additem)
	{
		char tmp  [2096];
		char tmp2 [2096];
		numtoScriptCommand(sn, tmp);
		numtostr(num, tmp2);	
		scriptcommand(s, tmp, tmp2);
	}

}

