/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "gumps.h"

#include "commands.h"
#include "guilds.h"
#include "house.h"
#include "im.h"
#include "magic.h"
#include "network.h"
#include "skills.h"
#include "SndPkg.h"
#include "targeting.h"
#include "virtues.h"	
#include "sregions.h"
#include "assert.h"
#include "magic_new.h"
#include "spells.h"
#include "regions.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "gumps.cpp"

void AddMenuButtonHandler(int id1, int id2, UOXSOCKET s);

void cGump::Button(int s, SERIAL serial, unsigned int button,  int type)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	//clConsole.send("gump-menu, button: %i type# %i \n",button, type); // lord bin	
    //if ((button)==0 || (button==1)) clConsole.send("gump-menu, type# %i closed\n",type); // lord bin

	if (Virtues->isVirtueMainGumpRequest(button, type))
	{
		Virtues->showVirtueMainGump(s);
		return;
	}

	if (Virtues->isVirtueSubGumpRequest(button, type))
	{
		Virtues->showVirtueSubGump(s);	
		return;
	}

	Magic->TithingGumpButtonHandler(button, type, s);
	AddMenuButtonHandler(button, type,s);

	if (button>10000)
	{
		Menu(s, button-10000);
		return;
	}

	switch (type)
	{
	case 1: // Item
		switch( button )
		{
		case 0:
		case 1: break; // send whenever you just press ok or cancel menu
		case 2:		entrygump( s, serial, type, button, 50, "Enter a new name for the item. (# = default name)" );	break;
		case 3:		entrygump( s, serial, type, button, 4, "Enter the new ID number for the item in hex." );		break;
		case 4:		entrygump( s, serial, type, button, 4, "Enter the new hue for the item in hex." );				break;
		case 5:		entrygump( s, serial, type, button, 4, "Enter the new X coordinate for the item in decimal." );	break;
		case 6:		entrygump( s, serial, type, button, 4, "Enter the new Y coordinate for the item in decimal." );	break;
		case 7:		entrygump( s, serial, type, button, 4, "Enter the new Z coordinate for the item in decimal." );	break;
		case 8:		entrygump( s, serial, type, button, 4, "Enter the new type for the item in decimal." );			break;
		case 9:		entrygump( s, serial, type, button, 4, "Enter the new itemhand for the item in decimal." );		break;//Xuri
		case 10:	entrygump( s, serial, type, button, 4, "Enter the new layer for the item in decimal." );		break;
		case 11:	entrygump( s, serial, type, button, 4, "Enter the new amount for the item in decimal." );		break;
		case 12:	entrygump( s, serial, type, button, 8, "Enter the new More for the item in hex." );				break;
		case 13:	entrygump( s, serial, type, button, 8, "Enter the new MoreB for the item in hex." );			break;
		case 14:	entrygump( s, serial, type, button, 1, "Enter the new stackable toggle for the item. (0/1)" );	break;
		case 15:	entrygump( s, serial, type, button, 1, "Enter the new dyeable toggle for the item. (0/1)" );	break;
		case 16:	entrygump( s, serial, type, button, 1, "Enter the new corpse toggle for the item. (0/1)" );		break;
		case 17:	entrygump( s, serial, type, button, 5, "Enter the new LODAMAGE value for the item in decimal." );	break;//|
		case 18:	entrygump( s, serial, type, button, 5, "Enter the new HIDAMAGE value for the item in decimal." );	break;//| both of these replace the old "attack value" (Xuri)
		case 19:	entrygump( s, serial, type, button, 5, "Enter the new defence value for the item in decimal." );	break;
		case 20:	entrygump( s, serial, type, button, 1, "Enter the new magic value for the item in decimal." );		break;
		case 21:	entrygump( s, serial, type, button, 1, "Enter the new visible value for the item in decimal." );	break;
		//start addons by Xuri
		case 22:	entrygump( s, serial, type, button, 5, "Enter the new HP value for the item in decimal." );			break;
		case 23:	entrygump( s, serial, type, button, 5, "Enter the new Max HP value for the item in decimal." );		break;
		case 24:	entrygump( s, serial, type, button, 5, "Enter the new Speed value for the item in decimal." );		break;
		case 25:	entrygump( s, serial, type, button, 5, "Enter the new Rank value for the item in decimal." );		break;
		case 26:	entrygump( s, serial, type, button, 5, "Enter the new Value for the item in decimal." );			break;
		case 27:	entrygump( s, serial, type, button, 5, "Enter the new Good value for the item in decimal." );		break;
		case 28:	entrygump( s, serial, type, button, 5, "Enter the new Made Skill value for the item in decimal." );	break;
		case 29:	entrygump( s, serial, type, button, 50, "Enter the new Creator name for the item." );				break;
		//end addons by Xuri
		default:	
			LogErrorVar( "Unknown button pressed %i", button );			
			break;
		}
		break;
	case 2:
		switch( button )
		{
		case 0:
		case 1: break; // send whenever you just press ok
		case 2:	 entrygump( s, serial, type, button, 50, "Enter a new Name for the character." );							break;
		case 3:	 entrygump( s, serial, type, button, 50, "Enter a new Title for the character." );							break;
		case 4:	 entrygump( s, serial, type, button, 4, "Enter a new X coordinate for the character in decimal." );			break;
		case 5:	 entrygump( s, serial, type, button, 4, "Enter a new Y coordinate for the character in decimal." );			break;
		case 6:	 entrygump( s, serial, type, button, 4, "Enter a new Z coordinate for the character in decimal." );			break;
		case 7:	 entrygump( s, serial, type, button, 3, "Enter a new Direction for the character in decimal." );			break;
		case 8:	 entrygump( s, serial, type, button, 4, "Enter a new Body Type for the character in hex." );				break;
		case 9:	 entrygump( s, serial, type, button, 4, "Enter a new Skin Hue for the character in hex." );					break;
		case 10: entrygump( s, serial, type, button, 3, "Enter a new Defence value for the character in decimal." );		break;
		case 11: entrygump( s, serial, type, button, 1, "Enter a new Hunger value for the character in decimal(0-6).");		break;			
		case 12: entrygump( s, serial, type, button, 5, "Enter a new Strength value for the character in decimal.");		break;			
		case 13: entrygump( s, serial, type, button, 5, "Enter a new Dexterity value for the character in decimal.");		break;			
		case 14: entrygump( s, serial, type, button, 5, "Enter a new Intelligence value for the character in decimal.");	break;
		case 15: entrygump( s, serial, type, button, 5, "Enter a new Karma value for the character in decimal.");			break;
		case 16: entrygump( s, serial, type, button, 5, "Enter a new Fame value for the character in decimal.");			break;
		case 17: entrygump( s, serial, type, button, 5, "Enter a new Kills value for the character in decimal.");			break;
		case 18: entrygump( s, serial, type, button, 5, "Enter a new Jail time for the character in seconds");				break;

		}
		break;
	case 3:
		switch (button)
		{
			case 0:
				return;
			case 1:
				Player->resurrect();
				staticeffect(Player, 0x376A, 0x09, 0x06);
				sysmessage(s, "You have been resurrected.");
				return;
		}
		break;
	case 4:			// Wholist
		if (button<200)	
		{		
			button-=7;
			Player->making=button;
			Commands->WhoCommand(s,type,button);
		}
		else
		{ 
			int i=Player->making;
			if (i<0)
			{
				sysmessage(s,"selected character not found");
				return;
			}
			serial=whomenudata[i];
			P_CHAR Victim = FindCharBySerial(serial); // find selected char ...
		    if (!Victim) 
			{
				sysmessage(s,"selected character not found");
				return;
			}
			switch(button)
			{
			case 200://gochar
				{
				bool travel = (Victim->pos.map == Player->pos.map) ? false : true;	// do we change maps ??

				doGmMoveEff(s); 	// have a flamestrike at origin and at player destination point 	//Aldur
				if (travel) SndNewMap(s,Victim->pos.map);
				Player->teleTo(Victim->pos); 
				if (travel) Player->teleTo(Victim->pos);	// send everything a 2nd time (client oddity)
				doGmMoveEff(s);
				}
				break;
			case 201://xtele
				Victim->teleTo(Player->pos);
				
				break;
			case 202://jail char
				if (Player->isSameAs(Victim))
				{
					sysmessage(s,"You cannot jail yourself!");					 
					break;
				}
				else
				{
					addmitem[s] = SrvParms->default_jail_time; 
					Targ->JailTarget (s,Victim);
					break;
				}						 
			case 203://release				 
				Targ->ReleaseTarget(s,Victim);
				break;
			case 204:
				if (Player->isSameAs(Victim))
				{
					sysmessage(s,"You cannot kick yourself");
					break; // lb
				}
				else
				{
					if (!Victim->InGame()) 
					{ 
						sysmessage(s,"you cant kick an offline player");
						break;
					}
					sysmessage(s, "Kicking player");				
					Network->Disconnect(Victim->calcSocket());
					Network->CorrectSockPositionAfterDisconnect(s,Victim->calcSocket());
					break;
				}
			default:
				LogError("Fallout of switch");
			}
			return;
		}
		break;
    // uups, someone deleted that 
	// readded by LB 10-dec 1999
	case 5:           // House
		P_ITEM Sign;
		P_ITEM House;
		House = NULL;
		Sign = FindItemBySerial(getAddid1_4(s));	// get the housesign
		if (Sign)
		{
			House = FindItemBySerial(Sign->getMore1_4());	// get the house
		}
		
		if (button != 20 && button != 2)
		{
			if (House)
			{
				setAddid1_4(s,House->serial);
			}
		}
		switch (button)
		{
		case 20: // Change house sign's appearance
			short id;
			id = ShortFromCharPtr(&buffer[s][21]);
			if (id>0)
			{
				if (Sign)
				{
					if (Sign->id() & 1)		// odd sign ids point east
						Sign->setId(id-1);
					else
						Sign->setId(id);
					Sign->refresh();
					sysmessage(s, "House sign changed.");
				}
			}
			return;
		case 0:
			return;
		case 2:  // Bestow ownership upon someone else
			target(s, 227, "Select person to transfer ownership to.");
			return;
		case 3:  // Turn house into a deed
			deedhouse(s, House);
			return;
		case 4:  // Kick someone out of house
			target(s, 228, "Select person to eject from house.");
			return;
		case 5:  // Ban somebody
			target(s, 229, "Select person to ban from house.");
			return;
		case 6:
		case 8: // Remove someone from house list
			target(s, 231, "Select person to remove from house registry.");
			return;
		case 7: // Make someone a friend
			target(s, 230, "Select person to make a friend of the house.");
			return;
		default:
			sprintf(temp, "HouseGump Called - Button=%i", button);
			sysmessage(s, temp);
			return;
		}
		break;
		
		case 6: // Hair Dye Gump
			switch (button)
			{
			case 0:return;
			case 1:
				short Dye;
				Dye = ShortFromCharPtr(&buffer[s][21]);
				P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

				int ci=0,loopexit=0;
				P_ITEM pi;
				while ( ((pi=Player->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
				{
					if (pi->layer==0x10 || pi->layer==0x0B)//beard(0x10) and hair
					{
						if (( Dye >= 0x44D && Dye <= 0x47B) || ( Dye >= 0x4B1 && Dye <= 0x4C8) ||
							( Dye >= 0x515 && Dye <= 0x534) || ( Dye >= 0x582 && Dye <= 0x5A1) ||
							( Dye >= 0x5DD && Dye <= 0x5FC) || ( Dye >= 0x641 && Dye <= 0x674) ||
							( Dye >= 0x8A5 && Dye <= 0x8A9) || ( Dye >= 0x961 && Dye <= 0x97C) )
							pi->setColor(Dye);
						pi->refresh();
						sysmessage(s, "You have successively dyed your hair.");
					}
				}
			}
			break;
			
		case 8: // Camp logout
			switch (button)
			{
			case 0: return;
			case 1:
				{
					Network->Disconnect(Player->calcSocket());
					
					PC_ITEM pj;
					int loopexit=0;
					RegGrid3x3Iterator4Items rg3ii(Player->pos);
					while((pj = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
					{
						if ((pj->id()==0x0A55 || pj->id()==0x0A58)
							&& Player->dist(pj) < 3)
						{
							P_ITEM Pack = Player->getBackpack();
							if (Pack)
							{
								P_ITEM Bedroll = pj->unconst();
								Bedroll->setId(0x0A58); // Closed Bedroll
								Pack->AddItem(Bedroll);
							}
							return;
						}
					}
				}
				break;
		}   
	}
}
		
void cGump::Input(int s)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int body,b,k;
	
	char type=buffer[s][7];
	char index=buffer[s][8];
	char* text=(char*)&buffer[s][12];
	int serial = LongFromCharPtr((unsigned char*)&buffer[s][3]);

	Guilds->GumpInput(s,type,index,text);

	if (type == 1 && (Player->isGM()))//AntiChrist
	{
		cItem* pi = FindItemBySerial( serial );
		if ( !pi ) return; //lb
		if (buffer[s][9]==0)
		{
			tweakmenu(s, pi->serial);
			return;
		}
		switch( index )
		{
		case 2:		strcpy( pi->name, (char*)text );	break;	// Name
		case 3:		pi->setId(hstr2num( text ));		break;	// ID
		case 4:		pi->setColor(hstr2num( text ));		break;	// Hue
		case 5:		k = str2num( text );	pi->MoveTo(k, pi->pos.y, pi->pos.z);	break;	// X
		case 6:		k = str2num( text );	pi->MoveTo(pi->pos.x, k, pi->pos.z);	break;	// Y
		case 7:		k = str2num( text );	pi->MoveTo(pi->pos.x, pi->pos.y, k);	break;	// Z
		case 8:		k = str2num( text );	pi->setType(k);	break;	// Type
		case 9:		k = str2num( text );	pi->itmhand = k;break;	// Itemhand - added by Xuri
		case 10:	k = str2num( text );	pi->layer = k;	break;	// Layer
		case 11:	k = str2num( text );	pi->amount = k;	break;	// Amount
		case 12:	k = hstr2num( text );	// More
					pi->setMore1_4(k);
					break;
		case 13: 	k = hstr2num( text );	// MoreB
					pi->setMoreB1_4(k);
					break;
		case 14: 	k = str2num( text );	pi->pileable = k;	break;	// Pileable
		case 15:	k = str2num( text );	pi->dye = k;		break;	// Dye
		case 16:	k = str2num( text );	pi->corpse = k;		break;	// Corpse
		case 17:	k = str2num( text );	pi->lodamage = k;	break;	// LoDamage
		case 18:	k = str2num( text );	pi->hidamage = k;	break;	// HiDamage
		case 19:	k = str2num( text );	pi->def = k;		break;	// Def
		case 20:	k = str2num( text );	pi->setMovability(k);break;	// Movability
		case 21:	k = str2num( text );	pi->visible = k;	break;	// Visible
		case 22:	k = str2num( text );	pi->hp = k;			break;	// Current Hitpoints
		case 23:	k = str2num( text );	pi->maxhp = k;		break;	// MAX Hitpoints
		case 24:	k = str2num( text );	pi->spd = k;		break;	// Speed (for Combat)
		case 25:	k = str2num( text );	pi->rank = k;		break;	// Rank
		case 26:	k = str2num( text );	pi->value = k;		break;	// Value
		case 27:	k = str2num( text );	pi->good = k;		break;	// Good(for Adv.Trade system)
		case 28:	k = str2num( text );	pi->madewith = k;	break;	// Made Skill
		case 29:	strcpy( pi->creator, (char*)text );			break;	// Creator
		}
		
		pi->refresh();
		tweakmenu(s, pi->serial);
	}
	if (type==2 && (Player->isGM()))//AntiChrist
	{
		cCoord old_pos;
		P_CHAR pc_j = FindCharBySerial( serial );
		if (pc_j == NULL) return;
		old_pos = pc_j->pos;
		if (buffer[s][9]==0)
		{
			tweakmenu(s, pc_j->serial);
			return;
		}
		switch( index )
		{
		case 2:		strcpy( pc_j->name, (char*)text );			break;	// Name
		case 3:		strcpy( pc_j->title, (char*)text );			break;	// Title
		case 4:		k = str2num( text );	pc_j->pos.x = k;	break;	// X
		case 5:		k = str2num( text );	pc_j->pos.y = k;	break;	// Y
		case 6:		k = str2num( text ); 	pc_j->pos.z = k;	pc_j->dispz = k;	break;	// Z
		case 7:		k = str2num( text );	pc_j->dir = k&0x0F;	break;// make sure the high-bits are clear // Dir
		case 8: // Body
			k = hstr2num( text );
			if (k>=0x000 && k<=0x3e1) // lord binary, body-values >0x3e crash the client, allow only non crashing ones			                       
			{
				pc_j->setXid(k);
				pc_j->setId(k);
				unsigned short color = pc_j->skin;						// transparency for mosnters allowed, not for palyers, 
				// if polymorphing from monster to player we have to switch from transparent to semi-transparent
				// or we have that sit-down-client crash
				if ((color&0x4000) && (k >=0x0190 && k<=0x03e1))
				{
					if (color!=0x8000)
					{
						pc_j->skin = pc_j->xskin = 0xF000;
					}
				}			
			}
			break;
		case 9:		// Skin
			k = hstr2num( text );
			body=pc_j->id();
			
			b=k&0x4000; // Lord binary --> that touchy transparency bit ! 
			// fixes a client crash with transparently dyed skin.
			// ( only with body values 190-03e1 --> no monster )
			// if such a char wants to sit down the client crashes.
			// this is a CLIENT(!) BUG I cant do anythhing  
			
			if (b==16384 && (body >=0x0190 && body<=0x03e1)) k=0xf000; // but assigning the only "transparent" value that works, namly semi-trasnparency.
			
			if (k!=0x8000) // 0x8000 also crashes client ...
			{	
		              pc_j->xskin = pc_j->skin = k;
			}
			break;
		case 10:	k = str2num( text );	pc_j->def = k;		break;	// Defence
		case 11:	k = str2num( text );	pc_j->setHunger(k);	break;	// Hunger
		case 12:	k = str2num( text );	pc_j->setStr(k);	break;	// Strength
		case 13:	k = str2num( text );	pc_j->setDex(k);	break;	// Dexterity
		case 14:	k = str2num( text );	pc_j->setInt(k);	break;	// Intelligence
		case 15:	k = str2num( text );	pc_j->karma = k;	break;	// Karma
		case 16:	k = str2num( text );	pc_j->fame = k;		break;	// Fame
		case 17:	k = str2num( text );	pc_j->kills = k;	break;	// Kills
		case 18:    k = str2num( text );	pc_j->jailtimer.setSecs(k);	break;
		}
		
		teleport(pc_j, old_pos);
		tweakmenu(s, pc_j->serial);
	}
}


void cGump::Menu(UOXSOCKET s, int m, P_ITEM Sign)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	char sect[512];
	int loopexit=0;
	short int length, length2, textlines=0;
	unsigned int i;
	bool house_gump=false, new_decay=false;
	int ds;
	char tt[255];
	char tt2[255];
	
	openscript("gumps.scp");
	sprintf(sect, "GUMPMENU %i", m);
	if (!i_scripts[gump_script]->find(sect))
	{
		closescript();
		return;
	}

	length=21;
	length2=1;

	loopexit=0;
	do
	{
		read1();
		if ((script1[0]!='}')&&(strncmp(script1, "type ", 5)!=0))
		{

			/*sprintf(tt,"pos1: %s\n",script1);
			LogMessage(tt);*/

			length+=strlen(script1)+4;
			length2+=strlen(script1)+4;
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	length+=3;

	sprintf(sect, "GUMPTEXT %i", m);
	if (!i_scripts[gump_script]->find(sect))
	{
		closescript();
		return;
	}

	loopexit=0;
	do
	{
		read1();
		if (script1[0]!='}')
		{
			/*sprintf(tt,"pos2: %s\n",script1);
			LogMessage(tt);*/

			if (!strcmp(script1,"Decay Status :")) { new_decay=true; }
	
			length+=(strlen(script1)*2)+2;
			textlines++;
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	unsigned char gump1[21]={0,};
	unsigned char gump2[3]={0,};
	unsigned char gump3[2]={0,};

	LongToCharPtr(Player->serial, &gump1[3]);
	gump1[10]=0x12; // Gump Number
	gump1[19]=length2>>8; // command section length
	gump1[20]=length2%256;

	// remark LB, 
	// 11-14 .. offset x
	// 15-18 .. offset y

	sprintf(sect, "GUMPMENU %i", m);
	if (!i_scripts[gump_script]->find(sect))
	{
		closescript();
		return;
	}
	// typecode setting - Crackerjack 8/8/99
	read1();
	if (!strncmp(script1, "type ", 5))
	{
		gump1[10]=atoi((char*)&script1[5]);
		script1[0]='}';
		house_gump=true;
	}

    if (house_gump && new_decay) // showing house decay status, LB 23'th september 2000
	{
        // 1) get house item#  
		
		if (Sign!=NULL) // should be !=-1 for house's gumps (only!), but to be on safe side, lets check it.
		{
            // 2) calc decay % number	
			P_ITEM House = FindItemBySerial( Sign->getMore1_4() );			  
			if (House)
			{
				if (SrvParms->housedecay_secs!=0)				
					ds=((House->time_unused)*100)/(SrvParms->housedecay_secs); else ds=-1;
				numtostr(ds,  tt);
			} else
			{
				// house item gone...
				/*strcpy(tt, "housedata corrupted");
				ds=-2;
				length+=(strlen(tt)+3)*2;*/			

				ds=-1;
				numtostr(ds,  tt);				
			}
                
			//if (j!=NULL) clConsole.send("decay: %i proz house_age: %i max_age: %i \n",ds,items[j].time_unused,server_data.housedecay_secs);

            // 3) adjust sizes because "decay status :" string is scripted, but the % number added dynamically      			
	  
			if (ds>=0 && ds<10)        length+=8;    // space digit space % =4*2
			else if (ds>=10 && ds<100) length+=10;   // space digit digit space % = 5*2
			else if (ds>=100)          length+=12;   // space digit digit digit space % = 6*2

			if (ds==-1) length+=10;
					
	        gump1[1]=length>>8;
	        gump1[2]=length%256;
		}
	} else ; 

	LongToCharPtr(1, &gump1[3]); // can be anything except 0
	XStartPkt(0xb0, length);
	XAddPkt(&gump1[0+3], 21-3);

	loopexit=0;
	do
	{
		if (script1[0]!='}')
		{
			sprintf(sect, "{ %s }", script1);
			XAddPkt((unsigned char*)&sect[0], strlen(sect));
		}
		read1();
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	// remark: gump2[0]==0, = termination of the sequence above
	gump2[1]=textlines>>8;
	gump2[2]=textlines%256;

	XAddPkt(&gump2[0], 3);

	sprintf(sect, "GUMPTEXT %i", m);
	if (!i_scripts[gump_script]->find(sect))
	{
		closescript();
		return;
	}

	loopexit=0;
	do
	{
		read1();
		if (script1[0]!='}')
		{

			/*sprintf(tt,"pos3: %s\n",script1);
			LogMessage(tt);*/

			if (house_gump)
			{
				if (!strcmp(script1,"Decay Status :"))
				{				 
				   strcpy(tt2,script1);
				   strcat(tt," %");
                   strcat(script1, " ");
				   strcat(script1,tt);
				   //clConsole.send("final string: %s\n",script1);
				   //clConsole.send("orig_len : %i new_len: %i\n",strlen(tt2),strlen(script1));
				}
			}

			gump3[0]=strlen(script1)>>8;
			gump3[1]=strlen(script1)%256;
			XAddPkt(&gump3[0], 2);
			gump3[0]=0;
			for (i=0;i<strlen(script1);i++)
			{
				gump3[1]=script1[i];
				XAddPkt(&gump3[0], 2);
			}
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	XFinishPkt(s);

	closescript();
}

// Runebook code by Victor (june 2002)
// Runebook crafting by Uber
// 
// rune books are type 70 GMs do not need to charge book if you set morez 
// to > 1000 you can have player rune books that need no charging.
// morex of the rune book stores the value of the default location in rune book
// morey of the rune book stores the value of the number of charges in the rune book
// morez of the rune book stores the value of the number of max charges in the rune book 

void cGump::RuneBookButton(int s, unsigned int button,  P_ITEM Book)
{
	P_ITEM pi=NULL;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (!Book) return;
	int ci=0;
	unsigned int i;
	
	if (button==1000) //rename runebook
	{
		Player->setInput(6,Book);
		sysmessage(s,"Enter a New Name For RuneBook.");
		return;
	}
	if ((button>=1) && (button<=16)) //recall and use the book charges
	{
		for(i=0;i<button;++i) pi=Book->Search(&ci);
		if (pi==NULL) return;

		if (Player->isGM()||Book->morey||Book->morez>1000)
		{
			Magic->BeginCasting(Player,32,STY_SCROLL,pi);

//			currentSpellType[s]=1;
//			OldMagic->NewCastSpell(s,pi->serial);
		}
		if (!Player->isGM()||Book->morez>1000)
			if (Book->morey)
				Book->morey--;
	}
	if (button>300&&button<317) //drop rune
	{
		if ((button-300)==Book->morex) Book->morex=0;
		for(i=0;i<button-300;i++) pi=Book->Search(&ci);

		pi->SetContSerial(Book->contserial);
		pi->pos.x=50+rand()%80;
		pi->pos.y=50+rand()%80;
		pi->pos.z=9;
		pi->layer=0x00;
		pi->refresh();
	}
	if (button>400&&button<417) //gate without using charges
	{
		for(i=0;i<button-400;i++) pi=Book->Search(&ci);
		if (pi==NULL) return;

/*		int r = calcRegionFromXY(Player->pos);
	    if (r<0 || r>255) r=255;
		if (!region[r].isRuneBookAllowed()) return;
*/
		Magic->BeginCasting(Player,52,STY_BOOK,pi);

//		currentSpellType[s]=1;		
//		OldMagic->NewCastSpell(s,pi->serial);
	}
	if (button>200&&button<217)	// set the default location
		Book->morex=button-200;

	if (button>500&&button<517)//recall without using charges
	{
		for(i=0;i<button-500;i++) pi=Book->Search(&ci);
		if (pi==NULL) return;

/*		int r = calcRegionFromXY(Player->pos);
	    if (r<0 || r>255) r=255;
		if (!region[r].isRuneBookAllowed()) return;
*/
		Magic->BeginCasting(Player,32,STY_BOOK,pi);

//		currentSpellType[s]=1;
//		OldMagic->NewCastSpell(s,pi->serial);
	} 
}

void cGump::RuneBook(int s, int type, P_ITEM Book)
{
	char sect[512];
	short int length=0, length2=0, textlines=0;
	int j,ci=0,m,n=125;
	unsigned int k=0, runenum=0,i=1;
	static char menuarray[300][50],menuarray1[30][50];
	unsigned int linecount1=0,linecount=0,line=0;
	P_ITEM pi;
	
	strcpy(menuarray[linecount++], "page 0");
	strcpy(menuarray[linecount++], "gumppic 100 10 2200");
	for(j=1;j<17;j++)
	{
		if (j==9) n=170;
		if (j==1||j==9) m=57;
		else if (j==8||j==16) m=59;
		else m=58;
		sprintf(menuarray[linecount++], "gumppic %i 50 %i",n+(j-1)*15,m);
	}
	
	for(j=1;j<9;j++)
	{
		if (j>4)
			sprintf(menuarray[linecount++], "button %i 187 %i %i 0 %i 0",160+(j-1)*35,j+2224,j+2224,j+1);
		else
			sprintf(menuarray[linecount++], "button %i 187 %i %i 0 %i 0",130+(j-1)*35,j+2224,j+2224,j+1);
	}
	strcpy(menuarray[linecount++], "text 160 40 0 19");
	strcpy(menuarray[linecount++], "text 300 40 0 20");
	strcpy(menuarray[linecount++], "page 1");
	strcpy(menuarray[linecount++], "button 130 20 2472 2473 1 0 1000");
	strcpy(menuarray[linecount++], "text 158 22 0 0");
	strcpy(menuarray[linecount++], "button 393 14 2206 2206 0 2 0");
	strcpy(menuarray1[linecount1++], "Rename Book");
	for(j=1;j<17;j++)
	{
		if (j<9)
		{
			sprintf(menuarray[linecount++], "button 130 %i 2103 2104 1 0 %i",65+(j-1)*15,j);
			sprintf(menuarray[linecount++], "text 145 %i 115 %i",60+(j-1)*15,j);
		}
		else
		{
			sprintf(menuarray[linecount++], "button 290 %i 2103 2104 1 0 %i",65+(j-9)*15,j);
			sprintf(menuarray[linecount++], "text 305 %i 115 %i",60+(j-9)*15,j);
		}
	}
	
	for(j=0;j<16;j++)
	{
		pi=Book->Search(&ci);
		if (pi!= NULL)
		{
			char buff[300];
			strncpy(buff,pi->name,60);
			for(i=0;i<13;i++) buff[i]=buff[i+8];
			buff[13]='\0';
			sprintf(menuarray1[linecount1++],"%s", buff);
			runenum++;
		}
		else
			strcpy(menuarray1[linecount1++], "Empty");
	}
	strcpy(menuarray1[linecount1++], "Set defualt");
	strcpy(menuarray1[linecount1++], "Drop rune");
	if (Book->morez<1001)
	{
		sprintf(menuarray1[linecount1++], "Charges: %d",Book->morey);
		sprintf(menuarray1[linecount1++], "Max Charges: %d",Book->morez);
	}
	else
	{
		sprintf(menuarray1[linecount1++], "GM Book");
		sprintf(menuarray1[linecount1++], "   GM Book");
	}
	for(j=2;j<10;j++)
	{
		sprintf(menuarray[linecount++], "page %i",j);
		if (j!=9)
			sprintf(menuarray[linecount++], "button 393 14 2206 2206 0 %i 0",j+1);
		sprintf(menuarray[linecount++], "button 125 14 2205 2205 0 %i 0",j-1);
		for(i=1;i<3;i++)
		{
			sprintf(menuarray[linecount++], "button %i 65 2103 2104 1 0 %i",130+(i-1)*160,++k);
			sprintf(menuarray[linecount++],"text %i 60 115 %i",145+(i-1)*160,k);
			if (k<=runenum)
			{
				if (k==Book->morex)
					sprintf(menuarray[linecount++], "button %i 20 2360 2360 1 0 %i",160+(i-1)*135,k+200);
				else
					sprintf(menuarray[linecount++], "button %i 20 2361 2360 1 0 %i",160+(i-1)*135,k+200);//default
				sprintf(menuarray[linecount++], "text %i 15 0 17",175+(i-1)*135);
				sprintf(menuarray[linecount++], "button %i 115 2437 2438 1 0 %i",135+(i-1)*160,k+300);//drop
				sprintf(menuarray[linecount++], "text %i 115 0 18",150+(i-1)*160);
			}
			sprintf(menuarray[linecount++], "button %i 140 2271 2271 1 0 %i",135+(i-1)*160,k+500);//recall
			sprintf(menuarray[linecount++], "button %i 140 2291 2291 1 0 %i",205+(i-1)*160,k+400);//gate
		}
	}
	
	length=21;
	length2=1;
	
	for(line=0;line<linecount;line++)
	{
		if (strlen(menuarray[line])==0)
			break;
		length+=strlen(menuarray[line])+4;
		length2+=strlen(menuarray[line])+4;
	}
	
	length+=3;
	textlines=0;
	line=0;
	
	for(line=0;line<linecount1;line++)
	{
		if (strlen(menuarray1[line])==0)
			break;
		length+=strlen(menuarray1[line])*2+2;
		textlines++;
	}
	
	unsigned char gump1[21]={0,};
	unsigned char gump2[3]={0,};
	unsigned char gump3[2]={0,};
	
	LongToCharPtr(1, &gump1[3]); // can be anything except 0	
	gump1[10]=type; // Gump Number
	gump1[19]=length2>>8;
	gump1[20]=length2%256;

	XStartPkt(0xb0, length);
	XAddPkt(&gump1[0+3], 21-3);
	
	for(line=0;line<linecount;line++)
	{
		sprintf(sect, "{ %s }", menuarray[line]);
		XAddPkt((unsigned char*)&sect[0], strlen(sect));
	}
	
	gump2[1]=textlines>>8;
	gump2[2]=textlines%256;
	XAddPkt(&gump2[0], 3);
	
	for(line=0;line<linecount1;line++)
	{
		if (strlen(menuarray1[line])==0)
			break;
		gump3[0]=strlen(menuarray1[line])>>8;
		gump3[1]=strlen(menuarray1[line])%256;
		XAddPkt(&gump3[0], 2);
		gump3[0]=0;
		for (i=0;i<strlen(menuarray1[line]);i++)
		{
			gump3[1]=menuarray1[line][i];
			XAddPkt(&gump3[0], 2);
		}
	}

	XFinishPkt(s);
}


void whomenu(int s, int type, char* filter, int searchbyaccount) //WhoList--By Homey-- Thx Zip and Taur helping me on this
// added also logged out chars+bugfixing , LB
{
	char sect[512];
	short int length, length2, textlines;
	int j,x;
	unsigned int line,i,k;
	static char menuarray1[10*(MAXCLIENT)+50][50]; // there shoundbe be more than 5*MAXLIENT palyers, 7 to be on save side
	static char menuarray[10*(MAXCLIENT)+50][50];
	unsigned int linecount=0;
	unsigned int linecount1=0,pagenum=1,position=40,linenum=1,buttonnum=7;
	bool doFiltering=false;
	unsigned char filterExpr='#'; // for now only very simply filtering by first letter	

	if (filter==NULL) doFiltering=false; 
	else
	{	
	  int fl = strlen(filter);	 
	  if (fl==0) doFiltering=false; 
	  else 
	  {
		  doFiltering=true;
		  filterExpr=filter[0];
	  }
	}
	
	j=0;
	for (k=0;k<now;k++)
	{
		P_CHAR pc = MAKE_CHAR_REF(currchar(k));
		if (pc==NULL) continue;
		if (pc->InGame()) 
		{
			if (doFiltering || searchbyaccount !=-1) 
			{				
				if (doFiltering)
				{
					char fc = pc->name[0];
					if (fc>=97 && fc <=122) fc-=32; // convert first letter to uppercase, note: stuff entered ALWAYS arrives upercase :/
					if (fc==filterExpr) j++;
				}
				if (searchbyaccount!=-1) if (pc->account==searchbyaccount) j++;
				assert(!(doFiltering && searchbyaccount!=-1)); // xor'ness has to be provided by calling logic
			}
			else j++;
		}
	}		   
	//--static pages
	strcpy(menuarray[linecount++], "nomove");
	strcpy(menuarray[linecount++], "noclose");
	strcpy(menuarray[linecount++], "page 0");
	strcpy(menuarray[linecount++], "resizepic 0 0 5120 320 340");    //The background
	strcpy(menuarray[linecount++], "button 20 300 2130 2129 1 0 1"); //OKAY
	strcpy(menuarray[linecount++], "text 20 10 300 0");           //text <Spaces from Left> <Space from top> <Length, Color?> <# in order>		
	sprintf(menuarray[linecount++], "page %i",pagenum);
	//--Start User List
	
	k=0;
	P_CHAR toCheck;
	AllCharsIterator aci;
	bool check;
	for(aci.Begin(); (toCheck=aci.GetData()) != NULL; aci++)
	{
		if (toCheck->account!=-1)
		{			
			check=false;
			if (doFiltering)
			{
			  char fc = toCheck->name[0];
			  if (fc>=97 && fc <=122) fc-=32;
			  if (fc==filterExpr) check=true;
			}
			if (doFiltering==false && searchbyaccount==-1) check=true;
			if (doFiltering==false && searchbyaccount!=-1 && toCheck->account==searchbyaccount) check=true; 			
			if (check)
			{
			   if (k>0 && (!(k%10)))
			   {
				position=40;
				pagenum++;
				sprintf(menuarray[linecount++], "page %i",pagenum);
			   }
			
			   k++;
			
			   sprintf(menuarray[linecount++], "text 40 %i 300 %i",position,linenum); //usernames
			   sprintf(menuarray[linecount++], "button 20 %i 1209 1210 1 0 %i",position,buttonnum);
			   position+=20;
			   linenum++;
			   buttonnum++;
			}
		}
	}
	
	//clConsole.send("k:%i pages: %i\n",k,pagenum);
	
	pagenum=1; //lets make some damn buttons
	for (i=0;i<k;i+=10)
	{			
		sprintf(menuarray[linecount++], "page %i", pagenum);
		if (i>=10)
			sprintf(menuarray[linecount++], "button 150 300 2223 2223  0 %i",pagenum-1); //back button
		if ((k>10) && ((i+10)<k))
			sprintf(menuarray[linecount++], "button %i 300 2224 2224  0 %i", 150+(20*(pagenum>1)),pagenum+1); //forward button
		pagenum++;
	}		
	
	length=21;
	length2=1;
	
	for(line=0;line<linecount;line++)
	{
		if (strlen(menuarray[line])==0)
			break;
		length+=strlen(menuarray[line])+4;
		length2+=strlen(menuarray[line])+4;
	}
	
	length+=3;
	textlines=0;
	line=0;
	
	if (!doFiltering) sprintf(menuarray1[linecount1++], "Users currently online: %i",j);
	else              sprintf(menuarray1[linecount1++], "%i Users currently online starting with %c",j, filterExpr);
				
	//Start user list
	
	x=0;
	for (i=0;i<(unsigned) now;i++)
	{
		P_CHAR pc = MAKE_CHAR_REF(currchar(i));
		if (!pc) continue;
		if (pc->InGame())
		{
			check=false;
			if (doFiltering)
			{
			   char fc = pc->name[0];
			   if (fc>=97 && fc <=122) fc-=32;
			   if (fc==filterExpr) check=true;
			}
			if (doFiltering==false && searchbyaccount==-1) check=true;
			if (doFiltering==false && searchbyaccount!=-1 && pc->account==searchbyaccount) check=true;
			if (check)
			{					
			   sprintf(menuarray1[linecount1++], "Player %s [online,%i]",pc->name, pc->account);
			   whomenudata[x++]=pc->serial;
			}
		}
	}
	
	for (aci.Begin(); (toCheck=aci.GetData()) != NULL; aci++)
	{
		if (toCheck->account!=-1 && !toCheck->InGame())
		{
			check=false;
		    char fc = toCheck->name[0];
			if (fc>=97 && fc <=122) fc-=32;
			if (doFiltering && fc==filterExpr) check=true;
			if (doFiltering==false && searchbyaccount==-1) check=true;
			if (doFiltering==false && searchbyaccount!=-1 && toCheck->account==searchbyaccount) check=true;
			if (check)
			{
			  sprintf(menuarray1[linecount1++], "Player: %s [offline,%i]",toCheck->name, toCheck->account);
			  whomenudata[x++]=toCheck->serial;
			  //clConsole.send("name: %s\n",chars[i].name);
			}
		
		}
	}

	for(line=0;line<linecount1;line++)
	{
		if (strlen(menuarray1[line])==0)
			break;
		{
			length+=strlen(menuarray1[line])*2 +2;
			textlines++;
		}
	}

	unsigned char gump1[21]={0,};
	unsigned char gump2[3]={0,};
	unsigned char gump3[2]={0,};

	LongToCharPtr(1, &gump1[3]); // can be anything except 0
	gump1[10]=type; // Gump Number
	gump1[19]=length2>>8;
	gump1[20]=length2%256;

	XStartPkt(0xb0, length);
	XAddPkt(&gump1[0+3], 21-3);
	
	for(line=0;line<linecount;line++)
	{
		sprintf(sect, "{ %s }", menuarray[line]);
		XAddPkt((unsigned char*)&sect[0], strlen(sect));
	}
	
	gump2[1]=textlines>>8;
	gump2[2]=textlines%256;
	
	XAddPkt(&gump2[0], 3);
	
	for(line=0;line<linecount1;line++)
	{
		if (strlen(menuarray1[line])==0)
			break;
		{
			gump3[0]=strlen(menuarray1[line])>>8;
			gump3[1]=strlen(menuarray1[line])%256;
			XAddPkt(&gump3[0], 2);
			gump3[0]=0;
			for (i=0;i<strlen(menuarray1[line]);i++)
			{
				gump3[1]=menuarray1[line][i];
				XAddPkt(&gump3[0], 2);
			}
		}
	}

	XFinishPkt(s);
}

void playermenu(int s, int type, char* filter) //WhoList2 with offline players--By Ripper
// added also logged out chars+bugfixing , LB
{
	char sect[512];
	short int length, length2, textlines;
	int x;
	unsigned int line,i,k;
	static char menuarray1[10*(MAXCLIENT)+50][50]; // there shoundbe be more than 5*MAXLIENT palyers, 7 to be on save side
	static char menuarray[10*(MAXCLIENT)+50][50];
	unsigned int linecount=0;
	unsigned int linecount1=0,pagenum=1,position=40,linenum=1,buttonnum=7;
	
	//--static pages
	strcpy(menuarray[linecount++], "nomove");
	strcpy(menuarray[linecount++], "noclose");
	strcpy(menuarray[linecount++], "page 0");
	strcpy(menuarray[linecount++], "resizepic 0 0 5120 320 340");    //The background
	strcpy(menuarray[linecount++], "button 20 300 2130 2129 1 0 1"); //OKAY
	strcpy(menuarray[linecount++], "text 20 10 300 0");           //text <Spaces from Left> <Space from top> <Length, Color?> <# in order>		
	sprintf(menuarray[linecount++], "page %i",pagenum);
	//--Start User List

	int playersonline = 0;
	k=0;
	for(i=0;i<now;i++)
	{
		P_CHAR pc = MAKE_CHAR_REF(currchar(i));
		if (!pc) continue;
		if (pc->InGame())
		{
			playersonline++;
			if (pc->account!=-1)
			{
				if (k>0 && (!(k%10)))
				{
					position=40;
					pagenum++;
					sprintf(menuarray[linecount++], "page %i",pagenum);
				}
				
				k++;
				
				sprintf(menuarray[linecount++], "text 40 %i 300 %i",position,linenum); //usernames
				sprintf(menuarray[linecount++], "button 20 %i 1209 1210 1 0 %i",position,buttonnum);
				position+=20;
				linenum++;
				buttonnum++;
			}
		}
	}
	
	
	//clConsole.send("k:%i pages: %i\n",k,pagenum);
	
	pagenum=1; //lets make some damn buttons
	for (i=0;i<k;i+=10)
	{			
		sprintf(menuarray[linecount++], "page %i", pagenum);
		if (i>=10)
			sprintf(menuarray[linecount++], "button 150 300 2223 2223  0 %i",pagenum-1); //back button
		if ((k>10) && ((i+10)<k))
			sprintf(menuarray[linecount++], "button %i 300 2224 2224  0 %i", 150+(20*(pagenum>1)),pagenum+1); //forward button
		pagenum++;
	}		
	
	length=21;
	length2=1;
	
	for(line=0;line<linecount;line++)
	{
		
		if (strlen(menuarray[line])==0)
			break;
		{
			length+=strlen(menuarray[line])+4;
			length2+=strlen(menuarray[line])+4;
		}
	}
	
	length+=3;
	textlines=0;
	line=0;
	
	sprintf(menuarray1[linecount1++], "Users currently online: %i",playersonline);
				
	//Start user list
	
	x=0;
	for (i=0;i<now;i++)
	{
		P_CHAR pc = MAKE_CHAR_REF(currchar(i));
		if (!pc) continue;
		if (pc->InGame())
		{ 
			sprintf(menuarray1[linecount1++], "Player %s [online]",pc->name);
			whomenudata[x++]=pc->serial;
		}	
	}
	
	for(line=0;line<linecount1;line++)
	{
		if (strlen(menuarray1[line])==0)
			break;
		{
			length+=strlen(menuarray1[line])*2 +2;
			textlines++;
		}
	}

	unsigned char gump1[21]={0,};
	unsigned char gump2[3]={0,};
	unsigned char gump3[2]={0,};

	LongToCharPtr(1, &gump1[3]); // can be anything except 0	
	gump1[10]=type; // Gump Number
	gump1[19]=length2>>8;
	gump1[20]=length2%256;

	XStartPkt(0xb0, length);
	XAddPkt(&gump1[0+3], 21-3);
	
	for(line=0;line<linecount;line++)
	{
		sprintf(sect, "{ %s }", menuarray[line]);
		XAddPkt((unsigned char*)&sect[0], strlen(sect));
	}
	
	gump2[1]=textlines>>8;
	gump2[2]=textlines%256;
	
	XAddPkt(&gump2[0], 3);
	
	for(line=0;line<linecount1;line++)
	{
		if (strlen(menuarray1[line])==0)
			break;
		{
			gump3[0]=strlen(menuarray1[line])>>8;
			gump3[1]=strlen(menuarray1[line])%256;
			XAddPkt(&gump3[0], 2);
			gump3[0]=0;
			for (i=0;i<strlen(menuarray1[line]);i++)
			{
				gump3[1]=menuarray1[line][i];
				XAddPkt(&gump3[0], 2);
			}
		}
	}

	XFinishPkt(s);
}


void tline( int line, SERIAL serial )
{
	char type;
	if (isCharSerial(serial))
		type = 2;
	else
		type = 1;
	line--; if ( line == 0 ) strcpy( script1, "page 0" );
	line--; if ( line == 0 ) strcpy( script1, "resizepic 0 0 2520 400 350" );
	line--; if ( line == 0 ) strcpy( script1, "text 40 10 32 0" );
	line--; if ( line == 0 ) strcpy( script1, "button 35 280 2130 2129 1 0 1" );
	if ( type == 1 ) 
	{ 
		line--; 
		P_ITEM pi = FindItemBySerial(serial);
		if ( line == 0 ) 
			sprintf( script1, "tilepic 300 180 %i", pi->id()); 
	}
	line--; if ( line == 0 ) strcpy( script1, "page 1" );
	line--; if ( line == 0 ) strcpy( script1, "button 366 320 2224 2224 0 2");
	line--; if ( line == 0 ) strcpy( script1, "text 288 317 32 1");
	line--; if ( line == 0 ) strcpy( script1, "text 90 70 0 3");
	line--; if ( line == 0 ) strcpy( script1, "text 200 70 16 4");
	line--; if ( line == 0 ) strcpy( script1, "button 30 70 2116 2115 1 0 2");
	line--; if ( line == 0 ) strcpy( script1, "text 90 95 0 5");
	line--; if ( line == 0 ) strcpy( script1, "text 200 95 16 6");
	line--; if ( line == 0 ) strcpy( script1, "button 30 95 2116 2115 1 0 3");
	line--; if ( line == 0 ) strcpy( script1, "text 90 120 0 7");
	line--; if ( line == 0 ) strcpy( script1, "text 200 120 16 8");
	line--; if ( line == 0 ) strcpy( script1, "button 30 120 2116 2115 1 0 4");
	line--; if ( line == 0 ) strcpy( script1, "text 90 145 0 9");
	line--; if ( line == 0 ) strcpy( script1, "text 200 145 16 10");
	line--; if ( line == 0 ) strcpy( script1, "button 30 145 2116 2115 1 0 5");
	line--; if ( line == 0 ) strcpy( script1, "text 90 170 0 11");
	line--; if ( line == 0 ) strcpy( script1, "text 200 170 16 12");
	line--; if ( line == 0 ) strcpy( script1, "button 30 170 2116 2115 1 0 6");
	line--; if ( line == 0 ) strcpy( script1, "text 90 195 0 13");
	line--; if ( line == 0 ) strcpy( script1, "text 200 195 16 14");
	line--; if ( line == 0 ) strcpy( script1, "button 30 195 2116 2115 1 0 7");
	line--; if ( line == 0 ) strcpy( script1, "text 90 220 0 15");
	line--; if ( line == 0 ) strcpy( script1, "text 200 220 16 16");
	line--; if ( line == 0 ) strcpy( script1, "button 30 220 2116 2115 1 0 8");
	if ( type == 2 )
	{
		line--; if ( line == 0 ) strcpy( script1, "text 90 245 0 17");
		line--; if ( line == 0 ) strcpy( script1, "text 200 245 16 18");
		line--; if ( line == 0 ) strcpy( script1, "button 30 245 2116 2115 1 0 9");
	}
	if ( type == 1 )
	{
		line--; if ( line == 0 ) strcpy( script1, "text 90 245 0 19");
		line--; if ( line == 0 ) strcpy( script1, "text 200 245 16 20");
		line--; if ( line == 0 ) strcpy( script1, "button 30 245 2116 2115 1 0 10");
	}
	line--; if ( line == 0 ) strcpy( script1, "page 2");
	line--; if ( line == 0 ) strcpy( script1, "button 40 320 2223 2223 0 1");
	line--; if ( line == 0 ) strcpy( script1, "text 65 317 32 2");
	line--; if ( line == 0 ) strcpy( script1, "button 366 320 2224 2224 0 3");
	line--; if ( line == 0 ) strcpy( script1, "text 288 317 32 1");
	if ( type == 1 )
	{
		line--; if ( line == 0 ) strcpy( script1, "text 90 70 0 17");
		line--; if ( line == 0 ) strcpy( script1, "text 200 70 16 18");
		line--; if ( line == 0 ) strcpy( script1, "button 30 70 2116 2115 1 0 9");
		line--; if ( line == 0 ) strcpy( script1, "text 90 95 0 21");
		line--; if ( line == 0 ) strcpy( script1, "text 200 95 16 22");
		line--; if ( line == 0 ) strcpy( script1, "button 30 95 2116 2115 1 0 11");
		line--; if ( line == 0 ) strcpy( script1, "text 90 120 0 23");
		line--; if ( line == 0 ) strcpy( script1, "text 200 120 16 24");
		line--; if ( line == 0 ) strcpy( script1, "button 30 120 2116 2115 1 0 12");
		line--; if ( line == 0 ) strcpy( script1, "text 90 145 0 25");
		line--; if ( line == 0 ) strcpy( script1, "text 200 145 16 26");
		line--; if ( line == 0 ) strcpy( script1, "button 30 145 2116 2115 1 0 13");
		line--; if ( line == 0 ) strcpy( script1, "text 90 170 0 27");
		line--; if ( line == 0 ) strcpy( script1, "text 200 170 16 28");
		line--; if ( line == 0 ) strcpy( script1, "button 30 170 2116 2115 1 0 14");
		line--; if ( line == 0 ) strcpy( script1, "text 90 195 0 29");
		line--; if ( line == 0 ) strcpy( script1, "text 200 195 16 30");
		line--; if ( line == 0 ) strcpy( script1, "button 30 195 2116 2115 1 0 15");
		line--; if ( line == 0 ) strcpy( script1, "text 90 220 0 31");
		line--; if ( line == 0 ) strcpy( script1, "text 200 220 16 32");
		line--; if ( line == 0 ) strcpy( script1, "button 30 220 2116 2115 1 0 16");
		line--; if ( line == 0 ) strcpy( script1, "text 90 245 0 33");
		line--; if ( line == 0 ) strcpy( script1, "text 200 245 16 34");
		line--; if ( line == 0 ) strcpy( script1, "button 30 245 2116 2115 1 0 17");
	}
	if ( type == 2 )
	{
		line--; if ( line==0 ) strcpy( script1, "text 90 70 0 19");
		line--; if ( line==0 ) strcpy( script1, "text 200 70 16 20");
		line--; if ( line==0 ) strcpy( script1, "button 30 70 2116 2115 1 0 10");
		line--; if ( line==0 ) strcpy( script1, "text 90 95 0 21");
		line--; if ( line==0 ) strcpy( script1, "text 200 95 16 22");
		line--; if ( line==0 ) strcpy( script1, "button 30 95 2116 2115 1 0 11");
		line--; if ( line==0 ) strcpy( script1, "text 90 120 0 23");
		line--; if ( line==0 ) strcpy( script1, "text 200 120 16 24");
		line--; if ( line==0 ) strcpy( script1, "button 30 120 2116 2115 1 0 12");
		line--; if ( line==0 ) strcpy( script1, "text 90 145 0 25");
		line--; if ( line==0 ) strcpy( script1, "text 200 145 16 26");
		line--; if ( line==0 ) strcpy( script1, "button 30 145 2116 2115 1 0 13");
		line--; if ( line==0 ) strcpy( script1, "text 90 170 0 27");
		line--; if ( line==0 ) strcpy( script1, "text 200 170 16 28");
		line--; if ( line==0 ) strcpy( script1, "button 30 170 2116 2115 1 0 14");
		//Karma
		line--; if ( line==0 ) strcpy( script1, "text 90 195 0 29");
		line--; if ( line==0 ) strcpy( script1, "text 200 195 16 30");
		line--; if ( line==0 ) strcpy( script1, "button 30 195 2116 2115 1 0 15");
		//Fame
		line--; if ( line==0 ) strcpy( script1, "text 90 220 0 31");
		line--; if ( line==0 ) strcpy( script1, "text 200 220 16 32");
		line--; if ( line==0 ) strcpy( script1, "button 30 220 2116 2115 1 0 16");
		//Kills
		line--; if ( line==0 ) strcpy( script1, "text 90 245 0 33");
		line--; if ( line==0 ) strcpy( script1, "text 200 245 16 34");
		line--; if ( line==0 ) strcpy( script1, "button 30 245 2116 2115 1 0 17");

	}
	line--; if ( line == 0 ) strcpy( script1, "page 3");
	line--; if ( line == 0 ) strcpy( script1, "button 40 320 2223 2223 0 2");
	line--; if ( line == 0 ) strcpy( script1, "text 65 317 32 2");
	line--;	if ( line == 0 ) strcpy( script1, "button 366 320 2224 2224 0 4" );
	line--; if ( line == 0 ) strcpy( script1, "text 288 317 32 1" );
	if ( type == 1 )
	{
		line--; if ( line == 0 ) strcpy( script1, "text 90 70 0 35");
		line--; if ( line == 0 ) strcpy( script1, "text 200 70 16 36");
		line--; if ( line == 0 ) strcpy( script1, "button 30 70 2116 2115 1 0 18");
		line--; if ( line == 0 ) strcpy( script1, "text 90 95 0 37");
		line--; if ( line == 0 ) strcpy( script1, "text 200 95 16 38");
		line--; if ( line == 0 ) strcpy( script1, "button 30 95 2116 2115 1 0 19");
		line--; if ( line == 0 ) strcpy( script1, "text 90 120 0 39");
		line--; if ( line == 0 ) strcpy( script1, "text 200 120 16 40");
		line--; if ( line == 0 ) strcpy( script1, "button 30 120 2116 2115 1 0 20");
		line--; if ( line == 0 ) strcpy( script1, "text 90 145 0 41");
		line--; if ( line == 0 ) strcpy( script1, "text 200 145 16 42");
		line--; if ( line == 0 ) strcpy( script1, "button 30 145 2116 2115 1 0 21");
		line--; if ( line == 0 ) strcpy( script1, "text 90 170 0 43");
		line--; if ( line == 0 ) strcpy( script1, "text 200 170 16 44");
		line--; if ( line == 0 ) strcpy( script1, "button 30 170 2116 2115 1 0 22");
		line--; if ( line == 0 ) strcpy( script1, "text 90 195 0 45");
		line--; if ( line == 0 ) strcpy( script1, "text 200 195 16 46");
		line--; if ( line == 0 ) strcpy( script1, "button 30 195 2116 2115 1 0 23");
		line--; if ( line == 0 ) strcpy( script1, "text 90 220 0 47");
		line--; if ( line == 0 ) strcpy( script1, "text 200 220 16 48");
		line--; if ( line == 0 ) strcpy( script1, "button 30 220 2116 2115 1 0 24");
		line--; if ( line == 0 ) strcpy( script1, "text 90 245 0 49");
		line--; if ( line == 0 ) strcpy( script1, "text 200 245 16 50");
		line--; if ( line == 0 ) strcpy( script1, "button 30 245 2116 2115 1 0 25");
	}
	if ( type == 2 )
	{
		line--; if ( line == 0 ) strcpy( script1, "text 90 70 0 35");
		line--; if ( line == 0 ) strcpy( script1, "text 200 70 16 36");
		line--; if ( line == 0 ) strcpy( script1, "button 30 70 2116 2115 1 0 18");

	}
	line--; if ( line == 0 ) strcpy( script1, "page 4");
	line--; if ( line == 0 ) strcpy( script1, "button 40 320 2223 2223 0 3");
	line--; if ( line == 0 ) strcpy( script1, "text 65 317 32 2");
	if (type==1)
	{
		line--; if ( line == 0 ) strcpy( script1, "text 90 70 0 51");
		line--; if ( line == 0 ) strcpy( script1, "text 200 70 16 52");
		line--; if ( line == 0 ) strcpy( script1, "button 30 70 2116 2115 1 0 26");
		line--; if ( line == 0 ) strcpy( script1, "text 90 95 0 53");
		line--; if ( line == 0 ) strcpy( script1, "text 200 95 16 54");
		line--; if ( line == 0 ) strcpy( script1, "button 30 95 2116 2115 1 0 27");
		line--; if ( line == 0 ) strcpy( script1, "text 90 120 0 55");
		line--; if ( line == 0 ) strcpy( script1, "text 200 120 16 56");
		line--; if ( line == 0 ) strcpy( script1, "button 30 120 2116 2115 1 0 28");
		line--; if ( line == 0 ) strcpy( script1, "text 90 145 0 57");
		line--; if ( line == 0 ) strcpy( script1, "text 200 145 16 58");
		line--; if ( line == 0 ) strcpy( script1, "button 30 145 2116 2115 1 0 29");

		//end addons by Xuri
	}
	line--; if (line==0) strcpy( script1,  "}");
}

void ttext(int line, SERIAL serial)
{
	char type;
	if (isCharSerial(serial))
		type = 2;
	else
		type = 1;

	if (type==1) { line--; if ( line == 0 ) strcpy( script1, "Item Properties"); }
	if (type==2) { line--; if ( line == 0 ) strcpy( script1, "Character Properties"); }
	line--; if ( line == 0 ) strcpy( script1, "Next page");
	line--; if ( line == 0 ) strcpy( script1, "Previous page");
	if (type==1)
	{
		P_ITEM pj = FindItemBySerial(serial);
		if (pj == NULL)
			return;
		line--; if ( line == 0 ) strcpy( script1, "Name");
		line--; if ( line == 0 ) strcpy( script1, pj->name );
		line--; if ( line == 0 ) strcpy( script1, "ID");
		line--; if ( line == 0 ) sprintf( script1,"0x%x (%i)", pj->id(), pj->id());
		line--; if ( line == 0 ) strcpy( script1, "Hue");
		line--; if ( line == 0 ) sprintf( script1,"0x%x (%i)", pj->color(), pj->color());
		line--; if ( line == 0 ) strcpy( script1, "X");
		line--; if ( line == 0 ) sprintf( script1,"%i (0x%x)", pj->pos.x, pj->pos.x);
		line--; if ( line == 0 ) strcpy( script1, "Y");
		line--; if ( line == 0 ) sprintf( script1,"%i (0x%x)", pj->pos.y, pj->pos.y);
		line--; if ( line == 0 ) strcpy( script1, "Z");
		line--; if ( line == 0 ) sprintf( script1,"%i (0x%x)", pj->pos.z, pj->pos.z);
		line--; if ( line == 0 ) strcpy( script1, "Type");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->type);
		line--; if ( line == 0 ) strcpy( script1,  "ItemHand" );
		line--; if ( line == 0 ) sprintf( script1, "%i", pj->itmhand );
		line--; if ( line == 0 ) strcpy( script1, "Layer");
		line--; if ( line == 0 ) sprintf( script1,"%i (0x%x)", pj->layer, pj->layer);
		line--; if ( line == 0 ) strcpy( script1, "Amount");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->amount);
		line--; if ( line == 0 ) strcpy( script1, "More");
		line--; if ( line == 0 ) sprintf( script1,"0x%x", pj->getMore1_4());
		line--; if ( line == 0 ) strcpy( script1, "MoreB");
		line--; if ( line == 0 ) sprintf( script1,"0x%x", pj->getMoreB1_4());
		line--; if ( line == 0 ) strcpy( script1, "Stackable");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->pileable);
		line--; if ( line == 0 ) strcpy( script1, "Dyeable");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->dye );
		line--; if ( line == 0 ) strcpy( script1, "Corpse");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->corpse );
		line--; if ( line == 0 ) strcpy((char*) script1, "LoDamage" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->lodamage );
		line--; if ( line == 0 ) strcpy( script1, "HiDamage" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->hidamage );
		line--; if ( line == 0 ) strcpy( script1, "Defense");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->def);
		line--; if ( line == 0 ) strcpy( script1, "Magic");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->getMovability());
		line--; if ( line == 0 ) strcpy( script1, "Visible");
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->visible);
		line--; if ( line == 0 ) strcpy( script1, "HitPoints" );
		line--; if ( line == 0 ) sprintf( script1, "%i", pj->hp );
		line--; if ( line == 0 ) strcpy( script1, "MaxHitPoints" );
		line--; if ( line == 0 ) sprintf((char*) script1, "%i", pj->maxhp );
		line--; if ( line == 0 ) strcpy((char*) script1, "Speed" );
		line--; if ( line == 0 ) sprintf((char*) script1, "%i", pj->spd );
		line--; if ( line == 0 ) strcpy( script1, "Rank");
		line--; if ( line == 0 ) sprintf((char*) script1,"%i", pj->rank);
		line--; if ( line == 0 ) strcpy((char*) script1, "Value");
		line--; if ( line == 0 ) sprintf((char*) script1,"%i", pj->value);
		line--; if ( line == 0 ) strcpy((char*) script1, "Good" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pj->good );
		line--; if ( line == 0 ) strcpy( script1, "Made Skill" );
		line--; if ( line == 0 ) sprintf( script1, "%i", pj->madewith );
		line--; if ( line == 0 ) strcpy((char*) script1, "Creator" );
		line--; if ( line == 0 ) strcpy(script1, pj->creator );

	}
	if ( type == 2 )
	{
		P_CHAR pc_j = FindCharBySerial(serial);
		if (pc_j == NULL)
			return;
		line--; if ( line == 0 ) strcpy( script1, "Name" );
		line--; if ( line == 0 ) strcpy( script1,  pc_j->name );
		line--; if ( line == 0 ) strcpy( script1, "Title" );
		line--; if ( line == 0 ) strcpy( script1,  pc_j->title );
		line--; if ( line == 0 ) strcpy( script1, "X" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->pos.x );
		line--; if ( line == 0 ) strcpy( script1, "Y" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->pos.y );
		line--; if ( line == 0 ) strcpy( script1, "Z" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->pos.z );
		line--; if ( line == 0 ) strcpy( script1, "Direction" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->dir );
		line--; if ( line == 0 ) strcpy( script1, "Body" );
		line--; if ( line == 0 ) sprintf( script1,"(0x%x) %i", pc_j->id(), pc_j->id() );
		line--; if ( line == 0 ) strcpy( script1, "Skin" );
		line--; if ( line == 0 ) sprintf( script1, "(0x%x) %i", pc_j->skin, pc_j->skin );
		line--; if ( line == 0 ) strcpy( script1, "Defence" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->def );
		line--; if ( line == 0 ) strcpy( script1, "Hunger" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->Hunger() );
		line--; if ( line == 0 ) strcpy( script1, "Strength" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->realStr() );
		line--; if ( line == 0 ) strcpy( script1, "Dexterity" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->realDex() );
		line--; if ( line == 0 ) strcpy( script1, "Intelligence" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->realInt() );
		line--; if ( line == 0 ) strcpy( script1, "Karma" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->karma );
		line--; if ( line == 0 ) strcpy( script1, "Fame" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->fame );
		line--; if ( line == 0 ) strcpy( script1, "Kills" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->kills );
		line--; if ( line == 0 ) strcpy( script1, "Jail time" );
		line--; if ( line == 0 ) sprintf( script1,"%i", pc_j->jailtimer.getRemainingSecs() );
		
	}
	line--; if ( line == 0) strcpy( script1, "}");
}


void tweakmenu(UOXSOCKET s, SERIAL serial)
{
	char sect[512];
	short int length, length2, textlines;
	unsigned int i;
	int line,loopexit=0;

	char type;
	if (isCharSerial(serial))
		type = 2;
	else
		type = 1;


	length=21;
	length2=1;
	line=0;

	do
	{
		line++;
		tline(line, serial);
		if (script1[0]!='}')
		{
			length+=strlen(script1)+4;
			length2+=strlen(script1)+4;
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	length+=3;
	textlines=0;
	line=0;


	loopexit=0;
	do
	{
		line++;
		ttext(line, serial);
		if (script1[0]!='}')
		{
			length+=(strlen(script1)*2)+2;
			textlines++;
		}
	}
	while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );


	unsigned char gump1[21]={0,};
	unsigned char gump2[3]={0,};
	unsigned char gump3[2]={0,};

	LongToCharPtr(serial, &gump1[3]);
	gump1[10]=type; // Gump Number
	gump1[19]=length2>>8;
	gump1[20]=length2%256;

	XStartPkt(0xb0, length);
	XAddPkt(&gump1[0+3], 21-3);

	line=0;

	loopexit=0;
	do
	{
		line++;
		tline(line, serial);
		if (script1[0]!='}')
		{
			sprintf(sect, "{ %s }", script1);
			XAddPkt((unsigned char*)&sect[0], strlen(sect));
		}
	}
	while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );

	gump2[1]=textlines>>8;
	gump2[2]=textlines%256;
	XAddPkt(&gump2[0], 3);
	line=0;

	loopexit=0;
	do
	{
		line++;
		ttext(line, serial);
		if (script1[0]!='}')
		{
			gump3[0]=strlen(script1)>>8;
			gump3[1]=strlen(script1)%256;
			XAddPkt(&gump3[0], 2);
			gump3[0]=0;
			for (i=0;i<strlen(script1);i++)
			{
				gump3[1]=script1[i];
				XAddPkt(&gump3[0], 2);
			}
		}
	}
	while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );

	XFinishPkt(s);
}

void entrygump(int s, SERIAL serial, unsigned char type, char index, short int maxlength, char *text1)
{
	short int length;
	unsigned char textentry1[12]="\xAB\x01\x02\x01\x02\x03\x04\x00\x01\x12\x34";
	unsigned char textentry2[9]="\x01\x01\x00\x00\x12\x34\x12\x34";
	
	sprintf(temp, "(%i chars max)", maxlength);
	length=11+strlen((char*)text1)+1+8+strlen(temp)+1;

	LongToCharPtr(serial, (unsigned char*)textentry1+3);
	textentry1[7]=type;
	textentry1[8]=index;
	textentry1[9]=(strlen(text1)+1)>>8;
	textentry1[10]=(strlen(text1)+1)%256;

	XStartPkt(0xAB, length);
	XAddPkt(&textentry1[0+3], 11-3);

	XAddPkt((unsigned char*)&text1[0], strlen(text1)+1);

	textentry2[4]=maxlength>>8;
	textentry2[5]=maxlength%256;
	textentry2[6]=(strlen(temp)+1)>>8;
	textentry2[7]=(strlen(temp)+1)%256;

	XAddPkt(&textentry2[0], 8);
	XAddPkt((unsigned char*)&temp[0], strlen(temp)+1);

	XFinishPkt(s);

}


void choice(int s) // Choice from GMMenu, Itemmenu or Makemenu received
{ // This routine is changed by Magius(CHE) to add Rank_system!
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int main, sub,loopexit=0;
	char sect[512];
	int i,scp_num;
	char lscomm[512],lsnum[512];  // Magius(CHE) for Rank-System
	Script * Scp;
	main=(buffer[s][5]<<8)+buffer[s][6];
	sub=(buffer[s][7]<<8)+buffer[s][8];
	
    //clConsole.send("main:%i sub:%i \n",main,sub);
	// if ((main!=0) && (sub==0)) clConsole.send("add menu (gm menu) closed- including its submenus\n");

	if ((main>=8000)&&(main<=8100)) Guilds->GumpChoice(s,main,sub);
	
	if ( (main&0xFF00)==0xFF00)
	{
		if (im_choice(s, main, sub)==0) return;
	}

	if (main>1246 && main<1259)
	{
		Skills->DoPotion(s, main-1246, sub, FindItemBySerial(getAddid1_4(s)));
		return;
	}
	else if (main<ITEMMENUOFFSET) // GM Menus
	{
		sprintf(sect, "GMMENU %i", main);
		scp_num =menus_script;
	}
	else if ((main>=5256) && (main<8192)) // Tracking fix 12-30-98
	{
		sprintf(sect, "ITEMMENU %i", main-256);
		scp_num = items_script;
	}
	else if (main>=ITEMMENUOFFSET && main<MAKEMENUOFFSET)
	{
		sprintf(sect, "ITEMMENU %i", main-ITEMMENUOFFSET);
		scp_num = items_script;
	}
	else if (main>=MAKEMENUOFFSET && main<TRACKINGMENUOFFSET)
	{
		if (sub<=0) return; // cancled menu
		sprintf(sect, "MAKEMENU %i", main-MAKEMENUOFFSET);
		scp_num =create_script;
	}// PolyMorph spell menu (scriptable) by AntiChrist (9/99)
	else if (main>=POLYMORPHMENUOFFSET && main<POLYMORPHMENUOFFSET+50)
	{
		if (sub<=0) return; // cancled menu, return !
		OldMagic->Polymorph(s,POLYMORPHMENUOFFSET,sub);
		return;
	}
	else // Tracking
	{
		if ((main-TRACKINGMENUOFFSET)>=TRACKINGMENUOFFSET+1&&(main-TRACKINGMENUOFFSET)<=TRACKINGMENUOFFSET+3)
		{
			if (!sub) return;
			if (!Player->checkSkill(TRACKING))
			{
				sysmessage(s,"You fail your attempt at tracking.");
				return;
			}
			Skills->TrackingMenu(s,sub-1);
		}
		sprintf(sect, "TRACKINGMENU %i", main-TRACKINGMENUOFFSET);
		scp_num = tracking_script;
	}
	Scp=i_scripts[scp_num];
	if (scp_num==items_script)
	{
		Scp=Scp->Select(sect,custom_item_script);
		if (!Scp) return;
	}
	else{ 
		Scp->Open();
		if (!Scp->find(sect)) return;
	}
	Scp->NextLine();
	Scp->NextLineSplitted();
	i=0;
	loopexit=0;
	
	do
	{
		if (!Scp->EndSect())
		{
			i++;
			if (main>=MAKEMENUOFFSET && main<TRACKINGMENUOFFSET)
			{
				Scp->NextLineSplitted();
				itemmake[s].needs=str2num(script2);
				
				Scp->NextLineSplitted();
				itemmake[s].minskill=str2num(script2);
				itemmake[s].maxskill=itemmake[s].minskill*SrvParms->skilllevel;
				// clConsole.send("needs %i, has %i\nskillneed %i, skillhas %i\n",itemmake[s].need,itemmake[s].has,itemmake[s].minskill,Player->skill[Player->making]);
				// Duke: we must count with the same criteria as in MakeMenu() !
				if (    itemmake[s].has<itemmake[s].needs
					|| (itemmake[s].has2 && itemmake[s].has2<itemmake[s].needs)
					|| Player->Skill(Player->making) < itemmake[s].minskill)
					i--;    // skip this item
			}
			Scp->NextLineSplitted();
			strcpy(lscomm,script1);
			strcpy(lsnum,script2);
			itemmake[s].number=str2num(script2);
			Scp->NextLineSplitted();
			if (!Scp->CmpTok1("RANK"))
			{
				gettokennum(script2, 0);
				itemmake[s].minrank=str2num(gettokenstr);
				gettokennum(script2, 1);
				itemmake[s].maxrank=str2num(gettokenstr);
				Scp->NextLineSplitted();		// found a rank line, so read one more
			} else
			{ // Set maximum rank if the item is not ranked!
				itemmake[s].minrank=itemmake[s].maxrank=10;
			}
			if (SrvParms->rank_system==0)
			{
				itemmake[s].minrank=itemmake[s].maxrank=10;
			}			

			if (i==sub)
			{
				Scp->Close();

				if (!strcmp("ADDITEM", lscomm))	// bughunting, Duke, 5.6.2003
					LogAssert(itemmake[s].maxskill!=0);

				scriptcommand(s, ( char*)lscomm,( char*)lsnum);			
				if (itemmake[s].maxskill<200) itemmake[s].maxskill=200;
			}
		}
	}
	while (!Scp->EndSect() &&(i!=sub) && (++loopexit < MAXLOOPS));
	if (i!=sub) Scp->Close(); 
}

void gmmenu(int s, int m) // Open one of the gray GM Call menus
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int total, i;
	int lentext;
	char sect[512];
	static char gmtext[255][257];
	int gmnumber=0;
	int gmindex,loopexit=0;
	
	openscript("menus.scp");
	sprintf(sect, "GMMENU %i", m);
	if (!i_scripts[menus_script]->find(sect))
	{
		closescript();
		return;
	}
	gmindex=m;
	read1();
	lentext=sprintf(gmtext[0], "%s", script1);

	loopexit=0;
	do
	{
		read1();
		if (script1[0]!='}')
		{
			gmnumber++;
			strncpy(gmtext[gmnumber], script1, 256);
			read1();
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	closescript();
	total=9+1+lentext+1;
	for (i=1;i<=gmnumber;i++)
	{
		total+=4+1+strlen(gmtext[i]);
	}

	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};
	
	LongToCharPtr(Player->serial,&gmprefix[3]);

	gmprefix[7]=gmindex>>8;
	gmprefix[8]=gmindex%256;

	XStartPkt(0x7c, total);
	XAddPkt(&gmprefix[0+3], 9-3);

	XAddPkt((unsigned char*)&lentext, 1);
	XAddPkt((unsigned char*)&gmtext[0], lentext);

	lentext=gmnumber;

	XAddPkt((unsigned char*)&lentext, 1);

	for (i=1;i<=gmnumber;i++)
	{
		gmmiddle[0]=(i-1)>>8;
		gmmiddle[1]=(i-1)%256;

		XAddPkt(&gmmiddle[0], 4);

		lentext=strlen(gmtext[i]);

		XAddPkt((unsigned char*)&lentext, 1);
		XAddPkt((unsigned char*)&gmtext[i], lentext);
	}

	XFinishPkt(s);
}

void itemmenu(int s, int m) // Menus for item creation
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int total, i;
	int lentext;
	char sect[512];
	static char gmtext[255][257]; // crashfix LB, was 30 !!!, increased to 255
	int gmid[255]; // crashifx LB
	int gmnumber=0;
	int gmindex,loopexit=0;
	Script * Scp=i_scripts[items_script];
	sprintf(sect, "ITEMMENU %i", m);
	Scp=Scp->Select(sect,custom_item_script);
	if (!Scp) return;
	gmindex=m;
	
	////////////////////////////////////////////////


	Scp->NextLine();
	strcpy(gmtext[0], script1);
	Scp->NextLineSplitted();
	while ( !Scp->EndSect() && (++loopexit < MAXLOOPS) )
	{
			gmnumber++;
			gmid[gmnumber]=hstr2num(script1);
			strcpy(gmtext[gmnumber], script2);
			Scp->NextLine();//jumps the itemmenu link
			Scp->NextLineSplitted();
	}
	Scp->Close();
	sprintf(temp, "%i: %s", m, gmtext[0]);
	lentext=sprintf(gmtext[0], "%s", temp);
	total=9+1+lentext+1;
	for (i=1;i<=gmnumber;i++)
	{
		total+=4+1+strlen(gmtext[i]);
	}

	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};

	LongToCharPtr(Player->serial,&gmprefix[3]);
	gmprefix[7]=(gmindex+ITEMMENUOFFSET)>>8;
	gmprefix[8]=(gmindex+ITEMMENUOFFSET)%256;

	XStartPkt(0x7c, total);
	XAddPkt(&gmprefix[0+3], 9-3);

	XAddPkt((unsigned char*)&lentext, 1);
	XAddPkt((unsigned char*)gmtext[0], lentext);

	lentext=gmnumber;

	XAddPkt((unsigned char*)&lentext, 1);

	for (i=1;i<=gmnumber;i++)
	{
		gmmiddle[0]=gmid[i]>>8;
		gmmiddle[1]=gmid[i]%256;

		XAddPkt(&gmmiddle[0], 4);

		lentext=strlen(gmtext[i]);

		XAddPkt((unsigned char*)&lentext, 1);
		XAddPkt((unsigned char*)&gmtext[i], lentext);
	}

	XFinishPkt(s);

}

void cGump::Open(int s, int serial, int num1, int num2)
{
	unsigned char shopgumpopen[8]="\x24\x00\x00\x00\x01\x00\x30";
	LongToCharPtr(serial,&shopgumpopen[1]);
	shopgumpopen[5]=num1;
	shopgumpopen[6]=num2;

	XStartPkt(0x24,7);
	XAddPkt(&shopgumpopen[0+1], 7-1);
	XFinishPkt(s);
}
