/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "html.h"
#include "accounts.h"
#include "Client.h"
#include "utilsys.h"
#include "verinfo.h"

#include "wolfpack.h"
#include "debug.h"
#undef  DBGFILE
#define DBGFILE "html.cpp"

extern void pdump(UOXSOCKET s, char type, FILE* file);

void offlinehtml()//HTML
{
	char hfile[512];
	unsigned int total,hr,min,sec,loopexit=0; //bugfix LB
	FILE *html;
	
	total=(uiCurrentTime-starttime)/MY_CLOCKS_PER_SEC;
	hr=total/3600;
	total-=hr*3600;
	min=total/60;
	total-=min*60;
	sec=total;

	Script* Scp = findSection(html_script,"OFFLINE_PAGE");
	if (!Scp) return;

	Scp->NextLineInSection();
	strcpy(hfile, script1);
	html = fopen(hfile, "w");
	if (html == NULL) // LB
	{ 
		LogWarning("Could not create html file, plz check html.scp"); 
		Scp->Close();
		return;
	}

	while (Scp->NextLineSplitted() && (++loopexit < MAXLOOPS) )
	{
		if (!strcmp(script1,"LINE")) fprintf(html,"%s\n",script2);
		else if (!strcmp(script1,"TIME")) fprintf(html,(getRealTimeString()).c_str());
		else if (!strcmp(script1,"UPTIME")) fprintf(html,"%2.2i:%2.2i:%2.2i",hr,min,sec);
	}

	fclose(html);
	Scp->Close();
}

void updatehtml()//HTML
{
	char hfile[512],sh[3],sm[3],ss[3];
	int a;
	unsigned int n=0;
	int gm=0,cns=0,ccount=0,icount=0,npccount=0,loopexit=0;
	FILE *html;

	Script* Scp = findSection(html_script,"ONLINE_PAGE");
	if (!Scp) return;

	Scp->NextLineInSection();
	strcpy(hfile, script1);

	html=fopen(hfile,"w");	// remove old one first 
	if (html == NULL) // LB
	{ 
		LogWarning("Could not create html file, please check html.scp");
		Scp->Close();
		return;
	}

	while (Scp->NextLineSplitted() && (++loopexit < MAXLOOPS) )
	{
		if (!strcmp(script1,"LINE")) fprintf(html,"%s\n",script2);
		else if (!strcmp(script1,"TIME")) fprintf(html,"%s <BR>",(getRealTimeString()).c_str());
		else if (!strcmp(script1,"NOW"))
		{
			P_CHAR pc = MAKE_CHAR_REF(currchar(n));
			if (pc)
			{
				if (pc->InGame()) //bugfix LB
				{
					fprintf(html,pc->name);
					n++;
				}
			}
		}
		else if (!strcmp(script1,"WHOLIST"))
		{
			a=0;
			for (n=0;n<now;n++)
			{ 
				P_CHAR pc = MAKE_CHAR_REF(currchar(n));
				if (!pc) continue;
				if (pc->InGame()) // bugfix, LB
				{
					a++;
					fprintf(html,"%i) %s <BR>\n",a,pc->name); // bugfix lb
				}
			}
		}
		else if (!strcmp(script1,"NOWNUM")) fprintf(html,"%i",now);
		else if (!strcmp(script1,"ACCOUNTNUM")) fprintf(html,"%i",Accounts->Count());
		else if (!strcmp(script1,"CHARCOUNT"))
		{
			if (ccount==0)
			{
				npccount=0;
				P_CHAR toCheck;
				AllCharsIterator aci;
				for (aci.Begin(); (toCheck=aci.GetData()) != NULL; aci++)
				{
					ccount++;
					if (toCheck->npc) 
						npccount++;
				}
			}
			fprintf(html,"%i",ccount);
		}
		else if (!strcmp(script1,"NPCS"))
		{
			if (npccount==0)
			{
				ccount=0;
				P_CHAR toCheck;
				AllCharsIterator aci;
				for (aci.Begin(); (toCheck=aci.GetData()) != aci.End(); aci++)
				{
					ccount++;
					if (toCheck->npc) 
						npccount++; //bugfix LB
				}
			}
			fprintf(html,"%i",npccount);
		}
		else if (!strcmp(script1,"ITEMCOUNT")) 
		{
			icount=0;
			PC_ITEM pi;
			AllItemsIterator aii;
			for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
			{
				icount++;
			}
			fprintf(html,"%i",icount);
		}
		else if (!strcmp(script1,"UPTIME"))
		{
			unsigned long int total,hr,min,sec; // bugfix, LB
			total=(uiCurrentTime-starttime)/MY_CLOCKS_PER_SEC;
			hr=total/3600;
			if (hr<10 && hr<=60) sprintf(sh,"0%lu",hr);
			else sprintf(sh,"%lu",hr);
			total-=hr*3600;
			min=total/60;
			if (min<10 && min<=60) sprintf(sm,"0%lu",min);
			else sprintf(sm,"%lu",min);
			total-=min*60;
			sec=total;
			if (sec<10 && sec <=60) sprintf(ss,"0%lu",sec);
			else sprintf(ss,"%lu",sec);
			fprintf(html,"%s:%s:%s",sh,sm,ss);	
		}
		else if (!strcmp(script1,"IP"))
		{	
			fprintf(html, serv.sIP.c_str());
		}
		else if (!strcmp(script1,"GMNUM"))
		{
			if (gm==0)
			{
				P_CHAR pc;
				AllPlayersIterator api;
				for (pc = api.First(); pc != NULL; pc = api.Next())
				{
				   if (pc->isGM() ) gm++;
				   else if (pc->isCounselor()) cns++; //bugfix LB
				}
			}
			fprintf(html,"%i",gm);
		}
		else if (!strcmp(script1,"CNSNUM"))
		{
			if (cns==0)
			{
				P_CHAR pc;
				AllPlayersIterator api;
				for (pc = api.First(); pc != NULL; pc = api.Next())
				{
				   if (pc->isGM() ) gm++;
				   else if (pc->isCounselor()) cns++; //bugfix LB
				}
			}
			fprintf(html,"%i",cns);
		}
		else if (!strcmp(script1,"PDUMP")) 
		{
			pdump(-1, 3, html);
		}
		else if (!strcmp(script1,"SIMCYC")) // bugfix LB
		{
			pdump(-1,4,html);
		}
		else if (!strcmp(script1,"UDTIME")) fprintf(html,"%f",(float)(SrvParms->html/60));
		
		else if (!strcmp(script1,"VER"))
		{
			fprintf(html,"%s %s ", wp_version.betareleasestring.c_str(), wp_version.verstring.c_str() );
            #ifndef __unix__
		    fprintf(html,"[WIN32]");
            #elif !defined(__linux__)
		    fprintf(html,"[BSD]");		
            #else
		    fprintf(html,"[LINUX]");
            #endif
		}
	}
	
	fclose(html);
	Scp->Close();
}


