/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __ITEMS_H__
#define __ITEMS_H__

#include <string>
#include "coord.h"
class cRectangle;
#include "timers.h"
#include "typedefs.h"
#include "inlines.h"

using namespace std ;

enum ePotionTypes
{
	POTION_None=0,
	POTION_AGILITY=1,
	POTION_CURE=2,
	POTION_EXPLOSION=3,
	POTION_HEAL=4,
	POTION_NIGHTSIGHT=5,
	POTION_POISON=6,
	POTION_REFRESH=7,
	POTION_STRENGTH=8,
	POTION_MANA=9,
	POTION_LSD=10,
	POTION_ALC=11,
	POTION_SHRINK=12,
	POTION_EXPLODING=13, // temporary type while explosion potion is about to explode, required to awoid double explosions in chain reactions
	POTION_LAST=14
};

enum eItemTypes
{
	ITY_None=0,
	ITY_Container=1,
	ITY_2=2,
	ITY_3=3,
	ITY_4=4,
	ITY_5=5,
	ITY_6=6,
	ITY_Key=7,
	ITY_LockedContainer=8,
	ITY_SpellBook=9,
	ITY_NecroBook=35,
	ITY_PaladinBook=36,
	ITY_RegularSpellScroll=37,
	ITY_NecroSpellScroll=38,
	ITY_PaladinSpellScroll=39,
	ITY_Reagent=40,
	ITY_Map=10,
	ITY_Book=11,
	ITY_Door=12,
	ITY_LockedDoor=13,
	ITY_Food=14,
	ITY_CastingItem=15, // ???
	ITY_Ankh=16,
	ITY_filledMortar=17,
	ITY_18=18,
	ITY_Potion=19,
	ITY_Campfire=45,
	ITY_Rune=50,
	ITY_Gate1=51,
	ITY_Gate2=52,
	ITY_60=60,
	ITY_ItemSpawner=61,
	ITY_NpcSpawner=62,
	ITY_SpawnChest=63,
	ITY_LockedSpawnChest=64,
	ITY_65=65,
	ITY_66=66,
	ITY_NpcAreaSpawner=69,
	ITY_RuneBook=70,
	ITY_TrvGate=71,
	ITY_80=80,
	ITY_81=81,
	ITY_MonsterGate=82,
	ITY_84=84,
	ITY_DamageObj=85,
	ITY_SoundObj=86,
	ITY_Trashbin=87,
	ITY_88=88,
	ITY_100=100,
	ITY_101=101,
	ITY_102=102,
	ITY_103=103,
	ITY_Teleporter=104,
	ITY_Drink=105,
	ITY_Boat=117,
	ITY_BoatModel=118,
	ITY_QuestSpawn=125,
	ITY_FireworksWand=181,
	ITY_SmokeObj=185,
	ITY_RenameDeed=186,
	ITY_GuildStone=202,
	ITY_Sign=203,
	ITY_VendorDeed=217,
	ITY_VendorDeedWithoutHouse=218,
	ITY_TownHouse=220,
	ITY_TownHouseDeed=222,
	ITY_ShipPlan=230,
	ITY_ShipYard=231,
	ITY_ShipPart=232,
	ITY_EmptyMap=300,
	ITY_TatteredMap=301,
	ITY_DecipheredMap=302,
	ITY_NPCITEM=307,
	ITY_SHRUNKNPC=308,
	ITY_POTIONKEG=327,
	ITY_POTIONKEG_PROTECTED=372,
	ITY_JailBall=401,
	ITY_ReputationBall=402,
	ITY_IDwand=404,
	ITY_BankDeed=405,
	ITY_Last=1111
};

// hardcoded Script Numbers for Items
#define SNI_Key			339
#define SNI_3185		3185	// slotmachine
#define SNI_3186		3186
#define SNI_3187		3187
#define SNI_2003		2003
#define SNI_2004		2004
#define SNI_2005		2005
#define SNI_2006		2006
#define SNI_2007		2007
#define SNI_OrderShield	29
#define SNI_ChaosShield	28
#define SNI_Deciphered	70025	// treasure map
#define SNI_BallOfJustice	50040	// crystal ball of justice
#define SNI_TreasureChestL1	15109	// treasure lvl 1


// new food system flags (thrawn)
#define FOOD_MEAT		1
#define FOOD_FISH		2
#define FOOD_CHEESE		4
#define FOOD_FRUIT		8
#define FOOD_VEGETABLE	16
#define FOOD_BAKED		32
#define FOOD_RAW		64
#define FOOD_MAGIC		128
// end new food system


class cItem
{
protected:
	int index;					// this item's inx in the allitems array
	bool archive;				// item has been modified and needs saving if 'true' (for future use, Duke)
	unsigned short _color;
public:
	int serial;					// Item serial number
	int qsf;					// QSF-id
	
	unsigned char id1;			// Item visuals as stored in the client
	unsigned char id2;
	unsigned short amount;		// Amount of items in pile
	unsigned short amount2;		// Used to track things like number of yards left in a roll of cloth
	unsigned char free;
	cCoord pos;

	struct					     // Attention, this is a bit field
	{
		bool isBeeingDragged :1; // true while the item hangs on the mouse cursor
	} flags;

	char name[50];
	char name2[50];
	int contserial;
	int multis;                 // Multi serial
	signed char layer;          // Layer if equipped on paperdoll
	int itmhand;                // ITEMHAND system - AntiChrist
	eItemTypes type;            // For things that do special things on doubleclicking
	unsigned int type2;	        // damn multi purpose field :(
			                    // 1. subtype for plank
			                    // 2. movement for boats
			                    // 3. backup type for enchanted weapons

	cCoord oldpos;

	long oldcontserial;         //Old contserial - used for bouncing bugfix - Antichrist
	signed char oldlayer;       // Old layer - used for bouncing bugfix - AntiChrist

	char offspell;
    int weight;
    unsigned char more1;        // For various stuff -> god-damn multi purpose variables :((((
    unsigned char more2;
    unsigned char more3;
    unsigned char more4;
    char moreb1;
    char moreb2;
    char moreb3;
    char moreb4;
    unsigned int morex;
    unsigned int morey;
    unsigned int morez;
    char doordir;         // Reserved for doors
    char dooropen;
    char pileable;        // Can item be piled
    char dye;             // Reserved: Can item be dyed by dye kit
    char corpse;          // Is item a corpse
    unsigned int att;     // Item attack
    unsigned int def;     // Item defense
    int lodamage;         // Minimum Damage weapon inflicts
    int hidamage;         // Maximum damage weapon inflicts
    unsigned int racehate; // Race # that weapon does x2 damage to -Fraz-
    int hp;               // Number of hit points an item has.
    int maxhp;            // Max number of hit points an item can have.
    int st;               // The strength needed to equip the item
    int st2;              // The strength the item gives
    int dx;               // The dexterity needed to equip the item
    int dx2;              // The dexterity the item gives
    int in;               // The intelligence needed to equip the item
    int in2;              // The intelligence the item gives
    int spd;              // The speed of the weapon
    int secureIt;         // secured chests
    int wipe;             // Should this item be wiped with the /wipe command
    unsigned char magic;  // 0=Default as stored in client, 1=Always movable, 2=Never movable, 3=Owner movable, 4=Locked Down
    unsigned int gatetime;
    int gatenumber;
    cTimer decaytimer; 
    int ownserial;
    unsigned char visible; // 0=Normally Visible, 1=Owner & GM Visible, 2=GM Visible
    int spawnserial;
    unsigned char dir;
	int lockdownmax;		// Max lockdown items in houses. Ripper
	int securemax;			// Max secure chests in houses. Ripper

protected:
	unsigned char priv;   // Bit 0, decay off/on.  Bit 1, newbie item off/on.  Bit 2 Dispellable
	
public:
	inline int getPriv() const	{return priv;}
	inline void setPriv(int p)	{priv=p;}
	inline void resetPriv()		{priv=0;}
	inline bool decays()		{return priv&1;}
	inline void decayOn()		{priv |= 1;}
	inline void decayOff()		{priv &= 0xFE;}
	inline bool newbie()		{return (priv&2) > 0;}
	inline void newbieOn()		{priv |= 2;}
	inline void newbieOff()		{priv &= 0xFD;}
	inline bool dispellable()	{return (priv&4) > 0;}
	inline void dispellableOn()	{priv |= 4;}
	inline void dispellableOff(){priv &= 0xFB;}
	
	int value;             // Price shopkeeper sells item at.
	int restock;           // Number up to which shopkeeper should restock this item
	int trigger;           // Trigger number that item activates
	int trigtype;          // Type of trigger
	int trigon;            // New trigger for items -Frazurbluu-
	unsigned int disabled; // Item is disabled, cant trigger.
	int tuses;             // Number of uses for trigger
	class cTriggerInfo
	{
	public:
		char disabledmsg[128]; // Item is disabled, so display this message. -- added by Magius(CHE) 
	} *TrigInf;
	cTriggerInfo* GetTrigInf();
	unsigned int poisoned; // AntiChrist -- for poisoning skill
	int  Poisoned()	const	{return poisoned;}
	char murderer[50];     // AntiChrist -- for corpse -- char's name who kille the char (forensic ev.)
	long int murdertime;   // AntiChrist -- for corpse -- when the people has been killed
	int rank;              // Magius(CHE) --- for rank system, this value is the LEVEL of the item from 1 to 10. Simply multiply the rank*10 and calculate the MALUS this item has from the original.
		                  // for example: RANK 5 ---> 5*10=50% of malus
		                  // this item has same values decreased by 50%..
		                  // RANK 1 ---> 1*10=10% this item has 90% of malus!
		                  // RANK 10 --> 10*10=100% this item has no malus! RANK 10 is automatically setted if you select RANKSYSTEM 0.
		                  // Vars: LODAMAGE,HIDAMAGE,ATT,DEF,HP,MAXHP

   char creator[50];      // Store the name of the player made this item -- Magius(CHE)
   int good;              // Store type of GOODs to trade system! (Plz not set as UNSIGNED)  --- Magius(CHE)
   int rndvaluerate;      // Store the value calculated base on RANDOMVALUE in region.scp. ---- MAgius(CHE) (2)
   int madewith;          // Store the skills used to make this item -- Magius(CHE)
                          // Note by Magius: Value range to -ALLSKILLS-1 to ALLSKILLS+1
                          //    To calculate skill used to made this item:
                          //       if is a positive value, substract 1 it.
                          //          Ex) madewith=34 , 34-1=33 , 33=STEALING
                          //       if is a negative value, add 1 from it and invert value.
                          //          Ex) madewith=-34 , -34+1=-33 , Abs(-33)=33=STEALING.
                          //       0 = NULL
                          //    So... a positive value is used when the item is made by a
                          //       player with 95.0+ at that skill. Infact in this way when
                          //       you click on the item appear its name and the name of the
                          //       creator. A Negative value if the player is not enought
                          //       skilled!
 
   int glow;              // LB identifies glowing objects
   short glow_color;		// for backup of old color
   char glow_effect; 

   char desc[100];

   int carve;                         // AntiChrist - for new carve system
   bool incognito;                    // AntiChrist - for items under incognito effect
   unsigned long int time_unused;     // LB -> used for house decay and possibly for more in future, gets saved
   unsigned long int timeused_last;   // helper attribute for time_unused, doesnt get saved
   int spawnregion;

   class cTownHouseInfo
	{
	public:
		cRectangle* area;
		cCoord* door1;
		cCoord* door2;
		cCoord* sign;
		cTownHouseInfo() {area=NULL;door1=NULL;door2=NULL;sign=NULL;}
	}* thi;

	void SetIndex(int i);
	int	 GetIndex() const;
	void Init(bool mkser=1);
	void setSerialOnly(int ser);
	void setSerial(int ser);

	void setContSerialOnly(int contser);
	bool SetContSerial(int contser);
	bool Contains(PC_ITEM pi) const;
	bool ContainsSub(P_ITEM pi);
	void SetContainer(P_ITEM Cont);

	void setOwnSerialOnly(int ownser);
	bool SetOwnSerial(int ownser);
	long GetOwnSerial()	const {return ownserial;}

	bool SetSpawnSerial(int spawnser);
	bool SetMultiSerial(int mulser);

	void setColor(short col);
	void setId(short id);
	inline bool isInWorld()		const	{return (contserial==-1);}
	inline bool IsWorn()		const	{return isCharSerial(contserial);}
	inline bool isSameAs(PC_ITEM pi) const {if (!pi || pi->serial != serial) return false; else return true;}
	inline short id()			const	{return (short)((id1<<8)+id2);}
	inline bool isMulti()		const	{return id() >= 0x4000;}

	inline short color()		const	{return _color;}
	void	setMore1_4(int n);
	void	setMore1_2(int n);
	void	setMore3_4(int n);
	void	setMoreB1_4(int n);
	void	setMoreB1_2(int n);
	void	setMoreB3_4(int n);
	int		getMore1_4() const;
	short	getMore1_2() const;
	short	getMore3_4() const;
	int		getMoreB1_4() const;
	short	getMoreB1_2() const;
	short	getMoreB3_4() const;

	void MoveTo(const cCoord& pos);
	void MoveTo2(const cCoord& pos);
	void MoveTo(int newx, int newy, signed char newz);
	void MoveTo(cCoord& npos, int offx, int offy=0, signed char offz=0);
	long ReduceAmount(const long amount);
	short GetContGumpType();
	void SetRandPosInCont(cItem* pCont);
	bool PileItem(cItem* pItem);
	bool ContainerPileItem(cItem* pItem);	                                // try to find an item in the container to stack with
	bool AddItem(cItem* pItem, short xx=-1, short yy=-1, bool sendit=true);	// Add Item to container
	int  CountItems(short ID= -1, short col= -1, short ty= -1) const;
	int  DeleteAmount(int amount, short id, short color=-1, short ty=-1);
	int getName(char* itemname);
	string getName(void);
	int getWeight();
	void startDecay();

	inline void setMovability(int m)	{this->magic=(m==3) ? 2:m;}		// force 'ownerMovable' to NotMovable'
	inline int  getMovability()	const   {return this->magic;}
	inline void setAllwaysMovable()	    {this->magic=1;}
	inline bool isAllwaysMovable() const{return (magic==1);}
	inline bool isOwnerMovable() const	{return (magic==3);}
	inline void setNotMovable()		    {this->magic=2;}
	inline bool isNotMovable() const	{return (magic==2);}
	inline void setLockedDown()			{this->magic |= 4;}
	inline void ResetLockedDown()		{this->magic &= 0xFB;}
	inline bool isLockedDown() const	{return ((magic&4) > 0);}
	inline void setOwnerMovable()       {this->magic=3;}

	inline int  getType()               {return this->type;}
	inline bool isType(eItemTypes t) const	{return (type==t);}
	inline bool isType(int t) const		{return type==(eItemTypes)t;}
	inline void setType(eItemTypes t)	{type=t;}
	inline void setType(int t)			{type=(eItemTypes)t;}
	bool isContainerType();
	bool IsSpawnerType();

	void refresh();
	int	 calcBuyPrice(short region);
	int	 calcSellPrice(short region, P_ITEM PlayersItem);
	P_ITEM Search(int *ci) const;
	int CountSpawnedItems() const;
	int CountSpawnedChars() const;
	void LockDown(int ownser);
	void ReleaseLockedDown();
	void TransferLockedDown(int newownser);
	bool WearOut();

	// new food system (thrawn)
protected:
	unsigned char foodtype;
public:
	char GetFoodType() {return foodtype;}
	void SetFoodType(char ftype) {foodtype  = ftype;}
	void AddFoodType(char ftype) {foodtype |= ftype;}
	void SubFoodType(char ftype) {foodtype &= (0xFF - ftype);}
	// end new food system
	P_ITEM unconst() const {P_ITEM p2=(P_ITEM)this; p2->archive=true; return p2;}
	bool HasChanged() const {return archive;}
};


#define MAKE_ITEM_REF(i)			Items->MakeRef(i)


class cAllItems
{
private:
	bool moreItemMemoryRequested;
	int  itemcount2;
	unsigned int  imem;
	int  errorIA;

	void GetScriptItemSetting(P_ITEM pi);
	unsigned char PackType(unsigned char id1, unsigned char id2);
	bool ResizeMemory();
	int  GetReusableSlot();
	int  MemItemFree();
public:
	cAllItems();
	int GetCount();
	int GetCapacity();
	P_ITEM MakeRef(int i);
	int GetNextFreeSerial();
	void DetermineHighestSerial(int ser);
	P_ITEM MakeBaseItem(bool newserial = true);
	P_ITEM CloneItem(P_ITEM Source);
	P_ITEM SplitPile(P_ITEM Pile, short amount);
	void DeleItem(P_ITEM pi);
	void FreeMemory();
	char isFieldSpellItem(P_ITEM pi);
	P_ITEM CreateFromScript(UOXSOCKET s, int itemnum);
	P_ITEM CreateScriptItem(int itemnum);
	P_ITEM CreateScriptItem(int s, int itemnum, int nSpawned);
	int  PickFromItemlist(char *sItemList);
	P_ITEM SpawnItem(UOXSOCKET s, P_CHAR pc, int nAmount, char* cName, int pileable,
					short id, short color,int nPack, int nSend);
	P_ITEM SpawnItem(CHARACTER ch,int nAmount, char* cName, char pileable, short id, short color, short nPack);
	P_ITEM SpawnItem(P_CHAR pc,   int nAmount, char* cName, char pileable, short id, short color, short nPack);
	P_ITEM SpawnItemBank(P_CHAR pc, int nItem);
	P_ITEM SpawnGoldInBank(P_CHAR pc, int amount);
	P_ITEM SpawnItemBackpack2(UOXSOCKET s, int nItem, int nDigging=0);
	void DecayItem(unsigned int currenttime, P_ITEM pi);
	void RespawnItem(unsigned int Currenttime, PC_ITEM pi);
	void AddRespawnItem(PC_ITEM Spawner, int x, bool inChest);
	void CheckMemoryRequest();
	bool AllocateMemory(int NumberOfItems);
	bool copyItemRawData(const cItem* const source, cItem* target); // copying ALL item data (xecpt serial) from source to target. currently only used for doppelgaenger AI subroutines. use with caution, dangerous.
	int ApplyCommonTags(P_ITEM pi);
	int ApplyWscTags(P_ITEM pi);
};

class AllItemsIterator
{
protected:
	unsigned int pos;
public:
	AllItemsIterator();
	~AllItemsIterator();
	void Begin();
	P_ITEM End();
	PC_ITEM GetData(void);
	AllItemsIterator& operator++(int);
};

#endif
