/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/*
*	WOLFPACK Magic stuff
*
*	Completed the restructuration by AntiChrist (9/99)
*	Functions' description added by AntiChrist (9/99)
*
*   UO:3D particle System implementation [and packet hacking]: Lord Binary 4/2001
*/

#include "magic.h"
#include "magic_new.h"

#include "boats.h"
#include "guilds.h"
#include "house.h"
#include "itemid.h"
#include "LoS.h"
#include "mapstuff.h"
#include "regions.h"
//#include "skills.h"
#include "SndPkg.h"
#include "sregions.h"
#include "TmpEff.h"
#include "weight.h"
#include "mapS.h"
#include "tiledata.h"
#include "network.h"

#include "wolfpack.h"

#include "debug.h"
#undef DBGFILE
#define DBGFILE "magic.cpp"
#define NOTUSED 0



/////////////////////////////////////////////////////////////////
/// INDEX:
//		- misc magic functions
//		- NPCs casting spells related functions
//		- ITEMs magic powers related funcions
//		- PCs casting spells related functions
/////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////
/////// MISC MAGIC FUNCTIONS ////////////////////////////////////
/////////////////////////////////////////////////////////////////


///////////////////
// Name:	InitSpells
// History:	AntiChrist, 11 September 1999
// Purpose:	Initialize magery system. Parse spells.scp and store spells data.
//

struct spell_st
{
	int enabled;		// spell enabled?
	int circle;			// circle number
	int mana;			// mana requirements
	int loskill;		// low magery skill req.
	int hiskill;		// high magery skill req.
	int sclo;			// low magery skill req. if using scroll
	int schi;			// high magery skill req. if using scroll
	char mantra[25];	// words of power
	int action;			// character action
	int delay;			// spell delay
	reag_st reagents;	// reagents req.
	char strToSay[100];// string visualized with targ. system
	int reflect;		// 1=spell reflectable, 0=spell not reflectable
	unsigned char runic;
};

CArray<70, spell_st>spells("spells");

class cOldSpell
{
	int spnum;
	struct spell_st* spi;
	int flags;
public:
	cOldSpell(struct spell_st* spellinfo,int n) {spnum=n;spi = spellinfo;flags=0;}
//	void SetFlags(int f)	{this->flags=f;}
	bool IsEnabled()		{return (this->spi->enabled > 0);}
	bool IsReflectable()	{return (this->spi->reflect > 0);}
	bool RequiresTarget()	{return OldMagic->requireTarget(this->spnum);}
	bool RequiresLocationTarget()	{return OldMagic->reqLocTarget(this->spnum);}
	bool IsTravelSpell()	{return (this->spnum==32 || this->spnum==45 || this->spnum==52);}	// recall, mark & gate
	bool RequiresItemTarget(){return (spnum==13 || spnum==14 || spnum==19 || spnum==23);}	// Magic Trap/Untrap/Lock/Unlock
	int GetMinSkill()		{return this->spi->loskill;}
	int GetMaxSkill()		{return this->spi->hiskill;}
	int GetMana()			{return this->spi->mana;}
	int GetAction()			{return this->spi->action;}
	int GetDelay()			{return this->spi->delay;}
};

CArray<70, cOldSpell*>spp("spp");	// array of spellpointers
cOldSpell* getSpell(int number) {return spp[number];}

int cOldMagic::InitSpells(void)
{
	int curspell = 0; // current spell
	
	openscript("spells.scp");
	// if (!i_scripts[spells_script]->find("SPELLA"))
	//{
	//	closescript();
	//	Console.send("Cannot find SPELLS SETTINGS string in spells.scp!");
	//	return false;
	//}
	
	int loopexit = 0;
	do
	{
		read2();
		if (!strcmp("SPELL", script1))			curspell = str2num(script2);
		else if (!strcmp("ENABLE", script1))	spells[curspell].enabled = str2num(script2);
		else if (!strcmp("CIRCLE", script1))	spells[curspell].circle = str2num(script2);
		else if (!strcmp("MANA", script1))		spells[curspell].mana = str2num(script2);
		else if (!strcmp("LOSKILL", script1))	spells[curspell].loskill = str2num(script2);
		else if (!strcmp("HISKILL", script1))	spells[curspell].hiskill = str2num(script2);
		else if (!strcmp("SCLO", script1))		spells[curspell].sclo = str2num(script2);
		else if (!strcmp("SCHI", script1))		spells[curspell].schi = str2num(script2);
		else if (!strcmp("MANTRA", script1))	strcpy(spells[curspell].mantra, script2);
		else if (!strcmp("ACTION", script1))	spells[curspell].action = hstr2num(script2);
		else if (!strcmp("DELAY", script1))		spells[curspell].delay = str2num(script2);
		else if (!strcmp("ASH", script1))		spells[curspell].reagents.ash = str2num(script2);
		else if (!strcmp("DRAKE", script1))		spells[curspell].reagents.drake = str2num(script2);
		else if (!strcmp("GARLIC", script1))	spells[curspell].reagents.garlic = str2num(script2);
		else if (!strcmp("GINSING", script1))	spells[curspell].reagents.ginseng = str2num(script2);
		else if (!strcmp("MOSS", script1))		spells[curspell].reagents.moss = str2num(script2);
		else if (!strcmp("PEARL", script1))		spells[curspell].reagents.pearl = str2num(script2);
		else if (!strcmp("SHADE", script1))		spells[curspell].reagents.shade = str2num(script2);
		else if (!strcmp("SILK", script1))		spells[curspell].reagents.silk = str2num(script2);
		else if (!strcmp("TARG", script1))		strcpy(spells[curspell].strToSay, script2);
		else if (!strcmp("REFLECT", script1))	spells[curspell].reflect = str2num(script2);
		else if (!strcmp("RUNIC", script1))		spells[curspell].runic = str2num(script2);
	}
	while ((strcmp(script1, "EOF")) &&(++loopexit < MAXLOOPS));
	closescript();

	int i;
	for (i=1;i<70;i++) spp[i] = new cOldSpell(&spells[i],i);

//	spp[1]->SetFlags(0);

	return true;
}

/*
/////////////
// name:	getSpellbook
// history:	by Duke, 3.8.2002
// Purpose:	find and return the player's spellbook
// Remark:	the search is stopped after the first book is found
//
P_ITEM cOldMagic::getSpellBook(P_CHAR Player)
{
	int ci=0, loopexit=0;
	P_ITEM pj;
	while ( (( pj=Player->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pj->isType(ITY_SpellBook) || pj->isType(ITY_NecroBook) || pj->isType(ITY_PaladinBook))
		{
			return pj;
		}
	}
	// not equipped ? so let's search the primary backpack
	P_ITEM Pack = Player->getBackpack();
	if (Pack)
	{
		ci=0; loopexit=0;
		while ( (( pj=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (pj->isType(ITY_SpellBook)  || pj->isType(ITY_NecroBook) || pj->isType(ITY_PaladinBook) )
			{
				return pj;
			}
		}
	}
	return NULL;
}
*/

/*
// Spellbook
// Purpose:	Sends the spellbook item (with all the
//			memorized spells) to player when doubleclicked.
//

void cOldMagic::SpellBook(UOXSOCKET s, P_ITEM pi)
{
	P_ITEM Book;

	if (!pi) // item send by client?
		Book=FindItemBySerPtr(&buffer[s][1]);
	else 
		Book=pi;

	CHARACTER cc=currchar(s);
	P_CHAR Player = MAKE_CHARREF_LR(cc);
	P_ITEM Pack = Player->getBackpack();
	if (!Book)
	{
		Book = getSpellBook(Player);
	}

	if (!Book ||	// no book at all
		(Pack && !Pack->Contains(Book) &&	// not in primary pack
		!Player->Wears(Book) ))		// not equipped
	{
		sysmessage(s, "In order to open spellbook, it must be equipped in your hand or in the first layer of your backpack.");
		return;
	}

	if (Book->layer!=1) senditem(s,Book); // prevents crash if pack not open

	unsigned char sbookstart[8]="\x24\x40\x01\x02\x03\xFF\xFF";
	LongToCharPtr(Book->serial, &sbookstart[1]);

	XStartPkt(0x24, 7);
	XAddPkt(&sbookstart[0+1], 7-1);
	XFinishPkt(s);

	int a;
	int i, scount=0;

	CArray<70, int>SiB("SIB");
	for (a=0; a<70; a++) SiB[a]=0;

	int ci=0, loopexit=0;
	P_ITEM pj;
	while ( (( pj=Book->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (IsSpellScroll72(pj->id()))
		{
			SiB[pj->id()-0x1F2D]=1;
		}
	}

	if (SiB[64])
	{
		for (i=0;i<64;i++) SiB[i]=1;
		SiB[64]=0;
	}

	// Fix for Reactive Armor/Bird's Eye dumbness. :)
	i=SiB[0];
	SiB[0]=SiB[1];
	SiB[1]=SiB[2];
	SiB[2]=SiB[3];
	SiB[3]=SiB[4];
	SiB[4]=SiB[5];
	SiB[5]=SiB[6]; // Morac is right! :)
	SiB[6]=i;
	// End fix.

	for (i=0;i<70;i++)
	{
		if (SiB[i]) scount++;
	}

	unsigned char sbookinit[6]="\x3C\x00\x3E\x00\x03";
	int l=(scount*19)+5;
	sbookinit[1]=(l)>>8;
	sbookinit[2]=(l)%256;
	sbookinit[3]=scount>>8;
	sbookinit[4]=scount%256;
	if (scount>0) 
	{
		XStartPkt(0x3c, l);
		XAddPkt(&sbookinit[0+3], 5-3);
	}

	unsigned char sbookspell[20]="\x40\x01\x02\x03\x1F\x2E\x00\x00\x01\x00\x48\x00\x7D\x40\x01\x02\x03\x00\x00";
	for (i=0;i<70;i++)
	{
		if (SiB[i])
		{
			sbookspell[0]=0x41;
			sbookspell[1]=0x00;
			sbookspell[2]=0x00;
			sbookspell[3]=i+1;
			sbookspell[8]=i+1;
			LongToCharPtr(Book->serial, &sbookspell[13]);

			XAddPkt(&sbookspell[0], 19);
		}
	}

	XFinishPkt(s);
}
*/

///////////////////
// Name:	GateCollision
// History:	Unknown, Modified by AntiChrist - collision dir
// Purpose:	Used when a PLAYER passes throu a gate. Takes the player
//			to the other side of the gate-link.
//
char cOldMagic::GateCollision(P_CHAR pcc)
{
	if (!pcc) return 0;

	// Check to make sure that this isn't a NPC (they shouldn't go throught gates)
	if (pcc->npc) return 0;

	// Now check whether the PC (player character) has moved or simply turned
	// If they have only turned, then ignore checking for a gate collision since it would
	// have happened the previous time

	if (pcc->pos == pcc->prevPos)
		return 0;

	// - Tauriel's region stuff 3/6/99
	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(pcc->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->isType(ITY_Gate1) || pi->isType(ITY_Gate2))
		{
			unsigned int n;
			if (pi->isType(ITY_Gate1)) n=1;
			else n=0;

			if (pcc->pos.IsSameXY(pi->pos) &&
				pcc->pos.z >= pi->pos.z)
			{
				///// attacking NPC following those who gateravel doesnt work !
				///// to be investigated, dunno why
				cCoord newPos(gatex[pi->gatenumber][n], gatey[pi->gatenumber][n], gatez[pi->gatenumber][n],DEFAULT_MAP);
				if ( pcc->npc==0 )
				{
					// Look for an NPC
					cChar *pc;
					RegGrid3x3Iterator4Chars rg3iii(pcc->pos);
	                while((pc = rg3iii.Next()) != NULL && (++loopexit < MAXLOOPS) )					
					{
						// That is following this player character
						if ( pc->npc && pcc->isSameAs(pc->GetFollowTarget()) )
						{
							// If the NPC that is following this player character is within 5 paces
							if (pcc->dist(pc) <= 4)
							{
								// Teleport the NPC along with the player
								pc->teleTo(newPos);
							}
						}
					}
				}
				
				// Set the characters destination

				pcc->teleTo(newPos);
				soundeffect( pcc, 0x01FE );
				staticeffect( pcc, 0x372A, 0x09, 0x06 );

				// Since the character has moved a step update the prevXYZ values
	            // to prevent the "bounce back" effect of the GateCollision check
	            pcc->prevPos = pcc->pos;
				return 1;
			}
		}
	}
	return 1;
}

///////////////////
// Name:	SummonMonster
// History:	Unknown
// Purpose:	Summon a monster (dispellable with DISPEL).
//
void cOldMagic::SummonMonster(UOXSOCKET s, short id, char * monstername, unsigned short color, int x, int y, int z, int spellnum)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	P_CHAR Monster = NULL;
	bool randommonster=false;

	switch(id)
	{
	case 0x0000:	// summon monster
 		soundeffect( Player, 0x0215 );
		int k;
		k = Npcs->PickFromNpcList(SNC_SummonList);
		if (k == -1)
 		{
 			sysmessage( s, "Contact your shard op to setup the summon list!" );
 			return;
 		}
		Monster = Npcs->AddRespawnNPC(s,k);
		if (!Monster) return;

		{
		cCoord Mpos(Player->pos);
		Mpos.Add(rand()%2,rand()%2);
		Monster->teleTo(Mpos);
		}
		randommonster=true;
 		break;

	case 0x000D: // Energy Vortex & Air elemental
		if (color==0x0075)
		{
			soundeffect(Player, 0x0212);
			Monster=Npcs->AddNPC(s,SNC_EnergyVortex,Player->pos);
		}
		else
		{
			soundeffect(Player, 0x0217);
			Monster=Npcs->AddNPC(s,SNC_AirElemental,Player->pos);
		}
		if (!Monster) return;
		Monster->setAi(50);
		Monster->tamed=true;
		break;
	case 0x000A:
		soundeffect(Player, 0x0216);
		Monster=Npcs->AddNPC(s,SNC_Deamon,Player->pos);
		if (!Monster) return;
		Monster->tamed=true;
		break;
	case 0x000E:
		soundeffect(Player, 0x0217);
		Monster=Npcs->AddNPC(s,SNC_EarthElemental,Player->pos);
		if (!Monster) return;
		Monster->tamed=true;
		break;
	case 0x000F:
		soundeffect(Player, 0x0217);
		Monster=Npcs->AddNPC(s,SNC_FireElemental,Player->pos);
		if (!Monster) return;
		Monster->tamed=true;
		break;
	case 0x0010:
		soundeffect(Player, 0x0217);
		Monster=Npcs->AddNPC(s,SNC_WaterElemental,Player->pos);
		if (!Monster) return;
		Monster->tamed=true;
		break;
	case 0x023E:
		soundeffect(Player, 0x0212); // I don't know if this is the right effect...	
		Monster=Npcs->AddNPC(s,SNC_BladeSpirits,Player->pos);
		if (!Monster) return;
		Monster->setAi(50);
		Monster->tamed=false;
		break;
	case 0x03e2: // Dupre The Hero
		soundeffect(Player, 0x0246);
		Monster = Npcs->MakeBaseChar();
		if (!Monster) return;
		Monster->def=50;
		Monster->lodamage=50;
		Monster->hidamage=100;
		Monster->spattack=7552; // 1-7 level spells
		Monster->setRealSkill(MAGERY,900);
		Monster->setRealSkill(TACTICS,1000);
		Monster->setRealSkill(WRESTLING,900);
		Monster->setRealSkill(SWORDSMANSHIP,1000);
		Monster->setRealSkill(PARRYING,1000);
		Monster->setRealSkill(MAGICRESISTANCE,650);
		Monster->setStr(600);
		Monster->fullHp();
		Monster->setDex(70);
		Monster->fullStm();
		Monster->setInt(100);
		Monster->mn=100;
		break;
	case 0x000B: // Black Night
		soundeffect(Player, 0x0216);
		Monster = Npcs->MakeBaseChar();
		if (!Monster) return;
		Monster->def=50;
		Monster->lodamage=50;
		Monster->hidamage=100;
		Monster->spattack=7552; // 1-7 level spells
		Monster->setRealSkill(MAGERY,1000);
		Monster->setRealSkill(TACTICS,1000);
		Monster->setRealSkill(WRESTLING,900);
		Monster->setRealSkill(SWORDSMANSHIP,1000);
		Monster->setRealSkill(PARRYING,1000);
		Monster->setRealSkill(MAGICRESISTANCE,1000);
		Monster->setStr(600);
		Monster->fullHp();
		Monster->setDex(70);
		Monster->fullStm();
		Monster->setInt(100);
		Monster->mn=100;
		break;
	case 0x0190: // Death Knight
		soundeffect(Player, 0x0246);
		Monster = Npcs->MakeBaseChar();
		if (!Monster) return;
		Monster->def=20;
		Monster->lodamage=10;
		Monster->hidamage=45;
		Monster->spattack=4095; // 1-7 level spells
		Monster->setRealSkill(MAGERY,500);
		Monster->setRealSkill(TACTICS,1000);
		Monster->setRealSkill(WRESTLING,900);
		Monster->setRealSkill(SWORDSMANSHIP,1000);
		Monster->setRealSkill(PARRYING,1000);
		Monster->setRealSkill(MAGICRESISTANCE,650);
		Monster->setStr(600);
		Monster->fullHp();
		Monster->setDex(70);
		Monster->fullStm();
		Monster->setInt(100);
		Monster->mn=100;
		break;
	default:
		soundeffect(Player, 0x0215);
		return;
	}

	Monster->fame=0;		// summoned creatures don't give fame nor karma
	Monster->karma=0;
	Monster->MakeDispellable();
	Monster->summoned=true;
	Monster->summontimer=(uiCurrentTime+((Player->Skill(MAGERY)/10)*(MY_CLOCKS_PER_SEC*2)));

	if (id!=0x023E && !(id==0x000d && color==0x0075)) // don't own BS or EV.
		Monster->SetOwnSerial(Player->serial); 

	if (!randommonster)		// if not using the 'summon monster' spell
	{
		strcpy(Monster->name, monstername);
		Monster->setId(id);
		Monster->setXid(id);
		Monster->skin = Monster->xskin = color;
		Monster->npc=1;
		
		if (x==0)
			Monster->MoveToOneOff(Player->pos);
		else
		{
			cCoord nPos(x, y, z,Player->pos.map);
			Monster->MoveTo(nPos);
		}
		
		Monster->spadelay=10;
		updatechar(Monster);
	}

	Monster->DoAction(0x0C);
	doStaticEffect(Monster, spellnum);
		
	if (!randommonster)		// if not using the 'summon monster' spell
	{
		// AntiChrist (9/99) - added the chance to make the monster attack
		// the person you targeted ( if you targeted a char, naturally :) )
		P_CHAR Target=FindCharBySerPtr(&buffer[s][7]);
		if (!Target) return;
		npcattacktarget(Target,Monster);
	}
}

/*
///////////////////
// Name:	CheckBook
// History:	Unknown
// Purpose:	Check if the spell is memorized into the spellbook.
//
int cOldMagic::CheckBook(int circle, int spell, P_ITEM Book)
{
	if (!Book) return 0;
	bool raflag = false;

	int spellnum=spell+(circle-1)*8;
	// Fix for OSI stupidity. :)
	if (spellnum==6) raflag = true;
	if (spellnum>=0 && spellnum<6) spellnum++;
	if (raflag) spellnum=0;

	int ci=0, loopexit=0;
	P_ITEM pj;
	while ( (( pj=Book->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pj->id()==(0x1F2D+spellnum) || pj->id()==0x1F6D)
		{
			return 1;
		}
	}
	return 0;
}
*/

/*int cOldMagic::SpellsInBook(P_ITEM Book)
{
	if (!Book) return -1;
	int ci = 0, loopexit = 0;
	int spellcount = 0;
	P_ITEM pj;
	while (((pj = Book->Search(&ci)) != NULL) &&(++loopexit < MAXLOOPS))
	{
		if (pj->id() == 0x1F6D)
			spellcount = 64;
		else
			spellcount++;
	}
	if (spellcount >= 64)
		spellcount = 64;
	return spellcount;
}*/


///////////////////
// Name:	SbOpenContainer
// History:	Unknown
// Purpose:	Open player's spellbook as a container.
//			(used for SBOPEN command)
//
/*void cOldMagic::SbOpenContainer(UOXSOCKET s, P_ITEM pi)
{
	if (pi)
	{
		if (pi->isType(ITY_SpellBook))
			backpack(s,pi);
		else
			sysmessage(s,"That is not a spellbook.");
	}
}*/



///////////////////
// Name:	CheckMana
// History:	Unknown, Modified by AntiChrist to use spells[] array.
// Purpose:	Check if character has enought mana to cast a spell of that circle.
//
char cOldMagic::CheckMana(P_CHAR pc, int num)
{

	if (pc->DoesNotNeedMana())
		return 1;

	if (pc->mn >= spells[num].mana) 
		return 1;
	else 
	{
		UOXSOCKET s = pc->calcSocket();
		if (s != -1) 
			sysmessage(s, "You have insufficient mana to cast that spell.");
		return 0;
	}
}



///////////////////
// Name:	SubtractMana
// History:	Unknown
//			10.3.2002 (Duke) added encapsulation for spells var
// Purpose:	Substract the required mana from character's mana reserve.
//
char cOldMagic::SubtractMana4Spell(P_CHAR pc, int num)
{
	return OldMagic->SubtractMana(pc, spells[num].mana);
}
char cOldMagic::SubtractMana(P_CHAR pc, int mana)
{
	if (pc->DoesNotNeedMana())
		return 1;

	if (pc->mn >= mana)
		pc->mn-=mana;
	else 
		pc->mn = 0;

	updatestats(pc, 1);//AntiChrist - bugfix
	return 1;
}



///////////////////
// Name:	CheckMagicReflect
// History:	Unknown
// Purpose:	Check if character is protected by MagicReflect;
//			if yes, remove the protection and do visual effect.
//
P_CHAR cOldMagic::CheckMagicReflect(P_CHAR &Attacker, P_CHAR &Defender)
{
	if (Defender->HasMagicReflect())
	{
		Defender->RemoveMagicReflect();
		staticeffect(Defender, 0x373A, 0, 15);
		return Attacker;
	}
	return Defender;
}


///////////////////
// Name:	CheckResist
// History:	Unknown, Modified by AntiChrist to add EV.INT. check
// Purpose:	Check character's magic resistance.
//
bool cOldMagic::CheckResist(P_CHAR Defender, int circle)	// for fieldeffects and trap
{
	if (!Defender) return 0;
	return CheckResist(NULL,Defender,circle);
}

bool cOldMagic::CheckResist(P_CHAR Attacker, P_CHAR Defender, int circle)
{
	bool i=Defender->checkSkill(MAGICRESISTANCE, 80*circle, 800+(80*circle));

	if (i)
	{
		//AntiChrist - 7/10/99
		//A higher Eval.Int. can disable opponent's resistspell!
		if (Attacker) //NOTE: only do the EV.INT. check if attacker > 0
		{
			if (Attacker->Skill(EVALUATINGINTEL) < Defender->Skill(MAGICRESISTANCE) && (rand()%3)==0)
			{
				UOXSOCKET s = Defender->calcSocket();
				if (s!=-1)
					sysmessage(s, "You feel yourself resisting magical energy!");
			} else
				return 0;
		} else
		{//attacker=-1: used for checking field effects
			UOXSOCKET s = Defender->calcSocket();
			if (s!=-1)
				sysmessage(s, "You feel yourself resisting magical energy!");
		}
	}
	return i;
}


///////////////////
// Name:	CheckFieldEffects2
// History:	Unknown
// Purpose:	Check if character stands on a magic-field, and apply effects.
//
// timecheck: 0: alwa
// timecheck: 1: only executed if the time is right for next fieldeffect checkys executed no matter of the nextfieldspelltime value
// we need this cauz its called from npccheck and pc-check
// npc-check already has its own timer, pc check not.
// thus in npccheck its called with 0, in pc check with 1
// we could add the fieldeffect check time the server.scp but i think this solution is better.
// LB October 99
//

void cOldMagic::CheckFieldEffects4(unsigned int currenttime, P_CHAR pc)
{
	PC_ITEM pi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(pc->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pi->pos.IsSameXY(pc->pos))	// lb
		{
			CheckFieldEffect(pc, pi);
			// break;  
			
			// hmmm, I think that's supposed to be an optimization.
			// if char standing on an item, and it's no field, char can't be in a field
			// not true. cauz there can be field+non-field-item+char at same x/y
			// LB
		}
	}
}

void cOldMagic::CheckFieldEffect(P_CHAR pc, PC_ITEM pi)
{
	short id = pi->id();
	
	if (id==0x3996 || id==0x398C)
	{
		if (!CheckResist(pc, 4))
			Magic->MagicDamage(pc, pi->morex/100);
		else
			Magic->MagicDamage(pc, pi->morex/200);
		soundeffect2(pc, 0x0208);
	}
	else if (id==0x3915 || id==0x3920)//Poison Field
	{
		if (!CheckResist(pc, 5))
		{
			if (pi->morex<997)
				Magic->PoisonDamage(pc,2);
			else
				Magic->PoisonDamage(pc,3); // gm mages can cast greater poison field, LB
		} else Magic->PoisonDamage(pc,1); // cant be completly resited
		
		soundeffect2(pc, 0x0208);
	}
	else if (id==0x3979 || id==0x3967)//Para Field
	{
		if (!pc->IsFrozen())
		{
			if (!CheckResist(pc, 6))
				tempeffect(pc, TEF_Paralyze, 0, 0, 0,pi->morex/100);
			soundeffect2(pc, 0x0204);
		}
	}
}

///////////////////
// Name:	BoxSpell
// History:	Unknown
// Purpose:	Calculate the spell box effect, depending on character's magery skill.
//
void cOldMagic::BoxSpell(UOXSOCKET s, int& x1, int& x2, int& y1, int& y2, int& z1, int& z2)
{
	int x, y, z, lenght;

	x=(buffer[s][11]<<8)+buffer[s][12];
	y=(buffer[s][13]<<8)+buffer[s][14];
	z=buffer[s][16];

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	lenght=Player->Skill(MAGERY)/170; // increased max-range, LB

	x1=x-lenght;
	x2=x+lenght;
	y1=y-lenght;
	y2=y+lenght;
	z1=z;
	z2=z+3;
}

///////////////////
// Name:	MagicTrap
// History:	Unknown
// Purpose:	Do the visual effect and apply magic damage when a player opens a trapped container.
//
void cOldMagic::MagicTrap(P_CHAR pc, P_ITEM pTrap)
{
	if (!pc) return;
	if (!pTrap) return;
	if (pc->isGM()) return;
	staticeffect(pc, 0x36B0, 0x09, 0x09);
	soundeffect2(pc, 0x0207);
	if (CheckResist(pc, 4)) 
		Magic->MagicDamage(pc,pTrap->moreb2);
	else 
		Magic->MagicDamage(pc,pTrap->moreb2/2);
	pTrap->moreb1=0;
	pTrap->moreb2=0;
	pTrap->moreb3=0;
}

///////////////////
// Name:	CheckReagents
// History:	Unknown, Modified by AntiChrist to use reag_st
// Purpose:	Check for required reagents in player's backpack.
//
char cOldMagic::CheckReagents(P_CHAR pc, int num)
{
	if (!pc) return 0;
	reag_st reagents = spells[num].reagents;
	reag_st failmsg;

	if (pc->DoesNotNeedRegs()) return 1;

	memset(&failmsg,0,sizeof(reag_st)); // set all members to 0

	if (reagents.ash!=0		&& pc->CountItems(0x0F8C)<reagents.ash)
		failmsg.ash=1;
	if (reagents.drake!=0	&& pc->CountItems(0x0F86)<reagents.drake)
		failmsg.drake=1;
	if (reagents.garlic!=0	&& pc->CountItems(0x0F84)<reagents.garlic)
		failmsg.garlic=1;
	if (reagents.ginseng!=0 && pc->CountItems(0x0F85)<reagents.ginseng)
		failmsg.ginseng=1;
	if (reagents.moss!=0	&& pc->CountItems(0x0F7B)<reagents.moss)
		failmsg.moss=1;
	if (reagents.pearl!=0	&& pc->CountItems(0x0F7A)<reagents.pearl)
		failmsg.pearl=1;
	if (reagents.shade!=0	&& pc->CountItems(0x0F88)<reagents.shade)
		failmsg.shade=1;
	if (reagents.silk!=0	&& pc->CountItems(0x0F8D)<reagents.silk)
		failmsg.silk=1;

	int fail=RegMsg(pc,failmsg);

	return fail;
}

///////////////////
// Name:	RegMsg
// History:	Unknown, Reprogrammed by AntiChrist to display missing reagents types.
// Purpose:	Display an error message if character has no enougth resgs.
//
int cOldMagic::RegMsg(P_CHAR pc, reag_st failmsg)
{
	bool display = false;
	char message[100] = {0,};  //just to make sure we end with '\0'

	strcpy(message, "You do not have enough reagents to cast that spell.[");

	if (failmsg.ash)	{ display = true; strcat(message,"Sa,"); }
	if (failmsg.drake)	{ display = true; strcat(message,"Mr,"); }
	if (failmsg.garlic)	{ display = true; strcat(message,"Ga,"); }
	if (failmsg.ginseng){ display = true; strcat(message,"Gi,"); }
	if (failmsg.moss)	{ display = true; strcat(message,"Bm,"); }
	if (failmsg.pearl)	{ display = true; strcat(message,"Bp,"); }
	if (failmsg.shade)	{ display = true; strcat(message,"Ns,"); }
	if (failmsg.silk)	{ display = true; strcat(message,"Ss,"); }

	message[strlen(message)-1]=']';

	if (display)
	{
		UOXSOCKET s = pc->calcSocket();
		if (s != -1) 
			sysmessage(s, message);
		return 0;
	}

	return 1;
}


///////////////////
// Name:	PFireballTarget
// History:	Unknown
// Purpose:	Calculate and inflict a magic damage.
//
void cOldMagic::PFireballTarget(P_CHAR pc, P_CHAR Def, int j) //j = % dammage
{
	if (!pc || !Def) return;
	movingeffect(pc, Def, 0x36, 0xD5, 0x05, 0x00, 0x01);
	soundeffect2(pc, 0x015E);
	// do we have to calculate attacker hp percentage,
	// or defender hp percentage?!?!?!
	int dmg =(Def->Hp() * j)/100;
	Magic->MagicDamage(Def, dmg);
}

///////////////////
// Name:	SpellFail
// History:	Unknown
// Purpose:	Do visual and sound effects when a player fails to cast a spell.
//
void cOldMagic::SpellFail(UOXSOCKET s)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	//Use Reagents on failure ( if casting from spellbook )
	if (!SrvParms->newmagictest && Player->GetCastingSpellType()==0) DelReagents( Player, Player->spell );

	//npcaction(cc, 128); // whaaaaaaaaaaaaaat ?
	//orders the PG to move a step on, but the pg doesn't really move
	//disappearing from the other clients. solarin
	
	if ( rand()%5==2 ) doStaticEffect(Player, 99); else staticeffect(Player, 0x3735, 0, 30);
	soundeffect2(Player, 0x005C);
	npcemote(s, Player, "The spell fizzles.",0);
}


/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////// NPCs CASTING SPELLS RELATED FUNCTIONS ///////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////


///////////////////
// Name:	NPCLightningTarget
// History:	Unknown
// Purpose:	Used for NPC; cast a lightning spell.
//
void cOldMagic::NPCLightningTarget(P_CHAR Attacker, P_CHAR Defender)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	SubtractMana(Attacker, 11);
	bolteffect(Target, true);
	soundeffect2(Target, 0x0029);

	if (CheckResist(Attacker, Target, 4))
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/180+RandomNum(1,2));
	}
	else
	{
		Magic->MagicDamage(Target, (Attacker->Skill(MAGERY)+1*(Attacker->Skill(EVALUATINGINTEL)/3))/(89+1*(Target->Skill(MAGICRESISTANCE)/30))+RandomNum(1,5));
	}
	return;
}

void cOldMagic::NPCHeal(P_CHAR pc)
{
	if (!pc) return;

    int loskill=spells[10].loskill;
    int hiskill=spells[10].hiskill;

	LogAssert(hiskill!=0);
	if (!pc->checkSkill(MAGERY, loskill, hiskill))
	{
		UOXSOCKET ss=pc->calcSocket();
		if (ss>-1)
		{
			SpellFail(ss);
		}
		return;
	}
	if (CheckMana(pc,10))
	{
		SubtractMana(pc, 10);
		pc->increaseHp(pc->Skill(MAGERY)/30+RandomNum(1,12));
		doStaticEffect(pc, 4);
	}
}

void cOldMagic::NPCCure(P_CHAR pc)
{
	if (!pc) return;

    int loskill=spells[11].loskill;
    int hiskill=spells[11].hiskill;

	LogAssert(hiskill!=0);
	if (!pc->checkSkill(MAGERY, loskill, hiskill))
	{
		UOXSOCKET ss=pc->calcSocket();
		if (ss>-1)
		{
			SpellFail(ss);
		}
		return;
	}
	if (CheckMana(pc,11))
	{
		doStaticEffect(pc, 11);
		SubtractMana(pc,5);
		pc->PoisonWearOff(pc->calcSocket());
		npcemoteall(pc,"Laughs at the poison attempt",0);
	}
}

void cOldMagic::NPCDispel(P_CHAR Caster, P_CHAR Victim)
{
	if (!Caster || !Victim) return;
	int loskill=spells[41].loskill;
	int hiskill=spells[41].hiskill;
	LogAssert(hiskill!=0);
	if (!Caster->checkSkill(MAGERY, loskill, hiskill))
	{
		UOXSOCKET ss=Caster->calcSocket();
		if (ss>-1)
		{
			SpellFail(ss);
		}
		return;
	}

	if (CheckMana(Caster,41))
	{
		if (Victim->IsDispellable())
		{
			SubtractMana(Caster,20);
			tileeffect(Victim->pos, 0x37, 0x2A, 0x00, 0x00);
			if (Victim->npc)
				Npcs->DeleteChar(Victim);
			else
				deathstuff(Victim);
		}
	}
}

///////////////////
// Name:	NPCEBoltTarget
// History:	Unknown
// Purpose:	Used for NPC; cast a energy bolt spell.
//
void cOldMagic::NPCEBoltTarget(P_CHAR Attacker, P_CHAR Defender)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	SubtractMana(Attacker, 20);
	doMoveEffect(Target, Defender, 42);
	soundeffect2(Target, 0x20A);

	if (CheckResist(Attacker, Defender, 6))
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/120);
	}
	else
	{
		Magic->MagicDamage(Target, (Attacker->Skill(MAGERY)+1*(Attacker->Skill(EVALUATINGINTEL)/3))/(34+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,10));
	}
}

///////////////////
// Name:	CheckParry
// History:	Unknown
// Purpose:	Check player's parrying skill (for cannonblast).
//
/*char cOldMagic::CheckParry(P_CHAR pc, int circle)
{
	char i=pc->checkSkill(PARRYING, 80*circle, 800+(80*circle));
	if (i)
	{
		int s=pc->calcSocket();
		if (s!=-1)
		{
			sysmessage(s, "You have dodged the cannon blast, and have taken less damage.");
		}
	}
	return i;
}*/

///////////////////
// Name:	NPCFlameStrikeTarget
// History:	Unknown
// Purpose:	Used for NPC; cast a flame strike spell.
//
void cOldMagic::NPCFlameStrikeTarget(P_CHAR Attacker, P_CHAR Defender)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	SubtractMana(Attacker, 40);
	doStaticEffect(Target, 51);
	soundeffect2(Target, 0x0208);

	if (CheckResist(Attacker, Defender, 7))
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/80);
	}
	else
	{
		Magic->MagicDamage(Target, (Attacker->Skill(MAGERY)+1*(Attacker->Skill(EVALUATINGINTEL)/3))/(34+1*(Target->Skill(MAGICRESISTANCE)/30))+RandomNum(1,25));
	}
	return;
}


/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////// ITEMs MAGIC POWER RELATED FUNCTIONS /////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////


///////////////////
// Name:	MagicArrowSpellItem
// History:	Modifyed by Correa to be used by both Items and Players
// Purpose:	Cast magic arrow
//
void cOldMagic::MagicArrow(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	doMoveEffect(Target, Defender, 5);
	soundeffect2(Target, 0x1E5);

	if (usemana)
		SubtractMana(Attacker, 4);
	if (CheckResist(Attacker, Target, 1))
	{
		Magic->MagicDamage(Target, (1+(rand()%1)+1)*(Attacker->Skill(MAGERY)/2000+1));
	}
	else
	{
		Magic->MagicDamage(Target, (1+(rand()%1)+2)*(Attacker->Skill(MAGERY)/1500+1));
	}
	return;
}

///////////////////
// Name:	ClumsySpell
// History:	Modifyed by Correa to be used by both Items and Chars
// Purpose:	cast a clumsy spell.
//
void cOldMagic::ClumsySpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;
 
	P_CHAR Target = NULL;
	Target=CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 4);

	doStaticEffect(Defender, 1);
	soundeffect2(Defender, 0x01DF);
	if (CheckResist(Attacker, Defender, 1)) return;
	tempeffect(Attacker, Defender, TEF_Clumsy, Attacker->Skill(MAGERY)/100, 0, 0);
	return;
}

///////////////////
// Name:	FeebleMindSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a feeblemind spell.
//
void cOldMagic::FeebleMindSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 4);

	doStaticEffect(Target, 3);
	soundeffect2(Target, 0x01E4);
	if (CheckResist(Attacker, Target, 1)) return;
	tempeffect(Attacker, Target, TEF_FeebleMind, Attacker->Skill(MAGERY)/100, 0, 0);
}

///////////////////
// Name:	WeakenSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a weaken spell.
//
void cOldMagic::WeakenSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 4);
	
	doStaticEffect(Target, 8);
	soundeffect2(Target, 0x01E6);
	if (CheckResist(Attacker, Target, 1)) return;
	tempeffect(Attacker, Target, TEF_Weaken, Attacker->Skill(MAGERY)/100, 0, 0);
}

///////////////////
// Name:	HarmSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a harm spell.
//
void cOldMagic::HarmSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 6);

	doStaticEffect(Target, 12);
	soundeffect2(Target, 0x01F1);
	if (CheckResist(Attacker, Target, 2))
	{
		Magic->MagicDamage(Defender, Attacker->Skill(MAGERY)/500+1);
	}
	else
	{
		Magic->MagicDamage(Defender, Attacker->Skill(MAGERY)/250+RandomNum(1,2));
	}
}


///////////////////
// Name:	FireballSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a fireball spell.
//
void cOldMagic::FireballSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 9);

	doMoveEffect(Attacker, Target, 18);
	soundeffect2(Attacker, 0x15E);
	if (CheckResist(Attacker, Target, 3)) 
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/280+1);
	else 
		Magic->MagicDamage(Target, (Attacker->Skill(MAGERY)+1*(Attacker->Skill(EVALUATINGINTEL)/3))/(139+1*(Target->Skill(MAGICRESISTANCE)/30))+RandomNum(1,4));
	return;
}

///////////////////
// Name:	CurseSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a curse spell.
//
void cOldMagic::CurseSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 11);

	doStaticEffect(Target, 27);
	soundeffect2(Target, 0x01E1);
	if (CheckResist(Attacker, Target, 1)) return;
	int j = Attacker->Skill(MAGERY)/100;
	tempeffect(Attacker, Target, TEF_Curse, j, j, j);
}

///////////////////
// Name:	LightningSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a lightning spell.
//
void cOldMagic::LightningSpellItem(P_CHAR Attacker, P_CHAR Defender)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);

	bolteffect(Target, true);
	soundeffect2(Target, 0x0029);
	if (CheckResist(Attacker, Defender, 4))
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/180+RandomNum(1,2));
	}
	else
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/90+RandomNum(1,5));
	}
}



///////////////////
// Name:	MindBlastSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a mindblast spell.
//
void cOldMagic::MindBlastSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 14);

	doStaticEffect(Target, 37);
	soundeffect2(Target, 0x0213);

	int dmg = abs(Attacker->effInt() - Target->effInt()) / 2;
	if (dmg > 50) dmg = 50;
	if (Attacker->effInt()>Target->effInt())
	{
		if (CheckResist(Attacker, Target, 5))
			dmg /= 2;
		Magic->MagicDamage(Target, dmg);
	}
	else
	{
		if (CheckResist(Defender, Target, 5))
			dmg /= 2;
		Magic->MagicDamage(Attacker, dmg);
	}
}


///////////////////
// Name:	ParalyzeSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a paralyze spell.
//
void cOldMagic::ParalyzeSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 14);

	if (CheckResist(Attacker, Target, 5)) return;
	doStaticEffect(Target, 38);
	soundeffect2(Target, 0x0204);
	tempeffect(Attacker, Target, TEF_Paralyze, 0, 0, 0);
}


///////////////////
// Name:	EsplosionSpellItem
// History:	Modified by Correa to be used by both Items and Chars
// Purpose:	Used for ITEMS; cast a explosion spell.
//
void cOldMagic::ExplosionSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana)
{
	if (!Attacker || !Defender) return;

	P_CHAR Target = CheckMagicReflect(Attacker, Defender);
	
	if (usemana)
		SubtractMana(Attacker, 20);
	
	doStaticEffect(Target, 43);
	soundeffect2(Target, 0x0207);
	if (CheckResist(Attacker, Target, 6))
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/120+RandomNum(1,5));
	}
	else
	{
		Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/40+RandomNum(1,10));
	}
}

///////////////////
// Name:	FlameStrikeSpellItem
// History:	Unknown
// Purpose:	Used for ITEMS; cast a flamestrike spell.
//
void cOldMagic::FlameStrikeSpellItem(P_CHAR Attacker, P_CHAR Defender)
{
	P_CHAR Target = CheckMagicReflect(Attacker, Defender);

	doStaticEffect(Target, 51);
	soundeffect2(Target, 0x0208);
	Magic->MagicDamage(Target, Attacker->Skill(MAGERY)/40+RandomNum(1,25));
}

/*bool cOldMagic::okToCastSpellHere(int num, const cCoord &pos)
{
	int r = calcRegionFromXY(pos);
	if (r<0 || r>255) r=255;

	if (region[r].isSpellAllowed(num)==1) return true;
	else return false;

}*/


/////////////////////////////////////////////////////////////////
/////// PCs CASTING SPELLS RELATED FUNCTIONS ////////////////////
/////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////
// Name:	newSelectSpell2Cast                         //
// History:	Abaddon, 28 August 1999                     //
//			AntiChrist 10 September 1999                //
//			Frazurbluu July 2001 -cleaning this mess up-//
// Purpose:	Execute the selected spell to cast.         //
//////////////////////////////////////////////////////////
/*bool cOldMagic::newSelectSpell2Cast(UOXSOCKET s, P_CHAR Player, int num)
{
	if (!Player) return false;
	// Much reordering follows -Fraz-

	cOldSpell* Spell = NULL;
	Spell = getSpell(num);
	if (Spell==NULL || num<0 || num>=70)
	{
		LogErrorVar("invalid Spell#%i\n", num);
		return false;
	}

	if (Player->cell && !Player->isGM())
	{
		sysmessage(s,"You are in jail and cannot cast spells");
		return false;
	}

	if (!Spell->IsEnabled())
	{
		sysmessage( s, "That spell is currently not enabled" );
		return false;
	}

	if (!Player->isGM())
	{
		if (!okToCastSpellHere(num, Player->pos)) 
		{
			sysmessage(s,"You can't cast that spell here");				
			return false;
		}
	}

	int type = currentSpellType[s];
	// The following loop checks to see if any item is currently equipped (if not a GM)
	if (!Player->isGM() && type!=2)
	{
		if (Player->WieldsAntiMagicalItem())
		{
			sysmessage(s,"You cannot cast while carrying something in your hands.");
			return false;
		}
	}

	Player->unhide();
	Player->disturbMed(s); // Meditation

	//Check for enough reagents
	if (type==0 && (!CheckReagents(Player, num)))
	{
		return false;
	}
	if (type != 2)// -Fraz-
	{
		if ( Player->mn < Spell->GetMana() && !Player->DoesNotNeedMana() )
		{
			sysmessage(s, "You have insufficient mana to cast that spell.");
			return false;
		}
	}
	//Only speak if not a rod/staff/wand -Fraz-
	if (type!=2)
	{
		if (spells[num].runic || Player->Skill(MAGERY)/10 > 99 )	// Add runic talk to gm mages (Blackwind)
		{		
			npctalkall_runic(Player,strupr(spells[num].mantra),0);
		}
		else
		{		
			npctalkall(Player, spells[num].mantra,0);
		}

		impaction(s, spells[num].action);
	}
	//spell section for implementation specific stuff to get the spell to work
	//AntiChrist - 26/10/99
	//LET'S USE SCRIPT-CONFIGURABLE DELAYS!!!
//	Player->casting=1;
	Player->spell=num;
	Player->spellaction=spells[num].action;
	Player->nextact=75;
	if (type==0 && (!(Player->isGM())))//if they are a gm they don't have a delay :-)
	{
		Player->spelltime=((spells[num].delay*MY_CLOCKS_PER_SEC)/10)+uiCurrentTime;
		Player->Freeze();//freeze
	} 
	else
	{
		Player->spelltime=0;
	}

	int loskill=0;
	int hiskill=0;
	if (type==1)
	{
		loskill=spells[num].sclo;
		hiskill=spells[num].schi;
	}
	if (!SrvParms->cutscrollreq)
	{
		LogAssert(hiskill!=0);
		if (type==1 && !(Player->isGM()) && !Player->checkSkill(MAGERY, loskill, hiskill))
		{
			Player->disturbCasting(s);
			return false;
		}
	}
	if (type != 2) // if it's not a wand -Fraz-
	{
		impaction(s, spells[num].action);//do the action
		preParticles(num,Player); // show the beautiful casting particles for UO:3D clients
		if (type==1)
		{
			return true;
		}
	}
	return false;
}*/

/*void cOldMagic::preParticles(int num, P_CHAR pc)
{
    stat_st t;
	t = cOldMagic::getStatEffects_pre(num);
	if ( t.effect[4] != -1 && t.effect[5] != -1 && t.effect[6] != -1 && t.effect[7] != -1 )
	staticeffect(pc, NOTUSED, NOTUSED, NOTUSED, true, &t, true); 			 			  		
}*/

void cOldMagic::afterParticles(int num, P_CHAR pc)
{
    stat_st t;
	t = cOldMagic::getStatEffects_after(num);
	if ( t.effect[4] != -1 && t.effect[5] != -1 && t.effect[6] != -1 && t.effect[7] != -1 )
	staticeffect(pc, NOTUSED, NOTUSED, NOTUSED, true, &t, true); 
}

void cOldMagic::itemParticles(int num, P_ITEM pi)
{
    stat_st t;
	t = cOldMagic::getStatEffects_item(num);
	if ( t.effect[4] != -1 && t.effect[5] != -1 && t.effect[6] != -1 && t.effect[7] != -1 )
	staticeffect2(pi, NOTUSED, NOTUSED, NOTUSED, NOTUSED, NOTUSED, true, &t, true); 
}

static int chardirxyz(P_CHAR Player, int x, int y)	// direction from character a to char b
{
	int dir,xdif,ydif;

	xdif = x-Player->pos.x;
	ydif = y-Player->pos.y;

	if ((xdif==0)&&(ydif<0)) dir=0;
	else if ((xdif>0)&&(ydif<0)) dir=1;
	else if ((xdif>0)&&(ydif==0)) dir=2;
	else if ((xdif>0)&&(ydif>0)) dir=3;
	else if ((xdif==0)&&(ydif>0)) dir=4;
	else if ((xdif<0)&&(ydif>0)) dir=5;
	else if ((xdif<0)&&(ydif==0)) dir=6;
	else if ((xdif<0)&&(ydif<0)) dir=7;
	else dir=-1;

	return dir;
}

static int fielddir(P_CHAR Player, int x, int y, int z)
{
//WARNING: unreferenced formal parameter z
	int dir=chardirxyz(Player, x, y);
	switch (dir)
	{
	case 0:
	case 4:
		return 0;
		break;
	case 2:
	case 6:
		return 1;
		break;
	case 1:
	case 3:
	case 5:
	case 7:
	case -1:
		switch(Player->dir) //crashfix, LB
		{
		case 0:
		case 4:
			return 0;
			break;
		case 2:
		case 6:
			return 1;
			break;
		case 1:
		case 3:
		case 5:
		case 7:
			return 1;
		default:
			Console.send("ERROR: Fallout of switch statement without default. LoneWolf.cpp, fielddir()\n"); //Morrolan
			return 0;
		}
	default:
		Console.send("ERROR: Fallout of switch statement without default. LoneWolf.cpp, fielddir()\n"); //Morrolan
		return 0;
	}
	return 1;
}

void cOldMagic::NewCastSpell( UOXSOCKET s, int serial )
{
	// for LocationTarget spell like ArchCure, ArchProtection etc...
	int	j=0, x1, x2, y1, y2, z1, z2, range, distx, disty;
	int dmg, dmgmod;
//	int loskill, hiskill;//AntiChrist moved here
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int curSpell = Player->spell;
	cOldSpell* Spell = getSpell(Player->spell);
	if (!Spell) return;

	int calcreg;
	double d;
	bool recalled;
	int n;
	int x, y, z, dz;
	int fx[5], fy[5]; // bugfix LB, was fx[4] ...
	unsigned char id1=0, id2=0;	
	int snr=0;
	bool char_selected, item_selected, terrain_selected;

/*	if (Player->dead==1) return;
	if (currentSpellType[s]==0)
	{
		loskill=Spell->GetMinSkill();
		hiskill=Spell->GetMaxSkill();
		
		LogAssert(hiskill!=0);
		if (!Player->isGM() && !Player->checkSkill(MAGERY, loskill, hiskill))
		{
			OldMagic->SpellFail(s);
			Player->endCasting();
			Player->spell=0;
			return;
		}
	}
	if (currentSpellType[s]!=2) SubtractMana(Player, Spell->GetMana());

	if (currentSpellType[s]==0) DelReagents(Player, curSpell);
*/
	if (Spell->RequiresTarget())					// target spells if true
	{
		if (Spell->IsTravelSpell())				// travel spells.... mark, recall and gate
		{
			// mark, recall and gate go here
			P_ITEM pi=FindItemBySerPtr(&buffer[s][7]);
			if (serial > -1)
			{
				pi = FindItemBySerial(serial);
			}
			if (pi)
			{
				if ( !pi->isInWorld() || line_of_sight( s, Player->pos, pi->pos, LOS_STD_BLOCKERS ) || Player->isGM() ) // bugfix LB
				{
					if (pi->isType(ITY_RuneBook))
					{
						if (pi->morex!=0 && curSpell!=45)
						{
							int ci=0,i;
							P_ITEM Book=pi;
							for(i=0;i<(int)Book->morex;i++)
								pi=Book->Search(&ci);
						}
						else if (pi->morex==0)
						{
							sysmessage(s,"No default location set in runebook!");
							Player->spell = 0;
							return;
						}
						else if (curSpell==45)
						{
							sysmessage( s, "That item is not a recall rune." );
							Player->spell = 0;
							return;
						}
					}
					if (pi->isType(ITY_Rune))
					{
						playSound( Player, curSpell );				
						doStaticEffect(Player, curSpell );
						switch( curSpell )
						{
						//////////// (32) RECALL ////////////////
						case 32:
							if ( pi->morex<=200 && pi->morey<=200 )
							{
								sysmessage(s,"That rune has not been marked yet!");
								recalled = false;
							}
							else if (!Player->isGM() && Weight->CheckWeight2(Player)) //Morrolan no recall if too heavy, GM's excempt
							{
								sysmessage(s, "You are too heavy to do that!");
								sysmessage(s, "You feel drained from the attempt.");
								statwindow(s, Player);
								recalled=false;
							}
							else
							{										
								invisibleItemParticles(Player, curSpell, Player->pos);
								cCoord newPos(pi->morex,pi->morey,pi->morez,DEFAULT_MAP);
								Player->teleTo(newPos); //LB
								doStaticEffect( Player, curSpell );
								sysmessage(s,"You have recalled from the rune.");
								recalled=true;
							}
							break;
						//////////// (45) MARK //////////////////
						case 45:
							pi->morex=Player->pos.x;
							pi->morey=Player->pos.y;
							pi->morez=Player->pos.z;
							sysmessage(s,"Recall rune marked.");
							//antichrist
							calcreg=calcRegionFromXY(Player->pos);
							sprintf(pi->name, "Rune to: %s.", region[calcreg].name);
							
							cOldMagic::invisibleItemParticles(Player, curSpell, Player->pos);						

							break;
						//////////// (52) GATE //////////////////
						case 52:
							if ( pi->morex<=200 && pi->morey<=200 )
							{
								sysmessage(s,"That rune has not been marked yet!");
								recalled=false;
							}
							else
							{
								gatex[gatecount][0]=Player->pos.x;	//create gate a player location
								gatey[gatecount][0]=Player->pos.y;
								gatez[gatecount][0]=Player->pos.z;
								gatex[gatecount][1]=pi->morex; //create gate at marked location
								gatey[gatecount][1]=pi->morey;
								gatez[gatecount][1]=pi->morez;
								recalled=true;

								for (n=0;n<2;n++)
								{
									strcpy(temp,"a blue moongate");
									P_ITEM pi_c = Items->SpawnItem(Player,1,"#",0,0x0f6c,0,0);
									if (pi_c != NULL)	//AntiChrist - to prevent crashes
									{
										pi_c->setType(n ? ITY_Gate2:ITY_Gate1);
										pi_c->pos.x=gatex[gatecount][n];
										pi_c->pos.y=gatey[gatecount][n];
										pi_c->pos.z=gatez[gatecount][n];
										pi_c->gatetime=(uiCurrentTime+(SrvParms->gatetimer*MY_CLOCKS_PER_SEC));
										//Console.send("GATETIME:%i UICURRENTTIME:%d GETCLOCK:%d\n",SrvParms->gatetimer,uiCurrentTime,getclock());
										pi_c->gatenumber=gatecount;
										pi_c->dir=1;

										mapRegions->Add(pi_c);	//add gate to list of items in the region
										pi_c->refresh();
									}
								}

								gatecount++;
								if (gatecount>=MAXGATES) gatecount=0;
								//addid1[s]=0;
								//addid2[s]=0;
							}
							break;
						default:
							Console.send("MAGIC-ERROR: Unknown Travel spell %i, magic.cpp\n", curSpell );
							break;
						}
					}
					else
						sysmessage( s, "That item is not a recall rune." );
				}
			}
			else
				sysmessage( s, "Not a valid target on item!" );
			Player->spell = 0;
			return;
		}

		/////////////////////////////////////////////////////////
		// spell code goes starts for targetted spells
		/////////////////////////////////////////////////////////

		if ( reqCharTarget( curSpell ) )
		{
			P_CHAR Defender = FindCharBySerPtr(&buffer[s][7]);	// character we are attacking is HERE
			// IF TARGET VALID
			if (Defender != NULL)				// we have to have targetted a person to kill them :)
			{
				if ( Player->dist(Defender) > SrvParms->attack_distance )
				{
					sysmessage( s, "You can't cast on someone that far away!" );
					return;
				}
				if ((line_of_sight( s, Player->pos, Defender->pos, LOS_STD_BLOCKERS)||
					(Player->isGM())))
				{
					if ( aggressiveSpell( curSpell ) )
					{
						if (Defender->isInnocent() && !Player->isSameAs(Defender) && !Player->Owns(Defender) &&
							!Guilds->Compare(Defender,Player) )
						{
							criminal(Player);
						}
						if (Defender->isAiVendor()) // Ripper 11-14-99
						{
							sysmessage(s," They are Invulnerable merchants!");
							return;
						}
						Defender->FightBack(Player);
					}
					if (Spell->IsReflectable())
					{
						//Console.send("spell-reflectable\n");
						Defender = CheckMagicReflect(Player, Defender);
					}
										
					playSound( Player, curSpell );
					doMoveEffect( Player, Defender, curSpell ); // do moving effect IFF it's on of the 5 or so spells with moving effects
					if (curSpell !=30 && curSpell !=58) doStaticEffect( Defender, curSpell ); // Lb, bugfix, was (DEREF_P_CHAR(Player) ...)																									
				
					switch( curSpell )
					{
						//////////// (1) CLUMSY /////////////////
						case 1:
							tempeffect( Player, Defender, TEF_Clumsy, Player->Skill(MAGERY)/100, 0, 0);
							break;
						//////////// (3) FEEBLEMIND /////////////
						case 3:
							tempeffect( Player, Defender, TEF_FeebleMind, Player->Skill(MAGERY)/100, 0, 0);
							break;
						//////////// (4) HEAL ///////////////////
						case 4:
							int m,h;
							m=Player->Skill(MAGERY);
							if (Player->isInnocent() && !Player->isSameAs(Defender))
							{
								if (Defender->crimflag>0 || Defender->isMurderer())
								{
									criminal(Player);
								}
							}

							h=0;
							if (m<100) h=1; else
							if (m>=100 && m<200) h=2; else
							if (m>=200 && m<300) h=4; else
							if (m>=300 && m<400) h=5; else
							if (m>=400) h=6;
							if (h>2) h+=rand()%3;

							Defender->increaseHp(h);
							break;
						//////////// (5) MAGIC ARROW ////////////
						case 5:
							Magic->MagicDamage(Defender, (1+(rand()%1)+1)*(Player->Skill(MAGERY)/2000+1));
							break;
						//////////// (6) NIGHT SIGHT ////////////
						case 6:

							int fix;
							fix = timeLight.fixedInlorSpellTime*60;
							int var;
							float fk,fl,fm;
							fk = (float) (timeLight.varInlorSpellTime*60);
							fl = (float) Player->Skill(MAGERY); // get magery of caster
							fl = fl / 1000.0;			
							fm = fk * fl;
							var = (int)fm; // oki dokey, you can write all that cruft into a single line, but got somewhat shizo about badly working conversion

							tempeffect( Player, Defender, TEF_NightSight, 0, 0, 0,var+fix);
							break;
						//////////// (7) REACTIVE ARMOR /////////
						case 7:
							if (Skills->GetAntiMagicalArmorDefence(Player)>10)
							{
                                sysmessage(s,"Spell fails due to the armor on target!");
                                break;
							}
							tempeffect( Player, Defender, TEF_ReactiveArmor, Player->Skill(MAGERY)/100, 0, 0 );
							Defender->ra=1;
							break;
						//////////// (8) WEAKEN /////////////////
						case 8:
							tempeffect( Player, Defender, TEF_Weaken, Player->Skill(MAGERY)/100, 0, 0);
							break;
						//////////// (9) AGILITY ////////////////
						case 9:
							tempeffect( Player, Defender, TEF_Agility, Player->Skill(MAGERY)/100, 0, 0);
							break;
						//////////// (10) CUNNING ///////////////
						case 10:
							tempeffect( Player, Defender, TEF_Cunning, Player->Skill(MAGERY)/100, 0, 0);
							break;
						//////////// (11) CURE //////////////////
						case 11:
							Defender->PoisonWearOff(s);
							break;
						//////////// (12) HARM //////////////////
						case 12:
							if (CheckResist(Player, Defender, 2))
								Magic->MagicDamage(Defender, Player->Skill(MAGERY)/500+1);
							else
								Magic->MagicDamage(Defender, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(249+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,2));
							break;
						//////////// (15) PROTECTION ////////////
						case 15:
							if (Skills->GetAntiMagicalArmorDefence(Player)>10)
							{
                                sysmessage(s,"Spell fails due to the armor on target!");
                                break;
							}
							tempeffect(Player, Defender, TEF_Protection, Player->Skill(MAGERY)/100, 0, 0 );
							break;
						//////////// (16) STRENGTH //////////////
						case 16:
							tempeffect( Player, Defender, TEF_Strength, Player->Skill(MAGERY)/100, 0, 0);
							break;
						//////////// (17) BLESS /////////////////
						case 17:
							j=Player->Skill(MAGERY)/100;
							tempeffect( Player, Defender, TEF_Bless, j, j, j);
							break;
						//////////// (18) FIREBALL //////////////
						case 18:
							if (CheckResist(Player, Defender, 3))
								Magic->MagicDamage(Defender, Player->Skill(MAGERY)/280+1);
							else
								Magic->MagicDamage(Defender, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(139+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,4));
							break;
						//////////// (20) POISON ////////////////
						case 20:
							if (CheckResist(Player, Defender, 1)) return;
							{
								Defender->PoisonStart(s,2);
							}
							break;
						//////////// (27) CURSE /////////////////
						case 27:
							if (!CheckResist(Player, Defender, 1))
							{
								j=Player->Skill(MAGERY)/100;
								tempeffect(Player, Defender, TEF_Curse, j, j, j);
							}
							break;
						//////////// (29) GREATER HEAL //////////
						case 29:
							if (Player->isInnocent() && !Player->isSameAs(Defender))
							{
								if (Defender->crimflag>0 || Defender->isMurderer())
								{
									criminal(Player);
								}
							}
							Defender->increaseHp(Player->Skill(MAGERY)/30+RandomNum(1,12));
							break;
						//////////// (30) LIGHTNING /////////////
						case 30:
							bolteffect(Defender, true);
							if (CheckResist(Player, Defender, 4))
								Magic->MagicDamage(Defender, Player->Skill(MAGERY)/180+RandomNum(1,2));
							else
								Magic->MagicDamage(Defender, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(89+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,5));
							break;
						//////////// (31) MANA DRAIN ////////////
						case 31:
							if (!CheckResist(Player, Defender, 4))
							{
								Defender->mn-=Player->Skill(MAGERY)/35;
								if (Defender->mn<0) Defender->mn=0;
								updatestats(Defender, 1);
							}
							break;
						//////////// (37) MIND BLAST ////////////
						case 37:
							if (Player->effInt() > Defender->effInt())
							{
								if (CheckResist(Player, Defender, 5))
									Magic->MagicDamage(Defender, (Player->effInt()-Defender->effInt())/4);
								else
									Magic->MagicDamage(Defender, (Player->effInt()-Defender->effInt())/2);
							}
							else
							{
								if (CheckResist(Defender, Player, 5))
									Magic->MagicDamage(Player, (Defender->effInt()-Player->effInt())/4);
								else
									Magic->MagicDamage(Player, (Defender->effInt()-Player->effInt())/2);
							}
							cOldMagic::afterParticles(37, Player);
							break;
						//////////// (38) PARALYZE //////////////
						case 38:
							if (!CheckResist(Player, Defender, 7))
								tempeffect(Player, Defender, TEF_Paralyze, 0, 0, 0);
							break;
						//////////// (41) DISPEL ////////////////
						case 41:
							if (Defender->IsDispellable())
							{
								//staticeffect(i, 0x37, 0x2A, 0x09, 0x06);
								tileeffect(Defender->pos, 0x37, 0x2A, 0x00, 0x00);
								if (Defender->npc) Npcs->DeleteChar(Defender);
								else deathstuff(Defender);
							}
							break;
						//////////// (42) ENERGY BOLT ///////////
						case 42:
							if (CheckResist(Player, Defender, 6))
								Magic->MagicDamage(Defender, Player->Skill(MAGERY)/120);
							else
								Magic->MagicDamage(Defender, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(34+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,10));						
													
							break;
						//////////// (43) EXPLOSION /////////////
						case 43:
							if (CheckResist(Player, Defender, 6))
								Magic->MagicDamage(Defender, Player->Skill(MAGERY)/120+RandomNum(1,5));
							else
								Magic->MagicDamage(Defender, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(39+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,10));
							break;
						//////////// (44) INVISIBILITY //////////
						case 44:						
							invisibleItemParticles(Defender, curSpell, Defender->pos,true);

							Defender->hidden=2;
							SndRemoveNpcToAll(Defender);
							updatechar(Defender);
							Defender->invistimeout=uiCurrentTime+(SrvParms->invisibiliytimer*MY_CLOCKS_PER_SEC);
							break;
						//////////// (51) FLAMESTRIKE ///////////
						case 51:
							if (CheckResist(Player, Defender, 7))
								Magic->MagicDamage(Defender, Player->Skill(MAGERY)/80);
							else
								Magic->MagicDamage(Defender, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(34+1*(Defender->Skill(MAGICRESISTANCE)/30))+RandomNum(1,25));
							break;
						//////////// (53) MANA VAMPIRE //////////
						case 53:
							if (!CheckResist(Player, Defender, 7))
							{
								if (Defender->mn<40)
								{
									Player->mn += Defender->mn;
									Defender->mn=0;
								}
								else
								{
									Defender->mn-=40;
									Player->mn+=40;
								}
								updatestats(Defender, 1);
								updatestats(Player, 1);
							}
							break;
						//////////// (59) RESURRECTION //////////
						case 59:
							if (Defender->dead && Defender->InGame())
							{
								PC_ITEM House = findHouseAt(Defender->pos);	// prevent house break-ins by Uber 07-27-2002
								if (House && !Defender->Owns(House))
								{
									sysmessage(s, "That player is in someone else's house!");
									break;
								}
								
								doStaticEffect(Defender, curSpell);
								Defender->resurrect();
								//b=Targ->NpcResurrectTarget(i);		
								invisibleItemParticles(Defender, curSpell, Defender->pos);
								return;
							}
							else if (!Defender->dead) sysmessage(s,"That player isn't dead!");
							else sysmessage(s,"That player isn't online!");
							break;
							//////////// (66) CANNON FIRING /////////
/*						case 66:
							if (CheckParry(Defender, 6))
								Magic->MagicDamage(Defender, Player->skill[TACTICS]/50);
							else
								Magic->MagicDamage(Defender, Player->skill[TACTICS]/25);
							break;
*/						default:
						Console.send("MAGIC-ERROR: Unknown CharacterTarget spell %i, magic.cpp\n", curSpell );
							break;
					}
				}
				else
				{
					sysmessage(s,"There seems to be something in the way.");
				}
			}
			else
				sysmessage(s,"That is not a person.");
		}
		else if (Spell->RequiresLocationTarget())
		{
			// field spells mostly go here
			x=fx[0]=(buffer[s][11]<<8)+buffer[s][12];
			y=fy[0]=(buffer[s][13]<<8)+buffer[s][14];
			//z=buffer[s][16];
			z=buffer[s][16]+Map->TileHeight((buffer[s][17]<<8)+buffer[s][18]); // bugfix, LB
			cCoord TLoc(x,y,z,Player->pos.map);	// we can safely assume that the player is on the same map ;)

			int tser=LongFromCharPtr(&buffer[s][7]);
			P_CHAR Tpc = FindCharBySerial( tser );
			P_ITEM Tpi = FindItemBySerial( tser );
		
			// ..[1] 0-> object or item selected, 1-> terrain selected
			char_selected=item_selected=terrain_selected=false;
			if      (Tpc && buffer[s][1]==0)      char_selected=true;
            else if (Tpi && buffer[s][1]==0)      item_selected=true;
			else                                  terrain_selected=true;
					
			//AntiChrist - location check
			if (!(buffer[s][11]==0xFF && buffer[s][12]==0xFF && buffer[s][13]==0xFF && buffer[s][14]==0xFF))
			{
			if ((line_of_sight( s, Player->pos, (cCoord&) TLoc,LOS_STD_BLOCKERS)||
				(Player->isGM())))
			{
/*				if (!okToCastSpellHere(curSpell, TLoc) && !Player->isGM())  // exploit fix, recheck if ok to use magery in targeted area
				{ 
					sysmessage(s,"It's not possible to cast that spell at your target");
					return; 
				}
*/
				if ( fieldSpell( curSpell ) )
				{
					/*
					int i; i=Player->targ;
					if (Defender->flag==0x04) criminal(cc);
				{
				*/
					//AntiChrist - fixed the fields missing middle piece - 9/99
					//(changed the order of fy and fy also!)
					j=fielddir(Player, x, y, z); // lb bugfix, socket char# confusion
					if (j)
					{
						fx[0]=fx[1]=fx[2]=fx[3]=fx[4]=x;
						fy[0]=y;
						fy[1]=y+1;
						fy[2]=y-1;
						fy[3]=y+2;
						fy[4]=y-2;
					}
					else
					{
						fy[0]=fy[1]=fy[2]=fy[3]=fy[4]=y;
						fx[0]=x;
						fx[1]=x+1;
						fx[2]=x-1;
						fx[3]=x+2;
						fx[4]=x-2;
					}	// end else
				}	// end if

				playSound( Player, curSpell );
				if (curSpell != 33 && curSpell !=58) doStaticEffect( Player, curSpell );

				cChar* pc;
				int loopexit=0;

				RegGrid3x3Iterator4Chars rg3ic(Player->pos);


				switch( curSpell )
				{
					//////////// (22) TELEPORT //////////////////
					case 22:
						{ // required due to a stupid/buggy msvc 6.0 error msg ... 
						  if (char_selected) { sysmessage(s, "You can't use that spell on characters");  return; }
						  if (item_selected) { sysmessage(s, "You can't teleport there.");  return; }

						  PC_ITEM Multi;
						  Multi = findMulti( TLoc );
						  if (Multi)
						  {
							sysmessage( s, "Bad you, you can't teleport here!" );
							return;
						  }

						  const tileData *tile;
						  const landData *ln;
						  cellData mp;
						  short tn;
						  int flag;

						  tn = ShortFromCharPtr( &buffer[s][0x11] );
					
						  if (tn==0)
						  {
	                        AllMaps->SeekMap(TLoc, mp);
							
							ln = TileData->SeekLand(mp.TID);
							flag = ln->flags;
							sprintf(temp, "%s", ln->name);
						  } else	 
						  {
							tile = TileData->SeekTile( tn );
							flag = tile->flags;
							sprintf(temp, "%s", tile->name);
						  }											

						  if ( (strstr((char *)temp, "water")) || TileData->isWet(flag) )
						  {
							sysmessage(s,"Give up wanabe Jesus !");
							return;
						  }

						  if (!Map->CanMonsterMoveHere(TLoc,TLoc.z))
						  {
							int x=rand()%4;
							if      (x==1) sysmessage(s,"Har Har! Did you really think you can teleport here?");
							else if (x==3) sysmessage(s,"Bad area, you can't teleport here!");
							else           sysmessage(s,"Only pink or knallgrau Llamas can teleport here!"); 
							return;                            
						  }

						  mapRegions->Remove(Player); //LB

						  cCoord epos = Player->pos;
						  cCoord tpos(x,y,z,Player->pos.map);
						  Player->teleTo(tpos);
						  doStaticEffect( Player, curSpell );
						  cOldMagic::invisibleItemParticles(Player, curSpell, epos);
						}
						
						break;
					//////////// (24) WALL OF STONE /////////////
					case 24:

						if (char_selected) { sysmessage(s, "You can't use that spell on characters");  return; }
						id1 = 0x00;
						id2 = 0x80;
						snr = 24;
						break;
					//////////// (25) ARCH CURE /////////////////
					case 25:

						if (terrain_selected || item_selected) { sysmessage(s, "This spell can be used only on characters");  return; }

						x1=0; x2=0; y1=0; y2=0; z1=0; z2=0;

						BoxSpell(s, x1, x2, y1, y2, z1, z2);

						while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if ((pc->InGame() || pc->npc) && (pc->pos.x>=x1&&pc->pos.x<=x2)&&
							(pc->pos.y>=y1&&pc->pos.y<=y2)/*&&
							(chars[ii].pos.z>=z1&&chars[ii].pos.z<=z2)*/)
							{
								if ((line_of_sight(s, Player->pos, pc->pos, LOS_STD_BLOCKERS)||
									(Player->isGM())))
								{
									doStaticEffect(pc, 25);										
									// tempeffect(cc, ii, 2, 0, 0, 0); // lb bugfix ?? why does this cll night-sight effect
									soundeffect2(pc, 0x01E9);
									pc->ResetPoisoned();
								}
								else
								{
									sprintf(temp,"There seems to be something in the way between you and %s.", pc->name);
									sysmessage(s, temp);
								}
							}
						}
						break;
						////////// (26) ARCH PROTECTION ///////////////
					case 26:
						if (terrain_selected || item_selected)
						{
							sysmessage(s, "This spell can be used only on characters");
							return;
						}
						x1 = x2 = y1 = y2 = z1 = z2 = 0;
						BoxSpell( s, x1, x2, y1, y2, z1, z2 );
						while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if (( pc->InGame() || pc->npc) && ( pc->pos.x >= x1 && pc->pos.x <= x2 ) &&
							( pc->pos.y >= y1 && pc->pos.y <= y2 ) /*&&
							( chars[ii].pos.z >= z1 && chars[ii].pos.z <= z2 )*/)
							{
								if (( line_of_sight( s, Player->pos, pc->pos, LOS_STD_BLOCKERS)||
									( Player->isGM() )))
								{
									playSound( pc, curSpell );
									doStaticEffect( pc, 26 );	// protection
									tempeffect(Player, pc, TEF_Protection, Player->Skill(MAGERY)/100, 0, 0 );
								}
								else
								{
									sprintf( temp, "There seems to be something in the way between you and %s.", pc->name );
									sysmessage( s, temp );
								}
							}
						}
						break;
					//////////// (28) FIRE FIELD ////////////////
					case 28:

						if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }

						if (j)
						{
							id1=0x39;
							id2=0x96;
						}		// end if
						else
						{
							id1=0x39;
							id2=0x8C;
						}		// end else
						snr = 28;
						break;
					//////////// (33) BLADE SPIRITS /////////////
					case 33:
						if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }
						SummonMonster( s, 0x023E, "a blade spirit", 0x0000, x, y, z, curSpell );
						break;
					//////////// (34) DISPEL FIELD //////////////
					case 34:
						{
							if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }							
							P_ITEM pi=FindItemBySerPtr(&buffer[s][7]);
							if (pi)
							{
								if (line_of_sight(s, Player->pos, pi->pos, LOS_STD_BLOCKERS)||
									Player->isGM() )
								{
									if (pi->dispellable())
										Items->DeleItem( pi );
									soundeffect3(pi,0x0201);
								}
								else
								{
									sysmessage(s, "There seems to be something in the way.");
								}
							}
						}
						break;
					//////////// (39) POISON FIELD //////////////
					case 39:
						if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }
						if (j)
						{
							id1=0x39;
							id2=0x20;
						}
						else
						{
							id1=0x39;
							id2=0x15;
						}
						snr = 39;
						break;
					//////////// (46) MASS CURSE ////////////////
					case 46:
						x1=0; x2=0; y1=0; y2=0; z1=0; z2=0;
						if (terrain_selected || item_selected) { sysmessage(s, "This spell can be used only on characters");  return; }

						BoxSpell(s, x1, x2, y1, y2, z1, z2);

						while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if ((pc->InGame() || pc->npc) && (pc->pos.x>=x1&&pc->pos.x<=x2)&&
							(pc->pos.y>=y1&&pc->pos.y<=y2)/*&&
							(chars[ii].pos.z>=z1&&chars[ii].pos.z<=z2)*/)
							{
								if ((line_of_sight(s, Player->pos, pc->pos, LOS_STD_BLOCKERS)||
									(Player->isGM())))
								{
									if (pc->isAiVendor()) // Ripper 11-14-99
									{
										sysmessage(s," They are Invulnerable merchants!");
										return;
									}
									
									if (pc->npc) 
										npcattacktarget(pc, Player);
									doStaticEffect(pc, curSpell);
									soundeffect2(pc, 0x01FB);
									if (CheckResist(Player, pc, 6)) j=Player->Skill(MAGERY)/200;
									else j=Player->Skill(MAGERY)/75;
									tempeffect(Player, pc, TEF_Curse, j, j, j);
								}
								else
								{
									sprintf(temp,"Try as you might, but you cannot see %s well enough to cover.", pc->name);
									sysmessage(s, temp);
								}
							}
						}
						break;
					//////////// (47) PARALYZE FIELD ////////////
					case 47:
					{
						if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }
						if (j)
						{
							id1=0x39;
							id2=0x79;
						}
						else
						{
							id1=0x39;
							id2=0x67;
						}
						snr = 47;
						break;
					//////////// (48) REVEAL ////////////////////
					}
					case 48:
					{
						cCoord puntcoord1(x,y,z) ;
						if (line_of_sight(s, Player->pos, (cCoord&) puntcoord1, LOS_STD_BLOCKERS)||
							Player->isGM())
						{
							RegGrid3x3Iterator4Chars rg3ic(puntcoord1);
							j=Player->Skill(MAGERY);
							range=(((j-261)*(15))/739)+5;
							//If the caster has a Magery of 26.1 (min to cast reveal w/ scroll), range radius is
							//5 tiles, if magery is maxed out at 100.0 (except for gms I suppose), range is 20

							while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
							{
								if (pc->isHidden() && !pc->isDummy()) //does reveal hidden people as well now :)
								{
									dz=abs(pc->pos.z-z); // new--difference in z coords
									d=dist(pc->pos,puntcoord1);
									if ((d<=range)&&(dz<=15)) //char to reveal is within radius or range and no more than 15 z coords away
									{
										if (pc->isHidden() && !pc->IsPermaHidden())
											doStaticEffect(pc, curSpell);
										pc->unhide();
									}
								}
							}
							soundeffect(Player,0x01FD);
						}
						else
						{
							sysmessage(s, "You would like to see if anything was there, but there is too much stuff in the way.");
						}
						break;

					}
					case 49:///////// Chain Lightning ///////////
							///////// Forgotten, added by LB ////
					{                   
						x1=0; x2=0; y1=0; y2=0; z1=0; z2=0;
						BoxSpell(s, x1, x2, y1, y2, z1, z2);

						if (terrain_selected || item_selected) { sysmessage(s, "This spell can be used only on characters");  return; }

						while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if ((pc->InGame() || pc->npc) && (pc->pos.x>=x1&&pc->pos.x<=x2)&&
							(pc->pos.y>=y1&&pc->pos.y<=y2)/*&&
							(chars[ii].pos.z>=z1&&chars[ii].pos.z<=z2)*/)
							{
								if ((line_of_sight(s, Player->pos, pc->pos, LOS_STD_BLOCKERS)||
									(Player->isGM())))
								{
									if (pc->isAiVendor()) // Ripper 11-14-99
									{
										sysmessage(s," They are Invulnerable merchants!");
										return;
									}
									if (pc->npc) 
										npcattacktarget(Player, pc);
									bolteffect(pc,true);
									soundeffect2(Player, 0x0029); //Homey fix for chainlightning sound
									
									P_CHAR Target = CheckMagicReflect(Player, pc);
									if (CheckResist(Player, pc, 7))
									{
										Magic->MagicDamage(Target, Player->Skill(MAGERY)/70);
									}
									else
									{
										Magic->MagicDamage(Target, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(49+1*(Target->Skill(MAGICRESISTANCE)/30)));
									}
								}
								else
								{
									sysmessage(s, "You cannot see the target well.");
								}
							}
						}
					break;
					}
					//////////// (50) ENERGY FIELD //////////////
					case 50:
					{
						if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }
						if (j)
						{
							id1=0x39;
							id2=0x56;
						}
						else
						{
							id1=0x39;
							id2=0x46;
						}
						snr = 50;
						break;
					//////////// (54) MASS DISPEL ///////////////
					}
					case 54:
					{
						x1=0; x2=0; y1=0; y2=0; z1=0; z2=0;

						BoxSpell(s, x1, x2, y1, y2, z1, z2);

						//if (char_selected) { sysmessage(s, "This spell can't be used on characters");  return; }

						while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if ((pc->InGame() || pc->npc) && (pc->IsDispellable())&&
								(pc->pos.x>=x1&&pc->pos.x<=x2)&&
								(pc->pos.y>=y1&&pc->pos.y<=y2)/*&&
								(pc->pos.z>=z1&&pc->pos.z<=z2)*/)
							{
								if (line_of_sight(s, Player->pos, pc->pos, LOS_STD_BLOCKERS) || Player->isGM())
								{
									if (CheckResist(Player, pc, 7) && rand()%2==0 ) // cant be 100% resisted , LB, osi
									{
										if (pc->npc)
											pc->FightBack(Player);
										return;
									}
									if (pc->npc) deathstuff(pc); // LB !!!!
									soundeffect2(pc, 0x0204);
									doStaticEffect(pc, curSpell);
								}
							}
						}
						break;
					//////////// (55) METEOR SWARM //////////////
					}
					case 55:
					{

						if (terrain_selected || item_selected) { sysmessage(s, "This spell can be used only on characters");  return; }
						x1=0; x2=0; y1=0; y2=0; z1=0; z2=0;

						BoxSpell(s, x1, x2, y1, y2, z1, z2);
						
						while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
						{
							if ((pc->InGame() || pc->npc) && (pc->pos.x>=x1&&pc->pos.x<=x2)&&
							(pc->pos.y>=y1&&pc->pos.y<=y2)/*&&
							(pc->pos.z>=z1&&pc->pos.z<=z2)*/)
							{
								if (line_of_sight(s, Player->pos, pc->pos, LOS_STD_BLOCKERS) || Player->isGM())
								{
									if (pc->isAiVendor()) // Ripper 11-14-99
									{
										sysmessage(s," They are Invulnerable merchants!");
										return;
									}
									if (pc->npc) npcattacktarget(Player,pc);
									soundeffect2(pc, 0x160); //sound fix for swarm--Homey
									doMoveEffect(Player, pc, curSpell);
									doStaticEffect(pc, curSpell);
									if (CheckResist(Player, pc, 7))
									{
										Magic->MagicDamage(pc, Player->Skill(MAGERY)/80);
									}
									else
									{
										Magic->MagicDamage(pc, (Player->Skill(MAGERY)+1*(Player->Skill(EVALUATINGINTEL)/3))/(39+1*(pc->Skill(MAGICRESISTANCE)/30)));
									}
								}
								else
								{
									sysmessage(s, "You cannot see the target well.");
								}
							}
						}
						break;
					//////////// (58) ENERGY VORTEX /////////////
					}
					case 58:
					{
						SummonMonster( s, 0x000D, "an energy vortex", 0x0075, x, y, z, curSpell );
						break;
					}
					default:
						Console.send("MAGIC-ERROR: Unknown LocationTarget spell %i, magic.cpp\n", curSpell );
						break;
				}

				//AntiChrist - bugfix -
				//wall of stone has to be 3 tiles of length, like OSI
				int j2;
				if (id1==0x00 &&	id2==0x80)
				{//if a wall of stone
					j2=2;
				} else
				{
					j2=4;
				}
				if ( fieldSpell( curSpell ) )
				{				
					for( j=0; j<=j2; j++ )
					{
						P_ITEM pi=Items->SpawnItem(Player,1,"#",0,(id1<<8)+id2,0,0);
						if (pi)
						{
							cCoord fieldPos(fx[j], fy[j], z, Player->pos.map);
							short fieldZ = Map->Height(fieldPos, z);
							pi->dispellableOn();
							pi->decayOn();
							pi->decaytimer.setSecs(Player->Skill(MAGERY)/15);
							pi->morex=Player->Skill(MAGERY); // remember casters magery skill for damage, LB
							pi->MoveTo(fx[j], fy[j], fieldZ);
							pi->dir=29;
							pi->setNotMovable();
							pi->refresh();
							itemParticles(snr,pi);
						}
					}
				}
			} // if los

			} else { // location check
				sysmessage(s,"That is not a valid location.");
			}
		}
		else if (Spell->RequiresItemTarget())
		{
			// ITEM TARGET
			P_ITEM pi=FindItemBySerPtr(&buffer[s][7]);
			if (pi)
			{
				if (line_of_sight( s, Player->pos, pi->pos, LOS_STD_BLOCKERS) || Player->isGM())
				{
					playSound( Player, curSpell );
					switch( curSpell )
					{
						//////////// (13) MAGIC TRAP ////////////
						case 13:
							if ((pi->isType(ITY_Container) || pi->isType(ITY_SpawnChest) ||
								pi->isType(ITY_LockedContainer) || pi->isType(ITY_LockedSpawnChest))
								&& pi->id()!=0x0E75)
							{
								pi->moreb1=1;
								pi->moreb2=Player->Skill(MAGERY)/20;
								pi->moreb3=Player->Skill(MAGERY)/10;
								soundeffect3(pi,0x01F0);									
								itemParticles(13,pi);
								sysmessage(s,"It's trapped!");
							}
							else
								sysmessage(s,"You cannot trap this!!!");
							break;
						//////////// (14) MAGIC UNTRAP //////////
						case 14:
							if ((pi->isType(ITY_Container) || pi->isType(ITY_SpawnChest) ||
								pi->isType(ITY_LockedContainer) || pi->isType(ITY_LockedSpawnChest)))
							{
								if (pi->moreb1==1)
								{
									if (rand()%100<=50+(Player->Skill(MAGERY)/10)-pi->moreb3)
									{
										pi->moreb1=0;
										pi->moreb2=0;
										pi->moreb3=0;
										soundeffect3(pi, 0x01F1);
										cOldMagic::itemParticles(14,pi);
										sysmessage(s,"You successfully untrap this item!");
									}
									else sysmessage(s,"You miss to untrap this item!");
								}
								else sysmessage(s,"This item doesn't seem to be trapped!");
							}
							else sysmessage(s,"This item cannot be trapped!");
							break;
						//////////// (19) MAGIC LOCK ////////////
						case 19:
							if ((pi->isType(ITY_Container) || pi->isType(ITY_SpawnChest))
								&& pi->id()!=0x0E75 )
							{
								switch(pi->type)
								{
								case 1:	pi->setType(ITY_LockedContainer); break;
								case 63: pi->setType(ITY_LockedSpawnChest); break;
								default:
									Console.send("ERROR: Fallout of switch statement without default. magic.cpp, magiclocktarget()/n"); //Morrolan
									break;
								}
								soundeffect3(pi, 0x0200);
								cOldMagic::itemParticles(19,pi);
								sysmessage(s,"It's locked!");
							}
							else
								sysmessage(s,"You cannot lock this!!!");
							break;

						//////////// (23) MAGIC UNLOCK //////////

						case 23:
							if (pi->isType(ITY_LockedContainer) || pi->isType(ITY_LockedSpawnChest))
							{
								if (pi->getMore1_4()==0)
								{ //Make sure it isn't an item that has a key (i.e. player house, chest..etc)
									switch(pi->type)
									{
									case 8: pi->setType(ITY_Container); break;
									case ITY_LockedSpawnChest: pi->setType(ITY_SpawnChest); break;
									default:
										//LogError("switch reached default");
										return;
									}
									soundeffect3(pi,0x01FF);
									cOldMagic::itemParticles(23,pi);
									sysmessage(s, "You manage to pick the lock.");
								}
							} else
							{
								if ( pi->isType(ITY_Container) || pi->isType(ITY_SpawnChest) || pi->isType(ITY_65) || pi->isType(ITY_Trashbin) )
								{
									sysmessage( s, "That is not locked." );
								}
								else
								{
									sysmessage( s, "That does not have a lock.");
								}
							}
							break;
						//////////// (41) DISPEL ////////////////
						//case 41:
						//	if (pi->isInvul()) Items->DeleItem(i);
						//	break;
						// Uhmm.....this already is in CharacterTarget spells
						// don't think if it should be here......
						default:
							Console.send("MAGIC-ERROR: Unknown ItemTarget spell %i, magic.cpp\n", curSpell );
							break;
					}
				}
				else
					sysmessage( s, "There is something in the way!" );
			}
			else
				sysmessage( s, "That is not a valid item" );
		}
		else
			sysmessage( s, "Can't cope with this spell, requires a target but it doesn't specify what type" );
		Player->spell = 0;
		return;
	}
	else
	{
		// non targetted spells
		playSound( Player, curSpell );
		if ( curSpell != 35 && curSpell !=40) doStaticEffect( Player, curSpell );

		P_ITEM iJ;
		switch( curSpell )
		{
			//////////// (2) CREATE FOOD ////////////////
			case 2:
				iJ = Items->SpawnItem(s, Player, 1, "#", 1, 0x09D3, 0x00, 1, 1 );
				if (iJ)
				{
					iJ->setType(ITY_Food);
					iJ->AddFoodType((unsigned char)FOOD_MAGIC); // flag for new food system
					iJ->refresh();
				}
				break; // LB crashfix
			//////////// (3) SUMMON MONSTER ////////////
			case 40: //33:
				SummonMonster( s, 0, "#", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (35) INCOGNITO ////////////
			case 35:
				tempeffect(Player,TEF_Incognito,0,0,0);//Incognito temp effect
				cOldMagic::doStaticEffect(Player, curSpell);
				break;
			//////////// (36) MAGIC REFLECTION /////////
			case 36:
				Player->GiveMagicReflect();
				break;
			//////////// (56) POLYMORPH /////////////////
			case 56:
				PolymorphMenu( s, POLYMORPHMENUOFFSET ); // Antichrist's Polymorph
				break;
			//////////// (57) EARTHQUAKE ///////////////
			case 57:
				{
				dmg=(Player->Skill(MAGERY)/40)+(rand()%20-10);
				dmgmod = 0;
				
				cChar* pc;
				int loopexit=0;

				RegGrid3x3Iterator4Chars rg3ic(Player->pos);
				while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
				{
					if (pc->isInvul() || pc->isAiVendor() || pc->isDummy())	// don't affect vendors // don't damage dummy npcs
						continue;
					if (pc->isSameAs(Player))				// nor the caster
						continue;
					distx=abs(pc->pos.x - Player->pos.x);
					disty=abs(pc->pos.y - Player->pos.y);
					if (distx<=15 && disty<=15 && (pc->npc || pc->InGame()))
					{
						if (pc->isInnocent()) criminal(Player);
						
						if (!pc->isGM() && pc->account!=0)
							dmgmod = min(distx,disty);
						dmgmod = -(dmgmod - 7);
						pc->reduceHp(dmg+dmgmod);
						pc->reduceStm(rand()%10+5);
						
						if (!pc->npc && pc->InGame())
							pc->DoAction((rand()%2) ? 0x15 : 0x16);
						else
							pc->DoAction(0x02); 

						if (pc->Hp() > 0)
						{ 
							if (pc->npc)
							{
								npcattacktarget(Player,pc); 
							}
						}
					} //if Distance
				}
				}
				break;			//////////// (60) SUMMON AIR ELEMENTAL /////
			case 60:
				SummonMonster( s, 0x000D, "Air", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (61) SUMMON DAEMON ////////////
			case 61:
				SummonMonster( s, 0x000A, "Daemon", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (62) SUMMON EARTH ELEMENTAL ///
			case 62:
				SummonMonster( s, 0x000E, "Earth", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (63) SUMMON FIRE ELEMENTAL ////
			case 63:
				SummonMonster( s, 0x000F, "Fire", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (64) SUMMON WATER ELEMENTAL ///
			case 64:
				SummonMonster( s, 0x0010, "Water", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (65) SUMMON HERO //////////////
			case 65:
				SummonMonster( s, 0x03E2, "Dupre the Hero", 0, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			//////////// (67) SUMMON BLACK NIGHT ///////
			case 67:
				SummonMonster( s, 0x000A, "Black Night", 5000, Player->pos.x+1, Player->pos.y+1, Player->pos.z, curSpell );
				break;
			default:
				Console.send("MAGIC-ERROR: Unknown NonTarget spell %i, magic.cpp\n", curSpell );
				break;
		}
		//sysmessage( s, "Spells like meteor swarm will go here, eventually" );
		Player->spell = 0;
		return;
	}

}

/*bool cOldMagic::townTarget( unsigned char num )
{
	switch( num )
	{
		case 2: // create food
		case 4: // heal
		case 6: // nightsight
		case 7: // reactive armor
		case 9: // agility
		case 11: // cure
		case 15: // protection
		case 16: // strength
		case 17: // bless
		case 22: // teleport
		case 25: // arch cure
		case 26: // arch protection
		case 29: // greater heal
		case 32: // recall
		case 40: // summoncreature
		case 44: // invisibility
		case 45: // mark
		case 48: // reveal
		case 52: // gate travel
		case 59: // resurrection
		case 36: // magic reflection
		case 56: // polymorph
		case 60: // air elemental
		case 61: // daemon
		case 62: // earth elemental
		case 63: // fire elemental
		case 64: // water elemental
			return true;
		default:
			return false;
	}
	return true;
}*/

bool cOldMagic::requireTarget( unsigned char num )
{

	switch( num )
	{
	case 1: // Clumsy
	case 3: // Feeblemind
	case 4: // Heal
	case 5: // Magic Arrow
	case 6: // Night Sight
	case 7:	// Reactive Armour
	case 8: // Weaken
	case 9: // Agility
	case 10:// Cunning
	case 11:// Cure
	case 12:// Harm
	case 13:// Magic Trap
	case 14:// Magic Untrap
	case 15:// Protection
	case 16:// Strength
	case 17:// Bless
	case 18:// Fireball
	case 19:// Magic Lock
	case 20:// Poison
	case 22:// Teleport
	case 23:// Unlock
	case 24:// Wall of Stone
	case 25:// Arch Cure
	case 26:// Arch protection
	case 27:// Curse
	case 28:// Fire Field
	case 29:// Greater Heal
	case 30:// Lightning
	case 31:// Mana drain
	case 32:// Recall
	case 33:// Blade Spirits
	case 34:// Dispel Field
	case 37:// Mind Blast
	case 38:// Paralyze
	case 39:// Poison Field
	case 41:// Dispel
	case 42:// Energy Bolt
	case 43:// Explosion
	case 44:// Invisibility
	case 45:// Mark
	case 46:// Mass curse
	case 47:// Paralyze Field
	case 48:// Reveal
	case 49:// Chain Lightning
	case 50:// Energy Field
	case 51:// Flamestrike
	case 52:// Gate Travel
	case 53:// Mana Vampire
	case 54:// Mass Dispel
	case 55:// Meteor Swarm
	case 58:// Energy Vortex
	case 59:// Resurrection
	case 66:// Cannon Firing
			return true;


	case 36:// Magic Reflection
	case 57:// Earthquake
	case 56:// Polymorph
	case 60:// Summon Air Elemental
	case 61:// Summon Daemon
	case 62:// Summon Earth Elemental
	case 63:// Summon Fire Elemental
	case 64:// Summon Water Elemental
	case 65:// Summon Hero
	case 67:// Summon Black Night
	default:
			return false;
	}
	return false;
}

void cOldMagic::DelReagents( P_CHAR pc, int num )
{
	if (!pc) return;
	if (pc->DoesNotNeedRegs()) return;

	reag_st& R = spells[num].reagents;
	pc->deleteItems(R.pearl,	0x0F7A);
	pc->deleteItems(R.moss,		0x0F7B);
	pc->deleteItems(R.garlic,	0x0F84);
	pc->deleteItems(R.ginseng,	0x0F85);
	pc->deleteItems(R.drake,	0x0F86);
	pc->deleteItems(R.shade,	0x0F88);
	pc->deleteItems(R.ash,		0x0F8C);
	pc->deleteItems(R.silk,		0x0F8D);
}

bool cOldMagic::reqCharTarget( int num )
{
	switch( num )
	{
		case 1:	// Clumsy
		case 3:	// Feeblemind
		case 4:	// Heal
		case 5:	// Magic Arrow
		case 6:	// Night Sight
		case 7:	// Reactive armour
		case 8:	// Weaken
		case 9:	// Agility
		case 10: // Cunning
		case 11: // Cure
		case 12: // Harm
		case 15: // Protection
		case 16: // Strength
		case 17: // Bless
		case 18: // Fireball
		case 20: // Poison
		case 27: // Curse
		case 29: // Greater Heal
		case 30: // Lightning
		case 31: // Mana drain
		case 37: // Mind Blast
		case 38: // Paralyze
		case 41: // Dispel
		case 42: // Energy Bolt
		case 43: // Explosion
		case 44: // Invisibility
		case 51: // Flamestrike
		case 53: // Mana Vampire
		case 56: // Polymorph
		case 59: // Resurrection
		case 66: // Cannon Firing
			return true;
		default:
			return false;
	}
	return false;
}

bool cOldMagic::reqLocTarget( int num )
{
	switch( num )
	{
		case 22:// Teleport
		case 24:// Wall of Stone
		case 25:// Arch Cure
		case 26:// Arch protection
		case 28:// Fire Field
		case 33:// Blade Spirits
		case 34:// Dispel Field
		case 39:// Poison Field
		case 46:// Mass curse
		case 47:// Paralyze Field
		case 48:// Reveal
		case 49:// Chainlightning
		case 50:// Energy Field
		case 54:// Mass Dispel
		case 55:// Meteor Swarm
		case 58:// Energy Vortex
			return true;
		default:
			return false;
	}
	return false;
}

move_st cOldMagic::getMoveEffects( int num )
{
	move_st temp;
	int te0,te1,te2,te3,te4;                // 2d move efefcts
	int te5,te6,te7,te8,te9,te10,te11,te12,te13, te14, te15, te16, te17; // 3d moving effects
	switch( num )
	{
	case 5:		te0=0x36; te1=0xE4; te2=0x05; te3=0x00; te4=0x01; 
		        te5=0x36; te6=0xe4; te7=0x07; te8=0x00; te9=0x0b; te10=0xbe; te11=0x0f; te12=0xa6; te13=0x00; te14=0x00; te15=0; te16=0; te17=0;
				break;

	case 18:	te0=0x36; te1=0xD5; te2=0x07; te3=0x00; te4=0x01; 
		        te5=0x36; te6=0xd4; te7=0x07; te8=0x00; te9=0x0b; te10=0xcb; te11=0x0f; te12=0xb3; te13=0x1; te14=0x60;te15=0; te16=1; te17=0;
		        break;

	case 42:	te0=0x37; te1=0x9F; te2=0x07; te3=0x00; te4=0x01; 
		        te5=0x37; te6=0x9f; te7=0x07; te8=0x00; te9=0x0b; te10=0xe3; te11=0x0f; te12=0xcb; te13=0x2; te14=0x11; te15=0; te16=1; te17=0;
		        break;

	case 55:	te0=0x36; te1=0xD5; te2=0x07; te3=0x00; te4=0x01; 
		        te5=0x36; te6=0xd4; te7=0x0a; te8=0x07; te9=0x25; te10=0x1d; te11=0x00; te12=0x01; te13=0x0; te14=0x0; te15=0; te16=1; te17=1;
		        break;
						        

	default:	te0=-1;	  te1=-1;   te2=-1;   te3=-1;   te4=-1;
		        te5=te6=te7=te8=te9=te10=te11=te12=te13=te14=te15=te16=te17=-1;
	}

	temp.effect[0]=te0;
	temp.effect[1]=te1;
	temp.effect[2]=te2;
	temp.effect[3]=te3;
	temp.effect[4]=te4;
	temp.effect[5]=te5;
	temp.effect[6]=te6;
	temp.effect[7]=te7;
	temp.effect[8]=te8;
	temp.effect[9]=te9;
	temp.effect[10]=te10;
	temp.effect[11]=te11;
	temp.effect[12]=te12;
	temp.effect[13]=te13;
	temp.effect[14]=te14;
	temp.effect[15]=te15;
	temp.effect[16]=te16;
	temp.effect[17]=te17;

	return temp;
}

stat_st cOldMagic::getStatEffects( int num )
{
	stat_st temp;
	int te0,te1,te2,te3,te4;      // 2d effects
	int te5,te6,te7,te8,te9,te10,te11,te12; // 3d particles

	te5=te6=te7=te8=te9=te10=0;
    te11=0; te12=1;
	switch( num )
	{
	case 1:		te0=0x37; te1=0x4A; te2=0x00; te3=15; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x8a; te10=0xffffff00;			
				break;
	case 3:		te0=0x37; te1=0x4A; te2=0x00; te3=15; 
		        te4=0x37; te5=0x79; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x8c; te10=0xffffff00;
		        break;
	case 4:		te0=0x37; te1=0x6A; te2=0x09; te3=0x06; 
		        te4=0x37; te5=0x6A; te6=0x09; te7=0x20;
				te8=0x13; te9=0x8d; te10=0xffffff00;
		        break;
	case 7:		te0=0x37; te1=0x3A; te2=0x00; te3=15;
		        te4=0x37; te5=0x6A; te6=0x09; te7=0x20;
				te8=0x13; te9=0x90; te10=0xffffff03;
		        break; 
	case 8:		te0=0x37; te1=0x4A; te2=0x00; te3=15;
		        te4=0x37; te5=0x79; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x91; te10=0xffffff00;
				break;
	case 9:		te0=0x37; te1=0x3A; te2=0x00; te3=15;
		        te4=0x37; te5=0x5a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x92; te10=0xffffff03;
				break;
	case 10:	te0=0x37; te1=0x3A; te2=0x00; te3=15;
		        te4=0x37; te5=0x5a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x93; te10=0xffffff00;
				break;
	case 11:	te0=0x37; te1=0x6A; te2=0x09; te3=0x06;
		        te4=0x37; te5=0x3a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x94; te10=0xffffff03;
				break;
	case 12:	te0=0x37; te1=0x4A; te2=0x09; te3=0x07; 
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x95; te10=0xffffff03;
		        break;
	case 15:	te0=0x37; te1=0x6A; te2=0x09; te3=0x06; 
		        te4=0x37; te5=0x5a; te6=0x09; te7=0x14;
				te8=0x13; te9=0x98; te10=0xffffff03;
		        break;
	case 16:	te0=0x37; te1=0x3A; te2=0x00; te3=15; 
		        te4=0x37; te5=0x5a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x99; te10=0xffffff03;
		        break;
	case 17:	te0=0x37; te1=0x3A; te2=0x00; te3=15; 
		        te4=0x37; te5=0x3a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x9a; te10=0xffffff02;
		        break;
	case 20:	te0=0x37; te1=0x4A; te2=0x00; te3=15;
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x9d; te10=0xffffff03;
		        break;
	case 22:	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x37; te5=0x28; te6=0x0a; te7=0x00;
				te8=0x13; te9=0x9f; te10=0xffffff00;
		        break;
	case 25:	te0=0x37; te1=0x6A; te2=0x09; te3=0x06; 
		        te4=0x37; te5=0x6a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x94; te10=0xffffff03;
		        break;
	case 26:    te0=0x37; te1=0x5A; te2=0x09; te3=0x06; 
		        te4=0x37; te5=0x5a; te6=0x09; te7=0x14;
				te8=0x13; te9=0xa3; te10=0xffffff03;
				break;
	case 27:	te0=0x37; te1=0x4A; te2=0x00; te3=15;
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0xa4; te10=0xffffff03;
				break;
	case 29:	te0=0x37; te1=0x6A; te2=0x09; te3=0x06; 
                te4=0x37; te5=0x6a; te6=0x09; te7=0x20;
				te8=0x13; te9=0xa6; te10=0xffffff03;
		        break;
	case 49:
	case 30:	te0=0x37; te1=0x4A; te2=0x00; te3=15; 		
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x05;
				te8=0x13; te9=0xa7; te10=0xffffff03;
		        break;
	case 31:	te0=0x37; te1=0x4A; te2=0x00; te3=15; 		
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0xa8; te10=0xffffff00;
		        break;
	case 32:  	te0=0x37; te1=0x4A; te2=0x00; te3=15; 		
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x05;
				te8=0x13; te9=0xa9; te10=0xffffff03;
		        break;
	case 33:  	te0=0x37; te1=0x4A; te2=0x00; te3=15; 		
		        te4=0x37; te5=0x28; te6=0x0a; te7=0x00;
				te8=0x13; te9=0xaa; te10=0xffffff00;
		        break;
	case 35:  	te0=0x37; te1=0x4A; te2=0x00; te3=15; 		
		        te4=0x37; te5=0x3a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0xac; te10=0xffffff00;
		        break;
	case 36:	te0=0x37; te1=0x3A; te2=0x00; te3=15;
		        te4=0x37; te5=0x5a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0xad; te10=0xffffff03;				
		        break;
	case 37:	te0=0x37; te1=0x4A; te2=0x00; te3=15; 	            
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x0f;
				te8=0x07; te9=0xf6; te10=0xffffff00;	
		        break;
	case 38:	te0=0x37; te1=0x35; te2=0x00; te3=30;
		        te4=0x37; te5=0x6a; te6=0x06; te7=0x01;
				te8=0x13; te9=0xaf; te10=0xffffff05;
				break;
	case 40:
	case 48:    te0=0x37; te1=0x35; te2=0x00; te3=30;
		        te4=0x37; te5=0x28; te6=0x0a; te7=0x0a;
				te8=0x13; te9=0xb1; te10=0xffffff00;
				break;
	case 43:	te0=0x36; te1=0xB0; te2=0x09; te3=0x09; 
		        te4=0x36; te5=0xbd; te6=0x0a; te7=0x0a;
				te8=0x13; te9=0xb4; te10=0xffffff00;
		        break;
	case 46:	te0=0x37; te1=0x4A; te2=0x00; te3=15; 
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x95; te10=0xffffff03;		 
		        break;		
	case 51:	te0=0x37; te1=0x09; te2=0x09; te3=0x19; 			   
		        te4=0x37; te5=0x09; te6=0x0a; te7=0x1e;
				te8=0x13; te9=0xbc; te10=0xffffff05;
		        break;
	case 53:	te0=0x37; te1=0x4A; te2=0x00; te3=15; 
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0xbe; te10=0xffffff00;		
		        break;
	case 54:	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x37; te5=0x28; te6=0x0a; te7=0x0a;
				te8=0x13; te9=0x9f; te10=0xffffff00;		
		        break;
	case 55:	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x05;
				te10=rand()%3;
				switch (te10)
				{
				  case 0: te8=0x13; te9=0xc0; break;
				  case 1: te8=0x17; te9=0xa8; break;
				  case 2: te9=0x1b; te9=0x90; break;
				  default: te8=0x13; te9=0xc0; 
				}
				te10=0xffffff00;		
		        break;
	case 58: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x05;
				te8=0x13; te9=0xc3; te10=0xffffff00;
				break;
	case 59: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x36; te5=0x6a; te6=0x09; te7=0x20;
			    te8=0x25; te9=0x1d; te10=0xffffff03;			
				break;
	case 60: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x20;
			    te8=0x13; te9=0xc5; te10=0xffffff03;			
				//te11=27; te12=0xf;
				break;
	case 61: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x00;
			    te8=0x13; te9=0xc6; te10=0xffffff03;			
				break;
	case 62: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x20;
			    te8=0x13; te9=0xc7; te10=0xffffff03;			
				break;
	case 63: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x20;
			    te8=0x13; te9=0xc8; te10=0xffffff03;			
				break;
	case 64: 	te0=0x37; te1=0x2A; te2=0x09; te3=0x06; 
		        te4=0x00; te5=0x00; te6=0x09; te7=0x00;
			    te8=0x13; te9=0xc9; te10=0xffffff03;			
				break;

	case 66:	te0=0x36; te1=0xB0; te2=0x09; te3=0x09; 
		        te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f;
				te8=0x13; te9=0x9e; te10=0xffffff00;	
		        break;

	case 99:	te0=0x37; te1=0x35; te2=0x00; te3=0x30;  // fizzle
		        te4=0x00; te5=0x00; te6=0x0a; te7=0x0f;
				te8=0x0f; te9=0xcb; te10=0xffffff01;	
		        break;			 

	default:	te0=-1;	te1=-1;	te2=-1;	te3=-1; te4=-1; te5=-1; te6=-1; te7=-1; te8=-1; te9=-1; te10=-1; break;
	}

	temp.effect[0]=te0;
	temp.effect[1]=te1;
	temp.effect[2]=te2;
	temp.effect[3]=te3;
	temp.effect[4]=te4;
	temp.effect[5]=te5;
	temp.effect[6]=te6;
	temp.effect[7]=te7;
	temp.effect[8]=te8;
	temp.effect[9]=te9;
	temp.effect[10]=te10;
	temp.effect[11]=te11;
	temp.effect[12]=te12;
	
	return temp;
}


stat_st cOldMagic::getStatEffects_pre( int num)
{
    stat_st temp;
    memset( &temp, -1, sizeof ( stat_st ) );    	
	int te4,te5,te6,te7,te8,te9,te10,te11,te12; // 3d particles

	te11=0; te12=1;
	switch( num )
	{
	case 1:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 2:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x33; te10=0xffff0102; break;
	case 3:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;		        
	case 4:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;		
	case 5:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x51; te10=0xffff0102; break;
	case 6:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 7:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x33; te10=0xffff0102; break;		        
	case 8:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;

	case 9:	   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;
	case 10:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;
	case 11:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;
	case 12:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x51; te10=0xffff0102; break;
	case 13:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x29; te10=0xffff0102; break;
	case 14:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x29; te10=0xffff0102; break;
	case 15:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x33; te10=0xffff0102; break;
	case 16:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;

	case 17:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x51; te10=0xffff0102; break;
	case 18:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x51; te10=0xffff0102; break;
	case 19:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x29; te10=0xffff0102; break;
	case 20:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x5b; te10=0xffff0102; break;
	case 21:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 22:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 23:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x29; te10=0xffff0102; break;
	case 24:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x33; te10=0xffff0102; break;
	case 25:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;

	case 26:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x33; te10=0xffff0102; break;
	case 27:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 28:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x51; te10=0xffff0102; break;
	case 29:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x65; te10=0xffff0102; break;
	case 30:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x3d; te10=0xffff0102; break;
	case 31:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 32:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;

	case 33:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x50; te10=0x02010102; break;
	case 34:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;
	case 35:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;
	case 36:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x34; te10=0xffff0102; break;
	case 37:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x48; te10=0xffff0102; break;
	case 38:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x34; te10=0xffff0102; break;
	case 39:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x5c; te10=0xffff0102; break;
	case 40:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x50; te10=0xffff0102; break;

	case 41:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;
	case 42:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x3e; te10=0xffff0102; break;
	case 43:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x51; te10=0xffff0102; break;
	case 44:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;
	case 45:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;
	case 46:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x47; te10=0xffff0102; break;
	case 47:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x34; te10=0xffff0102; break;
	case 48:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;

	case 49:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x3e; te10=0xffff0102; break;
	case 50:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x3e; te10=0xffff0102; break;
	case 51:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x52; te10=0xffff0102; break;
	case 52:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x48; te10=0xffff0102; break;
	case 53:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x48; te10=0xffff0102; break;
	case 54:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;
	case 55:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x52; te10=0xffff0102; break;
	case 56:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x2a; te10=0xffff0102; break;

	case 57:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x34; te10=0xffff0102; break;
	case 58:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x48; te10=0xffff0102; break;
	case 59:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x66; te10=0xffff0102; break;
	case 60:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x32; te10=0xffff0102; break;
	case 61:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x5a; te10=0xffff0102; break;
	case 62:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x3c; te10=0xffff0102; break;
	case 63:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x5a; te10=0xffff0102; break;
	case 64:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x23; te9=0x6e; te10=0xffff0102; break;

	default:	te4=-1;	te5=-1;	te6=-1;	te7=-1; te8=-1; te9=-1; te10=-1; te11=-1; break;
	}

	temp.effect[4]=te4;
	temp.effect[5]=te5;
	temp.effect[6]=te6;
	temp.effect[7]=te7;
	temp.effect[8]=te8;
	temp.effect[9]=te9;
	temp.effect[10]=te10;
	temp.effect[11]=te11;
	temp.effect[12]=te12;
	
	return temp;
}

stat_st cOldMagic::getStatEffects_after( int num)
{
    stat_st temp;
    memset( &temp, -1, sizeof ( stat_st ) );    	
	int te4,te5,te6,te7,te8,te9,te10, te11,te12;

	te11=0; te12=1;
	switch( num )
	{
	   case 6:	  te4=0x37; te5=0x6a; te6=0x09; te7=0x20; te8=0x13; te9=0x8f; te10=0xffff0003; break;	  	 
	   case 37:   te4=0x37; te5=0x4a; te6=0x0a; te7=0x0f; te8=0x13; te9=0xae; te10=0xffff0000; break;
	   case 38:   te4=0x00; te5=0x00; te6=0x0a; te7=0x05; te8=0x13; te9=0xaf; te10=0xffffff05; te11=0x27; te12=0x0f; break;
	   default:	te4=-1;	te5=-1;	te6=-1;	te7=-1; 
     		    te8=te9=te10=te11=te12=-1;
		        break;
	}

	temp.effect[4]=te4;
	temp.effect[5]=te5;
	temp.effect[6]=te6;
	temp.effect[7]=te7;
	temp.effect[8]=te8;
	temp.effect[9]=te9;
	temp.effect[10]=te10;
	temp.effect[11]=te11;
	temp.effect[12]=te12;
	
	return temp;
}


stat_st cOldMagic::getStatEffects_item( int num)
{
    stat_st temp;
    memset( &temp, -1, sizeof ( stat_st ) );    	
	int te4,te5,te6,te7,te8,te9,te10, te11;

	switch( num )
	{	  
	   case 13:   te4=0x37; te5=0x6a; te6=0x09; te7=0x0a; te8=0x13; te9=0x96; te10=0xffff0000; te11=0; break;
	   case 14:   te4=0x37; te5=0x6a; te6=0x09; te7=0x20; te8=0x13; te9=0x8f; te10=0xffff0003; te11=0; break;
	   case 19:   te4=0x37; te5=0x6a; te6=0x09; te7=0x20; te8=0x13; te9=0x9c; te10=0xffff0002; te11=0; break;
	   case 22:   te4=0x37; te5=0x28; te6=0x0a; te7=0x00; te8=0x07; te9=0xe7; te10=0xffff0002; te11=0; break;
	   case 23:   te4=0x37; te5=0x6a; te6=0x09; te7=0x20; te8=0x13; te9=0xa0; te10=0xffff0003; te11=0; break;
	   case 24:   te4=0x37; te5=0x6a; te6=0x09; te7=0x0a; te8=0x13; te9=0xa1; te10=0xffff0003; te11=0; break;
	   case 28:   te4=0x37; te5=0x6a; te6=0x0f; te7=0x0a; te8=0x13; te9=0xa5; te10=0xffff0000; te11=0; break;
	   case 32:   te4=0x00; te5=0x00; te6=0x00; te7=0x00; te8=0x13; te9=0xa9; te10=0xffff0003; te11=0; break;
	   case 39:   te4=0x37; te5=0x6a; te6=0x09; te7=0x0a; te8=0x13; te9=0xb0; te10=0xffff0000; te11=0; break;
	   case 44:   te4=0x37; te5=0x6a; te6=0x0a; te7=0x0f; te8=0x13; te9=0xb5; te10=0xffff0003; te11=0; break;
	   case 45:   te4=0x37; te5=0x79; te6=0x0a; te7=0x0f; te8=0x13; te9=0xb6; te10=0xffff0003; te11=0; break;
	   case 47:   te4=0x37; te5=0x6a; te6=0x09; te7=0x0a; te8=0x13; te9=0xb8; te10=0xffff0003; te11=0; break;
	   case 50:   te4=0x37; te5=0x6a; te6=0x09; te7=0x0a; te8=0x13; te9=0xbb; te10=0xffff0003; te11=0; break;
	   case 59:   te4=0x00; te5=0x00; te6=0x00; te7=0x00; te8=0x13; te9=0xc4; te10=0xffff0003; te11=0; break;

	   default:	te4=-1;	te5=-1;	te6=-1;	te7=-1; 
		        te8=te9=te10=te11=-1;
		        break;
	}

	temp.effect[4]=te4;
	temp.effect[5]=te5;
	temp.effect[6]=te6;
	temp.effect[7]=te7;
	temp.effect[8]=te8;
	temp.effect[9]=te9;
	temp.effect[10]=te10;
	temp.effect[11]=te11;
	
	return temp;
}


void cOldMagic::invisibleItemParticles(P_CHAR pc, int spellNum, cCoord epos, bool overhead)
{
	P_ITEM it;

    // create a dummy item for the effect on old location 
    it=Items->SpawnItem(pc, 1, "bugalert, plz let the devteam know", 0, 0x1, 0x00, 0);					
    it->pos=epos;
	if (overhead)
		it->pos.z+=12;					
	it->refresh();
	itemParticles(spellNum, it );
	// this is rather tricky, deleitem can't be applied there 
	// because the client has to tihnk its still there. np because it's an invisible item anyway
	// but we have to tell the memory manger to delete it
	removefromptr(&itemsp[it->serial%HASHMAX], it );
	it->free=1;	
}

static short getSoundEffects( int num )
{
	short te0;

	switch( num )	// The reason why I deleted some is because they already have
	{				// sounds in other parts of the code, keep them in if you want,
					// even the deleted numbers have been corrected - Paul77
	case 1:		te0=0x01DF; break;
	case 2:		te0=0x01E2; break;
	case 3:		te0=0x01E4; break;
	case 4:		te0=0x01F2; break;
	case 5:		te0=0x01E5; break;
	case 6:		te0=0x01E3; break;
	case 7:		te0=0x01EE; break;
	case 8:		te0=0x01E6; break;
	case 9:		te0=0x01E7; break;
	case 10:	te0=0x01EB; break;
	case 11:	te0=0x01E0; break; // Changed by Paul77
	case 12:	te0=0x01F1; break;
	case 13:	te0=0x01EF; break; // Added by Paul77
	case 14:	te0=0x01F0; break; // Added by Paul77
	case 15:	te0=0x01ED; break; // Changed by Paul77
	case 16:	te0=0x01EE; break;
	case 17:	te0=0x01EA; break;
	case 18:	te0=0x015E; break;
	case 19:	te0=0x01F4; break; // Added by Paul77
	case 20:	te0=0x0205; break; // Changed by Paul77
	case 22:	te0=0x01FE; break;
	case 23:	te0=0x01FF; break; // Added by Paul77
	case 24:	te0=0x01F6; break;
//	case 25:	te0=0x01E9; break; Deleted by Paul77
	case 26:	te0=0x01F7; break;
	case 27:	te0=0x01E1; break;
	case 28:	te0=0x020C; break;
	case 29:	te0=0x0202; break;
	case 30:	te0=0x0029; break;
	case 31:	te0=0x01F9; break;
	case 32:	te0=0x01FC; break;
//	case 33:	te0=0x0212; break; Deleted by Paul77
	case 34:	te0=0x0201; break;
//	case 35:	te0=0x0203; break; Deleted by Paul77 - Should not have a sound for Incognito
	case 36:	te0=0x01E9; break;
	case 37:	te0=0x0213; break;
	case 38:	te0=0x0204; break;
	case 39:	te0=0x020C; break;
	case 41:	te0=0x0201; break; // Changed by Paul77
	case 42:	te0=0x020A; break;
	case 43:	te0=0x0207; break;
	case 44:	te0=0x0203; break;
	case 45:	te0=0x01FA; break;
//	case 46:	te0=0x01FB; break; Changed and Deleted by Paul77
	case 47:	te0=0x020B; break;
	case 48:	te0=0x01FD; break; // Sound happens twice (probably justified so kept it) - Paul77
//	case 49:	te0=0x0029; break; Deleted by Paul77
	case 50:	te0=0x020B; break; // Changed by Paul77
	case 51:	te0=0x0208; break;
	case 52:	te0=0x020E; break;
	case 53:	te0=0x01F9; break; // Changed by Paul77
	case 54:	te0=0x0209; break; // Changed by Paul77
	case 55:	te0=0x0160; break; // Sound happens twice (probably justified so kept it) - Paul77
//	case 58:	te0=0x0212; break; Changed and Deleted by Paul77
//	case 60:	te0=0x0217; break; Deleted by Paul77
//	case 61:	te0=0x0216; break; Deleted by Paul77
//	case 62:	te0=0x0217; break; Deleted by Paul77
//	case 63:	te0=0x0217; break; Deleted by Paul77
//	case 64:	te0=0x0217; break; Deleted by Paul77
	case 65:	te0=0x0246; break;
	case 66:	te0=0x0207; break;

	default:	te0=-1;	break;
	}
	return te0;
}

void cOldMagic::playSound(P_CHAR pc, int num)
{
	short se = getSoundEffects( num );
	if ( se != -1 )
		soundeffect2(pc, se);
}

void cOldMagic::doStaticEffect(P_CHAR pc , int num )
{
	if (!pc) return;
	stat_st temp;
	memset( &temp , -1, sizeof(stat_st) );	
	temp = getStatEffects( num );

	if ( temp.effect[0] != -1 && temp.effect[1] != -1 && temp.effect[2] != -1 && temp.effect[3] != -1 )
	{
		staticeffect( pc, (temp.effect[0]<<8)+temp.effect[1], temp.effect[2], temp.effect[3], true,  &temp);
		// looks stupid to pass a pointer to a struct variable and elements of the *same* struct variable
		// actually it's very tricky but ok. (via pointer #4..15 is accessed, saved work to change a few 1000 LOC's) 
		// please don't touch. thx, LB 
	}
}

void cOldMagic::doMoveEffect( P_CHAR source, P_CHAR target, int num)
{
	if (source==NULL || target==NULL) return;

	move_st temp;
	memset( &temp , -1, sizeof( move_st) );	

	temp = getMoveEffects( num );

	if ( temp.effect[0] != -1 && temp.effect[1] != -1 && temp.effect[2] != -1 && temp.effect[3] != -1 && temp.effect[4] != -1 )
		movingeffect(source, target, temp.effect[0], temp.effect[1], temp.effect[2], temp.effect[3], temp.effect[4], true, &temp );
}

bool cOldMagic::aggressiveSpell( int num )
{
	switch( num )
	{
	case 1: // Clumsy
	case 3: // Feeblemind
	case 5: // Magic Arrow
	case 8: // Weaken
	case 12:// Harm
	case 18:// Fireball
	case 20:// Poison
	case 27:// Curse
	case 30:// Lightning
	case 31:// Mana drain
	case 37:// Mind Blast
	case 38:// Paralyze
	case 42:// Energy Bolt
	case 43:// Explosion
	case 46:// Mass curse
	case 49:// Chain Lightning
	case 51:// Flamestrike
	case 53:// Mana Vampire
	case 55:// Meteor Swarm
	case 66:// Cannon Firing
			return true;
	default:
			return false;
	}
	return false;
}

bool cOldMagic::fieldSpell( int num )
{
	switch( num )
	{
		case 24:// Wall of Stone
		case 28:// Fire Field
		case 39:// Poison Field
		case 47:// Paralyze Field
		case 50:// Energy Field
			return true;
		default:
			return false;
	}
}

// added by AntiChrist (9/99)
void cOldMagic::PolymorphMenu(int s,int gmindex)
{
	int total, i, loopexit=0;
	char lentext;
	char sect[512];
	static char gmtext[30][257];
	int gmid[30];
	int gmnumber=0,dummy=0;

	openscript("polymorph.scp");
	sprintf(sect, "POLYMORPHMENU %i",gmindex);
	if (!i_scripts[polymorph_script]->find(sect))
	{
		closescript();
		return;
	}
	read1();
	lentext=sprintf(gmtext[0],script1);
	do
	{
		read2();
		if (script1[0]!='}' && strcmp("POLYMORPHID",script1))
		{
			gmnumber++;
			gmid[gmnumber]=hstr2num(script1);
			strcpy(gmtext[gmnumber],script2);
			read1();
		}
	}
	while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );

	// reading polymorph duration time ...
	sprintf(sect, "POLYMORPHDURATION %i",dummy);
	if (!i_scripts[polymorph_script]->find(sect))
	{
		closescript();
		return;
	}

	loopexit=0;
	do
	{
		read2();
		if (script1[0]!='}')
		{
			polyduration=str2num(script1);
			read1();
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	closescript();

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	total=9+1+lentext+1;
	for (i=1;i<=gmnumber;i++) total+=4+1+strlen(gmtext[i]);

	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};

	LongToCharPtr(Player->serial,&gmprefix[3]);

	gmprefix[7]=gmindex>>8;
	gmprefix[8]=gmindex%256;

	XStartPkt(0x7c, total);
	XAddPkt(&gmprefix[0+3], 9-3);

	XAddPkt((unsigned char*)&lentext, 1);
	XAddPkt((unsigned char*)&gmtext[0], lentext);

	lentext=gmnumber;

	XAddPkt((unsigned char*)&lentext, 1);

	for (i=1;i<=gmnumber;i++)
	{
		gmmiddle[0]=gmid[i]>>8;
		gmmiddle[1]=gmid[i]%256;

		XAddPkt(&gmmiddle[0], 4);

		lentext=strlen(gmtext[i]);

		XAddPkt((unsigned char*)&lentext, 1);
		XAddPkt((unsigned char*)&gmtext[i], lentext);
	}

	XFinishPkt(s);
}

// added by AntiChrist (9/99)
void cOldMagic::Polymorph(int s, int gmindex, int creaturenumber)
{
	int i,k,loopexit=0;
	int id1,id2;

	char sect[512];
	openscript("polymorph.scp");
	sprintf(sect, "POLYMORPHMENU %i",gmindex);
	if (!i_scripts[polymorph_script]->find(sect))
	{
		closescript();
		return;
	}
	read1();
	i=0,k=0;

	do
	{
		read2();
		if (script1[0]!='}' && strcmp("POLYMORPHID",script1))
		{
			i++;
		}
	}
	while ( (script1[0]!='}') && (i<creaturenumber) && (++loopexit < MAXLOOPS) );

	read2();
	k=hstr2num(script2);

	closescript();

	id1=k>>8;
	id2=k%256;

	P_CHAR pc = MAKE_CHAR_REF(currchar(s));
	if (pc==NULL) return;

	//	soundeffect2(cc, 0x02, 0x0F); Deleted by Paul77 - Polymorph doesn't have a sound
	tempeffect(pc,TEF_Polymorph,id1,id2,0);

	teleport(pc, pc->pos); // position unchanged !!!
}

// only used for the /heal command
// LB
void cOldMagic::Heal(UOXSOCKET s, P_CHAR Player, P_CHAR Patient)
{
	if (!Player) return;
	if (Patient)
	{
		playSound(Player, 4);
		doStaticEffect(Patient, 4);
		Patient->fullHp();
		updatestats(Patient,0);
	}
	else sysmessage(s,"Not a valid heal target");
}

// only used for the /recall command
// AntiChrist
void cOldMagic::Recall(UOXSOCKET s, P_CHAR Player, P_ITEM pi)
{
	if (!Player) return;
	if (pi)	//Targeted item
	{
		if ( pi->morex<=200 && pi->morey<=200 )
		{
			sysmessage(s,"That rune has not been marked yet!");
		}
		else
		{
			cCoord newPos(pi->morex,pi->morey,pi->morez,DEFAULT_MAP);
			Player->teleTo(newPos);
			sysmessage(s,"You have recalled from the rune.");
		}
	} else sysmessage(s,"Not a valid recall target");//AntiChrist
}

// only used for the /mark command
// AntiChrist
void cOldMagic::Mark(UOXSOCKET s, P_CHAR Player, P_ITEM pi)
{
	if (!Player) return;
	if (pi)	//Targeted item
	{
		pi->morex=Player->pos.x;
		pi->morey=Player->pos.y;
		pi->morez=Player->pos.z;
		sysmessage(s,"Recall rune marked.");
	} else sysmessage(s,"Not a valid mark target");//AntiChrist
}

void cOldMagic::BuildCannon(int s, P_CHAR Player)
{
	if (!Player) return;

	soundeffect(Player, 0x0245);
	soundeffect(Player, 0x0246);
	
	P_ITEM iK = Items->SpawnItem(Player,1,"#",0,0x0E91,0,0);
	if (!iK) return;
	iK->setType(ITY_CastingItem);
	iK->morex=8;
	iK->morey=10;
	iK->morez=0;
	iK->setAllwaysMovable();
	iK->decaytimer.reset();
	iK->pos.x=ShortFromCharPtr(&buffer[s][11]);
	iK->pos.y=ShortFromCharPtr(&buffer[s][13]);
	iK->pos.z=buffer[s][16];
	iK->refresh();
}


// only used for the /gate command
// AntiChrist
void cOldMagic::Gate(UOXSOCKET s)
{
	int n;

	P_ITEM pi=FindItemBySerPtr(&buffer[s][7]);	//Targeted item
	if (pi)
	{
		if ( pi->morex<=200 && pi->morey<=200 )
		{
			sysmessage(s,"That rune has not been marked yet!");
		}
		else
		{
			P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
			gatex[gatecount][0]=Player->pos.x;	//create gate at player location
			gatey[gatecount][0]=Player->pos.y;
			gatez[gatecount][0]=Player->pos.z;
			gatex[gatecount][1]=pi->morex; //create gate at marked location
			gatey[gatecount][1]=pi->morey;
			gatez[gatecount][1]=pi->morez;

			for (n=0;n<2;n++)
			{
				strcpy(temp,"a blue moongate");
				P_ITEM iC = Items->SpawnItem(Player,1,"#",0,0x0f6c,0,0);
				if (iC!=NULL)//AntiChrist - to prevent crashes
				{
					iC->setType(n ? ITY_Gate2:ITY_Gate1);
					iC->pos.x=gatex[gatecount][n];
					iC->pos.y=gatey[gatecount][n];
					iC->pos.z=gatez[gatecount][n];
					iC->gatetime=(uiCurrentTime+(SrvParms->gatetimer*MY_CLOCKS_PER_SEC));
					//Console.send("GATETIME:%i UICURRENTTIME:%d GETCLOCK:%d\n",SrvParms->gatetimer,uiCurrentTime,getclock());
					iC->gatenumber=gatecount;
					iC->dir=1;
					mapRegions->Add(iC);	//add gate to list of items in the region
					iC->refresh();
				}
			}

			gatecount++;
			if (gatecount>MAXGATES) gatecount=0;
			addid1[s]=0;
			addid2[s]=0;
		}
	} else sysmessage(s,"Not a valid gate target");//AntiChrist
}

/*///////////////////
// Name:	SpellNumFromScrollID
// History:	by Duke, 18.3.2001
// Purpose:	Encapsulates the conversion of spell numbers from UO to WP
//			'reactive armor' is #1 in UO, but #7 in WP. So we must shift scrolls 2-7.
//
short cOldMagic::SpellNumFromScrollID(short id)
{
	if (id==0x1F2D)					return 7;			// Reactive Armor
	if (id>=0x1F2E && id<=0x1F33)	return (short) (id-0x1F2D);	// first circle without weaken
	if (id>=0x1F34 && id<=0x1F6C)	return (short)(id-0x1F2D+1);	// 2 to 8 circle spell scrolls plus weaken
	return -1;						// not a scroll
}*/

void cOldMagic::Action4Spell(UOXSOCKET s, int num)
{
	if (spells[num].action)
		impaction(s, spells[num].action);
}

void cOldMagic::SpeakMantra4Spell(P_CHAR Caster, int num)
{
	npctalkall(Caster, spells[num].mantra,0);
}

/*void cOldMagic::AfterSpellDelay(UOXSOCKET s, P_CHAR pc)
{
	pc->endCasting();
	
	//	LogAssert(pc->spell!=0);	// trying to trap spell==0
	cOldSpell* Spell=getSpell(pc->spell);
	if (!Spell) return;

	if (Spell->RequiresTarget())
	{
		target(s,100, spells[pc->spell].strToSay );
	}
	else
	{
		OldMagic->NewCastSpell( s,0 );
	}
}
*/

