/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__MAGIC_H__)
#define __MAGIC_H__


#include "platform.h"	// Platform specifics
#include "typedefs.h"

struct move_st;
struct stat_st;
class cCoord;

// used-in-the-interface
struct reag_st
{
	int ginseng;
	int moss;
	int drake;
	int pearl;
	int silk;
	int ash;
	int shade;
	int garlic;
};


class cOldMagic
{
public:
	bool CheckResist(P_CHAR Attacker, P_CHAR Defender, int circle);
	bool CheckResist(P_CHAR Defender, int circle);

	void CheckFieldEffects4(unsigned int currenttime, P_CHAR pc);
	void CheckFieldEffect(P_CHAR pc, PC_ITEM pi);
	int InitSpells( void );
//	void SpellBook(UOXSOCKET s, P_ITEM pi);
//	int  SpellsInBook(P_ITEM Book);
	char GateCollision(P_CHAR pcc);
//	bool newSelectSpell2Cast( int s, P_CHAR Player, int num );
//	bool okToCastSpellHere(int num, const cCoord &pos);
	bool requireTarget( unsigned char num );
	bool reqLocTarget( int num );
	bool reqCharTarget( int num );
//	bool townTarget( unsigned char num );
	stat_st getStatEffects( int num );
	stat_st getStatEffects_pre( int num);
	stat_st getStatEffects_after( int num);
	stat_st getStatEffects_item( int num);
//	void preParticles(int num, P_CHAR pc);
	void afterParticles(int num, P_CHAR pc);
	void itemParticles(int num, P_ITEM pi);
	void invisibleItemParticles(P_CHAR pc, int num, cCoord epos, bool overhead=false);
	move_st getMoveEffects( int num );
	bool aggressiveSpell( int num );
	bool fieldSpell( int num );
	void doMoveEffect( P_CHAR source, P_CHAR target, int num );
	void doStaticEffect( P_CHAR pc, int num );
	void playSound(P_CHAR pc, int num );
//	void NewDelReagents( CHARACTER s, reag_st reags );
	
	void DelReagents( P_CHAR pc, int num );

	void NewCastSpell(UOXSOCKET s, int serial);
//	void SbOpenContainer(int s);
//	void SbOpenContainer(UOXSOCKET s, P_ITEM pi);
	void PFireballTarget(P_CHAR Attacker, P_CHAR Defender, int j);
	void NPCLightningTarget(P_CHAR Attacker, P_CHAR Defender);
	void NPCEBoltTarget(P_CHAR Attacker, P_CHAR Defender);
	void NPCHeal(P_CHAR pc);
	void NPCCure(P_CHAR pc);
	void NPCDispel(P_CHAR Caster, P_CHAR Victim);
//	char CheckParry(P_CHAR pc, int circle);
	void NPCFlameStrikeTarget(P_CHAR Attacker, P_CHAR Defender);
	void MagicArrow(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void ClumsySpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void FeebleMindSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void WeakenSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void HarmSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void FireballSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void CurseSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void LightningSpellItem(P_CHAR Attacker, P_CHAR Defender);
	void MindBlastSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void ParalyzeSpell(P_CHAR Attacker, P_CHAR Defender, bool usenama = true);
	void ExplosionSpell(P_CHAR Attacker, P_CHAR Defender, bool usemana = true);
	void FlameStrikeSpellItem(P_CHAR Attacker, P_CHAR Defender);
//	P_ITEM getSpellBook(P_CHAR Player);
//	int CheckBook(int circle, int spell, P_ITEM Book);
	char CheckReagents(P_CHAR pc, int num);


	char CheckMana(P_CHAR pc, int num);
//	void DeleReagents(int s, int ash, int drake, int garlic, int ginseng, int moss, int pearl, int shade, int silk);

    void Recall(UOXSOCKET s, P_CHAR Player, P_ITEM pi); // we need this four ones for the commands (separatly) !!!
    void Mark(UOXSOCKET s, P_CHAR Player, P_ITEM pi);
    void Gate(UOXSOCKET s);
    void Heal(UOXSOCKET s, P_CHAR Player, P_CHAR Patient);

	void BuildCannon(int s, P_CHAR Player);
	P_CHAR CheckMagicReflect(P_CHAR &attacker, P_CHAR &defender);
	void SpellFail(int s);
	char SubtractMana(P_CHAR pc, int mana);
	void MagicTrap(P_CHAR pc, P_ITEM pTrap);	// moved here by AntiChrist (9/99)
	void Polymorph( int s, int gmindex, int creaturenumer); // added by AntiChrist (9/99)
//	short SpellNumFromScrollID(short id);
	void Action4Spell(UOXSOCKET s, int num);
	void SpeakMantra4Spell(P_CHAR Caster, int num);
	char SubtractMana4Spell(P_CHAR pc, int num);
//	void AfterSpellDelay(UOXSOCKET s, P_CHAR pc);


private:

	void SummonMonster(int s, short id, char *monstername, unsigned short color, int x, int y, int z, int spellnum);
//	void MagicReflect(int s);
	void BoxSpell(int s, int& x1, int& x2, int& y1, int& y2, int& z1, int& z2);
	int RegMsg(P_CHAR pc, reag_st failmsg);
//	void DirectDamage(int p, int amount);
	void PolymorphMenu( int s, int gmindex ); // added by AntiChrist (9/99)
};

#endif

