/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//
//
//
//Header file for the new magery.cpp
//holds:	one bease class for the spells
//			one class for every spell
//			one general magery class

#if !defined(__MAGIC_NEW_H__)
#define __MAGIC_NEW_H__

#include "platform.h"
#include "CArray.h"
#include "typedefs.h"
#include "gumps.h"

#include <vector>

// define some constants we need
static const char STY_BOOK	 = 0;
static const char STY_SCROLL = 1;
static const char STY_ITEM	 = 2;

static const char SBT_REGULAR = 0;
static const char SBT_NECRO	  = 1;
static const char SBT_PALADIN = 2;

class cSpell; //forward declaration
class cCoord; //forward declaration

class cMagic
{
protected:
	CDynArray<cSpell*>* spells; // created and set in LoadSpells()
	int numspells;
	CTithing *TithingGump;		

protected:
	void OpenSpellBook_old(P_CHAR Player, P_ITEM pi); // we need this for compatiblity with 3.x clients

public:
	cMagic();
	~cMagic();
	bool LoadSpells(); // loads the spells from the script file

	cSpell* GetSpell(int spellnum); // returns spell number "spellnumber"

	int CountSpells(P_ITEM Book);
	P_ITEM GetSpellBook(P_CHAR Player,int booktype); //gets the spellbook we need
	void OpenSpellBook(P_CHAR Player, P_ITEM pi, int booktype);

	inline void TithingGumpButtonHandler(int type, int gid, UOXSOCKET s) { TithingGump->ButtonHandler(type, gid, s); }
	void ShowTithingGump(P_CHAR Player);


	bool BeginCasting(P_CHAR Player,short spellnum,char type, void* preTarget = NULL); // called to start casting process..
	void AfterSpellDelay(P_CHAR Player); // called after spell delay..
	void FinnishCasting(P_CHAR Caster,void* Target, char targtype); // called to finnish casting process..

	char CalcFieldDirection(cCoord* casterpos,cCoord* destpos); // return values: 0 = x direction; i = y direction
	void AddMagicField(P_CHAR Player,cCoord* Position,short xid, short yid,int numItems, short time, short effNum);

	void MagicDamage(P_CHAR pc, int amount);
	void PoisonDamage(P_CHAR pc, int poison);
};

#endif
