/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/*
Module : necro.cpp
Purpose: store all necromancy related functions
Created: Genesis 11-12-1998
History: None
*/

#include "necro.h"

#include "itemid.h"
#include "SndPkg.h"
#include "TmpEff.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "necro.cpp"

void vialtarget(int nSocket, P_CHAR Player, int serial) // bug & crashfixed by LB 25 september 1999
{
	if (!Player) return;

	cItem* Vial = Player->getDclickedItem();
	if (!Vial) return; // should never happen
	
	cItem* Weapon = Player->getWeapon(); // search for a dagger in the players hand
	if (!Weapon || !IsDagger(Weapon->id()) )
	{
		sysmessage(nSocket,"You do not have a dagger equipped.");
		return;
	}
	
	if (isCharSerial(serial))
	{
		cChar* Victim = FindCharBySerial(serial);
		if (!Victim)
			return;
		Vial->more1=0;
		if (!Victim->npc)
		{
			// checkskill hmmm what skill/s has/have to added here LB ...
			
			if (Victim->isSameAs(Player))
			{
				if (Victim->Hp()<=10)
				{
					sysmessage(nSocket,"You are too wounded to continue.");
					return;
				}
				sysmessage(nSocket,"You prick your finger and fill the vial.");
			}
			else
			{
				if (Player->dist(Victim) > 2)
				{
					sysmessage(nSocket,"That individual is not anywhere near you.");
					return;
				}
				if (Victim->npc)
				{
					if (Victim->id()==0x000C || (Victim->id()>=0x003B && Victim->id()<=0x003D))
						Vial->more1=1;
					// Guard be summuned if in town and good npc
					// if good flag criminal
					// if evil npc attack necromancer but don't flag criminal
				}
				else
				{
					sprintf(temp,"%s has pricked you with a dagger and sampled your blood.",Player->name);
					sysmessage(Victim->calcSocket(),temp);
					// flag criminal						
				}
				Karma(Player,Victim,(0-(Victim->karma)));
			}
			Victim->reduceHp((rand()%6)+2);
			MakeNecroReg(nSocket,Vial,0x0E24);
		}
	}
	else
	{
		cItem* Corpse = FindItemBySerial(serial);
		if (!Corpse)
			return;
		if (!Corpse->corpse)
			sysmessage(nSocket,"That is not a person or a corpse!");
		else
		{
			Vial->more1=Corpse->more1;
			Karma(Player,NULL,-1000);
			if (Corpse->more2<4)
			{
				sysmessage(nSocket,"You take a sample of blood from the corpse.");
				MakeNecroReg(nSocket,Vial,0x0E24);
				Corpse->more2++;
			}
			else
				sysmessage(nSocket,"You examine the corpse but, decide any further blood samples would be to contaminated.");
		}
	}
}

void MakeNecroReg(UOXSOCKET s,P_ITEM pMat,short id)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if (id>=0x1B11 && id<=0x1B1C)	// Make bone powder.
	{
		sprintf(temp,"%s is grinding some bone into powder.", Player->name);
		npcemoteall(Player, temp,1);
		tempeffect(Player, TEF_Grinding, 0, 0, 0);
		tempeffect(Player, TEF_Grinding, 0, 3, 0);
		tempeffect(Player, TEF_Grinding, 0, 6, 0);
		tempeffect(Player, TEF_Grinding, 0, 9, 0);
		P_ITEM pItem = Items->SpawnItem(s,Player,1,"bone powder",1,0x0F8F,0,1,1);
		if (!pItem) return;
		pItem->morex=666;
		pItem->more1=1; // this will fill more with info to tell difference between ash and bone
		Items->DeleItem(pMat);
		
	}
	if (id==0x0E24) // Make vial of blood.
	{
		if (pMat->more1==1)
		{
			P_ITEM pItem = Items->SpawnItem(s,Player,1,"#",1,0x0F82,0,1,1);
			pItem->value=15;
			pItem->morex=666;
		}
		else
		{
	        P_ITEM pItem = Items->SpawnItem(s,Player,1,"#",1,0x0F7D,0,1,1);
			pItem->value=10;
			pItem->morex=666;
		}
		pMat->ReduceAmount(1);
	}
}
