/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __NETWORK_H__
#define __NETWORK_H__

#include "platform.h"	//Platform specifics
#include <iostream>

using namespace std ;

//Forward class Declaration
class cNetworkStuff;
#include "wolfpack.h"
#include "utilsys.h"
#include "typedefs.h"

typedef std::list<connectionAccountSt>::iterator CLITY;


struct ip_block_st
{
	unsigned long address;
	unsigned long mask;
};


class cNetworkStuff
{
public:
	cNetworkStuff();

	int  getPendingLogouts(void);
	void CorrectSockPositionAfterDisconnect(UOXSOCKET &pos, UOXSOCKET shuffle);
	void startchar(UOXSOCKET s);
	void LoginMain(UOXSOCKET s, CLITY c);	
	bool Disconnect(UOXSOCKET s, bool alwaysinsta=false);
	void CheckConn();
	void CheckMessage();
	void SockClose();	
	void LoadHosts_deny( void );
	void Initialize(void) { sockInit(); }

	int kr,faul; // needed because global varaibles cant be changes in constructores LB
	bool CheckForBlockedIP(sockaddr_in ip_address);
	char CheckDelayedLogoutTime(void);
	char CheckStuckConnections(void);
	char CheckDualLogins(void);

    int PacketLen( UOXSOCKET s, unsigned char packetnum); 


private:
	
	char pass1[256];
	char pass2[256];

	int m_packetLen[256];

	bool check80(UOXSOCKET s);
	
	std::vector<ip_block_st> hosts_deny;

	signed long Authenticate( const char *username, const char *pass );	

	void Login2(int s);
	void Relay(int s);
	void GoodAuth(int s);   
	void charplay (int s);
	void CharList(UOXSOCKET s, CLITY c);
	int  Receive(int s, int x, int a);
	void GetMsg(UOXSOCKET s, CLITY c, P_CHAR PLAYER);
	char CheckDelayedLogoutRegion(P_CHAR Player);
	void pSplit(char *pass0);
	void sockInit();
	void shuffleNowArrays(int s);
	void processPacket(UOXSOCKET s, unsigned char packetNumber, CLITY cInfo, P_CHAR PLAYER);


protected:

};


class LWCrypt
{
	private:

	unsigned int key[2][MAXCLIENT+1];
    unsigned int urKey[2][MAXCLIENT+1]; 
	bool use;
	unsigned char firstCryptByte[MAXCLIENT+1];

    public:
	   LWCrypt::LWCrypt(bool useit) { use=useit; }
	   LWCrypt::~LWCrypt() { ; }
	   bool LWCrypt::useMe() { return use; }

	   void LWCrypt::doCrypt(UOXSOCKET s, unsigned char *in, unsigned char *out, int len);
	   void LWCrypt::init(UOXSOCKET s, unsigned int seed, unsigned int key1, unsigned int key2);
	   bool LWCrypt::isFirstCryptByte(UOXSOCKET s, unsigned char x)
	   {
		   if (x==firstCryptByte[s]) return true; else return false;
	   }

	   void LWCrypt::synchKeysWithLogout(UOXSOCKET s, int appocalypseNow);
		   
};

class PacketReader
{
   private:

   CArray<MAXBUFFER_REAL, unsigned char>buffer;
   
   unsigned char state;
   int idx;
   int nLeft;
   int offs;

   unsigned char packetNum;
   int packetLen;

   bool con;
   UOXSOCKET s;

   int readAttempt(void);

   public:

   void readData(void);

   bool packetArrived(void)          { return (state==9); }
   bool seedArrived(void)            { return (state==2); }
   bool isDisconnected(void)         { return (!con); }
   unsigned char getPacketNum(void)  { return packetNum; }
   unsigned char getState(void)      { return state; }
   unsigned char* getBufferPtr(void) { return &buffer[0]; }

   void copyBuffer(unsigned char* p);
   void cloneFrom(PacketReader & src); // = operator more C++'ish but it's intentional not doing it
   void reset(UOXSOCKET s);            // kind of constructor, but needed several times, not only at birth. 
                                       // so I didn't bother to write a real c'tor.    
};

class PacketWriter
{
   private:

   int ConstrBufferLen;
   int tl;
   const int lim;
   int okstatus;

   CArray<MAXBUFFER_REAL*2, unsigned char>constructionBuffer;
   CArray<MAXCLIENT+1, CArray<MAXBUFFER_REAL*5, unsigned char> >compressedBuffer;
   CArray<MAXCLIENT+1, int>packets;

   unsigned char sendStyle;

   /*#define toSendLen toSendLen_CArray.prepare(DBGFILE,__LINE__)
   #define toSendOffs toSendOffs_CArray.prepare(DBGFILE,__LINE__)
   #define AppendNew AppendNew_CArray.prepare(DBGFILE,__LINE__)*/

   CArray<MAXCLIENT+1, int> toSendLen;  
   CArray<MAXCLIENT+1, int> toSendOffs;   
   CArray<MAXCLIENT+1, int> AppendNew;

   bool noserverPacket(unsigned char packetnum);
   bool PacketValid(UOXSOCKET s);
   bool oktoFlushBuffer(UOXSOCKET s);

   int dbgsourceline;
   char *dbgfile;

   public:  

   inline void prepareDebug(char *f, int l) { dbgsourceline=l; dbgfile=f; }
   int FlushBuffers(UOXSOCKET s);
   void StartPacketConstruction(unsigned char packetnum, unsigned short length);
   void AddPacketData(const unsigned char* data, unsigned short len);
   void FinishPacket(UOXSOCKET s);

   void synchWithLogout(UOXSOCKET s, int position);
   
   void clearAllBuffers(void)
   {
	   unsigned int a;
	   for (a=0; a<now; a++)
	   {
		   FlushBuffers(a);
	   }
   }
  
   int PackNew(UOXSOCKET s, int len);

   void reset(void)
   {	
	 int a;
	 for (a=0; a<MAXCLIENT; a++) 
	 {
		 reset(a);
	 }	 
   }

   void reset(UOXSOCKET s)
   {
	 toSendLen[s]=0;     
     toSendOffs[s]=0;	
	 AppendNew[s]=0;
	 packets[s]=0;
	 ConstrBufferLen=0;
   }

   PacketWriter::PacketWriter(int sndStyle):lim(MAXBUFFER_REAL*2) 
   {	  		   
	   reset();	   
   }
};

class countTraffic
{
   public:

	countTraffic::countTraffic()
	{		
		int a;
		for (a=0; a<256; a++)
		{
		  sendPackets[a]=0;
		  sendLen[a]=0;
		  sendLenCompressed[a]=0;
		  sendPacketsBFs[a]=0;
		  sendLenBFs[a]=0;
		  sendLenCompessedBFs[a]=0;
		  recvPackets[a]=0;
		  recvLen[a]=0;
		  recvPacketsBFs[a]=0;
		  recvLenBfs[a]=0;
		}

		sendTotal=0;
		sendTotalCompr=0;
		recvTotal=0;
	}

	inline void addSendPkt(unsigned char packetnum, int length, int lengthCompr, unsigned char sub)
	{
		if (packetnum!=0xBF)
		{
			sendPackets[packetnum]++;
			sendLen[packetnum]+=length;
			sendLenCompressed[packetnum]+=lengthCompr;
		} 
		else
		{
			sendPackets[0xBF]++;
			sendPacketsBFs[sub]++;
			sendLenBFs[sub]+=length;
			sendLenCompessedBFs[sub]+=lengthCompr;
		}

		sendTotal+=length;
		sendTotalCompr+=lengthCompr;
	}

	inline void addRecvPkt(unsigned char packetnum, int length, unsigned char sub)
	{
		if (packetnum!=0xBF)
		{
			recvPackets[packetnum]++;
			recvLen[packetnum]+=length;			
		} 
		else
		{
			recvPackets[0xBF]++;
			recvPacketsBFs[sub]++;
			recvLenBfs[sub]+=length;		
		}

		recvTotal+=length;		
	}

	void doStatistics(void);

    private:

	  int sendPackets[256];       // packet  count
	  int sendLen[256];           // lengths uncomressed
	  int sendLenCompressed[256]; // length  compressed

	  int sendPacketsBFs[256];    // same for sub packets 0f 0xbf (0xbf's NOT entered in above arrays)
	  int sendLenBFs[256];
	  int sendLenCompessedBFs[256];

	  int sendTotal;
	  int sendTotalCompr;
	  int recvTotal;

	  int recvPackets[256]; // same recv'd packets (no compression)
	  int recvLen[256];
	  int recvPacketsBFs[256];
	  int recvLenBfs[256];


};

class cClientVersion
{
  private:
	map<string,int>_cvm;
	const int offs_3d;
    string str_3d;

  public:
	cClientVersion::cClientVersion(void);
	bool get3DNess  (const string & version);
	int  getClientNr (const string &version);

	bool supportsNewBookPacket(const string&version);
	bool isAOSClient(const string&version);
	bool isLBRClient(const string&version);
	bool needsNewSpyPacketLength(const string&version);
};



#endif
