/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "regions.h"
#include "SndPkg.h"
#include "network.h"

#include "wolfpack.h"

#include "debug.h"
#undef DBGFILE
#define DBGFILE "npcinfo.cpp"


struct creat_st
{
	int basesound;
	unsigned char soundflag;
	unsigned char who_am_i;
	int icon;
	unsigned char type;
	char feathers;
	char ribs;
	char hides;
	char fur;
	char wool;
	char bird;
};

CArray<2048, creat_st>creatures("creatures");

void CarveInfo(int id, int feat, int ribs, int hides, int fur, int wool, int bird)
{
	creatures[id].feathers = feat;
	creatures[id].ribs = ribs;
	creatures[id].hides = hides;
	creatures[id].fur = fur;
	creatures[id].wool = wool;
	creatures[id].bird = bird;
}

void initCreatureArray(unsigned int index,int sound, int icon,unsigned char who, unsigned int type,char sflag)
{
    creatures[index].basesound = sound ;
    creatures[index].icon = icon ;
    creatures[index].who_am_i += who ;
    creatures[index].type =type ;
    creatures[index].soundflag = sflag ;
}

void init_creatures(void) // assigns the basesound, soundflag, who_am_i flag of all npcs
// LB 9.8.99/17.9/20.9

// completed: LB 27.3.2002 (covering ALL monsters LBR, T2A, Third dawn + old ones)

{
/////////////////////////////////////////////////////////////////////////////////////////////////
// soundflags	0: normal, 5 sounds (attack-started, idle, attack, defence, dying, see WOLFPACK.h)
//				1: birds .. only one "bird-shape" and zillions of sounds ...
//				2: only 3 sounds -> (attack,defence,dying)
//				3: only 4 sounds ->	(attack-started,attack,defnce,dying)
//				4: only 1 sound !!
//
// who_am_i bit # 1 creature can fly (must have the animations, so better dont change)
//				# 2 anti-blink: these creatures dont have animation #4, if not set creaure will randomly dissapear in battle
//								if you find a creature that blinks while fighting, set that bit
// type (disjunct) it belongs to: 
//
//            [ #  4: anything else
//              # 3: NPC ]  ( only 0,1,2 set there )
//
//              # 2: animal / pet (mounts too, even if rideable dragon)
//              # 1: sea creature
//              # 0: monster
//             			
// icon: used for tracking, to set the appropriate icon
////////////////////////////////////////////////////////////////////////////////////////////////////////
	memset(&creatures[0], 0, 2048*sizeof( creat_st ));

    //Ogre
	initCreatureArray(0x01,0x01AB,8514,0,0,0) ;

    //Ettin
	initCreatureArray(0x02,0x016F,8408,0,0,0) ;

    //Zombie
	initCreatureArray(0x03,0x01D7,8428,0,0,0) ;
	
    //Gargoyle
	initCreatureArray(0x04,0x0174,8409,1,0,0) ;

	//Eagle
	initCreatureArray(0x05,0x008f,8434,3,2,0) ;

    //Bird  -- Special sound treatment, because there are about 20 bird sounds
    initCreatureArray(0x06,0x007d,8430,1,2,1) ;

    //Orc
    initCreatureArray(0x07,0x01b0,8416,0,0,0) ;

	//corpser
    initCreatureArray(0x08,0x1ba,8402,0,0,3) ;

	//deamon
    initCreatureArray(0x09,0x0165,8403,1,0,0);
	
    //deamon 2
    initCreatureArray(0x0a,0x0165,8403,1,0,0) ;

	//dead spider
    initCreatureArray(0x0b,387,8445,0,0,0) ;

	//Green dragon
    initCreatureArray(0x0c,362,8406,1,0,0) ;

	//air-elemental
    initCreatureArray(0x0d,263,8429,0,0,0) ;

	//earth elemental
    initCreatureArray(0x0e,268,8407,0,0,0) ;

	//fire elemental
    initCreatureArray(0x0f,273,8435,0,0,0) ;

	//water elemental
    initCreatureArray(0x10,0x0116,8459,0,0,0);

	//Orc 2
    initCreatureArray(0x11,0x1b0,8416,0,0,0) ;

	//Ettin 2
    initCreatureArray(0x12,0x16F,8408,0,0,0);

	//dread spider 2
    initCreatureArray(0x13,387,8445,0,0,0) ;

	//frost spider
    initCreatureArray(0x14,904,8445,0,0,0);

	//Giant snake
    initCreatureArray(0x15,219,8446,0,0,0);

	//gazer
    initCreatureArray(0x16,377,8426,0,0,0);

	//dire wolf
    initCreatureArray(0x17,229,8476,0,2,0);

	//liche
    initCreatureArray(0x18,412,8440,0,0,0);

	//grey wolf
    initCreatureArray(0x19,229,8476,0,2,0);

	//ghost 1
    initCreatureArray(0x1a,1154,8457,0,0,0);

	//grey wolf
    initCreatureArray(0x1b,229,8476,0,2,0);

	//giant spider
    initCreatureArray(0x1c,387,8445,0,0,0);

	//gorialla
    initCreatureArray(0x1d,158,8437,0,2,0);

	//harpy
    initCreatureArray(0x1e,402,8412,0,0,0);

	//headless
    initCreatureArray(0x1f,407,8458,0,0,0) ;

	// 0x20 is *really* missing, crashes (2d) client if instanciated

	//lizardman
    initCreatureArray(0x21,417,8414,0,0,0) ;

    initCreatureArray(0x23,417,8414,0,0,0) ;

    initCreatureArray(0x24,417,8414,0,0,0) ;
    
    //wolves
    initCreatureArray(0x22,229,8476,0,2,0) ;
    initCreatureArray(0x25,229,8476,0,2,0) ;

	//black daemon
    initCreatureArray(0x26,696,9605,1,0,0);

    //mongbat
    initCreatureArray(0x27,422,8441,1,0,0) ;

	//elder daemon
    initCreatureArray(0x28,696,9606,1,0,0);

	//orc 3
    initCreatureArray(0x29,0x1b0,8416,0,0,0);

	//ratman
    initCreatureArray(0x2a,437,8419,0,0,0) ;
    initCreatureArray(0x2c,437,8419,0,0,0) ;
    initCreatureArray(0x2d,437,8419,0,0,0) ;

	//ice daemon
    initCreatureArray(0x2b,696,9607,1,0,0) ;
	
	//ancient worm
    initCreatureArray(0x2e,362,8452,1,0,0);

	//Reaper
    initCreatureArray(0x2f,0x1ba,8442,0,0,0);

	//Giant scorprion
    initCreatureArray(0x30,397,8420,0,0,0);

	//ancient worm white
    initCreatureArray(0x31,362,8452,1,0,0);

	//skeleton 2
    initCreatureArray(0x32,452,8423,0,0,0);

	//slime
    initCreatureArray(0x33,456,8424,0,0,0);

	//Snake
    initCreatureArray(0x34,219,8444,0,2,0);

	//troll
    initCreatureArray(0x35,461,8425,0,0,0);
    
    //troll 2
    initCreatureArray(0x36,461,8425,0,0,0);
    
    //troll 3
    initCreatureArray(0x37,461,8425,0,0,0);

    //skeleton 3
    initCreatureArray(0x38,452,8423,0,0,0);
    
    //skeleton 4
    initCreatureArray(0x39,452,8423,0,0,0);

	//wisp
    initCreatureArray(0x3a,466,8448,0,0,0);

    //red dragon
    initCreatureArray(0x3b,362,8406,1,0,0);
    
    //smaller red dragon
    initCreatureArray(0x3c,362,8406,1,0,0);
    
    //smaller green dragon
    initCreatureArray(0x3d,362,8406,1,0,0);
    
    //wyvern
    initCreatureArray(0x3e,362,9684,1,0,0);

    //cougar
    initCreatureArray(0x3f,115,9603,0,2,0);

	//snow leopard
    initCreatureArray(0x40,115,9635,0,2,0);

	// snow leopard 2
    initCreatureArray(0x41,115,9635,0,2,0);

	//swamp tentacle
    initCreatureArray(0x42,639,9672,0,0,0);

	//stone gargoyle
    initCreatureArray(0x43,372,9614,0,0,0);

	//gazer
    initCreatureArray(0x44,377,9615,0,0,0);

	//gazer 2
    initCreatureArray(0x45,875,8436,0,0,0);

	//terathen warrior
    initCreatureArray(0x46,594,9673,0,0,0);

    //terathen drone
    initCreatureArray(0x47,1170,9674,0,0,0);

    //terathen queen
    initCreatureArray(0x48,599,0675,0,0,0);

	//stone harpy
    initCreatureArray(0x49,402,9620,1,0,0);

	//Imp
    initCreatureArray(0x4a,959,9631,1,0,0);

	//Cyclop
    initCreatureArray(0x4b,604,8493,0,0,0);

    //Titan
    initCreatureArray(0x4c,609,9677,0,0,0);


	//kraken
    initCreatureArray(0x4d,1100,9634,0,0,0);

	//liche lord
    initCreatureArray(0x4e,412,8440,0,0,0);

	//liche lord 2
    initCreatureArray(0x4f,417,8440,0,0,0);
    
	//giant frog 1
    initCreatureArray(0x50,858,8495,0,0,0);

	//bullfrog
    initCreatureArray(0x51,863,8496,0,2,0);


	//liche lord 3
    initCreatureArray(0x52,417,8440,0,0,0);

	//ogre 2
    initCreatureArray(0x53,427,8395,0,0,0);

	//ogre 3
    initCreatureArray(0x53,427,8395,0,0,0);

	//phedian mage
    initCreatureArray(0x55,639,9643,0,0,0);

	//ophediean warrior
    initCreatureArray(0x56,649,9644,0,0,0);

	//ophedian queen
    initCreatureArray(0x57,644,9645,0,0,0);

	//mountain goat 2
    initCreatureArray(0x58,153,9600,0,2,0);

	//giant snake ice
    initCreatureArray(0x59,387,9664,0,0,0);


	//giant snake lava
    initCreatureArray(0x51,387,9665,0,0,0);

	//giant snake silver
    initCreatureArray(0x5b,904,9666,0,0,0);
	
	//giant snake silver
    initCreatureArray(0x5c,904,9666,0,0,0);

	//giant snake silver
    initCreatureArray(0x5d,904,9666,0,0,0);

	//ice slime
    initCreatureArray(0x5e,456,8424,0,0,0);
    
    /// 0x5f not there, crashing 2d clients if instanciated

	//ice slime
    initCreatureArray(0x60,456,8424,0,0,0);

	//hell hound
    initCreatureArray(0x61,133,9622,0,2,0);

	//hell hound 2
    initCreatureArray(0x62,133,9622,0,2,0);

	//wolf 2
    initCreatureArray(0x63,229,9679,0,2,0);

	//wolf 3
    initCreatureArray(0x64,229,9679,0,2,0);

	//centaur
    initCreatureArray(0x65,679,9601,0,0,0);

	//exodus
    initCreatureArray(0x66,768,8453,1,0,0);

	//asian dragon
    initCreatureArray(0x67,704,9619,1,0,0);

	//skeletal dragon
    initCreatureArray(0x68,1160,8406,1,0,0);

    //dragon
    initCreatureArray(0x69,722,8406,1,0,0);

	//shadow wyrm
    initCreatureArray(0x6a,717,8406,1,0,0);

	//agapite elemental
    initCreatureArray(0x6b,268,9689,0,0,0);

	//bronze elemental
    initCreatureArray(0x6c,268,9689,0,0,0);

	//copper elemental
    initCreatureArray(0x6d,268,9689,0,0,0);

	//agapite elemental
    initCreatureArray(0x6e,268,8407,0,0,0);

	//agapite elemental
    initCreatureArray(0x6f,268,8407,0,0,0);

	//valorite elemental
    initCreatureArray(0x70,268,8407,0,0,0);

	//horse dark steed
    initCreatureArray(0x71,168,8481,0,2,0);

	//horse ethernal
    initCreatureArray(0x72,168,8480,0,2,0);

	//horse nightmare
    initCreatureArray(0x73,168,9628,0,2,0);

	//horse silver steed
    initCreatureArray(0x74,168,9629,0,2,0);

	//horse war brittain
    initCreatureArray(0x75,168,8481,0,2,0);

	//horse war mage council
    initCreatureArray(0x76,168,8481,0,2,0);

	//horse mage council
    initCreatureArray(0x77,168,8481,0,2,0);

	//horse minax
    initCreatureArray(0x78,168,8481,0,2,0);

	//horse shadowlord
    initCreatureArray(0x79,168,8481,0,2,0);

	//horse unicorn
    initCreatureArray(0x7a,1212,9678,0,2,0);

	//ethereal
    initCreatureArray(0x7b,757,9609,1,0,0);
	
	//evil mage 1
    initCreatureArray(0x7c,1149,9610,0,0,0);
	
	//evil mage 2
    initCreatureArray(0x7d,1149,9611,0,0,0);

	//evil mage 3
    initCreatureArray(0x7e,1149,9611,0,0,0);

	//hell cat
    initCreatureArray(0x7f,105,9623,0,2,0);

	//pixie
    initCreatureArray(0x80,1133,9654,0,0,0);
    
    //swamp tentacle
    initCreatureArray(0x81,846,9672,0,0,0);

	//gargolye 3
    initCreatureArray(0x82,372,8409,0,0,0);

	//efreet genie
    initCreatureArray(0x83,880,9616,0,0,0);

	//kirin
    initCreatureArray(0x84,965,9632,0,2,0);

	//alligator
    initCreatureArray(0x85,90,8479,0,2,0);

	//Komodo dragon
    initCreatureArray(0x86,711,9633,1,2,0);

	//ogre lord artic
    initCreatureArray(0x87,427,9640,0,0,0);

	//ophedian archmage
    initCreatureArray(0x88,639,9641,0,0,0);

	//ophedian knight
    initCreatureArray(0x89,634,9642,0,0,0);

	//orc lord
    initCreatureArray(0x8a,1113,9648,0,0,0);

	//orc lord
    initCreatureArray(0x8b,1113,9648,0,0,0);
	
    //orc shaman
    initCreatureArray(0x8c,1113,9649,0,0,0);

	//paladin
    initCreatureArray(0x8d,1095,8454,0,0,0);

	//ratman
    initCreatureArray(0x8e,437,9655,0,0,0);

	//ratman 2
    initCreatureArray(0x8f,437,9655,0,0,0);

	//sea horse
    initCreatureArray(0x90,1144,9658,0,1,0);

	//sea serpent
    initCreatureArray(0x91,3,6443,0,1,0);

	//shadowlord
    initCreatureArray(0x92,1149,9610,0,0,0);

	//skeleton knight
    initCreatureArray(0x93,1165,9661,0,0,0);

	//skeleton mage
    initCreatureArray(0x94,1165,9662,0,0,0);

	//succubidus
    initCreatureArray(0x95,1200,9631,0,0,0);

	//sea serpant
    initCreatureArray(0x96,3,8443,0,1,0);

	//dolphin
    initCreatureArray(0x97,138,8443,0,1,0);
	
	//terethan
    initCreatureArray(0x98,589,9674,0,0,0);

	//walking dead ghoul
    initCreatureArray(0x99,382,9671,0,0,0);

	//rotting corpse
    initCreatureArray(0x9a,471,9659,0,0,0);

	//mummy
    initCreatureArray(0x9b,471,9639,0,0,0);

	// 0x9c isn't there, crashing 2d client if instanciated

	//black widow
    initCreatureArray(0x9d,904,9667,0,0,0);

	//acid elemental
    initCreatureArray(0x9e,517,9686,0,0,2);

	//blood elemental
    initCreatureArray(0x9f,517,9688,0,0,2);

	//blood elemental
    initCreatureArray(0xa0,517,9688,0,0,2);

	//ice elemental
    initCreatureArray(0xa1,263,9690,0,0,0);

	//posion elemental
    initCreatureArray(0xa2,517,9691,0,0,2);

	//snow elemental
    initCreatureArray(0xa3,268,9692,0,0,0);

	//energy vortex
    initCreatureArray(0xa4,263,9688,0,0,0);

	//wisp
    initCreatureArray(0xa5,466,8448,0,0,0);

	//gold elemental
    initCreatureArray(0xa6,268,9689,0,0,0);

	//brown bear
    initCreatureArray(0xa7,1218,8478,0,2,0);

	//shadow imp
    initCreatureArray(0xa8,959,9631,0,0,0);
 
	//// 0xa9 not in art files, hence crahsing 2d client if instanciated

	//ethereal llama
    initCreatureArray(0xaa,1011,8438,0,2,0);

	//ethereal ostard
    initCreatureArray(0xab,183,9652,0,2,2);

	//dragon red
    initCreatureArray(0xac,362,8406,1,0,0);

	//black widow
    initCreatureArray(0xad,904,9667,0,0,0);

	//scubbidius big
    initCreatureArray(0xae,1200,9631,1,0,0);

	//ethereal warrior male
    initCreatureArray(0xaf,762,9609,0,0,0);

	//pixie big
    initCreatureArray(0xb0,1132,9654,1,0,0);


	//nightmare
    initCreatureArray(0xb2,168,9628,0,2,0);

	//nightmare
    initCreatureArray(0xb3,168,9628,0,2,0);

	//white wyrm
    initCreatureArray(0xb4,704,8406,1,0,0);

	//orc scout
    initCreatureArray(0xb5,432,9647,0,0,0);

	//orc bomber
    initCreatureArray(0xb6,432,9648,0,0,0);

	// b7...ba : savage npc's no sound

	//ridgeback
    initCreatureArray(0xbb,869,9650,0,2,0);

	//ridgeback
    initCreatureArray(0xbc,869,9650,0,2,0);

	//orc-lord
    initCreatureArray(0xbd,1114,9650,0,0,0);

	/// be .. c7 : not in artfiules, crashing client if instanciated

	//white horse
    initCreatureArray(0xc8,168,8479,0,2,0);

	//cat
    initCreatureArray(0xc9,105,8475,2,2,0);

	//alligator
    initCreatureArray(0xca,90,8410,0,2,0);

	//small pig
    initCreatureArray(0xcb,196,8449,0,2,0);

	//brown horse
    initCreatureArray(0xcc,168,8481,0,2,0);

	// rabbit - only three sounds, need for special treatment
    initCreatureArray(0xcd,201,8485,0,2,2);

	//wooly sheep
    initCreatureArray(0xcf,214,8427,0,2,0);

	//chicken
    initCreatureArray(0xd0,110,8401,0,2,0);

	//goat     - no icon, so a different sheep one was used
    initCreatureArray(0xd1,153,8422,0,2,0);

	//brown bear
    initCreatureArray(0xd3,95,8399,0,2,0);

	//grizzly bear
    initCreatureArray(0xd4,95,8411,0,2,0);

	//polar bear
    initCreatureArray(0xd5,95,8417,0,2,0);

	//panther
    initCreatureArray(0xd6,186,8473,2,2,0);

	//giant rat
    initCreatureArray(0xd7,392,8400,0,0,0);

	//cow
    initCreatureArray(0xd8,120,8432,0,2,0);

	//dog
    initCreatureArray(0xd9,133,8405,0,2,0);

	//forest ostard
    initCreatureArray(0xda,1013,9651,0,2,0);

	// frenzied ostard
    initCreatureArray(0xdb,1013,9652,0,2,0);

	//llama
    initCreatureArray(0xdc,183,8438,0,2,2);

	//walrus
    initCreatureArray(0xdd,224,8447,0,1,0);

	//lamb/shorn sheep
    initCreatureArray(0xdf,216,8422,0,2,2);

	//jackal
    initCreatureArray(0xe1,229,8426,2,2,0);

	// yet another horse
    initCreatureArray(0xe2,168,8484,0,2,0);

	//horse
    initCreatureArray(0xe4,168,8480,0,2,0);

	//brown cow
    initCreatureArray(0xe7,120,8432,2,2,0);

	//bull
    initCreatureArray(0xe7,100,8431,2,2,0);

	//b/w cow
    initCreatureArray(0xe9,120,8451,0,2,0);

	//deer
    initCreatureArray(0xea,130,8404,0,2,2);

	//small deer
    initCreatureArray(0xed,130,8404,0,2,2);

	//rat
    initCreatureArray(0xee,240,8483,0,2,0);

	/// 0xef - 0x121  no monster, but not crashing client 

	//Boar
    initCreatureArray(0x122,196,8449,0,2,0);

	//pack horse
    initCreatureArray(0x123,168,8486,0,2,0);

	//pack llama
    initCreatureArray(0x124,183,8487,0,2,2);

	/// 0x125 - 0x189  no monster but not crashing client 

    initCreatureArray(0x190,0,8454,0,0,0);
    initCreatureArray(0x191,0,8455,0,0,0);
    initCreatureArray(0x192,0,9712,0,0,0);
    initCreatureArray(0x193,0,9713,0,0,0);
	
	/// 0x194 - 0x23c  no monster, but not crashing client 

    //e-vortex
    initCreatureArray(0x23d,263,0,0,0,0);
    
    //blade spirit
    initCreatureArray(0x23e,512,0,0,0,4);

	/// 0x23f-0x2ef no monster but not crashing client 

	//// LBR monster here.
	//// because none of them has neither deicated sounds nor icons, 
	//// --> lots of creative freedom ;)

	// iron golem
    initCreatureArray(0x2f0,268,9649,0,0,0);

	//gargoyle slave
    initCreatureArray(0x2f1,372,9613,1,0,0);

	//gargoyle enforcer
    initCreatureArray(0x2f2,372,9613,1,0,0);

	//gargoyle guard
    initCreatureArray(0x2f3,372,9613,1,0,0);

	//clockwork overseer
    initCreatureArray(0x2f4,877,9615,0,0,0);

	//clockwork minion
    initCreatureArray(0x2f5,877,9615,0,0,0);

	//gargoyle shopkeeper
    initCreatureArray(0x2f6,372,9613,1,0,0);


	// 2f7-2fa: no monster, but not crashing client

	//clockwork minion
    initCreatureArray(0x2fb,877,9615,0,0,0);

    // 2fc-306 : NPCs -> no sound (LB, juggernaut, meer's etc)

	//plague beast
    initCreatureArray(0x307,849,8424,0,0,0);

	//horde demon
    initCreatureArray(0x308,863,8495,0,0,0);

	//doppelganger
    initCreatureArray(0x309,1110,9685,0,0,0);

	//swarm 
    initCreatureArray(0x30a,877,9615,0,0,0);

	//bogling
    initCreatureArray(0x30b,760,8407,0,0,0);

	//bog thing
    initCreatureArray(0x30c,768,9602,0,0,0);

	//fire ant worker
    initCreatureArray(0x30d,838,9673,0,0,0);

	//fire ant warrior
    initCreatureArray(0x30e,838,9674,0,0,0);

	//fire ant queen
    initCreatureArray(0x30f,838,9675,0,0,0);

	//archane daemon
    initCreatureArray(0x310,357,9605,0,0,0);
	
	//four armed daemon
    initCreatureArray(0x311,696,9606,0,0,0);

    //chariot
    initCreatureArray(0x312,904,9667,0,0,0);

	//ant lion
    initCreatureArray(0x313,397,9657,0,0,0);

	//phinx
    initCreatureArray(0x314,1006,9679,0,0,0);

	//quagmire  - icon is a spider,open to better suggestions
    initCreatureArray(0x315,1105,9668,0,0,0);

	//sand vortex
    initCreatureArray(0x316,655,9689,0,0,0);

	//giant beetle
    initCreatureArray(0x317,701,9667,0,2,0);

	//chaos daemon
    initCreatureArray(0x318,357,9604,0,0,0);

	//skeletal mount
    initCreatureArray(0x319,168,9627,0,2,0);

	//swamp dragon
    initCreatureArray(0x31a,362,9619,1,2,0);


	//horde daemon (sesame street?)
    initCreatureArray(0x31b,697,9604,0,0,0);

	// horde daemon big
    initCreatureArray(0x31c,697,9604,0,0,0);

	//fire dragon
    initCreatureArray(0x31d,273,8406,1,0,0);

	//rust dragon
    initCreatureArray(0x31e,363,8406,1,0,0);

	// swamp dragon
    initCreatureArray(0x31f,362,8406,1,2,0);


	// 0x320 .. 0x333 no monsters, but not crashing client

	// horse, dappeled brown
    initCreatureArray(0x334,168,9624,0,2,0);


	// 0x335 .. 0x337 no monsters, but not crashing client

	//horse, dark brown
    initCreatureArray(0x338,168,9626,0,2,0);


	// dessert ostard
    initCreatureArray(0x339,1013,9650,0,2,0);


	// forset ostard
    initCreatureArray(0x33a,1013,9651,0,2,0);

	// frenzied ostard
    initCreatureArray(0x33b,1013,9652,0,2,0);


	// llama
    initCreatureArray(0x33c,183,8438,0,2,2);


	// 0x33d .. 0x33e no monsters, but not crashing client

	// birds : parrot
    initCreatureArray(0x33f,191,8474,0,2,0);

	
	// birds: phoenix
    initCreatureArray(0x340,750,8434,0,2,0);


	//birds: turkey
    initCreatureArray(0x341,629,8474,0,2,0);

	// hellcat
    initCreatureArray(0x342,674,9623,0,2,0);

	// jack rabbit
    initCreatureArray(0x343,201,8485,0,2,2);

	// 0x344 no monster, but not crashing client

	// ice snake
    initCreatureArray(0x345,219,9664,0,2,0);

	// lava snake
    initCreatureArray(0x340,750,8434,0,2,0);

	// ridgeback
    initCreatureArray(0x347,869,9650,0,2,0);

	// ridgeback giant
    initCreatureArray(0x348,869,9650,0,2,0);

	// ridgeback flame
    initCreatureArray(0x349,869,9650,0,2,0);

	// ridgeback hatchling
    initCreatureArray(0x34a,869,9650,0,2,0);

	// rat
    initCreatureArray(0x34b,204,8483,0,2,0);


	// 0x34c-d no monsters, but not crashing client

	// horse: dappled grey
    initCreatureArray(0x34e,168,9625,0,2,0);

	// 0x34f  no monster, but not crashing client

	// horse: tan
    initCreatureArray(0x350,168,9630,0,2,0);

	// 0x351-0x3c9 no monsters, but not crashing client

	// 0x3ca: player ghost
	// 0x3de: LB
	// 0x3df blackthorn
	// 03e2: dupre

	// anything between those 4 and 0x3e6: no monsters, but not crashing client

	// kirin_kirin
    initCreatureArray(0x3e6,168,9632,0,2,0);

	// npc's

	//creatures[

	int s;
	for (s=0;s<0x0400;s++)
	{
		switch(s)
		{	// (fixed by Covenant 02-09-2002)
		case 0x01: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Ogre
		case 0x02: CarveInfo(s, 0, 5, 0, 0, 0, 0); break; //Ettin
		case 0x03: break;	//Zombie
		case 0x04: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Gargoyle
		case 0x05: CarveInfo(s,36, 0, 0, 0, 0, 1); break; //Eagle
		case 0x06: CarveInfo(s,25, 0, 0, 0, 0, 1); break; //Bird
		case 0x07: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc (with an axe in 2d)
		case 0x08: break;	//Corpser
		case 0x09: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Daemon
		case 0x0A: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Daemon (with a sword in 2d)
		case 0x0B: break;	//Dread Spider
		case 0x0C: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Dragon (green in t2a/grey in uo:td)
		case 0x0D: break;	//Air Elemental
		case 0x0E: break;	//Earth Elemental
		case 0x0F: break;	//Fire Elemental
		case 0x10: break;	//Water Elemental
		case 0x11: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc
		case 0x12: CarveInfo(s, 0, 5, 0, 0, 0, 0); break; //Ettin (with club in 2d)
		case 0x13: break;       //Frost Spider
		case 0x14: break;       //Giant Spider
		case 0x15: CarveInfo(s, 0, 4,20, 0, 0, 0); break; //Giant Serpent
		case 0x16: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Gazer
		case 0x17: CarveInfo(s, 0, 1, 0, 7, 0, 0); break; //Dire Wolf
		case 0x18: break;	//Liche
		case 0x19: CarveInfo(s, 0, 1, 0, 5, 0, 0); break; //Grey Wolf
		case 0x1A: break;	//Ghoul
		case 0x1B: CarveInfo(s, 0, 1, 0, 5, 0, 0); break; //Grey Wolf (another one)
		case 0x1C: break;	//Spider
		case 0x1D: CarveInfo(s, 0, 1, 0, 1, 0, 0); break; //Gorilla
		case 0x1E: CarveInfo(s,50, 0, 0, 0, 0, 1); break; //Harpy
		case 0x1F: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Headless
			//case 0x20: break;	//-NULL-
		case 0x21: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Lizardman
		case 0x22: CarveInfo(s, 0, 1, 0, 5, 0, 0); break; //White Wolf
		case 0x23: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Lizardman (with spear in 2d)
		case 0x24: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Lizardman (with mace in 2d)
		case 0x25: CarveInfo(s, 0, 1, 0, 5, 0, 0); break; //White Wolf (another one)
		case 0x26: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Black Gate Daemon
		case 0x27: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Mongbat
		case 0x28: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Elder Daemon
		case 0x29: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc (with club in 2d)
		case 0x2A: CarveInfo(s, 0, 0, 0, 8, 0, 0); break; //Ratman
		case 0x2B: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Ice Fiend
		case 0x2C: CarveInfo(s, 0, 0, 0, 8, 0, 0); break; //Ratman (with axe in 2d)
		case 0x2D: CarveInfo(s, 0, 0, 0, 8, 0, 0); break; //Ratman (with sword in 2d)
		case 0x2E: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Ancient Wyrm
		case 0x2F: break;	//Reaper
		case 0x30: break;	//Giant Scorpion
		case 0x31: CarveInfo(s, 0,19,20, 0, 0, 0); break; //White Wyrm
		case 0x32: break;	//Skeleton
		case 0x33: break;	//Slime
		case 0x34: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Snake
		case 0x35: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Troll (with axe in 2d)
		case 0x36: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Troll
		case 0x37: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Troll (with club in 2d)
		case 0x38: break;	//Skeleton (with axe in 2d)
		case 0x39: break;	//Skeleton (with sword in 2d)
		case 0x3A: break;	//Wisp
		case 0x3B: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Red Dragon
		case 0x3C: CarveInfo(s, 0,10,20, 0, 0, 0); break; //Drake (grey)
		case 0x3D: CarveInfo(s, 0,10,20, 0, 0, 0); break; //Red Drake
		case 0x3E: CarveInfo(s, 0,10,20, 0, 0, 0); break; //Wyvern
		case 0x3F: CarveInfo(s, 0, 1,10, 0, 0, 0); break; //Cougar
		case 0x40: CarveInfo(s, 0, 1, 0,02, 0, 0); break; //Snow Leopard
		case 0x41: CarveInfo(s, 0, 1, 0,02, 0, 0); break; //Snow Leopard (another one)
		case 0x42: break;       //Swamp Tentacles
		case 0x43: break;       //Stone Gargoyle
		case 0x44: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Elder Gazer
		case 0x45: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Elder Gazer (another one)
		case 0x46: break;	//Terathan Warrior
		case 0x47: break;	//Terathan Drone
		case 0x48: break;	//Terathan Queen
		case 0x49: break;       //Stone Harpy
		case 0x4A: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Imp
		case 0x4B: CarveInfo(s, 0, 4, 0, 0, 0, 0); break; //Titan
		case 0x4C: CarveInfo(s, 0, 4, 0, 0, 0, 0); break; //Cyclops
		case 0x4D: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Kraken
		case 0x4E: break;       //Lich Lord
		case 0x50: CarveInfo(s, 0, 0,12, 0, 0, 0); break; //Giant Toad
		case 0x51: CarveInfo(s, 0, 0, 4, 0, 0, 0); break; //Bullfrog
		case 0x52: break;       //Lich Lord (another one)
		case 0x53: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Ogre Lord
		case 0x54: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Ogre Lord (another one)
		case 0x55: break;	//Ophidian Shaman
		case 0x56: break;	//Ophidian Warrior
		case 0x57: break;	//Ophidian Queen
		case 0x58: CarveInfo(s, 0, 2, 8, 0, 0, 0); break; //Mountain Goat
		case 0x59: CarveInfo(s, 0, 4,20, 0, 0, 0); break; //Giant Ice Snake
		case 0x5A: CarveInfo(s, 0, 4,20, 0, 0, 0); break; //Giant Lava Snake
		case 0x5B: CarveInfo(s, 0, 4,20, 0, 0, 0); break; //Giant Silver Serpent
		case 0x5C: CarveInfo(s, 0, 4,20, 0, 0, 0); break; //Giant Silver Serpent (another one)
		case 0x5D: CarveInfo(s, 0, 4,20, 0, 0, 0); break; //Giant Silver Serpent (another one)
		case 0x5E: break;       //Frost Slime
		case 0x5F: break;       //Leviathan (only works in 2D client)
		case 0x60: break;       //Frost Slime (another one)
		case 0x61: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Hell Hound
		case 0x62: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Hell Hound (pack leader)
		case 0x63: CarveInfo(s, 0, 1, 0, 7, 0, 0); break; //Dark Wolf
		case 0x64: CarveInfo(s, 0, 1, 0, 7, 0, 0); break; //Silver Wolf
		case 0x65: break;	//Centaur
		case 0x66: break;       //Exodus
		case 0x67: break;	//Serpentine Dragon
		case 0x68: break;       //Skeletal Dragon
			//case 0x69: break;       //-NULL-
		case 0x6A: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Shadow Wyrm
		case 0x6B: break;       //Agapite Elemental
		case 0x6C: break;       //Bronze Elemental
		case 0x6D: break;       //Copper Elemental
		case 0x6E: break;       //Dull Copper Elemental
		case 0x6F: break;       //Iron Elemental
		case 0x70: break;       //Valorite Elemental
		case 0x71: break;       //Verite Elemental
		case 0x72: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Dark Steed
		case 0x73: break;       //Ethereal Horse
		case 0x74: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Nightmare
		case 0x75: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Silver Steed
		case 0x76: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //War Horse (Britannians Faction)
		case 0x77: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //War Horse (Mage Council Faction)
		case 0x78: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //War Horse (Minax Faction)
		case 0x79: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //War Horse (Shadowlords Faction)
		case 0x7A: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Unicorn
		case 0x7B: break;       //Ethereal Warrior
		case 0x7C: break;       //Evil Mage
		case 0x7D: break;       //Evil Mage Master
		case 0x7E: break;       //Evil Mage Master (another one)
		case 0x7F: break;       //Predator Hell Cat
		case 0x80: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Pixie
		case 0x81: break;       //Swamp Tentacles (another one)
		case 0x82: break;       //Blistering Gargoyle
		case 0x83: break;       //Efreet
		case 0x84: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Kirin
		case 0x85: CarveInfo(s, 0, 1, 0,10, 0, 0); break; //Small Alligator
		case 0x86: CarveInfo(s, 0, 1, 0,10, 0, 0); break; //Komodo Dragon
		case 0x87: CarveInfo(s, 0, 2, 0, 0, 0, 0); break; //Artic Ogre Lord
		case 0x88: break;       //Ophidian Archmage
		case 0x89: break;       //Ophidian Knight
		case 0x8A: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc Lord
		case 0x8B: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc Chopper
		case 0x8C: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc Shaman
		case 0x8D: break;       //Paladin
		case 0x8E: CarveInfo(s, 0, 1, 0, 8, 0, 0); break; //Ratman Archer
		case 0x8F: CarveInfo(s, 0, 1, 0, 8, 0, 0); break; //Ratman Shaman
		case 0x90: break;       //Sea Horse
		case 0x91: break;	//Deep Sea Serpent
		case 0x92: break;       //The Harrower
		case 0x93: break;       //Skeleton Knight
		case 0x94: break;       //Skeleton Mage
		case 0x95: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Succubus
		case 0x96: break;	//Sea Serpent
		case 0x97: CarveInfo(s, 0, 1, 0, 7, 0, 0); break; //Dolphin
		case 0x98: break;       //Terathan Avenger
		case 0x99: break;       //Ghoul
		case 0x9A: break;       //Mummy
		case 0x9B: break;       //Rotting Corpse
			//case 0x9C: break;       //-NULL-
		case 0x9D: break;       //Black Widow Spider
		case 0x9E: break;       //Acid Elemental
		case 0x9F: break;       //Blood Elemental
		case 0xA0: break;       //Blood Elemental (another one)
		case 0xA1: break;       //Ice Elemental
		case 0xA2: break;       //Poison Elemental
		case 0xA3: break;       //Snow Elemental
		case 0xA4: break;       //Energy Vortex
		case 0xA5: break;       //Black Wisp
		case 0xA6: break;       //Gold Elemental
		case 0xA7: CarveInfo(s, 0, 1, 0, 2, 0, 0); break; //Brown Bear
		case 0xA8: break;       //Shadow Fiend
			//case 0xA9: break;       //-NULL-
		case 0xAA: break;       //Ethereal Llama
		case 0xAB: break;       //Ethereal Ostard
		case 0xAC: CarveInfo(s, 0,20,21, 0, 0, 0); break; //Red Dragon (big)
		case 0xAD: break;       //Mephitis, the Arachnid Champion
		case 0xAE: break;	//Semidar, Champion of the Abyss
		case 0xAF: break;	//Lord Oaks, the Forest Lord
		case 0xB0: break;	//Tatanya, the Forest Queen
		case 0xB1: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Nightmare (another one)
		case 0xB2: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Nightmare (another one)
		case 0xB3: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Nightmare (another one)
		case 0xB4: CarveInfo(s, 0,19,20, 0, 0, 0); break; //White Wyrm (Retro)
		case 0xB5: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc Scout
		case 0xB6: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Orc Bomber
			//case 0xB7-case 0xBA: break; //-NULL-
		case 0xBB: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Ridgeback
		case 0xBC: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Savage Ridgeback
		case 0xBD: break; //Orc Brute
		case 0xBE: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Fire Steed
			//case 0xBF-case 0xC7: break; //-NULL-
		case 0xC8: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Horse (Dappled Brown)
		case 0xC9: CarveInfo(s, 0, 1, 0, 1, 0, 0); break; //Cat
		case 0xCA: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Alligator
		case 0xCB: CarveInfo(s, 0, 6, 0, 0, 0, 0); break; //Pig
		case 0xCC: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Horse (dark)
		case 0xCD: CarveInfo(s, 0, 1, 0, 1, 0, 0); break; //Rabbit
		case 0xCE: CarveInfo(s, 0, 1,12, 0 ,0, 0); break; //Lava Lizard
		case 0xCF: CarveInfo(s, 0, 3, 0, 0, 1, 0); break; //Sheep
		case 0xD0: CarveInfo(s,25, 0, 0, 0, 0, 1); break; //Chicken
		case 0xD1: CarveInfo(s, 0, 2, 8, 0, 0, 0); break; //Goat Billy
		case 0xD2: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Desert Ostard
		case 0xD3: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Bear
		case 0xD4: CarveInfo(s, 0, 1, 0, 2, 0, 0); break; //Grizzly Bear
		case 0xD5: CarveInfo(s, 0, 2, 0, 3, 0, 0); break; //Polar Bear
		case 0xD6: CarveInfo(s, 0, 1,10, 0, 0, 0); break; //Panther
		case 0xD7: CarveInfo(s, 0, 1, 0, 1, 0, 0); break; //Giant Rat
		case 0xD8: CarveInfo(s, 0, 8,12, 0, 0, 0); break; //Cow (black)
		case 0xD9: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Hound
		case 0xDA: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Frenzied Ostard
		case 0xDB: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Forest Ostard
		case 0xDC: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Llama
		case 0xDD: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Walrus
			//case 0xDE: break;	//-NULL-
		case 0xDF: CarveInfo(s, 0, 3, 0, 0, 0, 0); break; //Sheep (Shorn)
		case 0xE1: CarveInfo(s, 0, 1, 0, 5, 0, 0); break; //Timber Wolf
		case 0xE2: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Horse (Dappled Grey)
			//case 0xE3: break;	//-NULL-
		case 0xE4: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Horse (tan)
			//case 0xE5: break;	//-NULL-
			//case 0xE6: break;	//-NULL-
		case 0xE7: CarveInfo(s, 0, 8,12, 0, 0, 0); break; //Spotted Cow
		case 0xE8: CarveInfo(s, 0,10,15, 0, 0, 0); break; //Brown Bull
		case 0xE9: CarveInfo(s, 0,10,15, 0, 0, 0); break; //Spotted Bull
		case 0xEA: CarveInfo(s, 0, 6,15, 0, 0, 0); break; //Great Heart
			//case 0xEB: break;	//-NULL-
			//case 0xEC: break;	//-NULL-
		case 0xED: CarveInfo(s, 0, 5, 8, 0, 0, 0); break; //Hind
		case 0xEE: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Sewer Rat
			//case 0xEF-case 0xFF: break; //-NULL-
		case 0x0122: CarveInfo(s, 0,10, 0, 0, 0, 0); break; //Boar
			//case 0x0123: break;   //-NULL-
		case 0x0124: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Pack Llama
			//case 0x0125-case 0x01A5: break; //-NULL
		case 0x01A4: break;     //Blonde Boy (only in pre-t2a relases)
		case 0x01A5: break;     //Brunette Boy (only in pre-t2a relases)
		case 0x01A6: break;     //Toddler Girl (only in pre-t2a relases)
		case 0x01A7: break;     //Brunette Girl (only in pre-t2a relases)
			//case 0x01A8-case 0x02EF: break; //-NULL-
		case 0x02F0: break;     //Iron Golem
		case 0x02F1: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Gargoyle Slave
		case 0x02F2: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Gargoyle Enforcer
		case 0x02F3: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Gargoyle Guard
		case 0x02F4: break;     //Exodus Clockwork Overseer
		case 0x02F5: break;     //Exodus Clockwork Minion
		case 0x02F6: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Gargoyle Shopkeeper
			//case 0x02F7-case 0xFA: break; //-NULL-
		case 0x02FB: break;     //Exodus Clockwork Minion
		case 0x02FC: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Juka Warrior
		case 0x02FD: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Juka Mage
		case 0x02FE: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Juka Lord
		case 0x02FF: break;     //Blackthorn Cohort
		case 0x0300: break;     //Juggernaut
		case 0x0301: break;     //Future Blackthorn (NPC)
		case 0x0302: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Meer Mage
		case 0x0303: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Meer Warrior
		case 0x0304: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Meer Ethernal
		case 0x0305: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Meer Capitain
		case 0x0306: break;     //Dawn Girl (NPC)
		case 0x0307: break;     //Plague Beast
		case 0x0308: break;     //Horde Demon (smallest)
		case 0x0309: break;     //Doppleganger
		case 0x030A: break;     //Swarm
		case 0x030B: break;     //Bogling
		case 0x030C: break;     //Bog Thing
		case 0x030D: break;     //Fire Ant Worker
		case 0x030E: break;     //Fire Ant Warrior
		case 0x030F: break;     //Fire Ant Queen
		case 0x0310: break;     //Arcane Demon
		case 0x0311: break;     //Four Armed Demon
			//case 0x0312: break;     //Chariot (not working yet)
			//case 0x0313: break;     //-NULL-
		case 0x0314: break;     //Sphinx
		case 0x0315: break;     //Quagmire
		case 0x0316: break;     //Sand Vortex
		case 0x0317: break;     //Giant Beetle
		case 0x0318: break;     //Chaos Demon
		case 0x0319: break;     //Skeletal Mount
		case 0x031A: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Swamp Dragon
		case 0x031B: break;     //Horde Demon
		case 0x031C: break;     //Horde Demon (big)
		case 0x031D: break;     //Rikktor, Champion of the Cold Blood
		case 0x031E: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Ancient Wyrm (Rust Dragon)
		case 0x031F: CarveInfo(s, 0,19,20, 0, 0, 0); break; //Armored Swamp Dragon
			//case 0x0320-case 0x0333: break; //-NULL-
		case 0x0334: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Dappled Brown Horse (another one)
		case 0x0338: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Dark Brown Horse (another one)
		case 0x0339: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Desert Ostard (another one)
		case 0x033A: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Forest Ostard (another one)
		case 0x033B: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Frenzied Ostard (another one)
		case 0x033C: CarveInfo(s, 0, 1,12, 0, 0, 0); break; //Llama (another one)
			//case 0x033D: break; //-NULL-
			//case 0x033E: break; //-NULL-
		case 0x033F: CarveInfo(s,25, 0, 0, 0, 0, 1); break; //Parrot
			//case 0x0340: CarveInfo(s,36, 0, 0, 0, 0, 1); break; //Phoenix (Not working yet)
			//case 0x0341: CarveInfo(s,25, 0, 0, 0, 0, 1); break; //Turkey (Not working yet)
		case 0x0342: break;     //Hell Cat
		case 0x0343: CarveInfo(s, 0, 1, 0, 1, 0, 0); break; //Jackrabbit
			//case 0x0344: break;     //-NULL-
		case 0x0345: break;     //Ice Snake
		case 0x0346: break;     //Lava Snake
		case 0x0347: CarveInfo(s, 0,15, 0, 0, 0, 0); break; //Ridgeback (another one)
			//case 0x0348: break;	  //Giant Ridgeback (not working yet)
			//case 0x0349: break;     //Flame Ridgeback (not working yet)
			//case 0x034A: break;     //Hatchling Ridgeback (not working yet)
		case 0x034B: CarveInfo(s, 0, 1, 0, 0, 0, 0); break; //Town Rat
			//case 0x034C-case 0x034F: break; //-NULL-
		case 0x0350: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Tan Horse (another one)
			//case 0x0351-case 0x03F5: break; //-NULL-
		case 0x03E6: CarveInfo(s, 0, 3,10, 0, 0, 0); break; //Kirin (another one)
		default: ;	// do nothing
		}
	}



}



////////////////
// name:	bgsound
// pupose:	Plays background sounds of the game
// history:	improved/completed/rewritten by LB 9-10 August 1999
//			added griditerator (Duke, 19.11.2000)
//
void bgsound (P_CHAR Player)
{
	int sound;
	unsigned int distance=(VISRANGE+5);
	P_CHAR inrange[15];
	int basesound=0;
	int bigf,xx;
	char sf,bfs;

	if (!Player) return;

	int y=0;
	cChar* pc;
	int loopexit=0;

	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pc->npc && !pc->dead && !pc->war && y<=10 && !pc->isDummy())
		{
			if (!pc->free) // lb, bugfix !
			{
				if (inRange(Player->pos, pc->pos, distance))
				{
					y++;
					inrange[y]=pc;
				}
			}
		}
	}

	if (y>0)
	{
		sound=((rand()%(y))+1);
		xx=inrange[sound]->id();
		if (xx>-1 && xx<2048)
		{
			basesound=creatures[xx].basesound;
			sf=creatures[xx].soundflag;
		}
		else return;

		if (basesound!=0)
		{
			switch(sf) // play only idle sounds, if there arnt any, dont play them !
			{
			case 0: basesound++; break;	// normal case -> play idle sound
			case 1: basesound++; break;	// birds sounds will be implmented later
			case 2:	basesound=0; break;	// no idle sound, so dont play it !
			case 3: basesound=0; break;	// no idle sound, so dont play it !
			case 4:	break; // only a single sound, play it !
			}
			if (basesound!=0)
			{
				SndSound(Player->calcSocket(), inrange[sound]->pos, basesound);
			}
		}
	}

	// play random mystic-sounds also if no creature is in range ...

	bigf=rand()%1333;
	basesound=0;

	if (bigf==66)
	{
		bfs=rand()%7;
		switch(bfs)
		{
		case 0: basesound=595;break; // gnome sound
		case 1: basesound=287;break; // bigfoot 1
		case 2: basesound=288;break; // bigfoot 2
		case 3: basesound=639;break; // old snake sound
		case 4: basesound=179;break; // lion sound
		case 5: basesound=246;break; // mystic
		case 6: basesound=253;break; // mystic II
		}

		if (basesound !=0)
		{
			SndSound(Player->calcSocket(), Player->pos, basesound);
		}
	}
}

void playmonstersound(P_CHAR Monster, int sfx)
{
	if (!Monster) return;
	short id=Monster->id();
	if (id>=2048) return;

	int basesound=creatures[id].basesound;
	char sf=creatures[id].soundflag;
	short offset=sfx;

	if (basesound != 0)
	{
		switch(sf)
		{
		case 0: break; // in normal case the offset is correct
		case 1: break; // birds sounds will be implmented later

		case 2:	// only start-attack, attack & ding sounds available
			if (sfx==1 || sfx==3) offset=-1; // idle, defend ? play nothing
			else if (sfx==2) offset=1; // correct offset
			else if (sfx==4) offset=2;
			break;
		case 3: // only start-attack, attack, defense & dying
			if (sfx==1) offset=-1; // idle -> play nothing
			else if (sfx==2) offset=1; // otherwise correct offsets
			else if (sfx==3) offset=2;
			else if (sfx==4) offset=3;
			break;
		case 4: // only a single sound
		
			if (sfx!=0) offset=-1; else offset=0;
		
			break;
		}
		basesound=basesound+offset;
		if (offset!=-1) soundeffect2(Monster, basesound);
		return;
	}
}

short NpcInfo_getIcon(short id)		{	return creatures[id].icon;}
short NpcInfo_getType(short id)		{	return creatures[id].type;}
bool  NpcInfo_canItFly(short id)	{	return creatures[id].who_am_i&0x1;}
bool  NpcInfo_antiBlink(short id)	{	return (creatures[id].who_am_i&0x2) > 0;}

short NpcInfo_GetFeathers(short id)	{	return creatures[id].feathers;}
short NpcInfo_GetRibs(short id)		{	return creatures[id].ribs;}
short NpcInfo_GetHides(short id)	{	return creatures[id].hides;}
short NpcInfo_GetFur(short id)		{	return creatures[id].fur;}
short NpcInfo_GetWool(short id)		{	return creatures[id].wool;}
short NpcInfo_GetBird(short id)		{	return creatures[id].bird;}



