/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "chars.h"

#include "accounts.h"
#include "Client.h"
#include "commands.h"
#include "house.h"
#include "itemid.h"
#include "magic.h"
#include "magic_new.h"
#include "mapS.h"
#include "mapstuff.h"
#include "msgboard.h"
#include "npcinfo.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"
#include "spells.h"
#include "sregions.h"
#include "TmpEff.h"
#include "trigger.h"
#include "utilsys.h"
#include "walking.h"
#include "worldmain.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "npcs.cpp"


#define CHAR_RESERVE 100	// minimum of free slots that should be left in the array.
							// otherwise, more memory will be allocated in the mainloop (Duke)
cChar **realchars;			// the anchor point for all the chars memory

unsigned int charcount;

void cSpawnContext::Init()
{
	LastItem=NULL;
	MyPack=NULL;
	ShopPack1A=NULL;
	ShopPack1B=NULL;
	ShopPack1C=NULL;
	haircolor=-1; // we need this to remember the haircolor for COLORMATCHHAIR
}


int addrandomcolor(int colorlist)
{
	int i,j,storeval=0;
	i=0; j=0;
	Script* Scp = findSection(colors_script,"RANDOMCOLOR",colorlist);
	if (!Scp)
	{
		LogWarningVar("Colorlist %i not found",colorlist);
		return 0;
	}
	int loopexit=0;
	while ( Scp->NextLineInSection() && (++loopexit < MAXLOOPS) )
	{
		i++;
	}
	Scp->Close();

	if (i>0)
	{
		i=rand()%i;
		i++;
		Scp = findSection(colors_script,"RANDOMCOLOR",colorlist);
		if (!Scp) return 0;
		loopexit=0;
		while ( Scp->NextLineInSection() && (++loopexit < MAXLOOPS) )
		{
			j++;
			if (j==i)
			{
				storeval=hstr2num(script1);
			}
		}
		Scp->Close();
	}
	return storeval;
}

void setrandomname(P_CHAR pc, char * namelist)
{
	if (!pc) return;

	char sect[512];
	int i=0,j=0;

	sprintf(sect, "RANDOMNAME %s", namelist);
	Script *pScpBase=i_scripts[npc_script];
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp)
	{
		sprintf(pc->name, "Error Namelist %s Not Found", namelist);
		return;
	}

	int loopexit=0;
	do
	{
		pScp->NextLine();
		if (script1[0]!='}')
		{
			i++;
		}
	}
	while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );
	pScp->Close();

	if (i>0)
	{
		i=rand()%(i);
		pScp=pScpBase->Select(sect,custom_npc_script);
		if (!pScp) return;

		loopexit=0;
		do
		{
			pScp->NextLine();
			if (script1[0]!='}')
			{
				if (j==i)
				{
					strcpy(pc->name,script1);
					break;
				}
				else j++;
			}
		}
		while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );
		pScp->Close();
	}
}

void setrandomsurname(P_CHAR pc, char * namelist)
{
	if (!pc) return;

	char sect[512];
	int i=0,j=0;

	sprintf(sect, "RANDOMNAME %s", namelist);
	Script *pScpBase=i_scripts[npc_script];
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp)
	{
		sprintf(pc->name, "Error Namelist %s Not Found", namelist);
		return;
	}

	int loopexit=0;
	do
	{
		pScp->NextLine();
		if (script1[0]!='}')
		{
			i++;
		}
	}
	while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );
	pScp->Close();

	if (i>0)
	{
		i=rand()%(i);
		pScp=pScpBase->Select(sect,custom_npc_script);
		if (!pScp) return;

		loopexit=0;
		do
		{
			pScp->NextLine();
			if (script1[0]!='}')
			{
				if (j==i)
				{
					strcat(pc->name," ");
					strcat(pc->name,script1);
					break;
				}
				else j++;
			}
		}
		while ((script1[0]!='}') && (++loopexit < MAXLOOPS) );
		pScp->Close();
	}
}

cCharStuff::cCharStuff()			{ cmem=0; charcount=0; moreCharMemoryRequested=false; charcount2=1;}
int cCharStuff::GetCount()			{ return charcount; }
int cCharStuff::GetCapacity()		{ return cmem; }
P_CHAR cCharStuff::MakeRef(int c)
{
	errorCA=0; // clear previous state, 0=no error
	
	if ( c<0 || (unsigned)c>=charcount || realchars[c] == NULL)
	{
		errorCA=1;
		return NULL;
	}
	return realchars[c];
}


void cCharStuff::DeleteChar(P_CHAR pc) // Delete character
{
	if (!pc) return;
	
	if (pc->serial >=0)
	{
		AllTmpEff->ExpireOnDeath(pc);
		DecSpawnCount(pc->spawnregion);
		
		removefromptr(&charsp[pc->serial%HASHMAX], pc);
		
		pc->SetSpawnSerial(-1);
		if (pc->ownserial!=-1) removefromptr(&cownsp[pc->ownserial%HASHMAX], pc);
		
		SndRemoveNpcToAll(pc);
		
		mapRegions->Remove(pc); // taking it out of mapregions BEFORE x,y changed, LB
	}
	
//	int c = pc->GetIndex();
//	delete realchars[c];
//	realchars[c] = NULL;		// can't do that here; leave it up to the mainloop
	pc->free=true;
}

void cCharStuff::FreeMemory()
{
	for (unsigned int i=0; i<charcount; i++)
	{
		if (realchars[i])
		{
			if (realchars[i]->free)
			{
				delete realchars[i];
				realchars[i] = NULL;
			}
		}
	}
}

bool cCharStuff::AllocateMemory(int NumberOfChars)
{
	bool memerr = false;
	cmem=NumberOfChars;
	cmem+=(2*CHAR_RESERVE);	// some reserve so realloc doesn't occur immediately after serverstart(Duke)
	if (cmem<40000) cmem=40000;	// as we now only allocate cChar *pointers* that's only 160 kB (Duke)

	int sz = cmem*sizeof(cChar*);
	if ((realchars= (cChar **) malloc(sz) )==NULL)
		memerr=true;
	else if (!AllTmpEff->Alloc(cmem*5))//MAXEFFECTS = 5*MAXCHARS
		memerr=1;

	if (memerr)
	{
		Console.send("\nERROR: Could not Allocate character memory!\n");
		error=1;
		return false;
	}

	memset(realchars,0,sz);		// make them NULL pointers

	Console.send("Done\n");
	return true;
}

bool cCharStuff::ResizeMemory()
{
	char memerr=0;
	const int slots=4000;   // bugfix for crashes under w95/98, LB never ever touch this number ...
	// it has major influence on performance !! if it too low -> slow and can cause crashes under w95/98.
	// this is because w95/98 can only handle 8196 subsequent realloc calls ( crappy thing...)
	// free() calls DONT help !!!, btw so we have to make that number real big
	// under nt and unix this limit doesnt exist

	P_CHAR *tp = (cChar **)realloc(realchars, (cmem + slots)*sizeof(cChar*) );
	if (tp==NULL)
		memerr=1;
	else if (!AllTmpEff->ReAlloc(cmem*5+slots*5))//MAXEFFECTS = 5*MAXCHARS
		memerr=1;
	
	if (memerr)
	{
		LogCriticalVar("Could not reallocate char memory after %i. No more chars will be created.\nLoneWolf may become unstable.",cmem);
		keeprun = 0;	// schedule shutdown
		LogMessage("LoneWolf shutdown due to char memory allocation problems");
		return false;
	}

	realchars = tp;		// change realchars only if realloc was ok (Duke)
	
	for (unsigned int i=cmem;i<cmem+slots;i++)
		realchars[i] = NULL;
	cmem+=slots;
	moreCharMemoryRequested=false;
	return true;
}

void cCharStuff::CheckMemoryRequest()
{
	if (moreCharMemoryRequested)
		ResizeMemory();
}

///////////////////////
// Name:	GetReusableSlot
// history:	by Duke, 6.09.2001
// Purpose:	searches for an empty slot in the chars array
//			It does this by simply searching from the *last* position where it found a slot.
//			If it reaches the end, it will search from the start. A timer prevents too many wrap-arounds.
//
int cCharStuff::GetReusableSlot()
{
	static unsigned int NextMemCheck=0;
	static unsigned int LastFree=0;	// remember this point in the array to continue search from here next time

	unsigned int ctime=uiCurrentTime;
	if (NextMemCheck<=ctime || (overflow))	// didn't wrap around in the past minute
	{
		unsigned int started=LastFree;		// remember where we started the search from here next time
		for (  ;LastFree<charcount;LastFree++)
		{
			P_CHAR LastFreeChar = MAKE_CHAR_REF(LastFree);
			if (!LastFreeChar)
				return LastFree;
		}
		// we have reached the end so start again from the beginning of the array
		for (LastFree=0;LastFree<started;LastFree++)
		{
			P_CHAR LastFreeChar = MAKE_CHAR_REF(LastFree);
			if (!LastFreeChar)
				return LastFree;
		}
		NextMemCheck=ctime+60*MY_CLOCKS_PER_SEC;	// nothing found, set time for next try
	}
	return -1;
}

int cCharStuff::MemCharFree()			// Find a free char slot
{
	if (charcount+CHAR_RESERVE >= cmem)	//less than 'Reserve' free slots left, so get more memory
		moreCharMemoryRequested=true;

	int c=GetReusableSlot();			// try to use the space of a deleted item
	if (c==-1)
	{
		if (charcount+1>=cmem)	//theres no more free sluts.. er slots
		{
			LogCritical("couldn't resize character memory in time");
			return -1;
		}
		c=charcount;
		charcount++;
	}
	realchars[c] = new cChar;
	return c;
}

int cCharStuff::GetNextFreeSerial()
{
	return charcount2++;
}

void cCharStuff::DetermineHighestSerial(int ser)
{
	if (charcount2<=ser) charcount2=ser+1;
}


P_ITEM cCharStuff::AddRandomLoot(P_ITEM Pack, char * lootlist)
{
	if (!Pack) return NULL;

	char sect[512];
	int i,j, storeval,loopexit=0;
	P_ITEM LastItem=NULL;
	storeval=-1;
	i=0; j=0;

	sprintf(sect, "LOOTLIST %s", lootlist);
	
	Script *pScpBase=i_scripts[npc_script];
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return NULL;

	loopexit=0;
	do
	{
		pScp->NextLine();
		if (script1[0]!='}')
		{
			i++; // Count number of entries on list.
		}
	} while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );
	pScp->Close();

	if (i>0)
	{
		i=rand()%(i);
		pScp=pScpBase->Select(sect,custom_npc_script);

		loopexit=0;
		do
		{
			pScp->NextLine();
			if (script1[0]!='}')
			{
				if (j==i)
				{
					storeval=str2num(script1);	//script1 = ITEM#

					scpMark m=pScp->Suspend();
					LastItem=Items->CreateScriptItem(storeval);
					pScp->Resume(m);

					if (LastItem)
					{
						LastItem->SetRandPosInCont(Pack);
						LastItem->SetContSerial(Pack->serial);
					}
					break;;    
				}
				else j++;
			}
		}	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );
		pScp->Close();
	}
	return LastItem;
}

int cCharStuff::PickFromNpcList(int npclist)
{
	char sect[512];
	sprintf(sect, "NPCLIST %i", npclist);

	Script *pScpBase=i_scripts[npc_script];
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return -1;

	return pScp->PickFromList();
}

P_CHAR cCharStuff::MakeBaseChar(bool newserial)
{
	int c=Npcs->MemCharFree();
	P_CHAR pc = MAKE_CHAR_REF(c);
	if (!pc) return NULL;
	pc->SetIndex(c);
	pc->Init(newserial);
	return pc;
}

P_CHAR cCharStuff::createNpcFromScript(int npcNum, struct wander_st * wan)
{
	char sect[512];

	Script *pScpBase=i_scripts[npc_script];
	sprintf(sect, "NPC %i", npcNum);
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return NULL;

	// check if the npc is actually an NPCLIST
	int loopexit=0;
	while (pScp->NextLineSplitted() && (++loopexit < MAXLOOPS) )
	{
		if (!strcmp("NPCLIST", script1))
		{
			scpMark m=pScp->Suspend();
			
			npcNum=Npcs->PickFromNpcList(str2num(script2));
			sprintf(sect, "NPC %i", npcNum);
			if (npcNum==-1) 
			{ 
				pScp->Close();
				return NULL;
			}
			pScp->Resume(m);
			break;  //got the NPC number to add stop reading
		}
	}
	pScp->Close();
	
	
	pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return NULL;

	//
	// Now lets spawn him/her
	//
	P_CHAR pc_c = Npcs->MakeBaseChar();
	if (!pc_c) return NULL;

	pc_c->scriptnum=npcNum;

	pc_c->setPriv(0x10);
	pc_c->npc=1;
	pc_c->att=1;
	pc_c->def=1;

	cSpawnContext CT;
	CT.Init();

	loopexit=0;
	while (pScp->NextLineSplitted() && (++loopexit < MAXLOOPS) )
	{
		int rc=0;
		
		// new NPCWANDER implementation
		if		(!strcmp("FX1",script1)) {wan->fx1=str2num(script2);continue;}
		else if (!strcmp("FX2",script1)) {wan->fx2=str2num(script2);continue;}
		else if (!strcmp("FY1",script1)) {wan->fy1=str2num(script2);continue;}
		else if (!strcmp("FY2",script1)) {wan->fy2=str2num(script2);continue;}
		else if (!strcmp("FZ1",script1)) {wan->fz1=str2num(script2);continue;}
		
		rc = ApplySkillTags(pc_c);							// well, the skill tags ;)
		if (rc) {if (rc==1) continue; else return NULL;}
		
		rc = ApplyCommonTags(pc_c);							// tags common to scp, wsc and monstergate
		if (rc) {if (rc==1) continue; else return NULL;}
		
		rc = ApplyTags(pc_c, pScp, npcNum, &CT);			// other tags in scp
		if (rc) {if (rc==1) continue; else return NULL;}
		
		rc = ApplyBirthLootTags(pc_c, pScp, npcNum, &CT);	// loot related tags in scp and monstergate
		if (rc) {if (rc==1) continue; else return NULL;}
		
		LogWarningVar("Unrecognized Tag <%s> in npc.scp",script1);
	}
	pScp->Close();
	
	//Now calc effective 'skill' based on 'baseskill' (stat modifiers)
	int skmax=SkillManager->getAllSkillsValue();
	for(int sk=0;sk<skmax;sk++)
	{
		SkillManager->updateSkillLevel(pc_c,sk);
	}
	
	return pc_c;
}


////////////////
// Name:	AddNPC (3 interfaces)
// Purpose: creates the scripted NPC given by npcNum
//			The position of the NPC can be given in three different ways:
//			1. by parms x1 y1 z1 (trigger)
//			2. by passing a socket (GM add)
//			3. by passing an item index (spawn rune)
//
// History: by Duke, 23.05.2000
// Remarks:	This function was created from the former AddRespawnNPC() and
//			AddNPCxyz() that were 95% identical
//
P_CHAR cCharStuff::AddRespawnNPC(PC_ITEM pi, int npcNum)
{
	return AddNPC(-1, pi, npcNum, 0,0,0);	// 's' is an item index
}
P_CHAR cCharStuff::AddRespawnNPC(UOXSOCKET s, int npcNum)
{
	return AddNPC(s, NULL, npcNum, 0,0,0);
}

P_CHAR cCharStuff::AddNPC(int s, int npcNum, const cCoord &pos)
{
	return AddNPC(s, NULL, npcNum, pos);	// 's' maybe(!) is a socket
}
P_CHAR cCharStuff::AddNPC(int s, PC_ITEM Spawner, int npcNum, int x1, int y1, signed char z1)
{
	cCoord spos(x1,y1,z1,DEFAULT_MAP);
	return AddNPC(s, Spawner, npcNum, spos);
}
P_CHAR cCharStuff::AddNPC(int s, PC_ITEM Spawner, int npcNum, const cCoord &pos)
{
	short postype;				// determines how xyz of the new NPC are set, see below

	if (pos.x > 0 && pos.y > 0)
 		postype = 3;	// take position from parms
	else if ( s > -1 && !Spawner)
		postype = 2;	// take position from socket's buffer
	else if ( s == -1 && Spawner)
		postype = 1;	// take position from items[i]
	else
	{
		Console.send("ERROR: bad parms in call to AddNPC\n");
		return NULL;
	}


	wander_st wan = {0,};	// temp. hold the rectangle or circle for npcwander from script
	P_CHAR pc_c = createNpcFromScript(npcNum,&wan);
	if (!pc_c) return NULL;
	
	
	// Now that we have created the NPC, lets place him
	switch (postype)
	{
	case 1:					// take position from (spawning) item
		if (!Spawner) return NULL;

		if (triggerx)
		{
			pc_c->pos.x=triggerx;
			pc_c->pos.y=triggery;
			pc_c->dispz=pc_c->pos.z=triggerz;
		} else
		{
		/*Zippy's Code chages for area spawns --> (Type 69) xos and yos (X OffSet, Y OffSet) 
		are used to find a random number that is then added to the spawner's x and y (Using 
		the spawner's z) and then place the NPC anywhere in a square around the spawner. 
		This square is random anywhere from -10 to +10 from the spawner's location (for x and 
		y) If the place chosen is not a valid position (the NPC can't walk there) then a new 
		place will be chosen, if a valid place cannot be found in a certain # of tries (50), 
		the NPC will be placed directly on the spawner and the server op will be warned. */
			
			int k=0, xos=0, yos=0, lb;
			
			if ((Spawner->isType(ITY_NpcAreaSpawner) || Spawner->isType(ITY_QuestSpawn))&& Spawner->isInWorld())
			{
				short xoMax = (Spawner->more3==0) ? 10 : Spawner->more3;
				short yoMax = (Spawner->more4==0) ? 10 : Spawner->more4;
				//signed char z, ztemp, found;
				
				k=0;
				do
				{
					if (k>=50) //this CAN be a bit laggy. adjust as nessicary
					{
						Console.send("Problem area spawner found at [%i,%i,%i]. NPC placed at default location.\n",Spawner->pos.x,Spawner->pos.y,Spawner->pos.z);
						xos=0;
						yos=0;
						break;
					}
					xos=RandomNum(-xoMax, xoMax);
					yos=RandomNum(-yoMax, yoMax);
					// Console.send("Spawning at Offset %i,%i (%i,%i,%i) [-%i,%i <-> -%i,%i]. [Loop #: %i]\n",xos,yos,items[i].x+xos,items[i].y+yos,items[i].z,items[i].more3,items[i].more3,items[i].more4,items[i].more4,k); /** lord binary, changed %s to %i, crash when uncommented ! **/
					k++;
					
					cCoord SpPos(Spawner->pos);
					SpPos.Add(xos,yos);
					if (SpPos.x < 1 || SpPos.y < 1) lb=0; /* lord binary, fixes crash when calling npcvalid with negative coordiantes */
					else lb=validNPCMove(SpPos.x,SpPos.y,SpPos.z,pc_c);				 
					
					// Bug fix Monsters spawning on water and mountains:	
					// validnpcmove acutally returns 0 if it is an invalid move for sure
					// but if it returns 1 it needs further checking !!!!!!!
					if (lb)
					{
                      // first of all statics
					  AllMaps->mapStaticIteratorStart(SpPos);
					  cellData stat;
					  
					  int loopexit=0;
					  while ( (AllMaps->mapStaticIteratorNext(stat)) && (++loopexit < MAXLOOPS) )
					  {
						const tileData *tile;
						tile = TileData->SeekTile(stat.TID);
						if ( (TileData->isTileBlocking(stat.TID)) || (TileData->isTileWet(stat.TID)) ) lb=0;
					  }

					  // secondly base map
					  if (lb)
					  {
					    cellData map1;	                  
	                    AllMaps->SeekMap(SpPos, map1);	             
	                    if ( TileData->isLandBlocking(map1.TID)  || TileData->isLandWet(map1.TID) ) lb=0;	
					  }
					}
				} while (!lb);
			} // end Zippy's changes (exept for all the +xos and +yos around here....)
			
			pc_c->pos=Spawner->pos;
			pc_c->pos.Add(xos,yos);
			pc_c->dispz=pc_c->pos.z;
			bool ok = pc_c->SetSpawnSerial(Spawner->serial);
			if (!ok)
			{
				sprintf(temp, "Invalid Spawnserial set for spawer item:%s serial:%i spawneder NPC:%s serial:%i\n", Spawner->name, Spawner->serial, pc_c->name, pc_c->serial);
				LogError(temp);
			}

			if (Spawner->more1)						// inherit npcwander from spawner ?
				pc_c->npcWander = Spawner->more2;
			
			pc_c->qsf = Spawner->qsf;				// inherit qsfid
		}
		break;
	case 2: // take position from Socket
		if (s!=-1)
		{
			pc_c->pos.x=(buffer[s][11]<<8)+buffer[s][12];
			pc_c->pos.y=(buffer[s][13]<<8)+buffer[s][14];
			pc_c->dispz=pc_c->pos.z=buffer[s][16]+Map->TileHeight((buffer[s][17]<<8)+buffer[s][18]);
			P_CHAR Player = MAKE_CHAR_REF(currchar(s));
			if (Player)
				pc_c->pos.map = Player->pos.map;
		}
		break;
	case 3: // take position from Parms
		pc_c->pos = pos;
		pc_c->dispz = pos.z;
		break;
	} // no default coz we tested on entry to function

	// now we have a position, let's set the borders
	switch (pc_c->npcWander)
	{
	case 2:		// circle
		pc_c->fx1=pc_c->pos.x;
		pc_c->fy1=pc_c->pos.y;
		pc_c->fz1=pc_c->pos.z;
		pc_c->fx2=(wan.fx2>=0) ? wan.fx2 : 2;	// radius; if not given from script,default=2
		break;
	case 3:		// box
		if (postype==1 && Spawner->more3 && Spawner->more4)
		{
			pc_c->fx1=Spawner->pos.x-Spawner->more3;
			pc_c->fx2=Spawner->pos.x+Spawner->more3;
			pc_c->fy1=Spawner->pos.y-Spawner->more4;
			pc_c->fy2=Spawner->pos.y+Spawner->more4;
			pc_c->fz1= -1;			// irrelevant for box
			break;
		}
		if (wan.fx1 || wan.fx2 || wan.fy1 || wan.fy2)	// any offset for rectangle given from script ?
		{
			pc_c->fx1=pc_c->pos.x+wan.fx1;
			pc_c->fx2=pc_c->pos.x+wan.fx2;
			pc_c->fy1=pc_c->pos.y+wan.fy1;
			pc_c->fy2=pc_c->pos.y+wan.fy2;
			pc_c->fz1= -1;			// irrelevant for box
		}
		break;
	//default: do nothing
	}
	
	pc_c->region=calcRegionFromXY(pc_c->pos);
	
	updatechar(pc_c);
	
	// Dupois - Added April 4, 1999
	// After the NPC has been fully initialized, then post the message (if its a quest spawner) type==125
	if (postype==1) // lb crashfix
	{
		if ( Spawner->isType(ITY_QuestSpawn) )
		{
			if (!MsgBoardQuestEscortCreate( pc_c ))
			{
				Npcs->DeleteChar(pc_c);
				return NULL;
			}
		}
	}
	// End - Dupois
	
	mapRegions->Add(pc_c);
	return pc_c;
}

static bool GetSkillVal(unsigned short *pska, char* key, int sk)
{
	if (!strcmp(key,script1))
	{
		pska[sk] = getstatskillvalue(script2);
		return true;
	}
	return false;
}

int cCharStuff::ApplySkillTags(P_CHAR pc)
{
	return ApplySkillTags(pc->baseskill);
}

int cCharStuff::ApplySkillTags(unsigned short *pska)
{
	int rc = 0;

	switch(script1[0])
	{
	case 'A':
			 if (GetSkillVal(pska,"ALCHEMY",	ALCHEMY)) rc=1;
		else if (GetSkillVal(pska,"ANATOMY",	ANATOMY)) rc=1;
		else if (GetSkillVal(pska,"ARCHERY",	ARCHERY)) rc=1;
		else if (GetSkillVal(pska,"ARMSLORE",	ARMSLORE)) rc=1;
		else if (GetSkillVal(pska,"ANIMALLORE",	ANIMALLORE)) rc=1;
		break;
	case 'B':
			 if (GetSkillVal(pska,"BEGGING",	BEGGING)) rc=1;
		else if (GetSkillVal(pska,"BLACKSMITHING",BLACKSMITHING)) rc=1;
		else if (GetSkillVal(pska,"BOWCRAFT",	BOWCRAFT)) rc=1;
		break;
	case 'C':
			 if (GetSkillVal(pska,"CAMPING",	CAMPING)) rc=1;
		else if (GetSkillVal(pska,"CARPENTRY",	CARPENTRY)) rc=1;
		else if (GetSkillVal(pska,"CARTOGRAPHY",CARTOGRAPHY)) rc=1;
		else if (GetSkillVal(pska,"COOKING",	COOKING)) rc=1;
		break;
	case 'D':
			 if (GetSkillVal(pska,"DETECTINGHIDDEN",DETECTINGHIDDEN)) rc=1;
		break;
	case 'E':
			 if (GetSkillVal(pska,"ENTICEMENT",	ENTICEMENT)) rc=1;
		else if (GetSkillVal(pska,"EVALUATINGINTEL",EVALUATINGINTEL)) rc=1;
		break;
	case 'F':
			 if (GetSkillVal(pska,"FISHING",	FISHING)) rc=1;
		else if (GetSkillVal(pska,"FORENSICS",	FORENSICS)) rc=1;
		else if (GetSkillVal(pska,"FENCING",	FENCING)) rc=1;
		break;
	case 'H':
			 if (GetSkillVal(pska,"HEALING",	HEALING)) rc=1;
		else if (GetSkillVal(pska,"HERDING",	HERDING)) rc=1;
		else if (GetSkillVal(pska,"HIDING",		HIDING)) rc=1;
		break;
	case 'I':
			 if (GetSkillVal(pska,"ITEMID",		ITEMID)) rc=1;
		else if (GetSkillVal(pska,"INSCRIPTION",INSCRIPTION)) rc=1;
		break;
	case 'L':
			 if (GetSkillVal(pska,"LUMBERJACKING",	LUMBERJACKING)) rc=1;
		else if (GetSkillVal(pska,"LOCKPICKING",	LOCKPICKING)) rc=1;
		break;
	case 'M':
			 if (GetSkillVal(pska,"MACEFIGHTING",	MACEFIGHTING)) rc=1;
		else if (GetSkillVal(pska,"MINING",			MINING)) rc=1;
		else if (GetSkillVal(pska,"MAGERY",			MAGERY)) rc=1;
		else if (GetSkillVal(pska,"MAGICRESISTANCE",MAGICRESISTANCE)) rc=1;
		else if (GetSkillVal(pska,"MUSICIANSHIP",	MUSICIANSHIP)) rc=1;
		else if (GetSkillVal(pska,"MEDITATION",		MEDITATION)) rc=1;
		break;
	case 'P':
			 if (GetSkillVal(pska,"PARRYING",	PARRYING)) rc=1;
		else if (GetSkillVal(pska,"PEACEMAKING",PEACEMAKING)) rc=1;
		else if (GetSkillVal(pska,"PROVOCATION",PROVOCATION)) rc=1;
		else if (GetSkillVal(pska,"POISONING",	POISONING)) rc=1;
		break;
	case 'R':
			 if (GetSkillVal(pska,"REMOVETRAPS",REMOVETRAPS)) rc=1;
		break;
	case 'S':
			 if (GetSkillVal(pska,"SPIRITSPEAK",SPIRITSPEAK)) rc=1;
		else if (GetSkillVal(pska,"STEALTH",	STEALTH)) rc=1;
		else if (GetSkillVal(pska,"SWORDSMANSHIP",SWORDSMANSHIP)) rc=1;
		else if (GetSkillVal(pska,"SNOOPING",	SNOOPING)) rc=1;
		else if (GetSkillVal(pska,"STEALING",	STEALING)) rc=1;
		break;
	case 'T':
			 if (GetSkillVal(pska,"TACTICS",	TACTICS)) rc=1;
		else if (GetSkillVal(pska,"TAILORING",	TAILORING)) rc=1;
		else if (GetSkillVal(pska,"TAMING",		TAMING)) rc=1;
		else if (GetSkillVal(pska,"TASTEID",	TASTEID)) rc=1;
		else if (GetSkillVal(pska,"TINKERING",	TINKERING)) rc=1;
		else if (GetSkillVal(pska,"TRACKING",	TRACKING)) rc=1;
		break;
	case 'V':
			 if (GetSkillVal(pska,"VETERINARY",	VETERINARY)) rc=1;
		break;
	case 'W':
			 if (GetSkillVal(pska,"WRESTLING",	WRESTLING)) rc=1;
		break;
	default:
		rc = 0;
	}
	return rc;
}

int cCharStuff::ApplyCommonTags(P_CHAR pc_c)
{
	switch(script1[0])
	{
	case 'E':
		if (!strcmp("EAT",script1)) // tags for new food system (thrawn)
		{
			if (!strlen(script2)) // be sure min. one food flag exists
			{
				LogWarningVar("Tag <%s> without subtags found in npc.scp",script1);
				break; 
			}

			pc_c->SetFood(0); // set food to 0 is necessary, because standart is "can eat" everything (thrawn)

			//search for the different flags
			if (strstr(script2,"BAKED"))		pc_c->AddFood((unsigned char)FOOD_BAKED);
			if (strstr(script2,"CHEESE"))		pc_c->AddFood((unsigned char)FOOD_CHEESE);
			if (strstr(script2,"FISH"))			pc_c->AddFood((unsigned char)FOOD_FISH);
			if (strstr(script2,"FRUITS"))		pc_c->AddFood((unsigned char)FOOD_FRUIT);
			if (strstr(script2,"MAGIC"))		pc_c->AddFood((unsigned char)FOOD_MAGIC);
			if (strstr(script2,"MEAT"))			pc_c->AddFood((unsigned char)FOOD_MEAT);
			if (strstr(script2,"RAW"))			pc_c->AddFood((unsigned char)FOOD_RAW);
			if (strstr(script2,"VEGETABLES"))	pc_c->AddFood((unsigned char)FOOD_VEGETABLE);

		}
		else return 0;
		break;
	case 'F':
		if (!strcmp("FAME",script1))		pc_c->fame=str2num(script2);
		else return 0;
		break;
	case 'H':
		if (!strcmp("HIDAMAGE",script1))	pc_c->hidamage=str2num(script2);
		else return 0;
		break;
	case 'K':
		if (!strcmp("KARMA",script1))		pc_c->karma=str2num(script2);
		else return 0;
		break;
	case 'L':
		if (!strcmp("LODAMAGE",script1))	pc_c->lodamage=str2num(script2);
		else return 0;
		break;
	case 'N':
		if (!strcmp("NAME",script1))		strcpy(pc_c->name, script2);
		else return 0;
		break;
	case 'P':
		if (!strcmp("POISON",script1))		pc_c->SetPoison(str2num(script2));
		else return 0;
		break;
	case 'T':
		if (!strcmp("TITLE",script1))		strcpy(pc_c->title, script2);
		else return 0;
		break;
	default:
		return 0;
	}
	return 1;	// we have handled it :)
}


///////////////////////////////
// loot that's created on char-creation
// (GOLD+ITEMPACK token)
//////////////////////////////

int cCharStuff::ApplyBirthLootTags(P_CHAR pc_c, Script *pScp, int npcNum, cSpawnContext* CT)
{
   switch(script1[0])
	{
	case 'G':
		if (!strcmp("GOLD", script1))
		{
			if (CT->MyPack)
			{
				int amt;
				gettokennum(script2, 0);
				int lovalue=str2num(gettokenstr);
				gettokennum(script2, 1);
				int hivalue=str2num(gettokenstr);
				if (hivalue==0)
				{
					if (lovalue/2!=0) amt=lovalue/2 + (rand()%(lovalue/2));
					else amt=0;
				}
				else
				{
					if (hivalue-lovalue!=0) amt=lovalue + (rand()%(hivalue-lovalue));
					else amt=lovalue;
				}
				if (amt > 0)
				{
					scpMark m=pScp->Suspend();
					P_ITEM pGold=Items->SpawnItem(pc_c,amt,"#",1,0x0EED,0,1);
					if (!pGold)
					{
						Npcs->DeleteChar(pc_c);
						return 2;
					}
					pScp->Resume(m);					
					pGold->decayOn();
				}
			} else LogWarningVar("Bad NPC Script %d with problem no backpack for gold.", npcNum);
		} else return 0;
		break;
		
	case 'P':
		if (!strcmp("PACKITEM",script1))
		{
			if (CT->MyPack)
			{
				int inum=str2num(script2);
				
				scpMark m=pScp->Suspend();
				CT->LastItem=Items->CreateScriptItem(inum);
				pScp->Resume(m);
				
				if (CT->LastItem && CT->MyPack)
				{
					CT->LastItem->SetContSerial(CT->MyPack->serial);
					CT->LastItem->SetRandPosInCont(CT->MyPack);
				}
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			}
			else
				LogWarningVar("Bad NPC Script %d with problem no backpack for packitem.", npcNum);
		} else return 0;
		break;		
	}
	return 1;	// we have handled it :)
}

////////////////////////////////////////////////////////////
//// ONLY CALLED WHEN Mobile DIES !!!!!
//// (loot that's generated when it dies=all LOOT+LOOTPERCENT tokens)
/////////////////////////////////////////////////////////////

int cCharStuff::ApplyDeathLootTags(P_CHAR pc_c)
{
	int npcNum=pc_c->scriptnum;
	char sect[1024];

	////////////////
	/// much code, but basicly we only loop through the SECTION NPC npcNUM, call ApplyDeathLootTag(pc_c) for each
	////////////////

	Script *pScpBase=i_scripts[npc_script];
	sprintf(sect, "NPC %i", npcNum);
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return 0;
	
	int loopexit=0;
	do
	{
		pScp->NextLineSplitted();
		if (script1[0]!='}')
		{
			if (!strcmp("NPCLIST", script1))
			{
				scpMark m=pScp->Suspend();
				
				npcNum=Npcs->PickFromNpcList(str2num(script2));
				sprintf(sect, "NPC %i", npcNum);
				if (npcNum==-1) 
				{ 
					pScp->Close();
					return 0;
				}
				pScp->Resume(m);
				break; 
			}
		}
	} while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

	pScp->Close();

	cSpawnContext CT;
	CT.Init();
	CT.MyPack=pc_c->getBackpack(); // note: we are only looping the LOOT tags, so no backback tag, hence we have to set it manually

	pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return 0;

	loopexit=0;
	do
	{
		pScp->NextLineSplitted();	
		
		if (script1[0]!='}')
		{					
			Npcs->ApplyDeathLootTags(pScp, npcNum, &CT);	// finally add the loot ;)			
		}

	}  while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );

   pScp->Close();

   return 1;
}

void cCharStuff::ApplyDeathLootTags(Script *pScp, int npcNum, cSpawnContext* CT)
{	

	if (!strcmp("LOOT",script1))
	{			
			if (CT->MyPack)
			{			
				scpMark m=pScp->Suspend();
				CT->LastItem=Npcs->AddRandomLoot(CT->MyPack, script2);
				if (!CT->LastItem)
				{
					LogWarningVar("could not add LOOT %s to npc",script2);
				}
				pScp->Resume(m);
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			}
			else
				LogWarningVar("Bad NPC Script %d with problem no backpack for loot.", npcNum);
		}
		else if (!strcmp("LOOTPERCENT", script1))
		{
			if (CT->MyPack)
			{
                gettokennum(script2, 1);
                int Percent = str2num(gettokenstr);
                if (rand()%100 < Percent)
                {
					scpMark m=pScp->Suspend();
					gettokennum(script2, 0);
					CT->LastItem = Npcs->AddRandomLoot(CT->MyPack, gettokenstr);
					if (!CT->LastItem)
					{
						LogWarningVar("could not add LOOT %s to npc",script2);
					}
					pScp->Resume(m);
					strcpy(script1, "DUMMY");
                }
			}
		} 
		else return;
		
	return;
}

int cCharStuff::ApplyTags(P_CHAR pc_c, Script *pScp, int npcNum, cSpawnContext* CT)
{
	switch(script1[0])
	{
	case 'B':
		if (!strcmp("BACKPACK", script1))
		{
			if (!CT->MyPack)
			{
				scpMark m=pScp->Suspend();
				CT->MyPack = pc_c->addBackpack();
				if (!CT->MyPack)
				{
					Npcs->DeleteChar(pc_c);
					return 2;
				}				
				CT->LastItem=CT->MyPack;
				pScp->Resume(m);
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			}
		}
		else return 0;
		break;
		
	case 'C':
		if (!strcmp("COLOR",script1))
		{
			if (CT->LastItem)
			{
				CT->LastItem->setColor(hstr2num(script2));
			}
		}
		else if (!strcmp("CARVE",script1)) pc_c->carve=str2num(script2);
		else if (!strcmp("CANTRAIN",script1)) pc_c->cantrain=true;
		else if (!strcmp("COLORMATCHHAIR",script1))
		{
			if (CT->LastItem && CT->haircolor!=-1)
			{
				CT->LastItem->setColor(CT->haircolor);
			}
		}
		else if (!strcmp("COLORLIST",script1))
		{
			scpMark m=pScp->Suspend();
			int rcol=addrandomcolor(str2num(script2));
			if (CT->LastItem)
			{
				CT->LastItem->setColor(rcol);
			}
			pScp->Resume(m);
			strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
		}
		else return 0;
		break;
		
	case 'D':
		if (!strcmp("DIRECTION",script1))
		{
			if (!strcmp("NE",script2)) pc_c->dir=1;
			else if (!strcmp("E",script2)) pc_c->dir=2;
			else if (!strcmp("SE",script2)) pc_c->dir=3;
			else if (!strcmp("S",script2)) pc_c->dir=4;
			else if (!strcmp("SW",script2)) pc_c->dir=5;
			else if (!strcmp("W",script2)) pc_c->dir=6;
			else if (!strcmp("NW",script2)) pc_c->dir=7;
			else if (!strcmp("N",script2)) pc_c->dir=0;
		}
		else if (!strcmp("DEX",script1) || !strcmp("DEXTERITY",script1)) 
		{
			pc_c->setDex(getstatskillvalue(script2));
			pc_c->fullStm();
		}
		else if (!strcmp("DEF",script1)) pc_c->def = getstatskillvalue(script2);
		else if (!strcmp("DAMAGE",script1) || !strcmp("ATT",script1))
		{
			gettokennum(script2, 0);
			int lovalue=str2num(gettokenstr);
			gettokennum(script2, 1);
			int hivalue=str2num(gettokenstr);
			pc_c->lodamage = lovalue;
			pc_c->hidamage = lovalue;
			if (hivalue)
				pc_c->hidamage = hivalue;
		}
		else return 0;
		break;
		
	case 'E':
		if (!strcmp("EMOTECOLOR",script1))	pc_c->emotecolor=hstr2num(script2);
		else return 0;
		break;
		
	case 'F':
		if (!strcmp("FLEEAT",script1))		pc_c->fleeat=str2num(script2);
		else return 0;
		break;
		
	case 'H':
		if (!strcmp("HAIRCOLOR",script1))
		{
			scpMark m=pScp->Suspend();
			
			if (CT->LastItem) // LB, couple of bugfixes
			{
				CT->haircolor=addrandomcolor(str2num(script2));
				if (CT->haircolor!=-1)
				{
					CT->LastItem->setColor(CT->haircolor);
				}
			}
			pScp->Resume(m);
			strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
		}
		else return 0;
		break;
		
	case 'I':
		if (!strcmp("ID",script1))
		{
			int tmp=hstr2num(script2);
			pc_c->setId(tmp);
			pc_c->setXid(tmp);
		}
		else if (!strcmp("ITEM",script1))
		{
			int inum=str2num(script2);
			
			scpMark m=pScp->Suspend();
			CT->LastItem=Items->CreateScriptItem(inum);
			pScp->Resume(m);
			
			if (CT->LastItem)
			{
				CT->LastItem->SetContSerial(pc_c->serial);
				if (CT->LastItem->layer==0)
					Console.send("Warning: Bad NPC Script %d with problem item %d executed!\n", npcNum, inum);
			}
			strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
		}
		else if (!strcmp("INT",script1) || !strcmp("INTELLIGENCE",script1))
		{
			pc_c->setInt(getstatskillvalue(script2));
			pc_c->fullMana();
		}
		else return 0;
		break;
		
	case 'L':
		if (!strcmp("LIFETIME",script1)) 
		{
			unsigned int uiTimer=str2num(script2);
			pc_c->summontimer = uiCurrentTime +(uiTimer*MY_CLOCKS_PER_SEC);
		}
		else return 0;
		break;

	case 'N':
		if (!strcmp("NAMELIST", script1))
		{
			scpMark m=pScp->Suspend();
			setrandomname(pc_c,script2);
			pScp->Resume(m);
			strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
		}
		else if (!strcmp(script1, "NOTRAIN"))	pc_c->cantrain=false;
		else if (!strcmp("NPCWANDER",script1))	pc_c->npcWander=str2num(script2);
		else if (!strcmp("NPCAI",script1))		pc_c->setAi(hstr2num(script2));
		else return 0;
		break;
		
	case 'O':
		if (!strcmp("ONHORSE",script1))			pc_c->onhorse=true;
		else return 0;
		break;
		
	case 'P':
			 if (!strcmp("PRIV1",script1))		pc_c->setPriv(str2num(script2));
		else if (!strcmp("PRIV2",script1))		pc_c->SetPriv2(str2num(script2));
		else return 0;
		break;
		
	case 'R':
		if (!strcmp("RACE",script1))			pc_c->setRace(str2num(script2));
		else if (!strcmp("REATTACKAT",script1))	pc_c->reattackat=str2num(script2);
		else if (!strcmp("RSHOPITEM",script1))
		{
			if (!CT->ShopPack1A)
			{
				CT->ShopPack1A=pc_c->GetItemOnLayer(0x1A);
			}
			if (CT->ShopPack1A)
			{
				int rsi=str2num(script2);
				
				scpMark m=pScp->Suspend();
				CT->LastItem=Items->CreateScriptItem(rsi);
				pScp->Resume(m);
				
				if (CT->LastItem)
				{
					CT->LastItem->SetContSerial(CT->ShopPack1A->serial);
					CT->LastItem->SetRandPosInCont(CT->ShopPack1A);
					if (CT->LastItem->name2 && (strcmp(CT->LastItem->name2,"#")))
						strcpy(CT->LastItem->name,CT->LastItem->name2); // Item identified! -- by Magius(CHE)					}
				}
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			} else
			{
				LogWarningVar("Bad NPC Script %d with problem no shoppack1 for item.", npcNum);
			}
		}
		else return 0;
		break;
		
	case 'S':
		if (!strcmp("SKIN",script1))
		{
			pc_c->skin = pc_c->xskin = hstr2num(script2);
		}
		else if (!strcmp("SHOPKEEPER", script1))
		{
			scpMark m=pScp->Suspend();
			Commands->MakeShop(pc_c); 
			pScp->Resume(m);
		}
		else if (!strcmp("SELLITEM",script1))
		{
			if (!CT->ShopPack1C)
			{
				CT->ShopPack1C=pc_c->GetItemOnLayer(0x1C);
			}
			if (CT->ShopPack1C)
			{
				int sinum=str2num(script2);
				
				scpMark m=pScp->Suspend();
				CT->LastItem=Items->CreateScriptItem(sinum);
				pScp->Resume(m);
				
				if (CT->LastItem)
				{
					CT->LastItem->SetContSerial(CT->ShopPack1C->serial);
					CT->LastItem->value=CT->LastItem->value/2;
					CT->LastItem->SetRandPosInCont(CT->ShopPack1C);
					if (CT->LastItem->name2 && (strcmp(CT->LastItem->name2,"#")))
						strcpy(CT->LastItem->name,CT->LastItem->name2); // Item identified! -- by Magius(CHE)					}
				}
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			} else
			{
				LogWarningVar("Bad NPC Script %d with problem no shoppack3 for item.", npcNum);
			}
		}
		else if (!strcmp("SHOPITEM",script1))
		{
			if (!CT->ShopPack1B)
			{
				CT->ShopPack1B=pc_c->GetItemOnLayer(0x1B);
			}
			if (CT->ShopPack1B)
			{
				int sinum=str2num(script2);
				
				scpMark m=pScp->Suspend();
				CT->LastItem=Items->CreateScriptItem(sinum);
				pScp->Resume(m);
				
				if (CT->LastItem)
				{
					CT->LastItem->SetContSerial(CT->ShopPack1B->serial);
					CT->LastItem->SetRandPosInCont(CT->ShopPack1B);
					if (CT->LastItem->name2 && (strcmp(CT->LastItem->name2,"#"))) strcpy(CT->LastItem->name,CT->LastItem->name2); // Item identified! -- by Magius(CHE)					}
				}
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			} else
			{
				LogWarningVar("Bad NPC Script %d with problem no shoppack2 for item.", npcNum);
			}
		}
		else if (!pScp->CmpTok1("SHOPLIST")) 
		{
			scpMark pos=pScp->Suspend();
			LoadShopList(pc_c,npcNum,str2num(script2));
			pScp->Resume(pos);
		}
		else if (!strcmp("SPATTACK",script1)) pc_c->spattack=str2num(script2);
		else if (!strcmp("SPEECH",script1)) pc_c->speech=str2num(script2);
		else if (!strcmp("SPLIT",script1)) pc_c->split=str2num(script2);
		else if (!strcmp("STR",script1) || !strcmp("STRENGTH",script1))
		{
			pc_c->setStr(getstatskillvalue(script2));
			pc_c->fullHp();
		}
		else if (!strcmp("SPLITCHANCE",script1))		pc_c->splitchnc=str2num(script2);
		else if (!strcmp("SAYCOLOR",script1)) 			pc_c->saycolor = static_cast<UI16>(hstr2num(script2));
		else if (!strcmp("SPADELAY",script1))			pc_c->spadelay=str2num(script2);
		else if (!strcmp("SKINLIST",script1))
		{
			scpMark m=pScp->Suspend();
			pc_c->xskin = pc_c->skin = addrandomcolor(str2num(script2));
			pScp->Resume(m);
			strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
		}
		else if (!strcmp("SKILL", script1))
		{
			gettokennum(script2, 0);
			int sk=str2num(gettokenstr);
			gettokennum(script2, 1);
			pc_c->setRealSkill(sk,str2num(gettokenstr));
		}
		
		else if (!strcmp("STABLEMASTER",script1)) pc_c->npc_type=1;
		else if (!strcmp("SURNAME",script1)) 
		{
			strcat(pc_c->name, " ");
			strcat(pc_c->name, script2);
		}
		else if (!strcmp("SURNAMELIST", script1))
		{
			scpMark m=pScp->Suspend();
			setrandomsurname(pc_c,script2);
			pScp->Resume(m);
			strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
		}
		else if (!strcmp("SUMMONED", script1))		pc_c->summoned=true; 
		else return 0;
		break;
	
	case 'T':
		if (!strcmp("TOTAME", script1))			pc_c->totame=str2num(script2);
		else if (!strcmp("TRIGGER",script1))	pc_c->trigger=str2num(script2);
		else if (!strcmp("TRIGWORD",script1))	strcpy(pc_c->trigword,script2);
		else return 0;
		break;
		
	case 'V':
		if (!strcmp("VALUE",script1)) if (CT->LastItem) CT->LastItem->value=str2num(script2);
		else return 0;
		break;
		
	default:
		return 0;
	}
	return 1;	// we have handled it :)
}

///////////////////////////////////////////////////////////////////
//// currently only a helper method for tempdupeNpc.
///  overwrites all data members from source with values from source (except serial)
///  use with extreme caution
///  target has to be already existing ! (source too of course)
///////////////////////////////////////////////////////////////////

bool cCharStuff::copyNpcRawData(const cChar* const source,cChar* target)
{
	if (source==NULL || target==NULL) return false;

	int  ser   = target->serial; // don't copy serial	
	int index  = target->GetIndex(); // index copying also fatal

	*target = *source;

	// using default c'tor.
	// shallow copy of all member variables
	// we have no pointers (precallocated arrays get copied too), so no prob and exactly what we need.

	target->SetSerialOnly(ser);
	target->SetIndex(index);

	return true;
}

// helper helper
bool cCharStuff::copyBps(cItem* pi_bpSource,cItem* pi_bpTarget)
{
	if (pi_bpSource==NULL || pi_bpTarget==NULL) return false;

	int ci=0;
	P_ITEM pi;
	int loopexit=0;

	while ( ((pi=pi_bpSource->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{		
		// create new item
		P_ITEM pi_cpy = Items->MakeBaseItem();
		if (pi_cpy==NULL) continue;

		// now copy it
		Items->copyItemRawData(pi, pi_cpy);

		pi_cpy->contserial=-1; // essential, container serial has to be set to NEW packpack not old

        pi_bpTarget->AddItem(pi_cpy, -1,-1, false); // add it to real(new) container, don't send (yet)

		if (pi->isType(ITY_Container) || pi->isType(ITY_RuneBook))
		{
		   copyBps(pi, pi_cpy);
		   continue;
		}		
	}

	return true;
}

// helper 
bool cCharStuff::EmptyandCopyBp(cItem* pi_bpSource,cItem* pi_bpTarget)
{
	if (pi_bpSource==NULL || pi_bpTarget==NULL) return false;

	// delete
	 int ci=0,loopexit=0; 
	 P_ITEM pi;
     while ( ((pi=pi_bpTarget->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	 {		  
	    Items->DeleItem(pi);			  						
	 }

	 // & copy

	 this->copyBps(pi_bpSource, pi_bpTarget);

	 return true;
}

//////////////////////////////////////////////////////////////
// copy cloths+backpack+items in hand from source to target npc
// attention: deletes them from target before adding source's
// bankbox, shoppacks etc is NOT duped.
//////////////////////////////////////////////////////////////

bool cCharStuff::copyNpcClothing(const cChar* const source,cChar* target)
{

	P_ITEM pi_bpTarget = target->getBackpack();
	P_ITEM pi_bpSource = source->getBackpack();  // source cant be const, because getBackpack possibley modifies packitem value
	
	if (pi_bpTarget!=NULL)
	{
		////////////////////////////////////////////////////////////////////////////////////
		// target and source have BP -> delete target's BP-contents and add BP items of source /
		////////////////////////////////////////////////////////////////////////////////////
		if (pi_bpSource!=NULL)
		{		   			
		  // delete target BP and copy soure BP items to targets BP
          this->EmptyandCopyBp(pi_bpSource, pi_bpTarget);
		 
		} else // target has BP but source not -> delete targets's BP
		{
			Items->DeleItem(pi_bpTarget);
		}

	} else
	{	   
		if (pi_bpSource!=NULL) // target has NO BP, but source has -> add a BP to target
		{
			const P_ITEM Pack=target->addBackpack();
			if (!Pack) return false;
			this->EmptyandCopyBp(pi_bpSource, Pack);
		}
		else // target and source have no BP -> do nothing
		{
			;
		}
	}
	
	/// remove current cloths from target
	P_ITEM pi, pi_cpy;	
	int ci=0,loopexit=0; 	     
	while ( ((pi=target->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		switch(pi->layer)
		{
		case 0x1:  case 0x2:  case 0x3:  case 0x4:
		case 0x5:  case 0x6:  case 0x7:  case 0x8:
		case 0xa:  case 0xb:  case 0xc:  case 0xd:
		case 0xe:  case 0x10: case 0x11: case 0x12:
		case 0x13: case 0x14: case 0x16: case 0x17:
		case 0x18:
			Items->DeleItem(pi);
			break;
			
		default:
			break;
		}
	}

	/// now copy cloths from source to target

	ci=0,loopexit=0; 	     
	while ( ((pi=source->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		switch(pi->layer)
		{
		case 0x1:  case 0x2:  case 0x3:  case 0x4:
		case 0x5:  case 0x6:  case 0x7:  case 0x8:
		case 0xa:  case 0xb:  case 0xc:  case 0xd:
		case 0xe:  case 0x10: case 0x11: case 0x12:
		case 0x13: case 0x14: case 0x16: case 0x17:
		case 0x18:
			
			// create new item
			pi_cpy = Items->MakeBaseItem();
			if (!pi_cpy) continue;

			Items->copyItemRawData(pi, pi_cpy); // actual copying
			
			pi_cpy->contserial=-1; // critical, purpose: source item doesn't get removed when added to new target bp
			pi_cpy->spawnregion=0;
			pi_cpy->spawnserial=-1;
			
			// add it to new (target's) body
			pi_cpy->SetContSerial(target->serial);
			
			break;	
			
		default:
			break;
		} // end switch
	}
	
	return true;
}

bool cCharStuff::TempDupeNpc(P_CHAR toDupe, P_CHAR Dupee, int modifier)
{

	// check for validy or already under effect. 
	// also dont allow to dupe temp-storage npcs
	// and target=source not ok

	if (toDupe==NULL || Dupee==NULL) return false;
	if (toDupe->doppelgaenger_serial!=0) return false;
	if (Dupee->doppelgaenger_serial!=0) return false;
	if (toDupe->serial==Dupee->serial) return false;
	
	// first let's create the npc that holds the copy of duppe untill effect has worn off
	P_CHAR pc_dummy = Npcs->MakeBaseChar();
	if (!pc_dummy) return false;

	/// now let's copy the dupee to newly created dummy npc (complete copy)
	this->copyNpcRawData(Dupee, pc_dummy);
	this->copyNpcClothing(Dupee, pc_dummy); // also copy cloths+bp, adds a BP

	// dummy ncps special settings
	pc_dummy->doppelgaenger_serial=-1; // doppelgaengerserial -1 indicates a temporal storage npc
	pc_dummy->makeInvulnerable();      // they should be neither killable nor visible. without them no later restoring possible

	/*pc_dummy->account=-1;
	pc_dummy->npc=1;*/
	
	pc_dummy->hide();
	pc_dummy->MoveToOneOff(Dupee->pos); // even if position unaltered we have to call moveto to add it to regions	

	Dupee->doppelgaenger_serial=pc_dummy->serial; // remember serial of temp storage npc !

	
	// now copy dupe target to dupee
	// actualy it's *important* NOT to copy all values here
	// only stats, skills, body, skin, name and title

	strncpy(Dupee->name, toDupe->name, 50);
	strncpy(Dupee->title, toDupe->title,50);

	Dupee->setId(toDupe->id());
	Dupee->setXid(toDupe->id());

	Dupee->emotecolor=toDupe->emotecolor;
	Dupee->saycolor=toDupe->saycolor;

	Dupee->skin=Dupee->xskin=toDupe->skin;

	Dupee->setHp(toDupe->Hp());
	Dupee->setStr(((toDupe->realStr())*modifier));

	Dupee->setDex((toDupe->realDex())*modifier);
	Dupee->setStm(toDupe->Stm()); // stamina

	Dupee->setInt((toDupe->realInt())*modifier);
	Dupee->setMana(toDupe->Mana());
	
	//Dupee->fullHp(); // always full HP because changing to near dead creatures might be bad, move to actual AI code	

	int i;
	int sk=SkillManager->getAllSkillsValue();
	for (i=0;i<sk;i++)
	{
		Dupee->setRealSkill(i,toDupe->getRealSkill(i)*modifier);
		Dupee->skill[i]=(toDupe->skill[i])*modifier;
	}
	for (i = 0; i < sk; i++) 
		Dupee->lockSkill[i]=toDupe->lockSkill[i];
     
	// plus all items dupe target wears+bp

    this->copyNpcClothing(toDupe, Dupee);

	// now show all changed npcs

	updatechar(pc_dummy);
	updatechar(Dupee);

	return true;
}

bool cCharStuff::TempDupeNpcRevert(P_CHAR Dupee)
{
	if (Dupee==NULL) return false;

	// first get temporary stprage npc
	int doppel_serial = Dupee->doppelgaenger_serial;
	P_CHAR pc_dummy;
	pc_dummy = FindCharBySerial(doppel_serial);
	if (pc_dummy==NULL)  return false;

	// revert changes to BP+body
	this->copyNpcRawData(pc_dummy, Dupee);	
	this->copyNpcClothing(pc_dummy, Dupee);

	// now set special doppelgaenger values back
	Dupee->doppelgaenger_serial=0;
	Dupee->makeVulnerable();
	Dupee->unhide();
	Dupee->MoveTo(Dupee->pos); // dont move to dummy npc pos

	// doppelgaeng ercan be deleted

	this->DeleteChar(pc_dummy);

	updatechar(Dupee);

	return true;
}

P_CHAR cCharStuff::CloneNpc(const cChar* const source, bool setclonetag)
{
	if (source==NULL) return NULL;
	if (!source->npc) return NULL; // player cloning -> no,no !!!
	
	// create new NPC
	P_CHAR clone = Npcs->MakeBaseChar();
	if (!clone) return NULL;

	// copy RAW NPC data
	this->copyNpcRawData(source, clone);	

	///// note: there are probalby still a couple of problematic references (to items, other npcs etc) !!!!

	///////////////// add BP, cloths and shoppacks ///////////////////////

	this->copyNpcClothing( source, clone); // copy cloths+bp, adds a BP
    this->copyShopPacks(source, clone);

	if (setclonetag) clone->isclone=true; else clone->isclone=false; // note: we ignore the clonetag of source by design

	return clone;
}

// pre: target has NO shoppacks and source all set
bool cCharStuff::copyShopPacks(const cChar* const source, P_CHAR Target)
{
	if (!source->shop) return true; // source npc no shoopkeeper, obviously we shouldn't continue ;)
	
	P_ITEM p1A=NULL, p1B=NULL, p1C=NULL;
	
	///////// first of all let's create the shop packs ///////////
	
	p1A = Target->GetItemOnLayer(0x1A);
	if (p1A==NULL)
	{
		p1A = Items->SpawnItem(Target, 1,"#", 0, 0x2AF8, 0, 0);	 
		if (p1A==NULL) return false;
		p1A->setType(ITY_Container);
		p1A->newbieOn();      	
		Target->Wear(p1A,0x1A);
	}
	else
	{
		LogWarning("copyshopbacks: p1a already set");
		return false;
	}

	p1B = Target->GetItemOnLayer(0x1B);
	if (p1B==NULL)
	{
		p1B = Items->SpawnItem(Target, 1,"#", 0, 0x2AF8, 0, 0);	 
		if (p1B==NULL) return false;
		p1B->setType(ITY_Container);
		p1B->newbieOn();      	
		Target->Wear(p1B,0x1B);
	}
	else
	{
		LogWarning("copyshoppacks: p1b already set");
		return false;
	}

	p1C = Target->GetItemOnLayer(0x1C);
	if (p1C==NULL)
	{
		p1C = Items->SpawnItem(Target, 1,"#", 0, 0x2AF8, 0, 0);
		if (p1C==NULL) return false;
		p1C->setType(ITY_Container);
		p1C->newbieOn();
		Target->Wear(p1C,0x1C);
	}
	else
	{
		LogWarning("copyshoppacks: p1c already set");
		return false;
	}
	
	//////////////// now copy 3 source backs into brand new packs //////////

	P_ITEM p1A_src=NULL, p1B_src=NULL, p1C_src=NULL;

	p1A_src = source->GetItemOnLayer(0x1A);
	p1B_src = source->GetItemOnLayer(0x1B);
	p1C_src = source->GetItemOnLayer(0x1C);

	if (p1A_src==NULL || p1B_src==NULL || p1C_src==NULL) return false;

	bool x = this->EmptyandCopyBp(p1A_src, p1A);
	if (!x) return false;

    x = this->EmptyandCopyBp(p1B_src, p1B);
	if (!x) return false;

	x = this->EmptyandCopyBp(p1C_src, p1C);
	if (!x) return false;

	return true;
}



void cCharStuff::Split(P_CHAR pc) // For NPCs That Split during combat
{
	if (!pc) return;

	P_CHAR Clone = Npcs->MakeBaseChar();
	if (!Clone) return;
	int serial=Clone->serial;
	memcpy(Clone,pc,sizeof(cChar));
	Clone->SetSerialOnly(serial);
	Clone->ResetFollowTarget();
	Clone->MoveToOneOff(pc->pos);
	Clone->kills=0;
	Clone->fullHp();
	Clone->fullStm();
	Clone->fullMana();

	if (rand()%35==5) Clone->split=1; else Clone->split=0;	// chance to split again	
	updatechar(Clone);
}

//s: char#
void cCharStuff::SpawnGuard(P_CHAR Offender, P_CHAR Caller, const cCoord& atPos)
{
	if (!Caller->inGuardedArea())
		return;
	
	if (Offender->dead || Caller->dead)
		return; // AntiChrist
	
	if (SrvParms->guardsactive && !Offender->isInvul() && !Offender->isDummy())
	{
        int t = region[Caller->region].guardnum[(rand()%10)];
		P_CHAR Guard = Npcs->AddNPC(Offender->calcSocket(), t, atPos);
		if (!Guard) return;
		Guard->setAi(4);		// teleporting CITY GUARD
		Guard->setAttackFirst();
		Guard->setAttacker(Offender);
		Guard->SetTarget(Offender);
		Guard->npcWander = 2;  // set wander mode Tauriel
		npcToggleCombat(Guard);
		Guard->npcmovetime =(unsigned int)(getNormalizedTime() +(double)(NPCSPEED*MY_CLOCKS_PER_SEC));
		Guard->summontimer =(getNormalizedTime() +(MY_CLOCKS_PER_SEC*25));    
		
		soundeffect2(Guard, 0x01FE);  // Tauriel 1-9-99 changed to stop crashing used to call soundeffect (expeted socket)
		staticeffect(Guard, 0x372A, 0x09, 0x06);
		
		updatechar(Guard);
		switch (RandomNum(0,1))
		{
		case 0:		npctalkall(Guard, "Thou shalt regret thine actions, swine!", 1);	break;
		case 1:		npctalkall(Guard, "Death to all Evil!", 1);							break;
		}
	}
}

/////////////
// name:	LoadShopList
// purpose:	Load the SECTION SHOPLIST for shopkeepers (called by the token SHOPLIST)
// history:	by opik, 21.12.02
//			

void cCharStuff::LoadShopList(P_CHAR pc,int npc_num,int listnum)
{
	int iLayer=0,shoplist_error=0;
	P_ITEM ShopPack,Item;
	Script *Scp=i_scripts[npc_script];
	char temp[300];
	sprintf(temp,"SHOPLIST %i",listnum);
	Scp=Scp->Select(temp,custom_npc_script);
	if (!Scp) return;
	int loopexit=0;
	Scp->NextLineSplitted();
	while(!Scp->EndSect() && (++loopexit < MAXLOOPS))
	{ 
		if (!Scp->CmpTok1("SELLITEM"))
			iLayer=0x1C;	
		else if (!Scp->CmpTok1("SHOPITEM"))
		{
			gettokennum(script2,1);
			if (gettokenstr[0]=='R')
				iLayer=0x1A;
			else
				iLayer=0x1B;
			gettokennum(script2,0);
			strcpy(script2,gettokenstr);
		}
		ShopPack=pc->GetItemOnLayer(iLayer);
		if (ShopPack)
		{
			int storeval=str2num(script2);
			scpMark m=Scp->Suspend();
			Item=Items->CreateScriptItem(storeval);
			Scp->Resume(m);
			if (Item)
			{
				Item->SetContSerial(ShopPack->serial);
				if (iLayer==0x1C)
					Item->value=Item->value/2;
				Item->SetRandPosInCont(ShopPack);
				if (Item->name2 && strcmp(Item->name2,"#")) 
					strcpy(Item->name,Item->name2);
			}
			ShopPack=NULL;
		}
		else
		{	
			shoplist_error++;//Count wrong tokens and tell if npc has not shoppack	
		}
		Scp->NextLineSplitted();
	}
	Scp->Close();
	strcpy(script1," ");//removes the '}' of the string == bad implementation of the while that reads the script :((
	if (shoplist_error)
	{
		char error[200];
		sprintf(error,"Warning: The NPC %i does not has the token SHOPKEEPER or the shoplist is empty or the tokens in shoplist are wrong (Count of wrong: %i).\n",npc_num,shoplist_error);
		LogWarning(error);	
	}
}

class cRace
{
public:
	int num;
	int strmax;
	int dexmax;
	int intmax;
	unsigned short skillmax[ALLSKILLSMAX];
	char name[50];
	void init(int number)
	{
		num = number;
		strmax = dexmax = intmax = 100;
		name[0] = 0;
		for (int i=0;i<ALLSKILLSMAX;i++) skillmax[i]=1000;
	}
};
static cRace Races[MAXRACES];
/////////////
// name:	LoadRaces
// purpose:	Load races.scp into the array
// history:	by Duke, 5.3.2004
//			
void cCharStuff::LoadRaces()
{
	int i;
	for (i=0;i<MAXRACES;i++)
	{
		cRace* Race = &Races[i];
		Race->init(i);
		if (i==0) continue;	// don't allow to overwrite the default
		Script *Scp=findSection(races_scp,"RACE",i);
		if (!Scp) continue;

		int loopexit=0;	
		while (Scp->NextLineSplitted() && (++loopexit < 100))	// no more than 100 lines in one section
		{			
			if (Scp->getKeyVal("STR",	&(Race->strmax)))	continue;
			if (Scp->getKeyVal("DEX",	&(Race->dexmax)))	continue;
			if (Scp->getKeyVal("INT",	&(Race->intmax)))	continue;
			if (Npcs->ApplySkillTags(Race->skillmax))		continue;
			if (Scp->getKeyVal("NAME",	 (Race->name)))		continue;
		}
		Scp->Close();	
	}
}

void cChar::chgRealSkill(int sk, int val)
{
	baseskill[sk] += val;
	if (baseskill[sk] > this->Race->skillmax[sk])
		baseskill[sk] = this->Race->skillmax[sk];
}

int cChar::getRace()		{	return this->Race->num; }
void cChar::setRace(int r)	{	if (r<0 || r>=MAXRACES) r=0; this->Race = &Races[r]; }
int cChar::getRaceName(char* rname, int maxlen) // rname must provide for maxlen bytes. maxlen includes the terminating 0 !
{
	if (!rname) return 0;
	int len = strlen(this->Race->name);
	if (len >= maxlen) return 0;
	strcpy(rname,this->Race->name);
	return len;
}

void cChar::Init(bool mkser)
{
	if (mkser)		// give it a NEW serial #
		this->SetSerial(Npcs->GetNextFreeSerial());
	else
		this->SetSerialOnly(-1);

	this->scriptnum=-1;

	this->qsf=-1;
	this->multis=-1;       //Multi serial
	this->free = false;
	strcpy(this->name,"Mr. noname");
	strcpy(this->orgname,"Mr. noname");
	this->title[0]=0x00;

	this->antispamtimer=0; //LB - anti spam
	this->unicode = false; // This is set to 1 if the player uses unicode speech, 0 if not
	this->account=-1;

	this->pos.x=100;
	this->pos.y=100;
	this->pos.z=this->dispz=0;
	this->pos.map=0;

	this->tamedamount=0;

//	this->race=0;           // -Fraz- Race AddOn
	this->Race = &Races[0];
	this->dir=0;            //&0F=Direction
	this->setId(0x0190);	// Character body type
	this->setXid(0x0190);	// Character body type
	this->skin = this->xskin = 0x0000; // Skin color
	this->keynumb=-1;       // for renaming keys 
	this->setPriv(0);	    // 1:GM clearance, 2:Broadcast, 4:Invulnerable, 8: single click serial numbers
	                        // 10: Don't show skill titles, 20: GM Pagable, 40: Can snoop others packs, 80: Counselor clearance
	this->SetPriv2(0);		// 1:Allmove, 2: Frozen, 4: View houses as icons, 8: permanently hidden
	                        // 10: no need mana, 20: dispellable, 40: permanent magic reflect, 80: no need reagents
	this->SetPriv4(0);

	unsigned int i;
	for (i=0;i<7;i++)
		this->priv3[i]=0;    // needed for Lord bianrys meta-gm stuff
	this->fonttype=3;        // Speech font to use
	this->saycolor=0x1700;   // Color for say messages
	this->emotecolor=0x0023; // Color for emote messages
	this->setStr(50);	     // Strength
	this->setDecStr(0);      // Reserved for calculation
	this->setTmpStr(0);
	this->setStrLimit(0);	 // disable individual limit by default
	this->setDex(50);	     // Dexterity
	this->setDecDex(0);      // Reserved for calculation
	this->setTmpDex(0);
	this->setDexLimit(0);	 // disable individual limit by default
	this->setInt(50);	     // Intelligence
	this->setDecInt(0);      // Reserved for calculation
	this->setTmpInt(0);
	this->setIntLimit(0);	 // disable individual limit by default
	this->setHp(50);	     // Hitpoints
	this->setStm(50);	     // Stamina
	this->setMana(50);	     // Mana
	this->hidamage=0;        //NPC Damage
	this->lodamage=0;        //NPC Damage

	this->isclone=false;


	this->creationday = getPlatformDay();

	for (i=0;i<ALLSKILLSMAX;i++) // note: all skills, even if in non aos mode intentional, to avoid losing 3 new aos skills when switch back and forth aos mode
	{
		this->setRealSkill(i,0);
		this->skill[i]=0;
		this->lockSkill[i]=0;
	}


	this->npc=0;
	this->shop=0;             //1=npc shopkeeper
	this->cell=0;             // Reserved for jailing players 
	                          // bugfix, LB 0= player not in jail !, not -1
	
	this->jailtimer.reset();  //blackwinds jail system

	this->ownserial=-1;       // If Char is an NPC, this sets its owner
	this->tamed = false;      // True if NPC is tamed
	this->robe = -1;          // Serial number of generated death robe (If char is a ghost)
	this->karma=0;
	this->fame=0;
	this->kills=0;            //PvP Kills
	this->deaths=0;
	this->dead = false;       // Is character dead
	this->fixedlight=255;     // Fixed lighting level (For chars in dungeons, where they dont see the night)
	                          // changed to -1, LB, bugfix
	this->speech=0;           // For NPCs: Number of the assigned speech block
	this->weight=0;           // Total weight
	this->WeightAtCursor=0;   // weight currently dragged
	this->att=0;              // Intrinsic attack (For monsters that cant carry weapons)
	this->def=0;              // Intrinsic defense
	this->war=0;              // War Mode
	this->ResetTarget();      // Current combat target
	this->timeout=0;          // Combat timeout (For hitting)
	this->timeout2=0;
	this->regen=0;
	this->regen2=0;
	this->regen3=0;           //Regeneration times for mana, stamin, and str
	this->setInput(0,NULL);
	this->setAttacker(NULL);  // Character who attacked this character
	this->npcmovetime=0;      // Next time npc will walk
	this->npcWander=0;        // NPC Wander Mode
	this->oldnpcWander=0;     // Used for fleeing npcs
	this->ResetFollowTarget();// NPC Follow Target
	this->fx1=-1;             //NPC Wander Point 1 x
	this->fx2=-1;             //NPC Wander Point 2 x
	this->fy1=-1;             //NPC Wander Point 1 y
	this->fy2=-1;             //NPC Wander Point 2 y
	this->fz1=0;              //NPC Wander Point 1 z
	this->spawnserial=-1;     // Spawned by
	this->hidden=0;           // 0 = not hidden, 1 = hidden, 2 = invisible spell
	this->invistimeout=0;
	this->resetAttackFirst(); // 0 = defending, 1 = attacked first
	this->onhorse=false;      // On a horse?
	this->setHunger(6);       // Level of hungerness, 6 = full, 0 = "empty"
	this->hungertime=0;       // Timer used for hunger, one point is dropped every 20 min
	this->dclickedserial=-1;	// serial of dclicked char or item
	this->target1serial=-1;		// serial of targeted char or item
	this->setAi(0);		      // NPC ai
	this->callnum=-1;	      // GM Paging
	this->playercallnum=-1;   //GM Paging
	this->pagegm=0;           //GM Paging
	this->region=255;
	this->skilldelay.reset();
	this->objectdelay.reset();
///	this->combathitmessage=0;
	this->making=-1;          // skill number of skill using to make item, 0 if not making anything.
	this->blocked=0;
	this->dir2=0;
	this->spiritspeaktimer.reset(); // Timer used for duration of spirit speak
	this->spattack=0;
	this->spadelay=0;
	this->spatimer=0;
	this->totame=0;             // Skill level required for taming
	this->summoned=false;		// Tell the difference between summoned and non-summoned npcs
	this->summontimer=0;		// Timer for summoned creatures.
	this->trackingtimer.reset();	// Timer used for the duration of tracking
	this->trackingtarget=-1;		// Tracking target serial
	for (i=0;i<MAXTRACKINGTARGETS;i++)
		this->trackingtargets[i]=-1;
	this->fishingtimer=0;       // Timer used to delay the catching of fish
	this->lastlightvalue=97;

	this->advobj=0;             //Has used advance gate?
	
	this->SetPoison(0);			// used for poison skill 
	this->ResetPoisoned();		// type of poison
	this->poisondamagetime.reset();	// poison damage timer
	this->poisontxt.reset();		// poision text timer
	this->poisonwearofftime.reset();// LB, makes poision wear off ...
	
	this->fleeat=SrvParms->npc_base_fleeat;
	this->reattackat=SrvParms->npc_base_reattackat;
	this->trigger=0;            //Trigger number that character activates
	this->trigword[0]='\x00';   //Word that character triggers on.
	this->disabled=0;           //Character is disabled for n cicles, cant trigger.
	this->disabledmsg[0] = 0;   //Character disabled message. -- by Magius(CHE) 
	this->split=0;
	this->splitchnc=0;
	this->targtrig=0;           //Stores the number of the trigger the character for targeting
	this->ra=0;                 // Reactive Armor spell
	this->trainer=0;            // Serial of the NPC training the char, -1 if none.
	this->trainingplayerin=0;   // Index in skillname of the skill the NPC is training the player in
	this->cantrain=true;

	// Begin of Guild Related Character information (DasRaetsel)
	this->guildtoggle=0;		// Toggle for Guildtitle								(DasRaetsel)
	this->guildtitle[0]='\x00';	// Title Guildmaster granted player						(DasRaetsel)
	this->guildfealty=-1;		// Serial of player you are loyal to (default=yourself)	(DasRaetsel)
	this->guildnumber=0;		// Number of guild player is in (0=no guild)			(DasRaetsel)
	this->GuildTraitor=false; 
	this->flag=0x02;            //1=red 2=grey 4=Blue 8=green 10=Orange // grey as default - AntiChrist
	// End of Guild Related Character information

	this->murderrate=0;      //#of ticks until one murder decays //REPSYS 
	this->crimflag=-1;       //Time when No longer criminal -1=Not Criminal
//	this->casting=0;         // 0/1 is the cast casting a spell?
	this->spelltime=0;       //Time when they are done casting....
	this->spell=0;           //current spell they are casting....
	this->spellaction=0;     //Action of the current spell....
	this->nextact=0;         //time to next spell action....
	
	this->squelched=0;       // zippy  - squelching
	this->mutetime=0;        //Time till they are UN-Squelched.
	this->med=0;             // 0=not meditating, 1=meditating //Morrolan - Meditation 
	this->stealth=-1;        //AntiChrist - stealth ( steps already done, -1=not using )
	this->running=0;         //AntiChrist - Stamina Loose while running
	this->logout=0;          //Time till logout for this char -1 means in the world or already logged out //Instalog
	this->ResetSwingTarget();//Target they are going to hit after they swing
	this->holdg=0;           // Gold a player vendor is holding for Owner
	this->fly_steps=0;       //LB -> used for flyging creatures
	this->guarded=false;     // True if CHAR is guarded by some NPC
	this->smoketimer=0;
	this->smokedisplaytimer=0;
	this->carve=-1;          // AntiChrist - for new carving system
	this->antiguardstimer=0; // AntiChrist - for "GUARDS" call-spawn
	this->polymorph=false;   //polymorph - AntiChrist
	this->incognito=false;   //incognito - AntiChrist
    this->postType = LOCALPOST;
    this->questDestRegion = 0;
    this->questOrigRegion= 0;
    this->questBountyReward= 0;
    this->questBountyPostSerial = 0;
    this->murdererSer = 0;
    this->spawnregion = 0;
    this->npc_type = 0;
    this->stablemaster_serial = 0;
	this->timeused_last = getNormalizedTime();
	this->time_unused = 0;
	this->doppelgaenger_serial = 0;
	this->SetViewingDepth(SrvParms->defaultgmview);

	this->spelldelay = 0;
	this->currentspelltype = 0;
	this->currentspell = NULL;
	this->tithingpoints = 0;
	this->preTarg = 0;

	this->SetFood(SrvParms->defaultfood);
	this->craftAI = 0;
	this->nextCraft.reset();
}

///////////////////////
// Name:	cChar::day
// history:	by punt, 15.4.2001
// Purpose:	return the day this was created
//
unsigned long cChar::day()
{
	return creationday ;
}
///////////////////////
// Name:	cChar::day(unsigned long)
// history:	by punt, 15.4.2001
// Purpose:	set the day this was created
//
void cChar::day(unsigned long CreateDay)
{
	creationday = CreateDay ;
}

///////////////////////
// Name:	GetItemOnLayer
// history:	by Duke, 26.3.2001
// Purpose:	returns the item on the given layer, if any
//
P_ITEM cChar::GetItemOnLayer(unsigned char layer) const
{
	P_ITEM pi;
	int ci=0,loopexit=0;
	while ( ((pi=this->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->layer==layer)
			return pi;
	}
	return NULL;
}

///////////////////////
// Name:	removeItemsFromHands
// history:	by Duke, 26.2.2002
// Purpose:	removes items of the given id if in hand 1 or 2
//
void cChar::removeItemsFromHands(unsigned short id)
{
	P_ITEM pi;
	int ci=0,loopexit=0;
	while ( ((pi=this->SearchHands(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->id()==id)
			Items->DeleItem(pi);
	}
}

///////////////////////
// Name:	GetBankBox
// history:	by Duke, 26.3.2001, touched by Correa, 21.04.2001
// Purpose:	Return the bank box. If banktype == 1, it will return the Item's bank box, else, 
//          gold bankbox is returned. 
//
P_ITEM cChar::GetBankBox( short banktype )			
{
	P_ITEM pi;
	int ci=0,loopexit=0;
	while ( ((pi=this->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->isType(ITY_Container) && pi->morex == 1)
			if ( banktype == 1 && pi->morey == 123 && SrvParms->usespecialbank) 
				return pi;
			else if ( banktype != 1 || !SrvParms->usespecialbank)
				return pi;
	}
	// If we reach this point, bankbox wasn't found == wasn't created yet.

	sprintf(temp, "%s's bank box.", name);
	pi = Items->SpawnItem(this,1,temp,0,0x09AB,0,0);
	if (pi == NULL) 
		return NULL;
	pi->SetOwnSerial(this->serial);
	pi->morex=1;
	if (SrvParms->usespecialbank && banktype == 1)//AntiChrist - Special Bank
		pi->morey=123;//gold only bank
	pi->setType(ITY_Container);
	this->Wear(pi,0x1d);
	UOXSOCKET s = this->calcSocket();
	if (s != -1)
		wearIt(s, pi);

	return pi;
}


///////////////////////
// Name:	disturbMed
// history:	by Duke, 17.3.2001
// Purpose:	stops meditation if necessary. Displays message if a socket is passed
//
void cChar::disturbMed(UOXSOCKET s)
{
	if (this->med) //Meditation
	{
		this->med=0;
		if (s != -1)
			sysmessage(s, "You break your concentration.");
	}
}

///////////////////////
// Name:	unhide
// history:	by Duke, 17.3.2001
// Purpose:	reveals the char if he was hidden
//
void cChar::unhide()
{
	if (this->isHidden() && !this->IsPermaHidden())
	{
		this->stealth=-1;
		this->hidden=0;
		updatechar(this);	// LB, necessary for client 1.26.2
		if (this->isGM())
			tempeffect(this, TEF_UnHideGM, 3, 0, 0); 
	}
}

///////////////////////
// Name:	setNextMoveTime
// history:	by Duke, 20.3.2001
// Purpose:	sets the move timer. tamediv can shorten the time for tamed npcs
//
void cChar::setNextMoveTime(short tamediv)
{
	if (this->tamed && tamediv != 0)
		this->npcmovetime=(unsigned int)((uiCurrentTime+double(NPCSPEED*MY_CLOCKS_PER_SEC/tamediv)));
	else
		this->npcmovetime=(unsigned int)((uiCurrentTime+double(NPCSPEED*MY_CLOCKS_PER_SEC)));
}

///////////////////////
// Name:	fight
// history:	by Duke, 20.3.2001
// Purpose:	makes a character fight the other
//
void cChar::fight(P_CHAR other)
{
	this->SetTarget(other);
	this->unhide();
	this->disturbMed();	// Meditation
	this->setAttacker(other);
	if (this->npc)
	{
		if (!this->war)
			npcToggleCombat(this);
		this->setNextMoveTime();
	}
}

///////////////////////
// Name:	CountItems
// history:	by Duke, 26.3.2001
// Purpose:	searches the character recursively,
//			counting the items of the given ID and (if given) color
//
int cChar::CountItems(short ID, short col, short type)
{
	P_ITEM pi=this->getBackpack();
		
	int number = 0 ;
	if (pi != NULL)
		number = pi->CountItems(ID, col, type);
	return number ;
}

int cChar::CountBankGold()
{
	P_ITEM pi = GetBankBox(1); //we want gold bankbox.
	if (!pi) return 0;
	return pi->CountItems(0x0EED);
}

///////////////////////
// Name:	deleteItems
// history:	by Duke, 24.7.2002
// Purpose:	searches the character recursively,
//			deleting the items of the given ID and (if given) color up to the given amount.
//			Returns the remainder of amount if the request could not be fulfilled completely
//
int cChar::deleteItems(int amount, unsigned short ID, short col, short type)
{
	P_ITEM pi=this->getBackpack();
		
	int number = amount;
	if (pi != NULL)
		number = pi->DeleteAmount(amount, ID, col, type);
	return number;
}

int cChar::deleteBankGold(int amount)
{
	P_ITEM pi = GetBankBox(1); //we want gold bankbox.
	if (!pi) return amount;
	return pi->DeleteAmount(amount,0x0EED);
}

int cChar::deleteGold(int amount)
{
	return deleteItems(amount,0x0EED);
}

///////////////////////
// Name:	addHalo
// history:	by Duke, 13.5.2001
// Purpose:	assigns the halo of the given item to a character
//
void cChar::addHalo(PC_ITEM pi)
{
	setptr(&glowsp[this->serial%HASHMAX],pi);
}

void cChar::removeHalo(P_ITEM pi)
{
	removefromptr(&glowsp[this->serial%HASHMAX],pi);
}

void cChar::glowHalo(PC_ITEM pi)
{
	if (pi->glow>0)
	{
		P_ITEM pHalo=FindItemBySerial(pi->glow);
		if (!pHalo) return;
		
		pHalo->layer=pi->layer; // copy layer information of the glowing item to the invisible light emitting object
		
		if (pHalo->layer==0 && pi->isInWorld()) // unequipped -> light source coords = item coords
		{
			pHalo->dir=29;
			pHalo->pos = pi->pos;
		} else if (pHalo->layer==0 && !pi->isInWorld()) // euqipped -> light source coords = players coords
		{
			pHalo->pos=this->pos;
			pHalo->pos.Add(0,0,4);
			pHalo->dir=99; // gives no light in backpacks
		} else
		{
			pHalo->pos=this->pos;
			pHalo->pos.Add(0,0,4);
			pHalo->dir=29;
		}
		pHalo->refresh();
	}
}

///////////////////////
// Name:	getWeapon
// history:	moved here from combat.cpp by Duke, 20.5.2001
// Purpose:	finds the equipped weapon of a character
//
P_ITEM cChar::getWeapon()
{
	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=this->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if ((pi->layer==1 && !pi->isType(ITY_SpellBook))		// not a spellbook (hozonko)
			|| (pi->layer==2 && !IsShield(pi->id())) ) //Morrolan don't check for shields
		{
			return pi;
		}
	}
	return NULL;
}

///////////////////////
// Name:	getShield
// history:	by Duke, 20.5.2001
// Purpose:	finds the equipped shield of a character
//
P_ITEM cChar::getShield()
{
	P_ITEM pi=GetItemOnLayer(2);
	if (pi && IsShield(pi->id()) )
		return pi;
	else
		return NULL;
}

P_ITEM Packitem(P_CHAR pc) // Find packitem
{
	if (!pc) return NULL;

	return pc->GetItemOnLayer(0x15);
}

P_ITEM cChar::getBackpack()	const {return Packitem(const_cast<cChar*>(this));}
// note about the somewhat ugly const_cast:
// packitem changes the state of the char object, 
// hence makes the LOGICAL constant getbackpack technically NOT constant.
// basicly I'm stating via const_cast that getbackpack is constant though a member variable (packitem) is changed.
// the same could be achived via setting the packitem memmber variable mutable.
// though that's more elegant, there might be situations there packitem variable has to be const.


///////////////////////
// Name:	setters for various serials
// history:	by Duke, 2.6.2001
// Purpose:	encapsulates revoval/adding to the pointer arrays
//
void cChar::SetSerialOnly(long ser)
{
	this->serial=ser;
}

void cChar::SetSerial(long ser)
{
	SetSerialOnly(ser);
	if (ser > -1)
		setptr(&charsp[ser%HASHMAX], this);
}

void cChar::setOwnSerialOnly(long ownser)
{
	ownserial=ownser;
}

bool cChar::SetOwnSerial(long ownser)
{
	// note: negative values !=-1
    // a) crash, due to [-x] (-x%y<0)
	// b) are logically wrong

	if (ownserial<-1 || ownser<-1)
	{
		sprintf(temp, "Invalid Ownserial:%i %lu",ownserial, ownser);
		LogError(temp);
		return false;
	}

	if (ownserial!=-1)	// if it was set, remove the old one
		removefromptr(&cownsp[ownserial%HASHMAX], this);
	
	setOwnSerialOnly(ownser);
	if (ownser != serial && ownser != -1)
		tamed = true;
	else
		tamed = false;

	if (ownser!=-1)		// if there is an owner, add it
		setptr(&cownsp[ownserial%HASHMAX], this);

	return true;
}

bool cChar::SetSpawnSerial(long spawnser)
{
	if (spawnserial<-1 || spawnser<-1)
	{
	  sprintf(temp, "Invalid Spawnserial:%lu %i",spawnser, spawnserial);
	  LogError(temp);
	  return false;
	}

	if (spawnserial!=-1)	// if it was set, remove the old one
		removefromptr(&cspawnsp[spawnserial%HASHMAX], this);

	spawnserial=spawnser;

	if (spawnser!=-1)		// if there is a spawner, add it
		setptr(&cspawnsp[spawnserial%HASHMAX], this);

	return true;
}

bool cChar::SetMultiSerial(long mulser)
{
	if (mulser<-1 || this->serial<-1)
	{
		sprintf(temp,"Invalid Multiserial:%lu %i\n",mulser, this->serial);
		LogError(temp);
		return false;
	}

	if (multis!=-1)	// if it was set, remove the old one
		cmultisp.remove(multis, this->serial);

	this->multis = mulser;

	if (mulser!=-1)		// if there is multi, add it
		cmultisp.insert(multis, this->serial);

	return true;
}

void cChar::MoveTo(const cCoord& newpos)
{
	// Avoid crash if go to 0,0
	if (newpos.x<1 || newpos.y<1)
		LogError("invalid X/Y detected");

	mapRegions->Remove(this);
	pos = newpos;
	dispz=newpos.z;
	mapRegions->Add(this);
}

void cChar::MoveToOneOff(const cCoord& newpos)
{
	cCoord OffPos = newpos;
	OffPos.Add(1,1);
	this->MoveTo(OffPos);
}

void cChar::teleTo(const cCoord& newpos, bool boatcheck)
{
	cCoord old = this->pos;
	this->MoveTo(newpos);
	teleport(this, old);
	if (boatcheck)	// teleTo() is also used in Boat::Move(). So don't do this for normal boat *movement* (Duke)
	{
		if (this->multis != -1)
		{
			if (findBoatAt(this->pos)==NULL)
				this->SetMultiSerial(-1);
		}
	}
}

void cChar::travelTo(const cCoord& newpos, UOXSOCKET s)
{
	bool travel = (newpos.map == this->pos.map) ? false : true;	// do we change maps ??

	doGmMoveEff(s); 	// Adding the gmmove effects ..Aldur
	if (travel)
	{
		SndNewMap(s,newpos.map);
		this->teleTo(newpos); // note: two teleto's in case of map change absolutely necessary, no bug !!! (client oddity on map-switch)
	}
	this->teleTo(newpos);			
	doGmMoveEff(s);
}

int cChar::getSkillSum()
{
	int sum=0,a;
	int sk=SkillManager->getAllSkillsValue();
	for (a=0;a<sk;a++)
	{
		sum+=this->getRealSkill(a);
	}
	return sum;		// this *includes* the decimal digit ie. xxx.y
}

///////////////////////
// Name:	getTeachingDelta
// history:	by Duke, 27.7.2001
// Purpose:	calculates how much the given player can learn from this teacher
//
int cChar::getTeachingDelta(cChar* pPlayer, int skill, int sum)
{
	int delta = min(250,this->getRealSkill(skill)/2);		// half the trainers skill, but not more than 250
	delta -= pPlayer->getRealSkill(skill);					// calc difference
	if (delta <= 0)
		return 0;

	if ((unsigned)(sum+delta) >= SrvParms->skillcap * 10)			// would new skill value be above cap ?
		delta = (SrvParms->skillcap * 10) - sum;		// yes, so reduce it
	return delta;
}

////////////
// Name:	addItemBonus
// history:	by Duke, 16.10.2002
// Purpose:	adds boni given by an item
//
void cChar::addItemBonus(cItem* pi)
{
	this->chgStr(pi->st2);
	this->chgDex(pi->dx2);
	this->chgInt(pi->in2);
}

////////////
// Name:	removeItemBonus
// history:	by Duke, 19.8.2001
// Purpose:	removes boni given by an item
//
void cChar::removeItemBonus(cItem* pi)
{
	this->chgStr(-1 * pi->st2);
	this->chgDex(-1 * pi->dx2);
	this->chgInt(-1 * pi->in2);
}

////////////
// Name:	canPickUp
// history:	by Duke, 20.9.2001
// Purpose:	checks if the char can drag the item
//
bool cChar::canPickUp(cItem* pi)
{
	if (!pi)
	{
		LogCritical("bad parm");
		return false;
	}

	// even with allmove ON, we shouldn't move these because it starts the decay process
	if ( pi->corpse								// don't move corpses, crashes client
		||(pi->isOwnerMovable() && !this->Owns(pi))	// owner movable but not owner
		|| pi->isLockedDown() )					// locked down ?
		return false;

	if (this->CanMoveAll())	// allmove
		return true;

	const tileData *tile;
	tile = TileData->SeekTile(pi->id());
	if ( pi->isNotMovable() || (tile->weight == 255 && !pi->isAllwaysMovable()))
		return false;
	return true;
}

////////////
// Name:	inGuardedArea
// history:	by Duke, 13.1.2002
// Purpose:	checks if the char is in a guarded region
// Remark:	the recalculation of the region is necessary because it is not maintained properly :(
//			I think it is better to do this only when needed
//
bool cChar::inGuardedArea()
{
	this->region=calcRegionFromXY(this->pos);	// make sure it is set correctly
	return ::region[this->region].isGuarded();
}

////////////
// Name:	
// history:	by Duke, 13.3.2002
// Purpose:	encapsulation for hitpoints
//
int  cChar::Hp()	{return hp;}
void cChar::setHp(int value) {hp = value;}
void cChar::increaseHp(int value)
{
	hp += value;
	hp = min(hp, (int)this->effStr());
	updatestats(this, 0);
}

void cChar::reduceHp(int damage)
{
	hp -= damage;
	hp = max(hp, 0);
	updatestats(this, 0);
	if (hp <= 0)
		deathstuff(this);
}

void cChar::fullHp()
{
	hp = this->effStr();
}

////////////
// Name:	
// history:	by Duke, 7.6.2002
// Purpose:	encapsulation for stamina
//
int  cChar::Stm()	{return stm;}
void cChar::setStm(int value) {stm = value;}
void cChar::increaseStm(int value)
{
	stm += value;
	stm = min(stm, (int)this->effDex());
	updatestats(this, 2);
}
void cChar::reduceStm(int loss)
{
	stm -= loss;
	stm = max(stm, 0);
	updatestats(this, 2);
}
void cChar::changeStm(int value)
{
	if (value > 0)
		increaseStm(value);
	else
		reduceStm(-1 * value);
}
void cChar::fullStm()
{
	stm = this->effDex();
}

////////////
// Name:	
// history:	by Duke, 7.6.2002
// Purpose:	encapsulation for mana
//
int  cChar::Mana()	{return mn;}
void cChar::setMana(int value) {mn = value;}
void cChar::increaseMana(int value)
{
	mn += value;
	mn = min(mn, (int)this->effInt());
	updatestats(this, 2);
}
void cChar::reduceMana(int loss)
{
	mn -= loss;
	mn = max(mn, 0);
	updatestats(this, 2);
}
void cChar::changeMana(int value)
{
	if (value > 0)
		increaseMana(value);
	else
		reduceMana(-1 * value);
}
void cChar::fullMana()
{
	mn = this->effInt();
}

////////////
// Name:	endCasting
// history:	by Duke, 15.3.2002
// Purpose:	reset magic values after casting has ended
//
void cChar::endCasting()
{
//	this->casting=0;
	this->spelltime=0;
	this->Unfreeze();
	this->spelldelay = false;
}

////////////
// Name:	disturbCasting
// history:	by Duke, 15.3.2002
// Purpose:	handle interruption of casting
//
void cChar::disturbCasting(UOXSOCKET s)
{
	if (this->IsCasting())
	{
		if (s != -1)
			OldMagic->SpellFail(s);
	}
	endCasting();
	this->spell=0;
}


// Name:  isBadBody
// History: by LB, 26.3.2002
// Purpose: find body id's that crash client

// type1: not in artfiles & client crasher
// type2: not in artfiles, but no client crasher
// note1: only 2d client crashes.
// note2: from 0x100-0x300 there are almost no monsters, but all of type 2
// thus not listed and this fuction only covers Ids 0x0 till 0x100.
// strictly speaking type2's wouldn't be necassairy because not client crashing

bool cChar::isBadBody()
{
	short thisId = this->id();
	bool bb;

	// list of npcs that osi patched in (=got valid) after(!) creation of this list
	if (thisId==0xbe) return false; // fire ethernal, 14-8-2002

	/// original list (06-2002)
	if (thisId>=0xbe && thisId<=0xc7) return true;  // tpye 1
	if (thisId>=0xef && thisId<=0x100) return true; // type 2

	switch(thisId)
	{
	  case 0x00: // type 2
	  case 0x20: // type 1
	  case 0x5f: // type 1
	  case 0x9c: // type 1
	  case 0xa9: // type 1
	  case 0xde: // type 2
	  case 0xe3: // type 2
	  case 0xe5: // type 2
	  case 0xe6: // type 2
	  case 0xeb: // type 2
	  case 0xec: // type 2

         bb=true; 
	     break;

	  default: 
		  bb=false; 
		  break;
	}

	return bb;
}


bool cChar::isNpcBody()
{
	short ID = this->id(); 
	bool npc;
	
	switch(ID)
	{
	   case 0x190:
	   case 0x191:
	   case 0x192:
	   case 0x193:
	   case 0x3df:
	   case 0x3e2:
	   case 0x3de:
	   case 0x3ca:
	   case 0xb7:
	   case 0xb8:
	   case 0xb9:
	   case 0xba:
		   /*
	   case 0x2fc:
	   case 0x2fd:
	   case 0x2fe:
	   case 0x2ff:
	   case 0x300:
	   case 0x301:
	   case 0x302:
	   case 0x303:
	   case 0x304:
	   case 0x305:
	   case 0x306:
		   */

           npc=true;
		   break;

	   default:
		   npc=false;
		   break;
	}

	return npc;
}

bool cChar::fixAnims()
{
	switch (this->id())
	{
	case 0x2fc:
	case 0x2fd:
	case 0x2fe:
	case 0x067:
	case 0x04a:
		return true;
	}
	return false;
}

bool cChar::isMount()
{
	switch (this->id())
	{
	  case 0xe2:
	  case 0xe4:
	  case 0xcc:
	  case 0xc8:	 
	  case 0xd2:
	  case 0xda:
	  case 0xdb:
	  case 0xdc:
	  case 0x72:
	  case 0x73:
	  case 0xbb:
	  case 0x75:
	  case 0x76:
	  case 0x78:
	  case 0x90:
	  case 0x79:
	  case 0x7a:
	  case 0x84:
	  case 0xaa:
	  case 0xab:
	  case 0xb1:
	  case 0xb2:
	  case 0xb3:
	  case 0xbc:
	  case 0xbe:
	  case 0x317:
	  case 0x318:
	  case 0x319:
	  case 0x31a:
	  case 0x31f:									
	  return true;
	}
	return false;
}

bool cChar::isAnimalBody()
{ 
	short ID = this->id();
	
	if (this->isNpcBody()) return false; // nps are undefined in creatures array !

	if (ID>-1 && ID<=2048) 
	{ 
	    if ( NpcInfo_getType(ID)==2) return true; 
		else return false; 
	} 
	else return false; 
}

bool cChar::isMonsterBody()
{ 
	short ID = this->id(); 
	if (this->isNpcBody()) return false; // nps are undefined in creatures array !

	if (ID>-1 && ID<=2048) 
	{ 
	    if ( NpcInfo_getType(ID)==0) return true; 
		else return false; 
	} 
	else return false; 
}

bool cChar::isWaterCreatureBody()
{ 
	short ID = this->id(); 

	if (this->isNpcBody()) return false; // nps are undefined in vreatures array !

	if (ID>-1 && ID<=2048) 
	{ 
	    if ( NpcInfo_getType(ID)==1) return true; 
		else return false; 
	} 
	else return false; 
}

////////////
// Name:	hasKeyFor
// history:	by Duke, 29.3.2002
// Purpose:	search the char's BP for the key to a house, boat, chest...
//
P_ITEM cChar::hasKeyFor(PC_ITEM Lockable)
{	
	cItem* Pack = this->getBackpack() ;
	if (Pack)
	{
		int ci=0,loopexit=0;
		P_ITEM Key;
		while ( ((Key=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (Key->isType(ITY_Key) && Key->getMore1_4() == Lockable->serial)
			{
				return Key;
			}
		}
	}
	return NULL;
}

////////////
// Name:	HasSuitableTreasureMap
// history:	by Duke, 24.10.03
// Purpose:	search the char's BP for a treasure map near the given spot
//
P_ITEM cChar::HasSuitableTreasureMap(cCoord& pos)
{	
	cItem* Pack = this->getBackpack() ;
	if (Pack)
	{
		int ci=0,loopexit=0;
		P_ITEM Map;
		while ( ((Map=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (Map->isType(ITY_DecipheredMap))
			{
				cCoord TreasureLoc(Map->morex,Map->morey,0);
				if (inRange(pos,TreasureLoc,10))
					return Map;
			}
		}
	}
	return NULL;
}

bool cChar::Owns(PC_ITEM pi)		{return (serial==pi->ownserial);}
bool cChar::Wears(PC_ITEM pi)		{return (serial==pi->contserial);}
unsigned cChar::dist(cChar* pc)		{return pc ? pos.distance(pc->pos) : 0x0fff;}
unsigned cChar::dist(PC_ITEM pi)	{return pi ? pos.distance(pi->pos) : 0x0fff;}

int cChar::getBowType()
{
	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=this->SearchHands(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		short id = pi->id();
		if (IsBow(id)) return 1;
		if (IsCrossbow(id)) return 2;
		if (IsHeavyCrossbow(id)) return 3;
	}
	return 0;
}

////////////
// Name:	Str
// history:	by Duke, 08.04.2002
// Purpose:	encapsulation for strength
//
short cChar::effStr()				{return st.Eff();}	// returns current effective strength
short cChar::realStr()				{return st.Real();}	// returns the true strength
short cChar::decStr()				{return st.Dec();}	// returns the 3 digits behind the decimal point
short cChar::StrLimit()				{return st.Limit();}// returns the individual stat limit
void  cChar::setStr(short val)		{st.setReal(val);}	// set the true Str
void  cChar::setDecStr(short val)	{st.setDec(val);}	// set the 3 digits
short cChar::getStrLimit()			{	  if (npc)			return 20000; //returns the players stat limit
									 else if (!st.Limit())	return this->Race->strmax;
									 else					return min(this->Race->strmax,(int)st.Limit());}
void  cChar::setStrLimit(short val)	{st.setLimit(val); chgRealStr(0);}
void  cChar::chgStr(short val)		{st.chgTemp(val);}	// intended for temporary changes of Str
void  cChar::chgRealStr(short val)	{st.chgReal(val,getStrLimit());}	// intended for permanent changes of Str
bool  cChar::incDecStr(short val)	{return st.chgDec(val,getStrLimit());}

////////////
// Name:	Dex
// history:	by Duke, 08.04.2002
// Purpose:	encapsulation for dexterity
//
short cChar::effDex()				{return dx.Eff();}	// returns current effective Dexterity
short cChar::realDex()				{return dx.Real();}	// returns the true Dexterity
short cChar::decDex()				{return dx.Dec();}	// returns the 3 digits behind the decimal point
short cChar::DexLimit()				{return dx.Limit();}// returns the individual stat limit
void  cChar::setDex(short val)		{dx.setReal(val);}	// set the true Dex
void  cChar::setDecDex(short val)	{dx.setDec(val);}	// set the 3 digits
short cChar::getDexLimit()			{	  if (npc)			return 20000; //returns the players stat limit
									 else if (!dx.Limit())	return this->Race->dexmax;
									 else					return min(this->Race->dexmax,(int)dx.Limit());}
void  cChar::setDexLimit(short val)	{dx.setLimit(val); chgRealDex(0);}
void  cChar::chgDex(short val)		{dx.chgTemp(val);}	// intended for temporary changes of Dex
void  cChar::chgRealDex(short val)	{dx.chgReal(val,getDexLimit());}	// intended for permanent changes of Dex
bool  cChar::incDecDex(short val)	{return dx.chgDec(val,getDexLimit());}

////////////
// Name:	Int
// history:	by Duke, 08.04.2002
// Purpose:	encapsulation for intelligence
//
short cChar::effInt()				{return in.Eff();}	// returns current effective Intelligence
short cChar::realInt()				{return in.Real();}	// returns the true Intelligence
short cChar::decInt()				{return in.Dec();}	// returns the 3 digits behind the decimal point
short cChar::IntLimit()				{return in.Limit();}// returns the individual stat limit
void  cChar::setInt(short val)		{in.setReal(val);}		// set the true Int
void  cChar::setDecInt(short val)	{in.setDec(val);}	// set the 3 digits
short cChar::getIntLimit()			{	  if (npc)			return 20000; //returns the players stat limit
									 else if (!in.Limit())	return this->Race->intmax;
									 else					return min(this->Race->intmax,(int)in.Limit());}
void  cChar::setIntLimit(short val)	{in.setLimit(val); chgRealInt(0);} //
void  cChar::chgInt(short val)		{in.chgTemp(val);}	// intended for temporary changes of Int
void  cChar::chgRealInt(short val)	{in.chgReal(val,getIntLimit());}	// intended for permanent changes of Int
bool  cChar::incDecInt(short val)	{return in.chgDec(val,getIntLimit());}

////////////
// Name:	npcAI
// history:	by Duke, 25.04.2002
// Purpose:	encapsulation for npcaitype
//
void cChar::setAi(int val)	{npcaitype = val;}
int  cChar::getAi()			{return npcaitype;}
bool cChar::isAiMonster()	{return npcaitype == 2;}
bool cChar::isAiTeleGuard()	{return npcaitype == 4;}
bool cChar::isAiVendor()	{return npcaitype == 17;}

////////////////
// name:		resurrect
// history:		by UnKnown (Touched tabstops by Tauriel Dec 28, 1998)
//				moved from cTargets::NpcResurrectTarget() to here (Duke, 7.4.2002)
// Purpose:		Resurrects a player character
//
bool cChar::resurrect()
{
	int k=this->calcSocket();
	if (k<=-1) return false;
	P_CHAR pc = this;

	// check if they are standing in a doorway (house break in exploit)
	cItem* pi;
	int loopexit=0;
	RegCellIterator4Items rcii(this->pos);
	while((pi = rcii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (!pi->pos.IsSameXY(this->pos))
			continue;
		if (IsDoor(pi->id()))
			return false;
	}

	if (pc->dead)
	{//Shouldn' be a validNPCMove inside a door, might fix house break in. -- from zippy code
		Fame(pc,0);
		soundeffect2(this, 0x0214);
		pc->setId(pc->xid());
		pc->skin = pc->xskin;
		pc->dead=false;
		pc->fullHp();
		pc->fullStm();
		pc->fullMana();
		pc->setAttacker(NULL);
		pc->resetAttackFirst();
		pc->war=0;

		P_ITEM pj;
		pj = pc->GetItemOnLayer(0x1A);	// where the backpack is 'parked' for ghosts
		if (pj)
			pj->layer=0x15;

		PC_ITEM Robe;
		AllItemsIterator aii;
		for (aii.Begin(); (Robe = aii.GetData()) != aii.End(); aii++)
		{
			if (Robe->serial == pc->robe)
			{
				Items->DeleItem(Robe->unconst());

				P_ITEM pi=Items->SpawnItem(this,1,"a resurrect robe",0,0x1F03,0,0);
				if (!pi) return false;
				pi->dye=1;
				pc->Wear(pi,0x16);
				break;
			}
		}
		updatechar(pc);
		return true;
	}

	sysmessage(k,"That person isn't dead");
	return false;
}

////////////
// Name:	setInput
// history:	by Duke, 12.05.2002
// Purpose:	prepares for direct text input from the player
//
void cChar::setInput(short mode, P_ITEM pi)
{
	this->inputmode = mode;
	this->inputitem = pi ? pi->serial : -1;
}

////////////
// Name:	setDclickedItem
// history:	by Duke, 12.05.2002
// Purpose:	several ways to store the item they dclicked
//
P_ITEM cChar::getDclickedItem()			{return FindItemBySerial(this->dclickedserial);}

////////////
// Name:	checkSkill
// history:	by Duke, 18.05.2002
// Purpose:	checks the given skill of this char in full range
//
bool cChar::checkSkill(unsigned short skill, short mini, short maxi)
{
	return SkillManager->CheckSkill(this,skill,mini,maxi);
}
bool cChar::checkSkill(unsigned short skill, short mini)
{
	return checkSkill(skill,mini,this->Race->skillmax[skill]);
}
bool cChar::checkSkill(unsigned short skill)
{
	return checkSkill(skill,0,this->Race->skillmax[skill]);
}

int cChar::calcSocket()
{
	assert(this!=NULL);
	if (!this) return -1;

	/*
	    LB note: better comment about the above to be added ;)
	*/

	if (this->npc)
		return -1;

	P_CHAR pc;
	AllPlayersIterator api;
	for (pc = api.First(); pc != NULL; pc = api.Next())
	{
		if (pc->isSameAs(this))
			return api.getSocket();
	}

	return -1;
}

////////////
// Name:	payment functions
// history:	by Duke, 1.09.2002
//			take it from the player if the bank hold not enough (Sayro, 5.3.2004)
// Purpose:	handle payment with or without bank
//
int cChar::useBankToPay(int amount)
{
	return (amount >= SrvParms->CheckBank) ? amount : 0;
}

bool cChar::canAfford(int amount)
{
	if (useBankToPay(amount))
		return (this->CountBankGold() >= amount || this->CountGold() >= amount);
	else
		return (this->CountGold() >= amount);
}

int cChar::pay(int amount)
{
	if (useBankToPay(amount) && this->CountBankGold() >= amount)
		this->deleteBankGold(amount);
	else
		this->deleteItems(amount,0x0EED);
	return 0;	// for future use
}

void cChar::checkEquipment() // check equipment of character p
{
	int ci=0, loopexit=0;
	P_ITEM pi,pack;
	while ( (( pi=this->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (this->id()!=0x191 && isFemaleArmour(pi->id())); // check for males wearing female armor
		else if (pi->st>this->effStr())//if strength required > character's strength
		{
			if (pi->name[0]=='#')
				pi->getName(temp2);
			else
				strcpy(temp2,pi->name);
			
			UOXSOCKET s = this->calcSocket();
			sprintf(temp, "You are not strong enough to keep %s equipped!", temp2);
			sysmessage(s, temp);
			itemsfx(s, pi->id());
			
			//Subtract stats bonus and poison
			this->removeItemBonus(pi);
			if (pi->trigon==1 && pi->layer > 0)// -Frazurbluu- Trigger Type 2 is my new trigger type *-
			{
				triggerwitem(this->calcSocket(), pi, 1); // trigger is fired when unequipped? sorry this needs checked
			}
			if (this->Poison() && pi->Poisoned()) this->poison-=pi->poisoned;
			if (this->Poison()<0) this->SetPoison(0);
			
		}
		else continue; // item is ok, check next item

		pack = this->getBackpack(); // look for players backpack
		if (pack)	// found a pack, so bounce item into pack instead of dropping on the ground
		{
			pack->AddItem(pi);
		}
		else // no pack found, drop item on ground
		{
			pi->SetContSerial(-1);
			pi->MoveTo2(this->pos);
		}

		// update the other clients in range
		SndWornItemsToAllInRange(this);
	}
}

void cChar::setAttacker(P_CHAR pc)		{if (pc!=NULL) this->attacker = pc->serial; else this->attacker=-1; }
P_CHAR cChar::getAttacker()				{return FindCharBySerial(attacker);}

void cChar::SetFollowTarget(P_CHAR pc)	{if (pc!=NULL) this->ftarg = pc->serial; else this->ftarg=-1;}
void cChar::ResetFollowTarget()			{this->ftarg = -1;}
bool cChar::IsFollowing()				{return (ftarg!=-1);}
P_CHAR cChar::GetFollowTarget()			{return FindCharBySerial(ftarg);}

void cChar::SetSwingTarget(P_CHAR pc)	{if (pc!=NULL) this->swingtarg = pc->serial; else this->swingtarg=-1;}
void cChar::ResetSwingTarget()			{this->swingtarg = -1;}
bool cChar::HasSwingTarget()			{return (swingtarg!=-1);}
P_CHAR cChar::GetSwingTarget()			{return FindCharBySerial(swingtarg);}

void cChar::SetTarget(P_CHAR pc)		{this->targ = pc->GetIndex();}
void cChar::ResetTarget()				{this->targ = -1;}
bool cChar::HasTarget()					{return (targ!=-1);}
P_CHAR cChar::GetTarget()				{return MAKE_CHAR_REF(targ);}
void cChar::FightBack(P_CHAR Agressor)	{npcattacktarget(this,Agressor);}

////////////
// Name:	addBackpack
// history:	by Duke, 20.10.2002
// Purpose:	give the char a backpack
//
P_ITEM cChar::addBackpack()
{
	P_ITEM Pack = Items->SpawnItem(this,1,"#",0,0x0E75,0,0);
	if (!Pack) return NULL;
	Pack->setType(ITY_Container);
	Pack->dye=1;
	Pack->setNotMovable(); // anti EUO exploit
	this->Wear(Pack,0x15);
	return Pack;
}

////////////
// Name:	AddGift
// history:	by Duke, 20.11.2002
// Purpose:	give the char a (christmas-) gift
//
bool cChar::AddGift(int item_scp_num)
{
	P_ITEM Pack;
	if (this->dead)		
		Pack=this->GetItemOnLayer(0x1A);	// ghosts have their pack at layer 1A
	else
		Pack = this->getBackpack();
	if (!Pack) return false;
	
	P_ITEM pi = Items->CreateScriptItem(-1, item_scp_num, 1);
	if (!pi) return false;
	Pack->AddItem(pi);
	pi->refresh();
	return true;
}

P_ITEM cChar::Search(int *ci) const
{
	return ContainerSearch(this->serial, ci);
}

P_ITEM cChar::SearchHands(int *ci)
{
	int loopexit=0;
	P_ITEM pi;
	while ( ((pi=this->Search(ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->layer==1 || pi->layer==2)
			return pi;
	}
	return 0;
}

int cChar::HasFreeHand()
{
	int loopexit=0;
	P_ITEM pi;
	bool a = false;
	bool b = false;
	int ci = 0;

	while ( ((pi=this->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if      (pi->itmhand==2) a = b = true;
		else if (pi->layer==1)   a =     true;
		else if (pi->layer==2)   b =     true;
	}

	if      ( (a) && (b) ) return 0;
	else if ( (a) || (b) ) return 1;
	else				   return 2;
}

bool cChar::WieldsAntiMagicalItem()
{
	int ci=0, loopexit=0;
	P_ITEM pj;
	while ( (( pj=this->SearchHands(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if ( pj->isType(ITY_SpellBook) ) continue;
		if ( IsStave(pj->id()) || IsChaosOrOrderShield(pj->id()) ) continue;

		return true;
	}
	return false;
}

void cChar::PoisonStart(UOXSOCKET s, int poisonstrength)
{
	if (poisonstrength <= 0) return;

	this->poisoned = poisonstrength;
	this->poisondamagetime.setSecs(40/poisonstrength); // a lev.1 poison takes effect after 40 secs, a deadly pois.(lev.4) takes 40/4 secs - AntiChrist
	this->poisonwearofftime.setSecs(SrvParms->poisontimer);
	impowncreate(s, this, 1); // Lb, sends the green bar ! 
}

void cChar::PoisonWearOff(UOXSOCKET s)
{
	this->ResetPoisoned();
	this->poisonwearofftime.reset();
	impowncreate(s, this, 1); // Lb, sends the green bar ! 
}

void cChar::SetViewingDepth(short depth)
{
	this->viewingdepth = depth;
}

short cChar::GetViewingDepth()
{
	if (this->isGM()) return this->viewingdepth;
	else return 0; //normal players always have viewingdepth = 0;
}

P_ITEM cChar::Shrink()
{
	if (!this->npc) return NULL; // don't shrink players  ;)

	short icon = NpcInfo_getIcon(this->id());	// set it to icon-item best fitting to npc-id

	P_ITEM pi = Items->SpawnItem(this,1,this->name,0,icon,0,0); //spawns the npc item
	if (!pi) return NULL;

	pi->setType(ITY_SHRUNKNPC);
	pi->morex = this->serial;				// save serial for retrival (remeber: it still exists, just hidden)
	pi->MoveTo2(this->pos);

	this->doppelgaenger_serial = -4; // -4: marker for npc in shrink status
	this->MoveToOneOff(this->pos); // get it out of old mapregions !
	this->war = 0; 
	this->setAttacker(NULL);

	this->hungertime -= uiCurrentTime;	// substract current time (gets readded on unshrink)
										// to freeze the timer (Thrawn)

	SndRemoveNpcToAll(this);
	updatechar(this);

	return pi;
}

void cChar::DoAction(int hex)
{
	SndAction(this, hex);
}

void cChar::SetIndex(int i)
{
	this->index = i;
}
int cChar::GetIndex()	// this is ONLY for places where we will continue to use an index !
{
	return this->index;
}

void cChar::SetOnline()
{
	Accounts->SetOnline(this->account, this);
}

void cChar::SetOffline()
{
	Accounts->SetOffline(this->account);
}

int cChar::InGame()		// comprises both online and delayed logout status
{
	if (!this) return 0;
	if (this->npc) return 0;

	int k=this->calcSocket();
	if (k==-1) return 0;

	if (Accounts->GetInWorld(this->account) == this->GetIndex()) 
		return 2;	//Instalog

	return 0;
}


// new magery related stuff
bool cChar::IsCasting()
{
//	return (currentspell ? true : false);
	return this->spelldelay;
}

void cChar::SetCastingSpell(cSpell* spell, char type, void* preTarget)
{
	this->currentspell		= spell;
	this->currentspelltype	= type;
	this->preTarg			= preTarget;
}

void cChar::StartSpellDelay()
{
	if (!this->currentspell) return; // can't start a spell delay, when we don't have a spell

	int s = this->calcSocket();

	this->unhide();
	this->disturbMed(s); // Meditation
	this->Freeze();//freeze
	
	if (!this->onhorse) impaction(s, currentspell->GetAction()); // only do some action when player is not on horse

	if (!this->isGM()) //delay only for players
	{
		this->spelltime=((currentspell->GetDelay(this->GetCastingSpellType())*MY_CLOCKS_PER_SEC)/10)+uiCurrentTime;
		this->spellaction = currentspell->GetAction();
		this->nextact=75;
		this->spelldelay = true;
	}
	else Magic->AfterSpellDelay(this); // skip delay for GMs
}

cSpell* cChar::GetCastingSpell()
{
	return currentspell;
}

char cChar::GetCastingSpellType()
{
	return currentspelltype;
}

// end magery related stuff


// new food system (thrawn)
bool cChar::CanEat(P_ITEM pi)
{
	return (((food&pi->GetFoodType()) == pi->GetFoodType()) ? true : false);
}
// end food system

void cChar::Wear(P_ITEM pi, char lay)
{
	pi->SetContSerial(this->serial);
	pi->layer = lay;
}

int cChar::MaxWeight()	// calc carrying capacity
{
//	return (this->effStr()*WEIGHT_PER_STR)+30;
	return (this->effStr()*WEIGHT_PER_STR)+30;
}

//////////////////
// name:	ToolWearOut
// purpose:	apply wear out to item, delete if necessary
// history:	first impl by Ripper in various places
//			collected here by Duke, 7.11.2000
//			moved to cChar by Duke, 8.12.2003
//			added 'missing!' msg Duke, 26.2.2004
//
bool cChar::ToolWearOut(UOXSOCKET s)
{
	P_ITEM Tool = this->getDclickedItem();
	if (!Tool)
	{
		sysmessage(s,"Where is your tool ?");
		return true;
	}
	return this->ToolWearOut(s,Tool);
}
				

bool cChar::ToolWearOut(UOXSOCKET s, P_ITEM pi)
{
	char tn[222];
	pi->getName(tn);	// get the name first, item might be deleted by WearOut

	if (pi->WearOut())	// has item been destroyed ??
	{
		sprintf(temp,"Your %s has been destroyed",tn);
		sysmessage(s,temp);
		return true;
	}
	else
		return false;
}

/////////////
// name:	AllCharsIterator
// purpose:	intended to replace the charcount loops
// history:	by Correa, 27.6.01
//			moved here from char.h to better encapsulate charcount var (Duke, 31.03.01)
//			changed ++ operator to skip free entries (Duke, 11.06.03)
//			changed GetData to skip free entries too (Duke, 28.07.03)
//
AllCharsIterator::AllCharsIterator()	            { pos = 0;}
AllCharsIterator::~AllCharsIterator()				{ }
void AllCharsIterator::Begin()						{ pos = 0; }
P_CHAR AllCharsIterator::End()						{ return NULL; }
//P_CHAR AllCharsIterator::GetData(void)				{ return pos < charcount ? MAKE_CHAR_REF(pos) : NULL; }
P_CHAR AllCharsIterator::GetData(void)
{
	P_CHAR pc = MAKE_CHAR_REF(pos);
	while (pc == NULL)
	{
		pos++;
		if (pos >= charcount)
			return NULL;
		pc = MAKE_CHAR_REF(pos);
	}
	return pc;
}
AllCharsIterator& AllCharsIterator::operator++(int)
{
	P_CHAR pc = NULL;
	while (pc == NULL || (pc && pc->free))
	{
		pos++;
		if (pos >= charcount)
			break;
		pc = MAKE_CHAR_REF(pos);
	}
	return *this;
}


