/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "house.h"
#include "itemid.h"
#include "LoS.h"
#include "magic.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"
#include "gumps.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "p_ai.cpp"

void cCharStuff::CheckAI(unsigned int currenttime, P_CHAR pc_i) //Lag Fix -- Zippy
{
	if (!pc_i) return;
	int onl;
	unsigned int chance;

    // in npc.scp add script # for npc`s ai
	// case - script - case - script -   case - script -  case - script
	//   0   -  0     -  4    -  4     -  8    -  8     -  12   -  C
	//   1   -  1     -  5    -  5     -  9    -  9     -  13   -  D
	//   2   -  2     -  6    -  6     -  10   -  A     -  14   -  E
	//   3   -  3     -  7    -  7     -  11   -  B     -  15   -  F
	// case - script - case - script
	//   16  -  10    -  20   -  14
	//   17  -  11    -  21   -  15
	//   18  -  12    -  22   -  16
	//   19  -  13    -  23   -  17  ...this is just a guide...Ripper
	cChar* pc;
	int loopexit=0;

	switch(pc_i->getAi())
	{
	case 0: // Shopkeepers greet players..Ripper
		if (SrvParms->VendorGreet==1 && pc_i->npc && pc_i->shop==1 && pc_i->isHuman())
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				if (pc_i->dist(pc) > 3)
					continue;
				if (pc->isInvul() || pc->npc || pc->dead || !pc->isInnocent() || !pc->InGame() || pc->isHidden())
					continue;
				if (!line_of_sight(-1,pc_i->pos, pc->pos, LOS_STD_BLOCKERS))
					continue;
				sprintf(temp,"Hello %s, Welcome to my shop, How may i help thee?.", pc->name);
				npctalkall(pc_i,temp,1);
				pc_i->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*30;
			}
		}
		break;
	case 1: // good healers
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (!pc->dead || pc_i->dist(pc) > 3 || pc->npc || !onl)
					continue;
				if (!line_of_sight(-1,pc_i->pos, pc->pos, LOS_STD_BLOCKERS))
					continue;
				if (pc->isMurderer()) 
				{
					npctalkall(pc_i, "I will nay give life to a scoundrel like thee!",1);
					continue;
				}
				if (pc->isCriminal()) 
				{
					npctalkall(pc_i, "I will nay give life to thee for thou art a criminal!",1);
					continue;
				}
				if (pc->isInnocent())
				{
					// prevent house break-ins by Uber 07-25-2002
					PC_ITEM House = findHouseAt( pc->pos );
					if (House && !pc->Owns(House))
					{
						npctalkall(pc_i, "I will nay give life to thee for thou art not in thine own abode!",1);
						continue;
					}
					if (pc_i->timeused_last + MY_CLOCKS_PER_SEC*10 >= uiCurrentTime) return;
					pc_i->timeused_last = uiCurrentTime;
					Gumps->Menu(pc->calcSocket(),7,0);
					pc_i->DoAction(0x10);
					
					switch(RandomNum(0, 4)) 
					{
					case 0: npctalkall(pc_i, "Thou art dead, but 'tis within my power to resurrect thee.  Live!",1);			break;
					case 1: npctalkall(pc_i, "Allow me to resurrect thee ghost.  Thy time of true death has not yet come.",1);	break;
					case 2: npctalkall(pc_i, "Perhaps thou shouldst be more careful.  Here, I shall resurrect thee.",1);		break;
					case 3: npctalkall(pc_i, "Live again, ghost!  Thy time in this world is not yet done.",1);					break;
					case 4: npctalkall(pc_i, "I shall attempt to resurrect thee.",1);											break;
					}
				}
			}
		}
		break;
	case 2 : // Monsters, PK's - (stupid NPCs)
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				chance = RandomNum(1, 100);
				if (pc_i->isSameAs(pc))
					continue;
				if (pc_i->dist(pc) > SrvParms->attack_distance)
					continue;
				if (pc->isInvul() || pc->isHidden() || pc->dead || pc->isDummy())
					continue;
				if (pc->Owns(pc_i))		// don't attack your master
					continue;
//				if (pc->npc && (pc->npcaitype == 2 || pc->npcaitype == 1))
//					continue;
//				if (SrvParms->monsters_vs_animals == 0 && (strlen(pc->title) > 0 || !onl))
//					continue;
//				if (SrvParms->monsters_vs_animals == 1 && chance > SrvParms->animals_attack_chance)
//					continue;

				if (onl || (pc->npc && !pc->isAiMonster() && pc->npcaitype!=1) &&
					((SrvParms->monsters_vs_animals == 0 && (strlen(pc->title)>0 || onl))||
					((SrvParms->monsters_vs_animals == 1)&&((unsigned)RandomNum(1,100)<=SrvParms->animals_attack_chance))))
				{
					npcattacktarget(pc_i, pc);
					if (pc_i->getRealSkill(MAGERY)>400)
					{
						if (pc_i->Hp() < (pc_i->effStr()/2))
						{
							npctalkall(pc_i, "In Vas Mani", 0);
							OldMagic->NPCHeal(pc_i);
						}
						if (pc_i->Poisoned())
						{
							npctalkall(pc_i, "An Nox", 0);
							OldMagic->NPCCure(pc_i);
						}
						if (pc->IsDispellable())
						{
							npctalkall(pc_i, "An Ort", 0);
							OldMagic->NPCDispel(pc_i, pc);
						}
					}
					return;
				}
			}
		}
		break;
	case 3 : //Evil Healers
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (!pc->dead || pc_i->dist(pc) > 3 || pc->npc || !onl)
					continue;
				if (!line_of_sight(-1,pc_i->pos, pc->pos, LOS_STD_BLOCKERS))
					continue;
				if (pc->isInnocent())
				{
					npctalkall(pc_i, "I dispise all things good. I shall not give thee another chance!",1);
					continue;
				}
				PC_ITEM House = findHouseAt( pc->pos );	// prevent house break-ins by Uber 07-25-2002
				if (House && !pc->Owns(House))
				{
					npctalkall(pc_i, "I will nay give life to thee for thou art not in thine own abode!",1);
					continue;
				}
				if (pc_i->timeused_last + MY_CLOCKS_PER_SEC*10 >= uiCurrentTime) return;
				pc_i->timeused_last = uiCurrentTime;
				Gumps->Menu(pc->calcSocket(),7,0);
				pc_i->DoAction(0x10);

				switch(RandomNum(0, 4)) 
				{
				case 0: npctalkall(pc_i, "Fellow minion of Mondain, Live!!",1); break;
				case 1: npctalkall(pc_i, "Thou has evil flowing through your vains, so I will bring you back to life.",1); break;
				case 2: npctalkall(pc_i, "If I res thee, promise to raise more hell!.",1); break;
				case 3: npctalkall(pc_i, "From hell to Britannia, come alive!.",1); break;
				case 4: npctalkall(pc_i, "Since you are Evil, I will bring you back to consciouness.",1); break;
				}
			}
		}
		break;
	case 4 : // Guards
		if (!pc_i->war	// guard isnt busy 
			&& pc_i->inGuardedArea())	// this region is guarded
		{
			cChar* Victim=NULL;
			unsigned int closest=999;
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				if (!pc->npc && !pc->InGame())
					continue;					// logged out player
				if (pc_i->isSameAs(pc))
					continue;					// the guard himself
				if (!(pc->isAiMonster() || /*pc->isCriminal() ||*/ pc->isMurderer()))
					continue;
				unsigned int d = pc_i->dist(pc);
				if (d > SrvParms->attack_distance || pc->isInvul() || pc->dead || pc->isDummy())
					continue;
				if ( closest > d)
				{
					closest = d;
					Victim = pc;
				}
			}
			if (Victim)
			{
				npcattacktarget(pc_i, Victim);
				npctalkall(pc_i, "Thou shalt regret thine actions, swine!",1); // ANTISPAM !!! LB
			}
		}
		break;
	case 5: // npc beggars
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (pc_i->dist(pc) > 3 || pc->isInvul() || pc->npc || pc->dead || !onl || !pc->isInnocent() || pc->isHidden())
					continue;
				int beg= RandomNum (0,2);
				{
					switch (beg)
					{
					case 0: npctalkall(pc_i,"Could thou spare a few coins?",1);
						pc_i->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*30;
						break;
					case 1: npctalkall(pc_i,"Hey buddy can you spare some gold?",1);
						pc_i->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*30;
						break;
					case 2: npctalkall(pc_i,"I have a family to feed, think of the children.",1);
						pc_i->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*30;
						break;
					default:
						break;
					}
				}
			}
		}
		break;
	case 6: break; // Ripper- chaos guards.
	case 7: break; // Ripper- order guards.
	case 8: break; //morrolan - old banker
	case 9 : // in world guards, they dont teleport out...Ripper
		if (!pc_i->war	// guard isnt busy 
			&& pc_i->inGuardedArea())	// this region is guarded
		{	// this bracket just to keep compiler happy
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				unsigned int d = pc_i->dist(pc);
				if (pc_i->isSameAs(pc) || d > 3 || pc->isInvul() || pc->dead || !onl || pc->isHidden() || pc->isDummy())
					continue;
				if ( !pc->npc && pc->crimflag > 0 )
				{
					sprintf(temp,"You better watch your step %s, I am watching thee!!", pc->name);
					npctalkall(pc_i,temp,1);
					pc_i->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*30;
				}
				else if ( !pc->npc && pc->isInnocent() && !pc->dead )
				{
					sprintf(temp,"%s is an upstanding citizen, I will protect thee in %s.", pc->name, region[pc->region].name);
					npctalkall(pc_i,temp,1);
					pc_i->antispamtimer=uiCurrentTime+MY_CLOCKS_PER_SEC*30;
				}
				else if ( d <= 10 && (
					(pc->npc && pc->isAiMonster())	// evil npc
					|| (!pc->npc && !(pc->isInnocent()) && !(pc->isCriminal()))	// a player, not grey or blue
					|| (pc->attackfirst==1)))	// any agressor
				{
					pc_i->pos = pc->pos; //Ripper..guards teleport to enemies.
					soundeffect2(pc_i, 0x01FE);
					staticeffect(pc, 0x372A, 0x09, 0x06);
					npcattacktarget(pc_i, pc);
					npctalkall(pc_i, "Thou shalt regret thine actions, swine!",1); // ANTISPAM !!! LB
					return;
				}
			}
		}
		break;
	case 10: // Tamed Dragons ..not white wyrm..Ripper
		// so regular dragons attack reds on sight while tamed.
		if (pc_i->npc && pc_i->tamed)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				if (pc_i->dist(pc) > 10 || !pc->npc || !pc->isAiMonster())
					continue;
				npcattacktarget(pc_i,pc);
				return;
			}
		}
		break;
	case 11 : // add NPCAI B in scripts to make them attack reds. (Ripper)
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (pc_i->dist(pc) > 10 || pc->isInvul() || pc->dead || pc->isDummy())
					continue;
				if (!(pc->isAiMonster() || pc->isCriminal() || pc->isMurderer()))
					continue;
				if (!pc->npc && !onl)
					continue;
				npcattacktarget(pc_i, pc);
			}
		}
		break;
	case 12: break;	// blue decorative npcs. 
	case 13 : // Pixie brain by Fizz, 5.12.2002
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (pc_i->dist(pc) > 10 || pc->isInvul() || pc->dead || pc->isDummy())
					continue;
				if (!(pc->isAiMonster() || pc->isCriminal() || pc->isMurderer() || pc->karma < 0))
					continue;
				if (!pc->isHuman())
					continue;
				if (!pc->npc && !onl)
					continue;
				npcattacktarget(pc_i, pc);
			}
		}
		break;

	case 17: break; //Zippy Player Vendors.
	case 30: // why is this the same as case 50???..Ripper
		if (!pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (pc_i->dist(pc) > 10 || pc->isInvul() || pc->dead || !pc->isAiMonster() || !onl || pc->isDummy())
					continue;
				npcattacktarget(pc_i, pc);
				return;
			}
		}
		break;
	case 32: // Pets Guarding..Ripper
		if (pc_i->npc && pc_i->tamed)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (pc_i->dist(pc) > 10 || pc->npc || pc->dead || !pc->guarded || !onl)
					continue;
				if (pc->Owns(pc_i))
				{
					pc_i->FightBack(pc->getAttacker());
					return;
				}
			}
		}
		break;
	case 50:// Energy Vortex / Blade Spirit
		if (!pc_i->war)
		{
			cChar* Victim=NULL;
			unsigned int closest=999;
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				if (pc_i->isSameAs(pc))
					continue;
				unsigned int d = pc_i->dist(pc);
				if (d > SrvParms->attack_distance || pc->isInvul() || pc->dead || (!pc->npc && !pc->InGame()) || pc->isDummy())
					continue;
				if ( closest > d)
				{
					closest = d;
					Victim = pc;
				}
			}
			if (Victim)
				npcattacktarget(pc_i, Victim);
		}
		break;
		// Case 60-70 is Skyfires new AI
	case 96:
	case 60: //Skyfire - Dragon AI
		if (pc_i->war)
		{
			RegGrid3x3Iterator4Chars rg3ic(pc_i->pos);
			while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
			{
				onl = pc->InGame();
				if (pc->npc || pc->dead || !onl)
					continue;
				if (pc_i->dist(pc) > 4 && pc->isSameAs(pc_i->getAttacker()))
				{
					if (pc->getBowType()!=0)
					{
						pc_i->dir=pc->dir;
						pc_i->teleTo(pc->pos);
						npctalkall(pc_i,"Foolish Mortal!",0);
					}
				}
				else
				{
					switch(RandomNum(0, 4))
					{
					case 0:	OldMagic->NPCEBoltTarget(pc_i,pc);			break;
					case 1:	OldMagic->NPCFlameStrikeTarget(pc_i,pc);	break;
					case 2:	OldMagic->ParalyzeSpell(pc_i,pc);			break;
					case 3:	OldMagic->NPCLightningTarget(pc_i,pc);		break;
					case 4:	OldMagic->ParalyzeSpell(pc_i,pc);			break;
					}
				}
			}
			npcattacktarget(pc_i, pc);
			if (pc_i->Hp() < pc_i->effStr()/2)
				OldMagic->NPCHeal(pc_i);
			if (pc_i->Poisoned())
				OldMagic->NPCCure(pc_i);
			if (pc->IsDispellable())
				OldMagic->NPCDispel(pc_i,pc);
			return;
		}
		else
		{
			if (pc_i->Hp() < pc_i->effStr()/2)
				OldMagic->NPCHeal(pc_i);
			if (pc_i->Poisoned())
				OldMagic->NPCCure(pc_i);
		}
		break;

	case 127: // doppelgaenger AI

		break;

	default:
		Console.send("ERROR: cCharStuff::CheckAI-> Error npc %i has invalid AI type %i\n",pc_i->serial,pc_i->getAi());
		return;
	}
}

PC_ITEM HeatSourceInRange(P_CHAR Player)
{
	if (!Player) return NULL;
	PC_ITEM pi;
	int loopexit=0;

	RegGrid3x3Iterator4Items rg3ii(Player->pos);
	while((pi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (IsCookingPlace(pi->id()) && iteminrange(Player,pi,3))
			return pi;
	}
	return NULL;
}

void cChar::resetCraftAI()
{
	this->craftAI = 0;
	this->nextCraft.reset();
}

void cChar::checkCraftAI(UOXSOCKET s)
{
	if (!this->craftAI || !this->nextCraft.hasExpired())
		return;

	if (this->war)
	{
		this->resetCraftAI();
		return;
	}

	switch (this->craftAI)
	{
	case 1:
		PC_ITEM Pack = this->getBackpack();
		if (!Pack)
		{
			this->resetCraftAI();
			return;
		}
		PC_ITEM Heat = HeatSourceInRange(this);
		if (!Heat)
		{
			this->resetCraftAI();
			return;
		}
		
		int loopexit=0;
		int ci=0;
		P_ITEM Raw = NULL;
		PC_ITEM pi;
		while ( ((pi=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (pi->id() == 0x097A ||	// fish
				pi->id() == 0x09B9 ||	// bird
				pi->id() == 0x09F1)		// ribs
			{
				Raw = Items->SplitPile(pi->unconst(),1);	// take one from the pile
				break;
			}
		}
		if (!Raw)
		{
			this->resetCraftAI();
			return;
		}

		this->dclickedserial = Raw->serial;
		switch (Raw->id())
		{
		case 0x097A:	Skills->CookOnFire(s,this,Heat,0x097B,"fish steaks");	break;
		case 0x09B9:	Skills->CookOnFire(s,this,Heat,0x09B7,"bird");			break;
		case 0x09F1:	Skills->CookOnFire(s,this,Heat,0x09F2,"ribs");			break;
		}
		this->nextCraft.setSecs(10*SrvParms->objectdelay);
		break;
	}
}

