/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// - Tauriel experimental pointer array *crap*
//
// -- pointer.cpp		Item specific routines (add, delete change) in preperation for
//						going to a pointer based system (compiled under level 3 no errors!
//
#include "pointer.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "pointer.cpp"

bool BuildPointerArray()
{
	int memerrflg=0;
	for (int i=0;i<HASHMAX;i++)
	{
		// null them first
		itemsp[i].pointer = NULL;
		charsp[i].pointer = NULL;
		cownsp[i].pointer = NULL;
		spawnsp[i].pointer = NULL;
		contsp[i].pointer = NULL;
		cspawnsp[i].pointer = NULL;
		ownsp[i].pointer = NULL;
		glowsp[i].pointer = NULL;


		// init them
		if (( itemsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( charsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( cownsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( spawnsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( contsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( cspawnsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( ownsp[i].pointer = new int[25]) == NULL) memerrflg=1;
		if (( glowsp[i].pointer = new int[25]) == NULL) memerrflg=1;

		if (memerrflg)
		{
			return false;
		}
		itemsp[i].max=ownsp[i].max=spawnsp[i].max=contsp[i].max=cownsp[i].max=cspawnsp[i].max=charsp[i].max=glowsp[i].max=25;
		for (int j=0;j<25;j++)
			itemsp[i].pointer[j]=ownsp[i].pointer[j]=cownsp[i].pointer[j]=spawnsp[i].pointer[j]=contsp[i].pointer[j]=cspawnsp[i].pointer[j]=charsp[i].pointer[j]=glowsp[i].pointer[j]=-1;
	}
	return true;
}

//
// - Sets an item into the array, reallocating space if needed
//   Usage: setptr(&itemsp[serial%256], item#);
//          setptr(&charsp[serial%256], char#);
//   NOTE: can be used to set other pointer arrays too (like regions)
void setptr(lookuptr_st *ptr, P_CHAR pc) //set char in pointer array
{
	if (pc->serial <0) return; // crash avoidance
	setptr(ptr, pc->GetIndex());
}
void setptr(lookuptr_st *ptr, PC_ITEM pi) //set item in pointer array
{
	if (pi->serial <0) return; // crash avoidance
	setptr(ptr, pi->GetIndex());
}
void setptr(lookuptr_st *ptr, int item) //set item in pointer array
{
	int i;
	if (ptr->max == 0)	// allow for deferred memory allocation ie. just when needed (Duke, 18.12.01)
	{
		if (ptr->pointer)
		{
			LogCritical("Corrupted pointer memory!");
			return;
		}
		else	// both are zero, so allocate
		{
			int* ti = (int *)malloc(25*sizeof(int));
			if (!ti)
			{
				LogCritical("Error allocating pointer memory!");
				return;
			}
			else
			{
				ptr->pointer = ti;
				ptr->max = 25;
				memset(ptr->pointer,0xFF,25*sizeof(int));	// initialize to -1
			}
		}
	}

	for (i=0;i<(ptr->max);i++)
	{
		if (ptr->pointer[i]==-1)
		{
			ptr->pointer[i]=item;
			return;
		} else if (ptr->pointer[i]==item) return;
	}

	//resize(ptr->pointer, ptr->max, ptr->max+25);
	// Must be out of slots, so reallocate some and set item
//	if ((ptr->pointer = (int *)realloc(ptr->pointer, (ptr->max+25)*sizeof(int)))==NULL)
	int* ti = (int *)realloc(ptr->pointer, (ptr->max+25)*sizeof(int));
	if (!ti)
	{
		LogCritical("Error reallocating pointer memory!");
		error=1;
		//keeprun=0;  //shutdown
		return;
	}
	else
		ptr->pointer = ti;

	for (i=ptr->max;i<(ptr->max+25);i++) ptr->pointer[i]=-1;
	ptr->pointer[ptr->max]=item;
	ptr->max+=25;
	return;
}

// - Find a specific item/char by serial number.
//   Usage: item=findbyserial(&itemsp[serial%HASHMAX], serial, 0);
//          char=findbyserial(&charsp[serial%HASHMAX], serial, 1);
//          if (item==-1) clConsole.send("Couldn't find by serial: %d\n", serial);
int findbyserial(lookuptr_st *ptr, int nSerial, int nType)
{ 
	if (nSerial < 0) return -1;  //prevent errors from some clients being slower than the server clicking on nolonger valid items
	
	if (ptr == NULL || ptr->pointer == NULL) // Blackwind / Crashfix 
		return -1;
	for (int i=0;i<(ptr->max);i++)
	{ 
		if (nType==0 && (ptr->pointer[i]> -1 && ptr->pointer[i] < Items->GetCount()) )
		{
			P_ITEM TheItem = MAKE_ITEM_REF(ptr->pointer[i]);
			if (TheItem!=NULL)
			{
				if (TheItem->serial==nSerial)
					return ptr->pointer[i];
			}
		}
		if (nType==1 && (ptr->pointer[i]>-1 && ptr->pointer[i] < Npcs->GetCount()) )
		{
			P_CHAR TheChar = MAKE_CHAR_REF(ptr->pointer[i]);
			if (TheChar!=NULL)
			{
				if (TheChar->serial==nSerial)
					return ptr->pointer[i];
			}
		}
	}
	return -1;
}

// - Remove an item/char from a pointer array
//   (Ok, just mark it as a free slot ;P )
void removefromptr(lookuptr_st *ptr, P_CHAR pc)
{
	if (pc->serial <0) return; // crash avoidance
	removefromptr(ptr, pc->GetIndex());
}
void removefromptr(lookuptr_st *ptr, PC_ITEM pi)
{
	if (pi->serial <0) return; // crash avoidance
	removefromptr(ptr, pi->GetIndex());
}
void removefromptr(lookuptr_st *ptr, int nItem)
{
	int i;
	for (i=0;i<(ptr->max);i++)
	{
		if (ptr->pointer[i]==nItem)
		{
			ptr->pointer[i]=-1;
		//	return;		// don't return here, let's remove ALL the occurences (Duke)
		}
	}
}

///////////////////////////
// Name:	SearchOwnedPets
// history:	by Duke, 24.12.2002
// Purpose:	simplyfies the access via cownsp and creates CHAR pointers
//			IMPORTANT: ci should point to a 0 at the start of the search
//
P_CHAR SearchOwnedPets(const int serial, int *ci)
{
	if (serial <0) return NULL; // crash avoidance
	int loopexit=0;
	while ( (*ci<cownsp[serial%HASHMAX].max) && (++loopexit < MAXLOOPS) ) 
	{
		int i=cownsp[serial%HASHMAX].pointer[*ci];
		(*ci)++;
		if (i>-1)
		{
			P_CHAR pc = MAKE_CHAR_REF(i);
			if (pc)
			{
				if (pc->ownserial==serial)
					return pc;
			}
		}
	}
	return NULL;
}

///////////////////////////
// Name:	SearchOwnedItems
// history:	by Duke, 3.3.2002
// Purpose:	simplyfies the access via ownsp and creates ITEM pointers
//			IMPORTANT: ci should point to a 0 at the start of the search
//
P_ITEM SearchOwnedItems(const int serial, int *ci)
{
	if (serial <0) return NULL; // crash avoidance
	int loopexit=0;
	while ( (*ci<ownsp[serial%HASHMAX].max) && (++loopexit < MAXLOOPS) ) 
	{
		int i=ownsp[serial%HASHMAX].pointer[*ci];
		(*ci)++;
		if (i>-1)
		{
			P_ITEM iItem = MAKE_ITEM_REF(i);
			if (iItem!=NULL)
			{
				if (iItem->ownserial==serial)
					return iItem;
			}
		}
	}
	return NULL;
}

///////////////////////////
// Name:	ContainerSearch
// history:	by Duke, 3.10.2000
// Purpose:	simplyfies the access via contsp and creates ITEM pointers
//			IMPORTANT: ci should point to a 0 at the start of the search
//
P_ITEM ContainerSearch(const int serial, int *ci)
{
	if (serial <0) return NULL; // crash avoidance
	int loopexit=0;
	while ( (*ci<contsp[serial%HASHMAX].max) && (++loopexit < MAXLOOPS) ) 
	{
		int i=contsp[serial%HASHMAX].pointer[*ci];
		(*ci)++;
		if (i>-1)
		{
			P_ITEM iItem = MAKE_ITEM_REF(i);
			if (iItem!=NULL)
			{
				if (iItem->contserial==serial)
					return iItem;
			}
		}
	}
	return NULL;
}

///////////////////////////
// Name:	ContainerSearchFor
// history:	by Duke, 14.12.2000
// Purpose:	simplyfies the access via contsp and creates ITEM pointers.
//			searches the container given by serial for items with the given id and (if given) color.
//			IMPORTANT: ci should point to a 0 at the start of the search
//
P_ITEM ContainerSearchFor(const int serial, int *ci, short id, short color)
{
	P_ITEM pi;
	int loopexit=0;
	while ( ((pi=ContainerSearch(serial,ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->id()==id &&	(color==-1 || pi->color()==color))
		return pi;
	}
	return NULL;
}

///////////////////////////
// Name:	ContainerCountItems
// history:	by Duke, 26.03.2001
// Purpose:	searches the container given by serial AND the subcontainers
//			for items with the given id and (if given) color.
//			Returns the total number of items found
//
int ContainerCountItems(const int serial, short id, short color, short type)
{
	int ci=0; 
	int total=0;
	P_ITEM pi;
	int loopexit=0;
	while ( ((pi=ContainerSearch(serial,&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->isType(ITY_Container))		// a subcontainer ?
		{
			total += ContainerCountItems(pi->serial, id, color, type);
			continue;
		}
		if ((id==-1 || pi->id()==id) &&
			(color==-1 || pi->color()==color) &&
			(type==-1 || pi->isType(type))) // added count by type support (thrawn)
			total += pi->amount;
	}
	return total;
}

///////////////////////////
// Name:	SearchSpawnedItems
// history:	by Duke, 18.4.2003
// Purpose:	simplyfies the access via spawnsp and creates ITEM pointers
//			IMPORTANT: ci should point to a 0 at the start of the search
//
P_ITEM SearchSpawnedItems(const int serial, int *ci)
{
	if (serial <0) return NULL; // crash avoidance
	int loopexit=0;
	while ( (*ci<spawnsp[serial%HASHMAX].max) && (++loopexit < MAXLOOPS) ) 
	{
		int i=spawnsp[serial%HASHMAX].pointer[*ci];
		(*ci)++;
		if (i>-1)
		{
			P_ITEM iItem = MAKE_ITEM_REF(i);
			if (iItem!=NULL)
			{
				if (iItem->spawnserial==serial)
					return iItem;
			}
		}
	}
	return NULL;
}

///////////////////////////
// Name:	SearchSpawnedChars
// history:	by Duke, 18.4.2003
// Purpose:	simplyfies the access via cspawnsp and creates P_CHAR pointers
//			IMPORTANT: ci should point to a 0 at the start of the search
//
P_CHAR SearchSpawnedChars(const int serial, int *ci)
{
	if (serial <0) return NULL; // crash avoidance
	int loopexit=0;
	while ( (*ci<cspawnsp[serial%HASHMAX].max) && (++loopexit < MAXLOOPS) ) 
	{
		int c=cspawnsp[serial%HASHMAX].pointer[*ci];
		(*ci)++;
		if (c>-1)
		{
			P_CHAR pc = MAKE_CHAR_REF(c);
			if (pc!=NULL)
			{
				if (pc->spawnserial==serial)
					return pc;
			}
		}
	}
	return NULL;
}

/////////////////////
// Name:	FindItemBySerial
// Purpose:	creates an item pointer from the given serial, returns NULL if not found
// History:	by Duke, 5.11.2000
//
P_ITEM FindItemBySerial(int serial)
{
	if (!isItemSerial(serial))
		return NULL;
	int i=findbyserial(&itemsp[serial%HASHMAX], serial, 0);
	if (i==-1) return NULL;		// legal rc from findbyserial, don't log
	return MAKE_ITEM_REF(i);
}
P_ITEM FindItemBySerPtr(unsigned char *p)
{
	int serial=LongFromCharPtr(p);
	if (!isItemSerial(serial)) return NULL;
	return FindItemBySerial(serial);
}

/////////////////////
// Name:	FindCharBySerial
// Purpose:	creates an chars pointer from the given serial, returns NULL if not found
// History:	by Duke, 11.11.2000
//			added BySerPtr Duke, 24.2.2001
//
P_CHAR FindCharBySerial(int serial)
{
	if (!isCharSerial(serial))
		return NULL;
	int i=findbyserial(&charsp[serial%HASHMAX], serial, 1);
	if (i==-1) return NULL;		// legal rc from findbyserial, don't log
	else return MAKE_CHARREF_LRV(i,NULL);
}
P_CHAR FindCharBySerPtr(unsigned char *p)
{
	int serial=LongFromCharPtr(p);
	if (!isCharSerial(serial)) return NULL;
	return FindCharBySerial(serial);
}

P_CHAR FindWearerOf(PC_ITEM pi)
{
	return FindCharBySerial(pi->contserial);
}

