/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "rectangle.h"
#include "wolfpack.h"	// just for min() & max()	:(
#include "debug.h"

#undef  DBGFILE
#define DBGFILE "rectangle.cpp"

/////////////////////
// Name:	cRectangle
// Purpose:	a rectangle for coordinates of type short
// Remark:	does not check if the coords are suitable for UO !
// History:	by Duke, 26.12.01
//

cRectangle::cRectangle()
{
	lowerLeftX=lowerLeftY=upperRightX=upperRightY=0;
}

cRectangle::cRectangle(short x1, short y1, short x2, short y2)
{
	init(x1,y1,x2,y2);
}

void cRectangle::init(short x1, short y1, short x2, short y2)
{
	lowerLeftX=min(x1,x2);
	lowerLeftY=min(y1,y2);
	upperRightX=max(x1,x2);
	upperRightY=max(y1,y2);
}

bool cRectangle::includes(short x, short y) const
{
	return (!(x < lowerLeftX || x > upperRightX || y < lowerLeftY || y > upperRightY) );
}

bool cRectangle::overlaps(cRectangle& other) const
{
	return ((this->includes(other.lowerLeftX, other.lowerLeftY)  )||
			(this->includes(other.lowerLeftX, other.upperRightY) )||
			(this->includes(other.upperRightX,other.lowerLeftY)	 )||
			(this->includes(other.upperRightX,other.upperRightY) ));
}



cMapRectangle::cMapRectangle()
{
	mapNo=0;
}

cMapRectangle::cMapRectangle(short x1, short y1, short x2, short y2, short map)
{
	init(x1,y1,x2,y2,map);
}

void cMapRectangle::init(short x1, short y1, short x2, short y2, short map)
{
	rect.init(x1,y1,x2,y2);
	mapNo = map;
}

bool cMapRectangle::includes(short x, short y, short map) const
{
	if (mapNo != map) return false;
	return rect.includes(x,y);
}

bool cMapRectangle::overlaps(cMapRectangle& other) const
{
	if (this->mapNo != other.mapNo) return false;
	return this->rect.overlaps(other.rect);
}


