/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//
// -- Region class  Added by Tauriel 3/6/1999 To lookup items by region
//	This should help for now. BTW- my first attempt at C++
//	So forgive any newbie mistakes :)
//	-- Side note, I wanted regions to be more generic, but
//	now that I have to do this, time doesn't allow for it yet.

#ifndef __REGION_H__
#define __REGION_H__

#include "typedefs.h"
#include "pointer.h"
#include "coord.h"


class cRegion
{
private:
	unsigned char GridSize;
	unsigned char ColSize;
//	lookuptr_st MapCells[33000]; //A very large pointer structure array
	lookuptr_st MapCells4Chars[33000]; //A very large pointer structure array
	lookuptr_st MapCells4Items[33000];

public:
	cRegion(); //constructor
	virtual ~cRegion(); //destructor
	unsigned int GetCell(unsigned int x, unsigned int y);
	void cRegion::Add(P_ITEM pi);
	void cRegion::Add(P_CHAR pc);
	SI16 AddItem(unsigned long nItem);
	void cRegion::Remove(PC_ITEM pi);
	void cRegion::Remove(P_CHAR pc);
	SI16 RemoveItem(unsigned long nItem);
	long GetNextItem(unsigned int cell, unsigned int Last);
	long GetNextChar(unsigned int cell, unsigned int Last);
	long GetItem(unsigned int cell, unsigned int item);
	long GetChar(unsigned int cell, unsigned int item);
	unsigned int GetColSize() const {return ColSize;};
	int myGridx(unsigned int x) {return x/GridSize;};
	int myGridy(unsigned int y) {return y/GridSize;};

};


const int CharacterOffset = 1000000;

enum RegionIteratorDomain { ItemsOnly, CharsOnly };
class RegionIterator
{
protected:
	int x, y, getcell, mapitemptr, mapitem;
	cCoord StartPos;
	RegionIteratorDomain domain;

public:
//	RegionIterator(int myX, int myY, RegionIteratorDomain dm);
	RegionIterator(const cCoord& pos, RegionIteratorDomain dm);
	virtual ~RegionIterator() { }

	int First();
	int Next();
	bool End();
	bool IsItem() const;
	bool IsChar() const;
	bool IsMulti() const;
	int GetX() const { return x; }
	int GetY() const { return y; }
};

class RegCellIterator4Items : public RegionIterator
{
public:
	RegCellIterator4Items(const cCoord& pos) : RegionIterator(pos,ItemsOnly) { }
	~RegCellIterator4Items() { }

	P_ITEM First();
	P_ITEM Next();
};

class RegCellIterator4Chars : public RegionIterator
{
public:
	RegCellIterator4Chars(const cCoord& pos) : RegionIterator(pos,CharsOnly) { }
	~RegCellIterator4Chars() { }

	P_CHAR First();
	P_CHAR Next();
};

class RegGrid3x3Iterator4Items : public RegionIterator
{
protected:
	int GridColSize;
	int orgCell;
	P_ITEM NextCell();
public:
	RegGrid3x3Iterator4Items(cCoord pos);
	~RegGrid3x3Iterator4Items() { }
	P_ITEM First();
	P_ITEM Next();
};

class RegGrid3x3Iterator4Chars : public RegionIterator
{
protected:
	int GridColSize;
	int orgCell;
	P_CHAR NextCell();
public:
	RegGrid3x3Iterator4Chars(cCoord pos);
	~RegGrid3x3Iterator4Chars() { }
	P_CHAR First();
	P_CHAR Next();
};

#endif
