/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __SCRIPTC_H__
#define __SCRIPTC_H__

#include "platform.h"
#include <sys/types.h>
#include <map>
#include <string>
using namespace std ;

class cCoord;
class cRectangle;
class cMapRectangle;

typedef unsigned long scpMark;

// One entry in the cache
struct ScriptEntry
{
	string name;
    unsigned long offset;
};


extern char script1[512];

enum  enScripts { items_script = 0,npc_script,create_script,regions_script,misc_script,skills_scriptnew,
			location_script,menus_script,spells_script,speech_script,tracking_script,
			newbie_script,titles_script,advance_script,trigger_script,ntrigger_script,
			wtrigger_script,necro_script,house_script,colors_script,spawn_script,
			html_script,metagm_script,polymorph_script,hard_items,custom_npc_script,
			custom_item_script,menupriv_script,carve_script,msgboard_script,
			fishing_script, gump_script, startlocs_scp, maps_scp, townhouse_scp,reserve_scp, 
			resources_scp, races_scp, NUM_SCRIPTS} ;

#define SCP_PRELOADABLE	0x0008
#define SCP_PRELOADED	0x0004

#ifndef _MSC_VER
typedef long int _off_t ;
#endif


class Script
{
public:
    Script(const char *_filename, short _flags=0);
	~Script();
	bool Open();
	void Close();
	Script* Select(char* sect, short custom);
	scpMark Suspend();
	void Resume(scpMark mark);
	bool NextLine();
	bool NextLineInSection();
	bool NextLineSplitted();
	int  CmpTok1(char* comp) {return strcmp(script1,comp);}
	
	bool EndSect() {return (script1[0]=='}');}
	bool find(const char *secname, const int secID);
	bool find(const char *section);
    char isin(const char *section);
	bool getKeyVal(const char* key, int* num);
	bool getKeyVal(const char* key, cCoord** pos);
	bool getKeyVal(const char* key, cRectangle** rect);
	bool getKeyVal(const char* key, cMapRectangle* mrect);
	bool getKeyVal(const char* key, char* name);
	bool getKeyVal(const char* key, short* Value);
	int  PickFromList();

	inline unsigned long getlastPosition(void) { return lp; } // for debugging only
    
private:
	bool preload();
    void reload();
	bool ReadMemLine();
	void MakeIndexForFile();
	void MakeIndexForMem();
    
	map<string, ScriptEntry> entries;
    time_t last_modification;
    char *filename;
	char *img;
	_off_t scpsize;
	char *curmempos;	// current read position for preloaded files
	short flags;
	unsigned long int lp;
};

// free functions
Script* findSection(enScripts scpID, char* sectName, int sectID);
Script* findSection(enScripts scpID, char* sectName);	// For loading sections that don't have numbers
#endif
