/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////
// Name:	scripts.cpp
// Purpose: functions that handle the timer controlled stuff
// History:	cut from wolfpack.cpp by Duke, 26.10.00
// Remarks:	not necessarily ALL those functions
//

#include "scripts.h"
#include "wolfpack.h"
#include "debug.h"

#undef  DBGFILE
#define DBGFILE "scripts.cpp"

void readscript () // Read a line from the opened script file
{
	int i, valid=0;
	char c;
	temp[0]=0;

	while(!valid)
	{
		i=0;
		if (feof(scpfile)) return;
		c=(char)fgetc(scpfile);
		while (c!=10)
		{
			if (c!=13)
			{
				temp[i]=c;
				i++;
			}
			if (feof(scpfile) || i>=512) { temp[0]='E'; temp[1]='O'; temp[2]='F'; temp[3]=0; return; } // quick hack to avoid server freezes if a script doesnt end with a return, LB
			c=(char)fgetc(scpfile);
		}
		temp[i]=0;
		valid=1;
		if (temp[0]=='/' && temp[1]=='/') valid=0;
		if (temp[0]=='{') valid=0;
		if (temp[0]==0) valid=0;
	}
}

bool openscript (char *name, bool shutdownonfail) // Open script file
{
	scpfile=fopen(name,"r") ;
	 
	if (scpfile==NULL )
	{
		if (!shutdownonfail)
			return false;

		LogWarningVar("file %s not found...",name);
		error=1;
		keeprun=0;
	}
	openings++;
	if (openings>1)
	{//AntiChrist
		sprintf(temp,"LoneWolf Script Manager ERROR: error opening %s ( openings: %i ). Last file: %s",name,openings,scpfilename);
		LogError(temp);
		openings=1;	//reset the counter to avoid follow-up msgs (Duke,25.4.01)
	}
	strcpy(scpfilename,name);
	return true;
}


void closescript ()
{
	//AntiChrist
	if (strlen(scpfilename)>0)
	{
		if (scpfile != NULL)	// if it's not open, don't close it and don't crash ! (Duke, 6.5.2001)
			fclose(scpfile);

		scpfile = NULL ;

		openings--;
		if (openings<0)
		{
			strcpy(temp,"LoneWolf Script Manager ERROR: openings<-1!!!");
			LogError(temp);
			openings=0;
		}
	} else
	{
		strcpy(temp,"LoneWolf Script Manager ERROR: no opened scripts to close!");
		LogError(temp);
	}
}

void read1 () // Read script line without splitting parameters
{
	readscript();
	strcpy(script1,temp);
}

void read2 () // Read line from script
{
	int i;
	readscript();
	i=0;
	script1[0]=0;
	script2[0]=0;

	while(temp[i]!=0 && temp[i]!=' ' && temp[i]!='=' && i<1024 )
	{
		i++;
	}

	strncpy(script1, temp, i);
	script1[i]=0;
	if (script1[0]!='}' && temp[i]!=0) strcpy(script2,(char*)( temp+i+1));
	return;
}

void readwscline () // Read line from *.WSC
{
	int i, valid=0;
	char c;
	temp[0]=0;
	while (!valid)
	{
		i=0;
		if (feof(wscfile)) return;
		c=(char)fgetc(wscfile);
		while (c!=10)
		{
			if (c!=13)
			{
				temp[i]=c;
				i++;
			}
			if (feof(wscfile) || i>=512 ) return;
			c=(char)fgetc(wscfile);
		}
		temp[i]=0;
		valid=1;
		if (temp[0]=='/' && temp[1]=='/') valid=0;
		if (temp[0]=='{') valid=0;
		if (temp[0]==0) valid=0;
		if (temp[0]==10) valid=0;
		if (temp[0]==13) valid=0;
	}
}

// reads the ENTIRE line, spaces + ='s DONT't tokenize the line, but sections, line feeds etc are ignored
// LB
void readFullLine ()
{
	int i=0;
	readwscline();
	script1[0]=0;
	while(temp[i]!=0  && i<1024 ) i++;
	strncpy(script1,(char*) temp, i);
	script1[i]=0;	
	return;
}

void readw2 ()
{
	int i=0;

	readwscline();
	script1[0]=0;
	script2[0]=0;
	script3[0]=0;
	while(temp[i]!=0 && temp[i]!=' ' && temp[i]!='=' && i<1024 ) i++;
	strncpy(script1,(char*) temp, i);
	script1[i]=0;
	if (script1[0]!='}' && temp[i]!=0) strcpy(script2, (char*)(temp+i+1));
	return;
}


void readw3 ()
{
	int i=0,j;

	readwscline();
	script1[0]=0;
	script2[0]=0;
	script3[0]=0;
	while(temp[i]!=0 && temp[i]!=' ' && temp[i]!='=' && i<1024 ) i++;
	strncpy(script1, temp, i);
	script1[i]=0;
	if (script1[0]=='}' || temp[i]==0) return;
	i++;
	j=i;
	while(temp[i]!=0 && temp[i]!=' ' && temp[i]!='=' && i <1024 ) i++;
	strncpy(script2, (char*)(temp+j), i-j);
	script2[i-j]=0;
	strcpy((char*)script3, (char*)(temp+i+1));
}


void gettokennum(char * s, int num)
{
	int i, j;

	memset(&gettokenstr[0], 0, 255);

	i=0;

	int loopexit=0;
	while(num!=0 && (++loopexit < MAXLOOPS) )
	{
		if (s[i]==0)
		{
			num--;
		}
		else
		{
			if (s[i]==' ' && i!=0 && s[i-1]!=' ')
			{
				num--;
			}
			i++;
		}
	}
	j=0;

	loopexit=0;
	while(num!=-1 && (++loopexit < MAXLOOPS) )
	{
		if (s[i]==0)
		{
			num--;
		}
		else
		{
			if (s[i]==' ' && i!=0 && s[i-1]!=' ')
			{
				num--;
			}
			else
			{
				gettokenstr[j]=s[i];
				j++;
			}
			i++;
		}
	}
}

// Added by Krozy on 7-Sep-98
// New getstatskillvalue function.
// Takes a string, gets the tokens.
// If its one value - It returns that value.
// If its two values - It gets a random number between the values
int getstatskillvalue(char *stringguy)
{
	char values[512];
	int lovalue,hivalue,retcode;

	strcpy(values, stringguy);
	gettokennum(values, 0);
	lovalue=str2num(gettokenstr);
	gettokennum(values, 1);
	hivalue=str2num(gettokenstr);

	if (hivalue)
	{
		retcode = RandomNum(lovalue, hivalue);
	}
	else
	{
		retcode = lovalue;
	}
	return retcode;
}

void LoadCustomScripts()
{
	int i=0;
	Script *pScp;

	pScp=i_scripts[npc_script];
	pScp->Open();
	do
	{
		pScp->NextLineSplitted();
		if (!pScp->CmpTok1("CUSTOM_NPC_SCRIPT")) strcpy(n_scripts[custom_npc_script],script2);
		i++;
	} while (n_scripts[custom_npc_script][0]==0 && i<10);
	pScp->Close();

	if (n_scripts[custom_npc_script][0]!=0)
		i_scripts[custom_npc_script]=new Script(n_scripts[custom_npc_script]);

	i=0;
	pScp=i_scripts[items_script];
	pScp->Open();
	do
	{
		pScp->NextLineSplitted();
		if (!pScp->CmpTok1("CUSTOM_ITEM_SCRIPT")) strcpy(n_scripts[custom_item_script],script2);
		i++;
	} while (n_scripts[custom_item_script][0]==0 && i<10);
	pScp->Close();

	if (n_scripts[custom_item_script][0]!=0)
		i_scripts[custom_item_script]=new Script(n_scripts[custom_item_script]);
}

