/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#include "skills.h"

#include "basics.h"
#include "combat.h"
#include "im.h"
#include "itemid.h"
#include "magic.h"
#include "magic_new.h"
#include "spells.h"
#include "npcinfo.h"
#include "regions.h"
#include "SndPkg.h"
#include "TmpEff.h"
#include "tiledata.h"
#include "network.h"

#include "wolfpack.h"

#include "debug.h"
#undef DBGFILE
#define DBGFILE "skills.cpp"


//int goldsmithing;
//1=iron, 2=golden, 3=agapite, 4=shadow, 5=mythril, 6=bronze, 7=verite, 8=merkite, 9=copper, 10=silver
int ingottype=0;//will hold number of ingot type to be deleted

//////////////////////////
// Function:	CalcRank
// History:		24 Agoust 1999 created by Magius(CHE)
//				16.9.2000 revamped a bit (Duke)
//
// Purpose:		calculate item rank based on player' skill.
//
int cSkills::CalcRank(int s,P_CHAR Player,int skill)
{
	if (!Player) return 10;
	int rank;

	float sk_range=(float) 50.00 + Player->Skill(skill) - itemmake[s].minskill;
	if (sk_range<=0)
		rank=itemmake[s].minrank;
	else if (sk_range>=1000)
		rank=itemmake[s].maxrank;

	float randnum = static_cast<float>(rand()%1000);
	if (randnum <= sk_range)
		rank = itemmake[s].maxrank;
	else
	{
		float randnum1;
		if (SrvParms->skilllevel==11)
			randnum1=(float) (rand()%1000);
		else
			randnum1=(float) (rand()%1000)-((randnum-sk_range)/(11-SrvParms->skilllevel));

		int rk_range=itemmake[s].maxrank-itemmake[s].minrank;
		rank=(int) (randnum1*rk_range)/1000;
		rank+=itemmake[s].minrank-1;
		if (rank>itemmake[s].maxrank) rank=itemmake[s].maxrank;
		if (rank<itemmake[s].minrank) rank=itemmake[s].minrank;
	}
	return rank;
}

//////////////////////////
// Function:	ApplyRank
// History:		24 Agoust 1999 created by Magius(CHE)
//				16.9.2000 removed array access and revamped a bit (Duke)
//
// Purpose:		modify variables base on item's rank.
//
void cSkills::ApplyRank(UOXSOCKET s,P_ITEM pi,int rank)
{
	if (!pi) return;
	if (SrvParms->rank_system==0) return;

	if (SrvParms->rank_system==1)
	{
		pi->rank=rank;
		// Variables to change: LODAMAGE,HIDAMAGE,ATT,DEF,HP,MAXHP
		if (pi->lodamage>0) pi->lodamage=(rank*pi->lodamage)/10;
		if (pi->hidamage>0) pi->hidamage=(rank*pi->hidamage)/10;
		if (pi->att>0) pi->att=(rank*pi->att)/10;
		if (pi->def>0) pi->def=(rank*pi->def)/10;
		if (pi->hp>0) pi->hp=(rank*pi->hp)/10;
		if (pi->maxhp>0) pi->maxhp=(rank*pi->maxhp)/10;
		switch(rank)
		{
			case 1: sysmessage(s,"You made an item with no quality!"); break;
			case 2: sysmessage(s,"You made an item very below standard quality!");break;
			case 3: sysmessage(s,"You made an item below standard quality!");break;
			case 4: sysmessage(s,"You made a weak quality item!");break;
			case 5: sysmessage(s,"You made a standard quality item!");break;
			case 6: sysmessage(s,"You made a nice quality item!");break;
			case 7: sysmessage(s,"You made a good quality item!");break;
			case 8: sysmessage(s,"You made a great quality item!");break;
			case 9: sysmessage(s,"You made a beautiful quality item!");break;
			case 10: sysmessage(s,"You made a perfect quality item!");break;
		}
	}
	else
		pi->rank=rank;
}

////////////////
// name:	cSkills::Zero_Itemmake(int s)
// history:	by Magius(CHE),24 Agoust 1999
// Purpose:	Resets all values into itemmake[s].
//
void cSkills::Zero_Itemmake(int s)
{
	itemmake[s].has=0;
	itemmake[s].has2=0;
	itemmake[s].needs=0;
	itemmake[s].minskill=0;
	itemmake[s].maxskill=0;
	itemmake[s].Mat1id=0;		// id of material used to make item
	itemmake[s].Mat1color=-1;	// color of material doesn't matter by default (Duke)
	itemmake[s].Mat2id=0;		// id of second material used to make item		(vagrant)
	itemmake[s].Mat2color=-1;	// color of material doesn't matter by default
	itemmake[s].minrank=10; // value of minum rank level of the item to create! - Magius(CHE)
	itemmake[s].maxrank=10; // value of maximum rank level of the item to create! - Magius(CHE)
	itemmake[s].number=0; // scp number of the item - used to regognize the item selected and apply Magius(CHE) rank!
}

////////////////
// name:	Skills->MakeMenutarget(int s,int x,int skill)
// history:	by Unknown
// Purpose:	create a specified menuitem target.
//
typedef int SOCK;

class cMMTsmith;		// forward declaration for cMMT factory

class cMMT				// MakeMenuTarget
{
protected:
	char* failtext;
	short badsnd1;
	short badsnd2;
public:
	cMMT(short badsnd=0, char *failmsg="You fail to create the item.")
	{
		badsnd1=badsnd>>8;
		badsnd2=badsnd&0x00FF;
		failtext=failmsg;
	}
	virtual void deletematerial(SOCK s, int amount)
	{
		P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
		P_ITEM pPack=Packitem(Player);
		if (!pPack) return;
		int amt = max(amount, 1);

		pPack->DeleteAmount(amt,itemmake[s].Mat1id,itemmake[s].Mat1color);
		if (itemmake[s].Mat2id)						// if a 2nd material is used, delete that too
			pPack->DeleteAmount(amt,itemmake[s].Mat2id,itemmake[s].Mat2color);
	}
	virtual void delonfail(SOCK s)		{deletematerial(s, itemmake[s].needs/2);}
	virtual void delonsuccess(SOCK s)	{deletematerial(s, itemmake[s].needs);}
	virtual void playbad(SOCK s)		{soundeffect(s,badsnd1,badsnd2);}
	virtual void failmsg(SOCK s)		{sysmessage(s,failtext);}
	virtual void failure(SOCK s)		{delonfail(s);playbad(s);failmsg(s);}
	static cMMT* factory(short skill);
};

class cMMTsmith : public cMMT		// MakeMenuTarget for Smithing
{
public:
	cMMTsmith(short badsnd=0x002A) : cMMT(badsnd) {}
	virtual void deletematerial(SOCK s, int amount)
	{
		P_ITEM Pack=Packitem(MAKE_CHAR_REF(currchar(s)));
		if (!Pack) return;
		amount=(amount>0 ? amount : 1);
		Pack->DeleteAmount(amount, 0x1BF2, ingottype);	// ingottype is now the color of the ingot
		/*switch(ingottype)
		{
			case 1: Pack->DeleteAmount(amount, 0x1BF2, 0x0961); break;//delete iron
			case 2: Pack->DeleteAmount(amount, 0x1BF2, 0x0466); break;//delete golden
			case 3: Pack->DeleteAmount(amount, 0x1BF2, 0x0150); break;//delete agapite
			case 4: Pack->DeleteAmount(amount, 0x1BF2, 0x0386); break;//delete shadow
			case 5: Pack->DeleteAmount(amount, 0x1BF2, 0x0191); break;//delete mythril
			case 6: Pack->DeleteAmount(amount, 0x1BF2, 0x02E7); break;//delete bronze
			case 7: Pack->DeleteAmount(amount, 0x1BF2, 0x022F); break;//delete verite
			case 8: Pack->DeleteAmount(amount, 0x1BF2, 0x02C3); break;//delete merkite
			case 9: Pack->DeleteAmount(amount, 0x1BF2, 0x046E); break;//delete copper
			case 10:Pack->DeleteAmount(amount, 0x1BF2, 0x0000); break;//delete silver
		}*/
		ingottype=0;
	}
};

cMMT* cMMT::factory(short skill)
{
	switch (skill)
	{
		case BLACKSMITHING:	return new cMMTsmith(0x002A);break; 
		case CARPENTRY:		return new cMMT(0x023D);break; 
		case INSCRIPTION:	return new cMMT(585,"You fail to inscribe the spell");break; 
		case TAILORING:		return new cMMT(0x0248);break;
		case BOWCRAFT:		return new cMMT(0x0051);break;
		case TINKERING:		return new cMMT(0x002A);break;
		default:			return new cMMT(0x0000);break;	// a generic handler
	}
}

void cSkills::MakeMenuTarget(int s, int x, int skill)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int rank=10; // For Rank-System --- Magius(he)
	cMMT *targ = cMMT::factory(skill);
	
	// exploit fix - detects if they took the material out of their
	// backpack while the makemenu was active (Duke, 25.11.2000)
	int amt=Player->CountItems(itemmake[s].Mat1id);
	if ( amt < itemmake[s].needs && !Player->isGM() )
	{
		sysmessage(s,"You do not have enough resources anymore!!");
		return;
	}
	
/*
	By Polygon:
	When doing cartography, check if empty map is still there
*/
	if (skill == CARTOGRAPHY)	// Is it carto?
	{
		if (!HasEmptyMap(Player))	// Did the map disappear?
		{
			sysmessage(s,"You don't have your blank map anymore!!");
			return;
		}
	}
//	END OF: By Polygon

	if (!Player->isGM()) //GM cannot fail! - AntiChrist
	{
		LogAssert(itemmake[s].maxskill!=0);
		if (!Player->checkSkill(skill, itemmake[s].minskill, itemmake[s].maxskill))
		{
			// Magius(CHE) 
			// With these 2 lines if you have a resouce item with
			// Amount=1 and fail to work on it, this resouce will be
			// Removed anyway. So noone can increase his skill using
			// a single resource item.
			int tmpneed=itemmake[s].needs/2; // Magius(CHE) 
			if (tmpneed==0) itemmake[s].needs++; // Magius(CHE) 
			switch(skill) 
			{
			case BLACKSMITHING:
			case CARPENTRY:
			case INSCRIPTION:
			case TAILORING:
			case BOWCRAFT:
			case TINKERING:
				targ->failure(s);
				break;
			case CARTOGRAPHY:	//Polygon: Do sounds, message and deletion if carto fails
				DelEmptyMap(Player);
				soundeffect(Player, 0x0249);
				sysmessage(s, "You scratch on the map but the result is unusable");
				break;
			default:
				targ->failure(s);
				break;
			}
			Zero_Itemmake(s);
			return;
		}
	}

	switch(skill)
	{	
	case BLACKSMITHING:	targ->delonsuccess(s);	break;
	case CARPENTRY:		targ->delonsuccess(s);break;
	case INSCRIPTION:	Player->deleteItems(1, itemmake[s].Mat1id); break;//don't use default, cauz we delete 1 scroll //use materialid
		//case TAILORING: delequan(cc, itemmake[s].materialid1,itemmake[s].materialid2, itemmake[s].needs);break;	//same as default skill
	case TINKERING:
	case BOWCRAFT:	targ->delonsuccess(s);break;
		// Polygon: Delete empty map for carto
	case CARTOGRAPHY:	if (!DelEmptyMap(Player)) return;break;
	default:
		Player->deleteItems(itemmake[s].needs, itemmake[s].Mat1id);
	}
	itemmake[s].Mat1id=0;
	P_ITEM pi=Items->SpawnItemBackpack2(s, x);
	if (!pi)
	{
		LogWarningVar("bad script item # %d(Item Not found).", x);
		return;	//invalid script item
	} 
	// Starting Rank System Addon, Identify Item and Store the Creator Name- by Magius(CHE)
	if (pi->name2 && (strcmp(pi->name2,"#"))) 
		strcpy(pi->name,pi->name2); // Item identified! - }
	if (SrvParms->rank_system==1) rank=CalcRank(s,Player,skill);
	else if (SrvParms->rank_system==0) rank=10;
	ApplyRank(s,pi,rank);
	
	if (!Player->isGM())		//AntiChrist - do this only if not a GM! bugfix - to avoid "a door mixed by GM..."
	{
		strcpy(pi->creator,Player->name); // Memorize Name of the creator
		if (Player->Skill(skill)>950)
			pi->madewith=skill+1; // Memorize Skill used
		else
			pi->madewith=0-skill-1; // Memorize Skill used
	}
	else
	{
		pi->creator[0]='\0';
		pi->madewith=0;
	}
	// End Rank System Addon
	
	pi->setAllwaysMovable(); // JM's bugfix
	
	if (skill == BLACKSMITHING			// let's see if we can make exceptional quality
		&& SrvParms->rank_system==0)	// this would interfer with the rank system
	{
		int modifier = 1;
		int skmin = itemmake[s].minskill;
		int skdif = Player->Skill(skill)-skmin;
		if (   skdif > 0 && skmin!=1000			// just to be sure ...
			&& skmin >= 500						// only for higher level items
			&& skdif > (rand()%(1000-skmin)))	// 1st test depends on how far the players
		{										// skill is above the requirements
			
			if (!(rand()%10)) modifier=10;		// 10% chance for 10% more
			if (!(rand()%100)) modifier=5;		// 1% chance for 20% more
			if (!(rand()%1000)) modifier=2;		// only one in a thousand for 50% more
			if (modifier > 1)
			{
				char p1[50], p2[50], p3[50], p4[50];
				unsigned int spaceleft=0;				// for space left in name field
				if (pi->name[0]=='#')
				{
					char tmp[100];
					pi->getName(tmp);				// get the name from tile data
					strcpy(pi->name,(char*)tmp);
				}
				spaceleft = sizeof(pi->name)-strlen(pi->name);
				switch (modifier)
				{
				case 10: strcpy(p1, " of high quality"); strcpy(p2," of h.q."); strcpy(p3,"(hQ)"); break;
				case  5: strcpy(p1 ," of very high quality"); strcpy(p2, " of v.h.q."); strcpy(p3, "(vhQ)"); break;
				case  2: strcpy(p1, " of exceptional quality"); strcpy(p2, " of e.q."); strcpy(p3, "(eQ)"); break;
				}
				if (strlen(p1) < spaceleft) strcpy(p4, p1);
				else if (strlen(p2) < spaceleft) strcpy(p4, p2);
				else if (strlen(p3) < spaceleft) strcpy(p4, p3);
				strcat(pi->name,p4);	// append name extension
				
				pi->hp += pi->hp / modifier;
				pi->maxhp = pi->hp;
				pi->def += pi->def / modifier;
				pi->att += pi->att / modifier;
				pi->lodamage += pi->lodamage / modifier;
				pi->hidamage += pi->hidamage / modifier;
			}
		}
	}
	
	if (skill==MINING) soundeffect(Player,0x0054); // Added by Magius(CHE)
	if (skill==BLACKSMITHING) soundeffect(Player,0x002a);
	if (skill==CARPENTRY) soundeffect(Player,0x023d);
	if (skill==INSCRIPTION) soundeffect(Player,0x0249);
	if (skill==TAILORING) soundeffect(Player,0x0248);
	if (skill==TINKERING) soundeffect(Player,0x002A);
	// Polygon: Do the cartography sound
	if (skill==CARTOGRAPHY) soundeffect(Player, 0x0249);
	
	if (skill == TAILORING) // -Fraz- Implementing color remembrance for tailored items
	{
		if (!pi->color())		// if the new item did not receive a color from the scripts
		{
			pi->setColor(itemmake[s].newColor);	// use color of material
			pi->refresh();
		}
	}
	sysmessage(s,"You create the item and place it in your backpack.");
	//		itemmake[s].has=0;
	//		itemmake[s].has2=0;
	/*		
	Code added by Polygon
	Creates a key for every chest-container
	and puts it in the chest
	*/
	if (IsChest(pi->id()))
	{
//		removed the double skill check, creating chests should be much harder then creating keys (Thrawn)
//		LogAssert(itemmake[s].maxskill!=0);
//		if (Player->checkSkill(TINKERING, itemmake[s].minskill, itemmake[s].maxskill) || Player->isGM())
//		{
			pi->setMore1_4(pi->serial);		// Store the serial number in the more-value needed as unique lock-ID
			P_ITEM pik=Items->CreateScriptItem(-1, SNI_Key, 1);
			if (!pik) return;
			pik->setType(ITY_Key);					// Item is a key
			pik->setMore1_4(pi->getMore1_4());		// Copy the lock-number to the keys more-variable to make it fit the lock
			strcpy(pik->creator,Player->name);		// Store the creator
			pik->SetContSerial(pi->serial);			// Set the container
			pik->SetRandPosInCont(pi);				// Put the damn thing in the container
			pik->refresh();							// Refresh it
			sysmessage(s, "You create a corresponding key and put it in the chest");
//		}
	}
	//		End of: By Polygon
	statwindow(s,Player);
	Zero_Itemmake(s);
	/*
	By Polygon:
	Give the map the correct attributes so that it
	shows the correct part of the map and has correct size
	*/
	if ((x>70000) && (x < 70013)) // Is it a map?
	{
		int tlx, tly, lrx, lry;	// Tempoarly storing of topleft and lowright x,y
		if (x<70004)	// Is it a detail map? do +-250 from pos
		{
			tlx = Player->pos.x - 250;
			tly = Player->pos.y - 250;
			lrx = Player->pos.x + 250;
			lry = Player->pos.y + 250;
		}
		else if (x<70007)	// Is it a regional map? do +-500 from pos
		{
			tlx = Player->pos.x - 500;
			tly = Player->pos.y - 500;
			lrx = Player->pos.x + 500;
			lry = Player->pos.y + 500;
		}
		else if (x<70010)	// Is it a land map? do +-1000 from pos
		{
			tlx = Player->pos.x - 1000;
			tly = Player->pos.y - 1000;
			lrx = Player->pos.x + 1000;
			lry = Player->pos.y + 1000;
		}
		else				// So it's a worldmap eh?
		{
			tlx = 0;
			tly = 0;
			lrx = 0x13FF;
			lry = 0x0FFF;
		}
		// Check if we are over the borders and correct errors
		if (tlx < 0)	// Too far left?
		{
			lrx -= tlx;	// Add the stuff too far left to the right border (tlx is neg. so - and - gets + ;)
			tlx = 0;	// Set tlx to correct value
		}
		else if (lrx > 0x13FF) // Too far right?
		{
			tlx -= lrx - 0x13FF;	// Subtract what is to much from the left border
			lrx = 0x13FF;	// Set lrx to correct value
		}
		if (tly < 0)	// Too far top?
		{
			lry -= tly;	// Add the stuff too far top to the bottom border (tly is neg. so - and - gets + ;)
			tly = 0;	// Set tly to correct value
		}
		else if (lry > 0x0FFF) // Too far bottom?
		{
			tly -= lry - 0x0FFF;	// Subtract what is to much from the top border
			lry = 0x0FFF;	// Set lry to correct value
		}
		// Set the map data
		pi->setMore1_2(tlx);	// Set topleft x
		pi->setMore3_4(tly);	// Set topleft y
		pi->setMoreB1_2(lrx);	// Set lowright x
		pi->setMoreB3_4(lry);	// Set lowright y
	}
	//		END OF: By Polygon
}

void cSkills::MakeMenu(int s, int m, int skill) // Menus for playermade objects
{ // s - character online #, m - menu to use, skill - skill being used
	int total, i;
	int lentext;
	char sect[512];
	SecVec<string>gmtext;
	SecVec<int>gmid;
	char str[257];
	string title;
	int gmnumber=0;
	int gmindex;
	int minres=0; // To calculate minimum resources required! By Magius(CHE) for Rank System
	int minskl=0; // To calculate minimum skill required! By Magius(CHE) for Rank System
	//int tmpgmnumber=0; // By Magius(CHE) for Rank System
	make_st *imk=&itemmake[s];

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	Player->making=skill;
	
	Script *pScp=i_scripts[create_script];
	if (!pScp->Open()) return;
	sprintf(sect, "MAKEMENU %i", m);
	if (!pScp->find(sect)) 
	{
		pScp->Close();
		return;
	}
	gmindex=m;
	pScp->NextLine();
	
	title=script1;

	pScp->NextLineSplitted();
	int loopexit=0;
	do
	{
		if (script1[0]!='}')
		{
			char tmp[99];		
		    gmnumber++;		
			gmid.push_back(hstr2num(script1));
			gmtext.push_back(script2);

			pScp->NextLineSplitted();
			if (pScp->CmpTok1("RESOURCE"))
			{
				sprintf(tmp,"create.scp, MAKEMENU %i: Expected 'RESOURCE <num>' after '%s'!", m,gmtext.back().c_str());
				LogWarning(tmp);
				pScp->Close();
				return;
			}

			imk->needs=str2num(script2);

			pScp->NextLineSplitted();
			imk->minskill=str2num(script2);
			imk->maxskill=imk->minskill*SrvParms->skilllevel; // by Magius(CHE)

			if (strcmp(script1,"SKILL"))
			{
				sprintf(tmp,"create.scp, MAKEMENU %i: Expected 'SKILL <num>' after 'RESOURCE %i'!", m,imk->needs);
				LogWarning(tmp);
				pScp->Close();
				return;
			}
			
			 char append[20];
			 sprintf(append, " - [%d/%d.%d]", imk->needs,imk->minskill/10,imk->minskill%10);					
			 gmtext.back()+=append;			
			

			if (imk->maxskill<200) imk->maxskill=200;

			if (imk->has < imk->needs ||
				(imk->has2 && imk->has2<imk->needs) ||
				Player->Skill(skill) < imk->minskill )
			{
				gmnumber--;
				gmtext.pop_back();
				gmid.pop_back();
			}
			 

			pScp->NextLineSplitted();
			imk->number=str2num(script2);
			if (minres>imk->needs || !minres) minres=imk->needs;
			if (minskl>imk->minskill || !minskl) minskl=imk->minskill;
			if (strcmp(script1,"ADDITEM") && strcmp(script1,"MAKEMENU") && strcmp(script1,"GOPLACE"))
			{
				sprintf(tmp,"create.scp, MAKEMENU %i: Expected 'ADDITEM/MAKEMENU <num>' after 'SKILL %i'!", m,imk->minskill);
				LogWarning(tmp);
				pScp->Close();
				return;
			}
		
			pScp->NextLineSplitted();
			if (!strcmp(script1,"RANK"))	// Item Rank System - by Magius(CHE)
			{
				gettokennum(script2, 0);
				imk->minrank=str2num(gettokenstr);
				gettokennum(script2, 1);
				imk->maxrank=str2num(gettokenstr);
				pScp->NextLineSplitted();
			} else 
			{ // Set maximum rank if the item is not ranked!
				imk->minrank=10;
				imk->maxrank=10;
			}
			if (SrvParms->rank_system==0)
			{
				imk->minrank=10;
				imk->maxrank=10;
			}
		}
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );
	pScp->Close();

	if (!gmnumber) 
	{
		sysmessage(s,"You aren't skilled enough to make anything with what you have.");
		return; 
	}

	sprintf(temp, "%i: %s", m, title.c_str());
	title=temp;
	int sz=title.size();
	lentext=min(sz,256);
	total=9+1+lentext+1;
	for (i=0;i<gmnumber;i++)
	{
		sz=gmtext[i].size();
		total+=4+1+min(sz,256);
	}

	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};

	XStartPkt(0x7c, total);

	LongToCharPtr(Player->serial,&gmprefix[3]); // menu ID, so player serial works
	ShortToCharPtr((gmindex+MAKEMENUOFFSET), &gmprefix[7]);

	XAddPkt((unsigned char*)&gmprefix[0+3],9-3);
	XAddPkt((unsigned char*)&lentext, 1);

	strncpy(str, title.c_str(),257);
	XAddPkt((unsigned char*)&str, min(lentext,256));

	XAddPkt((unsigned char*)&gmnumber, 1);

	for (i=0;i<gmnumber;i++)
	{	

		ShortToCharPtr(gmid[i], &gmmiddle[0]);

		XAddPkt(&gmmiddle[0], 4); // #0+#1 -> id, 2+3 color, init'ed to 0

		sz=gmtext[i].size();
		lentext=min(sz,256);

		XAddPkt((unsigned char*)&lentext, 1);

		strncpy(str, gmtext[i].c_str(), 257);
		XAddPkt((unsigned char*)&str, lentext);
	}

	XFinishPkt(s);

	targetok[s]=1; 
}

void cSkills::Hide(int s) 
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	P_CHAR Attacker = Player->getAttacker();
	if (Attacker && inrange1p(Player, Attacker)) 
	{ 
		sysmessage(s, "You cannot hide while fighting."); 
		return; 
	} 
	
	if (Player->isHiddenBySkill()) 
	{ 
		sysmessage(s, "You are already hidden"); 
		return; 
	} 
	
	if (!Player->checkSkill(HIDING)) 
	{ 
		sysmessage(s, "You are unable to hide here."); 
		return; 
	} 
	
	if (Player->isGM()) // add flamestrike effect for gms, LB 
	{ 
		////////////////////////////////// 
		// Change FS delay 
		// 
		// 
		staticeffect(Player, 0x3709, 0x09, 0x19); 
		soundeffect2(Player, 0x0208); 
		tempeffect(Player, TEF_HideGM, 1, 0, 0); 
		// immediate hiding overwrites the effect. 
		// so lets hide after 4 secs. 
		// 1 sec works fine now so changed to this. 
		return; 
		// 
		// 
		// Aldur 
		////////////////////////////////// 
	}
	else //if not a GM check if have light source eqqiped
	{ 
		int ci=0,loopexit=0;
		P_ITEM pi;
		while ( ((pi=Player->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
		{
			if (TileData->isLightSourceItem(pi->id()))
			{	
				sysmessage(s,"You can't hide with a light source equipped!");
				return;
			}
		}
	}
	sysmessage(s, "You have hidden yourself well."); 
	Player->hide(); 
	SndRemoveNpcToAll(Player);
	updatechar(Player); 
}

void cSkills::Stealth(int s)//AntiChrist
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (Player->hidden==0)
	{
		sysmessage(s,"You must hide first.");
		return;
	}
	if (Player->Skill(HIDING)<700)
	{
		sysmessage(s,"You are not hidden well enough. Become better at hiding.");
		Player->unhide();
		return;
	}
	if (!Player->checkSkill(STEALTH)) 
	{
		Player->unhide();
		return;
	}
	sprintf(temp,"You can move %i steps unseen.", ((SrvParms->maxstealthsteps*Player->Skill(STEALTH))/1000));
	sysmessage(s,temp);
	Player->hide();
	Player->stealth=0; //AntiChrist -- init. steps already done
	updatechar(Player);
}

void cSkills::PeaceMaking(int s)
{
	P_ITEM Inst=Skills->GetInstrument(s);
	if (!Inst) 
	{
		sysmessage(s, "You do not have an instrument to play on!");
		return;
	}
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int res1=Player->checkSkill(PEACEMAKING);
	int res2=Player->checkSkill(MUSICIANSHIP);
	if (res1 && res2)
	{
		Skills->PlayInstrumentWell(s, Inst);
		sysmessage(s, "You play your hypnotic music, stopping the battle.");
		
		cChar* pc;
		int loopexit=0;
		RegGrid3x3Iterator4Chars rg3ic(Player->pos);
		while((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
		{
			if (inrange1p(pc, Player) && pc->war)
			{
				int j=pc->calcSocket();
				if (j!=-1)
					if (perm[j]) sysmessage(j, "You hear some lovely music, and forget about fighting.");
					if (pc->war) npcToggleCombat(pc);
					pc->ResetTarget();
					pc->setAttacker(NULL);
					pc->resetAttackFirst();
			}
		}
	} 
	else 
	{
		Skills->PlayInstrumentPoor(s, Inst);
		sysmessage(s, "You attempt to calm everyone, but fail.");
	}
}

void cSkills::PlayInstrumentWell(int s, P_ITEM Instrument)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	short snd = 0x38;
	switch(Instrument->id())
	{
	case 0x0E9C: snd=0x0038;	break;
	case 0x0E9D:
	case 0x0E9E: snd=0x0052;	break;
	case 0x0EB1:
	case 0x0EB2: snd=0x0045;	break;
	case 0x0EB3:
	case 0x0EB4: snd=0x004C;	break;
	default:
		LogError("switch reached default");
	}
	soundeffect2(Player, snd);
}

void cSkills::PlayInstrumentPoor(int s, P_ITEM Instrument)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	short snd = 0x39;
	switch(Instrument->id())
	{
	case 0x0E9C: snd=0x0039;	break;
	case 0x0E9D:
	case 0x0E9E: snd=0x0053;	break;
	case 0x0EB1:
	case 0x0EB2: snd=0x0046;	break;
	case 0x0EB3:
	case 0x0EB4: snd=0x004D;	break;
	default:
		LogError("switch reached default");
	}
	soundeffect2(Player, snd);
}

P_ITEM cSkills::GetInstrument(int s)
{
	P_CHAR Player = MAKE_CHARREF_LRV(currchar(s),NULL);

	P_ITEM Pack = Packitem(Player);
	if (!Pack) return NULL;

	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if ( IsInstrument(pi->id()) )
		{
			return pi;
		}
	}
	return NULL;
}

//////////////////////////////
// name:	DoOnePotion
// history: Duke,20.04.2000
// Purpose:	helper function for DoPotion
//			checks if player has enough regs for selected potion and deletes them
//
static bool DoOnePotion(int s,short regid, int regamount, char* regname)
{
	P_CHAR Player = MAKE_CHARREF_LRV(currchar(s),false);

	if (Player->CountItems(regid) >= regamount)
	{
		sprintf(temp, "*%s starts grinding some %s in the mortar.*", Player->name, regname);
		npcemoteall(Player, temp,1); // LB, the 1 stops stupid alchemy spam
		Player->deleteItems(regamount,regid);
		return true;
	}
	else
	{
		sysmessage(s, "You do not have enough reagents for that potion.");
		return false;
	}
}

///////////////////////////
// name:	DoPotion
// history: unknown, revamped by Duke,21.04.2000
// Purpose:	determines regs and quantity, creates working sound and
//			indirectly calls CreatePotion on success
//
void cSkills::DoPotion(int s, int type, int sub, P_ITEM Mortar)
{
	if (!Mortar) return;
	if (sub == 0)	// user cancelled second alchemy menu 
		return;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	bool success=false;
	
	switch((type*10)+sub)
	{
	case 11: success=DoOnePotion(s,0x0F7B, 1,"blood moss");		break;//agility
	case 12: success=DoOnePotion(s,0x0F7B, 3,"blood moss");		break;//greater agility
	case 21: success=DoOnePotion(s,0x0F84, 1,"garlic");			break;//lesser cure
	case 22: success=DoOnePotion(s,0x0F84, 3,"garlic");			break;//cure
	case 23: success=DoOnePotion(s,0x0F84, 6,"garlic");			break;//greater cure
	case 31: success=DoOnePotion(s,0x0F8C, 3,"sulfurous ash");	break;//lesser explosion
	case 32: success=DoOnePotion(s,0x0F8C, 5,"sulfurous ash");	break;//explosion
	case 33: success=DoOnePotion(s,0x0F8C,10,"sulfurous ash");	break;//greater explosion
	case 41: success=DoOnePotion(s,0x0F85, 1,"ginseng");		break;//lesser heal
	case 42: success=DoOnePotion(s,0x0F85, 3,"ginseng");		break;//heal
	case 43: success=DoOnePotion(s,0x0F85, 7,"ginseng");		break;//greater heal
	case 51: success=DoOnePotion(s,0x0F8D, 1,"spider's silk");	break;//night sight
	case 61: success=DoOnePotion(s,0x0F88, 1,"nightshade");		break;//lesser poison
	case 62: success=DoOnePotion(s,0x0F88, 2,"nightshade");		break;//poison
	case 63: success=DoOnePotion(s,0x0F88, 4,"nightshade");		break;//greater poison
	case 64: success=DoOnePotion(s,0x0F88, 8,"nightshade");		break;//deadly poison
	case 71: success=DoOnePotion(s,0x0F7A, 1,"black pearl");	break;//refresh
	case 72: success=DoOnePotion(s,0x0F7A, 5,"black pearl");	break;//total refreshment
	case 81: success=DoOnePotion(s,0x0F86, 2,"mandrake");		break;//strength
	case 82: success=DoOnePotion(s,0x0F86, 5,"mandrake");		break;//greater strength
	case 121: success=DoOnePotion(s,0x0F78, 1,"batwings");		break;//shrink
	default:
		LogErrorVar("switch reached default for <%i>",(type*10)+sub);
		return;
	}
	if (success)
	{
		tempeffect(Player, TEF_Grinding, 0, 0, 0);	// make grinding sound for a while
		tempeffect(Player, TEF_Grinding, 0, 3, 0);
		tempeffect(Player, TEF_Grinding, 0, 6, 0);
		tempeffect(Player, TEF_Grinding, 0, 9, 0);
		tempeffect(Player, Mortar, TEF_Mortar, type, sub, 0);	// this will indirectly call CreatePotion()
	}
}

///////////////////////////
// name:	CreatePotion
// history: unknown, revamped by Duke,21.04.2000
// Purpose:	does the appropriate skillcheck for the potion, creates it
//			in the mortar on success and tries to put it into a bottle
//
void cSkills::CreatePotion(P_CHAR pc, char type, char sub, P_ITEM Mortar)
{
	if (!pc || !Mortar) return;

	int lo,hi;
	switch((10*type)+sub)
	{
	case 11: lo=151; hi= 651; break;//agility
	case 12: lo=351; hi= 851; break;//greater agility
	case 21: lo=  0; hi= 500; break;//lesser cure
	case 22: lo=251; hi= 751; break;//cure
	case 23: lo=651; hi=1151; break;//greater cure
	case 31: lo= 51; hi= 551; break;//lesser explosion
	case 32: lo=351; hi= 851; break;//explosion
	case 33: lo=651; hi=1151; break;//greater explosion
	case 41: lo=  0; hi= 500; break;//lesser heal
	case 42: lo=151; hi= 651; break;//heal
	case 43: lo=551; hi=1051; break;//greater heal
	case 51: lo=  0; hi= 500; break;//night sight
	case 61: lo=  0; hi= 500; break;//lesser poison
	case 62: lo=151; hi= 651; break;//poison
	case 63: lo=551; hi=1051; break;//greater poison
	case 64: lo=901; hi=1401; break;//deadly poison
	case 71: lo=  0; hi= 500; break;//refresh
	case 72: lo=251; hi= 751; break;//total refreshment
	case 81: lo=251; hi= 751; break;//strength
	case 82: lo=451; hi= 951; break;//greater strength
	case 121: lo=500; hi= 750; break;//shrink
	default:
		LogError("switch reached default");
		return;
	}
	LogAssert(hi!=0);
	int success=pc->checkSkill(ALCHEMY,lo,hi);
	if (success==0 && !pc->isGM()) // AC bugfix
	{
		sprintf(temp, "*%s tosses the failed mixture from the mortar, unable to create a potion from it.*", pc->name);
		npcemoteall(pc, temp,0);
		return;
	}

	Mortar->setType(ITY_filledMortar);
	Mortar->more1=type;
	Mortar->more2=sub;
	Mortar->morex=pc->Skill(ALCHEMY);
	Mortar->morey=pc->Skill(MAGERY);
	
	if (pc->CountItems(0x0F0E) < 1)
	{
		target(pc->calcSocket(), 109, "Where is an empty bottle for your potion?");
	}
	else
	{
		pc->deleteItems(1, 0x0F0E);
		Skills->PotionToBottle(pc, Mortar);
	} 
}

/////////////////////////
// name:	BottleTarget
// history: unknown, revamped by Duke,23.04.2000
// Purpose: Uses the targeted potion bottle *outside* the backpack to
//			pour in the potion from the mortar
//
void cSkills::BottleTarget(int s, P_CHAR Player, P_ITEM pi)
{
	if (!Player) return;

	if (!pi || pi->isLockedDown()) return;

	if (pi->id()==0x0F0E)	// an empty potion bottle ?
	{
		P_ITEM Mortar = FindItemBySerial(getAddid1_4(s));
		if (!Mortar) return;
		if (Mortar->isType(ITY_filledMortar)) 
		{
			pi->ReduceAmount(1);
			Skills->PotionToBottle(Player, Mortar);
		}
	}
	else
		sysmessage(s,"This is not an appropriate container for a potion.");
}

/////////////////////////
// name:	PotionToBottle
// history: unknown, revamped by Duke,23.04.2000
// Purpose: this really creates the potion
//
void cSkills::PotionToBottle(P_CHAR pc, P_ITEM Mortar)
{
	if (!pc || !Mortar) return;
	short id;
	char pn[50];

	soundeffect(pc, 0x0240);	// Liquid sfx
	sprintf(temp, "*%s pours the completed potion into a bottle.*", pc->name);
	npcemoteall(pc,temp,0);

	switch((10*Mortar->more1)+Mortar->more2)
	{
	case 11: id=0x0F08;strcpy(pn, "an agility");				break;
	case 12: id=0x0F08;strcpy(pn, "a greater agility");			break;
	case 21: id=0x0F07;strcpy(pn, "a lesser cure");				break;
	case 22: id=0x0F07;strcpy(pn, "a cure");					break;
	case 23: id=0x0F07;strcpy(pn, "a greater cure");			break;
	case 31: id=0x0F0D;strcpy(pn, "a lesser explosion");		break;
	case 32: id=0x0F0D;strcpy(pn, "an explosion");				break;
	case 33: id=0x0F0D;strcpy(pn, "a greater explosion");		break;
	case 41: id=0x0F0C;strcpy(pn, "a lesser heal");				break;
	case 42: id=0x0F0C;strcpy(pn, "a heal");					break;
	case 43: id=0x0F0C;strcpy(pn, "a greater heal");			break;
	case 51: id=0x0F06;strcpy(pn, "a night sight");				break;
	case 61: id=0x0F0A;strcpy(pn, "a lesser poison");			break;
	case 62: id=0x0F0A;strcpy(pn, "a poison");					break;
	case 63: id=0x0F0A;strcpy(pn, "a greater poison");			break;
	case 64: id=0x0F0A;strcpy(pn, "a deadly poison");			break;
	case 71: id=0x0F0B;strcpy(pn, "a refresh");					break;
	case 72: id=0x0F0B;strcpy(pn, "a total refreshment");		break;
	case 81: id=0x0F09;strcpy(pn, "a strength");				break;
	case 82: id=0x0F09;strcpy(pn, "a greater strength");		break;
	case 121: id=0x0F06;strcpy(pn, "a shrink");					break;
	default:
		LogError("switch reached default");
		return;
	}
	
	P_ITEM Potion = Items->SpawnItem(pc,1,"#",0, id,0,1);
	if (!Potion) return;
	
	sprintf(Potion->name,"%s potion",pn);
	Potion->setType(ITY_Potion);
	Potion->morex=Mortar->morex;
	Potion->morey=Mortar->more1;
	Potion->morez=Mortar->more2;
	Potion->setMoreB1_4(Mortar->morey); // save creator's magery skill ... for now only required for nightsight
	
	// the remainder of this function NOT (yet) revamped by Duke !
	
	// Addon for Storing creator NAME and SKILLUSED by Magius(CHE) 
	if (!pc->isGM())
	{
		strcpy(Potion->creator,pc->name); // Magius(CHE) - Memorize Name of the creator
		if (pc->Skill(ALCHEMY)>950) Potion->madewith=ALCHEMY+1; // Memorize Skill used - Magius(CHE)
		else Potion->madewith=0-ALCHEMY-1; // Memorize Skill used - Magius(CHE)
	} else
	{
		Potion->creator[0]='\0';
		Potion->madewith=0;
	}
	
	Potion->refresh();
	Mortar->setType(ITY_None);
	// items[i].weight=100; // Ripper 11-25-99
	// AntiChrist NOTE: please! use the HARDITEMS.SCP...
	// the settings used in that script are used EVERY TIME we have an item created via
	// code ( and not via script )...so we simply can add the string:
	// WEIGHT 100
	// in the "potion section" of that file, and EVERY TIME the potions are created via scripts
	// they have those settings! :) that's easy isn't it? =P
}


void cSkills::SpiritSpeak(int s) // spirit speak time, on a base of 30 seconds + skill[SPIRITSPEAK]/50 + INT
{
	//	Unsure if spirit speaking should they attempt again?
	//	Suggestion: If they attempt the skill and the timer is !0 do not have it raise the skill

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (!Player->checkSkill(SPIRITSPEAK))
	{
		sysmessage(s,"You fail your attempt at contacting the netherworld.");
		return;
	}
	
	impaction(s,0x11);			// I heard there is no action...but I decided to add one
	soundeffect(Player,0x024A);	// only get the sound if you are successful
	sysmessage(s,"You establish a connection to the netherworld.");
	Player->spiritspeaktimer.setSecs(spiritspeak_data.spiritspeaktimer + Player->Skill(SPIRITSPEAK) + Player->effInt());
}

int cSkills::GetCombatSkill(P_CHAR pc)
{
	if (!pc) return WRESTLING;

	int skillused = WRESTLING;
	
	int ci=0,loopexit=0;
	P_ITEM pi;
	while ( ((pi=pc->SearchHands(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (IsSwordType(pi->id()) )
		{
			skillused = SWORDSMANSHIP;
			break;
		}
		if (IsMaceType(pi->id()) )
		{
			skillused = MACEFIGHTING;
			break;
		}
		if (IsFencingType(pi->id()) )
		{
			skillused = FENCING;
			break;
		}
		if (IsBowType(pi->id()) )
		{
			skillused = ARCHERY;
			break;
		}
	}
	return(skillused);
}

void cSkills::Tracking(int s,int selection)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	Player->trackingtarget=Player->trackingtargets[selection]; // sets trackingtarget that was selected in the gump
	Player->trackingtimer.setSecs((((tracking_data.basetimer*Player->Skill(TRACKING))/1000)+1)); // tracking time in seconds ... gm tracker -> basetimer+1 seconds, 0 tracking -> 1 sec, new calc by LB
	Player->trackingdisplaytimer.setSecs(tracking_data.redisplaytime);
	P_CHAR Tracked = FindCharBySerial(Player->trackingtarget);
	if (!Tracked) return;
	sprintf(temp,"You are now tracking %s.",Tracked->name);
	sysmessage(s,temp);
	Skills->Track(Player);
}

void cSkills::CreateTrackingMenu(int s,int m)
{
	int total;
	char lentext;
	char gmtext[MAXTRACKINGTARGETS][257]; // crashfix, LB
	int gmid[MAXTRACKINGTARGETS]; // crashfix, LB

	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	int t=1;	// animals
	char type[40]="You see no signs of any animals.";

	if (m==(2+TRACKINGMENUOFFSET)) // monsters
	{	
		strcpy(type,"You see no signs of any creatures.");
		t=2;
	}

	if (m==(3+TRACKINGMENUOFFSET)) // players
	{		
		strcpy(type,"You see no signs of anyone.");
		t=3;
	}

	Script* Scp = findSection(tracking_script,"TRACKINGMENU",m);
	if (!Scp) return;
	Scp->NextLineInSection();
	lentext=sprintf(gmtext[0], "%s", script1);	// menu title
	Scp->Close();
	
	int distance=tracking_data.baserange+Player->Skill(TRACKING)/50;
	int NumTargets=0;
	P_CHAR pc;
	int loopexit=0;
	RegGrid3x3Iterator4Chars rg3ic(Player->pos);
	while ((pc = rg3ic.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pc->isGMorCounselor()) continue; //skip staff members (thrawn)
		if (pc->isDummy()) continue; //skip dummy npc's (thrawn)
		int d=Player->dist(pc);
		
		bool ok=false;
		if (t==1)      ok = (pc->isAnimalBody() && pc->npc);
		else if (t==2) ok = (pc->isMonsterBody() && pc->npc);
		else if (t==3) ok = (pc->InGame() && pc->calcSocket()!=s);
	
		if (ok && d<=distance)
		{
			Player->trackingtargets[NumTargets] = pc->serial;
			NumTargets++;
			if (NumTargets>=MAXTRACKINGTARGETS) break; // lb crashfix

			switch (Skills->TrackingDirection(s,pc))
			{
			case NORTH:		strcpy(temp,"to the North");			break;
			case NORTHWEST:	strcpy(temp,"to the Northwest");		break;
			case NORTHEAST:	strcpy(temp,"to the Northeast");		break;
			case SOUTH:		strcpy(temp,"to the South");			break;
			case SOUTHWEST:	strcpy(temp,"to the Southwest");		break;
			case SOUTHEAST:	strcpy(temp,"to the Southeast");		break;
			case WEST:		strcpy(temp,"to the West");				break;
			case EAST:		strcpy(temp,"to the East");				break;
			default:		strcpy(temp,"right next to you");
			}
			sprintf(gmtext[NumTargets], "%s %s",pc->name,temp);						
			int b = pc->id();
			if (b<2048 && b>-1) gmid[NumTargets]=NpcInfo_getIcon(b); // placing correct icon, LB
			else gmid[NumTargets]=NpcInfo_getIcon(0x190);
		}
	}
	
	if (NumTargets==0)
	{
		sysmessage(s,type);
		return;
	}
	
	unsigned int i;
	total=9+1+lentext+1;
	for (i=1;i<=NumTargets;i++) total+=4+1+strlen(gmtext[i]);

	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};

	XStartPkt(0x7c, total);

	LongToCharPtr(Player->serial,&gmprefix[3]);
	ShortToCharPtr(m+TRACKINGMENUOFFSET,&gmprefix[7]);

	XAddPkt(&gmprefix[0+3], 9-3);

	XAddPkt((unsigned char*)&lentext, 1);
	XAddPkt((unsigned char*)&gmtext[0], lentext);
	XAddPkt((unsigned char*)&NumTargets, 1);

	for (i=1;i<=NumTargets;i++)
	{
		ShortToCharPtr(gmid[i],&gmmiddle[0]);
		XAddPkt(&gmmiddle[0], 4);

		lentext=strlen(gmtext[i]);
		XAddPkt((unsigned char*)&lentext, 1);
		XAddPkt((unsigned char*)&gmtext[i], lentext);
	}

	XFinishPkt(s);
}

void cSkills::TrackingMenu(int s,int gmindex)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	char gmtext[MAXTRACKINGTARGETS][257];
	int gmid[MAXTRACKINGTARGETS];
	int gmnumber=0;
	if (gmindex<1000) 
	{
		Skills->Tracking(s,gmindex);
		return;
	}

	Script* Scp = findSection(tracking_script,"TRACKINGMENU",gmindex);
	if (!Scp) return;
	Scp->NextLineInSection();
	char lentext=sprintf(gmtext[0], "%s", script1);

	int loopexit=0;
	while (Scp->NextLineSplitted() && (++loopexit < MAXLOOPS) )
	{
		gmnumber++;
		gmid[gmnumber]=hstr2num(script1);
		strcpy(gmtext[gmnumber], script2);
		Scp->NextLineInSection();
	}
	Scp->Close();

	int i,total=9+1+lentext+1;
	for (i=1;i<=gmnumber;i++) total+=4+1+strlen(gmtext[i]);

	unsigned char gmprefix[9]={0,};
	unsigned char gmmiddle[4]={0,};

	LongToCharPtr(Player->serial,&gmprefix[3]);
	ShortToCharPtr(gmindex+TRACKINGMENUOFFSET,&gmprefix[7]);

	XStartPkt(0x7c, total);
	XAddPkt(&gmprefix[0+3], 9-3);

	XAddPkt((unsigned char*)&lentext, 1);
	XAddPkt((unsigned char*)&gmtext[0], lentext);

	lentext=gmnumber;
	XAddPkt((unsigned char*)&lentext, 1);

	for (i=1;i<=gmnumber;i++)
	{
		ShortToCharPtr(gmid[i],&gmmiddle[0]);
		XAddPkt(&gmmiddle[0], 4);

		lentext=strlen(gmtext[i]);
		XAddPkt((unsigned char*)&lentext, 1);
		XAddPkt((unsigned char*)&gmtext[i], lentext);
	}

	XFinishPkt(s);
}

void cSkills::Track(P_CHAR Player)
{
	if (!Player) return;
	int s=Player->calcSocket();
	P_CHAR Target = FindCharBySerial(Player->trackingtarget);
	if (!Target) return;

	int direction=5;
	if ((Player->pos.y-direction)>=Target->pos.y)  // North
	{
		sprintf(temp,"%s is to the North",Target->name);
		if ((Player->pos.x-direction)>Target->pos.x)
			sprintf(temp,"%s is to the Northwest",Target->name);
		if ((Player->pos.x+direction)<Target->pos.x)
			sprintf(temp,"%s is to the Northeast",Target->name);
	}
	else if ((Player->pos.y+direction)<=Target->pos.y)  // South
	{
		sprintf(temp,"%s is to the South",Target->name);
		if ((Player->pos.x-direction)>Target->pos.x)
			sprintf(temp,"%s is to the Southwest",Target->name);
		if ((Player->pos.x+direction)<Target->pos.x)
			sprintf(temp,"%s is to the Southeast",Target->name);
	}
	else if ((Player->pos.x-direction)>=Target->pos.x)  // West
	{
		sprintf(temp,"%s is to the West",Target->name);
	}
	else if ((Player->pos.x+direction)<=Target->pos.x)  // East
	{
		sprintf(temp,"%s is to the East",Target->name);
	}
	else sprintf(temp,"%s is right next to you",Target->name);
	
	unsigned char arrow[7];
	arrow[0]='\xBA';
	arrow[1]=1;
	ShortToCharPtr(Target->pos.x-1,&arrow[2]);
	ShortToCharPtr(Target->pos.y,&arrow[4]);

	XStartPkt(0xBA,6);
	XAddPkt(&arrow[0+1],6-1);
	XFinishPkt(s);
}

int cSkills::TrackingDirection(int s,P_CHAR pc_i)
{
	if (!pc_i) return 0;
	int direction=5;
	P_CHAR Player = MAKE_CHARREF_LRV(currchar(s),0);
	if ((Player->pos.y-direction)>=pc_i->pos.y)  // North
	{
		if ((Player->pos.x-direction)>pc_i->pos.x)
			return NORTHWEST;
		if ((Player->pos.x+direction)<pc_i->pos.x)
			return NORTHEAST;
		return NORTH;
	}
	else if ((Player->pos.y+direction)<=pc_i->pos.y)  // South
	{
		if ((Player->pos.x-direction)>pc_i->pos.x)
			return SOUTHWEST;
		if ((Player->pos.x+direction)<pc_i->pos.x)
			return SOUTHEAST;
		return SOUTH;
	}
	else if ((Player->pos.x-direction)>=pc_i->pos.x)  // West
		return WEST;
	else if ((Player->pos.x+direction)<=pc_i->pos.x)  // East
		return EAST;
	else return 0;
}
// Redone by LB on dec 28'th 1999
// Thx goes to Ripper for the design 
///////////////////////
// name:	CheckThreeSkills
// history:	by Duke, 8 April 2000
// Purpose:	little helper function for TellScroll()
//			checks the 3 skills required for engraving and cumulates
//			the returnvalues i.e. only a part==3 means success!
//
static int CheckThreeSkills(int s, P_CHAR Player, int low, int high)
{
	int part=0;
	Player->SetCastingSpell(NULL,0); // needed for MAGERY check
	//	currentSpellType[s]=0;		
	LogAssert(high!=0);
	part += Player->checkSkill(INSCRIPTION,	low, high);
	part += Player->checkSkill(MAGERY,		low, high);
	part += Player->checkSkill(TINKERING,	low, high);
	return part;
}

///////////////////////
// name:	TellScroll
// history:	unknown, modified by LB & AntiChrist, 
//			partially revamped by Duke, 8 April 2000
// Purpose:	callback function for inscription menue
//			This is the point where control is returned after the user
//			selected a spell to inscribe/engrave from the gump menu.
//
void TellScroll( char *menu_name, int s, long snum )
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));

	if (snum<=0) return;				// bad spell selction

	P_ITEM pi = FindItemBySerial(Player->target1serial);	// lets re-grab the item they clicked on
	if (!pi) return;

	unsigned int cir=(int)((snum-800)/10);		// snum holds the circle/spell as used in inscribe.gmp
	unsigned int spl=(((snum-800)-(cir*10))+1);	// i.e. 800 + 1-based circle*10 + zero-based spell
										// snum also equals the item # in items.scp of the scroll to be created !
	P_ITEM pk = Player->getBackpack();
	if (!pk) return;
	
	P_ITEM Book = Magic->GetSpellBook(Player,SBT_REGULAR);

	cSpell* spell = Magic->GetSpell(spl + (cir-1)*8);
	if (!spell) return;

	if (!spell->IsInBook(Book))
	{
		sysmessage(s,"You don't have this spell in your spell book!");
		return;
	}
	
	int num=(8*(cir-1))+spl;	// circle & spell combined to a zero-based index

	OldMagic->Action4Spell(s,num);
	OldMagic->SpeakMantra4Spell(Player,num);
	
	if (!OldMagic->CheckReagents(Player, num)
		|| !OldMagic->CheckMana(Player, num))
	{
		OldMagic->SpellFail(s);
		return;
	}
	OldMagic->SubtractMana4Spell(Player, num);
	
	if (pi->id()==0x0E34)  //is it a scroll?
	{
		itemmake[s].Mat1id=0x0E34; 
		itemmake[s].needs=1; 
		itemmake[s].has=Player->CountItems(0x0E34); 
		itemmake[s].minskill=(cir-1)*100;	//set range values based on scroll level
		itemmake[s].maxskill=(cir+2)*100;

		OldMagic->DelReagents(Player, num);
		
		LogAssert(itemmake[s].maxskill!=0);
		Skills->MakeMenuTarget(s,snum,INSCRIPTION); //put it in your pack
	}
	else
	{
		if (pi->att>0 || pi->def>0 || pi->hidamage) //or is it an item?
		{
			int part=0;
			switch(cir)
			{
			case 1:	part = CheckThreeSkills(s,Player,  11, 401);break;
			case 2:	part = CheckThreeSkills(s,Player,  61, 501);break;
			case 3:	part = CheckThreeSkills(s,Player, 161, 601);break;
			case 4:	part = CheckThreeSkills(s,Player, 261, 701);break;
			case 5:	part = CheckThreeSkills(s,Player, 361, 801);break;
			case 6:	part = CheckThreeSkills(s,Player, 461, 901);break;
			case 7:	part = CheckThreeSkills(s,Player, 661,1101);break;
			case 8:	part = CheckThreeSkills(s,Player, 761,1201);break;
			default:
				LogError("switch reached default");
				return;
			}
			if (part < 3)		// failure !
			{
				switch(part)
				{
				case 0:
					sysmessage(s,"Your hand jerks and you punch a hole in the item");
					pi->hp -= 3;
					break;
				case 1:
					sysmessage(s,"Your hand slips and you dent the item");
					pi->hp -= 2;
					break;
				case 2:
					sysmessage(s,"Your hand cramps and you scratch the item");
					pi->hp--;
					break;
				}
				if (pi->hp<1)
					pi->hp=1;
			}
			else				// success !
			{
				if (!( pi->morez == 0 ||(pi->morex == cir && pi->morey == spl))  )
					sysmessage(s,"This item already has a spell!");
				
				else if ( pi->morez >= (9 - pi->morex)*2)
					sysmessage(s,"Item at max charges!");
				
				else
				{
					Skills->EngraveAction(s, pi, cir, spl);	// check mana & set name
					
					if (!(pi->morex == cir && pi->morey == spl))	// not THIS spell
					{
						pi->type2=pi->type; //kept type of item for returning to this type when item remain no charge 
						pi->setType(ITY_CastingItem);	//make it magical
						pi->morex=cir;//spell circle
						pi->morey=spl;//spell number
						sysmessage(s,"Item successfully Engraved");
					}
					else
						sysmessage(s,"You added one more charge to the Item");
					
					pi->morez++;  // charges
					sysmessage(s,"Item successfully Engraved");
				}
			}
		}
	}
}

/////////////////////////////
// name:	Inscribe
// history:	unknown, modified by AntiChrist
//			partially revamped by Duke,8 April 2000
//			added runebook crafting by Uber/Duke 06-16-2002
// Purpose:	bring up inscription menue
//
void cSkills::Inscribe(int s, P_ITEM pi) 
{
	if (!pi) return;
	
	if ( !( ((pi->id()==0x0E34) || (pi->id()==0x1F14)) || //its a scroll or rune (allow always)
			(SrvParms->engraving && (pi->att>0 || pi->def>0 || pi->hidamage>0))) ) // it's something else (check serverswitch)
	{
		sysmessage(s,"You could not possibly engrave on that!");
		return;
	}

	if (pi->id()!=0x0E34 && pi->amount > 1)
	{
		sysmessage(s,"You can't engrave piles of items!");
		return;
	}
	
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (pi->id()==0x1F14) // they selected a rune
	{
		// runebook creation
		// first check to see if they have the required scrolls
		if (Player->CountItems(0x0E34) < 8)
		{
			sysmessage(s,"You need at least 8 blank scrolls.");
			return;
		}
		
		if (Player->CountItems(0x1F4C) < 1)
		{
			sysmessage(s,"You need at least 1 recall scroll.");
			return;
		}
		
		if (Player->CountItems(0x1F60) < 1)
		{
			sysmessage(s,"You need at least 1 gate travel scroll.");
			return;
		}
		
		// check skill
		int charges = 1;
		int modifier = 0;
		int skmin = 500;
		int skdif = Player->Skill(INSCRIPTION) - skmin;
		
		if (skdif <= 0)
		{
			sysmessage(s, "You are not skilled enough!");
			return;
		}
		else
		{
			// do some randomizing (not very good randomizing, but anyway...)
			// so at 50 skill you have chance to make 5, or 6 charges
			// at 60 skill you can make 5, 6, 7, or 8 charges
			// at 70 skill you can make 6, 7, 8, or 9 charges
			// etc..
			if (Player->checkSkill(INSCRIPTION,skmin))
			{
				// have a chance at making higher then normal
				if (!(rand()%10)) modifier=-1;        // 10% chance of -1 charge
				if (!(rand()%10)) modifier=1;         // 10% chance of +1 charge
				if (!(rand()%100)) modifier=2;        // 1% chance of +2 charges
			}
			else
			{
				// they failed
				sysmessage(s, "You failed to make the runebook!");
				
				// remove the required items
				Player->deleteItems(rand()%8, 0x0E34);
				Player->deleteItems(1, 0x1F4C);
				Player->deleteItems(1, 0x1F60);
				Items->DeleItem(pi);
				
				return;
			}
			
			// get number of charges
			// I'm sure there's a better way to do this?
			charges = 5 + skdif/100 + modifier;
			if (charges > 10) charges=10;
			if (charges < 5) charges=5;
			
			switch(modifier)
			{
			case -1:	sysmessage(s, "Your hand slips a little.");			break;
			case 0:		sysmessage(s, "You make a runebook.");				break;
			case 1:		sysmessage(s, "You make a good runebook.");			break;
			case 2:		sysmessage(s, "You make an exceptional runebook!");	break;
			}
			
			// create the item
			P_ITEM rpi = Items->SpawnItemBackpack2(s,90000);
			if (!rpi) return;
			rpi->morey = charges;
			rpi->morez = charges;
			
			// remove the required items
			Player->deleteItems(8, 0x0E34);
			Player->deleteItems(1, 0x1F4C);
			Player->deleteItems(1, 0x1F60);
			Items->DeleItem(pi);
			return;
		}
	}
	else // not a rune
	{
		// select spell gump menu system here, must return control to LoneWolf so we dont
		// freeze the game. when returning to this routine, use snum to determine where to go
		// and snum is also the value of what they selected.
		im_sendmenu( "InscribeMenu", s );  //this is in im.cpp file using inscribe.gmp
	}
	return;
}

////////////////////////
// name:	TellScroll
// history:	unknown, modified by AntiChrist, totally revamped by Duke,8 April 2000
// Purpose:	check mana&regs and set the name of selected spell
//
int cSkills::EngraveAction(int s, P_ITEM pi, int cir, int spl)
{
	char *spn;					// spellname
	int num=(8*(cir-1))+spl;
	P_CHAR Player = MAKE_CHARREF_LRV(currchar(s),0);
	OldMagic->DelReagents(Player, num);
		
	switch(cir*10 + spl)
	{
	// first circle
	case 11: spn="Clumsy";
			pi->offspell=1;
			break;
	case 12: spn="Create Food";break;   
	case 13: spn="Feeblemind";
			pi->offspell=2;
			break;
	case 14: spn="Heal";break;
	case 15: spn="Magic Arrow";
			pi->offspell=3;
			break;
	case 16: spn="Night Sight";break;
	case 17: // Reactive Armor
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	case 18: spn="Weaken";
			pi->offspell=4;
			break;
	// 2nd circle
	case 21: spn="Agility";break;
	case 22: spn="Cunning";break;
	case 24: spn="Harm";
			pi->offspell=5;
			break;
	case 23:// Cure
	case 25:// Magic Trap
	case 26:// Magic Untrap
	case 27:// Protection
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	case 28: spn="Strength";break;
	// 3rd circle
	case 31: spn="Bless";break;
	case 32:// Fireball
			spn="Daemon's Breath";
			pi->offspell=6;
			break;
	case 34: spn="Poison";break;
	case 33: //Magic lock
	case 35: //Telekinesis
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	case 36: spn="Teleport";break;
	case 37: spn="Unlock";break;
	case 38: spn="Wall of Stone";break;
	// 4th circle
	case 41:// Arch Cure
	case 42:// Arch Protection
	case 47:// Mana Drain
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	case 43:// Curse
			spn="Evil's Eye";
			pi->offspell=8;
			break;
	case 44: spn="Fire Field";break;
	case 45: spn="Greater Heal";break;
	case 46: spn="Lightning";
			pi->offspell=9;
			break;
	case 48: spn="Recall";break;
	// 5th circle
	case 51: spn="Blade Spirit";break;
	case 52: spn="Dispel Field";break;
	case 54: spn="Magic Reflection";break;
	case 55: spn="Mind Blast";
			pi->offspell=11;
			break;
	case 56://Paralyze
			spn="Ghoul's Touch";
			pi->offspell=12;
			break;
	case 57: spn="Poison Field";break;
	case 53://Incognito
	case 58://Summon Creature
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	// 6th circle
	case 61: spn="Dispel";break;
	case 62: spn="Energy Bolt";
			pi->offspell=13;
			break;  
	case 63: spn="Explosion";
			pi->offspell=14;
			break;
	case 64: spn="Invisibility";break;
	case 65: spn="Mark";break;
	case 66://Mass Curse
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	case 67: spn="Paralyse Field";break;
	case 68: spn="Reveal";break;
	// 7th circle
	case 72: spn="Energy Field";break;
	case 73: spn="Flamestrike";
			pi->offspell=15;
			break;
	case 74: spn="Gate Travel";break;
	case 71:// Chain Lightning
	case 75:// Mana Vampire
	case 76:// Mass Dispel
	case 77:// Meteor Storm
	case 78:// Polymorph
	// 8th circle
	case 81:// Earthquake
			sysmessage(s, "Sorry this spell is not implemented!");
			return 0;
	case 82: spn="Energy Vortex";break;
	case 83: spn="Resurrection";break;
	case 84: spn="Summon Air Elemental";break;
	case 85: spn="Summon Daemon";break;
	case 86: spn="Summon earth Elemental";break;
	case 87: spn="Summon Fire Elemental";break;
	case 88: spn="Summon Water Elemental";break;
	default:
		LogError("switch reached default");
		return 0;
	}
	sprintf(pi->name2,"of %s with", spn);
	return 1;
}


void cSkills::TDummy(int s)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	int type = Player->getBowType();
	
	if (type > 0)
	{
		sysmessage(s, "Practice archery on archery buttes !");
		return;
	}
	int skillused = Skills->GetCombatSkill(Player);
	
	if (Player->onhorse)
		Combat->CombatOnHorse(Player);
	else
		Combat->CombatOnFoot(Player);
	
	switch(rand()%3)
	{
	case 0: soundeffect(Player, 0x013B);break;
	case 1: soundeffect(Player, 0x013C);break;
	case 2: soundeffect(Player, 0x013D);break;
	default:
		LogError("switch reached default");
		return;
	}
	int serial = LongFromCharPtr(&buffer[s][1]) & 0x7FFFFFFF;
	P_ITEM iJ = FindItemBySerial( serial );
	if (iJ)
	{
		if (iJ->id()==0x1070) iJ->setId(0x1071);
		if (iJ->id()==0x1074) iJ->setId(0x1075);
		tempeffect(Player, iJ, TEF_TDummy);
		iJ->refresh();
	}
	if (Player->Skill(skillused) < 300)
	{
		Player->checkSkill(skillused);
		if (Player->Skill(TACTICS) < 300)
			Player->checkSkill(TACTICS, 0, 250);  //Dupois - Increase tactics but only by a fraction of the normal rate
	}
	else
		sysmessage(s, "You feel you would gain no more from using that.");   
}

/*
void cSkills::NewDummy(unsigned int currenttime)
{
	P_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pi->id()==0x1071 && pi->gatetime<=currenttime) 
		{
			pi->setId(0x1070);
			pi->gatetime=0;
			pi->refresh();
		} else
			if (pi->id()==0x1075 && pi->gatetime<=currenttime) 
			{
				pi->setId(0x1074);
				pi->gatetime=0;
				pi->refresh();
			} 
	}
}*/

void cSkills::AButte(int s1, P_ITEM pButte)
{
	int v1,i;
	int arrowsquant=0;
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s1));
	int type=Player->getBowType();
	if (pButte->id()==0x100A)
	{ // East Facing Butte
		if ((pButte->pos.x > Player->pos.x)||(pButte->pos.y != Player->pos.y))
			v1=-1;
		else v1=Player->pos.x-pButte->pos.x;
	}
	else
	{ // South Facing Butte
		if ((pButte->pos.y>Player->pos.y)||(pButte->pos.x!=Player->pos.x))
			v1=-1;
		else v1=Player->pos.y-pButte->pos.y;
	}
	
	if (v1==1)
	{
		P_ITEM pi=NULL;
		if (pButte->more1>0)
		{
			pi=Items->SpawnItem(Player,pButte->more1/2,"#",1,0x0F3F,0,1);
			if (!pi) return;
		}
		
		if (pButte->more2>0)
		{
			pi=Items->SpawnItem(Player,pButte->more2/2,"#",1,0x1BFB,0,1);
			if (!pi) return;
		}
		
		i=0;
		if (pButte->more1>0) i++;
		if (pButte->more2>0) i+=2;
		
		switch(i)
		{
		case 0:
			sprintf(temp,"This target is empty");
			break;
		case 1:
			sprintf(temp,"You pull %d arrows from the target",pButte->more1/2);
			break;
		case 2:
			sprintf(temp,"You pull %d bolts from the target",pButte->more2/2);
			break;
		case 3:
			sprintf(temp,"You pull %d arrows and %d bolts from the target",pButte->more1,pButte->more2/2);
			break;
		default:
			LogError("switch reached default");
			return;
		}
		sysmessage(s1,temp);
		pButte->more1=0;
		pButte->more2=0;
	}
	
	if ((v1>=5)&&(v1<=8))
	{
		if (type == 0)
		{
			sysmessage(s1, "You need to equip a bow to use this.");
			return;
		} 
		if ((pButte->more1+pButte->more2)>99)
		{
			sysmessage(s1, "You should empty the butte first!");
			return;
		}
		if (type==1) arrowsquant=Player->CountItems(0x0F3F);
		else arrowsquant=Player->CountItems(0x1BFB);
		if (arrowsquant==0) 
		{
			sysmessage(s1, "You have nothing to fire!");
			return;
		}
		if (type==1) 
		{
			Player->deleteItems(1, 0x0F3F);
			pButte->more1++;
			//add moving effect here to item, not character
		}
		else
		{
			Player->deleteItems(1, 0x1BFB);
			pButte->more2++;
			//add moving effect here to item, not character
		} 
		if (Player->onhorse) Combat->CombatOnHorse(Player);
		else Combat->CombatOnFoot(Player);
		
		if (Player->Skill(ARCHERY) < 350)
			Player->checkSkill(ARCHERY);
		else
			sysmessage(s1, "You learn nothing from practicing here");

		switch((Player->Skill(ARCHERY)+((rand()%200)-100))/100)
		{
		case -1:
		case 0:
		case 1:
			sysmessage(s1, "You miss the target");
			soundeffect(Player, 0x0238);
			break;
		case 2:
		case 3:
			sysmessage(s1, "You hit the outer ring!");
			soundeffect(Player, 0x0234);
			break;
		case 4:
		case 5:
		case 6:
			sysmessage(s1, "You hit the middle ring!");
			soundeffect(Player, 0x0234);
			break;
		case 7:
		case 8:
		case 9:
			sysmessage(s1, "You hit the inner ring!");
			soundeffect(Player, 0x0234);
			break;
		case 10:
		case 11:
			sysmessage(s1, "You hit the bullseye!!");
			soundeffect(Player, 0x0234);
			break;
		default:
			break;
		}
	}
	if ((v1>1)&&(v1<5)||(v1>8)) sysmessage(s1, "You cant use that from here.");
}

void cSkills::Meditation(UOXSOCKET s) // Morrolan - meditation(int socket)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	// blackwind warmode fix.
	if (Player->war)
	{
		sysmessage(s, "Your mind is too busy with the war thoughts.");
		return;
	}
	if (Skills->GetAntiMagicalArmorDefence(Player)>15) // blackwind armor affect fix
	{
		sysmessage(s, "Regenerative forces cannot penetrate your armor.");
		Player->med = 0;
		return;
	}
	else if (Player->WieldsAntiMagicalItem())
	{
		sysmessage(s, "You cannot meditate with that in your hands!");
		Player->med = 0;
		return;
	}
	else if (Player->Mana() == Player->effInt())
	{
		sysmessage(s, "You are at peace.");
		Player->med = 0;
		return;
	}
	else if (!Player->checkSkill(MEDITATION))
	{
		sysmessage(s, "You cannot focus your concentration.");
		Player->med = 0;
		return;
	}
	else
	{
		sysmessage(s, "You enter a meditative trance.");
		Player->med = 1;
		soundeffect(Player, 0x00F9);
		return;
	}
}

//AntiChrist - 5/11/99
//
//If you are a ghost and attack a player, you can PERSECUTE him
//and his mana decreases each time you try to persecute him
//decrease=3+(your int/10)
//
void cSkills::Persecute (UOXSOCKET s) //AntiChrist - persecute stuff
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	P_CHAR Target = Player->GetTarget();
	if (!Target) return;

	if (Target->isGM()) return;

	int decrease=(Player->effInt()/10)+3;

	if (Player->skilldelay.hasExpired() || Player->isGM())
	{
		if ((rand()%20)+Player->effInt() > 45) //not always
		{
			if ( Target->Mana() <= decrease )
				Target->mn = 0;
			else 
				Target->mn-=decrease;//decrease mana
			updatestats(Target,1);//update
			sysmessage(s,"Your spiritual forces disturb the enemy!");
			sysmessage(Target->calcSocket(),"A damned soul is disturbing your mind!");
			Player->skilldelay.setSecs(SrvParms->skilldelay);

			sprintf(temp, "%s is persecuted by a ghost!!", Target->name);
					
			for (unsigned int j=0;j<now;j++)
			{
				if (perm[j])
				{
					if (inrange1pl(Player, currchar(j)))
					{
						Player->emotecolor=0x0026;
						npcemote(j, Target, temp, 1);
					}
				}
			}
		}
		else
			sysmessage(s,"Your mind is not strong enough to disturb the enemy.");
	}
	else
		sysmessage(s,"You are unable to persecute him now...rest a little...");
}

int cSkills::GetAntiMagicalArmorDefence(P_CHAR pc)
{// blackwind
	int ar = 0;

	if (isTrueHuman(pc))
	{
		int ci = 0, loopexit = 0;
		P_ITEM pi;
		while (((pi = pc->Search(&ci)) != NULL) &&(++loopexit < MAXLOOPS))
		{
			if (pi->layer>1 && pi->layer < 25)
			{
				short id = pi->id();
				if (IsStuddedArmour(id) || IsLeatherArmour(id))
					continue;

				if (!(strstr(pi->name, "boot")|| strstr(pi->name, "mask")))
					ar += pi->def;
			}
		}
	}
	return ar;
}

void cSkills::Snooping(P_CHAR Player, P_ITEM Container)
{
	UOXSOCKET s = Player->calcSocket();
	P_CHAR pc_owner = GetPackOwner(Container);
	UOXSOCKET owner_sock = pc_owner->calcSocket();
	if (pc_owner->isGMorCounselor())
	{
		sysmessage(s, "You can't peek into that container or you'll be jailed.");// AntiChrist
		sprintf(temp, "%s is trying to snoop you!", Player->name);
		sysmessage(owner_sock, temp);
		return;
	}
	else if (Player->checkSkill(SNOOPING))
	{
		backpack(s,Container);
		sysmessage(s, "You successfully peek into that container.");
		// Karma(currchar(s),-1,-2000);//AntiChrist
		// criminal(currchar(s));//AntiChrist
	}
	else
	{
		sysmessage(s, "You failed to peek into that container.");
		if (Player->npc)
			npctalk(s, Player, "Art thou attempting to disturb my privacy?", 0);
		else
		{
			sprintf(temp, "You notice %s trying to peek into your pack!", Player->name);
			if (owner_sock != -1)
				sysmessage(owner_sock, temp); 
		}
		// Karma(currchar(s),-1,-2000);//AntiChrist
		// criminal(currchar(s));//AntiChrist
	}
	Player->objectdelay.setSecs(SrvParms->objectdelay+SrvParms->snoopdelay);//adds a delay - solarin
}


/*
	By Polygon:
	Function is called when clicked on the "Cartography button
	Builds the cartography menu
*/
void cSkills::Cartography(int s)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (HasEmptyMap(Player))
	{
		itemmake[s].has = 1;
		itemmake[s].Mat1id = 0x14ED;
		MakeMenu(s, 1200, CARTOGRAPHY);
	}
	else
		sysmessage(s, "You don't have an empty map to draw on");
}

// END OF: By Polygon

/*
	By Polygon:
	Two functions that are needed for the cartography skill to
	determine if the correct map type is in pack
*/

bool cSkills::HasEmptyMap(P_CHAR Player)	// Check if the player carries an empty map
{
	if (!Player) return false;
	P_ITEM Pack = Packitem(Player);	// Get the packitem
	if (Pack == NULL)	// Does he have a backpack?
		return false;	// No? Then no cartography

	P_ITEM cand;	// Stores the candidate for the map
	int ci=0;		// Stores the last found item
	int loopexit=0;	// Avoids the loop to take too much time
	while (++loopexit < MAXLOOPS)	// The search loop
	{
		cand = ContainerSearchFor(Pack->serial, &ci, 0x14ED, -1);	// Search
		if (cand == NULL)	// Nothing found?
			return false;	// Nah, then no cartography
		if (cand->isType(ITY_EmptyMap))	// Is it the right type
			return true;	// Yay, go on with carto
	}
	return false;	// Search lasted too long, abort
}

bool cSkills::DelEmptyMap(P_CHAR Player)	// Delete an empty map from the player's backpack, use HasEmptyMap before!
{
	if (!Player) return false;

	P_ITEM Pack = Packitem(Player);	// Get the packitem
	if (Pack == NULL)	// Does he have a backpack?
	{
		// No? Very strange... Give out an error message
		LogError("No backpack found in DelEmptyMap. No HasEmptyMap performed before or serious bug occured");
		return false;	// abort the opeation if you get this
	}

	P_ITEM cand;	// Stores the candidate for the map
	int ci=0;		// Stores the last found item
	int loopexit=0;	// Avoids the loop to take too much time
	while (++loopexit < MAXLOOPS)	// The search loop
	{
		cand = ContainerSearchFor(Pack->serial, &ci, 0x14ED, -1);	// Search
		if (cand == NULL)	// Nothing found?
		{
			// No? Quite strange.. Give out an error message
			LogError("No map found in pack in DelEmptyMap. No HasEmptyMap performed before or serious bug occured");
			return false;	// abort the operation if you get this
		}
		if (cand->isType(ITY_EmptyMap))	// Is it the right type
		{
			Items->DeleItem(cand);	// Delete it
			return true;		// Go on with cartography
		}
	}
	return false;	// Search lasted too long, abort (shouldn't happen, abort if ya get this)
}

//	END OF: By Polygon

/*
	By Polygon:
	Attempt to decipher a tattered treasure map
	Called when double-clicked such a map
*/

void cSkills::Decipher(P_ITEM tmap, int s)
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	char sect[500];			// Needed for script search
	int regtouse;			// Stores the region-number of the TH-region
	int i;					// Loop variable
	int btlx, btly, blrx, blry; // Stores the borders of the tresure region (topleft x-y, lowright x-y)
	int tlx, tly, lrx, lry;		// Stores the map borders
	int x, y;					// Stores the final treasure location

	if (Player->skilldelay.hasExpired() || Player->isGM())	// Char doin something?
	{
		if (Player->checkSkill(CARTOGRAPHY, tmap->morey * 10))	// Is the char skilled enough to decipher the map
		{
			P_ITEM nmap=Items->SpawnItemBackpack2(s, SNI_Deciphered);
			if (!nmap)
			{
				LogWarning("bad script item # SNI_Deciphered(Item Not found).");
				return;	//invalid script item
			} 
			sprintf(nmap->name, "a deciphered lvl.%d treasure map", tmap->morez);	// Give it the correct name
			nmap->morez = tmap->morez;				// Give it the correct level
			strcpy(nmap->creator, Player->name);	// Store the creator
			Script *rscript=i_scripts[regions_script];	// Region script
			if (!rscript->Open())
			{
				LogWarning("Treasure hunting cSkills::Decipher : Cannot open regions-script");
				return;
			}
			sprintf(sect, "TREASURE %i", nmap->morez);
			if (!rscript->find(sect)) 
			{
				rscript->Close();
				LogWarningVar("Treasure hunting cSkills::Decipher : Unable to find 'SECTION TREASURE%X' in regions-script", nmap->morez);
				return;
			}
			rscript->NextLine();				// Get the number of areas
			regtouse = rand()%str2num(script1);	// Select a random one
			for (i = 0; i < regtouse; i++)		// Skip the ones before the correct one
			{
				rscript->NextLine();
				rscript->NextLine();
				rscript->NextLine();
				rscript->NextLine();
			}
			rscript->NextLine();				// Get the treasure region borders
			btlx = str2num(script1);
			rscript->NextLine();
			btly = str2num(script1);
			rscript->NextLine();
			blrx = str2num(script1);
			rscript->NextLine();
			blry = str2num(script1);
			rscript->Close();					// Close the script
			if ((btlx < 0) || (btly < 0) || (blrx > 0x13FF) || (blry > 0x0FFF))	// Valid region?
			{
				sprintf(sect, "Treasure Hunting cSkills::Decipher : Invalid region borders for lvl.%d , region %d", nmap->morez, regtouse+1);	// Give out detailed warning :D
				LogWarning(sect);
				return;
			}
			x = btlx + (rand()%(blrx-btlx));	// Generate treasure location
			y = btly + (rand()%(blry-btly));
			tlx = x - 250;		// Generate map borders
			tly = y - 250;
			lrx = x + 250;
			lry = y + 250;
			// Check if we are over the borders and correct errors
			if (tlx < 0)	// Too far left?
			{
				lrx -= tlx;	// Add the stuff too far left to the right border (tlx is neg. so - and - gets + ;)
				tlx = 0;	// Set tlx to correct value
			}
			else if (lrx > 0x13FF) // Too far right?
			{
				tlx -= lrx - 0x13FF;	// Subtract what is to much from the left border
				lrx = 0x13FF;	// Set lrx to correct value
			}
			if (tly < 0)	// Too far top?
			{
				lry -= tly;	// Add the stuff too far top to the bottom border (tly is neg. so - and - gets + ;)
				tly = 0;	// Set tly to correct value
			}
			else if (lry > 0x0FFF) // Too far bottom?
			{
				tly -= lry - 0x0FFF;	// Subtract what is to much from the top border
				lry = 0x0FFF;	// Set lry to correct value
			}
			nmap->more1 = tlx>>8;	// Store the map extends
			nmap->more2 = tlx%256;
			nmap->more3 = tly>>8;
			nmap->more4 = tly%256;
			nmap->setMoreB1_2(lrx);
			nmap->setMoreB3_4(lry);
			nmap->morex = x;		// Store the treasure's location
			nmap->morey = y;
			Items->DeleItem(tmap);	// Delete the tattered map
		}
		else
			sysmessage(s, "You fail to decipher the map");		// Nope :P
		// Set the skill delay, no matter if it was a success or not
		Player->skilldelay.setSecs(SrvParms->skilldelay);
		soundeffect(Player, 0x0249);	// Do some inscription sound regardless of success or failure
		sysmessage(s, "You put the deciphered tresure map in your pack");	// YAY
	}
	else
		sysmessage(s, "You must wait to perform another action");	// wait a bit
}

// END OF: By Polygon


void cSkills::InitCraftingClass()
{
	Crafting.LoadOreTable();
}

////////////////////////////////////
// Begin Crafting Class Functions //
////////////////////////////////////

cCrafting::cCrafting()
{
	OreTableSize = 0;
	for (int x = 0; x < 50; x++)
		OreTable[x].InitNullValues();
}

void cCrafting::LoadOreTable()
{
	Script *Scp=findSection(resources_scp, "ORETABLE");
	if (!Scp) return;

	int loopexit = 0;
	while (Scp->NextLineSplitted() && (loopexit < 50))	// 50 sounds good.  I'll keep it from the copy/paste.
	{
		int OreSection;
		if (Scp->getKeyVal("MINEORE", &OreSection))
		{
			OreTable[OreTableSize].ScriptPos = OreSection;
			OreTableSize++;
			continue;
		}
	}
	Scp->Close();

	for (int y = 0; y < OreTableSize; y++)
		LoadOreResource(y, OreTable[y].ScriptPos);
}

void cCrafting::LoadOreResource(int pos, int ResourceNumber)
{
	Script *Scp=findSection(resources_scp, "ORETYPE", ResourceNumber);
	if (!Scp) return;

	int loopexit = 0;
	while (Scp->NextLineSplitted() && (loopexit < 50))
	{
		if (Scp->getKeyVal("ORECOLOR",		&OreTable[pos].OreColor)) continue;
		if (Scp->getKeyVal("INGOTCOLOR",	&OreTable[pos].IngotColor)) continue;
		if (Scp->getKeyVal("ITEMCOLOR",		&OreTable[pos].ItemColor)) continue;
		if (Scp->getKeyVal("NAME",			OreTable[pos].Name)) continue;
		if (Scp->getKeyVal("MINSKILL",		&OreTable[pos].MinSkill)) continue;
		if (Scp->getKeyVal("CHANCE",		&OreTable[pos].Chance)) continue;
		if (Scp->getKeyVal("SMITHMENU",		&OreTable[pos].SmithMenu)) continue;
		if (Scp->getKeyVal("TINKERMENU",	&OreTable[pos].TinkerMenu)) continue;
	}
	Scp->Close();
}
/*
struct OreInfo
{
	short OreColor;
	short IngotColor;	// switched colors between iron and silver :((
	short minskill;		// minimum skill to handle that ore
	short quota;		// relative(!) chance to mine that ore (quota/sum of all quotas)
	char *name;
};
const struct OreInfo OreTable[] =	// MUST be sorted by minskill
{
	{0x0000,0x0961,  0,2520,"Iron"},
	{0x0386,0x0386,650, 126,"Shadow"},
	{0x02C3,0x02C3,700, 112,"Merkite"},
	{0x046E,0x046E,750,  98,"Copper"},
	{0x0961,0x0000,790,  84,"Silver"},
	{0x02E7,0x02E7,800,  70,"Bronze"},
	{0x0466,0x0466,850,  56,"Golden"},
	{0x0150,0x0150,900,  42,"Agapite"},
	{0x022F,0x022F,950,  28,"Verite"},
	{0x0191,0x0191,990,  14,"Mythril"}
};
const short NumberOfOres = sizeof(OreTable)/sizeof(OreInfo);
*/
const sOreResource* cCrafting::GetByOreColor(unsigned short color)
{
	int i;
	for (i=0;i<OreTableSize;i++)		
	{
		if (color == OreTable[i].OreColor)
			return &OreTable[i];
	}
	LogError("Something went wrong with mining");
	return NULL;
}

const sOreResource* cCrafting::GetByIngotColor(unsigned short color)
{
	int i;
	for (i=0;i<OreTableSize;i++)		
	{
		if (color == OreTable[i].IngotColor)
			return &OreTable[i];
	}
	LogError("Something went wrong with mining");
	return NULL;
}

const sOreResource* cCrafting::GetByItemColor(unsigned short color)
{
	int i;
	for (i=0;i<OreTableSize;i++)		
	{
		if (color == OreTable[i].OreColor)
			return &OreTable[i];
	}
	LogError("Something went wrong with mining");
	return NULL;
}

const sOreResource* cCrafting::getColorFound(unsigned short skill)
{
	int i,totalQuotas=0,minersQuota=0;

	for (i=0;i<OreTableSize;i++)		
	{
		if (OreTable[i].MinSkill<=skill)		// get his part of quotas depending on his skill
			minersQuota += OreTable[i].Chance;
		else
			break;
	}
	if (minersQuota < 1) return NULL;
	int r = rand()%minersQuota;

	for (i=0;i<OreTableSize;i++)		
	{
		totalQuotas += OreTable[i].Chance;	// summarize quotas until we find the ore
		if (r < totalQuotas)
			return &OreTable[i];
		if (OreTable[i].MinSkill > skill)
		{
			LogError("Something went wrong with mining");
			break;
		}
	}
	return &OreTable[0];	// shouldn't get here, but return iron as default anyway
}

void sOreResource::InitNullValues()
{
	this->Chance = 1;
	this->IngotColor = 0;
	this->OreColor = 0;
	this->MinSkill = 0;
	this->SmithMenu = -1;
	this->TinkerMenu = -1;
	this->ScriptPos = -1;
	strcpy(this->Name, "#");
}

bool cSkillManagement::CheckSkill(P_CHAR pc, unsigned short int sk, int low, int high)
{
	if (!pc) return false;

	if (high>1200) high=1200;
	if (high==low)
	{
		LogErrorVar("minskill equals maxskill <%d>", high);
		return 0;
	}

	UOXSOCKET s=-1;
    if (!pc->npc) s=pc->calcSocket();

	if (pc->dead) // fix for magic resistance exploit and probably others too, LB
	{
		sprintf(temp,"Ghosts can not train %s",skillname[sk].c_str());
		sysmessage(s, temp );
		return 0;
	}

	if (pc->isGM()) return 1;
	if (skill[sk].reveals) pc->unhide();

	int charrange=pc->Skill(sk)-low;	// how far is the player's skill above the required minimum ?
	if (charrange<0) return 0; //changed to return, because you should have no chance for sucess with skill<minimum required (thrawn)

	float chance = ((charrange*990)/(high-low));		// removed the 10% minimal chance (thrawn)
	if (chance>990) chance=990;	// *allways* a 1% chance of failure
	
	bool skillused=0;
	if ( chance >= rand()%1000 ) skillused = 1;

	if (pc->cell) return skillused;

	unsigned char r = calcRegionFromXY(pc->pos);
	if (region[r].isArena()) return skillused; // no skillgain inside an area, to prevent powergaming

	if (pc->getRealSkill(sk) < high)
	{
		if (sk!=MAGERY || (sk==MAGERY && !pc->npc && pc->GetCastingSpellType()==0))
		{
			if (SkillManager->AdvanceSkill(pc, sk, skillused))
			{
				SkillManager->updateSkillLevel(pc, sk); 
				if (!pc->npc && pc->InGame()) updateskillPacket(s, sk);
			}
		}
	}
	return skillused;
}

//////////////////////////////
// name:	FindAdvanceInfo
// history:	by Duke, 6.1.2003
// Purpose: finds the appropriate line for the used skill in advance table
//
advance_st* cSkillManagement::FindAdvanceInfo(int sk, int val)
{
	int id = sk;
	if (skill[sk].advance_like != -1)		// if this skill has no own advancetable
		id=skill[sk].advance_like;

	int i=skill[id].advance_index;
	int loopexit=0;
	while (		wpadvance[i+1].skid==id 	// if NEXT line is for same skill
			&&	wpadvance[i+1].base <= val	// and is not higher than our current value
			&& (++loopexit < MAXLOOPS) )
	{
		i++;								// then proceed to it !
	}
	return &wpadvance[i];
}

bool cSkillManagement::AdvanceSkill(P_CHAR pc, int sk, char skillused)
{
	if (!pc) return 0;
	unsigned int incval;
	unsigned char lockstate;

	lockstate=pc->lockSkill[sk];
	if (pc->isGM()) lockstate=0;
	// for gms no skill cap exists, also ALL skill will be interpreted as up, no matter how they are set

	if (lockstate==2 || lockstate==1) return 0;		// skill is locked -> forget it
	// also NOthing happens if you train a skill marked for atrophy !!!
	// skills only fall if others raise, ( osi quote ), so my interpretion
	// is that those marked as falling cant fall if you use them directly
	// exception: if you are gm its ignored! 
	
	this->AdvanceStats(pc, sk);

	int c=0;
	int atrophy_candidates[ALLSKILLSMAX+1];
	int ski=SkillManager->getAllSkillsValue();
	for (int b=0;b<(ski);b++) 
	{
		if (pc->lockSkill[b]==1 && pc->getRealSkill(b)!=0) // only count atrophy candidtes if they are above 0 !!!
		{
			atrophy_candidates[c]=b;
			c++;
		}
	}

	unsigned int skillsum = 0;
	if (!pc->isGM())
	{
		skillsum = pc->getSkillSum() / 10;

		if (skillsum >= SrvParms->skillcap && c==0) // skill capped and no skill is marked as fall down.
		{
			sprintf(temp,"You have reached the skill-cap of %i and no skill can fall!", SrvParms->skillcap);
			sysmessage(pc->calcSocket(),temp);
			return 0;
		}

	} else skillsum=0;
	
	advance_st* Adv = this->FindAdvanceInfo(sk, pc->getRealSkill(sk));
	if (skillused)
		incval=Adv->success*10;
	else
		incval=Adv->failure*10;

	bool advanced = false;
	//if (incval>rand()%1000)
	if (incval>rand()%SrvParms->skilladvancemodifier)
	{
		advanced = true;
		pc->chgRealSkill(sk,1);			
	}

	if (advanced)
	{
		// no atrophy for gm's !! 
		if (skillsum >= SrvParms->skillcap) // atrophy only if cap is reached !!!
		// if we are above the skill cap -> we have to let the atrophy candidates fall
		// important: we have to let 2 skills fall, or we'll never go down to cap
		// (especially if we are far above the cap from previous verisons)
		{
			int d=0;
			int dsk = 0;	// the skill to be decreased
			if (c==1) 
			{
				dsk = atrophy_candidates[0];
				if (pc->getRealSkill(dsk)>=2) d=2; else d=1; // avoid value below 0 (=65535 cause unsigned)
				{ 
					if (d==1 && pc->getRealSkill(dsk)==0) d=0; // should never happen ...
						pc->chgRealSkill(dsk, -d);
					this->updateSkillLevel(pc, dsk); 		// we HAVE to correct the skill-value
					updateskillPacket(pc->calcSocket(), dsk); // and send changed skill values packet so that client can re-draw correctly			
				}
			// this is very important cauz this is ONLY done for the calling skill value automatically .
			} 
			else
			{
				if (c!=0) d=rand()%c; else d=0;
				dsk = atrophy_candidates[d];
				if (pc->getRealSkill(dsk)) 
				{
					pc->chgRealSkill(dsk,-1);
					this->updateSkillLevel(pc, dsk); 	
					updateskillPacket(pc->calcSocket(), dsk); 				
				}

				if (c!=0) d=rand()%c; else d=0;
				dsk = atrophy_candidates[d];
				if (pc->getRealSkill(dsk)) 
				{
					pc->chgRealSkill(dsk,-1);
					this->updateSkillLevel(pc, dsk); 	
					updateskillPacket(pc->calcSocket(), dsk); 			
				}
			}
		}
	}
	return advanced;
}

//////////////////////////////
// name:	AdvanceOneStat
// history:	by Duke, 21 March 2000
// Purpose: little helper functions for cSkills::AdvanceStats
//			finds the appropriate line for the used skill in advance table
//
int cSkillManagement::calcStatIncrement(int stat, int val)
{
	advance_st* Adv = this->FindAdvanceInfo(stat, val);
	return Adv->success;
}

///////////////////////////////
// name:	AdvanceStats
// history: revamped by Duke, 21 March 2000
// Purpose: Advance STR, DEX and INT after use of a skill
//			checks if STR+DEX+INT are higher than statcap from server.scp
//			gives all three stats the chance (from skills.scp & server.scp) to rise
//			and reduces the two other stats if necessary
//
void cSkillManagement::AdvanceStats(P_CHAR pc, int sk)
{
	bool update=false;
	bool atCap=false;
	bool isGM=false;

	if (pc->isGM())		// a GM ?
		isGM=true;
	if (pc->realStr() + pc->realDex() + pc->realInt() >= (int)SrvParms->statcap)
		atCap = true;
	
	int mod=SrvParms->statsadvancemodifier;
	
	if (skill[sk].st>rand()%mod)
		if (pc->incDecStr(calcStatIncrement(STR,pc->realStr())))
		{
			update = true;
			if (atCap)
				if (rand()%2) pc->chgRealDex(-1); else pc->chgRealInt(-1);
		}
	
	if (skill[sk].dx>rand()%mod)
		if (pc->incDecDex(calcStatIncrement(DEX,pc->realDex())))
		{
			update = true;
			if (atCap)
				if (rand()%2) pc->chgRealStr(-1); else pc->chgRealInt(-1);
		}
	
	if (skill[sk].in>rand()%mod)
		if (pc->incDecInt(calcStatIncrement(INTELL,pc->realInt())))
		{
			update = true;
			if (atCap)
				if (rand()%2) pc->chgRealStr(-1); else pc->chgRealDex(-1);
		}
	
	int i,so;
	so=pc->calcSocket();
	if (update && (so!=-1))
	{
		statwindow(so, pc);				// update client's status window
		int ski=SkillManager->getAllSkillsValue();
		for (i=0; i<ski; i++)
		{
			updateSkillLevel(pc, i);	// update client's skill window
		}
		if (atCap && !isGM)
		{
			sprintf(temp,"You have reached the stat-cap of %i!" ,SrvParms->statcap);
			sysmessage(so,temp);
		}
	}
}

int cSkillManagement::getAllSkillsValue(void)
{
	if (SrvParms->AOS_Mode) return ALLSKILLSAOS; else return ALLSKILLSNONAOS;
}

void cSkillManagement::SkillUse(int s, int x) // Skill is clicked on the skill list
{
	P_CHAR Player = MAKE_CHARREF_LR(currchar(s));
	if (Player->cell>0)
	{
		sysmessage(s,"you are in jail and cant gain skills here!");
		return;
	}
	if (Player->dead)
	{
		sysmessage(s,"You cannot do that as a ghost.");
		return;
	}
	if (x!=STEALTH)
		Player->unhide();

	Player->disturbMed(); // Meditation

	if (Player->IsCasting())
	{
		sysmessage( s, "You can't do that while you are casting" );
		return;
	}
	if (!Player->skilldelay.hasExpired() && !Player->isGM())
	{
		sysmessage(s, "You must wait a few moments before using another skill.");
		return;
	}
	switch(x)
	{
	case ARMSLORE:
		target(s, 29, "What item do you wish to get information about?");
		break;
	case ANATOMY:
		target(s, 37, "Whom shall I examine?");
		break;
	case ITEMID:
		target(s, 40, "What do you wish to appraise and identify?");
		break;
	case EVALUATINGINTEL:
		target(s, 41, "What would you like to evaluate?");
		break;
	case TAMING:
		target(s, 42, "Tame which animal?");
		break;
	case HIDING:
		Skills->Hide(s);
		break;
	case STEALTH:
		Skills->Stealth(s);
		break;
	case DETECTINGHIDDEN:
		target(s, 77, "Where do you wish to search for hidden characters?");
		break;
	case PEACEMAKING:
		Skills->PeaceMaking(s);
		break;
	case PROVOCATION:
		target(s, 79, "Whom do you wish to incite?");
		break;
	case ENTICEMENT:
		target(s, 81, "Whom do you wish to entice?");
		break;
	case SPIRITSPEAK:
		Skills->SpiritSpeak(s);
		break;
	case STEALING:
		if (SrvParms->rogue)
			target(s,205, "What do you wish to steal?");
		else
			sysmessage(s, "That skill has been disabled.");
		break;
	case INSCRIPTION:
		target(s, 160, "What do you wish to place a spell on?");
		break;
	case TRACKING:
		Skills->TrackingMenu(s,TRACKINGMENUOFFSET);
		break;
	case BEGGING:
		target(s, 152, "Whom do you wish to annoy?");
		break;
	case ANIMALLORE:
		target(s, 153, "What animal do you wish to get information about?");
		break;
	case FORENSICS:
		target(s, 154, "What corpse do you want to examine?");
		break;
	case POISONING:
		target(s, 155, "What poison do you want to apply?");
		break;
	case TASTEID:
		target(s, 70, "What do you want to taste?");
		break;
	case MEDITATION:  //Morrolan - Meditation
		if (SrvParms->armoraffectmana)
			Skills->Meditation(s);
		else
			sysmessage(s, "Meditation is turned off.  Tell your GM to enable ARMOR_AFFECT_MANA_REGEN in server.scp to enable it.");
		break;
	case CARTOGRAPHY:	//	By Polygon:	Added support for cartography skill
		Skills->Cartography(s);
		break;
	default:
		sysmessage(s, "That skill has not been implemented yet.");
		return;
	}
	Player->skilldelay.setSecs(SrvParms->skilldelay);
}


// Calculate the skill of this character based on the characters baseskill and stats
void cSkillManagement::updateSkillLevel(P_CHAR pc, int sk)
{
	if (!pc) return;
	int temp = (((skill[sk].st * pc->effStr()) / 100 +
		(skill[sk].dx * pc->effDex()) / 100 +
		(skill[sk].in * pc->effInt()) / 100)
		*(1000-pc->getRealSkill(sk)))/1000+pc->getRealSkill(sk);
	
	pc->skill[sk] = max(static_cast<unsigned int>(pc->getRealSkill(sk)), static_cast<unsigned int>(temp));
}


cSkillManagement::cSkillManagement(void):wpadvance("wpadvance"), skill("lliks")
{
	skillname[ALCHEMY]="ALCHEMY";skillname[ANATOMY]="ANATOMY";
	skillname[ANIMALLORE]="ANIMALLORE";skillname[ARMSLORE]="ARMSLORE";
	skillname[PARRYING]="PARRYING";skillname[BEGGING]="BEGGING";
	skillname[BLACKSMITHING]="BLACKSMITHING";skillname[BOWCRAFT]="BOWCRAFT";
	skillname[PEACEMAKING]="PEACEMAKING";skillname[CAMPING]="CAMPING";
	skillname[CARPENTRY]="CARPENTRY";skillname[CARTOGRAPHY]="CARTOGRAPHY";
	skillname[COOKING]="COOKING";skillname[DETECTINGHIDDEN]="DETECTINGHIDDEN";
	skillname[ENTICEMENT]="ENTICEMENT";skillname[EVALUATINGINTEL]="EVALUATINGINTEL";
	skillname[HEALING]="HEALING";skillname[FISHING]="FISHING";
	skillname[FORENSICS]="FORENSICS";skillname[HERDING]="HERDING";
	skillname[HIDING]="HIDING";skillname[PROVOCATION]="PROVOCATION";
	skillname[INSCRIPTION]="INSCRIPTION";skillname[LOCKPICKING]="LOCKPICKING";
	skillname[MAGERY]="MAGERY";skillname[MAGICRESISTANCE]="MAGICRESISTANCE";
	skillname[TACTICS]="TACTICS";skillname[SNOOPING]="SNOOPING";
	skillname[MUSICIANSHIP]="MUSICIANSHIP";skillname[POISONING]="POISONING";
	skillname[ARCHERY]="ARCHERY";skillname[SPIRITSPEAK]="SPIRITSPEAK";
	skillname[STEALING]="STEALING";skillname[TAILORING]="TAILORING";
    skillname[TAMING]="TAMING";skillname[TASTEID]="TASTEID";
	skillname[TINKERING]="TINKERING";skillname[TRACKING]="TRACKING";
	skillname[VETERINARY]="VETERINARY";skillname[SWORDSMANSHIP]="SWORDSMANSHIP";
	skillname[MACEFIGHTING]="MACEFIGHTING";skillname[FENCING]="FENCING";
	skillname[WRESTLING]="WRESTLING";skillname[LUMBERJACKING]="LUMBERJACKING";
	skillname[MINING]="MINING";skillname[MEDITATION]="MEDITATION";
	skillname[STEALTH]="STEALTH";skillname[ITEMID]="ITEMID";
	skillname[REMOVETRAPS]="REMOVETRAPS";
	skillname[NECROMANCY]="NECROMANCY";
	skillname[FOCUS]="FOCUS";
	skillname[CHIVALRY]="CHIVALRY";
	skillname[STR]="STR";
	skillname[DEX]="DEX";
	skillname[INTELL]="INT";
	skillname[FAME]="FAME";
	skillname[KARMA]="KARMA";
}


void cSkillManagement::loadskills()
{
	int i, l=0;

	bool newone=false;
	for (i=0;i<SKILLS;i++) // lb
	{
		skill[i].st=0;
		skill[i].dx=0;
		skill[i].in=0;
		skill[i].advance_like=-1;
		skill[i].advance_index=l;
		skill[i].reveals = false;

		Script *Scp=findSection(skills_scriptnew,"SKILL",i);
		if (!Scp) continue;

		int loopexit=0;	
		while (Scp->NextLineSplitted() && (++loopexit < 50))	// no more than 50 lines in one section
		{			
			if (i==INTELL) newone=true;

			if (Scp->getKeyVal("STR",		&(skill[i].st)))		continue;
			if (Scp->getKeyVal("DEX",		&(skill[i].dx)))		continue;
			if (Scp->getKeyVal("INT",		&(skill[i].in)))		continue;
			if (Scp->getKeyVal("ADVANCE",	&(skill[i].advance_like)))	continue;
			if (!strcmp("SKILLPOINT", script1))
			{
				wpadvance[l].skid=i;
				gettokennum(script2, 0);
				wpadvance[l].base=str2num(gettokenstr);
				gettokennum(script2, 1);
				wpadvance[l].success=str2num(gettokenstr);
				gettokennum(script2, 2);
				wpadvance[l].failure=str2num(gettokenstr);
				l++;
			}
			if (!strcmp("REVEAL", script1)) skill[i].reveals = true;
		}
		Scp->Close();	
	}

	if (!newone)
	{
		LogError("FATAL error: skillsnew.scp in OLD skills.scp format\n");
		Console.send("FATAL error: skillsnew.scp in OLD skills.scp format\n");
		exit(-1);
	}

}

void cSkillManagement::skillVars(void)
{
	strcpy(skill[ALCHEMY].madeword,"mixed");
	strcpy(skill[ANATOMY].madeword,"made");
	strcpy(skill[ANIMALLORE].madeword,"made");
	strcpy(skill[ITEMID].madeword,"made");
	strcpy(skill[ARMSLORE].madeword,"made");
	strcpy(skill[PARRYING].madeword,"made");
	strcpy(skill[BEGGING].madeword,"made");
	strcpy(skill[BLACKSMITHING].madeword,"forged");
	strcpy(skill[BOWCRAFT].madeword,"bowcrafted");
	strcpy(skill[PEACEMAKING].madeword,"made");
	strcpy(skill[CAMPING].madeword,"made");
	strcpy(skill[CARPENTRY].madeword,"made");
	strcpy(skill[CARTOGRAPHY].madeword,"written");
	strcpy(skill[COOKING].madeword,"cooked");
	strcpy(skill[DETECTINGHIDDEN].madeword,"made");
	strcpy(skill[ENTICEMENT].madeword,"made");
	strcpy(skill[EVALUATINGINTEL].madeword,"made");
	strcpy(skill[HEALING].madeword,"made");
	strcpy(skill[FISHING].madeword,"made");
	strcpy(skill[FORENSICS].madeword,"made");
	strcpy(skill[HERDING].madeword,"made");
	strcpy(skill[HIDING].madeword,"made");
	strcpy(skill[PROVOCATION].madeword,"made");
	strcpy(skill[INSCRIPTION].madeword,"written");
	strcpy(skill[LOCKPICKING].madeword,"made");
	strcpy(skill[MAGERY].madeword,"envoked");
	strcpy(skill[MAGICRESISTANCE].madeword,"made");
	strcpy(skill[TACTICS].madeword,"made");
	strcpy(skill[SNOOPING].madeword,"made");
	strcpy(skill[MUSICIANSHIP].madeword,"made");
	strcpy(skill[POISONING].madeword,"made");
	strcpy(skill[ARCHERY].madeword,"made");
	strcpy(skill[SPIRITSPEAK].madeword,"made");
	strcpy(skill[STEALING].madeword,"made");
	strcpy(skill[TAILORING].madeword,"sewn");
	strcpy(skill[TAMING].madeword,"made");
	strcpy(skill[TASTEID].madeword,"made");
	strcpy(skill[TINKERING].madeword,"made");
	strcpy(skill[TRACKING].madeword,"made");
	strcpy(skill[VETERINARY].madeword,"made");
	strcpy(skill[SWORDSMANSHIP].madeword,"made");
	strcpy(skill[MACEFIGHTING].madeword,"made");
	strcpy(skill[FENCING].madeword,"made");
	strcpy(skill[WRESTLING].madeword,"made");
	strcpy(skill[LUMBERJACKING].madeword,"made");
	strcpy(skill[MINING].madeword,"smelted");
	strcpy(skill[MEDITATION].madeword,"envoked");
	strcpy(skill[STEALTH].madeword,"made");
	strcpy(skill[REMOVETRAPS].madeword,"made");
	strcpy(skill[NECROMANCY].madeword,"rot");
	strcpy(skill[FOCUS].madeword,"made");
	strcpy(skill[CHIVALRY].madeword,"enlighted");

}


char* cSkillManagement::getMadeWord(int sk)
{
	return skill[sk].madeword;
}

const char* cSkillManagement::getSkillName(int sk)
{
	return skillname[sk].c_str();
}
