/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __SKILLS_H__
#define __SKILLS_H__

#include "typedefs.h"
#include "CArray.h"
#include "globals.h"


enum skillenum
{
	ALCHEMY=0,
	ANATOMY=1,
	ANIMALLORE=2,
	ITEMID=3,
	ARMSLORE=4,
	PARRYING=5,
	BEGGING=6,
	BLACKSMITHING=7,
    BOWCRAFT=8,
    PEACEMAKING=9,
    CAMPING=10,
    CARPENTRY=11,
    CARTOGRAPHY=12,
    COOKING=13,
    DETECTINGHIDDEN=14,
    ENTICEMENT=15,
    EVALUATINGINTEL=16,
    HEALING=17,
    FISHING=18,
    FORENSICS=19,
    HERDING=20,
	HIDING=21,
    PROVOCATION=22,
    INSCRIPTION=23,
    LOCKPICKING=24,
    MAGERY=25,
    MAGICRESISTANCE=26,
    TACTICS=27,
    SNOOPING=28,
    MUSICIANSHIP=29,
    POISONING=30,
    ARCHERY=31,
    SPIRITSPEAK=32,
    STEALING=33,
    TAILORING=34,
    TAMING=35,
    TASTEID=36,
    TINKERING=37,
    TRACKING=38,
    VETERINARY=39,
    SWORDSMANSHIP=40,
    MACEFIGHTING=41,
    FENCING=42,
    WRESTLING=43,
    LUMBERJACKING=44,
    MINING=45,
	MEDITATION=46,
    STEALTH=47,
    REMOVETRAPS=48,
	ALLSKILLSNONAOS=49,
	ALLSKILLSAOS=52,
	ALLSKILLSMAX=52, // for array declaration
	NECROMANCY=49,
	FOCUS=50,
	CHIVALRY=51,
	STR=52,        // for the set 
	DEX=53,
	INTELL=54,
	FAME=55,
	KARMA=56,
	SKILLS=57,
	ALL=123,
};

struct advance_st
{
	unsigned char skid;
	int base;
	int success;
	int failure;
};

struct skill_st
{
	int st;
	int dx;
	int in;
	int advance_like;
	int advance_index;
	char madeword[50]; // Added by Magius(CHE)
	bool reveals; //added by thrawn: skill reveals the player if true
};

struct sOreResource
{
	void InitNullValues();
	char Name[20];
	short OreColor;
	short IngotColor;
	short ItemColor;		// used for smelting items into ingots
	short MinSkill;
	int Chance;
	int SmithMenu;
	int TinkerMenu;
	int ScriptPos;
};

class cCrafting
{
private:		// variables
	sOreResource OreTable[50];
	int OreTableSize;
private:		// functions
	void LoadOreResource(int pos, int ResourceNumber);
public:
	cCrafting();
	void LoadOreTable();
	const sOreResource* GetByOreColor(unsigned short color);
	const sOreResource* GetByIngotColor(unsigned short color);
	const sOreResource* GetByItemColor(unsigned short color);
	const sOreResource* getColorFound(unsigned short skill);
};

class cSkills
{
public:		// variables
	cCrafting Crafting;
private:
	void Tracking(int s, int selection);
	int  GetSubIngotAmt(int p, char id1, char id2, char color1, char color2);
	int  DeleSubIngot(int p, int id1, int id2, int color1, int color2, int amount);
	void PlayInstrumentWell(int s, P_ITEM Instrument);
	void PlayInstrumentPoor(int s, P_ITEM Instrument);
	P_ITEM GetInstrument(int s);
	int  CalcRank(int s, P_CHAR Player, int skill); // by Magius(CHE)
	void ApplyRank(int s, P_ITEM pi,int rank); // by Magius(CHE)
	void Zero_Itemmake(int s); // by Magius(CHE)
public:
	void Meditation(int s);
	void Hide(int s);
	void Stealth(int s);
	void PeaceMaking(int s);
	void InitCraftingClass();
	void RepairTarget(UOXSOCKET s, P_CHAR Player, P_ITEM pi); // Ripper
	void SmeltItemTarget(UOXSOCKET s, P_CHAR Player, P_ITEM pi); // Ripper
	void TasteIDTarget(int s, P_CHAR Player, P_ITEM pi);
	int  TrackingDirection(int s, P_CHAR pc_i);
	void CreatePotion(P_CHAR pc, char type, char sub, P_ITEM Mortar);
	void TinkerAxel(int s, P_ITEM pi);
	void TinkerAwg(int s, P_ITEM pi);
	void TinkerClock(int s, P_ITEM pi);
	void MakeDough(int s, P_CHAR Player, P_ITEM pi);
	void MakePizza(int s, P_CHAR Player, P_ITEM pi);
	void Track(P_CHAR Player);
	void DoPotion(int s, int type, int sub, P_ITEM Mortar);
	void Tailoring(int s, P_CHAR Player, P_ITEM pi);
	void Fletching(int s, P_CHAR Player, P_ITEM pi);
	void BowCraft(int s, P_CHAR Player,const P_ITEM pi);
	void Carpentry(int s, P_CHAR Player, P_ITEM pi);
	void Smith(int s, P_ITEM pi);
	void MakeMenuTarget(int s, int x, int skill);
	void MakeMenu(int s, int m, int skill);
	void Mine(int s, P_CHAR Player);
	void GraveDig(int s);
	void SmeltOre(int s, P_CHAR Player, P_ITEM pi);
	void Wheel(int s, P_CHAR Player, P_ITEM pi, int mat);
	void Loom(int s, P_CHAR Player, P_ITEM pi);
	void CookOnFire(int s, P_CHAR Player, PC_ITEM pi, short id, char* matname);
	void TreeTarget(int s,P_CHAR Player);
	void DetectHidden(UOXSOCKET s, P_CHAR Player);
	void ProvocationTarget1(UOXSOCKET s, P_CHAR pc);
	void ProvocationTarget2(UOXSOCKET s, P_CHAR pc);
	void EnticementTarget1(UOXSOCKET s, P_CHAR pc);
	void EnticementTarget2(UOXSOCKET s, P_CHAR pc);
	void AlchemyTarget(int s, P_ITEM pi);
	void BottleTarget(int s,P_CHAR Player, P_ITEM pi);
	void PotionToBottle(P_CHAR pc, P_ITEM Mortar);
	void CreateBandageTarget(int s, P_CHAR Player, P_ITEM pi);
	void HealingSkillTarget(int s, P_CHAR Player, P_CHAR pc);
	void SpiritSpeak(int s);
	void ArmsLoreTarget(int s, P_CHAR Player, P_ITEM pi);
	void ItemIdTarget(int s, P_CHAR Player, P_ITEM pi);
	void EvaluateIntTarget(UOXSOCKET s, P_CHAR Player, P_CHAR pc);
	void AnatomyTarget(int s, P_CHAR Player, P_CHAR pc);
	void TameTarget(int s, P_CHAR Player, P_CHAR pc);
	void TameTargetPart2(P_CHAR Tamer, P_CHAR Pet);
	void TameTargetPart3(P_CHAR Tamer, P_CHAR Pet);
	int  GetCombatSkill(P_CHAR pc);
	void StealingTarget(int s, P_CHAR Player, int serial);
	void PickPocketTarget(int s);
	void CreateTrackingMenu(int s, int m);
	void TrackingMenu(int s, int gmindex);
	void BeggingTarget(int s, P_CHAR Player, P_CHAR pc);
	void AnimalLoreTarget(int s, P_CHAR Player, P_CHAR pc);
	void ForensicsTarget(int s, P_CHAR Player, P_ITEM pi);
	void PoisoningTarget(int s, P_CHAR Player, P_ITEM pi);
	void Inscribe(int s, P_ITEM pi);
	int  EngraveAction(int s, P_ITEM pi, int cir, int spl);
	void LockPick(int s, P_CHAR Player, P_ITEM pi);
	void TDummy(int s);
	void NewDummy(unsigned int currenttime);
	void Tinkering(int s, P_CHAR Player, P_ITEM pi);
	void AButte(int s1, P_ITEM pButte);
	void Persecute(UOXSOCKET s);//AntiChrist persecute stuff
	void Cartography(int s); // By Polygon - opens the cartography skillmenu
	bool HasEmptyMap(P_CHAR Player); // By Polygon - checks if player has an empty map
	bool DelEmptyMap(P_CHAR Player); // By Polygon - deletes an empty map from the player's pack
	void Decipher(P_ITEM tmap, int s); // By Polygon - attempt to decipher a tattered treasure map
	int  GetAntiMagicalArmorDefence(P_CHAR pc); // blackwind meditation armor stuff
	void Snooping(P_CHAR, P_ITEM);
	
};


/// skill checks & advancement stuff
class cSkillManagement
{
   public:

	 cSkillManagement::cSkillManagement(void);
     bool AdvanceSkill(P_CHAR pc, int sk, char skillused);
	 char* getMadeWord(int sk);
	 const char* getSkillName(int sk);
	 void updateSkillLevel(P_CHAR pc, int skill);
	 void SkillUse(int s, int x);
	 void loadskills(); // to be mvoed to c'tor
	 void skillVars();  // to be moved to c'tor
	 bool CheckSkill(P_CHAR pc,unsigned short int sk, int low, int high);
	 advance_st* FindAdvanceInfo(int sk, int val);
	 int calcStatIncrement(int stat, int val);
	 void AdvanceStats(P_CHAR pc, int sk);
	 int getAllSkillsValue(void);

   private:

	   CArray<1000, advance_st>wpadvance;
       CArray<SKILLS+1, skill_st>skill;
	   std::string skillname[SKILLS+1];	

};


void TellScroll( char *menu_name, int player, long item_param );

#endif
