/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__STORAGE_H__)
#define __STORAGE_H__

// Platform specifics
#include "platform.h"

// System includes

#include <iterator>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

// Forward class definition


// wolfpack includes
#include "typedefs.h"

// Class definition


template<class T> class Storage_cl
{
public:
	Storage_cl();
	~Storage_cl();
	bool insert(T& cData, int serial);
	bool insert(T* ptrData, int serial);
	int Count(void);
	T* getPtr(int serial);
	T* Next(int &offset);
	
	void remove(int serial);
	T* operator[](long index);
	
private:
	std::map<int, T*> mapData;
	typename std::map<int, T*>::iterator iterData;
	vector<int> indices;
};

class Container_cl
{
public:
	Container_cl();
	~Container_cl();
	bool insert(SERIAL serContainer, SERIAL serObject);
	vector<SERIAL> getData(SERIAL serContainer);
	bool find(SERIAL serContainer, SERIAL serObject);
	bool remove(SERIAL serContainer, SERIAL serObject);
	
private:
	multimap<SERIAL, SERIAL> mapData;
	multimap<SERIAL, SERIAL>::iterator iterData;
};

#endif

