/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////
// Name:	teleport.cpp
// Purpose: functions that handle the teleporting
// History:	cut from wolfpack.cpp by Duke, 26.10.00
// Remarks:	not necessarily ALL those functions
//

#include "teleport.h"

#include "mapstuff.h"
#include "regions.h"
#include "skills.h"
#include "SndPkg.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "teleport.cpp"

struct tele_locations_st 
{
	cCoord destination, origem;
};

std::multimap <int, tele_locations_st> tele_locations; // can't use a map here, so using a multimap with x as the key :(


void teleporters(P_CHAR pc)
{
	multimap<int, tele_locations_st>::iterator itl;
	itl = tele_locations.find(pc->pos.x);
	
	int loopexit=0;
	while ((pc->pos.x == itl->second.origem.x && itl != tele_locations.end()) && ++loopexit<MAXLOOPS)
	{
		if (pc->pos.y == itl->second.origem.y)
		{
			if ((itl->second.origem.z == illegal_z)||(pc->pos.z == itl->second.origem.z))
			{
				pc->teleTo(itl->second.destination);
				return;
			}
		}
		itl++;
	}
}

void read_in_teleport(void)
{
	FILE *fp;
	char text[256];
	char seps[]	= " ,\t\n";
	char *token;

	fp = fopen("teleport.scp","r");

	if (fp==NULL)
	{
		Console.send("ERROR: Teleport Data not found\n");
		error=1;
		keeprun=0;
		return;
	}

	int loopexit=0;
	while(!feof(fp) && ++loopexit<MAXLOOPS*17)
	{
		fgets(text,255,fp);

		if (text[0]!=';')
		{
			tele_locations_st dummy;

			token = strtok( text, seps );
			
			dummy.origem.x = atoi(token);
			token = strtok( NULL, seps );
			dummy.origem.y = atoi(token);
			token = strtok( NULL, seps );
			if (token[0] == 'A')
				dummy.origem.z = illegal_z;
			else
				dummy.origem.z = atoi(token);

			token = strtok( NULL, seps );
			dummy.destination.x = atoi(token);
			token = strtok(NULL, seps );
			dummy.destination.y = atoi(token);
			token = strtok(NULL, seps);
			dummy.destination.z = atoi(token);

			tele_locations.insert(make_pair(dummy.origem.x, dummy));
			
		}
	}
	fclose(fp);
}

int validtelepos(int s)
{
	cChar* pc = MAKE_CHARREF_LRV(currchar(s),-1);
	int z=-1;
	if ((pc->pos.x>=1397)&&(pc->pos.x<=1400)&&
		(pc->pos.y>=1622)&&(pc->pos.y<=1630))
		z=28;
	if ((pc->pos.x>=1510)&&(pc->pos.x<=1537)&&
		(pc->pos.y>=1455)&&(pc->pos.y<=1456))
		z=15;
	return z;
}

void advancementobjects(P_CHAR pc_s, int adv, int allways)
{
	if (!pc_s) return;

	if (pc_s->advobj!=0 && !allways)
	{
		sysmessage(pc_s->calcSocket(),"You have already used an advancement object with this character.");
		return;
	}

	staticeffect(pc_s, 0x373A, 0, 15);
	soundeffect2(pc_s, 0x01E9);
	pc_s->advobj=adv;

	Script *Scp=findSection(advance_script,"ADVANCEMENT",adv);
	if (!Scp)
	{
		LogWarningVar("ADVANCEMENT OBJECT: Script section <%i> not found.",adv);
		pc_s->advobj=0;
		return;
	}

	int loopexit=0;
	while (Scp->NextLineSplitted() && (++loopexit < 150))	// no more than 150 lines in one section
	{
		int rc = 0;
		if (!strcmp("STR",script1) || !strcmp("STRENGTH",script1))
		{
			pc_s->setStr(getstatskillvalue(script2));
		}
		if (!strcmp("DEX",script1) || !strcmp("DEXTERITY",script1))
		{
			pc_s->setDex(getstatskillvalue(script2));
		}
		if (!strcmp("INT",script1) || !strcmp("INTELLIGENCE",script1))
		{
			pc_s->setInt(getstatskillvalue(script2));
			pc_s->setDecInt(0);
		}
		
		rc = Npcs->ApplySkillTags(pc_s);
		if (rc) {if (rc==1) continue; else return;}
		
		if (!strcmp("DYEHAIR",script1))
		{
			cItem* Hair=pc_s->GetItemOnLayer(0x0B);
			if (Hair)
			{
				Hair->setColor(hstr2num(script2));
				Hair->refresh();
			}
		}
		
		if (!strcmp("DYEBEARD",script1))
		{
			cItem* Beard=pc_s->GetItemOnLayer(0x10);
			if (Beard)
			{
				Beard->setColor(hstr2num(script2));
				Beard->refresh();
			}
		}
		
		if (!strcmp("KILLHAIR",script1))
		{
			cItem* Hair=pc_s->GetItemOnLayer(0x0B);
			if (Hair)
				Items->DeleItem(Hair);
		}
		
		if (!strcmp("KILLBEARD",script1))
		{
			cItem* Beard=pc_s->GetItemOnLayer(0x10);
			if (Beard)
				Items->DeleItem(Beard);
		}
		
		if (!strcmp("KILLPACK",script1))
		{
			cItem* Pack=pc_s->GetItemOnLayer(0x15);
			if (Pack)
				Items->DeleItem(Pack);
		}
		if (!strcmp("ITEM",script1))
		{
			int x=str2num(script2);
			scpMark m=Scp->Suspend();
			P_ITEM pRetitem = Items->CreateScriptItem(x);
			Scp->Resume(m);
			strcpy(script1, "DUMMY");
			
			if (pRetitem!=NULL)
			{
				if (pRetitem->layer==0x0B || pRetitem->layer==0x10)
				{
					pRetitem->SetContSerial(pc_s->serial);
				}
				else
				{
					P_ITEM Pack=pc_s->GetItemOnLayer(0x15);
					if (Pack)
					{
						pRetitem->SetContSerial(Pack->serial);
						pRetitem->SetRandPosInCont(Pack);
					}
				}
				pRetitem->refresh();
			}
		}
		
		if (!strcmp(script1,"SKIN"))
		{
			pc_s->skin = pc_s->xskin = static_cast<UI16>(hstr2num(script2));
		}
		
		if (!strcmp("POLY",script1))
		{
			short x=hstr2num(script2);
			pc_s->setId(x);
			pc_s->setXid(x);
		}
		
		if (!strcmp("ADVOBJ",script1))
		{
			pc_s->advobj=str2num(script2);
		}
		
		if (!strcmp("RACE", script1))
		{
			pc_s->setRace(str2num(script2));
		}
	}

	SndRemoveNpcToAll(pc_s);	// force client to forget about the char. Needed for color change
	updatechar(pc_s);
	Scp->Close();
}


// dead code ???!
void monstergate(P_CHAR pc_s, int npcNum)
{
	int tmp, z, lovalue, hivalue;
	char sect[512];

	if (!pc_s) return;
	if (pc_s->npc) return;

	int storeval=-1;

	sprintf(sect, "NPC %i", npcNum);
	Script *pScpBase=i_scripts[npc_script];
	Script *pScp=pScpBase->Select(sect,custom_npc_script);
	if (!pScp) return;

	cSpawnContext CT;
	CT.Init();

	pc_s->title[0] = 0;
	PC_ITEM pi;
	AllItemsIterator aii;
	for (aii.Begin(); (pi = aii.GetData()) != aii.End(); aii++)
	{
		if (pc_s->Wears(pi) &&
			pi->layer!=0x15 && pi->layer!=0x1D &&
			pi->layer!=0x10 && pi->layer!=0x0B)
		{
			if (!CT.MyPack)
			{
				CT.MyPack=pc_s->getBackpack();
			}
			if (!CT.MyPack)
			{
				scpMark m=pScp->Suspend();
				CT.MyPack = pc_s->addBackpack();
				if (!CT.MyPack) return;
				pScp->Resume(m);

				CT.LastItem=CT.MyPack;
			}

			if (CT.MyPack) 
			{
				P_ITEM pi2 = pi->unconst();
				pi2->SetRandPosInCont(CT.MyPack);
				pi2->SetContSerial(CT.MyPack->serial);
				pi2->layer=0x00;
				
				SndRemoveItemToAll(pi2);
				pi2->refresh();
			}
		}
		else if (pc_s->Wears(pi) &&
			(pi->layer==0x0B || pi->layer==0x10))
		{
			Items->DeleItem(pi->unconst());
		}
	}

	int loopexit=0;
	do
	{
		pScp->NextLineSplitted();

		if (script1[0]!='}')
		{
			int rc = Npcs->ApplyCommonTags(pc_s);			// tags common to scp, wsc and monstergate
			if (rc) {if (rc==1) continue; else return;}

			rc = Npcs->ApplyBirthLootTags(pc_s, pScp, npcNum, &CT);	// loot related tags in scp and monstergate
			if (rc) {if (rc==1) continue; else return;}

			if (!strcmp("NAMELIST", script1))
			{
				scpMark m=pScp->Suspend();
				setrandomname(pc_s,script2);
				pScp->Resume(m);

				strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
			}
			if (!strcmp("ID",script1))
			{
				tmp=hstr2num(script2);
				pc_s->setId(tmp);
				pc_s->setXid(tmp);
			}
			if (!strcmp("SKIN",script1))
			{
				pc_s->skin = pc_s->xskin = hstr2num(script2);
			}

			if (!strcmp("ITEM",script1))
			{
				storeval=str2num(script2);
				scpMark m=pScp->Suspend();
				CT.LastItem = Items->CreateScriptItem(storeval);
				pScp->Resume(m);
				if (CT.LastItem)
				{
					CT.LastItem->SetContSerial(pc_s->serial);
					if (CT.LastItem->layer==0)
					{
						Console.send("Warning: Bad NPC Script %d with problem item %d executed!\n", npcNum, storeval);
					}
				}
				strcpy(script1, "DUMMY"); // Prevents unexpected matchups...
			}

			if (!strcmp("COLOR",script1))
			{
				if (CT.LastItem)
				{
					CT.LastItem->setColor(hstr2num(script2));
				}
			}
			if (!strcmp("COLORLIST",script1))
			{
				if (CT.LastItem)
				{
					scpMark m=pScp->Suspend();
					storeval=addrandomcolor(str2num(script2));
					CT.LastItem->setColor(storeval);
					pScp->Resume(m);
					strcpy(script1, "DUMMY"); // To prevent accidental exit of loop.
				}
			}

			//--------------------- NEW STAT & SKILL FORMAT ----------------
			//Handle Stats
			if (!strcmp("STR",script1) || !strcmp("STRENGTH",script1))
			{
				pc_s->setStr(getstatskillvalue(script2));
				pc_s->fullHp();
			}
			if (!strcmp("DEX",script1) || !strcmp("DEXTERITY",script1))
			{
				pc_s->setDex(getstatskillvalue(script2));
				pc_s->fullStm();
			}
			if (!strcmp("INT",script1) || ! strcmp("INTELLIGENCE",script1))
			{
				pc_s->setInt(getstatskillvalue(script2));
				pc_s->setDecInt(0);
				pc_s->mn = pc_s->effInt();
			}
			//Done Handling Stats

			//Handle Skills
			rc = Npcs->ApplySkillTags(pc_s);
			if (rc) {if (rc==1) continue; else return;}

			//Handle Extras
			if (!strcmp("DAMAGE",script1) || !strcmp("ATT",script1))
			{
				gettokennum(script2, 0);
				lovalue=str2num(gettokenstr);
				gettokennum(script2, 1);
				hivalue=str2num(gettokenstr);
				pc_s->lodamage = lovalue;
				pc_s->hidamage = lovalue;
				if (hivalue) pc_s->hidamage = hivalue;
			}
			if (!strcmp("DEF",script1)) pc_s->def = getstatskillvalue(script2);
			//Done Handling Extras

			//Handle Obsolete Stuff
			if (!strcmp("SKILL", script1))
			{
				gettokennum(script2, 0);
				z=str2num(gettokenstr);
				gettokennum(script2, 1);
				pc_s->setRealSkill(z,str2num(gettokenstr));
			}
			//Done Handling Obsolete Stuff
		}
	//--------------- DONE NEW STAT & SKILL FORMAT ---------------------
	}
	while ( (script1[0]!='}') && (++loopexit < MAXLOOPS) );
	pScp->Close();

	//Now find real 'skill' based on 'baseskill' (stat modifiers)
	int sk=SkillManager->getAllSkillsValue();
	for(z=0;z<sk;z++)
	{
		SkillManager->updateSkillLevel(pc_s,z);
	}
	updatechar(pc_s);
	staticeffect(pc_s, 0x373A, 0, 15);
	soundeffect2(pc_s, 0x01E9);
}

// new function 
////////////////////////////////// 
// This will be just a body type switching 
// and coloring item. 
// Uses the integer number of the monster type 
// from the npc file. 
// Gate has to be of type 84. 
// 
// 
void polycolorgate(P_CHAR pc_s, int x) 
{ 
	int tmp; 
	char sect[256]; 

	if (!pc_s) return; 
	if (pc_s->npc) return; 

	sprintf(sect, "NPC %i", x); 
	Script *pScpBase = i_scripts[npc_script]; 
	Script *pScp = pScpBase->Select(sect, custom_npc_script); 

	if (!pScp)
		return; 

	int loopexit = 0; 
	do 
	{ 
		pScp->NextLineSplitted(); 
		if (script1[0] != '}') 
		{ 
			if (!strcmp("ID", script1))
			{ 
				tmp = hstr2num(script2); 
				pc_s->setId(tmp);
				pc_s->setXid(tmp);
			} 
			else if (!strcmp("SKIN", script1))
			{ 
				pc_s->skin = pc_s->xskin = static_cast<UI16>(hstr2num(script2));
			} 
		} 
	} 
	while ((script1[0] != '}') &&(++loopexit < MAXLOOPS)); 
	pScp->Close(); 
  
	updatechar(pc_s); 
	staticeffect(pc_s, 0x373A, 0, 15); 
	soundeffect2(pc_s, 0x01E9); 
} 
// 
// 
// Aldur 
////////////////////////////////// 

void objTeleporters(P_CHAR pc_s)
{
	PC_ITEM pmi;
	int loopexit=0;
	RegGrid3x3Iterator4Items rg3ii(pc_s->pos);
	while((pmi = rg3ii.Next()) != NULL && (++loopexit < MAXLOOPS) )
	{
		if (pmi->pos.IsSameXY(pc_s->pos) &&
			((abs(pmi->pos.z) + 10) >= abs(pc_s->pos.z)) &&((abs(pmi->pos.z) - 10) <= abs(pc_s->pos.z)))
		{
			if ((pmi->isType(ITY_60)) && (pmi->morex + pmi->morey + pmi->morez >0))
			{
				cCoord newPos(pmi->morex,pmi->morey,pmi->morez,DEFAULT_MAP);
				pc_s->teleTo(newPos);
			}
			
			// advancement objects
			if (pmi->isType(ITY_80) && !pc_s->npc)
			{
				if (pmi->getMore1_4() != 0)
				{
					if (pc_s->serial == pmi->getMore1_4())
						advancementobjects(pc_s, pmi->morex, 0);
				}
				else
					advancementobjects(pc_s, pmi->morex, 0);
			}
			
			if (pmi->isType(ITY_81) && !pc_s->npc)
			{
				if (pmi->getMore1_4() != 0)
				{
					if (pc_s->serial == pmi->getMore1_4())
						advancementobjects(pc_s, pmi->morex, 1);
				}
				else
					advancementobjects(pc_s, pmi->morex, 1);
				// The above code lets you restrict a gate's use by setting its MORE values to a char's serial #
			}
			
			// damage objects
			if (!pc_s->isInvul() && pmi->isType(ITY_DamageObj))
			{
				pc_s->reduceHp(pmi->morex + RandomNum(pmi->morey, pmi->morez));
			}
			// monster gates
			if (pmi->isType(ITY_MonsterGate))
				monstergate(pc_s, pmi->morex);

			if (pmi->isType(ITY_84)) 		// This will be just a body type switching item. (Aldur)
				polycolorgate(pc_s, pmi->morex); 
			
			// sound objects
			if (pmi->isType(ITY_SoundObj))
			{
				if ((unsigned)RandomNum(1, 100) <= pmi->morez)
					soundeffect3(pmi, (pmi->morex << 8) + pmi->morey);
			}
		}
	}
}

