/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

////////////////////////
// name:	timers.cpp
// purpose:	implementation of basic timers
//
//

#include "timers.h"

#include "globals.h"

////////////
// Name:	cTimer
// history:	by Duke, 14.04.2002
// Purpose:	encapsulation for simple timers
//
void  cTimer::setValue(unsigned int val){timer=val;}
void  cTimer::setSecs(int val)			{timer=uiCurrentTime + MY_CLOCKS_PER_SEC*val;}
void  cTimer::setMilliSecs(int val)		{timer=uiCurrentTime + val;}
void  cTimer::reset()					{timer=0;}
unsigned int cTimer::getValue() const	{return timer;}
bool  cTimer::IsRunning() const			{return (timer>0);}
bool  cTimer::hasExpired() const		{return (IsRunning() && timer<=uiCurrentTime);}
int   cTimer::getRemainingSecs() const	{return timer <= uiCurrentTime ? 0 : (timer-uiCurrentTime)/MY_CLOCKS_PER_SEC;}

bool  cSimpleTimer::hasExpired()	{return (timer<=uiCurrentTime);}

