/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//
#include "titles.h"
#include "chars.h"
#include "SndPkg.h"
#include "wolfpack.h"
#include "guilds.h"
#include "network.h"

cTitle::cTitle()
{
	empty[0]=0;
	is_reload=false;
	Reload();
	is_reload=true;
}

////////////////////////////////////////
// Name: LoadTitles
// Purpose: Load the other, skill, and prowees titles.
// IN: The section name, tokens array lenght, tokens array, titles array where the strings will be stored
// OUT: void

void cTitle::LoadTitles(char * Section,int MaxEntries,char *tokens[],char *title[])
{
	
	Script * Scp=i_scripts[titles_script];
	Scp->Open();
	int loopexit=0;
	if (Scp->find(Section))
	{
		Scp->NextLineSplitted();
		while(!Scp->EndSect() && ((++loopexit < MAXLOOPS)))
		{
			for(int i=0;i<MaxEntries;i++)
			{
				if (!Scp->CmpTok1(tokens[i])) 
				{
					
					if (!strcmp(script2,"NO_TITLE"))
						strcpy(script2,empty);
					title[i]=new char[strlen(script2)+1];
					strcpy(title[i],script2);
					break;
				}
			}
			Scp->NextLineSplitted();
		}
	}
	//for no assigned tokens prevents null pointers
	for(int i=0;i<MaxEntries;i++)
	{
		if (!title[i])
		{
			title[i]=new char[1];
			strcpy(title[i],empty);
		}
	
	}
	Scp->Close();
}

//////////////////////////////////////////////////
// NAME: LoadFame
// PURPOSE: Load the fame titles, it have a diferent format than skill, prowees and other
// IN: void
// OUT: void


void cTitle::LoadFame()
{
	char *FameTokens[]={"K<-10000","K<-5000","K<-2500","K<-1250","K<-625","K<625","K<1250",
			    "K<2500","K<5000","K<10000","K>10000"};
	Script * Scp=i_scripts[titles_script];
	Scp->Open();
	int i,loopexit=0;
	
	if (Scp->find("FAME"))
	{
		Scp->NextLineSplitted();
		while(!Scp->EndSect() && ((++loopexit < MAXLOOPS)))
		{
			for(i=0;i<FAMEENTRIES;i++)
			{
				if (!Scp->CmpTok1(FameTokens[i])) 
				{
					
					gettokennum(script2,4);
					if (!strcmp(gettokenstr,"NO_TITLE")) strcpy(gettokenstr,empty);
					fame[i].FO10000X= new char[strlen(gettokenstr)+strlen(other[LORD])+2];
					fame[i].FO10000Y= new char[strlen(gettokenstr)+strlen(other[LADY])+2];
					sprintf(fame[i].FO10000X,"%s %s",gettokenstr,other[LORD]);
					sprintf(fame[i].FO10000Y,"%s %s",gettokenstr,other[LADY]);
					
					gettokennum(script2,3);
					if (!strcmp(gettokenstr,"NO_TITLE")) strcpy(gettokenstr,empty);
					fame[i].FB10000= new char[strlen(gettokenstr)+1];
					strcpy(fame[i].FB10000,gettokenstr);
					
					gettokennum(script2,2);
					if (!strcmp(gettokenstr,"NO_TITLE")) strcpy(gettokenstr,empty);
					fame[i].FB5000= new char[strlen(gettokenstr)+1];
					strcpy(fame[i].FB5000,gettokenstr);
					
					gettokennum(script2,1);
					if (!strcmp(gettokenstr,"NO_TITLE")) strcpy(gettokenstr,empty);
					fame[i].FB2500= new char[strlen(gettokenstr)+1];
					strcpy(fame[i].FB2500,gettokenstr);
					
					gettokennum(script2,0);
					if (!strcmp(gettokenstr,"NO_TITLE")) strcpy(gettokenstr,empty);
					fame[i].FB1250= new char[strlen(gettokenstr)+1];
					strcpy(fame[i].FB1250,gettokenstr);
					break;
				}
			}
			Scp->NextLineSplitted();
		}
			
	}
	Scp->Close();
	//prevent null pointers
	for(i=0;i<FAMEENTRIES;i++)
	{
		if (!fame[i].FO10000X)
		{
			fame[i].FO10000X= new char[1];
			strcpy(fame[i].FO10000X,empty);
		}
		if (!fame[i].FO10000Y)
		{
			fame[i].FO10000Y= new char[1];
			strcpy(fame[i].FO10000Y,empty);
		}
		if (!fame[i].FB10000)
		{
			fame[i].FB10000= new char[1];
			strcpy(fame[i].FB10000,empty);
		}
		if (!fame[i].FB5000)
		{
			fame[i].FB5000= new char[1];
			strcpy(fame[i].FB5000,empty);
		}
		if (!fame[i].FB2500)
		{
			fame[i].FB2500= new char[1];
			strcpy(fame[i].FB2500,empty);
		}	
		if (!fame[i].FB1250)
		{
			fame[i].FB1250= new char[1];
			strcpy(fame[i].FB1250,empty);
		}
			
	}

}

////////////////////////////////////////////////////////////////
// NAME: Reload
// PURPOSE: Load the titles (using LoadTitles and LoadFame) when the class cTitle is instaced
//  and when the 'R' key is pressed in console
// IN:void
// OUT: void

void cTitle::Reload() // old loadtitles
{
	//This is the token that can be handed from the script (plus RAND and NO_TILE)
	//To add any token only add the tag here and in the array index (in titles.h)
	char *OtherTokens[]={"1_4KILLS","5_9KILLS","10_19KILLS","20_49KILLS","50_99KILLS",
			     ">100KILLS","ADMINTAG","SQUELCHEDTAG","OFFLINETAG","LADYTAG","LORDTAG",		  					     "INVULTAG","GMTAG","FROZENTAG","GUARDEDTAG","GUARDINGTAG","VENDORTAG","WARTAG",
			     "CRIMINALTAG","MURDERERTAG"};
	
	char *SkillTokens[]={"ALCHEMY","ANATOMY","ANIMALLORE","ITEMID","ARMSLORE","PARRYING","BEGGING",
						 "BLACKSMITHING","BOWCRAFT","PEACEMAKING","CAMPING","CARPENTRY",
						 "CARTOGRAPHY","COOKING","DETECTINGHIDDEN","ENTICEMENT","EVALUATINGINTEL",
						 "HEALING","FISHING","FORENSICS","HERDING","HIDING","PROVOCATION",
						 "INSCRIPTION","LOCKPICKING","MAGERY","MAGICRESISTANCE","TACTICS",
						 "SNOOPING","MUSICIANSHIP","POISONING","ARCHERY","SPIRITSPEAK","STEALING",
						 "TAILORING","TAMING","TASTEID","TINKERING","TRACKING","VETERINARY",
						 "SWORDSMANSHIP","MACEFIGHTING","FENCING","WRESTLING","LUMBERJACKING",
						 "MINING","MEDITATION","STEALTH","REMOVETRAPS", "NECROMANCY", "FOCUS", "CHIVALRY"};

	char *ProwessTokens[]={"SK10","SK20","SK30","SK40","SK50","SK60","SK70","SK80","SK90",
						   "SK100","SK110","SK120"};

	if (is_reload) //Clean Memory only when reload not when creation. 
		freeMemory();
	//First point to null all
	int i;
	for(i=0;i<FAMEENTRIES;i++)
	{
		fame[i].FO10000X=NULL;
		fame[i].FO10000Y=NULL;
		fame[i].FB10000=NULL;
		fame[i].FB5000=NULL;
		fame[i].FB2500=NULL;
		fame[i].FB1250=NULL;
	}
	for(i=0;i<OTHERENTRIES;i++)
	{
		other[i]=NULL;
	}
	int sk=SkillManager->getAllSkillsValue();
	for(i=0;i<sk;i++)
	{
		skill[i]=NULL;
	}
	for(i=0;i<PROWESSENTRIES;i++)
	{
		prowess[i]=NULL;
	}
	
	//now load the script in memory
	int ski=SkillManager->getAllSkillsValue();
	LoadTitles("OTHER",OTHERENTRIES,OtherTokens,other);
	LoadTitles("SKILL",ski,SkillTokens,skill);
	LoadTitles("PROWESS",PROWESSENTRIES,ProwessTokens,prowess);
	LoadFame();	
}

//////////////////////////////////////////////////////////
// NAME: freeMemory
// PURPOSE: delete the old titles
// IN: void OUT: void

void cTitle::freeMemory()
{
	int i;
	for(i=0;i<OTHERENTRIES;i++)
		delete[] other[i];

	int sk=SkillManager->getAllSkillsValue();
	for(i=0;i<sk;i++)
		delete[]  skill[i];
		
	for(i=0;i<PROWESSENTRIES;i++)
		delete[]  prowess[i];

	for(i=0;i<FAMEENTRIES;i++)
	{
		delete[]  fame[i].FO10000X;
		delete[]  fame[i].FO10000Y;
		delete[]  fame[i].FB10000;
		delete[]  fame[i].FB5000;
		delete[]  fame[i].FB2500;
		delete[]  fame[i].FB1250;
	}
}

///////////////////////////////////////////////////////
// NAME:GetFameTitle 
// PURPOSE: Calcuses the fame title of a character
// IN: P_CHAR, pointer to a character :)
// OUT: The fame title

char * cTitle::GetFameTitle(P_CHAR pc) //old title3()
{
	int karma=pc->karma;
	unsigned int xfame=pc->fame;
	int karma_index=0;
	if (karma<-10000)		karma_index=KB_10000;
	else if (karma<-5000)	karma_index=KB_5000;
	else if (karma<-2500)	karma_index=KB_2500;
	else if (karma<-1250)	karma_index=KB_1250;
	else if (karma<-625)	karma_index=KB_625;
	else if (karma<625)		karma_index=KB625;
	else if (karma<1250)	karma_index=KB1250;
	else if (karma<2500)	karma_index=KB2500;
	else if (karma<5000)	karma_index=KB5000;
	else if (karma<10000)	karma_index=KB10000;
	else					karma_index=KO10000;

		 if (xfame<1250)	return fame[karma_index].FB1250; 	
	else if (xfame<2500)	return fame[karma_index].FB2500;
	else if (xfame<5000)	return fame[karma_index].FB5000;
	else if (xfame<10000)	return fame[karma_index].FB10000;
	else if (pc->id()==0x0191) return fame[karma_index].FO10000Y;
	else					return fame[karma_index].FO10000X;
}

///////////////////////////////////////////////////////
// NAME:GetProwessTitle 
// PURPOSE: Calcuses the prowess title of a character
// IN: P_CHAR, pointer to a character :)
// OUT: The prowees title or an empty string


char * cTitle::GetProwessTitle(P_CHAR pc) //old title1()
{
	int x = pc->getRealSkill(bestskill(pc));
	if (x>(PROWESSENTRIES*100)) x=PROWESSENTRIES*100;//prevent wrong array index for high skill
	if (x>99) 
		return prowess[(int)(x/100)-1];
	else 
		return empty;
}

///////////////////////////////////////////////////////
// NAME:GetSkillTitle 
// PURPOSE: Calcuses the skill title of a character and catch the token RAND
// IN: P_CHAR, pointer to a character :)
// OUT: The skill title or an empty string



char * cTitle::GetSkillTitle(P_CHAR pc){ 
	int j,i=bestskill(pc);
	if (skill[i])
	{
		//if find a RAND title jump to another random title
		if (!strcmp(skill[i],"RAND"))
		{
			int sk=SkillManager->getAllSkillsValue();
			i=rand()%sk;
			j=0;
			int loopexit=0;
			while((!strcmp(skill[i],"RAND")) && (++loopexit<MAXLOOPS))
			{
				i=rand()%sk;
				j++;
				if (j>5) return empty; //Max 5 jumps finding a non RAND title.
			}
		}
		return skill[i];
	}
	else
		return empty;
} //old title2()



///////////////////////////////////////////////////////
// NAME:GetTitle 
// PURPOSE: Make the title of a character that is showed in paperdoll
// IN: CHARACTER (int)
// OUT: The title.



char * cTitle::GetTitle(P_CHAR pc)
{
	// Format:
	// The [MurderTitle] [Fame] [GM|ADMIN] [NAME], The [prowres] [skillTitle]. 
	
	if (!pc) return "error";
	if (pc->title[0])
		sprintf(tempTitle,"%s %s ",pc->title,pc->name);	
	else
	{
		sprintf(tempTitle,"The %s %s ",GetMurderTitle(pc),GetFameTitle(pc));
		if (other[ADMIN][0] && pc->account==0 && pc->isGM() && !pc->PrivHide()) 
			strcat(tempTitle,other[ADMIN]);
		else if (other[GM][0] && pc->isGM() && pc->account!=0 && !pc->PrivHide()) 
			strcat(tempTitle,other[GM]);
		
		if (!strcmp(tempTitle,"The   ")) 
			tempTitle[0]=0;//If not murder title and fametile and GM/Admin title, remove the "The  "
		else
			strcat(tempTitle," ");

		strcat(tempTitle,pc->name);

		if (!pc->npc)
		{
			char rname[50];
			int rlen = pc->getRaceName(rname,50);
			if (rlen > 0)
			{
				sprintf(temp, " the %s",rname);
				strcat(tempTitle,temp);
			}
		}

		if ( GetProwessTitle(pc)[0] || GetSkillTitle(pc)[0] ) // if no prowess/skill title put only the name
		{
			sprintf(temp,", %s %s",GetProwessTitle(pc),GetSkillTitle(pc));
			strcat(tempTitle,temp);
		}
	}
	//clean double spaces
	strcpy(temp,tempTitle);
	int j=0,k=0;

	int loopexit=0;
	while((temp[j]!=0) && ++loopexit<MAXLOOPS)
	{
		if (temp[j]==' ' && temp[j+1]==' ') 
		{
			j++; 
			continue;
		}
		tempTitle[k++]=temp[j];
		j++;
	}
	tempTitle[k]=0;
	return tempTitle;
}

///////////////////////////////////////////////////////
// NAME:GetMurderTitle 
// PURPOSE: Calcuses the title depending of the kills counter, used by GetTitle()
// IN: P_CHAR, pointer to a character
// OUT: The murder title or empty string

char * cTitle::GetMurderTitle(P_CHAR pc)
{
	temp[0]=0;
	int index;
	if (pc->isCriminal() || pc->isMurderer())
	{
		if (pc->kills<4) index=KILLS_1_4;
		else if (pc->kills>=5 && pc->kills<10) index=KILLS_5_9;
		else if (pc->kills>=10 && pc->kills<20) index=KILLS_10_19;
		else if (pc->kills>=20 && pc->kills<50) index=KILLS_20_49;
		else if (pc->kills>=50 && pc->kills<100) index=KILLS_50_99;
		else index=KILLS_100;
		return other[index];
	}
	
	return empty;
}

///////////////////////////////////////////////////////
// NAME:ShowCname 
// PURPOSE: Make the name of a character, that is displayed above its head when see or 
//  when singleclick a char, show the char flags (frozen,invul...) and the serial of the char 
// (when showid command is used)
// IN: player (int), character that player sees or singleclick (int), flag used when showid command to see serial
// OUT: void, send directly to the client


void cTitle::ShowCname (int s, P_CHAR Player, P_CHAR pc, char seeSerial=0)
{
	if (!Player || !pc) return;

	tempTitle[0]=0;
	
	if (other[SQUELCHED][0] && pc->squelched)
		sprintf(tempTitle," [%s] ",other[SQUELCHED]);
	
	if (!pc->npc && pc->PrivHide() && (pc->fame >= 10000 ) ) // Morollan, only normal players have titles now
	{
		if (pc->id()==0x0191 && other[LADY][0]) 
			sprintf(tempTitle,"%s ",other[LADY]);
		else if (pc->id()==0x0190 && other[LORD][0]) 
			sprintf(tempTitle,"%s ",other[LORD]);
	}

	strcat(tempTitle,pc->name);
	if (Player->canSeeSerials() || seeSerial)
	{
		char serstr[20];
		LongToHexChunks(pc->serial,serstr);
		strcat(tempTitle,serstr);
	}
	if (!pc->npc)
	{
		char rname[50];
		int rlen = pc->getRaceName(rname,50);
		if (rlen > 0)
		{
			sprintf(temp, " [%s] ",rname);
			strcat(tempTitle,temp);
		}
	}
	
	if (!pc->npc && !pc->InGame() && other[OFFLINE][0])
	{
		sprintf(temp, " [%s]",other[OFFLINE]);
		strcat(tempTitle,temp);
	}

	if (other[INVUL][0] && pc->isInvul() && pc->account!=0 && !pc->PrivHide())
	{ 
		sprintf(temp, " [%s]",other[INVUL]);  
		strcat(tempTitle,temp); 
	} 
	if (other[ADMIN][0] && pc->account==0 && pc->isGM() && !pc->PrivHide())			
	{ 
		sprintf(temp," [%s]",other[ADMIN]); 
		strcat(tempTitle,temp); 
	}
	if (other[GM][0] && pc->account!=0 && pc->isGM() && !pc->PrivHide())			
	{ 
		sprintf(temp," [%s]",other[GM]); 
		strcat(tempTitle,temp); 
	} 
	if (pc->IsFrozen() && other[FROZEN][0])							
	{ 
		sprintf(temp, " [%s]",other[FROZEN]);  
		strcat(tempTitle,temp); 
	}
	if (pc->guarded && other[GUARDED][0])							
	{ 
		sprintf(temp, " [%s]",other[GUARDED]); 

		strcat(tempTitle,temp); 
	} 
	if (other[GUARDING][0] && pc->tamed && pc->npcaitype==32 
		&& Player->Owns(pc) && Player->guarded)
	{ 
		sprintf(temp, " [%s]",other[GUARDING]); 
		strcat(tempTitle,temp); 
	} 
	if (other[VENDOR][0] && pc->tamed && pc->isAiVendor())			
	{  
		sprintf(temp, " [%s]",other[VENDOR]); 
		strcat(tempTitle,temp); 
	}
	if (pc->war && other[WAR][0])								
	{  
		sprintf(temp, " [%s]",other[WAR]); 
		strcat(tempTitle,temp); 
	}
	if (other[CRIMINAL][0] && pc->crimflag>0 && pc->kills<(unsigned)repsys.maxkills)
	{ 
		sprintf(temp, " [%s]",other[CRIMINAL]);  
		strcat(tempTitle,temp); 
	}
	if (pc->kills>=(unsigned)repsys.maxkills && other[MURDERER][0])				
	{ 
		sprintf(temp, " [%s]",other[MURDERER]); 
		strcat(tempTitle,temp); 
	} 
	if (pc->doppelgaenger_serial==-1) strcat(tempTitle, " [temporal storage body]");
	
	Guilds->Title(s,pc);
	int tl,guild;

	tl=44+strlen(tempTitle)+1;

	unsigned char talk[14];

	LongToCharPtr(pc->serial,&talk[3]);
	talk[7]=1;
	talk[8]=1;
	talk[9]=6; // Mode: "You see"
	guild=Guilds->Compare(Player,pc);
	if (guild==1) //Same guild (Green)
	{
		talk[10]=0x00;
		talk[11]=0x43;
	}
	else if (guild==2) //enemy (Orange)
	{
		talk[10]=0x00;
		talk[11]=0x30;
	}
	else if ((pc->isGM() || pc->account==0) && !pc->PrivHide())
	{
		talk[10]=0x00;
		talk[11]=0x35;//Admin & GM get yellow names ..Ripper
	}
	else
	{
		switch(pc->flag)
		{
		case 0x01:	talk[10]=0x00;talk[11]=0x26;break;//red
		case 0x04:	talk[10]=0x00;talk[11]=0x5A;break;//blue
		case 0x08:	talk[10]=0x00;talk[11]=0x49;break;//green
		case 0x10:	talk[10]=0x00;talk[11]=0x30;break;//orange
		default:	talk[10]=0x03;talk[11]=0xB2;	  //grey
		}
	}

	if (pc->doppelgaenger_serial==-1) // always highlight temporal bodies red !
	{
	   talk[10]=0x00;talk[11]=0x26;//red
	}

	talk[12]=0;
	talk[13]=3;

	XStartPkt(0x1C, tl);
	XAddPkt(&talk[0+3], 14-3);
	XAddPkt((unsigned char*)&zeros[0], 30);
	XAddPkt((unsigned char*)&tempTitle[0], strlen(tempTitle)+1);
	XFinishPkt(s);
}

