/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

//////////////////////////////////////////////////////////////////////
// file:	translate.cpp
// purpose:	translates strings to another language
//			used by emus that are based on LoneWolf
// remarks:	this is a VERY simple implementation. The primary goal was
//			to provide a way to avoid translations throughout the sources
//			(allowing for easier merges) and to avoid things like
//			sysmessage(s, MSG47362); // resource-approach
//			Searching the array of strings sequentially will be a bit slow :(
//			but let's see how slow it really is. There are several ways to
//			make it faster ;)
// history:	by Duke, 22.9.01
//
 
#include <string>
#include "platform.h"

#include "oem.h"
#ifdef OEM

struct str_pair		// a pair of two strings
{
	char* english;
	char* foreign;
};

static const struct str_pair trtab[] =	// translation table
{
	{"You aren't skilled enough to make anything with what you have.",
	 "rien ne vas plus"},
	{"You fail your attempt at contacting the netherworld.",
	 NULL},		// NULL for foreign string should give original (english) text
	{"You must hide first.",
	 "O sole mio!"}
};

char* translate(char* txt)
{
	const struct str_pair * pp;

	for (pp=trtab; pp < trtab+(sizeof(trtab)/sizeof(str_pair));pp++)
	{
		if (!strcmp(pp->english,txt))
		{
			if (!pp->foreign)
				break;
			return pp->foreign;
		}
	}
	return txt;	// no translation found 
}
#endif

