////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/////////////////////
// Name:	virtues.cpp
// Purpose: supporting virtues system introduced by OSI Jan 2002 (clients 3.0.6j ++)
// History:	started 14'th Jan 2002 by LB
// Remarks:	currently only a lowlevel access to virtue gumps rather than a complete implemenation

#include "virtues.h"
#include "stdio.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "virtues.cpp"

CVirtues::CVirtues():MainVirtueButtonId(1), MainVirtueButtonTypeId(461), MainVirtueButtonIdStart(105), SubVirtueButtonId(2), SubVirtueButtonTypeId(10014), SubVirtueButtonTypeId2(10005),SubVirtueButtonId2start(1)
{

   //////////////////////////////////////

   MainVirtueGump=NULL;

   MainVirtueGump = new CGumps<0x0400>(0x0000271e, "MainVirtueGump");

   MainVirtueGump->addGumpDescr("page 0");
   MainVirtueGump->addGumpDescr("gumppic 30 40 104");
   
   MainVirtueGump->addGumpDescr("page 1");
   MainVirtueGump->addGumpDescr("gumppic 61 71 108 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 123 46 112 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 187 70 107 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 35 135 110 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 211 133 105 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 61 195 111 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 186 195 109 hue=2402 class=VirtueGumpItem");
   MainVirtueGump->addGumpDescr("gumppic 121 221 106 hue=2402 class=VirtueGumpItem");

   MainVirtueGump->addGumpDescr("button 57 269 2027 2027 1 0 2");
   MainVirtueGump->addGumpDescr("button 186 269 2071 2071 1 0 3");

   MainVirtueGump->addGumpText("The Virtues");
   MainVirtueGump->addGumpText("Humility");
   MainVirtueGump->addGumpText("Sacrifice");
   MainVirtueGump->addGumpText("Compassion");
   MainVirtueGump->addGumpText("Spirituality");
   MainVirtueGump->addGumpText("Valor");
   MainVirtueGump->addGumpText("Honor");
   MainVirtueGump->addGumpText("Justice");
   MainVirtueGump->addGumpText("Honesty");
   MainVirtueGump->addGumpText("close");
   MainVirtueGump->addGumpText("click one a gem to activate the virtue");
   MainVirtueGump->addGumpText("click to open status gump\n");
  
   MainVirtueGump->toRawData();

   MainVirtueGump->deleteGumpDescrComplete();
   MainVirtueGump->deleteGumpTextComplete();

   /////////////////////////////////////////////////

   SubVirtueGump = NULL;
   SubVirtueGump = new CGumps<0x0600> (0x00002715, "SubVirtueGump");

   SubVirtueGump->addGumpDescr("page 0");
   SubVirtueGump->addGumpDescr("gumppic 30 40 2080");
   SubVirtueGump->addGumpDescr("gumppic 47 77 2081");
   SubVirtueGump->addGumpDescr("gumppic 47 147 2081");
   SubVirtueGump->addGumpDescr("gumppic 47 217 2081");
   SubVirtueGump->addGumpDescr("gumppic 47 267 2083");
   SubVirtueGump->addGumpDescr("gumppic 70 213 2091");
   
   SubVirtueGump->addGumpDescr("page 1");
   SubVirtueGump->addGumpDescr("htmlgump 140 73 200 20 0 0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 80 100 100 40 1051000  0 0");   
   SubVirtueGump->addGumpDescr("xmfhtmlgump 80 129 100 40 1051001  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 80 159 100 40 1051002  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 80 189 100 40 1051003  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 200 100 200 40 1051004  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 200 129 200 40 1051005  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 200 159 200 40 1051006  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 200 189 200 40 1051007  0 0");
   SubVirtueGump->addGumpDescr("xmfhtmlgump 75 224 220 60 1052062  0 0");
   SubVirtueGump->addGumpDescr("button 60 100 1210 1210 1 0 1");
   SubVirtueGump->addGumpDescr("button 60 129 1210 1210 1 0 2");
   SubVirtueGump->addGumpDescr("button 60 159 1210 1210 1 0 3");
   SubVirtueGump->addGumpDescr("button 60 189 1210 1210 1 0 4");
   SubVirtueGump->addGumpDescr("button 180 100 1210 1210 1 0 5");
   SubVirtueGump->addGumpDescr("button 180 129 1210 1210 1 0 6");
   SubVirtueGump->addGumpDescr("button 180 159 1210 1210 1 0 7");
   SubVirtueGump->addGumpDescr("button 180 189 1210 1210 1 0 8");
   SubVirtueGump->addGumpDescr("button 280 43 4014 4014 1 0 9");


   SubVirtueGump->addGumpText("The Virtues");
   SubVirtueGump->addGumpText("Humility");
   SubVirtueGump->addGumpText("Sacrifice");
   SubVirtueGump->addGumpText("Compassion");
   SubVirtueGump->addGumpText("Spirituality");
   SubVirtueGump->addGumpText("Valor");
   SubVirtueGump->addGumpText("Honor");
   SubVirtueGump->addGumpText("Justice");
   SubVirtueGump->addGumpText("Honesty");
   SubVirtueGump->addGumpText("Close");
   SubVirtueGump->addGumpText("Click on a blue gem to view your status in that virtue");

   SubVirtueGump->toRawData();

   SubVirtueGump->deleteGumpDescrComplete();
   SubVirtueGump->deleteGumpTextComplete();


   StatusVirtueGump=NULL;
   StatusVirtueGump = new CGumps<0x0600> (0x00002716, "StatusVirtueGump");
   
   /*
   /// healgump
   StatusVirtueGump->addGumpDescr("page 0");
   StatusVirtueGump->addGumpDescr("resizepic 0 0 2600 400 350");

   StatusVirtueGump->addGumpDescr("xmfhtmlgump 0 20 400 35 1011022 0 0");
   StatusVirtueGump->addGumpDescr("xmfhtmlgump 50 55 300 140 1011025 1 1");
   StatusVirtueGump->addGumpDescr("xmfhtmlgump 235 230 110 35 1011012 0 0");
   StatusVirtueGump->addGumpDescr("xmfhtmlgump 100 230 110 35 1011011 0 0" );
   StatusVirtueGump->addGumpDescr("button 200 227 4005 4007 1 0"); 
   StatusVirtueGump->addGumpDescr("button 65 227 4005 4007 1 0 2");*/

    StatusVirtueGump->addGumpDescr("page 0");
    StatusVirtueGump->addGumpDescr("gumppic 30 40 2080");
    StatusVirtueGump->addGumpDescr("gumppic 47 77 2081");
    StatusVirtueGump->addGumpDescr("gumppic 47 147 2081");
    StatusVirtueGump->addGumpDescr("gumppic 47 217 2081");
    StatusVirtueGump->addGumpDescr("gumppic 47 267 2083");
    StatusVirtueGump->addGumpDescr("gumppic 70 213 2091");
   
    StatusVirtueGump->addGumpDescr("page 1");
    StatusVirtueGump->addGumpDescr("xmfhtmlgump 157 73 200 40 1051000 0 0");
    StatusVirtueGump->addGumpDescr("xmfhtmlgump 75 95 220 140 1052051 0 0");
    StatusVirtueGump->addGumpDescr("xmfhtmlgump 75 224 220 60 1052044 0 0");
    StatusVirtueGump->addGumpDescr("button 65 277 1209 1209 1 0 1");
    StatusVirtueGump->addGumpDescr("button 280 43 4014 4014 1 0 2");
    StatusVirtueGump->addGumpDescr("xmfhtmlgump 83 275 400 40 1052055 0 0");
    StatusVirtueGump->addGumpDescr("gumppic 95 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 112 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 129 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 146 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 163 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 180 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 197 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 214 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 231 50 2360");
    StatusVirtueGump->addGumpDescr("gumppic 248 50 2360");

	StatusVirtueGump->addGumpText("Humility");
    StatusVirtueGump->addGumpText("Humility is perceiving one's fucking skill");

   StatusVirtueGump->toRawData();

   StatusVirtueGump->deleteGumpDescrComplete();
   StatusVirtueGump->deleteGumpTextComplete();

}

CVirtues::~CVirtues()
{
  if ( MainVirtueGump!=NULL)    delete  MainVirtueGump;
  if ( SubVirtueGump!=NULL)     delete  SubVirtueGump;
  if ( StatusVirtueGump!=NULL)  delete  StatusVirtueGump;

}

void CVirtues::showVirtueMainGump(UOXSOCKET s)
{
   MainVirtueGump->SendGump(s); // dummy for debugging to delete   
  // MainVirtueGump->showrawdatadump();
}

void CVirtues::showVirtueSubGump(UOXSOCKET s)
{
	SubVirtueGump->SendGump(s);
//	SubVirtueGump->showrawdatadump();
}

void CVirtues::showVirtueHumility(UOXSOCKET s)
{
	StatusVirtueGump->SendGump(s);
}

void CVirtues::showVirtueSacrifice(UOXSOCKET s)
{
	;
}

void CVirtues::showVirtueCompassion(UOXSOCKET s)
{
   ;
}

void CVirtues::showVirtueSprituality(UOXSOCKET s)
{
	;
}

void CVirtues::showVirtueValority(UOXSOCKET s)
{
	;
}

void CVirtues::showVirtueHonor(UOXSOCKET s)
{
	;
}

void CVirtues::showVirtueJustice(UOXSOCKET s)
{
	;
}

void CVirtues::showVirtueHonesty(UOXSOCKET s)
{
	;
}

bool CVirtues::isVirtueMainGumpRequest(int button, int type)
{
	bool via_sux=(MainVirtueButtonId==button && MainVirtueButtonTypeId==type);
	return via_sux;
}

bool CVirtues::isVirtueSubGumpRequest(int button, int type)
{
	bool via_sux=(SubVirtueButtonId==button && SubVirtueButtonTypeId==type);
	return via_sux;
}


bool CVirtues::isVirtueMainGumpValorRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+7)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpHonorRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+2)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpCompassionRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+0)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpJusticeRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+4)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpHonestyRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+1)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpSpiritualityRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+6)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpSacrificeRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+5)==button);
	return ok;
}

bool CVirtues::isVirtueMainGumpHumilityRequest(int button, int type)
{
	bool ok = (MainVirtueButtonTypeId==type && (MainVirtueButtonIdStart+3)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpValorRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+4)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpHumilityRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+0)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpSacrificeRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+1)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpCompassionRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+2)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpSpiritualityRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+3)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpHonorRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+5)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpJusticeRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+6)==button);
	return ok;
}

bool CVirtues::isVirtueSubGumpHonestyRequest(int button, int type)
{
	bool ok = (SubVirtueButtonTypeId2==type && (SubVirtueButtonId2start+7)==button);
	return ok;
}

