/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __VERTUES_H__
#define __VERTUES_H__

#include "platform.h"
#include "typedefs.h"
#include "cGumps.h"

/**************************************************************/
/* Virtue System implementation by LB                         */ 
/* Currently this is only a LOW level interface to it         */
/* No real implementation, just bringing up the gumps         */
/* and tracking of virtue gump selection                      */
/* Implementation of entire system is low priority            */
/* Actually it isn't decided if it will ever be fully impl.   */
/**************************************************************/

/*** Note1: requires clients 3.0.6j or above                ***/

/*** Note2: even this interface is subject to change a lot  ***/

/*** Note3: do not use yet                                  ***/

class CVirtues
{
    public:

		CVirtues(); 

		virtual~CVirtues();
	
		void showVirtueMainGump(UOXSOCKET s);
		void showVirtueSubGump(UOXSOCKET s);

		void showVirtueHumility(UOXSOCKET s);
		void showVirtueSacrifice(UOXSOCKET s);
		void showVirtueCompassion(UOXSOCKET s);
		void showVirtueSprituality(UOXSOCKET s);
		void showVirtueValority(UOXSOCKET s);
		void showVirtueHonor(UOXSOCKET s);
		void showVirtueJustice(UOXSOCKET s);
		void showVirtueHonesty(UOXSOCKET s);
	
	    bool isVirtueMainGumpRequest(int id, int subid);
		bool isVirtueSubGumpRequest(int id, int subid);

		bool isVirtueMainGumpClose(int id, int subid);
		bool isVirtueSubGumpClose(int id, int subid);

		bool isVirtueSubGumpValorClose(int id, int subid);
		bool isVirtueSubGumpHonorClose(int id, int subid);
		bool isVirtueSubGumpCompassionClose(int id, int subid);
		bool isVirtueSubGumpJusticeClose(int id, int subid);
		bool isVirtueSubGumpHonestyClose(int id, int subid);
		bool isVirtueSubGumpSpiritualityClose(int id, int subid);
		bool isVirtueSubGumpSacrificeClose(int id, int subid);
		bool isVirtueSubGumpHumilityClose(int id, int subid);


		bool isVirtueMainGumpValorRequest(int id, int subid);
		bool isVirtueMainGumpHonorRequest(int id, int subid);
		bool isVirtueMainGumpCompassionRequest(int id, int subid);
		bool isVirtueMainGumpJusticeRequest(int id, int subid);
		bool isVirtueMainGumpHonestyRequest(int id, int subid);
		bool isVirtueMainGumpSpiritualityRequest(int id, int subid);
		bool isVirtueMainGumpSacrificeRequest(int id, int subid);
		bool isVirtueMainGumpHumilityRequest(int id, int subid);

		bool isVirtueSubGumpValorRequest(int id, int subid);
		bool isVirtueSubGumpHonorRequest(int id, int subid);
		bool isVirtueSubGumpCompassionRequest(int id, int subid);
		bool isVirtueSubGumpJusticeRequest(int id, int subid);
		bool isVirtueSubGumpHonestyRequest(int id, int subid);
		bool isVirtueSubGumpSpiritualityRequest(int id, int subid);
		bool isVirtueSubGumpSacrificeRequest(int id, int subid);
		bool isVirtueSubGumpHumilityRequest(int id, int subid);


	private:

		CGumps<0x0400> *MainVirtueGump;
		CGumps<0x0600> *SubVirtueGump;
		CGumps<0x0600> *StatusVirtueGump;

		int MainVirtueButtonId;
		int MainVirtueButtonTypeId;
		int MainVirtueButtonIdStart;

		int SubVirtueButtonId;
		int SubVirtueButtonTypeId;	

		int SubVirtueButtonTypeId2;
		int SubVirtueButtonId2start;

};


#endif

