/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

/****************************************************
 *	      All weight function are coded here		*										
 *               Done by Moongraven					*
 ****************************************************/

#include "weight.h"

#include "SndPkg.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "weight.cpp"


/**************************************************************************************************************************
void newcalcweight(int);

  Ison 2-20-99 - re-wrote by Tauriel 3/20/99
  
	calcweight will search player's paperdoll and then backpacks for items with item.weight set to a value.  Values are 
	added until total weight of character is determined.  The called character's weight is first set to zero then re-calculated
	during the function.  Since it is a global variable I just modifed .weight instead of returning a value.

  pass the current character number to the function

**************************************************************************************************************************/

void cWeight::NewCalc(P_CHAR pc)
{
	if (!pc) return;
//	P_CHAR pc=MAKE_CHARREF_LR(p);
	float totalweight=0.0;

	//get weight for items on players
	int ci=0;
	P_ITEM pi;
	int loopexit=0;
	while ( ((pi=pc->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		if (pi->id() == 0x1E5E)	// trade window ?
			continue;
		if ((pi->layer!=0x0B) && (pi->layer!=0x10) && //no weight for hair/beard
			(pi->layer!=0x1D) && (pi->layer!=0x19))   //no weight for steed/bank box
		{
			totalweight+=(pi->getWeight()/100.0f);
		}
	}

	// Items in players pack
	P_ITEM Pack=Packitem(pc);
	if (Pack) totalweight+=RecursePacks(Pack); //LB

	totalweight+=pc->WeightAtCursor;

	pc->weight=(int)totalweight;

	return;
}

//////////////////
// name:	RecursePacks
// Purpose:	recurses through the container given by bp to calculate the total weight
// History:	Ison 2-20-99  - rewrote by Tauriel 3/20/99
//			rewritten by Duke 4.11.2k
//
float cWeight::RecursePacks(P_ITEM Pack)
{
	float totalweight=0.0;

	if (!Pack) return 0.0;
	
	int ci=0;
	P_ITEM pi;
	int loopexit=0;
	while ( ((pi=Pack->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		int itemsweight=pi->getWeight();
		if (pi->isContainerType())	//item is another container
		{
			totalweight+=(itemsweight/100.0f);		// the weight of container itself
			totalweight+=RecursePacks(pi); //find the item's weight within this container
		}
		
		if (pi->id()==0x0EED)
			totalweight+=(pi->amount*SrvParms->goldweight);
		else
			totalweight+=(float)((itemsweight*pi->amount)/100.0);
	}
	return totalweight;
}

int cWeight::CheckWeight(P_CHAR pc, int k) // Check when player is walking if overloaded
{
	if (pc->weight > pc->MaxWeight())
	{
		float res=float(pc->weight - pc->MaxWeight())*2;

		pc->reduceStm((int)res);
		if (!(pc->Stm() > 0))
		{
			sysmessage(pc->calcSocket(),"You are overloaded! You can't hold all this weight..");
			return 0;
		}
	}
	return 1;
}

int cWeight::CheckWeight2(P_CHAR pc) // Morrolan - Check when player is teleporting if overloaded
{
	if (pc->weight > pc->MaxWeight())
	{
		pc->mn -= 30;
		if (pc->mn<=0)
		{
			pc->mn=0;
		}
		return 1;
	}
	return 0;
}

//	history:	added containersearch Duke, 4.11.2k
float cWeight::LockeddownWeight(P_ITEM pItem, int *total)
{
	float totalweight=0.0;
	if (!pItem) 
	{
		*total=0;
		return 0.0;
	}
	
	int ci=0;
	P_ITEM pi;
	int loopexit=0;
	while ( ((pi=pItem->Search(&ci)) != NULL) && (++loopexit < MAXLOOPS) )
	{
		int itemsweight=pi->getWeight();
		*total+=1;
		if (pi->isContainerType()) //item is another container
		{
			totalweight+=(itemsweight/100.0f); //(pi->weight/100);
			totalweight+=LockeddownWeight(pi, total); //find the item's weight within this container
		}
		
		if ( pi->id() == 0x0EED )
			totalweight+=(pi->amount*SrvParms->goldweight);
		else
			totalweight+=(float)((itemsweight*pi->amount)/100.0f); //((pi->weight*pi->amount)/100);  // Ison 2-21-99
	}

	if (*total==0) 
	{ 
		*total=pItem->amount;
		*total=*total*-1; // Indicate that not a pack ! on osi servers in that case weigt/items count isnt shown
		                  // thus i set it negative, if you want to show it anyway, add something like if (weight<0) weight*=-1; 
		return ((((float)pItem->getWeight())/100)*pItem->amount); // if no pack return single item weight*/        		
		
	}
	else
		return totalweight;
}

