/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// Wolfpack Includes

#include "wpconsole.h"
#if defined(__unix__)
#include <curses.h>
#endif
#include "globals.h"

// Method Implementations

//========================================================================================
// Constructor
cConsole::cConsole()
{
	bEnabled = true;
	// do nothing at the moment
	setStreams(&cin, &cout, &cerr, &cout);
}

//========================================================================================
// Destuctor
cConsole::~cConsole()
{
	// Clean up any terminal settings
}

void cConsole::enabled(bool bState)
{
	bEnabled = bState;
}

void cConsole::setStreams(istream *in, ostream *out, ostream *error, ostream *log)
{
	inputstrm	= in;
	outputstrm	= out;
	errorstrm	= error;
	logstrm		= log;
}


//========================================================================================
// Send a char string to the console
void cConsole::send(char* szMessage, ...)
{
	va_list argptr;
	char msg[4096];
	va_start(argptr, szMessage);
	vsnprintf(msg,4096, szMessage, argptr);
	va_end(argptr);
	
	string sMessage(msg);
	send(sMessage);
}

//========================================================================================
// Send a message to the console
void cConsole::send(string sMessage)
{
#if defined(__unix__)
	if (Daemon)
	{
		if (outputstrm != NULL)
		{
			(*outputstrm) << sMessage;
			flush((*outputstrm));
		}

	}
	else
	{
		addstr(sMessage.c_str());
		wrefresh(stdscr);
	}
#else
	if (outputstrm != NULL)
	{
		(*outputstrm) << sMessage;
		flush((*outputstrm));
	}
#endif
}
//========================================================================================
// Send a char string to the log
void cConsole::log(char* szMessage, ...)
{
	va_list argptr;
	char msg[4096];

	va_start(argptr, szMessage);
	vsnprintf(msg, 4096, szMessage, argptr);
	va_end(argptr);
	
	string sMessage(msg);
	log(sMessage);
}
//========================================================================================
// Send a message to the log
void cConsole::log(string sMessage)
{
	if (logstrm != NULL)
		(*logstrm) << sMessage;

}
//========================================================================================
// Send a char string to the error
void cConsole::error(char* szMessage, ...)
{
	va_list argptr;
	char msg[4096];
	va_start(argptr, szMessage);
	vsnprintf(msg, 4096,szMessage, argptr);
	va_end(argptr);
	
	string sMessage(msg);
	error(sMessage);
}
//========================================================================================
// Send a message to the console
void cConsole::error(string sMessage)
{
	if (errorstrm != NULL)
		(*errorstrm) << sMessage;
}

//=========================================================================================
// Get input from the console
UI08 cConsole::getkey(void)
{
	UI08 key = 0;

//	if (cin.peek())
//		key = cin.get();
	
	return key;
}


