/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__WPCONSOLE_H__)
#define __WPCONSOLE_H__

// Platform specifics
#include "platform.h"


// System Includes

#include <iostream>
#include <string>
#include <cstdarg>
#include <cstdio>

using namespace std;


// Third Party includes



//Forward class declaration

class cConsole;

//Wolfpack Includes


//Class definitions

class cConsole
{
public:
	// Constructor
	cConsole();
	// Destructor
	~cConsole();

	void enabled(bool);
	void setStreams(istream *in, ostream *out, ostream *error, ostream *log);

	// Send a message to the console
	void send(char* szMessage, ...);
	void send(string sMessage);


	// Log a message
	void log(char* szMessage, ...);
	void log(string sMessage);

	// Flag an error
	void error(char* szMessage, ...);
	void error(string sMessage);

	// Get input from the console
	UI08 getkey(void);

private:

	istream *inputstrm;
	ostream *outputstrm;
	ostream *errorstrm;
	ostream *logstrm;

	bool bEnabled;
};

#endif
